/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/arraysFind","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Me=function(we){for(var e=[],y=0,M=we.length;y<M;y++)e[y]=Re[we[y]];return e};define(Re[64],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hh=e.$gh=e.$fh=void 0;function y(A){return(l,k,f)=>{let R=null,D=null;if(typeof f.value=="function"?(R="value",D=f.value):typeof f.get=="function"&&(R="get",D=f.get),!D)throw new Error("not supported");f[R]=A(D,k)}}function M(A,l,k){let f=null,R=null;if(typeof k.value=="function"?(f="value",R=k.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(f="get",R=k.get),!R)throw new Error("not supported");const D=`$memoize$${l}`;k[f]=function(...c){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,c)}),this[D]}}e.$fh=M;function C(A,l,k){return y((f,R)=>{const D=`$debounce$${R}`,c=`$debounce$result$${R}`;return function(...p){this[c]||(this[c]=k?k():void 0),clearTimeout(this[D]),l&&(this[c]=l(this[c],...p),p=[this[c]]),this[D]=setTimeout(()=>{f.apply(this,p),this[c]=k?k():void 0},A)}})}e.$gh=C;function L(A,l,k){return y((f,R)=>{const D=`$throttle$timer$${R}`,c=`$throttle$result$${R}`,p=`$throttle$lastRun$${R}`,$=`$throttle$pending$${R}`;return function(...m){if(this[c]||(this[c]=k?k():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),l&&(this[c]=l(this[c],...m)),this[$])return;const t=this[p]+A;t<=Date.now()?(this[p]=Date.now(),f.apply(this,[this[c]]),this[c]=k?k():void 0):(this[$]=!0,this[D]=setTimeout(()=>{this[$]=!1,this[p]=Date.now(),f.apply(this,[this[c]]),this[c]=k?k():void 0},t-Date.now()))}})}e.$hh=L}),define(Re[88],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hM=e.$gM=void 0;class y{constructor(C){this.a=C,this.b=0}nextId(){return this.a+ ++this.b}}e.$gM=y,e.$hM=new y("id#")}),define(Re[115],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var M;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var C;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(C||(e.ParseErrorCode=C={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(r,s=!1){let n=0;const o=r.length;let w="",d=0,I=16,S=0;function u(B){let O=0,N=0;for(;O<B;){const te=r.charCodeAt(n);if(te>=48&&te<=57)N=N*16+te-48;else if(te>=65&&te<=70)N=N*16+te-65+10;else if(te>=97&&te<=102)N=N*16+te-97+10;else break;n++,O++}return O<B&&(N=-1),N}function g(B){n=B,w="",d=0,I=16,S=0}function h(){const B=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&f(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&f(r.charCodeAt(n)))for(n++;n<r.length&&f(r.charCodeAt(n));)n++;else return S=3,r.substring(B,n);let O=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&f(r.charCodeAt(n))){for(n++;n<r.length&&f(r.charCodeAt(n));)n++;O=n}else S=3;return r.substring(B,O)}function P(){let B="",O=n;for(;;){if(n>=o){B+=r.substring(O,n),S=2;break}const N=r.charCodeAt(n);if(N===34){B+=r.substring(O,n),n++;break}if(N===92){if(B+=r.substring(O,n),n++,n>=o){S=2;break}switch(r.charCodeAt(n++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:{const Y=u(4);Y>=0?B+=String.fromCharCode(Y):S=4;break}default:S=5}O=n;continue}if(N>=0&&N<=31)if(k(N)){B+=r.substring(O,n),S=2;break}else S=6;n++}return B}function W(){if(w="",S=0,d=n,n>=o)return d=o,I=17;let B=r.charCodeAt(n);if(l(B)){do n++,w+=String.fromCharCode(B),B=r.charCodeAt(n);while(l(B));return I=15}if(k(B))return n++,w+=String.fromCharCode(B),B===13&&r.charCodeAt(n)===10&&(n++,w+=`
`),I=14;switch(B){case 123:return n++,I=1;case 125:return n++,I=2;case 91:return n++,I=3;case 93:return n++,I=4;case 58:return n++,I=6;case 44:return n++,I=5;case 34:return n++,w=P(),I=10;case 47:{const O=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<o&&!k(r.charCodeAt(n));)n++;return w=r.substring(O,n),I=12}if(r.charCodeAt(n+1)===42){n+=2;const N=o-1;let te=!1;for(;n<N;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,te=!0;break}n++}return te||(n++,S=1),w=r.substring(O,n),I=13}return w+=String.fromCharCode(B),n++,I=16}case 45:if(w+=String.fromCharCode(B),n++,n===o||!f(r.charCodeAt(n)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return w+=h(),I=11;default:for(;n<o&&K(B);)n++,B=r.charCodeAt(n);if(d!==n){switch(w=r.substring(d,n),w){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return w+=String.fromCharCode(B),n++,I=16}}function K(B){if(l(B)||k(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let B;do B=W();while(B>=12&&B<=15);return B}return{setPosition:g,getPosition:()=>n,scan:s?j:W,getToken:()=>I,getTokenValue:()=>w,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>S}}e.$Qm=A;function l(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function k(r){return r===10||r===13||r===8232||r===8233}function f(r){return r>=48&&r<=57}var R;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(R||(R={}));function D(r,s){const n=[],o=new Object;let w;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function S(u,g,h,P){d.value=u,d.offset=g,d.length=h,d.type=P,d.colonOffset=void 0,w=d}try{b(r,{onObjectBegin:(u,g)=>{if(s<=u)throw o;w=void 0,I=s>u,n.push("")},onObjectProperty:(u,g,h)=>{if(s<g||(S(u,g,h,"property"),n[n.length-1]=u,s<=g+h))throw o},onObjectEnd:(u,g)=>{if(s<=u)throw o;w=void 0,n.pop()},onArrayBegin:(u,g)=>{if(s<=u)throw o;w=void 0,n.push(0)},onArrayEnd:(u,g)=>{if(s<=u)throw o;w=void 0,n.pop()},onLiteralValue:(u,g,h)=>{if(s<g||(S(u,g,h,v(u)),s<=g+h))throw o},onSeparator:(u,g,h)=>{if(s<=g)throw o;if(u===":"&&w&&w.type==="property")w.colonOffset=g,I=!1,w=void 0;else if(u===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(I=!0,n[n.length-1]=""),w=void 0}}})}catch(u){if(u!==o)throw u}return{path:n,previousNode:w,isAtPropertyKey:I,matches:u=>{let g=0;for(let h=0;g<u.length&&h<n.length;h++)if(u[g]===n[h]||u[g]==="*")g++;else if(u[g]!=="**")return!1;return g===u.length}}}e.$Rm=D;function c(r,s=[],n=L.DEFAULT){let o=null,w=[];const d=[];function I(u){Array.isArray(w)?w.push(u):o!==null&&(w[o]=u)}return b(r,{onObjectBegin:()=>{const u={};I(u),d.push(w),w=u,o=null},onObjectProperty:u=>{o=u},onObjectEnd:()=>{w=d.pop()},onArrayBegin:()=>{const u=[];I(u),d.push(w),w=u,o=null},onArrayEnd:()=>{w=d.pop()},onLiteralValue:I,onError:(u,g,h)=>{s.push({error:u,offset:g,length:h})}},n),w[0]}e.$Sm=c;function p(r,s=[],n=L.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function w(u){o.type==="property"&&(o.length=u-o.offset,o=o.parent)}function d(u){return o.children.push(u),u}b(r,{onObjectBegin:u=>{o=d({type:"object",offset:u,length:-1,parent:o,children:[]})},onObjectProperty:(u,g,h)=>{o=d({type:"property",offset:g,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:u,offset:g,length:h,parent:o})},onObjectEnd:(u,g)=>{o.length=u+g-o.offset,o=o.parent,w(u+g)},onArrayBegin:(u,g)=>{o=d({type:"array",offset:u,length:-1,parent:o,children:[]})},onArrayEnd:(u,g)=>{o.length=u+g-o.offset,o=o.parent,w(u+g)},onLiteralValue:(u,g,h)=>{d({type:v(u),offset:g,length:h,parent:o,value:u}),w(g+h)},onSeparator:(u,g,h)=>{o.type==="property"&&(u===":"?o.colonOffset=g:u===","&&w(g))},onError:(u,g,h)=>{s.push({error:u,offset:g,length:h})}},n);const S=o.children[0];return S&&delete S.parent,S}e.$Tm=p;function $(r,s){if(!r)return;let n=r;for(const o of s)if(typeof o=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let w=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===o){n=d.children[1],w=!0;break}if(!w)return}else{const w=o;if(n.type!=="array"||w<0||!Array.isArray(n.children)||w>=n.children.length)return;n=n.children[w]}return n}e.$Um=$;function m(r){if(!r.parent||!r.parent.children)return[];const s=m(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;s.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&s.push(n)}return s}e.$Vm=m;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const s=Object.create(null);for(const n of r.children){const o=n.children[1];o&&(s[n.children[0].value]=t(o))}return s}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$Wm=t;function i(r,s,n=!1){return s>=r.offset&&s<r.offset+r.length||n&&s===r.offset+r.length}e.$Xm=i;function a(r,s,n=!1){if(i(r,s,n)){const o=r.children;if(Array.isArray(o))for(let w=0;w<o.length&&o[w].offset<=s;w++){const d=a(o[w],s,n);if(d)return d}return r}}e.$Ym=a;function b(r,s,n=L.DEFAULT){const o=A(r,!1);function w(ce){return ce?()=>ce(o.getTokenOffset(),o.getTokenLength()):()=>!0}function d(ce){return ce?se=>ce(se,o.getTokenOffset(),o.getTokenLength()):()=>!0}const I=w(s.onObjectBegin),S=d(s.onObjectProperty),u=w(s.onObjectEnd),g=w(s.onArrayBegin),h=w(s.onArrayEnd),P=d(s.onLiteralValue),W=d(s.onSeparator),K=w(s.onComment),j=d(s.onError),B=n&&n.disallowComments,O=n&&n.allowTrailingComma;function N(){for(;;){const ce=o.scan();switch(o.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:B||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(ce){case 12:case 13:B?te(10):K();break;case 16:te(1);break;case 15:case 14:break;default:return ce}}}function te(ce,se=[],$e=[]){if(j(ce),se.length+$e.length>0){let _=o.getToken();for(;_!==17;){if(se.indexOf(_)!==-1){N();break}else if($e.indexOf(_)!==-1)break;_=N()}}}function Y(ce){const se=o.getTokenValue();return ce?P(se):S(se),N(),!0}function Ee(){switch(o.getToken()){case 11:{let ce=0;try{ce=JSON.parse(o.getTokenValue()),typeof ce!="number"&&(te(2),ce=0)}catch{te(2)}P(ce);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return N(),!0}function Se(){return o.getToken()!==10?(te(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(W(":"),N(),me()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function Pe(){I(),N();let ce=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ce||te(4,[],[]),W(","),N(),o.getToken()===2&&O)break}else ce&&te(6,[],[]);Se()||te(4,[],[2,5]),ce=!0}return u(),o.getToken()!==2?te(7,[2],[]):N(),!0}function ge(){g(),N();let ce=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ce||te(4,[],[]),W(","),N(),o.getToken()===4&&O)break}else ce&&te(6,[],[]);me()||te(4,[],[4,5]),ce=!0}return h(),o.getToken()!==4?te(8,[4],[]):N(),!0}function me(){switch(o.getToken()){case 3:return ge();case 1:return Pe();case 10:return Y(!0);default:return Ee()}}return N(),o.getToken()===17?n.allowEmptyContent?!0:(te(4,[],[]),!1):me()?(o.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.$Zm=b;function E(r,s){const n=A(r),o=[];let w,d=0,I;do switch(I=n.getPosition(),w=n.scan(),w){case 12:case 13:case 17:d!==I&&o.push(r.substring(d,I)),s!==void 0&&o.push(n.getTokenValue().replace(/[^\r\n]/g,s)),d=n.getPosition();break}while(w!==17);return o.join("")}e.$1m=E;function v(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$2m=v}),function(we,e){typeof define=="function"&&define.amd?define(Re[116],Me([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(we=typeof globalThis<"u"?globalThis:we||self,e(we.marked={}))}(this,function(we){"use strict";function e(be,pe){for(var De=0;De<pe.length;De++){var ne=pe[De];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(be,ne.key,ne)}}function y(be,pe,De){return pe&&e(be.prototype,pe),De&&e(be,De),Object.defineProperty(be,"prototype",{writable:!1}),be}function M(be,pe){if(be){if(typeof be=="string")return C(be,pe);var De=Object.prototype.toString.call(be).slice(8,-1);if(De==="Object"&&be.constructor&&(De=be.constructor.name),De==="Map"||De==="Set")return Array.from(be);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return C(be,pe)}}function C(be,pe){(pe==null||pe>be.length)&&(pe=be.length);for(var De=0,ne=new Array(pe);De<pe;De++)ne[De]=be[De];return ne}function L(be,pe){var De=typeof Symbol<"u"&&be[Symbol.iterator]||be["@@iterator"];if(De)return(De=De.call(be)).next.bind(De);if(Array.isArray(be)||(De=M(be))||pe&&be&&typeof be.length=="number"){De&&(be=De);var ne=0;return function(){return ne>=be.length?{done:!0}:{done:!1,value:be[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}we.defaults=A();function l(be){we.defaults=be}var k=/[&<>"']/,f=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(pe){return c[pe]};function $(be,pe){if(pe){if(k.test(be))return be.replace(f,p)}else if(R.test(be))return be.replace(D,p);return be}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(be){return be.replace(m,function(pe,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var i=/(^|[^\[])\^/g;function a(be,pe){be=typeof be=="string"?be:be.source,pe=pe||"";var De={replace:function(le,re){return re=re.source||re,re=re.replace(i,"$1"),be=be.replace(le,re),De},getRegex:function(){return new RegExp(be,pe)}};return De}var b=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(be,pe,De){if(be){var ne;try{ne=decodeURIComponent(t(De)).replace(b,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}pe&&!E.test(De)&&(De=w(pe,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch{return null}return De}var r={},s=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function w(be,pe){r[" "+be]||(s.test(be)?r[" "+be]=be+"/":r[" "+be]=u(be,"/",!0)),be=r[" "+be];var De=be.indexOf(":")===-1;return pe.substring(0,2)==="//"?De?pe:be.replace(n,"$1")+pe:pe.charAt(0)==="/"?De?pe:be.replace(o,"$1")+pe:be+pe}var d={exec:function(){}};function I(be){for(var pe=1,De,ne;pe<arguments.length;pe++){De=arguments[pe];for(ne in De)Object.prototype.hasOwnProperty.call(De,ne)&&(be[ne]=De[ne])}return be}function S(be,pe){var De=be.replace(/\|/g,function(re,oe,de){for(var Ie=!1,F=oe;--F>=0&&de[F]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ne=De.split(/ \|/),le=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>pe)ne.splice(pe);else for(;ne.length<pe;)ne.push("");for(;le<ne.length;le++)ne[le]=ne[le].trim().replace(/\\\|/g,"|");return ne}function u(be,pe,De){var ne=be.length;if(ne===0)return"";for(var le=0;le<ne;){var re=be.charAt(ne-le-1);if(re===pe&&!De)le++;else if(re!==pe&&De)le++;else break}return be.slice(0,ne-le)}function g(be,pe){if(be.indexOf(pe[1])===-1)return-1;for(var De=be.length,ne=0,le=0;le<De;le++)if(be[le]==="\\")le++;else if(be[le]===pe[0])ne++;else if(be[le]===pe[1]&&(ne--,ne<0))return le;return-1}function h(be){be&&be.sanitize&&!be.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(be,pe){if(pe<1)return"";for(var De="";pe>1;)pe&1&&(De+=be),pe>>=1,be+=be;return De+be}function W(be,pe,De,ne){var le=pe.href,re=pe.title?$(pe.title):null,oe=be[1].replace(/\\([\[\]])/g,"$1");if(be[0].charAt(0)!=="!"){ne.state.inLink=!0;var de={type:"link",raw:De,href:le,title:re,text:oe,tokens:ne.inlineTokens(oe)};return ne.state.inLink=!1,de}return{type:"image",raw:De,href:le,title:re,text:$(oe)}}function K(be,pe){var De=be.match(/^(\s+)(?:```)/);if(De===null)return pe;var ne=De[1];return pe.split(`
`).map(function(le){var re=le.match(/^\s+/);if(re===null)return le;var oe=re[0];return oe.length>=ne.length?le.slice(ne.length):le}).join(`
`)}var j=function(){function be(De){this.options=De||we.defaults}var pe=be.prototype;return pe.space=function(ne){var le=this.rules.block.newline.exec(ne);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},pe.code=function(ne){var le=this.rules.block.code.exec(ne);if(le){var re=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?re:u(re,`
`)}}},pe.fences=function(ne){var le=this.rules.block.fences.exec(ne);if(le){var re=le[0],oe=K(re,le[3]||"");return{type:"code",raw:re,lang:le[2]?le[2].trim():le[2],text:oe}}},pe.heading=function(ne){var le=this.rules.block.heading.exec(ne);if(le){var re=le[2].trim();if(/#$/.test(re)){var oe=u(re,"#");(this.options.pedantic||!oe||/ $/.test(oe))&&(re=oe.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:re,tokens:this.lexer.inline(re)}}},pe.hr=function(ne){var le=this.rules.block.hr.exec(ne);if(le)return{type:"hr",raw:le[0]}},pe.blockquote=function(ne){var le=this.rules.block.blockquote.exec(ne);if(le){var re=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},pe.list=function(ne){var le=this.rules.block.list.exec(ne);if(le){var re,oe,de,Ie,F,q,J,Q,H,x,ae,Le,je=le[1].trim(),Qe=je.length>1,Ge={type:"list",raw:"",ordered:Qe,start:Qe?+je.slice(0,-1):"",loose:!1,items:[]};je=Qe?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Qe?je:"[*+-]");for(var xe=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(Le=!1,!(!(le=xe.exec(ne))||this.rules.block.hr.test(ne)));){if(re=le[0],ne=ne.substring(re.length),Q=le[2].split(`
`,1)[0],H=ne.split(`
`,1)[0],this.options.pedantic?(Ie=2,ae=Q.trimLeft()):(Ie=le[2].search(/[^ ]/),Ie=Ie>4?1:Ie,ae=Q.slice(Ie),Ie+=le[1].length),q=!1,!Q&&/^ *$/.test(H)&&(re+=H+`
`,ne=ne.substring(H.length+1),Le=!0),!Le)for(var Xe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");ne&&(x=ne.split(`
`,1)[0],Q=x,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Xe.test(Q)||_e.test(ne)));){if(Q.search(/[^ ]/)>=Ie||!Q.trim())ae+=`
`+Q.slice(Ie);else if(!q)ae+=`
`+Q;else break;!q&&!Q.trim()&&(q=!0),re+=x+`
`,ne=ne.substring(x.length+1)}Ge.loose||(J?Ge.loose=!0:/\n *\n *$/.test(re)&&(J=!0)),this.options.gfm&&(oe=/^\[[ xX]\] /.exec(ae),oe&&(de=oe[0]!=="[ ] ",ae=ae.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:re,task:!!oe,checked:de,loose:!1,text:ae}),Ge.raw+=re}Ge.items[Ge.items.length-1].raw=re.trimRight(),Ge.items[Ge.items.length-1].text=ae.trimRight(),Ge.raw=Ge.raw.trimRight();var ze=Ge.items.length;for(F=0;F<ze;F++){this.lexer.state.top=!1,Ge.items[F].tokens=this.lexer.blockTokens(Ge.items[F].text,[]);var st=Ge.items[F].tokens.filter(function(Z){return Z.type==="space"}),X=st.every(function(Z){for(var ve=Z.raw.split(""),Ue=0,Oe=L(ve),Ze;!(Ze=Oe()).done;){var rt=Ze.value;if(rt===`
`&&(Ue+=1),Ue>1)return!0}return!1});!Ge.loose&&st.length&&X&&(Ge.loose=!0,Ge.items[F].loose=!0)}return Ge}},pe.html=function(ne){var le=this.rules.block.html.exec(ne);if(le){var re={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};if(this.options.sanitize){var oe=this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]);re.type="paragraph",re.text=oe,re.tokens=this.lexer.inline(oe)}return re}},pe.def=function(ne){var le=this.rules.block.def.exec(ne);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var re=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:le[0],href:le[2],title:le[3]}}},pe.table=function(ne){var le=this.rules.block.table.exec(ne);if(le){var re={type:"table",header:S(le[1]).map(function(J){return{text:J}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=le[0];var oe=re.align.length,de,Ie,F,q;for(de=0;de<oe;de++)/^ *-+: *$/.test(re.align[de])?re.align[de]="right":/^ *:-+: *$/.test(re.align[de])?re.align[de]="center":/^ *:-+ *$/.test(re.align[de])?re.align[de]="left":re.align[de]=null;for(oe=re.rows.length,de=0;de<oe;de++)re.rows[de]=S(re.rows[de],re.header.length).map(function(J){return{text:J}});for(oe=re.header.length,Ie=0;Ie<oe;Ie++)re.header[Ie].tokens=this.lexer.inline(re.header[Ie].text);for(oe=re.rows.length,Ie=0;Ie<oe;Ie++)for(q=re.rows[Ie],F=0;F<q.length;F++)q[F].tokens=this.lexer.inline(q[F].text);return re}}},pe.lheading=function(ne){var le=this.rules.block.lheading.exec(ne);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:this.lexer.inline(le[1])}},pe.paragraph=function(ne){var le=this.rules.block.paragraph.exec(ne);if(le){var re=le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1];return{type:"paragraph",raw:le[0],text:re,tokens:this.lexer.inline(re)}}},pe.text=function(ne){var le=this.rules.block.text.exec(ne);if(le)return{type:"text",raw:le[0],text:le[0],tokens:this.lexer.inline(le[0])}},pe.escape=function(ne){var le=this.rules.inline.escape.exec(ne);if(le)return{type:"escape",raw:le[0],text:$(le[1])}},pe.tag=function(ne){var le=this.rules.inline.tag.exec(ne);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):$(le[0]):le[0]}},pe.link=function(ne){var le=this.rules.inline.link.exec(ne);if(le){var re=le[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var oe=u(re.slice(0,-1),"\\");if((re.length-oe.length)%2===0)return}else{var de=g(le[2],"()");if(de>-1){var Ie=le[0].indexOf("!")===0?5:4,F=Ie+le[1].length+de;le[2]=le[2].substring(0,de),le[0]=le[0].substring(0,F).trim(),le[3]=""}}var q=le[2],J="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);Q&&(q=Q[1],J=Q[3])}else J=le[3]?le[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(re)?q=q.slice(1):q=q.slice(1,-1)),W(le,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:J&&J.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},pe.reflink=function(ne,le){var re;if((re=this.rules.inline.reflink.exec(ne))||(re=this.rules.inline.nolink.exec(ne))){var oe=(re[2]||re[1]).replace(/\s+/g," ");if(oe=le[oe.toLowerCase()],!oe||!oe.href){var de=re[0].charAt(0);return{type:"text",raw:de,text:de}}return W(re,oe,re[0],this.lexer)}},pe.emStrong=function(ne,le,re){re===void 0&&(re="");var oe=this.rules.inline.emStrong.lDelim.exec(ne);if(oe&&!(oe[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=oe[1]||oe[2]||"";if(!de||de&&(re===""||this.rules.inline.punctuation.exec(re))){var Ie=oe[0].length-1,F,q,J=Ie,Q=0,H=oe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,le=le.slice(-1*ne.length+Ie);(oe=H.exec(le))!=null;)if(F=oe[1]||oe[2]||oe[3]||oe[4]||oe[5]||oe[6],!!F){if(q=F.length,oe[3]||oe[4]){J+=q;continue}else if((oe[5]||oe[6])&&Ie%3&&!((Ie+q)%3)){Q+=q;continue}if(J-=q,!(J>0)){if(q=Math.min(q,q+J+Q),Math.min(Ie,q)%2){var x=ne.slice(1,Ie+oe.index+q);return{type:"em",raw:ne.slice(0,Ie+oe.index+q+1),text:x,tokens:this.lexer.inlineTokens(x)}}var ae=ne.slice(2,Ie+oe.index+q-1);return{type:"strong",raw:ne.slice(0,Ie+oe.index+q+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}}}}},pe.codespan=function(ne){var le=this.rules.inline.code.exec(ne);if(le){var re=le[2].replace(/\n/g," "),oe=/[^ ]/.test(re),de=/^ /.test(re)&&/ $/.test(re);return oe&&de&&(re=re.substring(1,re.length-1)),re=$(re,!0),{type:"codespan",raw:le[0],text:re}}},pe.br=function(ne){var le=this.rules.inline.br.exec(ne);if(le)return{type:"br",raw:le[0]}},pe.del=function(ne){var le=this.rules.inline.del.exec(ne);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2])}},pe.autolink=function(ne,le){var re=this.rules.inline.autolink.exec(ne);if(re){var oe,de;return re[2]==="@"?(oe=$(this.options.mangle?le(re[1]):re[1]),de="mailto:"+oe):(oe=$(re[1]),de=oe),{type:"link",raw:re[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},pe.url=function(ne,le){var re;if(re=this.rules.inline.url.exec(ne)){var oe,de;if(re[2]==="@")oe=$(this.options.mangle?le(re[0]):re[0]),de="mailto:"+oe;else{var Ie;do Ie=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(Ie!==re[0]);oe=$(re[0]),re[1]==="www."?de="http://"+oe:de=oe}return{type:"link",raw:re[0],text:oe,href:de,tokens:[{type:"text",raw:oe,text:oe}]}}},pe.inlineText=function(ne,le){var re=this.rules.inline.text.exec(ne);if(re){var oe;return this.lexer.state.inRawBlock?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):$(re[0]):re[0]:oe=$(this.options.smartypants?le(re[0]):re[0]),{type:"text",raw:re[0],text:oe}}},be}(),B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=a(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.listItemStart=a(/^( *)(bull) */).replace("bull",B.bullet).getRegex(),B.list=a(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=a(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=a(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.blockquote=a(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=I({},B),B.gfm=I({},B.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.table=a(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.gfm.paragraph=a(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",B.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",B._tag).getRegex(),B.pedantic=I({},B.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:a(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=a(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=a(B._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=a(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=a(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=a(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=a(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=a(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=a(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=a(O.reflink).replace("label",O._label).replace("ref",B._label).getRegex(),O.nolink=a(O.nolink).replace("ref",B._label).getRegex(),O.reflinkSearch=a(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=I({},O),O.pedantic=I({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=I({},O.normal,{escape:a(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=a(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=I({},O.gfm,{br:a(O.br).replace("{2,}","*").getRegex(),text:a(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(be){return be.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function te(be){var pe="",De,ne,le=be.length;for(De=0;De<le;De++)ne=be.charCodeAt(De),Math.random()>.5&&(ne="x"+ne.toString(16)),pe+="&#"+ne+";";return pe}var Y=function(){function be(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||we.defaults,this.options.tokenizer=this.options.tokenizer||new j,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:B.normal,inline:O.normal};this.options.pedantic?(ne.block=B.pedantic,ne.inline=O.pedantic):this.options.gfm&&(ne.block=B.gfm,this.options.breaks?ne.inline=O.breaks:ne.inline=O.gfm),this.tokenizer.rules=ne}be.lex=function(ne,le){var re=new be(le);return re.lex(ne)},be.lexInline=function(ne,le){var re=new be(le);return re.inlineTokens(ne)};var pe=be.prototype;return pe.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},pe.blockTokens=function(ne,le){var re=this;le===void 0&&(le=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(J,Q,H){return Q+"    ".repeat(H.length)});for(var oe,de,Ie,F;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(J){return(oe=J.call({lexer:re},ne,le))?(ne=ne.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.space(ne)){ne=ne.substring(oe.raw.length),oe.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(oe);continue}if(oe=this.tokenizer.code(ne)){ne=ne.substring(oe.raw.length),de=le[le.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue[this.inlineQueue.length-1].src=de.text):le.push(oe);continue}if(oe=this.tokenizer.fences(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.heading(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.hr(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.blockquote(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.list(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.html(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.def(ne)){ne=ne.substring(oe.raw.length),de=le[le.length-1],de&&(de.type==="paragraph"||de.type==="text")?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.raw,this.inlineQueue[this.inlineQueue.length-1].src=de.text):this.tokens.links[oe.tag]||(this.tokens.links[oe.tag]={href:oe.href,title:oe.title});continue}if(oe=this.tokenizer.table(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.lheading(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var J=1/0,Q=ne.slice(1),H=void 0;re.options.extensions.startBlock.forEach(function(x){H=x.call({lexer:this},Q),typeof H=="number"&&H>=0&&(J=Math.min(J,H))}),J<1/0&&J>=0&&(Ie=ne.substring(0,J+1))}(),this.state.top&&(oe=this.tokenizer.paragraph(Ie))){de=le[le.length-1],F&&de.type==="paragraph"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):le.push(oe),F=Ie.length!==ne.length,ne=ne.substring(oe.raw.length);continue}if(oe=this.tokenizer.text(ne)){ne=ne.substring(oe.raw.length),de=le[le.length-1],de&&de.type==="text"?(de.raw+=`
`+oe.raw,de.text+=`
`+oe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=de.text):le.push(oe);continue}if(ne){var q="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,le},pe.inline=function(ne,le){return le===void 0&&(le=[]),this.inlineQueue.push({src:ne,tokens:le}),le},pe.inlineTokens=function(ne,le){var re=this;le===void 0&&(le=[]);var oe,de,Ie,F=ne,q,J,Q;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(F))!=null;)H.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(F=F.slice(0,q.index)+"["+P("a",q[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(F))!=null;)F=F.slice(0,q.index)+"["+P("a",q[0].length-2)+"]"+F.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(F))!=null;)F=F.slice(0,q.index)+"++"+F.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(J||(Q=""),J=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ae){return(oe=ae.call({lexer:re},ne,le))?(ne=ne.substring(oe.raw.length),le.push(oe),!0):!1}))){if(oe=this.tokenizer.escape(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.tag(ne)){ne=ne.substring(oe.raw.length),de=le[le.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.link(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(oe.raw.length),de=le[le.length-1],de&&oe.type==="text"&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):le.push(oe);continue}if(oe=this.tokenizer.emStrong(ne,F,Q)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.codespan(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.br(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.del(ne)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(oe=this.tokenizer.autolink(ne,te)){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(!this.state.inLink&&(oe=this.tokenizer.url(ne,te))){ne=ne.substring(oe.raw.length),le.push(oe);continue}if(Ie=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ae=1/0,Le=ne.slice(1),je=void 0;re.options.extensions.startInline.forEach(function(Qe){je=Qe.call({lexer:this},Le),typeof je=="number"&&je>=0&&(ae=Math.min(ae,je))}),ae<1/0&&ae>=0&&(Ie=ne.substring(0,ae+1))}(),oe=this.tokenizer.inlineText(Ie,N)){ne=ne.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(Q=oe.raw.slice(-1)),J=!0,de=le[le.length-1],de&&de.type==="text"?(de.raw+=oe.raw,de.text+=oe.text):le.push(oe);continue}if(ne){var x="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return le},y(be,null,[{key:"rules",get:function(){return{block:B,inline:O}}}]),be}(),Ee=function(){function be(De){this.options=De||we.defaults}var pe=be.prototype;return pe.code=function(ne,le,re){var oe=(le||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(ne,oe);de!=null&&de!==ne&&(re=!0,ne=de)}return ne=ne.replace(/\n$/,"")+`
`,oe?'<pre><code class="'+this.options.langPrefix+$(oe,!0)+'">'+(re?ne:$(ne,!0))+`</code></pre>
`:"<pre><code>"+(re?ne:$(ne,!0))+`</code></pre>
`},pe.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},pe.html=function(ne){return ne},pe.heading=function(ne,le,re,oe){if(this.options.headerIds){var de=this.options.headerPrefix+oe.slug(re);return"<h"+le+' id="'+de+'">'+ne+"</h"+le+`>
`}return"<h"+le+">"+ne+"</h"+le+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(ne,le,re){var oe=le?"ol":"ul",de=le&&re!==1?' start="'+re+'"':"";return"<"+oe+de+`>
`+ne+"</"+oe+`>
`},pe.listitem=function(ne){return"<li>"+ne+`</li>
`},pe.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(ne){return"<p>"+ne+`</p>
`},pe.table=function(ne,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+le+`</table>
`},pe.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},pe.tablecell=function(ne,le){var re=le.header?"th":"td",oe=le.align?"<"+re+' align="'+le.align+'">':"<"+re+">";return oe+ne+("</"+re+`>
`)},pe.strong=function(ne){return"<strong>"+ne+"</strong>"},pe.em=function(ne){return"<em>"+ne+"</em>"},pe.codespan=function(ne){return"<code>"+ne+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(ne){return"<del>"+ne+"</del>"},pe.link=function(ne,le,re){if(ne=v(this.options.sanitize,this.options.baseUrl,ne),ne===null)return re;var oe='<a href="'+$(ne)+'"';return le&&(oe+=' title="'+le+'"'),oe+=">"+re+"</a>",oe},pe.image=function(ne,le,re){if(ne=v(this.options.sanitize,this.options.baseUrl,ne),ne===null)return re;var oe='<img src="'+ne+'" alt="'+re+'"';return le&&(oe+=' title="'+le+'"'),oe+=this.options.xhtml?"/>":">",oe},pe.text=function(ne){return ne},be}(),Se=function(){function be(){}var pe=be.prototype;return pe.strong=function(ne){return ne},pe.em=function(ne){return ne},pe.codespan=function(ne){return ne},pe.del=function(ne){return ne},pe.html=function(ne){return ne},pe.text=function(ne){return ne},pe.link=function(ne,le,re){return""+re},pe.image=function(ne,le,re){return""+re},pe.br=function(){return""},be}(),Pe=function(){function be(){this.seen={}}var pe=be.prototype;return pe.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(ne,le){var re=ne,oe=0;if(this.seen.hasOwnProperty(re)){oe=this.seen[ne];do oe++,re=ne+"-"+oe;while(this.seen.hasOwnProperty(re))}return le||(this.seen[ne]=oe,this.seen[re]=0),re},pe.slug=function(ne,le){le===void 0&&(le={});var re=this.serialize(ne);return this.getNextSafeSlug(re,le.dryrun)},be}(),ge=function(){function be(De){this.options=De||we.defaults,this.options.renderer=this.options.renderer||new Ee,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Se,this.slugger=new Pe}be.parse=function(ne,le){var re=new be(le);return re.parse(ne)},be.parseInline=function(ne,le){var re=new be(le);return re.parseInline(ne)};var pe=be.prototype;return pe.parse=function(ne,le){le===void 0&&(le=!0);var re="",oe,de,Ie,F,q,J,Q,H,x,ae,Le,je,Qe,Ge,xe,Xe,_e,it,tt,ze=ne.length;for(oe=0;oe<ze;oe++){if(ae=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(tt=this.options.extensions.renderers[ae.type].call({parser:this},ae),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ae.type))){re+=tt||"";continue}switch(ae.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ae.tokens),ae.depth,t(this.parseInline(ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ae.text,ae.lang,ae.escaped);continue}case"table":{for(H="",Q="",F=ae.header.length,de=0;de<F;de++)Q+=this.renderer.tablecell(this.parseInline(ae.header[de].tokens),{header:!0,align:ae.align[de]});for(H+=this.renderer.tablerow(Q),x="",F=ae.rows.length,de=0;de<F;de++){for(J=ae.rows[de],Q="",q=J.length,Ie=0;Ie<q;Ie++)Q+=this.renderer.tablecell(this.parseInline(J[Ie].tokens),{header:!1,align:ae.align[Ie]});x+=this.renderer.tablerow(Q)}re+=this.renderer.table(H,x);continue}case"blockquote":{x=this.parse(ae.tokens),re+=this.renderer.blockquote(x);continue}case"list":{for(Le=ae.ordered,je=ae.start,Qe=ae.loose,F=ae.items.length,x="",de=0;de<F;de++)xe=ae.items[de],Xe=xe.checked,_e=xe.task,Ge="",xe.task&&(it=this.renderer.checkbox(Xe),Qe?xe.tokens.length>0&&xe.tokens[0].type==="paragraph"?(xe.tokens[0].text=it+" "+xe.tokens[0].text,xe.tokens[0].tokens&&xe.tokens[0].tokens.length>0&&xe.tokens[0].tokens[0].type==="text"&&(xe.tokens[0].tokens[0].text=it+" "+xe.tokens[0].tokens[0].text)):xe.tokens.unshift({type:"text",text:it}):Ge+=it),Ge+=this.parse(xe.tokens,Qe),x+=this.renderer.listitem(Ge,_e,Xe);re+=this.renderer.list(x,Le,je);continue}case"html":{re+=this.renderer.html(ae.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ae.tokens));continue}case"text":{for(x=ae.tokens?this.parseInline(ae.tokens):ae.text;oe+1<ze&&ne[oe+1].type==="text";)ae=ne[++oe],x+=`
`+(ae.tokens?this.parseInline(ae.tokens):ae.text);re+=le?this.renderer.paragraph(x):x;continue}default:{var st='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return re},pe.parseInline=function(ne,le){le=le||this.renderer;var re="",oe,de,Ie,F=ne.length;for(oe=0;oe<F;oe++){if(de=ne[oe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(Ie=this.options.extensions.renderers[de.type].call({parser:this},de),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(de.type))){re+=Ie||"";continue}switch(de.type){case"escape":{re+=le.text(de.text);break}case"html":{re+=le.html(de.text);break}case"link":{re+=le.link(de.href,de.title,this.parseInline(de.tokens,le));break}case"image":{re+=le.image(de.href,de.title,de.text);break}case"strong":{re+=le.strong(this.parseInline(de.tokens,le));break}case"em":{re+=le.em(this.parseInline(de.tokens,le));break}case"codespan":{re+=le.codespan(de.text);break}case"br":{re+=le.br();break}case"del":{re+=le.del(this.parseInline(de.tokens,le));break}case"text":{re+=le.text(de.text);break}default:{var q='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return re},be}();function me(be,pe,De){if(typeof be>"u"||be===null)throw new Error("marked(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");if(typeof pe=="function"&&(De=pe,pe=null),pe=I({},me.defaults,pe||{}),h(pe),De){var ne=pe.highlight,le;try{le=Y.lex(be,pe)}catch(F){return De(F)}var re=function(q){var J;if(!q)try{pe.walkTokens&&me.walkTokens(le,pe.walkTokens),J=ge.parse(le,pe)}catch(Q){q=Q}return pe.highlight=ne,q?De(q):De(null,J)};if(!ne||ne.length<3||(delete pe.highlight,!le.length))return re();var oe=0;me.walkTokens(le,function(F){F.type==="code"&&(oe++,setTimeout(function(){ne(F.text,F.lang,function(q,J){if(q)return re(q);J!=null&&J!==F.text&&(F.text=J,F.escaped=!0),oe--,oe===0&&re()})},0))}),oe===0&&re();return}function de(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+$(F.message+"",!0)+"</pre>";throw F}try{var Ie=Y.lex(be,pe);if(pe.walkTokens){if(pe.async)return Promise.all(me.walkTokens(Ie,pe.walkTokens)).then(function(){return ge.parse(Ie,pe)}).catch(de);me.walkTokens(Ie,pe.walkTokens)}return ge.parse(Ie,pe)}catch(F){de(F)}}me.options=me.setOptions=function(be){return I(me.defaults,be),l(me.defaults),me},me.getDefaults=A,me.defaults=we.defaults,me.use=function(){for(var be=arguments.length,pe=new Array(be),De=0;De<be;De++)pe[De]=arguments[De];var ne=I.apply(void 0,[{}].concat(pe)),le=me.defaults.extensions||{renderers:{},childTokens:{}},re;pe.forEach(function(oe){if(oe.extensions&&(re=!0,oe.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var F=le.renderers?le.renderers[Ie.name]:null;F?le.renderers[Ie.name]=function(){for(var q=arguments.length,J=new Array(q),Q=0;Q<q;Q++)J[Q]=arguments[Q];var H=Ie.renderer.apply(this,J);return H===!1&&(H=F.apply(this,J)),H}:le.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[Ie.level]?le[Ie.level].unshift(Ie.tokenizer):le[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?le.startBlock?le.startBlock.push(Ie.start):le.startBlock=[Ie.start]:Ie.level==="inline"&&(le.startInline?le.startInline.push(Ie.start):le.startInline=[Ie.start]))}Ie.childTokens&&(le.childTokens[Ie.name]=Ie.childTokens)})),oe.renderer&&function(){var Ie=me.defaults.renderer||new Ee,F=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Le=0;Le<x;Le++)ae[Le]=arguments[Le];var je=oe.renderer[Q].apply(Ie,ae);return je===!1&&(je=H.apply(Ie,ae)),je}};for(var q in oe.renderer)F(q);ne.renderer=Ie}(),oe.tokenizer&&function(){var Ie=me.defaults.tokenizer||new j,F=function(Q){var H=Ie[Q];Ie[Q]=function(){for(var x=arguments.length,ae=new Array(x),Le=0;Le<x;Le++)ae[Le]=arguments[Le];var je=oe.tokenizer[Q].apply(Ie,ae);return je===!1&&(je=H.apply(Ie,ae)),je}};for(var q in oe.tokenizer)F(q);ne.tokenizer=Ie}(),oe.walkTokens){var de=me.defaults.walkTokens;ne.walkTokens=function(Ie){var F=[];return F.push(oe.walkTokens.call(this,Ie)),de&&(F=F.concat(de.call(this,Ie))),F}}re&&(ne.extensions=le),me.setOptions(ne)})},me.walkTokens=function(be,pe){for(var De=[],ne=function(){var de=re.value;switch(De=De.concat(pe.call(me,de)),de.type){case"table":{for(var Ie=L(de.header),F;!(F=Ie()).done;){var q=F.value;De=De.concat(me.walkTokens(q.tokens,pe))}for(var J=L(de.rows),Q;!(Q=J()).done;)for(var H=Q.value,x=L(H),ae;!(ae=x()).done;){var Le=ae.value;De=De.concat(me.walkTokens(Le.tokens,pe))}break}case"list":{De=De.concat(me.walkTokens(de.items,pe));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[de.type]?me.defaults.extensions.childTokens[de.type].forEach(function(je){De=De.concat(me.walkTokens(de[je],pe))}):de.tokens&&(De=De.concat(me.walkTokens(de.tokens,pe)))}},le=L(be),re;!(re=le()).done;)ne();return De},me.parseInline=function(be,pe){if(typeof be>"u"||be===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof be!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(be)+", string expected");pe=I({},me.defaults,pe||{}),h(pe);try{var De=Y.lexInline(be,pe);return pe.walkTokens&&me.walkTokens(De,pe.walkTokens),ge.parseInline(De,pe)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+$(ne.message+"",!0)+"</pre>";throw ne}},me.Parser=ge,me.parser=ge.parse,me.Renderer=Ee,me.TextRenderer=Se,me.Lexer=Y,me.lexer=Y.lex,me.Tokenizer=j,me.Slugger=Pe,me.parse=me;var ce=me.options,se=me.setOptions,$e=me.use,_=me.walkTokens,z=me.parseInline,V=me,ue=ge.parse,ye=Y.lex;we.Lexer=Y,we.Parser=ge,we.Renderer=Ee,we.Slugger=Pe,we.TextRenderer=Se,we.Tokenizer=j,we.getDefaults=A,we.lexer=ye,we.marked=me,we.options=ce,we.parse=V,we.parseInline=z,we.parser=ue,we.setOptions=se,we.use=$e,we.walkTokens=_,Object.defineProperty(we,"__esModule",{value:!0})}),define(Re[117],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.rot=e.$Ll=void 0;function y(l,k,f){return Math.min(Math.max(l,k),f)}e.$Ll=y;function M(l,k){return(k+l%k)%k}e.rot=M;class C{constructor(){this.a=0}getNext(){return this.a++}}e.$Nl=C;class L{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ol=L;class A{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const f=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Pl=A}),function(){function we(C){const L=[];typeof C=="number"&&L.push("code/timeOrigin",C);function A(k){L.push(k,Date.now())}function l(){const k=[];for(let f=0;f<L.length;f+=2)k.push({name:L[f],startTime:L[f+1]});return k}return{mark:A,getMarks:l}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?we():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(C+A.startTime)});return L}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return we(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),we()}function y(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=y(M))}(),function(we,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var M in y)(typeof exports=="object"?exports:we)[M]=y[M]}}(typeof self<"u"?self:this,function(){return function(we){var e={};function y(M){if(e[M])return e[M].exports;var C=e[M]={i:M,l:!1,exports:{}};return we[M].call(C.exports,C,C.exports,y),C.l=!0,C.exports}return y.m=we,y.c=e,y.d=function(M,C,L){y.o(M,C)||Object.defineProperty(M,C,{enumerable:!0,get:L})},y.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},y.t=function(M,C){if(1&C&&(M=y(M)),8&C||4&C&&typeof M=="object"&&M&&M.__esModule)return M;var L=Object.create(null);if(y.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:M}),2&C&&typeof M!="string")for(var A in M)y.d(L,A,function(l){return M[l]}.bind(null,A));return L},y.n=function(M){var C=M&&M.__esModule?function(){return M.default}:function(){return M};return y.d(C,"a",C),C},y.o=function(M,C){return Object.prototype.hasOwnProperty.call(M,C)},y.p="",y(y.s=0)}([function(we,e,y){(function(M){var C;e=we.exports=$e,C=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,l=e.re=[],k=e.src=[],f=0,R=f++;k[R]="0|[1-9]\\d*";var D=f++;k[D]="[0-9]+";var c=f++;k[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=f++;k[p]="("+k[R]+")\\.("+k[R]+")\\.("+k[R]+")";var $=f++;k[$]="("+k[D]+")\\.("+k[D]+")\\.("+k[D]+")";var m=f++;k[m]="(?:"+k[R]+"|"+k[c]+")";var t=f++;k[t]="(?:"+k[D]+"|"+k[c]+")";var i=f++;k[i]="(?:-("+k[m]+"(?:\\."+k[m]+")*))";var a=f++;k[a]="(?:-?("+k[t]+"(?:\\."+k[t]+")*))";var b=f++;k[b]="[0-9A-Za-z-]+";var E=f++;k[E]="(?:\\+("+k[b]+"(?:\\."+k[b]+")*))";var v=f++,r="v?"+k[p]+k[i]+"?"+k[E]+"?";k[v]="^"+r+"$";var s="[v=\\s]*"+k[$]+k[a]+"?"+k[E]+"?",n=f++;k[n]="^"+s+"$";var o=f++;k[o]="((?:<|>)?=?)";var w=f++;k[w]=k[D]+"|x|X|\\*";var d=f++;k[d]=k[R]+"|x|X|\\*";var I=f++;k[I]="[v=\\s]*("+k[d]+")(?:\\.("+k[d]+")(?:\\.("+k[d]+")(?:"+k[i]+")?"+k[E]+"?)?)?";var S=f++;k[S]="[v=\\s]*("+k[w]+")(?:\\.("+k[w]+")(?:\\.("+k[w]+")(?:"+k[a]+")?"+k[E]+"?)?)?";var u=f++;k[u]="^"+k[o]+"\\s*"+k[I]+"$";var g=f++;k[g]="^"+k[o]+"\\s*"+k[S]+"$";var h=f++;k[h]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=f++;k[P]="(?:~>?)";var W=f++;k[W]="(\\s*)"+k[P]+"\\s+",l[W]=new RegExp(k[W],"g");var K=f++;k[K]="^"+k[P]+k[I]+"$";var j=f++;k[j]="^"+k[P]+k[S]+"$";var B=f++;k[B]="(?:\\^)";var O=f++;k[O]="(\\s*)"+k[B]+"\\s+",l[O]=new RegExp(k[O],"g");var N=f++;k[N]="^"+k[B]+k[I]+"$";var te=f++;k[te]="^"+k[B]+k[S]+"$";var Y=f++;k[Y]="^"+k[o]+"\\s*("+s+")$|^$";var Ee=f++;k[Ee]="^"+k[o]+"\\s*("+r+")$|^$";var Se=f++;k[Se]="(\\s*)"+k[o]+"\\s*("+s+"|"+k[I]+")",l[Se]=new RegExp(k[Se],"g");var Pe=f++;k[Pe]="^\\s*("+k[I]+")\\s+-\\s+("+k[I]+")\\s*$";var ge=f++;k[ge]="^\\s*("+k[S]+")\\s+-\\s+("+k[S]+")\\s*$";var me=f++;k[me]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)C(ce,k[ce]),l[ce]||(l[ce]=new RegExp(k[ce]));function se(H,x){if(H instanceof $e)return H;if(typeof H!="string"||H.length>L||!(x?l[n]:l[v]).test(H))return null;try{return new $e(H,x)}catch{return null}}function $e(H,x){if(H instanceof $e){if(H.loose===x)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof $e))return new $e(H,x);C("SemVer",H,x),this.loose=x;var ae=H.trim().match(x?l[n]:l[v]);if(!ae)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+ae[1],this.minor=+ae[2],this.patch=+ae[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ae[4]?this.prerelease=ae[4].split(".").map(function(Le){if(/^[0-9]+$/.test(Le)){var je=+Le;if(je>=0&&je<A)return je}return Le}):this.prerelease=[],this.build=ae[5]?ae[5].split("."):[],this.format()}e.parse=se,e.valid=function(H,x){var ae=se(H,x);return ae?ae.version:null},e.clean=function(H,x){var ae=se(H.trim().replace(/^[=v]+/,""),x);return ae?ae.version:null},e.SemVer=$e,$e.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},$e.prototype.toString=function(){return this.version},$e.prototype.compare=function(H){return C("SemVer.compare",this.version,this.loose,H),H instanceof $e||(H=new $e(H,this.loose)),this.compareMain(H)||this.comparePre(H)},$e.prototype.compareMain=function(H){return H instanceof $e||(H=new $e(H,this.loose)),z(this.major,H.major)||z(this.minor,H.minor)||z(this.patch,H.patch)},$e.prototype.comparePre=function(H){if(H instanceof $e||(H=new $e(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var x=0;do{var ae=this.prerelease[x],Le=H.prerelease[x];if(C("prerelease compare",x,ae,Le),ae===void 0&&Le===void 0)return 0;if(Le===void 0)return 1;if(ae===void 0)return-1;if(ae!==Le)return z(ae,Le)}while(++x)},$e.prototype.inc=function(H,x){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",x);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",x);break;case"prepatch":this.prerelease.length=0,this.inc("patch",x),this.inc("pre",x);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",x),this.inc("pre",x);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ae=this.prerelease.length;--ae>=0;)typeof this.prerelease[ae]=="number"&&(this.prerelease[ae]++,ae=-2);ae===-1&&this.prerelease.push(0)}x&&(this.prerelease[0]===x?isNaN(this.prerelease[1])&&(this.prerelease=[x,0]):this.prerelease=[x,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,x,ae,Le){typeof ae=="string"&&(Le=ae,ae=void 0);try{return new $e(H,ae).inc(x,Le).version}catch{return null}},e.diff=function(H,x){if(be(H,x))return null;var ae=se(H),Le=se(x);if(ae.prerelease.length||Le.prerelease.length){for(var je in ae)if((je==="major"||je==="minor"||je==="patch")&&ae[je]!==Le[je])return"pre"+je;return"prerelease"}for(var je in ae)if((je==="major"||je==="minor"||je==="patch")&&ae[je]!==Le[je])return je},e.compareIdentifiers=z;var _=/^[0-9]+$/;function z(H,x){var ae=_.test(H),Le=_.test(x);return ae&&Le&&(H=+H,x=+x),ae&&!Le?-1:Le&&!ae?1:H<x?-1:H>x?1:0}function V(H,x,ae){return new $e(H,ae).compare(new $e(x,ae))}function ue(H,x,ae){return V(H,x,ae)>0}function ye(H,x,ae){return V(H,x,ae)<0}function be(H,x,ae){return V(H,x,ae)===0}function pe(H,x,ae){return V(H,x,ae)!==0}function De(H,x,ae){return V(H,x,ae)>=0}function ne(H,x,ae){return V(H,x,ae)<=0}function le(H,x,ae,Le){var je;switch(x){case"===":typeof H=="object"&&(H=H.version),typeof ae=="object"&&(ae=ae.version),je=H===ae;break;case"!==":typeof H=="object"&&(H=H.version),typeof ae=="object"&&(ae=ae.version),je=H!==ae;break;case"":case"=":case"==":je=be(H,ae,Le);break;case"!=":je=pe(H,ae,Le);break;case">":je=ue(H,ae,Le);break;case">=":je=De(H,ae,Le);break;case"<":je=ye(H,ae,Le);break;case"<=":je=ne(H,ae,Le);break;default:throw new TypeError("Invalid operator: "+x)}return je}function re(H,x){if(H instanceof re){if(H.loose===x)return H;H=H.value}if(!(this instanceof re))return new re(H,x);C("comparator",H,x),this.loose=x,this.parse(H),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,C("comp",this)}e.rcompareIdentifiers=function(H,x){return z(x,H)},e.major=function(H,x){return new $e(H,x).major},e.minor=function(H,x){return new $e(H,x).minor},e.patch=function(H,x){return new $e(H,x).patch},e.compare=V,e.compareLoose=function(H,x){return V(H,x,!0)},e.rcompare=function(H,x,ae){return V(x,H,ae)},e.sort=function(H,x){return H.sort(function(ae,Le){return e.compare(ae,Le,x)})},e.rsort=function(H,x){return H.sort(function(ae,Le){return e.rcompare(ae,Le,x)})},e.gt=ue,e.lt=ye,e.eq=be,e.neq=pe,e.gte=De,e.lte=ne,e.cmp=le,e.Comparator=re;var oe={};function de(H,x){if(H instanceof de)return H.loose===x?H:new de(H.raw,x);if(H instanceof re)return new de(H.value,x);if(!(this instanceof de))return new de(H,x);if(this.loose=x,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(ae){return this.parseRange(ae.trim())},this).filter(function(ae){return ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function Ie(H){return!H||H.toLowerCase()==="x"||H==="*"}function F(H,x,ae,Le,je,Qe,Ge,xe,Xe,_e,it,tt,ze){return((x=Ie(ae)?"":Ie(Le)?">="+ae+".0.0":Ie(je)?">="+ae+"."+Le+".0":">="+x)+" "+(xe=Ie(Xe)?"":Ie(_e)?"<"+(+Xe+1)+".0.0":Ie(it)?"<"+Xe+"."+(+_e+1)+".0":tt?"<="+Xe+"."+_e+"."+it+"-"+tt:"<="+xe)).trim()}function q(H,x){for(var ae=0;ae<H.length;ae++)if(!H[ae].test(x))return!1;if(x.prerelease.length){for(ae=0;ae<H.length;ae++)if(C(H[ae].semver),H[ae].semver!==oe&&H[ae].semver.prerelease.length>0){var Le=H[ae].semver;if(Le.major===x.major&&Le.minor===x.minor&&Le.patch===x.patch)return!0}return!1}return!0}function J(H,x,ae){try{x=new de(x,ae)}catch{return!1}return x.test(H)}function Q(H,x,ae,Le){var je,Qe,Ge,xe,Xe;switch(H=new $e(H,Le),x=new de(x,Le),ae){case">":je=ue,Qe=ne,Ge=ye,xe=">",Xe=">=";break;case"<":je=ye,Qe=De,Ge=ue,xe="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(J(H,x,Le))return!1;for(var _e=0;_e<x.set.length;++_e){var it=x.set[_e],tt=null,ze=null;if(it.forEach(function(st){st.semver===oe&&(st=new re(">=0.0.0")),tt=tt||st,ze=ze||st,je(st.semver,tt.semver,Le)?tt=st:Ge(st.semver,ze.semver,Le)&&(ze=st)}),tt.operator===xe||tt.operator===Xe||(!ze.operator||ze.operator===xe)&&Qe(H,ze.semver)||ze.operator===Xe&&Ge(H,ze.semver))return!1}return!0}re.prototype.parse=function(H){var x=this.loose?l[Y]:l[Ee],ae=H.match(x);if(!ae)throw new TypeError("Invalid comparator: "+H);this.operator=ae[1],this.operator==="="&&(this.operator=""),ae[2]?this.semver=new $e(ae[2],this.loose):this.semver=oe},re.prototype.toString=function(){return this.value},re.prototype.test=function(H){return C("Comparator.test",H,this.loose),this.semver===oe||(typeof H=="string"&&(H=new $e(H,this.loose)),le(H,this.operator,this.semver,this.loose))},re.prototype.intersects=function(H,x){if(!(H instanceof re))throw new TypeError("a Comparator is required");var ae;if(this.operator==="")return ae=new de(H.value,x),J(this.value,ae,x);if(H.operator==="")return ae=new de(this.value,x),J(H.semver,ae,x);var Le=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Qe=this.semver.version===H.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),xe=le(this.semver,"<",H.semver,x)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Xe=le(this.semver,">",H.semver,x)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Le||je||Qe&&Ge||xe||Xe},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(H){var x=this.loose;H=H.trim(),C("range",H,x);var ae=x?l[ge]:l[Pe];H=H.replace(ae,F),C("hyphen replace",H),H=H.replace(l[Se],"$1$2$3"),C("comparator trim",H,l[Se]),H=(H=(H=H.replace(l[W],"$1~")).replace(l[O],"$1^")).split(/\s+/).join(" ");var Le=x?l[Y]:l[Ee],je=H.split(" ").map(function(Qe){return function(Ge,xe){return C("comp",Ge),Ge=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){C("caret",tt,ze);var st=ze?l[te]:l[N];return tt.replace(st,function(X,Z,ve,Ue,Oe){var Ze;return C("caret",tt,X,Z,ve,Ue,Oe),Ie(Z)?Ze="":Ie(ve)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(Ue)?Ze=Z==="0"?">="+Z+"."+ve+".0 <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+".0 <"+(+Z+1)+".0.0":Oe?(C("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ze=Z==="0"?ve==="0"?">="+Z+"."+ve+"."+Ue+Oe+" <"+Z+"."+ve+"."+(+Ue+1):">="+Z+"."+ve+"."+Ue+Oe+" <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+"."+Ue+Oe+" <"+(+Z+1)+".0.0"):(C("no pr"),Ze=Z==="0"?ve==="0"?">="+Z+"."+ve+"."+Ue+" <"+Z+"."+ve+"."+(+Ue+1):">="+Z+"."+ve+"."+Ue+" <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+"."+Ue+" <"+(+Z+1)+".0.0"),C("caret return",Ze),Ze})}(it,_e)}).join(" ")}(Ge,xe),C("caret",Ge),Ge=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(it){return function(tt,ze){var st=ze?l[j]:l[K];return tt.replace(st,function(X,Z,ve,Ue,Oe){var Ze;return C("tilde",tt,X,Z,ve,Ue,Oe),Ie(Z)?Ze="":Ie(ve)?Ze=">="+Z+".0.0 <"+(+Z+1)+".0.0":Ie(Ue)?Ze=">="+Z+"."+ve+".0 <"+Z+"."+(+ve+1)+".0":Oe?(C("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ze=">="+Z+"."+ve+"."+Ue+Oe+" <"+Z+"."+(+ve+1)+".0"):Ze=">="+Z+"."+ve+"."+Ue+" <"+Z+"."+(+ve+1)+".0",C("tilde return",Ze),Ze})}(it,_e)}).join(" ")}(Ge,xe),C("tildes",Ge),Ge=function(Xe,_e){return C("replaceXRanges",Xe,_e),Xe.split(/\s+/).map(function(it){return function(tt,ze){tt=tt.trim();var st=ze?l[g]:l[u];return tt.replace(st,function(X,Z,ve,Ue,Oe,Ze){C("xRange",tt,X,Z,ve,Ue,Oe,Ze);var rt=Ie(ve),mt=rt||Ie(Ue),wt=mt||Ie(Oe);return Z==="="&&wt&&(Z=""),rt?X=Z===">"||Z==="<"?"<0.0.0":"*":Z&&wt?(mt&&(Ue=0),wt&&(Oe=0),Z===">"?(Z=">=",mt?(ve=+ve+1,Ue=0,Oe=0):wt&&(Ue=+Ue+1,Oe=0)):Z==="<="&&(Z="<",mt?ve=+ve+1:Ue=+Ue+1),X=Z+ve+"."+Ue+"."+Oe):mt?X=">="+ve+".0.0 <"+(+ve+1)+".0.0":wt&&(X=">="+ve+"."+Ue+".0 <"+ve+"."+(+Ue+1)+".0"),C("xRange return",X),X})}(it,_e)}).join(" ")}(Ge,xe),C("xrange",Ge),Ge=function(Xe,_e){return C("replaceStars",Xe,_e),Xe.trim().replace(l[me],"")}(Ge,xe),C("stars",Ge),Ge}(Qe,x)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Qe){return!!Qe.match(Le)})),je=je.map(function(Qe){return new re(Qe,x)})},de.prototype.intersects=function(H,x){if(!(H instanceof de))throw new TypeError("a Range is required");return this.set.some(function(ae){return ae.every(function(Le){return H.set.some(function(je){return je.every(function(Qe){return Le.intersects(Qe,x)})})})})},e.toComparators=function(H,x){return new de(H,x).set.map(function(ae){return ae.map(function(Le){return Le.value}).join(" ").trim().split(" ")})},de.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new $e(H,this.loose));for(var x=0;x<this.set.length;x++)if(q(this.set[x],H))return!0;return!1},e.satisfies=J,e.maxSatisfying=function(H,x,ae){var Le=null,je=null;try{var Qe=new de(x,ae)}catch{return null}return H.forEach(function(Ge){Qe.test(Ge)&&(Le&&je.compare(Ge)!==-1||(je=new $e(Le=Ge,ae)))}),Le},e.minSatisfying=function(H,x,ae){var Le=null,je=null;try{var Qe=new de(x,ae)}catch{return null}return H.forEach(function(Ge){Qe.test(Ge)&&(Le&&je.compare(Ge)!==1||(je=new $e(Le=Ge,ae)))}),Le},e.validRange=function(H,x){try{return new de(H,x).range||"*"}catch{return null}},e.ltr=function(H,x,ae){return Q(H,x,"<",ae)},e.gtr=function(H,x,ae){return Q(H,x,">",ae)},e.outside=Q,e.prerelease=function(H,x){var ae=se(H,x);return ae&&ae.prerelease.length?ae.prerelease:null},e.intersects=function(H,x,ae){return H=new de(H,ae),x=new de(x,ae),H.intersects(x)},e.coerce=function(H){if(H instanceof $e)return H;if(typeof H!="string")return null;var x=H.match(l[h]);return x==null?null:se((x[1]||"0")+"."+(x[2]||"0")+"."+(x[3]||"0"))}}).call(this,y(1))},function(we,e){var y,M,C=we.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function l(t){if(y===setTimeout)return setTimeout(t,0);if((y===L||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:L}catch{y=L}try{M=typeof clearTimeout=="function"?clearTimeout:A}catch{M=A}})();var k,f=[],R=!1,D=-1;function c(){R&&k&&(R=!1,k.length?f=k.concat(f):D=-1,f.length&&p())}function p(){if(!R){var t=l(c);R=!0;for(var i=f.length;i;){for(k=f,f=[];++D<i;)k&&k[D].run();D=-1,i=f.length}k=null,R=!1,function(a){if(M===clearTimeout)return clearTimeout(a);if((M===A||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(a);try{M(a)}catch{try{return M.call(null,a)}catch{return M.call(this,a)}}}(t)}}function $(t,i){this.fun=t,this.array=i}function m(){}C.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)i[a-1]=arguments[a];f.push(new $(t,i)),f.length!==1||R||l(p)},$.prototype.run=function(){this.fun.apply(null,this.array)},C.title="browser",C.browser=!0,C.env={},C.argv=[],C.version="",C.versions={},C.on=m,C.addListener=m,C.once=m,C.off=m,C.removeListener=m,C.removeAllListeners=m,C.emit=m,C.prependListener=m,C.prependOnceListener=m,C.listeners=function(t){return[]},C.binding=function(t){throw new Error("process.binding is not supported")},C.cwd=function(){return"/"},C.chdir=function(t){throw new Error("process.chdir is not supported")},C.umask=function(){return 0}}])}),define(Re[118],Me([1,0,9,6]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=void 0;function C(E){const v=E;return v?typeof v.read=="function":!1}e.$Xd=C;function L(E){const v=E;return v?[v.on,v.pause,v.resume,v.destroy].every(r=>typeof r=="function"):!1}e.$Yd=L;function A(E){const v=E;return v?L(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$Zd=A;function l(E,v){return new k(E,v)}e.$1d=l;class k{constructor(v,r){this.e=v,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(r=>r(v))}h(v){this.c.error.length===0?(0,y.$Z)(v):this.c.error.slice(0).forEach(r=>r(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,r){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(v,r){if(this.a.destroyed)return;let s;switch(v){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const n=s.indexOf(r);n>=0&&s.splice(n,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(E,v){const r=[];let s;for(;(s=E.read())!==null;)r.push(s);return v(r)}e.$2d=f;function R(E,v,r){const s=[];let n;for(;(n=E.read())!==null&&s.length<r;)s.push(n);return n===null&&s.length>0?v(s):{read:()=>{if(s.length>0)return s.shift();if(typeof n<"u"){const o=n;return n=void 0,o}return E.read()}}}e.$3d=R;function D(E,v){return new Promise((r,s)=>{const n=[];c(E,{onData:o=>{v&&n.push(o)},onError:o=>{v?s(o):r(void 0)},onEnd:()=>{r(v?v(n):void 0)}})})}e.$4d=D;function c(E,v,r){E.on("error",s=>{r?.isCancellationRequested||v.onError(s)}),E.on("end",()=>{r?.isCancellationRequested||v.onEnd()}),E.on("data",s=>{r?.isCancellationRequested||v.onData(s)})}e.$5d=c;function p(E,v){return new Promise((r,s)=>{const n=new M.$Qc,o=[],w=S=>{if(o.push(S),o.length>v)return n.dispose(),E.pause(),r({stream:E,buffer:o,ended:!1})},d=S=>(n.dispose(),s(S)),I=()=>(n.dispose(),r({stream:E,buffer:o,ended:!0}));n.add((0,M.$Pc)(()=>E.removeListener("error",d))),E.on("error",d),n.add((0,M.$Pc)(()=>E.removeListener("end",I))),E.on("end",I),n.add((0,M.$Pc)(()=>E.removeListener("data",w))),E.on("data",w)})}e.$6d=p;function $(E,v){const r=l(v);return r.end(E),r}e.$7d=$;function m(){const E=l(()=>{throw new Error("not supported")});return E.end(),E}e.$8d=m;function t(E){let v=!1;return{read:()=>v?null:(v=!0,E)}}e.$9d=t;function i(E,v,r){const s=l(r);return c(E,{onData:n=>s.write(v.data(n)),onError:n=>s.error(v.error?v.error(n):n),onEnd:()=>s.end()}),s}e.$0d=i;function a(E,v,r){let s=!1;return{read:()=>{const n=v.read();return s?n:(s=!0,n!==null?r([E,n]):E)}}}e.$$d=a;function b(E,v,r){let s=!1;const n=l(r);return c(v,{onData:o=>s?n.write(o):(s=!0,n.write(r([E,o]))),onError:o=>n.error(o),onEnd:()=>{s||(s=!0,n.write(E)),n.end()}}),n}e.$_d=b}),define(Re[26],Me([1,0,40,118]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=void 0;const C=typeof Buffer<"u",L=new y.$U(()=>new Uint8Array(256));let A,l;class k{static alloc(h){return C?new k(Buffer.allocUnsafe(h)):new k(new Uint8Array(h))}static wrap(h){return C&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new k(h)}static fromString(h,P){return!(P?.dontUseNodeBuffer||!1)&&C?new k(Buffer.from(h)):(A||(A=new TextEncoder),new k(A.encode(h)))}static fromByteArray(h){const P=k.alloc(h.length);for(let W=0,K=h.length;W<K;W++)P.buffer[W]=h[W];return P}static concat(h,P){if(typeof P>"u"){P=0;for(let j=0,B=h.length;j<B;j++)P+=h[j].byteLength}const W=k.alloc(P);let K=0;for(let j=0,B=h.length;j<B;j++){const O=h[j];W.set(O,K),K+=O.byteLength}return W}constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}clone(){const h=k.alloc(this.byteLength);return h.set(this),h}toString(){return C?this.buffer.toString():(l||(l=new TextDecoder),l.decode(this.buffer))}slice(h,P){return new k(this.buffer.subarray(h,P))}set(h,P){if(h instanceof k)this.buffer.set(h.buffer,P);else if(h instanceof Uint8Array)this.buffer.set(h,P);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),P);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return c(this.buffer,h)}writeUInt32BE(h,P){p(this.buffer,h,P)}readUInt32LE(h){return $(this.buffer,h)}writeUInt32LE(h,P){m(this.buffer,h,P)}readUInt8(h){return t(this.buffer,h)}writeUInt8(h,P){i(this.buffer,h,P)}indexOf(h,P=0){return f(this.buffer,h instanceof k?h.buffer:h,P)}}e.$ae=k;function f(g,h,P=0){const W=h.byteLength,K=g.byteLength;if(W===0)return 0;if(W===1)return g.indexOf(h[0]);if(W>K-P)return-1;const j=L.value;j.fill(h.length);for(let te=0;te<h.length;te++)j[h[te]]=h.length-te-1;let B=P+h.length-1,O=B,N=-1;for(;B<K;)if(g[B]===h[O]){if(O===0){N=B;break}B--,O--}else B+=Math.max(h.length-O,j[g[B]]),O=h.length-1;return N}e.$be=f;function R(g,h){return g[h+0]<<0>>>0|g[h+1]<<8>>>0}e.$ce=R;function D(g,h,P){g[P+0]=h&255,h=h>>>8,g[P+1]=h&255}e.$de=D;function c(g,h){return g[h]*2**24+g[h+1]*2**16+g[h+2]*2**8+g[h+3]}e.$ee=c;function p(g,h,P){g[P+3]=h,h=h>>>8,g[P+2]=h,h=h>>>8,g[P+1]=h,h=h>>>8,g[P]=h}e.$fe=p;function $(g,h){return g[h+0]<<0>>>0|g[h+1]<<8>>>0|g[h+2]<<16>>>0|g[h+3]<<24>>>0}e.$ge=$;function m(g,h,P){g[P+0]=h&255,h=h>>>8,g[P+1]=h&255,h=h>>>8,g[P+2]=h&255,h=h>>>8,g[P+3]=h&255}e.$he=m;function t(g,h){return g[h]}e.$ie=t;function i(g,h,P){g[P]=h}e.$je=i;function a(g){return M.$2d(g,h=>k.concat(h))}e.$ke=a;function b(g){return M.$9d(g)}e.$le=b;function E(g){return M.$4d(g,h=>k.concat(h))}e.$me=E;async function v(g){return g.ended?k.concat(g.buffer):k.concat([...g.buffer,await E(g.stream)])}e.$ne=v;function r(g){return M.$7d(g,h=>k.concat(h))}e.$oe=r;function s(g){return M.$0d(g,{data:h=>typeof h=="string"?k.fromString(h):k.wrap(h)},h=>k.concat(h))}e.$pe=s;function n(g){return M.$1d(h=>k.concat(h),g)}e.$qe=n;function o(g,h){return M.$$d(g,h,P=>k.concat(P))}e.$re=o;function w(g,h){return M.$_d(g,h,P=>k.concat(P))}e.$se=w;function d(g){let h=0,P=0,W=0;const K=new Uint8Array(Math.floor(g.length/4*3)),j=O=>{switch(P){case 3:K[W++]=h|O,P=0;break;case 2:K[W++]=h|O>>>2,h=O<<6,P=3;break;case 1:K[W++]=h|O>>>4,h=O<<4,P=2;break;default:h=O<<2,P=1}};for(let O=0;O<g.length;O++){const N=g.charCodeAt(O);if(N>=65&&N<=90)j(N-65);else if(N>=97&&N<=122)j(N-97+26);else if(N>=48&&N<=57)j(N-48+52);else if(N===43||N===45)j(62);else if(N===47||N===95)j(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${g[O]}`)}}const B=W;for(;P>0;)j(0);return k.wrap(K).slice(0,B)}e.$te=d;const I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:g},h=!0,P=!1){const W=P?S:I;let K="";const j=g.byteLength%3;let B=0;for(;B<g.byteLength-j;B+=3){const O=g[B+0],N=g[B+1],te=g[B+2];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[(N<<2|te>>>6)&63],K+=W[te&63]}if(j===1){const O=g[B+0];K+=W[O>>>2],K+=W[O<<4&63],h&&(K+="==")}else if(j===2){const O=g[B+0],N=g[B+1];K+=W[O>>>2],K+=W[(O<<4|N>>>4)&63],K+=W[N<<2&63],h&&(K+="=")}return K}e.$ue=u}),define(Re[119],Me([1,0,28,15]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.FuzzyScore=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.or=void 0;function C(...re){return function(oe,de){for(let Ie=0,F=re.length;Ie<F;Ie++){const q=re[Ie](oe,de);if(q)return q}return null}}e.or=C,e.$Aj=L.bind(void 0,!1),e.$Bj=L.bind(void 0,!0);function L(re,oe,de){if(!de||de.length<oe.length)return null;let Ie;return re?Ie=M.$2e(de,oe):Ie=de.indexOf(oe)===0,Ie?oe.length>0?[{start:0,end:oe.length}]:[]:null}function A(re,oe){const de=oe.toLowerCase().indexOf(re.toLowerCase());return de===-1?null:[{start:de,end:de+re.length}]}e.$Cj=A;function l(re,oe){return k(re.toLowerCase(),oe.toLowerCase(),0,0)}e.$Dj=l;function k(re,oe,de,Ie){if(de===re.length)return[];if(Ie===oe.length)return null;if(re[de]===oe[Ie]){let F=null;return(F=k(re,oe,de+1,Ie+1))?i({start:Ie,end:Ie+1},F):null}return k(re,oe,de,Ie+1)}function f(re){return 97<=re&&re<=122}function R(re){return 65<=re&&re<=90}e.$Ej=R;function D(re){return 48<=re&&re<=57}function c(re){return re===32||re===9||re===10||re===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>p.add(re.charCodeAt(0)));function $(re){return c(re)||p.has(re)}function m(re,oe){return re===oe||$(re)&&$(oe)}function t(re){return f(re)||R(re)||D(re)}function i(re,oe){return oe.length===0?oe=[re]:re.end===oe[0].start?oe[0].start=re.start:oe.unshift(re),oe}function a(re,oe){for(let de=oe;de<re.length;de++){const Ie=re.charCodeAt(de);if(R(Ie)||D(Ie)||de>0&&!t(re.charCodeAt(de-1)))return de}return re.length}function b(re,oe,de,Ie){if(de===re.length)return[];if(Ie===oe.length)return null;if(re[de]!==oe[Ie].toLowerCase())return null;{let F=null,q=Ie+1;for(F=b(re,oe,de+1,Ie+1);!F&&(q=a(oe,q))<oe.length;)F=b(re,oe,de+1,q),q++;return F===null?null:i({start:Ie,end:Ie+1},F)}}function E(re){let oe=0,de=0,Ie=0,F=0,q=0;for(let ae=0;ae<re.length;ae++)q=re.charCodeAt(ae),R(q)&&oe++,f(q)&&de++,t(q)&&Ie++,D(q)&&F++;const J=oe/re.length,Q=de/re.length,H=Ie/re.length,x=F/re.length;return{upperPercent:J,lowerPercent:Q,alphaPercent:H,numericPercent:x}}function v(re){const{upperPercent:oe,lowerPercent:de}=re;return de===0&&oe>.6}function r(re){const{upperPercent:oe,lowerPercent:de,alphaPercent:Ie,numericPercent:F}=re;return de>.2&&oe<.8&&Ie>.6&&F<.2}function s(re){let oe=0,de=0,Ie=0,F=0;for(let q=0;q<re.length;q++)Ie=re.charCodeAt(q),R(Ie)&&oe++,f(Ie)&&de++,c(Ie)&&F++;return(oe===0||de===0)&&F===0?re.length<=30:oe<=5}function n(re,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!s(re)||oe.length>60)return null;const de=E(oe);if(!r(de)){if(!v(de))return null;oe=oe.toLowerCase()}let Ie=null,F=0;for(re=re.toLowerCase();F<oe.length&&(Ie=b(re,oe,0,F))===null;)F=a(oe,F+1);return Ie}e.$Fj=n;function o(re,oe,de=!1){if(!oe||oe.length===0)return null;let Ie=null,F=0;for(re=re.toLowerCase(),oe=oe.toLowerCase();F<oe.length&&(Ie=w(re,oe,0,F,de))===null;)F=d(oe,F+1);return Ie}e.$Gj=o;function w(re,oe,de,Ie,F){if(de===re.length)return[];if(Ie===oe.length)return null;if(m(re.charCodeAt(de),oe.charCodeAt(Ie))){let q=null,J=Ie+1;if(q=w(re,oe,de+1,Ie+1,F),!F)for(;!q&&(J=d(oe,J))<oe.length;)q=w(re,oe,de+1,J,F),J++;return q?re.charCodeAt(de)!==oe.charCodeAt(Ie)?q:i({start:Ie,end:Ie+1},q):null}else return null}function d(re,oe){for(let de=oe;de<re.length;de++)if($(re.charCodeAt(de))||de>0&&$(re.charCodeAt(de-1)))return de;return re.length}const I=C(e.$Bj,n,A),S=C(e.$Bj,n,l),u=new y.$Cc(1e4);function g(re,oe,de=!1){if(typeof re!="string"||typeof oe!="string")return null;let Ie=u.get(re);Ie||(Ie=new RegExp(M.$Ke(re),"i"),u.set(re,Ie));const F=Ie.exec(oe);return F?[{start:F.index,end:F.index+F[0].length}]:de?S(re,oe):I(re,oe)}e.$Hj=g;function h(re,oe){const de=ue(re,re.toLowerCase(),0,oe,oe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return de?W(de):null}e.$Ij=h;function P(re,oe,de,Ie,F,q){const J=Math.min(13,re.length);for(;de<J;de++){const Q=ue(re,oe,de,Ie,F,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,q]}e.$Jj=P;function W(re){if(typeof re>"u")return[];const oe=[],de=re[1];for(let Ie=re.length-1;Ie>1;Ie--){const F=re[Ie]+de,q=oe[oe.length-1];q&&q.end===F?q.end=F+1:oe.push({start:F,end:F+1})}return oe}e.$Kj=W;const K=128;function j(){const re=[],oe=[];for(let de=0;de<=K;de++)oe[de]=0;for(let de=0;de<=K;de++)re.push(oe.slice(0));return re}function B(re){const oe=[];for(let de=0;de<=re;de++)oe[de]=0;return oe}const O=B(2*K),N=B(2*K),te=j(),Y=j(),Ee=j(),Se=!1;function Pe(re,oe,de,Ie,F){function q(Q,H,x=" "){for(;Q.length<H;)Q=x+Q;return Q}let J=` |   |${Ie.split("").map(Q=>q(Q,3)).join("|")}
`;for(let Q=0;Q<=de;Q++)Q===0?J+=" |":J+=`${oe[Q-1]}|`,J+=re[Q].slice(0,F+1).map(H=>q(H.toString(),3)).join("|")+`
`;return J}function ge(re,oe,de,Ie){re=re.substr(oe),de=de.substr(Ie),console.log(Pe(Y,re,re.length,de,de.length)),console.log(Pe(Ee,re,re.length,de,de.length)),console.log(Pe(te,re,re.length,de,de.length))}function me(re,oe){if(oe<0||oe>=re.length)return!1;const de=re.codePointAt(oe);switch(de){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$hf(de)}}function ce(re,oe){if(oe<0||oe>=re.length)return!1;switch(re.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function se(re,oe,de){return oe[re]!==de[re]}function $e(re,oe,de,Ie,F,q,J=!1){for(;oe<de&&F<q;)re[oe]===Ie[F]&&(J&&(O[oe]=F),oe+=1),F+=1;return oe===de}e.$Lj=$e;var _;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(_||(_={}));var z;(function(re){re.Default=[-100,0];function oe(de){return!de||de.length===2&&de[0]===-100&&de[1]===0}re.isDefault=oe})(z||(e.FuzzyScore=z={}));class V{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(oe,de){this.firstMatchCanBeWeak=oe,this.boostFullMatch=de}}e.$Mj=V;function ue(re,oe,de,Ie,F,q,J=V.default){const Q=re.length>K?K:re.length,H=Ie.length>K?K:Ie.length;if(de>=Q||q>=H||Q-de>H-q||!$e(oe,de,Q,F,q,H,!0))return;ye(Q,H,de,q,oe,F);let x=1,ae=1,Le=de,je=q;const Qe=[!1];for(x=1,Le=de;Le<Q;x++,Le++){const it=O[Le],tt=N[Le],ze=Le+1<Q?N[Le+1]:H;for(ae=it-q+1,je=it;je<ze;ae++,je++){let st=Number.MIN_SAFE_INTEGER,X=!1;je<=tt&&(st=be(re,oe,Le,de,Ie,F,je,H,q,te[x-1][ae-1]===0,Qe));let Z=0;st!==Number.MAX_SAFE_INTEGER&&(X=!0,Z=st+Y[x-1][ae-1]);const ve=je>it,Ue=ve?Y[x][ae-1]+(te[x][ae-1]>0?-5:0):0,Oe=je>it+1&&te[x][ae-1]>0,Ze=Oe?Y[x][ae-2]+(te[x][ae-2]>0?-5:0):0;if(Oe&&(!ve||Ze>=Ue)&&(!X||Ze>=Z))Y[x][ae]=Ze,Ee[x][ae]=3,te[x][ae]=0;else if(ve&&(!X||Ue>=Z))Y[x][ae]=Ue,Ee[x][ae]=2,te[x][ae]=0;else if(X)Y[x][ae]=Z,Ee[x][ae]=1,te[x][ae]=te[x-1][ae-1]+1;else throw new Error("not possible")}}if(Se&&ge(re,de,Ie,q),!Qe[0]&&!J.firstMatchCanBeWeak)return;x--,ae--;const Ge=[Y[x][ae],q];let xe=0,Xe=0;for(;x>=1;){let it=ae;do{const tt=Ee[x][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);xe>1&&oe[de+x-1]===F[q+ae-1]&&!se(it+q-1,Ie,F)&&xe+1>te[x][it]&&(it=ae),it===ae?xe++:xe=1,Xe||(Xe=it),x--,ae=it-1,Ge.push(ae)}H===Q&&J.boostFullMatch&&(Ge[0]+=2);const _e=Xe-Q;return Ge[0]-=_e,Ge}e.$Nj=ue;function ye(re,oe,de,Ie,F,q){let J=re-1,Q=oe-1;for(;J>=de&&Q>=Ie;)F[J]===q[Q]&&(N[J]=Q,J--),Q--}function be(re,oe,de,Ie,F,q,J,Q,H,x,ae){if(oe[de]!==q[J])return Number.MIN_SAFE_INTEGER;let Le=1,je=!1;return J===de-Ie?Le=re[de]===F[J]?7:5:se(J,F,q)&&(J===0||!se(J-1,F,q))?(Le=re[de]===F[J]?7:5,je=!0):me(q,J)&&(J===0||!me(q,J-1))?Le=5:(me(q,J-1)||ce(q,J-1))&&(Le=5,je=!0),Le>1&&de===Ie&&(ae[0]=!0),je||(je=se(J,F,q)||me(q,J-1)||ce(q,J-1)),de===Ie?J>H&&(Le-=je?3:5):x?Le+=je?2:0:Le+=je?0:1,J+1===Q&&(Le-=je?3:5),Le}function pe(re,oe,de,Ie,F,q,J){return ne(re,oe,de,Ie,F,q,!0,J)}e.$Oj=pe;function De(re,oe,de,Ie,F,q,J){return ne(re,oe,de,Ie,F,q,!1,J)}e.$Pj=De;function ne(re,oe,de,Ie,F,q,J,Q){let H=ue(re,oe,de,Ie,F,q,Q);if(H&&!J)return H;if(re.length>=3){const x=Math.min(7,re.length-1);for(let ae=de+1;ae<x;ae++){const Le=le(re,ae);if(Le){const je=ue(Le,Le.toLowerCase(),de,Ie,F,q,Q);je&&(je[0]-=3,(!H||je[0]>H[0])&&(H=je))}}}return H}function le(re,oe){if(oe+1>=re.length)return;const de=re[oe],Ie=re[oe+1];if(de!==Ie)return re.slice(0,oe)+Ie+de+re.slice(oe+2)}}),define(Re[29],Me([1,0,15]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(M||(M={})),function(C){const L="error",A="warning",l="warn",k="info",f="ignore";function R(c){return c?y.$1e(L,c)?C.Error:y.$1e(A,c)||y.$1e(l,c)?C.Warning:y.$1e(k,c)?C.Info:C.Ignore:C.Ignore}C.fromValue=R;function D(c){switch(c){case C.Error:return L;case C.Warning:return A;case C.Info:return k;default:return f}}C.toString=D}(M||(M={})),e.default=M}),define(Re[120],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Jd=Symbol("MicrotaskDelay")}),define(Re[49],Me([1,0,18,15]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=void 0;class C{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const $=p.charCodeAt(0),m=this.b.charCodeAt(this.c);return $-m}value(){return this.b[this.c]}}e.$Ph=C;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,M.$Ue)(p,this.b,0,p.length,this.c,this.d):(0,M.$We)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Qh=L;class A{constructor(p=!0,$=!0){this.f=p,this.g=$}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let $=p.length-1;$>=0;$--,this.c--){const m=this.b.charCodeAt($);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,M.$Ue)(p,this.b,0,p.length,this.d,this.e):(0,M.$We)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Rh=A;var l;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(l||(l={}));class k{constructor(p,$){this.f=p,this.g=$,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,M.$Ve)(p,this.c.scheme);if(this.d[this.e]===2)return(0,M.$Ve)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,M.$Te)(p,this.c.query);if(this.d[this.e]===5)return(0,M.$Te)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Sh=k;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(R||(R={}));class D{static forUris(p=()=>!1,$=()=>!1){return new D(new k(p,$))}static forPaths(p=!1){return new D(new A(void 0,!p))}static forStrings(){return new D(new C)}static forConfigKeys(){return new D(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,$){if($){const m=$.slice(0);(0,y.$Wb)(m);for(const t of m)this.set(t,p)}else{const m=p.slice(0);(0,y.$Wb)(m);for(const t of m)this.set(t[0],t[1])}}set(p,$){const m=this.b.reset(p);let t;this.c||(this.c=new f,this.c.segment=m.value());const i=[];for(t=this.c;;){const b=m.cmp(t.segment);if(b>0)t.left||(t.left=new f,t.left.segment=m.value()),i.push([-1,t]),t=t.left;else if(b<0)t.right||(t.right=new f,t.right.segment=m.value()),i.push([1,t]),t=t.right;else if(m.hasNext())m.next(),t.mid||(t.mid=new f,t.mid.segment=m.value()),i.push([0,t]),t=t.mid;else break}const a=t.value;t.value=$,t.key=p;for(let b=i.length-1;b>=0;b--){const E=i[b][1];E.updateHeight();const v=E.balanceFactor();if(v<-1||v>1){const r=i[b][0],s=i[b+1][0];if(r===1&&s===1)i[b][1]=E.rotateLeft();else if(r===-1&&s===-1)i[b][1]=E.rotateRight();else if(r===1&&s===-1)E.right=i[b+1][1]=i[b+1][1].rotateRight(),i[b][1]=E.rotateLeft();else if(r===-1&&s===1)E.left=i[b+1][1]=i[b+1][1].rotateLeft(),i[b][1]=E.rotateRight();else throw new Error;if(b>0)switch(i[b-1][0]){case-1:i[b-1][1].left=i[b][1];break;case 1:i[b-1][1].right=i[b][1];break;case 0:i[b-1][1].mid=i[b][1];break}else this.c=i[0][1]}}return a}get(p){return this.d(p)?.value}d(p){const $=this.b.reset(p);let m=this.c;for(;m;){const t=$.cmp(m.segment);if(t>0)m=m.left;else if(t<0)m=m.right;else if($.hasNext())$.next(),m=m.mid;else break}return m}has(p){const $=this.d(p);return!($?.value===void 0&&$?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,$){const m=this.b.reset(p),t=[];let i=this.c;for(;i;){const a=m.cmp(i.segment);if(a>0)t.push([-1,i]),i=i.left;else if(a<0)t.push([1,i]),i=i.right;else if(m.hasNext())m.next(),t.push([0,i]),i=i.mid;else break}if(i){if($?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const a=this.f(i.right);if(a.key){const{key:b,value:E,segment:v}=a;this.e(a.key,!1),i.key=b,i.value=E,i.segment=v}}else{const a=i.left??i.right;if(t.length>0){const[b,E]=t[t.length-1];switch(b){case-1:E.left=a;break;case 0:E.mid=a;break;case 1:E.right=a;break}}else this.c=a}for(let a=t.length-1;a>=0;a--){const b=t[a][1];b.updateHeight();const E=b.balanceFactor();if(E>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),t[a][1]=b.rotateLeft()):E<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),t[a][1]=b.rotateRight()),a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const $=this.b.reset(p);let m=this.c,t;for(;m;){const i=$.cmp(m.segment);if(i>0)m=m.left;else if(i<0)m=m.right;else if($.hasNext())$.next(),t=m.value||t,m=m.mid;else break}return m&&m.value||t}findSuperstr(p){return this.g(p,!1)}g(p,$){const m=this.b.reset(p);let t=this.c;for(;t;){const i=m.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(m.hasNext())m.next(),t=t.mid;else return t.mid?this.h(t.mid):$?t.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[$,m]of this)p(m,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const $=[];return this.j(p,$),$[Symbol.iterator]()}j(p,$){p&&(p.left&&this.j(p.left,$),p.value&&$.push([p.key,p.value]),p.mid&&this.j(p.mid,$),p.right&&this.j(p.right,$))}_isBalanced(){const p=$=>{if(!$)return!0;const m=$.balanceFactor();return m<-1||m>1?!1:p($.left)&&p($.right)};return p(this.c)}}e.$Th=D}),define(Re[41],Me([1,0,89]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Tj=e.ThemeColor=void 0;var M;(function(A){function l(k){return k&&typeof k=="object"&&typeof k.id=="string"}A.isThemeColor=l})(M||(e.ThemeColor=M={}));function C(A){return{id:A}}e.$Tj=C;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const l=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function k(a){const b=l.exec(a.id);if(!b)return k(y.$Sj.error);const[,E,v]=b,r=["codicon","codicon-"+E];return v&&r.push("codicon-modifier-"+v.substring(1)),r}A.asClassNameArray=k;function f(a){return k(a).join(" ")}A.asClassName=f;function R(a){return"."+k(a).join(".")}A.asCSSSelector=R;function D(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||M.isThemeColor(a.color))}A.isThemeIcon=D;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function p(a){const b=c.exec(a);if(!b)return;const[,E]=b;return{id:E}}A.fromString=p;function $(a){return{id:a}}A.fromId=$;function m(a,b){let E=a.id;const v=E.lastIndexOf("~");return v!==-1&&(E=E.substring(0,v)),b&&(E=`${E}~${b}`),{id:E}}A.modify=m;function t(a){const b=a.id.lastIndexOf("~");if(b!==-1)return a.id.substring(b+1)}A.getModifier=t;function i(a,b){return a.id===b.id&&a.color?.id===b.color?.id}A.isEqual=i})(L||(e.ThemeIcon=L={}))}),define(Re[121],Me([1,0,119,15,41]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;const L="$(",A=new RegExp(`\\$\\(${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?\\)`,"g"),l=new RegExp(`(\\\\)?${A.source}`,"g");function k(i){return i.replace(l,(a,b)=>b?a:`\\${a}`)}e.$Uj=k;const f=new RegExp(`\\\\${A.source}`,"g");function R(i){return i.replace(f,a=>`\\${a}`)}e.$Vj=R;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(i){return i.indexOf(L)===-1?i:i.replace(D,(a,b,E,v)=>E?a:b||v||"")}e.$Wj=c;function p(i){return i?i.replace(/\$\((.*?)\)/g,(a,b)=>` ${b} `).trim():""}e.$Xj=p;const $=new RegExp(`\\$\\(${C.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(i){$.lastIndex=0;let a="";const b=[];let E=0;for(;;){const v=$.lastIndex,r=$.exec(i),s=i.substring(v,r?.index);if(s.length>0){a+=s;for(let n=0;n<s.length;n++)b.push(E)}if(!r)break;E+=r[0].length}return{text:a,iconOffsets:b}}e.$Yj=m;function t(i,a,b=!1){const{text:E,iconOffsets:v}=a;if(!v||v.length===0)return(0,y.$Hj)(i,E,b);const r=(0,M.$Ie)(E," "),s=E.length-r.length,n=(0,y.$Hj)(i,r,b);if(n)for(const o of n){const w=v[o.start+s]+s;o.start+=w,o.end+=w}return n}e.$Zj=t}),define(Re[36],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(C){return y.test(C)}e.$cg=M,e.$dg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(l){for(let k=0;k<l.length;k++)l[k]=Math.floor(Math.random()*256);return l};const L=new Uint8Array(16),A=[];for(let l=0;l<256;l++)A.push(l.toString(16).padStart(2,"0"));return function(){C(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let k=0,f="";return f+=A[L[k++]],f+=A[L[k++]],f+=A[L[k++]],f+=A[L[k++]],f+="-",f+=A[L[k++]],f+=A[L[k++]],f+="-",f+=A[L[k++]],f+=A[L[k++]],f+="-",f+=A[L[k++]],f+=A[L[k++]],f+="-",f+=A[L[k++]],f+=A[L[k++]],f+=A[L[k++]],f+=A[L[k++]],f+=A[L[k++]],f+=A[L[k++]],f}}()}),define(Re[122],Me([1,0,18,65,36]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=e.$Xs=e.$Ws=e.$Vs=e.$Us=void 0;function L(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$Us=L;function A(D,c,p){const $={id:(0,C.$dg)(),name:D,uri:c,data:p};return{asString:async()=>"",asFile:()=>$,value:void 0}}e.$Vs=A;class l{constructor(){this.a=new Map}get size(){let c=0;for(const p of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const p=[...this.a.keys()];return M.Iterable.some(this,([$,m])=>m.asFile())&&p.push("files"),R(k(c),p)}get(c){return this.a.get(this.b(c))?.[0]}append(c,p){const $=this.a.get(c);$?$.push(p):this.a.set(this.b(c),[p])}replace(c,p){this.a.set(this.b(c),[p])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,p]of this.a)for(const $ of p)yield[c,$]}b(c){return k(c)}}e.$Ws=l;function k(D){return D.toLowerCase()}function f(D,c){return R(k(D),c.map(k))}e.$Xs=f;function R(D,c){if(D==="*/*")return c.length>0;if(c.includes(D))return!0;const p=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[$,m,t]=p;return t==="*"?c.some(i=>i.startsWith(m+"/")):!1}e.$Ys=Object.freeze({create:D=>(0,y.$Lb)(D.map(c=>c.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$Ys.split(D).filter(c=>!c.startsWith("#"))})}),define(Re[123],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0,e.$Zr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[124],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.$lt=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class M{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let k=0,f=l.notIn.length;k<f;k++)switch(l.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(l,k){if(l.getTokenCount()===0)return!0;const f=l.findTokenIndexAtOffset(k-2),R=l.getStandardTokenType(f);return this.isOK(R)}g(l,k){for(let f=l;f<=k;f++){const R=String.fromCharCode(f);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$lt=M;class C{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of l)L(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),L(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),L(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),L(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&L(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$mt=C;function L(A,l,k){A.has(l)?A.get(l).push(k):A.set(l,[k])}}),define(Re[125],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H7=e.$G7=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$G7=y;class M{constructor(L){this.identifier=L}}e.$H7=M}),define(Re[126],Me([10,11]),function(we,e){return we.create("vs/base/common/actions",e)}),define(Re[127],Me([1,0,5,6,126]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=void 0;class L extends M.$Rc{constructor(c,p="",$="",m=!0,t){super(),this.h=this.B(new y.$Md),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=p,this.u=$,this.w=m,this.C=t}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,p){this.C&&await this.C(c)}}e.$si=L;class A extends M.$Rc{constructor(){super(...arguments),this.f=this.B(new y.$Md),this.onWillRun=this.f.event,this.m=this.B(new y.$Md),this.onDidRun=this.m.event}async run(c,p){if(!c.enabled)return;this.f.fire({action:c});let $;try{await this.u(c,p)}catch(m){$=m}this.m.fire({action:c,error:$})}async u(c,p){await c.run(p)}}e.$ti=A;class l{constructor(){this.id=l.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let p=[];for(const $ of c)$.length&&(p.length?p=[...p,new l,...$]:p=$);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$ui=l;class k{get actions(){return this.a}constructor(c,p,$,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=p,this.class=m,this.a=$}async run(){}}e.$vi=k;class f extends L{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,C.localize(0,null),void 0,!1)}}e.$wi=f;function R(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...c)=>D.run(...c),tooltip:D.label}}e.$xi=R}),define(Re[128],Me([10,11]),function(we,e){return we.create("vs/base/common/date",e)}),define(Re[129],Me([1,0,128]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=void 0;const M=60,C=M*60,L=C*24,A=L*7,l=L*30,k=L*365;function f(D,c,p,$){typeof D!="number"&&(D=D.getTime());const m=Math.round((new Date().getTime()-D)/1e3);if(m<-30)return(0,y.localize)(0,null,f(new Date().getTime()+m*1e3,!1));if(!$&&m<30)return(0,y.localize)(1,null);let t;return m<M?(t=m,c?t===1?p?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):p?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?p?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):p?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):m<C?(t=Math.floor(m/M),c?t===1?p?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):p?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?p?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):p?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):m<L?(t=Math.floor(m/C),c?t===1?p?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):p?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?p?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):p?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):m<A?(t=Math.floor(m/L),c?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):m<l?(t=Math.floor(m/A),c?t===1?p?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):p?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?p?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):p?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):m<k?(t=Math.floor(m/l),c?t===1?p?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):p?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?p?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):p?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(m/k),c?t===1?p?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):p?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?p?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):p?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$am=f;function R(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$bm=R}),define(Re[130],Me([10,11]),function(we,e){return we.create("vs/base/common/errorMessage",e)}),define(Re[42],Me([1,0,18,16,130]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=void 0;function L(D,c){return c&&(D.stack||D.stacktrace)?C.localize(0,null,l(D),A(D.stack)||A(D.stacktrace)):l(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function l(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?C.localize(1,null,D.message):D.message||C.localize(2,null)}function k(D=null,c=!1){if(!D)return C.localize(3,null);if(Array.isArray(D)){const p=y.$Gb(D),$=k(p[0],c);return p.length>1?C.localize(4,null,$,p.length):$}if(M.$xf(D))return D;if(D.detail){const p=D.detail;if(p.error)return L(p.error,c);if(p.exception)return L(p.exception,c)}return D.stack?L(D,c):D.message?D.message:C.localize(5,null)}e.$yi=k;function f(D){const c=D;return c instanceof Error&&Array.isArray(c.actions)}e.$zi=f;function R(D,c){let p;return typeof D=="string"?p=new Error(D):p=D,p.actions=c,p}e.$Ai=R}),define(Re[131],Me([1,0,40,19]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.$nq=e.$mq=e.$lq=e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=void 0;const C=new y.$U(()=>{const S=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:S,collatorIsNumeric:S.resolvedOptions().numeric}}),L=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function l(S,u,g=!1){const h=S||"",P=u||"",W=C.value.collator.compare(h,P);return C.value.collatorIsNumeric&&W===0&&h!==P?h<P?-1:1:W}e.$eq=l;function k(S,u){const g=L.value.collator;return S=S||"",u=u||"",E(g,S,u)}e.$fq=k;function f(S,u){const g=L.value.collator;return S=S||"",u=u||"",n(S,u)||E(g,S,u)}e.$gq=f;function R(S,u){const g=L.value.collator;return S=S||"",u=u||"",s(S,u)||E(g,S,u)}e.$hq=R;function D(S,u){return S=S||"",u=u||"",S===u?0:S<u?-1:1}e.$iq=D;function c(S,u){const[g,h]=a(S),[P,W]=a(u);let K=C.value.collator.compare(h,W);if(K===0){if(C.value.collatorIsNumeric&&h!==W)return h<W?-1:1;if(K=C.value.collator.compare(g,P),C.value.collatorIsNumeric&&K===0&&g!==P)return g<P?-1:1}return K}e.$jq=c;function p(S,u){S=S||"",u=u||"";const g=b(S),h=b(u),P=L.value.collator,W=A.value.collator;return E(W,g,h)||E(P,S,u)}e.$kq=p;function $(S,u){S=S||"",u=u||"";const g=b(S),h=b(u),P=L.value.collator,W=A.value.collator;return E(W,g,h)||n(S,u)||E(P,S,u)}e.$lq=$;function m(S,u){S=S||"",u=u||"";const g=b(S),h=b(u),P=L.value.collator,W=A.value.collator;return E(W,g,h)||s(S,u)||E(P,S,u)}e.$mq=m;function t(S,u){S=S||"",u=u||"";const g=b(S).toLowerCase(),h=b(u).toLowerCase();return g!==h?g<h?-1:1:S!==u?S<u?-1:1:0}e.$nq=t;const i=/^(.*?)(\.([^.]*))?$/;function a(S,u=!1){const g=S?i.exec(S):[];let h=[g&&g[1]||"",g&&g[3]||""];return u&&(!h[0]&&h[1]||h[0]&&h[0].charAt(0)===".")&&(h=[h[0]+"."+h[1],""]),h}function b(S){const u=S?i.exec(S):[];return u&&u[1]&&u[1].charAt(0)!=="."&&u[3]||""}function E(S,u,g){const h=S.compare(u,g);return h!==0?h:u.length!==g.length?u.length<g.length?-1:1:0}function v(S){const u=S.charAt(0);return u.toLocaleUpperCase()!==u}function r(S){const u=S.charAt(0);return u.toLocaleLowerCase()!==u}function s(S,u){return v(S)&&r(u)?-1:r(S)&&v(u)?1:0}function n(S,u){return r(S)&&v(u)?-1:v(S)&&r(u)?1:0}function o(S,u,g=!1){return g||(S=S&&S.toLowerCase(),u=u&&u.toLowerCase()),S===u?0:S<u?-1:1}function w(S,u,g=!1){const h=S.split(M.sep),P=u.split(M.sep),W=h.length-1,K=P.length-1;let j,B;for(let O=0;;O++){if(j=W===O,B=K===O,j&&B)return l(h[O],P[O],g);if(j)return-1;if(B)return 1;const N=o(h[O],P[O],g);if(N!==0)return N}}e.$oq=w;function d(S,u,g){const h=S.toLowerCase(),P=u.toLowerCase(),W=I(S,u,g);if(W)return W;const K=h.endsWith(g),j=P.endsWith(g);if(K!==j)return K?-1:1;const B=l(h,P);return B!==0?B:h.localeCompare(P)}e.$pq=d;function I(S,u,g){const h=S.toLowerCase(),P=u.toLowerCase(),W=h.startsWith(g),K=P.startsWith(g);if(W!==K)return W?-1:1;if(W&&K){if(h.length<P.length)return-1;if(h.length>P.length)return 1}return 0}e.$qq=I}),define(Re[43],Me([1,0,19,22,15,16]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=void 0;function A(d){return d===47||d===92}e.$Pf=A;function l(d){return d.replace(/[\\/]/g,y.$fc.sep)}e.$Qf=l;function k(d){return d.indexOf("/")===-1&&(d=l(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$Rf=k;function f(d,I=y.$fc.sep){if(!d)return"";const S=d.length,u=d.charCodeAt(0);if(A(u)){if(A(d.charCodeAt(1))&&!A(d.charCodeAt(2))){let h=3;const P=h;for(;h<S&&!A(d.charCodeAt(h));h++);if(P!==h&&!A(d.charCodeAt(h+1))){for(h+=1;h<S;h++)if(A(d.charCodeAt(h)))return d.slice(0,h+1).replace(/[\\/]/g,I)}}return I}else if(i(u)&&d.charCodeAt(1)===58)return A(d.charCodeAt(2))?d.slice(0,2)+I:d.slice(0,2);let g=d.indexOf("://");if(g!==-1){for(g+=3;g<S;g++)if(A(d.charCodeAt(g)))return d.slice(0,g+1)}return""}e.$Sf=f;function R(d){if(!M.$j||!d||d.length<5)return!1;let I=d.charCodeAt(0);if(I!==92||(I=d.charCodeAt(1),I!==92))return!1;let S=2;const u=S;for(;S<d.length&&(I=d.charCodeAt(S),I!==92);S++);return!(u===S||(I=d.charCodeAt(S+1),isNaN(I)||I===92))}e.$Tf=R;const D=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(d,I=M.$j){const S=I?D:c;return!(!d||d.length===0||/^\s+$/.test(d)||(S.lastIndex=0,S.test(d))||I&&p.test(d)||d==="."||d===".."||I&&d[d.length-1]==="."||I&&d.length!==d.trim().length||d.length>255)}e.$Uf=$;function m(d,I,S){const u=d===I;return!S||u?u:!d||!I?!1:(0,C.$1e)(d,I)}e.$Vf=m;function t(d,I,S,u=y.sep){if(d===I)return!0;if(!d||!I||I.length>d.length)return!1;if(S){if(!(0,C.$2e)(d,I))return!1;if(I.length===d.length)return!0;let h=I.length;return I.charAt(I.length-1)===u&&h--,d.charAt(h)===u}return I.charAt(I.length-1)!==u&&(I+=u),d.indexOf(I)===0}e.$Wf=t;function i(d){return d>=65&&d<=90||d>=97&&d<=122}e.$Xf=i;function a(d,I){return M.$j&&d.endsWith(":")&&(d+=y.sep),(0,y.$hc)(d)||(d=(0,y.$ic)(I,d)),d=(0,y.$gc)(d),M.$j?(d=(0,C.$Je)(d,y.sep),d.endsWith(":")&&(d+=y.sep)):(d=(0,C.$Je)(d,y.sep),d||(d=y.sep)),d}e.$Yf=a;function b(d){const I=(0,y.$gc)(d);return M.$j?d.length>3?!1:E(I)&&(d.length===2||I.charCodeAt(2)===92):I===y.$fc.sep}e.$Zf=b;function E(d,I=M.$j){return I?i(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$1f=E;function v(d,I=M.$j){return E(d,I)?d[0]:void 0}e.$2f=v;function r(d,I,S){return I.length>d.length?-1:d===I?0:(S&&(d=d.toLowerCase(),I=I.toLowerCase()),d.indexOf(I))}e.$3f=r;function s(d){const I=d.split(":");let S,u,g;for(const h of I){const P=Number(h);(0,L.$Bf)(P)?u===void 0?u=P:g===void 0&&(g=P):S=S?[S,h].join(":"):h}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:u!==void 0?u:void 0,column:g!==void 0?g:u!==void 0?1:void 0}}e.$4f=s;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function w(d,I,S=8){let u="";for(let h=0;h<S;h++){let P;h===0&&M.$j&&!I&&(S===3||S===4)?P=o:P=n,u+=P.charAt(Math.floor(Math.random()*P.length))}let g;return I?g=`${I}-${u}`:g=u,d?(0,y.$ic)(d,g):g}e.$5f=w}),define(Re[66],Me([1,0,19]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0,e.$Mr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},C={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const D=(0,y.$nc)(R),c=M[D.toLowerCase()];return c!==void 0?c:A(R)}e.$Nr=L;function A(R){const D=(0,y.$nc)(R);return C[D.toLowerCase()]}e.$Or=A;function l(R){for(const D in C)if(C[D]===R)return D}e.$Pr=l;const k=/^(.+)\/(.+?)(;.+)?$/;function f(R,D){const c=k.exec(R);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:D?void 0:R}e.$Qr=f}),define(Re[67],Me([1,0,26,2]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.$jh=e.$ih=void 0;function C(k){return JSON.stringify(k,A)}e.$ih=C;function L(k){let f=JSON.parse(k);return f=l(f),f}e.$jh=L;function A(k,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function l(k,f=0){if(!k||f>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return M.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof y.$ae||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let R=0;R<k.length;++R)k[R]=l(k[R],f+1);else for(const R in k)Object.hasOwnProperty.call(k,R)&&(k[R]=l(k[R],f+1))}return k}e.$kh=l}),define(Re[13],Me([1,0,9,22,2]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.Schemas=void 0;var L;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$6f="vscode-tkn",e.$7f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${L.vscodeRemoteResource}`}set(R,D,c){this.a[R]=D,this.b[R]=c}setConnectionToken(R,D){this.c[R]=D}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return y.$Z(t),R}const D=R.authority;let c=this.a[D];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const p=this.b[D],$=this.c[D];let m=`path=${encodeURIComponent(R.path)}`;return typeof $=="string"&&(m+=`&${e.$7f}=${encodeURIComponent($)}`),C.URI.from({scheme:M.$p?this.d:L.vscodeRemoteResource,authority:`${c}:${p}`,path:this.f,query:m})}}e.$8f=new A,e.$9f="vs/../../extensions",e.$0f="vs/../../node_modules",e.$$f="vs/../../node_modules.asar",e.$_f="vs/../../node_modules.asar.unpacked",e.$ag="vscode-app";class l{static{this.a=e.$ag}asBrowserUri(R){const D=this.b(R,we);return this.uriToBrowserUri(D)}uriToBrowserUri(R){return R.scheme===L.vscodeRemote?e.$8f.rewrite(R):R.scheme===L.file&&(M.$n||M.$q&&M.$h.origin===`${L.vscodeFileResource}://${l.a}`)?R.with({scheme:L.vscodeFileResource,authority:R.authority||l.a,query:null,fragment:null}):R}asFileUri(R){const D=this.b(R,we);return this.uriToFileUri(D)}uriToFileUri(R){return R.scheme===L.vscodeFileResource?R.with({scheme:L.file,authority:R.authority!==l.a?R.authority:null,query:null,fragment:null}):R}b(R,D){return C.URI.isUri(R)?R:C.URI.parse(D.toUrl(R))}}e.$bg=new l;var k;(function(f){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(R.get("3"));const D="vscode-coi";function c($){let m;typeof $=="string"?m=new URL($).searchParams:$ instanceof URL?m=$.searchParams:C.URI.isUri($)&&(m=new URL($.toString(!0)).searchParams);const t=m?.get(D);if(t)return R.get(t)}f.getHeadersFromQuery=c;function p($,m,t){if(!globalThis.crossOriginIsolated)return;const i=m&&t?"3":t?"2":"1";$ instanceof URLSearchParams?$.set(D,i):$[D]=i}f.addSearchParam=p})(k||(e.COI=k={}))}),define(Re[23],Me([1,0,43,13,19,22,15,2]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eg=e.DataUri=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=void 0;function k(p){return(0,l.$vc)(p,!0)}e.$ig=k;class f{constructor($){this.a=$}compare($,m,t=!1){return $===m?0:(0,A.$Te)(this.getComparisonKey($,t),this.getComparisonKey(m,t))}isEqual($,m,t=!1){return $===m?!0:!$||!m?!1:this.getComparisonKey($,t)===this.getComparisonKey(m,t)}getComparisonKey($,m=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,m,t=!1){if($.scheme===m.scheme){if($.scheme===M.Schemas.file)return y.$Wf(k($),k(m),this.a($))&&$.query===m.query&&(t||$.fragment===m.fragment);if((0,e.$zg)($.authority,m.authority))return y.$Wf($.path,m.path,this.a($),"/")&&$.query===m.query&&(t||$.fragment===m.fragment)}return!1}joinPath($,...m){return l.URI.joinPath($,...m)}basenameOrAuthority($){return(0,e.$rg)($)||$.authority}basename($){return C.$fc.basename($.path)}extname($){return C.$fc.extname($.path)}dirname($){if($.path.length===0)return $;let m;return $.scheme===M.Schemas.file?m=l.URI.file(C.$lc(k($))).path:(m=C.$fc.dirname($.path),$.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),m="/")),$.with({path:m})}normalizePath($){if(!$.path.length)return $;let m;return $.scheme===M.Schemas.file?m=l.URI.file(C.$gc(k($))).path:m=C.$fc.normalize($.path),$.with({path:m})}relativePath($,m){if($.scheme!==m.scheme||!(0,e.$zg)($.authority,m.authority))return;if($.scheme===M.Schemas.file){const a=C.$kc(k($),k(m));return L.$j?y.$Qf(a):a}let t=$.path||"/";const i=m.path||"/";if(this.a($)){let a=0;for(const b=Math.min(t.length,i.length);a<b&&!(t.charCodeAt(a)!==i.charCodeAt(a)&&t.charAt(a).toLowerCase()!==i.charAt(a).toLowerCase());a++);t=i.substr(0,a)+t.substr(a)}return C.$fc.relative(t,i)}resolvePath($,m){if($.scheme===M.Schemas.file){const t=l.URI.file(C.$jc(k($),m));return $.with({authority:t.authority,path:t.path})}return m=y.$Rf(m),$.with({path:C.$fc.resolve($.path,m)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,m){return $===m||$!==void 0&&m!==void 0&&(0,A.$1e)($,m)}hasTrailingPathSeparator($,m=C.sep){if($.scheme===M.Schemas.file){const t=k($);return t.length>y.$Sf(t).length&&t[t.length-1]===m}else{const t=$.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,m=C.sep){return(0,e.$Ag)($,m)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,m=C.sep){let t=!1;if($.scheme===M.Schemas.file){const i=k($);t=i!==void 0&&i.length===y.$Sf(i).length&&i[i.length-1]===m}else{m="/";const i=$.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$Ag)($,m)?$.with({path:$.path+"/"}):$}}e.$jg=f,e.$kg=new f(()=>!1),e.$lg=new f(p=>p.scheme===M.Schemas.file?!L.$l:!0),e.$mg=new f(p=>!0),e.$ng=e.$kg.isEqual.bind(e.$kg),e.$og=e.$kg.isEqualOrParent.bind(e.$kg),e.$pg=e.$kg.getComparisonKey.bind(e.$kg),e.$qg=e.$kg.basenameOrAuthority.bind(e.$kg),e.$rg=e.$kg.basename.bind(e.$kg),e.$sg=e.$kg.extname.bind(e.$kg),e.$tg=e.$kg.dirname.bind(e.$kg),e.$ug=e.$kg.joinPath.bind(e.$kg),e.$vg=e.$kg.normalizePath.bind(e.$kg),e.$wg=e.$kg.relativePath.bind(e.$kg),e.$xg=e.$kg.resolvePath.bind(e.$kg),e.$yg=e.$kg.isAbsolutePath.bind(e.$kg),e.$zg=e.$kg.isEqualAuthority.bind(e.$kg),e.$Ag=e.$kg.hasTrailingPathSeparator.bind(e.$kg),e.$Bg=e.$kg.removeTrailingPathSeparator.bind(e.$kg),e.$Cg=e.$kg.addTrailingPathSeparator.bind(e.$kg);function R(p,$){const m=[];for(let t=0;t<p.length;t++){const i=$(p[t]);p.some((a,b)=>b===t?!1:(0,e.$og)(i,$(a)))||m.push(p[t])}return m}e.$Dg=R;var D;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function $(m){const t=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(b=>{const[E,v]=b.split(":");E&&v&&t.set(E,v)});const a=m.path.substring(0,m.path.indexOf(";"));return a&&t.set(p.META_DATA_MIME,a),t}p.parseMetaData=$})(D||(e.DataUri=D={}));function c(p,$,m){if($){let t=p.path;return t&&t[0]!==C.$fc.sep&&(t=C.$fc.sep+t),p.with({scheme:m,authority:$,path:t})}return p.with({scheme:m})}e.$Eg=c}),define(Re[12],Me([1,0,21,9,5,6,23,22,120]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eh=e.$dh=e.$ch=e.Promises=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=void 0;function f(z){return!!z&&typeof z.then=="function"}e.$Fg=f;function R(z){const V=new y.$Wd,ue=z(V.token),ye=new Promise((be,pe)=>{const De=V.token.onCancellationRequested(()=>{De.dispose(),V.dispose(),pe(new M.$4)});Promise.resolve(ue).then(ne=>{De.dispose(),V.dispose(),be(ne)},ne=>{De.dispose(),V.dispose(),pe(ne)})});return new class{cancel(){V.cancel()}then(be,pe){return ye.then(be,pe)}catch(be){return this.then(void 0,be)}finally(be){return ye.finally(be)}}}e.$Gg=R;function D(z,V,ue){return new Promise((ye,be)=>{const pe=V.onCancellationRequested(()=>{pe.dispose(),ye(ue)});z.then(ye,be).finally(()=>pe.dispose())})}e.$Hg=D;function c(z,V){return new Promise((ue,ye)=>{const be=V.onCancellationRequested(()=>{be.dispose(),ye(new M.$4)});z.then(ue,ye).finally(()=>be.dispose())})}e.$Ig=c;async function p(z){let V=-1;const ue=z.map((ye,be)=>ye.then(pe=>(V=be,pe)));try{return await Promise.race(ue)}finally{z.forEach((ye,be)=>{be!==V&&ye.cancel()})}}e.$Jg=p;function $(z,V,ue){let ye;const be=setTimeout(()=>{ye?.(void 0),ue?.()},V);return Promise.race([z.finally(()=>clearTimeout(be)),new Promise(pe=>ye=pe)])}e.$Kg=$;function m(z){return new Promise((V,ue)=>{const ye=z();f(ye)?ye.then(V,ue):V(ye)})}e.$Lg=m;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(V){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=V,!this.b){const ue=()=>{if(this.b=null,this.f)return;const ye=this.queue(this.d);return this.d=null,ye};this.b=new Promise(ye=>{this.a.then(ue,ue).then(ye)})}return new Promise((ue,ye)=>{this.b.then(ue,ye)})}return this.a=V(),new Promise((ue,ye)=>{this.a.then(be=>{this.a=null,ue(be)},be=>{this.a=null,ye(be)})})}dispose(){this.f=!0}}e.$Mg=t;class i{constructor(){this.a=Promise.resolve(null)}queue(V){return this.a=this.a.then(()=>V(),()=>V())}}e.$Ng=i;class a{constructor(){this.a=new Map}queue(V,ue){const be=(this.a.get(V)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(V)===be&&this.a.delete(V)});return this.a.set(V,be),be}}e.$Og=a;const b=(z,V)=>{let ue=!0;const ye=setTimeout(()=>{ue=!1,V()},z);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(ye),ue=!1}}},E=z=>{let V=!0;return queueMicrotask(()=>{V&&(V=!1,z())}),{isTriggered:()=>V,dispose:()=>{V=!1}}};class v{constructor(V){this.defaultDelay=V,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(V,ue=this.defaultDelay){this.g=V,this.h(),this.b||(this.b=new Promise((be,pe)=>{this.d=be,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const ye=()=>{this.a=null,this.d?.(null)};return this.a=ue===k.$Jd?E(ye):b(ue,ye),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Pg=v;class r{constructor(V){this.a=new v(V),this.b=new t}trigger(V,ue){return this.a.trigger(()=>this.b.queue(V),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Qg=r;class s{constructor(){this.a=!1,this.b=new Promise((V,ue)=>{this.d=V})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Rg=s;class n extends s{constructor(V){super(),this.f=setTimeout(()=>this.open(),V)}open(){clearTimeout(this.f),super.open()}}e.$Sg=n;function o(z,V){return V?new Promise((ue,ye)=>{const be=setTimeout(()=>{pe.dispose(),ue()},z),pe=V.onCancellationRequested(()=>{clearTimeout(be),pe.dispose(),ye(new M.$4)})}):R(ue=>o(z,ue))}e.$Tg=o;function w(z,V=0,ue){const ye=setTimeout(()=>{z(),ue&&be.dispose()},V),be=(0,L.$Pc)(()=>{clearTimeout(ye),ue?.deleteAndLeak(be)});return ue?.add(be),be}e.$Ug=w;function d(z){const V=[];let ue=0;const ye=z.length;function be(){return ue<ye?z[ue++]():null}function pe(De){De!=null&&V.push(De);const ne=be();return ne?ne.then(pe):Promise.resolve(V)}return Promise.resolve(null).then(pe)}e.$Vg=d;function I(z,V=ye=>!!ye,ue=null){let ye=0;const be=z.length,pe=()=>{if(ye>=be)return Promise.resolve(ue);const De=z[ye++];return Promise.resolve(De()).then(le=>V(le)?Promise.resolve(le):pe())};return pe()}e.$Wg=I;function S(z,V=ye=>!!ye,ue=null){if(z.length===0)return Promise.resolve(ue);let ye=z.length;const be=()=>{ye=-1;for(const pe of z)pe.cancel?.()};return new Promise((pe,De)=>{for(const ne of z)ne.then(le=>{--ye>=0&&V(le)?(be(),pe(le)):ye===0&&pe(ue)}).catch(le=>{--ye>=0&&(be(),De(le))})})}e.$Xg=S;class u{constructor(V){this.a=0,this.d=V,this.f=[],this.b=0,this.g=new C.$Md}get onDrained(){return this.g.event}get size(){return this.a}queue(V){return this.a++,new Promise((ue,ye)=>{this.f.push({factory:V,c:ue,e:ye}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const V=this.f.shift();this.b++;const ue=V.factory();ue.then(V.c,V.e),ue.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Yg=u;class g extends u{constructor(){super(1)}}e.$Zg=g;class h{constructor(){this.a=new Ee,this.b=0}queue(V){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,V())):this.a.run(this.b++,V())}}e.$1g=h;class P{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const V=new ge;return this.b.add(V),V.p}g(){for(const[,V]of this.a)if(V.size>0)return!1;return!0}queueFor(V,ue=A.$kg){const ye=ue.getComparisonKey(V);let be=this.a.get(ye);if(!be){be=new g;const pe=this.f++,De=C.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(ye),this.h(),this.d?.deleteAndDispose(pe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$Zc),this.d.set(pe,De),this.a.set(ye,be)}return be}h(){this.g()&&this.j()}j(){for(const V of this.b)V.complete();this.b.clear()}dispose(){for(const[,V]of this.a)V.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$2g=P;class W{constructor(V,ue){this.a=-1,typeof V=="function"&&typeof ue=="number"&&this.setIfNotSet(V,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(V,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,V()},ue)}setIfNotSet(V,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,V()},ue))}}e.$3g=W;class K{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(V,ue){this.cancel(),this.a=setInterval(()=>{V()},ue)}}e.$4g=K;class j{constructor(V,ue){this.b=-1,this.a=V,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(V=this.d){this.cancel(),this.b=setTimeout(this.f,V)}get delay(){return this.d}set delay(V){this.d=V}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$5g=j;class B{constructor(V,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=V,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(V=this.b){V%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${V}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(V/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$6g=B;class O extends j{constructor(V,ue){super(V,ue),this.j=[]}work(V){this.j.push(V),this.isScheduled()||this.schedule()}h(){const V=this.j;this.j=[],this.a?.(V)}dispose(){this.j=[],super.dispose()}}e.$7g=O;class N extends L.$Rc{constructor(V,ue){super(),this.g=V,this.h=ue,this.a=[],this.b=this.B(new L.$Sc),this.f=!1}get pending(){return this.a.length}work(V){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+V.length>this.g.maxBufferedWork)return!1}else if(this.pending+V.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of V)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$8g=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$9g=z=>{(0,l.$B)(()=>{if(V)return;const ue=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let V=!1;return{dispose(){V||(V=!0)}}}:e.$9g=(z,V)=>{const ue=requestIdleCallback(z,typeof V=="number"?{timeout:V}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(ue))}}}}();class te{constructor(V){this.d=!1,this.a=()=>{try{this.f=V()}catch(ue){this.g=ue}finally{this.d=!0}},this.b=(0,e.$9g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$0g=te;async function Y(z,V,ue){let ye;for(let be=0;be<ue;be++)try{return await z()}catch(pe){ye=pe,await o(V)}throw ye}e.$$g=Y;class Ee{isRunning(V){return typeof V=="number"?this.a?.taskId===V:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(V,ue,ye){return this.a={taskId:V,cancel:()=>ye?.(),promise:ue},ue.then(()=>this.d(V),()=>this.d(V)),ue}d(V){this.a&&V===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const V=this.b;this.b=void 0,V.run().then(V.promiseResolve,V.promiseReject)}}queue(V){if(this.b)this.b.run=V;else{let ue,ye;const be=new Promise((pe,De)=>{ue=pe,ye=De});this.b={run:V,promise:be,promiseResolve:ue,promiseReject:ye}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$_g=Ee;class Se{constructor(V,ue=()=>Date.now()){this.d=V,this.f=ue,this.a=0,this.b=0}increment(){const V=this.f();return V-this.a>this.d&&(this.a=V,this.b=0),this.b++,this.b}}e.$ah=Se;var Pe;(function(z){z[z.Resolved=0]="Resolved",z[z.Rejected=1]="Rejected"})(Pe||(Pe={}));class ge{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((V,ue)=>{this.a=V,this.b=ue})}complete(V){return new Promise(ue=>{this.a(V),this.d={outcome:0,value:V},ue()})}error(V){return new Promise(ue=>{this.b(V),this.d={outcome:1,value:V},ue()})}cancel(){return this.error(new M.$4)}}e.$bh=ge;var me;(function(z){async function V(ye){let be;const pe=await Promise.all(ye.map(De=>De.then(ne=>ne,ne=>{be||(be=ne)})));if(typeof be<"u")throw be;return pe}z.settled=V;function ue(ye){return new Promise(async(be,pe)=>{try{await ye(be,pe)}catch(De){pe(De)}})}z.withAsyncBody=ue})(me||(e.Promises=me={}));var ce;(function(z){z[z.Initial=0]="Initial",z[z.DoneOK=1]="DoneOK",z[z.DoneError=2]="DoneError"})(ce||(ce={}));class se{static fromArray(V){return new se(ue=>{ue.emitMany(V)})}static fromPromise(V){return new se(async ue=>{ue.emitMany(await V)})}static fromPromises(V){return new se(async ue=>{await Promise.all(V.map(async ye=>ue.emitOne(await ye)))})}static merge(V){return new se(async ue=>{await Promise.all(V.map(async ye=>{for await(const be of ye)ue.emitOne(be)}))})}static{this.EMPTY=se.fromArray([])}constructor(V){this.a=0,this.b=[],this.d=null,this.f=new C.$Md,queueMicrotask(async()=>{const ue={emitOne:ye=>this.g(ye),emitMany:ye=>this.h(ye),reject:ye=>this.k(ye)};try{await Promise.resolve(V(ue)),this.j()}catch(ye){this.k(ye)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let V=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(V<this.b.length)return{done:!1,value:this.b[V++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.f.event)}while(!0)}}}static map(V,ue){return new se(async ye=>{for await(const be of V)ye.emitOne(ue(be))})}map(V){return se.map(this,V)}static filter(V,ue){return new se(async ye=>{for await(const be of V)ue(be)&&ye.emitOne(be)})}filter(V){return se.filter(this,V)}static coalesce(V){return se.filter(V,ue=>!!ue)}coalesce(){return se.coalesce(this)}static async toPromise(V){const ue=[];for await(const ye of V)ue.push(ye);return ue}toPromise(){return se.toPromise(this)}g(V){this.a===0&&(this.b.push(V),this.f.fire())}h(V){this.a===0&&(this.b=this.b.concat(V),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(V){this.a===0&&(this.a=2,this.d=V,this.f.fire())}}e.$ch=se;class $e extends se{constructor(V,ue){super(ue),this.l=V}cancel(){this.l.cancel()}}e.$dh=$e;function _(z){const V=new y.$Wd,ue=z(V.token);return new $e(V,async ye=>{const be=V.token.onCancellationRequested(()=>{be.dispose(),V.dispose(),ye.reject(new M.$4)});try{for await(const pe of ue){if(V.token.isCancellationRequested)return;ye.emitOne(pe)}be.dispose(),V.dispose()}catch(pe){be.dispose(),V.dispose(),ye.reject(pe)}})}e.$eh=_}),define(Re[37],Me([1,0,18,12,43,28,19,22,15]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=void 0;function f(){return Object.create(null)}e.$pj=f,e.$qj="**",e.$rj="/";const R="[/\\\\]",D="[^/\\\\]",c=/\//g;function p(Ee,Se){switch(Ee){case 0:return"";case 1:return`${D}*?`;default:return`(?:${R}|${D}+${R}${Se?`|${R}${D}+`:""})*?`}}function $(Ee,Se){if(!Ee)return[];const Pe=[];let ge=!1,me=!1,ce="";for(const se of Ee){switch(se){case Se:if(!ge&&!me){Pe.push(ce),ce="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":me=!0;break;case"]":me=!1;break}ce+=se}return ce&&Pe.push(ce),Pe}e.$sj=$;function m(Ee){if(!Ee)return"";let Se="";const Pe=$(Ee,e.$rj);if(Pe.every(ge=>ge===e.$qj))Se=".*";else{let ge=!1;Pe.forEach((me,ce)=>{if(me===e.$qj){if(ge)return;Se+=p(2,ce===Pe.length-1)}else{let se=!1,$e="",_=!1,z="";for(const V of me){if(V!=="}"&&se){$e+=V;continue}if(_&&(V!=="]"||!z)){let ue;V==="-"?ue=V:(V==="^"||V==="!")&&!z?ue="^":V===e.$rj?ue="":ue=(0,k.$Ee)(V),z+=ue;continue}switch(V){case"{":se=!0;continue;case"[":_=!0;continue;case"}":{const ye=`(?:${$($e,",").map(be=>m(be)).join("|")})`;Se+=ye,se=!1,$e="";break}case"]":{Se+="["+z+"]",_=!1,z="";break}case"?":Se+=D;continue;case"*":Se+=p(1);continue;default:Se+=(0,k.$Ee)(V)}}ce<Pe.length-1&&(Pe[ce+1]!==e.$qj||ce+2<Pe.length)&&(Se+=R)}ge=me===e.$qj})}return Se}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new L.$Cc(1e4),s=function(){return!1},n=function(){return null};function o(Ee,Se){if(!Ee)return n;let Pe;typeof Ee!="string"?Pe=Ee.pattern:Pe=Ee,Pe=Pe.trim();const ge=`${Pe}_${!!Se.trimForExclusions}`;let me=r.get(ge);if(me)return w(me,Ee);let ce;return t.test(Pe)?me=I(Pe.substr(4),Pe):(ce=i.exec(d(Pe,Se)))?me=S(ce[1],Pe):(Se.trimForExclusions?b:a).test(Pe)?me=u(Pe,Se):(ce=E.exec(d(Pe,Se)))?me=g(ce[1].substr(1),Pe,!0):(ce=v.exec(d(Pe,Se)))?me=g(ce[1],Pe,!1):me=h(Pe),r.set(ge,me),w(me,Ee)}function w(Ee,Se){if(typeof Se=="string")return Ee;const Pe=function(ge,me){return(0,C.$Wf)(ge,Se.base,!l.$l)?Ee((0,k.$Ie)(ge.substr(Se.base.length),A.sep),me):null};return Pe.allBasenames=Ee.allBasenames,Pe.allPaths=Ee.allPaths,Pe.basenames=Ee.basenames,Pe.patterns=Ee.patterns,Pe}function d(Ee,Se){return Se.trimForExclusions&&Ee.endsWith("/**")?Ee.substr(0,Ee.length-2):Ee}function I(Ee,Se){return function(Pe,ge){return typeof Pe=="string"&&Pe.endsWith(Ee)?Se:null}}function S(Ee,Se){const Pe=`/${Ee}`,ge=`\\${Ee}`,me=function(se,$e){return typeof se!="string"?null:$e?$e===Ee?Se:null:se===Ee||se.endsWith(Pe)||se.endsWith(ge)?Se:null},ce=[Ee];return me.basenames=ce,me.patterns=[Se],me.allBasenames=ce,me}function u(Ee,Se){const Pe=te(Ee.slice(1,-1).split(",").map($e=>o($e,Se)).filter($e=>$e!==n),Ee),ge=Pe.length;if(!ge)return n;if(ge===1)return Pe[0];const me=function($e,_){for(let z=0,V=Pe.length;z<V;z++)if(Pe[z]($e,_))return Ee;return null},ce=Pe.find($e=>!!$e.allBasenames);ce&&(me.allBasenames=ce.allBasenames);const se=Pe.reduce(($e,_)=>_.allPaths?$e.concat(_.allPaths):$e,[]);return se.length&&(me.allPaths=se),me}function g(Ee,Se,Pe){const ge=A.sep===A.$fc.sep,me=ge?Ee:Ee.replace(c,A.sep),ce=A.sep+me,se=A.$fc.sep+Ee;let $e;return Pe?$e=function(_,z){return typeof _=="string"&&(_===me||_.endsWith(ce)||!ge&&(_===Ee||_.endsWith(se)))?Se:null}:$e=function(_,z){return typeof _=="string"&&(_===me||!ge&&_===Ee)?Se:null},$e.allPaths=[(Pe?"*/":"./")+Ee],$e}function h(Ee){try{const Se=new RegExp(`^${m(Ee)}$`);return function(Pe){return Se.lastIndex=0,typeof Pe=="string"&&Se.test(Pe)?Ee:null}}catch{return n}}function P(Ee,Se,Pe){return!Ee||typeof Se!="string"?!1:W(Ee)(Se,void 0,Pe)}e.$tj=P;function W(Ee,Se={}){if(!Ee)return s;if(typeof Ee=="string"||K(Ee)){const Pe=o(Ee,Se);if(Pe===n)return s;const ge=function(me,ce){return!!Pe(me,ce)};return Pe.allBasenames&&(ge.allBasenames=Pe.allBasenames),Pe.allPaths&&(ge.allPaths=Pe.allPaths),ge}return O(Ee,Se)}e.$uj=W;function K(Ee){const Se=Ee;return Se?typeof Se.base=="string"&&typeof Se.pattern=="string":!1}e.$vj=K;function j(Ee){return Ee.allBasenames||[]}e.$wj=j;function B(Ee){return Ee.allPaths||[]}e.$xj=B;function O(Ee,Se){const Pe=te(Object.getOwnPropertyNames(Ee).map($e=>N($e,Ee[$e],Se)).filter($e=>$e!==n)),ge=Pe.length;if(!ge)return n;if(!Pe.some($e=>!!$e.requiresSiblings)){if(ge===1)return Pe[0];const $e=function(V,ue){let ye;for(let be=0,pe=Pe.length;be<pe;be++){const De=Pe[be](V,ue);if(typeof De=="string")return De;(0,M.$Fg)(De)&&(ye||(ye=[]),ye.push(De))}return ye?(async()=>{for(const be of ye){const pe=await be;if(typeof pe=="string")return pe}return null})():null},_=Pe.find(V=>!!V.allBasenames);_&&($e.allBasenames=_.allBasenames);const z=Pe.reduce((V,ue)=>ue.allPaths?V.concat(ue.allPaths):V,[]);return z.length&&($e.allPaths=z),$e}const me=function($e,_,z){let V,ue;for(let ye=0,be=Pe.length;ye<be;ye++){const pe=Pe[ye];pe.requiresSiblings&&z&&(_||(_=(0,A.$mc)($e)),V||(V=_.substr(0,_.length-(0,A.$nc)($e).length)));const De=pe($e,_,V,z);if(typeof De=="string")return De;(0,M.$Fg)(De)&&(ue||(ue=[]),ue.push(De))}return ue?(async()=>{for(const ye of ue){const be=await ye;if(typeof be=="string")return be}return null})():null},ce=Pe.find($e=>!!$e.allBasenames);ce&&(me.allBasenames=ce.allBasenames);const se=Pe.reduce(($e,_)=>_.allPaths?$e.concat(_.allPaths):$e,[]);return se.length&&(me.allPaths=se),me}function N(Ee,Se,Pe){if(Se===!1)return n;const ge=o(Ee,Pe);if(ge===n)return n;if(typeof Se=="boolean")return ge;if(Se){const me=Se.when;if(typeof me=="string"){const ce=(se,$e,_,z)=>{if(!z||!ge(se,$e))return null;const V=me.replace("$(basename)",()=>_),ue=z(V);return(0,M.$Fg)(ue)?ue.then(ye=>ye?Ee:null):ue?Ee:null};return ce.requiresSiblings=!0,ce}}return ge}function te(Ee,Se){const Pe=Ee.filter($e=>!!$e.basenames);if(Pe.length<2)return Ee;const ge=Pe.reduce(($e,_)=>{const z=_.basenames;return z?$e.concat(z):$e},[]);let me;if(Se){me=[];for(let $e=0,_=ge.length;$e<_;$e++)me.push(Se)}else me=Pe.reduce(($e,_)=>{const z=_.patterns;return z?$e.concat(z):$e},[]);const ce=function($e,_){if(typeof $e!="string")return null;if(!_){let V;for(V=$e.length;V>0;V--){const ue=$e.charCodeAt(V-1);if(ue===47||ue===92)break}_=$e.substr(V)}const z=ge.indexOf(_);return z!==-1?me[z]:null};ce.basenames=ge,ce.patterns=me,ce.allBasenames=ge;const se=Ee.filter($e=>!$e.basenames);return se.push(ce),se}function Y(Ee,Se){return(0,y.$tb)(Ee,Se,(Pe,ge)=>typeof Pe=="string"&&typeof ge=="string"?Pe===ge:typeof Pe!="string"&&typeof ge!="string"?Pe.base===ge.base&&Pe.pattern===ge.pattern:!1)}e.$yj=Y}),define(Re[50],Me([1,0,9,121,23,15,2]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.MarkdownStringTextNewlineStyle=void 0;var l;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(l||(e.MarkdownStringTextNewlineStyle=l={}));class k{constructor(i="",a=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$6)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(i,a=0){return this.value+=c(this.supportThemeIcons?(0,M.$Uj)(i):i).replace(/([ \t]+)/g,(b,E)=>"&nbsp;".repeat(E.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,a){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(i,a,b){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(i),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(i,a){const b=new RegExp((0,L.$Ee)(a),"g");return i.replace(b,(E,v)=>i.charAt(v-1)!=="\\"?`\\${E}`:E)}}e.$1j=k;function f(t){return R(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$2j=f;function R(t){return t instanceof k?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$3j=R;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,C.$ng)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$4j=D;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$5j=c;function p(t){return t.replace(/"/g,"&quot;")}e.$6j=p;function $(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$7j=$;function m(t){const i=[],a=t.split("|").map(E=>E.trim());t=a[0];const b=a[1];if(b){const E=/height=(\d+)/.exec(b),v=/width=(\d+)/.exec(b),r=E?E[1]:"",s=v?v[1]:"",n=isFinite(parseInt(s)),o=isFinite(parseInt(r));n&&i.push(`width="${s}"`),o&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$8j=m}),define(Re[90],Me([1,0,18,43,19,22,23,15]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=void 0;function k(o,w){const{os:d,tildify:I,relative:S}=w;if(S){const h=f(o,S,d);if(typeof h=="string")return h}let u=o.fsPath;if(d===1&&!L.$j?u=u.replace(/\//g,"\\"):d!==1&&L.$j&&(u=u.replace(/\\/g,"/")),d!==1&&I?.userHome){const h=I.userHome.fsPath;let P;o.scheme!==I.userHome.scheme&&o.path.startsWith(C.$fc.sep)?P=I.userHome.with({path:o.path}).fsPath:P=o.fsPath,u=c(P,h,d)}return(d===1?C.$ec:C.$fc).normalize(R(u,d===1))}e.$mv=k;function f(o,w,d){const I=d===1?C.$ec:C.$fc,S=d===3?A.$kg:A.$mg,u=w.getWorkspace(),g=(0,y.$Nb)(u.folders);if(!g)return;o.scheme!==g.uri.scheme&&o.path.startsWith(C.$fc.sep)&&(o=g.uri.with({path:o.path}));const h=w.getWorkspaceFolder(o);if(!h)return;let P;if(S.isEqual(h.uri,o)?P="":P=S.relativePath(h.uri,o)??"",P&&(P=I.normalize(P)),u.folders.length>1&&!w.noPrefix){const W=h.name?h.name:S.basenameOrAuthority(h.uri);P=P?`${W} \u2022 ${P}`:W}return P}function R(o,w=L.$j){return(0,M.$1f)(o,w)?o.charAt(0).toUpperCase()+o.slice(1):o}e.$nv=R;let D=Object.create(null);function c(o,w,d=L.OS){if(d===1||!o||!w)return o;let I=D.original===w?D.normalized:void 0;I||(I=w,L.$j&&(I=(0,M.$Qf)(I)),I=`${(0,l.$Je)(I,C.$fc.sep)}${C.$fc.sep}`,D={original:w,normalized:I});let S=o;return L.$j&&(S=(0,M.$Qf)(S)),(d===3?S.startsWith(I):(0,l.$2e)(S,I))?`~/${S.substr(I.length)}`:o}e.$ov=c;function p(o,w){return o.replace(/^~($|\/|\\)/,`${w}$1`)}e.$pv=p;const $="\u2026",m="\\\\",t="~";function i(o,w=C.sep){const d=new Array(o.length);let I=!1;for(let S=0;S<o.length;S++){const u=o[S];if(u===""){d[S]=`.${w}`;continue}if(!u){d[S]=u;continue}I=!0;let g="",h=u;h.indexOf(m)===0?(g=h.substr(0,h.indexOf(m)+m.length),h=h.substr(h.indexOf(m)+m.length)):h.indexOf(w)===0?(g=h.substr(0,h.indexOf(w)+w.length),h=h.substr(h.indexOf(w)+w.length)):h.indexOf(t)===0&&(g=h.substr(0,h.indexOf(t)+t.length),h=h.substr(h.indexOf(t)+t.length));const P=h.split(w);for(let W=1;I&&W<=P.length;W++)for(let K=P.length-W;I&&K>=0;K--){I=!1;let j=P.slice(K,K+W).join(w);for(let B=0;!I&&B<o.length;B++)if(B!==S&&o[B]&&o[B].indexOf(j)>-1){const O=K+W===P.length,N=K>0&&o[B].indexOf(w)>-1?w+j:j,te=o[B].endsWith(N);I=!O||te}if(!I){let B="";(P[0].endsWith(":")||g!=="")&&(K===1&&(K=0,W++,j=P[0]+w+j),K>0&&(B=P[0]+w),B=g+B),K>0&&(B=B+$+w),B=B+j,K+W<P.length&&(B=B+w+$),d[S]=B}}I&&(d[S]=u)}return d}e.$qv=i;var a;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function b(o,w=Object.create(null)){const d=[];let I=!1,S="";for(const u of o)if(u==="$"||I&&u==="{")S&&d.push({value:S,type:a.TEXT}),S="",I=!0;else if(u==="}"&&I){const g=w[S];if(typeof g=="string")g.length&&d.push({value:g,type:a.VARIABLE});else if(g){const h=d[d.length-1];(!h||h.type!==a.SEPARATOR)&&d.push({value:g.label,type:a.SEPARATOR})}S="",I=!1}else S+=u;return S&&!I&&d.push({value:S,type:a.TEXT}),d.filter((u,g)=>{if(u.type===a.SEPARATOR){const h=d[g-1],P=d[g+1];return[h,P].every(W=>W&&(W.type===a.VARIABLE||W.type===a.TEXT)&&W.value.length>0)}return!0}).map(u=>u.value).join("")}e.$rv=b;function E(o,w){return L.$k||w?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$k?"&":"&&"):o.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$sv=E;function v(o,w){return L.$k||w?o.replace(/\(&&\w\)|&&/g,""):L.$j?o.replace(/&&|&/g,d=>d==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.$tv=v;function r(o){return o.replace(/&/g,"&&")}e.$uv=r;function s(o){if(o.endsWith("]")){const w=o.lastIndexOf(" [",o.length-2);if(w!==-1){const d=n(o.substring(0,w));return{name:d.name,parentPath:d.parentPath+o.substring(w)}}}return n(o)}e.$vv=s;function n(o){const w=o.indexOf("/")!==-1?C.$fc:C.$ec,d=w.basename(o),I=w.dirname(o);return d.length?{name:d,parentPath:I}:{name:I,parentPath:""}}}),define(Re[132],Me([1,0,26,2]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function C(D){return D.toJSON()}class L{constructor(c){this.a=c}transformIncoming(c){const p=this.a.transformIncoming(c);return p===c?c:C(M.URI.from(p))}transformOutgoing(c){const p=this.a.transformOutgoing(c);return p===c?c:C(M.URI.from(p))}transformOutgoingURI(c){const p=this.a.transformOutgoing(c);return p===c?c:M.URI.from(p)}transformOutgoingScheme(c){return this.a.transformOutgoingScheme(c)}}e.$Im=L,e.$Jm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,c,p){if(!D||p>200)return null;if(typeof D=="object"){if(D instanceof M.URI)return c.transformOutgoing(D);for(const $ in D)if(Object.hasOwnProperty.call(D,$)){const m=A(D[$],c,p+1);m!==null&&(D[$]=m)}}return null}function l(D,c){const p=A(D,c,0);return p===null?D:p}e.$Km=l;function k(D,c,p,$){if(!D||$>200)return null;if(typeof D=="object"){if(D.$mid===1)return p?M.URI.revive(c.transformIncoming(D)):c.transformIncoming(D);if(D instanceof y.$ae)return null;for(const m in D)if(Object.hasOwnProperty.call(D,m)){const t=k(D[m],c,p,$+1);t!==null&&(D[m]=t)}}return null}function f(D,c){const p=k(D,c,!1,0);return p===null?D:p}e.$Lm=f;function R(D,c){const p=k(D,c,!0,0);return p===null?D:p}e.$Mm=R}),define(Re[133],Me([1,0,37,19]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nE=void 0;function C(L,A,l,k,f,R){if(Array.isArray(L)){let D=0;for(const c of L){const p=C(c,A,l,k,f,R);if(p===10)return p;p>D&&(D=p)}return D}else{if(typeof L=="string")return k?L==="*"?5:L===l?10:0:0;if(L){const{language:D,pattern:c,scheme:p,hasAccessToAllModels:$,notebookType:m}=L;if(!k&&!$)return 0;m&&f&&(A=f);let t=0;if(p)if(p===A.scheme)t=10;else if(p==="*")t=5;else return 0;if(D)if(D===l)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(m)if(m===R)t=10;else if(m==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(c){let i;if(typeof c=="string"?i=c:i={...c,base:(0,M.$gc)(c.base)},i===A.fsPath||(0,y.$tj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$nE=C}),define(Re[91],Me([1,0,26,22]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0=e.$Q0=void 0;var C;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(C||(C={}));function L(D){for(let c=0,p=D.length;c<p;c+=4){const $=D[c+0],m=D[c+1],t=D[c+2],i=D[c+3];D[c+0]=i,D[c+1]=t,D[c+2]=m,D[c+3]=$}}function A(D){const c=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return M.$D()||L(c),y.$ae.wrap(c)}function l(D){const c=D.buffer;if(M.$D()||L(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const p=new Uint8Array(c.byteLength);return p.set(c),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function k(D){const c=new Uint32Array(f(D));let p=0;if(c[p++]=D.id,D.type==="full")c[p++]=1,c[p++]=D.data.length,c.set(D.data,p),p+=D.data.length;else{c[p++]=2,c[p++]=D.deltas.length;for(const $ of D.deltas)c[p++]=$.start,c[p++]=$.deleteCount,$.data?(c[p++]=$.data.length,c.set($.data,p),p+=$.data.length):c[p++]=0}return A(c)}e.$Q0=k;function f(D){let c=0;if(c+=1+1,D.type==="full")c+=1+D.data.length;else{c+=1,c+=(1+1+1)*D.deltas.length;for(const p of D.deltas)p.data&&(c+=p.data.length)}return c}function R(D){const c=l(D);let p=0;const $=c[p++];if(c[p++]===1){const a=c[p++],b=c.subarray(p,p+a);return p+=a,{id:$,type:"full",data:b}}const t=c[p++],i=[];for(let a=0;a<t;a++){const b=c[p++],E=c[p++],v=c[p++];let r;v>0&&(r=c.subarray(p,p+v),p+=v),i[a]={start:b,deleteCount:E,data:r}}return{id:$,type:"delta",deltas:i}}e.$R0=R}),define(Re[134],Me([10,11]),function(we,e){return we.create("vs/editor/common/config/editorOptions",e)}),define(Re[135],Me([1,0,18,24,22,123,136,134]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=f;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class D{constructor(Z,ve,Ue,Oe){this.id=Z,this.name=ve,this.defaultValue=Ue,this.schema=Oe}applyUpdate(Z,ve){return p(Z,ve)}compute(Z,ve,Ue){return Ue}}class c{constructor(Z,ve){this.newValue=Z,this.didChange=ve}}e.ApplyUpdateResult=c;function p(X,Z){if(typeof X!="object"||typeof Z!="object"||!X||!Z)return new c(Z,X!==Z);if(Array.isArray(X)||Array.isArray(Z)){const Ue=Array.isArray(X)&&Array.isArray(Z)&&y.$tb(X,Z);return new c(Z,!Ue)}let ve=!1;for(const Ue in Z)if(Z.hasOwnProperty(Ue)){const Oe=p(X[Ue],Z[Ue]);Oe.didChange&&(X[Ue]=Oe.newValue,ve=!0)}return new c(X,ve)}class ${constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,ve){return p(Z,ve)}validate(Z){return this.defaultValue}}class m{constructor(Z,ve,Ue,Oe){this.id=Z,this.name=ve,this.defaultValue=Ue,this.schema=Oe}applyUpdate(Z,ve){return p(Z,ve)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,ve,Ue){return Ue}}function t(X,Z){return typeof X>"u"?Z:X==="false"?!1:!!X}e.boolean=t;class i extends m{constructor(Z,ve,Ue,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=Ue),super(Z,ve,Ue,Oe)}validate(Z){return t(Z,this.defaultValue)}}function a(X,Z,ve,Ue){if(typeof X>"u")return Z;let Oe=parseInt(X,10);return isNaN(Oe)?Z:(Oe=Math.max(ve,Oe),Oe=Math.min(Ue,Oe),Oe|0)}e.clampedInt=a;class b extends m{static clampedInt(Z,ve,Ue,Oe){return a(Z,ve,Ue,Oe)}constructor(Z,ve,Ue,Oe,Ze,rt=void 0){typeof rt<"u"&&(rt.type="integer",rt.default=Ue,rt.minimum=Oe,rt.maximum=Ze),super(Z,ve,Ue,rt),this.minimum=Oe,this.maximum=Ze}validate(Z){return b.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function E(X,Z,ve,Ue){if(typeof X>"u")return Z;const Oe=v.float(X,Z);return v.clamp(Oe,ve,Ue)}e.clampedFloat=E;class v extends m{static clamp(Z,ve,Ue){return Z<ve?ve:Z>Ue?Ue:Z}static float(Z,ve){if(typeof Z=="number")return Z;if(typeof Z>"u")return ve;const Ue=parseFloat(Z);return isNaN(Ue)?ve:Ue}constructor(Z,ve,Ue,Oe,Ze){typeof Ze<"u"&&(Ze.type="number",Ze.default=Ue),super(Z,ve,Ue,Ze),this.validationFn=Oe}validate(Z){return this.validationFn(v.float(Z,this.defaultValue))}}class r extends m{static string(Z,ve){return typeof Z!="string"?ve:Z}constructor(Z,ve,Ue,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=Ue),super(Z,ve,Ue,Oe)}validate(Z){return r.string(Z,this.defaultValue)}}function s(X,Z,ve,Ue){return typeof X!="string"?Z:Ue&&X in Ue?Ue[X]:ve.indexOf(X)===-1?Z:X}e.stringSet=s;class n extends m{constructor(Z,ve,Ue,Oe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=Oe,Ze.default=Ue),super(Z,ve,Ue,Ze),this.c=Oe}validate(Z){return s(Z,this.defaultValue,this.c)}}class o extends D{constructor(Z,ve,Ue,Oe,Ze,rt,mt=void 0){typeof mt<"u"&&(mt.type="string",mt.enum=Ze,mt.default=Oe),super(Z,ve,Ue,mt),this.c=Ze,this.d=rt}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function w(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ve,Ue){return Ue===0?Z.accessibilitySupport:Ue}}class I extends D{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{insertSpace:t(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var S;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(S||(e.TextEditorCursorBlinkingStyle=S={}));function u(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function h(X){switch(X){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=h;function P(X){switch(X){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class W extends ${constructor(){super(140)}compute(Z,ve,Ue){const Oe=["monaco-editor"];return ve.get(39)&&Oe.push(ve.get(39)),Z.extraEditorClassName&&Oe.push(Z.extraEditorClassName),ve.get(73)==="default"?Oe.push("mouse-default"):ve.get(73)==="copy"&&Oe.push("mouse-copy"),ve.get(110)&&Oe.push("showUnused"),ve.get(138)&&Oe.push("showDeprecated"),Oe.join(" ")}}class K extends i{constructor(){super(37,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Z,ve,Ue){return Ue&&Z.emptySelectionClipboard}}class j extends D{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:l.localize(16,null),included:C.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:l.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{cursorMoveOnType:t(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":s(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":s(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(ve.loop,this.defaultValue.loop)}}}class B extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",B.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?B.OFF:Z==="true"?B.ON:Z:Z?B.ON:B.OFF}}e.EditorFontLigatures=B;class O extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?O.OFF:Z==="true"?O.TRANSLATE:Z:Z?O.TRANSLATE:O.OFF}compute(Z,ve,Ue){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends ${constructor(){super(50)}compute(Z,ve,Ue){return Z.fontInfo}}class te extends m{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Z){const ve=v.float(Z,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(ve,6,100)}compute(Z,ve,Ue){return Z.fontInfo.fontSize}}class Y extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(b.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class Ee extends D{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Ue,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Ue,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Ue,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Ue,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Ue,description:l.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{multiple:s(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??s(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??s(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??s(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??s(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??s(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Se extends D{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:l.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:t(ve.enabled,this.defaultValue.enabled),delay:b.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:t(ve.sticky,this.defaultValue.sticky),hidingDelay:b.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(ve.above,this.defaultValue.above)}}}var Pe;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Pe||(e.RenderMinimap=Pe={}));class ge extends ${constructor(){super(143)}compute(Z,ve,Ue){return ge.computeLayout(ve,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const ve=Z.height/Z.lineHeight,Ue=Math.floor(Z.paddingTop/Z.lineHeight);let Oe=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Oe=Math.max(Oe,ve-1));const Ze=(Ue+Z.viewLineCount+Oe)/(Z.pixelRatio*Z.height),rt=Math.floor(Z.viewLineCount/Ze);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:Oe,desiredRatio:Ze,minimapLineCount:rt}}static c(Z,ve){const Ue=Z.outerWidth,Oe=Z.outerHeight,Ze=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ze*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const rt=ve.stableMinimapLayoutInput,mt=rt&&Z.outerHeight===rt.outerHeight&&Z.lineHeight===rt.lineHeight&&Z.typicalHalfwidthCharacterWidth===rt.typicalHalfwidthCharacterWidth&&Z.pixelRatio===rt.pixelRatio&&Z.scrollBeyondLastLine===rt.scrollBeyondLastLine&&Z.paddingTop===rt.paddingTop&&Z.paddingBottom===rt.paddingBottom&&Z.minimap.enabled===rt.minimap.enabled&&Z.minimap.side===rt.minimap.side&&Z.minimap.size===rt.minimap.size&&Z.minimap.showSlider===rt.minimap.showSlider&&Z.minimap.renderCharacters===rt.minimap.renderCharacters&&Z.minimap.maxColumn===rt.minimap.maxColumn&&Z.minimap.scale===rt.minimap.scale&&Z.verticalScrollbarWidth===rt.verticalScrollbarWidth&&Z.isViewportWrapping===rt.isViewportWrapping,wt=Z.lineHeight,Ct=Z.typicalHalfwidthCharacterWidth,Yt=Z.scrollBeyondLastLine,qt=Z.minimap.renderCharacters;let bt=Ze>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Ut=Z.minimap.maxColumn,Lt=Z.minimap.size,Bt=Z.minimap.side,Pt=Z.verticalScrollbarWidth,At=Z.viewLineCount,Nt=Z.remainingWidth,Wt=Z.isViewportWrapping,Ht=qt?2:3;let Kt=Math.floor(Ze*Oe);const at=Kt/Ze;let ut=!1,Jt=!1,It=Ht*bt,Et=bt/Ze,dt=1;if(Lt==="fill"||Lt==="fit"){const{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ae,extraLinesBeyondLastLine:fe,desiredRatio:G,minimapLineCount:Fe}=ge.computeContainedMinimapLineCount({viewLineCount:At,scrollBeyondLastLine:Yt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Oe,lineHeight:wt,pixelRatio:Ze});if(At/Fe>1)ut=!0,Jt=!0,bt=1,It=1,Et=bt/Ze;else{let Je=!1,Ve=bt+1;if(Lt==="fit"){const et=Math.ceil((Ae+At+fe)*It);Wt&&mt&&Nt<=ve.stableFitRemainingWidth?(Je=!0,Ve=ve.stableFitMaxMinimapScale):Je=et>Kt}if(Lt==="fill"||Je){ut=!0;const et=bt;It=Math.min(wt*Ze,Math.max(1,Math.floor(1/G))),Wt&&mt&&Nt<=ve.stableFitRemainingWidth&&(Ve=ve.stableFitMaxMinimapScale),bt=Math.min(Ve,Math.max(1,Math.floor(It/Ht))),bt>et&&(dt=Math.min(2,bt/et)),Et=bt/Ze/dt,Kt=Math.ceil(Math.max(Ce,Ae+At+fe)*It),Wt?(ve.stableMinimapLayoutInput=Z,ve.stableFitRemainingWidth=Nt,ve.stableFitMaxMinimapScale=bt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const kt=Math.floor(Ut*Et),Tt=Math.min(kt,Math.max(0,Math.floor((Nt-Pt-2)*Et/(Ct+Et)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(Ze*Tt);const Ke=yt/Ze;yt=Math.floor(yt*dt);const Ot=qt?1:2,zt=Bt==="left"?0:Ue-Tt-Pt;return{renderMinimap:Ot,minimapLeft:zt,minimapWidth:Tt,minimapHeightIsEditorHeight:ut,minimapIsSampling:Jt,minimapScale:bt,minimapLineHeight:It,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:Ke,minimapCanvasOuterHeight:at}}static computeLayout(Z,ve){const Ue=ve.outerWidth|0,Oe=ve.outerHeight|0,Ze=ve.lineHeight|0,rt=ve.lineNumbersDigitCount|0,mt=ve.typicalHalfwidthCharacterWidth,wt=ve.maxDigitWidth,Ct=ve.pixelRatio,Yt=ve.viewLineCount,qt=Z.get(135),bt=qt==="inherit"?Z.get(134):qt,Ut=bt==="inherit"?Z.get(130):bt,Lt=Z.get(133),Bt=ve.isDominatedByLongLines,Pt=Z.get(57),At=Z.get(67).renderType!==0,Nt=Z.get(68),Wt=Z.get(104),Ht=Z.get(83),Kt=Z.get(72),at=Z.get(102),ut=at.verticalScrollbarSize,Jt=at.verticalHasArrows,It=at.arrowSize,Et=at.horizontalScrollbarSize,dt=Z.get(43),kt=Z.get(109)!=="never";let Tt=Z.get(65);dt&&kt&&(Tt+=16);let yt=0;if(At){const ft=Math.max(rt,Nt);yt=Math.round(ft*wt)}let Ke=0;Pt&&(Ke=Ze*ve.glyphMarginDecorationLaneCount);let Ot=0,zt=Ot+Ke,Ce=zt+yt,Ae=Ce+Tt;const fe=Ue-Ke-yt-Tt;let G=!1,Fe=!1,Be=-1;bt==="inherit"&&Bt?(G=!0,Fe=!0):Ut==="on"||Ut==="bounded"?Fe=!0:Ut==="wordWrapColumn"&&(Be=Lt);const Je=ge.c({outerWidth:Ue,outerHeight:Oe,lineHeight:Ze,typicalHalfwidthCharacterWidth:mt,pixelRatio:Ct,scrollBeyondLastLine:Wt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:Kt,verticalScrollbarWidth:ut,viewLineCount:Yt,remainingWidth:fe,isViewportWrapping:Fe},ve.memory||new R);Je.renderMinimap!==0&&Je.minimapLeft===0&&(Ot+=Je.minimapWidth,zt+=Je.minimapWidth,Ce+=Je.minimapWidth,Ae+=Je.minimapWidth);const Ve=fe-Je.minimapWidth,et=Math.max(1,Math.floor((Ve-ut-2)/mt)),gt=Jt?It:0;return Fe&&(Be=Math.max(1,et),Ut==="bounded"&&(Be=Math.min(Be,Lt))),{width:Ue,height:Oe,glyphMarginLeft:Ot,glyphMarginWidth:Ke,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:zt,lineNumbersWidth:yt,decorationsLeft:Ce,decorationsWidth:Tt,contentLeft:Ae,contentWidth:Ve,minimap:Je,viewportColumn:et,isWordWrapMinified:G,isViewportWrapping:Fe,wrappingColumn:Be,verticalScrollbarWidth:ut,horizontalScrollbarHeight:Et,overviewRuler:{top:gt,width:ut,height:Oe-2*gt,right:0}}}}e.EditorLayoutInfoComputer=ge;class me extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Z){return s(Z,"simple",["simple","advanced"])}compute(Z,ve,Ue){return ve.get(2)===2?"advanced":Ue}}class ce extends D{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:l.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:t(Z.enabled,this.defaultValue.enabled)}}}class se extends D{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:l.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:l.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:l.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:l.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:t(ve.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class $e extends D{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:l.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(56,null),l.localize(57,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(58,null,C.$k?"Ctrl+Option":"Ctrl+Alt"),l.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:l.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:l.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:l.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:s(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(ve.fontFamily,this.defaultValue.fontFamily),padding:t(ve.padding,this.defaultValue.padding)}}}class _ extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):b.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,ve,Ue){return Ue<0?b.clampedInt(-Ue*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class z extends v{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>v.clamp(Z,0,150),{markdownDescription:l.localize(63,null)})}compute(Z,ve,Ue){return Z.fontInfo.lineHeight}}class V extends D{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:l.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:l.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(66,null),l.localize(67,null),l.localize(68,null)],default:Z.size,description:l.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:l.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:l.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:l.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:l.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:t(ve.enabled,this.defaultValue.enabled),autohide:t(ve.autohide,this.defaultValue.autohide),size:s(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ve.side,this.defaultValue.side,["right","left"]),showSlider:s(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(ve.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(ve.scale,1,1,3),maxColumn:b.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(X){return X==="ctrlCmd"?C.$k?"metaKey":"ctrlKey":"altKey"}class ye extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{top:b.clampedInt(ve.top,0,0,1e3),bottom:b.clampedInt(ve.bottom,0,0,1e3)}}}class be extends D{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:l.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:l.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:t(ve.enabled,this.defaultValue.enabled),cycle:t(ve.cycle,this.defaultValue.cycle)}}}class pe extends ${constructor(){super(141)}compute(Z,ve,Ue){return Z.pixelRatio}}class De extends D{constructor(){const Z={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(79,null),l.localize(80,null),l.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:Z.strings,description:l.localize(82,null)},comments:{anyOf:ve,default:Z.comments,description:l.localize(83,null)},other:{anyOf:ve,default:Z.other,description:l.localize(84,null)}},default:Z,markdownDescription:l.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Ct=Z?"on":"off";return{comments:Ct,strings:Ct,other:Ct}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:ve,comments:Ue,strings:Oe}=Z,Ze=["on","inline","off"];let rt,mt,wt;return typeof ve=="boolean"?rt=ve?"on":"off":rt=s(ve,this.defaultValue.other,Ze),typeof Ue=="boolean"?mt=Ue?"on":"off":mt=s(Ue,this.defaultValue.comments,Ze),typeof Oe=="boolean"?wt=Oe?"on":"off":wt=s(Oe,this.defaultValue.strings,Ze),{other:rt,comments:mt,strings:wt}}}var ne;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ne||(e.RenderLineNumbersType=ne={}));class le extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null),l.localize(89,null)],default:"on",description:l.localize(90,null)})}validate(Z){let ve=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(ve=4,Ue=Z):Z==="interval"?ve=3:Z==="relative"?ve=2:Z==="on"?ve=1:ve=0),{renderType:ve,renderFn:Ue}}}function re(X){const Z=X.get(97);return Z==="editable"?X.get(90):Z!=="on"}e.filterValidationDecorations=re;class oe extends D{constructor(){const Z=[],ve={type:"number",description:l.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:l.localize(92,null),format:"color-hex"}}}]},default:Z,description:l.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const ve=[];for(const Ue of Z)if(typeof Ue=="number")ve.push({column:b.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const Oe=Ue;ve.push({column:b.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return ve.sort((Ue,Oe)=>Ue.column-Oe.column),ve}return this.defaultValue}}class de extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Ie(X,Z){if(typeof X!="string")return Z;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class F extends D{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"auto",description:l.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(98,null),l.localize(99,null),l.localize(100,null)],default:"auto",description:l.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:l.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:l.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:l.localize(104,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z,Ue=b.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=b.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(ve.vertical,this.defaultValue.vertical),horizontal:Ie(ve.horizontal,this.defaultValue.horizontal),useShadows:t(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:b.clampedInt(ve.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:b.clampedInt(ve.verticalSliderSize,Oe,0,1e3),scrollByPage:t(ve.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends D{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:l.localize(105,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:l.localize(106,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:l.localize(107,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:l.localize(108,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:l.localize(109,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:l.localize(110,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:l.localize(111,null)}})}applyUpdate(Z,ve){let Ue=!1;ve.allowedCharacters&&Z&&(M.$7m(Z.allowedCharacters,ve.allowedCharacters)||(Z={...Z,allowedCharacters:ve.allowedCharacters},Ue=!0)),ve.allowedLocales&&Z&&(M.$7m(Z.allowedLocales,ve.allowedLocales)||(Z={...Z,allowedLocales:ve.allowedLocales},Ue=!0));const Oe=super.applyUpdate(Z,ve);return Ue?new c(Oe.newValue,!0):Oe}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{nonBasicASCII:x(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,ve){if(typeof Z!="object"||!Z)return ve;const Ue={};for(const[Oe,Ze]of Object.entries(Z))Ze===!0&&(Ue[Oe]=!0);return Ue}}class J extends D{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:l.localize(112,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[l.localize(113,null),l.localize(114,null)],description:l.localize(115,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:l.localize(116,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:t(ve.enabled,this.defaultValue.enabled),mode:s(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends D{constructor(){const Z={enabled:L.$Zr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Zr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(117,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:l.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:t(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends D{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(119,null),l.localize(120,null),l.localize(121,null)],default:Z.bracketPairs,description:l.localize(122,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(123,null),l.localize(124,null),l.localize(125,null)],default:Z.bracketPairsHorizontal,description:l.localize(126,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:l.localize(127,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:l.localize(128,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(129,null),l.localize(130,null),l.localize(131,null)],default:Z.highlightActiveIndentation,description:l.localize(132,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{bracketPairs:x(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(X,Z,ve){const Ue=ve.indexOf(X);return Ue===-1?Z:ve[Ue]}class ae extends D{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(133,null),l.localize(134,null)],default:Z.insertMode,description:l.localize(135,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:l.localize(136,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:l.localize(137,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:l.localize(138,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(139,null),l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Z.selectionMode,markdownDescription:l.localize(143,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:l.localize(144,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:l.localize(145,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:l.localize(146,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:l.localize(147,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:l.localize(148,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(149,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(150,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(151,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(152,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(153,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(154,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(155,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(156,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(157,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(158,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(159,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(160,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(161,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(162,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(163,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(164,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(165,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(166,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(167,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{insertMode:s(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(ve.showIcons,this.defaultValue.showIcons),showStatusBar:t(ve.showStatusBar,this.defaultValue.showStatusBar),preview:t(ve.preview,this.defaultValue.preview),previewMode:s(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(ve.showMethods,this.defaultValue.showMethods),showFunctions:t(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:t(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(ve.showFields,this.defaultValue.showFields),showVariables:t(ve.showVariables,this.defaultValue.showVariables),showClasses:t(ve.showClasses,this.defaultValue.showClasses),showStructs:t(ve.showStructs,this.defaultValue.showStructs),showInterfaces:t(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:t(ve.showModules,this.defaultValue.showModules),showProperties:t(ve.showProperties,this.defaultValue.showProperties),showEvents:t(ve.showEvents,this.defaultValue.showEvents),showOperators:t(ve.showOperators,this.defaultValue.showOperators),showUnits:t(ve.showUnits,this.defaultValue.showUnits),showValues:t(ve.showValues,this.defaultValue.showValues),showConstants:t(ve.showConstants,this.defaultValue.showConstants),showEnums:t(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:t(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(ve.showKeywords,this.defaultValue.showKeywords),showWords:t(ve.showWords,this.defaultValue.showWords),showColors:t(ve.showColors,this.defaultValue.showColors),showFiles:t(ve.showFiles,this.defaultValue.showFiles),showReferences:t(ve.showReferences,this.defaultValue.showReferences),showFolders:t(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:t(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(ve.showSnippets,this.defaultValue.showSnippets),showUsers:t(ve.showUsers,this.defaultValue.showUsers),showIssues:t(ve.showIssues,this.defaultValue.showIssues)}}}class Le extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(181,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(182,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var je;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(je||(e.WrappingIndent=je={}));class Qe extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(183,null),l.localize(184,null),l.localize(185,null),l.localize(186,null)],description:l.localize(187,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,ve,Ue){return ve.get(2)===2?0:Ue}}class Ge extends ${constructor(){super(144)}compute(Z,ve,Ue){const Oe=ve.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class xe extends D{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(188,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(189,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(190,null),l.localize(191,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:t(ve.enabled,this.defaultValue.enabled),showDropSelector:s(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends D{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:l.localize(192,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(193,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(194,null),l.localize(195,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:t(ve.enabled,this.defaultValue.enabled),showPasteSelector:s(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const _e="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:C.$k?it:C.$l?tt:_e,fontWeight:"normal",fontSize:C.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(X){return e.editorOptionsRegistry[X.id]=X,X}var st;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(196,null)})),acceptSuggestionOnEnter:ze(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(197,null),""],markdownDescription:l.localize(198,null)})),accessibilitySupport:ze(new d),accessibilityPageSize:ze(new b(3,"accessibilityPageSize",10,1,1073741824,{description:l.localize(199,null),tags:["accessibility"]})),ariaLabel:ze(new r(4,"ariaLabel",l.localize(200,null))),ariaRequired:ze(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new i(8,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(201,null),tags:["accessibility"]})),autoClosingBrackets:ze(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(202,null),l.localize(203,null),""],description:l.localize(204,null)})),autoClosingComments:ze(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(205,null),l.localize(206,null),""],description:l.localize(207,null)})),autoClosingDelete:ze(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(208,null),""],description:l.localize(209,null)})),autoClosingOvertype:ze(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(210,null),""],description:l.localize(211,null)})),autoClosingQuotes:ze(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(212,null),l.localize(213,null),""],description:l.localize(214,null)})),autoIndent:ze(new o(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[l.localize(215,null),l.localize(216,null),l.localize(217,null),l.localize(218,null),l.localize(219,null)],description:l.localize(220,null)})),automaticLayout:ze(new i(13,"automaticLayout",!1)),autoSurround:ze(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(221,null),l.localize(222,null),l.localize(223,null),""],description:l.localize(224,null)})),bracketPairColorization:ze(new Q),bracketPairGuides:ze(new H),stickyTabStops:ze(new i(115,"stickyTabStops",!1,{description:l.localize(225,null)})),codeLens:ze(new i(17,"codeLens",!0,{description:l.localize(226,null)})),codeLensFontFamily:ze(new r(18,"codeLensFontFamily","",{description:l.localize(227,null)})),codeLensFontSize:ze(new b(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(228,null)})),colorDecorators:ze(new i(20,"colorDecorators",!0,{description:l.localize(229,null)})),colorDecoratorActivatedOn:ze(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(230,null),l.localize(231,null),l.localize(232,null)],description:l.localize(233,null)})),colorDecoratorsLimit:ze(new b(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(234,null)})),columnSelection:ze(new i(22,"columnSelection",!1,{description:l.localize(235,null)})),comments:ze(new I),contextmenu:ze(new i(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new i(25,"copyWithSyntaxHighlighting",!0,{description:l.localize(236,null)})),cursorBlinking:ze(new o(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:l.localize(237,null)})),cursorSmoothCaretAnimation:ze(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(238,null),l.localize(239,null),l.localize(240,null)],description:l.localize(241,null)})),cursorStyle:ze(new o(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:l.localize(242,null)})),cursorSurroundingLines:ze(new b(29,"cursorSurroundingLines",0,0,1073741824,{description:l.localize(243,null)})),cursorSurroundingLinesStyle:ze(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(244,null),l.localize(245,null)],markdownDescription:l.localize(246,null)})),cursorWidth:ze(new b(31,"cursorWidth",0,0,1073741824,{markdownDescription:l.localize(247,null)})),disableLayerHinting:ze(new i(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new i(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new i(34,"domReadOnly",!1)),dragAndDrop:ze(new i(35,"dragAndDrop",!0,{description:l.localize(248,null)})),emptySelectionClipboard:ze(new K),dropIntoEditor:ze(new xe),stickyScroll:ze(new se),experimentalWhitespaceRendering:ze(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),extraEditorClassName:ze(new r(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new v(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:l.localize(253,null)})),find:ze(new j),fixedOverflowWidgets:ze(new i(42,"fixedOverflowWidgets",!1)),folding:ze(new i(43,"folding",!0,{description:l.localize(254,null)})),foldingStrategy:ze(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(255,null),l.localize(256,null)],description:l.localize(257,null)})),foldingHighlight:ze(new i(45,"foldingHighlight",!0,{description:l.localize(258,null)})),foldingImportsByDefault:ze(new i(46,"foldingImportsByDefault",!1,{description:l.localize(259,null)})),foldingMaximumRegions:ze(new b(47,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(260,null)})),unfoldOnClickAfterEndOfLine:ze(new i(48,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(261,null)})),fontFamily:ze(new r(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(262,null)})),fontInfo:ze(new N),fontLigatures2:ze(new B),fontSize:ze(new te),fontWeight:ze(new Y),fontVariations:ze(new O),formatOnPaste:ze(new i(55,"formatOnPaste",!1,{description:l.localize(263,null)})),formatOnType:ze(new i(56,"formatOnType",!1,{description:l.localize(264,null)})),glyphMargin:ze(new i(57,"glyphMargin",!0,{description:l.localize(265,null)})),gotoLocation:ze(new Ee),hideCursorInOverviewRuler:ze(new i(59,"hideCursorInOverviewRuler",!1,{description:l.localize(266,null)})),hover:ze(new Se),inDiffEditor:ze(new i(61,"inDiffEditor",!1)),letterSpacing:ze(new v(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>v.clamp(X,-5,20),{description:l.localize(267,null)})),lightbulb:ze(new ce),lineDecorationsWidth:ze(new _),lineHeight:ze(new z),lineNumbers:ze(new le),lineNumbersMinChars:ze(new b(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new i(69,"linkedEditing",!1,{description:l.localize(268,null)})),links:ze(new i(70,"links",!0,{description:l.localize(269,null)})),matchBrackets:ze(new n(71,"matchBrackets","always",["always","near","never"],{description:l.localize(270,null)})),minimap:ze(new V),mouseStyle:ze(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new v(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:l.localize(271,null)})),mouseWheelZoom:ze(new i(75,"mouseWheelZoom",!1,{markdownDescription:l.localize(272,null)})),multiCursorMergeOverlapping:ze(new i(76,"multiCursorMergeOverlapping",!0,{description:l.localize(273,null)})),multiCursorModifier:ze(new o(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[l.localize(274,null),l.localize(275,null)],markdownDescription:l.localize(276,null)})),multiCursorPaste:ze(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(277,null),l.localize(278,null)],markdownDescription:l.localize(279,null)})),multiCursorLimit:ze(new b(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(280,null)})),occurrencesHighlight:ze(new i(80,"occurrencesHighlight",!0,{description:l.localize(281,null)})),overviewRulerBorder:ze(new i(81,"overviewRulerBorder",!0,{description:l.localize(282,null)})),overviewRulerLanes:ze(new b(82,"overviewRulerLanes",3,0,3)),padding:ze(new ye),pasteAs:ze(new Xe),parameterHints:ze(new be),peekWidgetDefaultFocus:ze(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(283,null),l.localize(284,null)],description:l.localize(285,null)})),definitionLinkOpensInPeek:ze(new i(87,"definitionLinkOpensInPeek",!1,{description:l.localize(286,null)})),quickSuggestions:ze(new De),quickSuggestionsDelay:ze(new b(89,"quickSuggestionsDelay",10,0,1073741824,{description:l.localize(287,null)})),readOnly:ze(new i(90,"readOnly",!1)),readOnlyMessage:ze(new de),renameOnType:ze(new i(92,"renameOnType",!1,{description:l.localize(288,null),markdownDeprecationMessage:l.localize(289,null)})),renderControlCharacters:ze(new i(93,"renderControlCharacters",!0,{description:l.localize(290,null),restricted:!0})),renderFinalNewline:ze(new n(94,"renderFinalNewline",C.$l?"dimmed":"on",["off","on","dimmed"],{description:l.localize(291,null)})),renderLineHighlight:ze(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(292,null)],description:l.localize(293,null)})),renderLineHighlightOnlyWhenFocus:ze(new i(96,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(294,null)})),renderValidationDecorations:ze(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(295,null),l.localize(296,null),l.localize(297,null),""],description:l.localize(298,null)})),revealHorizontalRightPadding:ze(new b(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new i(100,"roundedSelection",!0,{description:l.localize(299,null)})),rulers:ze(new oe),scrollbar:ze(new F),scrollBeyondLastColumn:ze(new b(103,"scrollBeyondLastColumn",4,0,1073741824,{description:l.localize(300,null)})),scrollBeyondLastLine:ze(new i(104,"scrollBeyondLastLine",!0,{description:l.localize(301,null)})),scrollPredominantAxis:ze(new i(105,"scrollPredominantAxis",!0,{description:l.localize(302,null)})),selectionClipboard:ze(new i(106,"selectionClipboard",!0,{description:l.localize(303,null),included:C.$l})),selectionHighlight:ze(new i(107,"selectionHighlight",!0,{description:l.localize(304,null)})),selectOnLineNumbers:ze(new i(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(305,null),l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),showUnused:ze(new i(110,"showUnused",!0,{description:l.localize(309,null)})),showDeprecated:ze(new i(138,"showDeprecated",!0,{description:l.localize(310,null)})),inlayHints:ze(new $e),snippetSuggestions:ze(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(311,null),l.localize(312,null),l.localize(313,null),l.localize(314,null)],description:l.localize(315,null)})),smartSelect:ze(new Le),smoothScrolling:ze(new i(113,"smoothScrolling",!1,{description:l.localize(316,null)})),stopRenderingLineAfter:ze(new b(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ae),inlineSuggest:ze(new J),inlineCompletionsAccessibilityVerbose:ze(new i(147,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(317,null)})),suggestFontSize:ze(new b(118,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(318,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new b(119,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(319,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new i(120,"suggestOnTriggerCharacters",!0,{description:l.localize(320,null)})),suggestSelection:ze(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(321,null),l.localize(322,null),l.localize(323,null)],description:l.localize(324,null)})),tabCompletion:ze(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(325,null),l.localize(326,null),l.localize(327,null)],description:l.localize(328,null)})),tabIndex:ze(new b(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new q),unusualLineTerminators:ze(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(329,null),l.localize(330,null),l.localize(331,null)],description:l.localize(332,null)})),useShadowDOM:ze(new i(126,"useShadowDOM",!0)),useTabStops:ze(new i(127,"useTabStops",!0,{description:l.localize(333,null)})),wordBreak:ze(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(334,null),l.localize(335,null)],description:l.localize(336,null)})),wordSeparators:ze(new r(129,"wordSeparators",A.$1r,{description:l.localize(337,null)})),wordWrap:ze(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(338,null),l.localize(339,null),l.localize(340,null),l.localize(341,null)],description:l.localize(342,null)})),wordWrapBreakAfterCharacters:ze(new r(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new r(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new b(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:l.localize(343,null)})),wordWrapOverride1:ze(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new W),defaultColorDecorators:ze(new i(145,"defaultColorDecorators",!1,{markdownDescription:l.localize(344,null)})),pixelRatio:ze(new pe),tabFocusMode:ze(new i(142,"tabFocusMode",!1,{markdownDescription:l.localize(345,null)})),layoutInfo:ze(new ge),wrappingInfo:ze(new Ge),wrappingIndent:ze(new Qe),wrappingStrategy:ze(new me)}}),define(Re[137],Me([10,11]),function(we,e){return we.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[138],Me([10,11]),function(we,e){return we.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[139],Me([10,11]),function(we,e){return we.create("vs/platform/contextkey/common/scanner",e)}),define(Re[140],Me([10,11]),function(we,e){return we.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[141],Me([10,11]),function(we,e){return we.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[142],Me([10,11]),function(we,e){return we.create("vs/platform/files/common/files",e)}),define(Re[143],Me([10,11]),function(we,e){return we.create("vs/platform/markers/common/markers",e)}),define(Re[144],Me([10,11]),function(we,e){return we.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[145],Me([10,11]),function(we,e){return we.create("vs/platform/workspace/common/workspace",e)}),define(Re[146],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostChat",e)}),define(Re[147],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[148],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[149],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[150],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[151],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[152],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostProgress",e)}),define(Re[153],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[154],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[155],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[156],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[157],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[158],Me([10,11]),function(we,e){return we.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[159],Me([10,11]),function(we,e){return we.create("vs/workbench/common/editor",e)}),define(Re[160],Me([10,11]),function(we,e){return we.create("vs/workbench/common/views",e)}),define(Re[161],Me([10,11]),function(we,e){return we.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[162],Me([10,11]),function(we,e){return we.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[163],Me([10,11]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[164],Me([10,11]),function(we,e){return we.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[165],Me([10,11]),function(we,e){return we.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[166],Me([10,11]),function(we,e){return we.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[167],Me([10,11]),function(we,e){return we.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[168],Me([1,0,9,139]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.TokenType=void 0;var C;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(C||(e.TokenType=C={}));function L(...f){switch(f.length){case 1:return(0,M.localize)(0,null,f[0]);case 2:return(0,M.localize)(1,null,f[0],f[1]);case 3:return(0,M.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,M.localize)(3,null),l=(0,M.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,y.$7)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const D=this.d,c=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:c};this.g.push({offset:D,lexeme:c,additionalInfo:R}),this.f.push(p)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const D=this.c.substring(this.d,this.e),c=k.b.get(D);c?this.k(c):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,D=!1,c=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(l);return}const $=this.c.charCodeAt(R);if(D)D=!1;else if($===47&&!c){R++;break}else $===91?c=!0:$===92?D=!0:$===93&&(c=!1);R++}for(;R<this.c.length&&k.a.has(this.c.charCodeAt(R));)R++;this.e=R;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ii=k}),define(Re[169],Me([1,0,23,29,141,276]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,l=/^-(\d{4})(\d{2})(\d{2})$/;function k(i){return i=i.trim(),i==="*"||A.test(i)}e.$Io=k;function f(i){if(!k(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=i.match(A);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$Jo=f;function R(i){if(!i)return null;const a=i.majorBase,b=i.majorMustEqual,E=i.minorBase;let v=i.minorMustEqual;const r=i.patchBase;let s=i.patchMustEqual;i.hasCaret&&(a===0||(v=!1),s=!1);let n=0;if(i.preRelease){const o=l.exec(i.preRelease);if(o){const[,w,d,I]=o;n=Date.UTC(Number(w),Number(d)-1,Number(I))}}return{majorBase:a,majorMustEqual:b,minorBase:E,minorMustEqual:v,patchBase:r,patchMustEqual:s,isMinimum:i.hasGreaterEquals,notBefore:n}}e.$Ko=R;function D(i,a,b){let E;typeof i=="string"?E=R(f(i)):E=i;let v;a instanceof Date?v=a.getTime():typeof a=="string"&&(v=new Date(a).getTime());let r;if(typeof b=="string"?r=R(f(b)):r=b,!E||!r)return!1;const s=E.majorBase,n=E.minorBase,o=E.patchBase;let w=r.majorBase,d=r.minorBase,I=r.patchBase;const S=r.notBefore;let u=r.majorMustEqual,g=r.minorMustEqual,h=r.patchMustEqual;return r.isMinimum?s>w?!0:s<w?!1:n>d?!0:n<d||v&&v<S?!1:o>=I:(s===1&&w===0&&(!u||!g||!h)&&(w=1,d=0,I=0,u=!0,g=!1,h=!1),s<w?!1:s>w?!u:n<d?!1:n>d?!g:o<I?!1:o>I?!h:!(v&&v<S))}e.$Lo=D;function c(i,a,b,E,v){const r=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return r.push([M.default.Error,C.localize(0,null)]),r;if(typeof E.name!="string")return r.push([M.default.Error,C.localize(1,null,"name")]),r;if(typeof E.version!="string")return r.push([M.default.Error,C.localize(2,null,"version")]),r;if(!E.engines)return r.push([M.default.Error,C.localize(3,null,"engines")]),r;if(typeof E.engines.vscode!="string")return r.push([M.default.Error,C.localize(4,null,"engines.vscode")]),r;if(typeof E.extensionDependencies<"u"&&!t(E.extensionDependencies))return r.push([M.default.Error,C.localize(5,null,"extensionDependencies")]),r;if(typeof E.activationEvents<"u"){if(!t(E.activationEvents))return r.push([M.default.Error,C.localize(6,null,"activationEvents")]),r;if(typeof E.main>"u"&&typeof E.browser>"u")return r.push([M.default.Error,C.localize(7,null,"activationEvents","main","browser")]),r}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&r.push([M.default.Warning,C.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return r.push([M.default.Error,C.localize(9,null,"main")]),r;{const o=(0,y.$ug)(b,E.main);(0,y.$og)(o,b)||r.push([M.default.Warning,C.localize(10,null,o.path,b.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return r.push([M.default.Error,C.localize(11,null,"browser")]),r;{const o=(0,y.$ug)(b,E.browser);(0,y.$og)(o,b)||r.push([M.default.Warning,C.localize(12,null,o.path,b.path)])}}if(!L.valid(E.version))return r.push([M.default.Error,C.localize(13,null)]),r;const s=[];if(!p(i,a,E,v,s))for(const o of s)r.push([M.default.Error,o]);return r}e.$Mo=c;function p(i,a,b,E,v){return E||typeof b.main>"u"&&typeof b.browser>"u"?!0:m(i,a,b.engines.vscode,v)}e.$No=p;function $(i,a,b){return i==="*"||m(a,b,i)}e.$Oo=$;function m(i,a,b,E=[]){const v=R(f(b));if(!v)return E.push(C.localize(14,null,b)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return E.push(C.localize(15,null,b)),!1}else if(!v.majorMustEqual)return E.push(C.localize(16,null,b)),!1;return D(i,a,v)?!0:(E.push(C.localize(17,null,i,b)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let a=0,b=i.length;a<b;a++)if(typeof i[a]!="string")return!1;return!0}}),define(Re[68],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kh=void 0;class y{constructor(C,L=[],A=!1){this.ctor=C,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$Kh=y}),define(Re[69],Me([1,0,68]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=e.InstantiationType=void 0;const M=[];var C;(function(l){l[l.Eager=0]="Eager",l[l.Delayed=1]="Delayed"})(C||(e.InstantiationType=C={}));function L(l,k,f){k instanceof y.$Kh||(k=new y.$Kh(k,[],!!f)),M.push([l,k])}e.$tr=L;function A(){return M}e.$ur=A}),define(Re[170],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=void 0;class y{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$$p=y;class M{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const l=this.lookupOrInsertNode(L),k=this.lookupOrInsertNode(A);l.outgoing.set(k.key,k),k.incoming.set(l.key,l)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const l of this.a.values())l.outgoing.delete(A),l.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let l=this.a.get(A);return l||(l=new y(A,L),this.a.set(A,l)),l}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,l]of this.a)L.push(`${A}
	(-> incoming)[${[...l.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...l.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const l=new Set([L]),k=this.c(A,l);if(k)return k}}c(L,A){for(const[l,k]of L.outgoing){if(A.has(l))return[...A,l].join(" -> ");A.add(l);const f=this.c(k,A);if(f)return f;A.delete(l)}}}e.$_p=M}),define(Re[4],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.$Nh=e.$Mh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function l(k){return k[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=l})(y||(e._util=y={})),e.$Mh=C("instantiationService");function M(A,l,k){l[y.DI_TARGET]===l?l[y.DI_DEPENDENCIES].push({id:A,index:k}):(l[y.DI_DEPENDENCIES]=[{id:A,index:k}],l[y.DI_TARGET]=l)}function C(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const l=function(k,f,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(l,k,R)};return l.toString=()=>A,y.serviceIds.set(A,l),l}e.$Nh=C;function L(A){return A}e.$Oh=L}),define(Re[44],Me([1,0,16,2,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.ConfigurationTarget=e.$ji=e.$ii=e.$hi=void 0,e.$hi=(0,C.$Nh)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof M.URI)}e.$ii=L;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof M.URI)}e.$ji=A;var l;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(l||(e.ConfigurationTarget=l={}));function k(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ki=k;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$li=f;function R(i,a){const b=Object.create(null);for(const E in i)D(b,E,i[E],a);return b}e.$mi=R;function D(i,a,b,E){const v=a.split("."),r=v.pop();let s=i;for(let n=0;n<v.length;n++){const o=v[n];let w=s[o];switch(typeof w){case"undefined":w=s[o]=Object.create(null);break;case"object":break;default:E(`Ignoring ${a} as ${v.slice(0,n+1).join(".")} is ${JSON.stringify(w)}`);return}s=w}if(typeof s=="object"&&s!==null)try{s[r]=b}catch{E(`Ignoring ${a} as ${v.join(".")} is ${JSON.stringify(s)}`)}else E(`Ignoring ${a} as ${v.join(".")} is ${JSON.stringify(s)}`)}e.$ni=D;function c(i,a){const b=a.split(".");p(i,b)}e.$oi=c;function p(i,a){const b=a.shift();if(a.length===0){delete i[b];return}if(Object.keys(i).indexOf(b)!==-1){const E=i[b];typeof E=="object"&&!Array.isArray(E)&&(p(E,a),Object.keys(E).length===0&&delete i[b])}}function $(i,a,b){function E(s,n){let o=s;for(const w of n){if(typeof o!="object"||o===null)return;o=o[w]}return o}const v=a.split("."),r=E(i,v);return typeof r>"u"?b:r}e.$pi=$;function m(i,a,b){Object.keys(a).forEach(E=>{E!=="__proto__"&&(E in i?y.$zf(i[E])&&y.$zf(a[E])?m(i[E],a[E],b):b&&(i[E]=a[E]):i[E]=a[E])})}e.$qi=m;function t(i){return i.replace(/[\[\]]/g,"")}e.$ri=t}),define(Re[32],Me([1,0,22,15,168,4,138,9]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.ContextKeyExprType=e.$Ji=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",y.$k),k.set("isLinux",y.$l),k.set("isWindows",y.$j),k.set("isWeb",y.$p),k.set("isMacNative",y.$k&&!y.$p),k.set("isEdge",y.$H),k.set("isFirefox",y.$F),k.set("isChrome",y.$E),k.set("isSafari",y.$G);function f(_,z){if(k.get(_)!==void 0)throw(0,l.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(_,z)}e.$Ji=f;const R=Object.prototype.hasOwnProperty;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const c={regexParsingWithErrorRecovery:!0},p=(0,A.localize)(0,null),$=(0,A.localize)(1,null),m=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),a=(0,A.localize)(5,null),b=(0,A.localize)(6,null),E=(0,A.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(z=c){this.k=z,this.d=new C.$Ii,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(z){if(z===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(z).scan(),this.g=0,this.h=[];try{const V=this.l();if(!this.E()){const ue=this.D(),ye=ue.type===17?a:void 0;throw this.h.push({message:i,offset:ue.offset,lexeme:C.$Ii.getLexeme(ue),additionalInfo:ye}),v.c}return V}catch(V){if(V!==v.c)throw V;return}}l(){return this.m()}m(){const z=[this.o()];for(;this.y(16);){const V=this.o();z.push(V)}return z.length===1?z[0]:r.or(...z)}o(){const z=[this.s()];for(;this.y(15);){const V=this.s();z.push(V)}return z.length===1?z[0]:r.and(...z)}s(){if(this.y(2)){const z=this.D();switch(z.type){case 11:return this.z(),w.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const V=this.l();return this.A(1,t),V?.negate()}case 17:return this.z(),P.create(z.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",z)}}return this.t()}t(){const z=this.D();switch(z.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const V=this.l();return this.A(1,t),V}case 17:{const V=z.lexeme;if(this.z(),this.y(9)){const ye=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ye.type!==10)throw this.B("REGEX",ye);const be=ye.lexeme,pe=be.lastIndexOf("/"),De=pe===be.length-1?void 0:this.w(be.substring(pe+1));let ne;try{ne=new RegExp(be.substring(1,pe),De)}catch{throw this.B("REGEX",ye)}return N.create(V,ne)}switch(ye.type){case 10:case 19:{const be=[ye.lexeme];this.z();let pe=this.D(),De=0;for(let de=0;de<ye.lexeme.length;de++)ye.lexeme.charCodeAt(de)===40?De++:ye.lexeme.charCodeAt(de)===41&&De--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:De++;break;case 1:De--;break;case 10:case 18:for(let de=0;de<pe.lexeme.length;de++)pe.lexeme.charCodeAt(de)===40?De++:ye.lexeme.charCodeAt(de)===41&&De--}if(De<0)break;be.push(C.$Ii.getLexeme(pe)),this.z(),pe=this.D()}const ne=be.join(""),le=ne.lastIndexOf("/"),re=le===ne.length-1?void 0:this.w(ne.substring(le+1));let oe;try{oe=new RegExp(ne.substring(1,le),re)}catch{throw this.B("REGEX",ye)}return r.regex(V,oe)}case 18:{const be=ye.lexeme;this.z();let pe=null;if(!(0,M.$Ae)(be)){const De=be.indexOf("/"),ne=be.lastIndexOf("/");if(De!==ne&&De>=0){const le=be.slice(De+1,ne),re=be[ne+1]==="i"?"i":"";try{pe=new RegExp(le,re)}catch{throw this.B("REGEX",ye)}}}if(pe===null)throw this.B("REGEX",ye);return N.create(V,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const ye=this.u();return r.notIn(V,ye)}switch(this.D().type){case 3:{this.z();const ye=this.u();if(this.x().type===18)return r.equals(V,ye);switch(ye){case"true":return r.has(V);case"false":return r.not(V);default:return r.equals(V,ye)}}case 4:{this.z();const ye=this.u();if(this.x().type===18)return r.notEquals(V,ye);switch(ye){case"true":return r.not(V);case"false":return r.has(V);default:return r.notEquals(V,ye)}}case 5:return this.z(),B.create(V,this.u());case 6:return this.z(),O.create(V,this.u());case 7:return this.z(),K.create(V,this.u());case 8:return this.z(),j.create(V,this.u());case 13:return this.z(),r.in(V,this.u());default:return r.has(V)}}case 20:throw this.h.push({message:b,offset:z.offset,lexeme:"",additionalInfo:E}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const z=this.D();switch(z.type){case 17:case 18:return this.z(),z.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(z){return z.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(z){return this.C(z)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(z,V){if(this.C(z))return this.z();throw this.B(V,this.D())}B(z,V,ue){const ye=(0,A.localize)(8,null,z,C.$Ii.getLexeme(V)),be=V.offset,pe=C.$Ii.getLexeme(V);return this.h.push({message:ye,offset:be,lexeme:pe,additionalInfo:ue}),v.c}C(z){return this.D().type===z}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ki=v;class r{static false(){return w.INSTANCE}static true(){return d.INSTANCE}static has(z){return I.create(z)}static equals(z,V){return S.create(z,V)}static notEquals(z,V){return h.create(z,V)}static regex(z,V){return N.create(z,V)}static in(z,V){return u.create(z,V)}static notIn(z,V){return g.create(z,V)}static not(z){return P.create(z)}static and(...z){return Ee.create(z,null,!0)}static or(...z){return Se.create(z,null,!0)}static greater(z,V){return K.create(z,V)}static greaterEquals(z,V){return j.create(z,V)}static smaller(z,V){return B.create(z,V)}static smallerEquals(z,V){return O.create(z,V)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(z){return z==null?void 0:this.c.parse(z)}}e.$Li=r;function s(_){const z=new v({regexParsingWithErrorRecovery:!1});return _.map(V=>(z.parse(V),z.lexingErrors.length>0?z.lexingErrors.map(ue=>({errorMessage:ue.additionalInfo?(0,A.localize)(9,null,ue.additionalInfo):(0,A.localize)(10,null),offset:ue.offset,length:ue.lexeme.length})):z.parsingErrors.length>0?z.parsingErrors.map(ue=>({errorMessage:ue.additionalInfo?`${ue.message}. ${ue.additionalInfo}`:ue.message,offset:ue.offset,length:ue.lexeme.length})):[]))}e.$Mi=s;function n(_,z){const V=_?_.substituteConstants():void 0,ue=z?z.substituteConstants():void 0;return!V&&!ue?!0:!V||!ue?!1:V.equals(ue)}e.$Ni=n;function o(_,z){return _.cmp(z)}class w{static{this.INSTANCE=new w}constructor(){this.type=0}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!1}serialize(){return"false"}keys(){return[]}map(z){return this}negate(){return d.INSTANCE}}e.$Oi=w;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(z){return this.type-z.type}equals(z){return z.type===this.type}substituteConstants(){return this}evaluate(z){return!0}serialize(){return"true"}keys(){return[]}map(z){return this}negate(){return w.INSTANCE}}e.$Pi=d;class I{static create(z,V=null){const ue=k.get(z);return typeof ue=="boolean"?ue?d.INSTANCE:w.INSTANCE:new I(z,V)}constructor(z,V){this.key=z,this.c=V,this.type=2}cmp(z){return z.type!==this.type?this.type-z.type:ge(this.key,z.key)}equals(z){return z.type===this.type?this.key===z.key:!1}substituteConstants(){const z=k.get(this.key);return typeof z=="boolean"?z?d.INSTANCE:w.INSTANCE:this}evaluate(z){return!!z.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(z){return z.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$Qi=I;class S{static create(z,V,ue=null){if(typeof V=="boolean")return V?I.create(z,ue):P.create(z,ue);const ye=k.get(z);return typeof ye=="boolean"?V===(ye?"true":"false")?d.INSTANCE:w.INSTANCE:new S(z,V,ue)}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=4}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=k.get(this.c);if(typeof z=="boolean"){const V=z?"true":"false";return this.d===V?d.INSTANCE:w.INSTANCE}return this}evaluate(z){return z.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(z){return z.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.$Ri=S;class u{static create(z,V){return new u(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=10,this.c=null}cmp(z){return z.type!==this.type?this.type-z.type:me(this.d,this.f,z.d,z.f)}equals(z){return z.type===this.type?this.d===z.d&&this.f===z.f:!1}substituteConstants(){return this}evaluate(z){const V=z.getValue(this.f),ue=z.getValue(this.d);return Array.isArray(V)?V.includes(ue):typeof ue=="string"&&typeof V=="object"&&V!==null?R.call(V,ue):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(z){return z.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$Si=u;class g{static create(z,V){return new g(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=11,this.c=u.create(z,V)}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(z){return z.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ti=g;class h{static create(z,V,ue=null){if(typeof V=="boolean")return V?P.create(z,ue):I.create(z,ue);const ye=k.get(z);return typeof ye=="boolean"?V===(ye?"true":"false")?w.INSTANCE:d.INSTANCE:new h(z,V,ue)}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=5}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){const z=k.get(this.c);if(typeof z=="boolean"){const V=z?"true":"false";return this.d===V?w.INSTANCE:d.INSTANCE}return this}evaluate(z){return z.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(z){return z.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Ui=h;class P{static create(z,V=null){const ue=k.get(z);return typeof ue=="boolean"?ue?w.INSTANCE:d.INSTANCE:new P(z,V)}constructor(z,V){this.c=z,this.d=V,this.type=3}cmp(z){return z.type!==this.type?this.type-z.type:ge(this.c,z.c)}equals(z){return z.type===this.type?this.c===z.c:!1}substituteConstants(){const z=k.get(this.c);return typeof z=="boolean"?z?w.INSTANCE:d.INSTANCE:this}evaluate(z){return!z.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(z){return z.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Vi=P;function W(_,z){if(typeof _=="string"){const V=parseFloat(_);isNaN(V)||(_=V)}return typeof _=="string"||typeof _=="number"?z(_):w.INSTANCE}class K{static create(z,V,ue=null){return W(V,ye=>new K(z,ye,ue))}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=12}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Wi=K;class j{static create(z,V,ue=null){return W(V,ye=>new j(z,ye,ue))}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=13}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(z){return z.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Xi=j;class B{static create(z,V,ue=null){return W(V,ye=>new B(z,ye,ue))}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=14}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Yi=B;class O{static create(z,V,ue=null){return W(V,ye=>new O(z,ye,ue))}constructor(z,V,ue){this.c=z,this.d=V,this.f=ue,this.type=15}cmp(z){return z.type!==this.type?this.type-z.type:me(this.c,this.d,z.c,z.d)}equals(z){return z.type===this.type?this.c===z.c&&this.d===z.d:!1}substituteConstants(){return this}evaluate(z){return typeof this.d=="string"?!1:parseFloat(z.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(z){return z.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Zi=O;class N{static create(z,V){return new N(z,V)}constructor(z,V){this.d=z,this.f=V,this.type=7,this.c=null}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.d<z.d)return-1;if(this.d>z.d)return 1;const V=this.f?this.f.source:"",ue=z.f?z.f.source:"";return V<ue?-1:V>ue?1:0}equals(z){if(z.type===this.type){const V=this.f?this.f.source:"",ue=z.f?z.f.source:"";return this.d===z.d&&V===ue}return!1}substituteConstants(){return this}evaluate(z){const V=z.getValue(this.d);return this.f?this.f.test(V):!1}serialize(){const z=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${z}`}keys(){return[this.d]}map(z){return z.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=te.create(this)),this.c}}e.$1i=N;class te{static create(z){return new te(z)}constructor(z){this.c=z,this.type=8}cmp(z){return z.type!==this.type?this.type-z.type:this.c.cmp(z.c)}equals(z){return z.type===this.type?this.c.equals(z.c):!1}substituteConstants(){return this}evaluate(z){return!this.c.evaluate(z)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(z){return new te(this.c.map(z))}negate(){return this.c}}e.$2i=te;function Y(_){let z=null;for(let V=0,ue=_.length;V<ue;V++){const ye=_[V].substituteConstants();if(_[V]!==ye&&z===null){z=[];for(let be=0;be<V;be++)z[be]=_[be]}z!==null&&(z[V]=ye)}return z===null?_:z}class Ee{static create(z,V,ue){return Ee.d(z,V,ue)}constructor(z,V){this.expr=z,this.c=V,this.type=6}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let V=0,ue=this.expr.length;V<ue;V++){const ye=o(this.expr[V],z.expr[V]);if(ye!==0)return ye}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let V=0,ue=this.expr.length;V<ue;V++)if(!this.expr[V].equals(z.expr[V]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:Ee.create(z,this.c,!1)}evaluate(z){for(let V=0,ue=this.expr.length;V<ue;V++)if(!this.expr[V].evaluate(z))return!1;return!0}static d(z,V,ue){const ye=[];let be=!1;for(const pe of z)if(pe){if(pe.type===1){be=!0;continue}if(pe.type===0)return w.INSTANCE;if(pe.type===6){ye.push(...pe.expr);continue}ye.push(pe)}if(ye.length===0&&be)return d.INSTANCE;if(ye.length!==0){if(ye.length===1)return ye[0];ye.sort(o);for(let pe=1;pe<ye.length;pe++)ye[pe-1].equals(ye[pe])&&(ye.splice(pe,1),pe--);if(ye.length===1)return ye[0];for(;ye.length>1;){const pe=ye[ye.length-1];if(pe.type!==9)break;ye.pop();const De=ye.pop(),ne=ye.length===0,le=Se.create(pe.expr.map(re=>Ee.create([re,De],null,ue)),null,ne);le&&(ye.push(le),ye.sort(o))}if(ye.length===1)return ye[0];if(ue){for(let pe=0;pe<ye.length;pe++)for(let De=pe+1;De<ye.length;De++)if(ye[pe].negate().equals(ye[De]))return w.INSTANCE;if(ye.length===1)return ye[0]}return new Ee(ye,V)}}serialize(){return this.expr.map(z=>z.serialize()).join(" && ")}keys(){const z=[];for(const V of this.expr)z.push(...V.keys());return z}map(z){return new Ee(this.expr.map(V=>V.map(z)),null)}negate(){if(!this.c){const z=[];for(const V of this.expr)z.push(V.negate());this.c=Se.create(z,this,!0)}return this.c}}e.$3i=Ee;class Se{static create(z,V,ue){return Se.d(z,V,ue)}constructor(z,V){this.expr=z,this.c=V,this.type=9}cmp(z){if(z.type!==this.type)return this.type-z.type;if(this.expr.length<z.expr.length)return-1;if(this.expr.length>z.expr.length)return 1;for(let V=0,ue=this.expr.length;V<ue;V++){const ye=o(this.expr[V],z.expr[V]);if(ye!==0)return ye}return 0}equals(z){if(z.type===this.type){if(this.expr.length!==z.expr.length)return!1;for(let V=0,ue=this.expr.length;V<ue;V++)if(!this.expr[V].equals(z.expr[V]))return!1;return!0}return!1}substituteConstants(){const z=Y(this.expr);return z===this.expr?this:Se.create(z,this.c,!1)}evaluate(z){for(let V=0,ue=this.expr.length;V<ue;V++)if(this.expr[V].evaluate(z))return!0;return!1}static d(z,V,ue){let ye=[],be=!1;if(z){for(let pe=0,De=z.length;pe<De;pe++){const ne=z[pe];if(ne){if(ne.type===0){be=!0;continue}if(ne.type===1)return d.INSTANCE;if(ne.type===9){ye=ye.concat(ne.expr);continue}ye.push(ne)}}if(ye.length===0&&be)return w.INSTANCE;ye.sort(o)}if(ye.length!==0){if(ye.length===1)return ye[0];for(let pe=1;pe<ye.length;pe++)ye[pe-1].equals(ye[pe])&&(ye.splice(pe,1),pe--);if(ye.length===1)return ye[0];if(ue){for(let pe=0;pe<ye.length;pe++)for(let De=pe+1;De<ye.length;De++)if(ye[pe].negate().equals(ye[De]))return d.INSTANCE;if(ye.length===1)return ye[0]}return new Se(ye,V)}}serialize(){return this.expr.map(z=>z.serialize()).join(" || ")}keys(){const z=[];for(const V of this.expr)z.push(...V.keys());return z}map(z){return new Se(this.expr.map(V=>V.map(z)),null)}negate(){if(!this.c){const z=[];for(const V of this.expr)z.push(V.negate());for(;z.length>1;){const V=z.shift(),ue=z.shift(),ye=[];for(const be of $e(V))for(const pe of $e(ue))ye.push(Ee.create([be,pe],null,!1));z.unshift(Se.create(ye,null,!1))}this.c=Se.create(z,this,!0)}return this.c}}e.$4i=Se;class Pe extends I{static{this.d=[]}static all(){return Pe.d.values()}constructor(z,V,ue){super(z,null),this.f=V,typeof ue=="object"?Pe.d.push({...ue,key:z}):ue!==!0&&Pe.d.push({key:z,description:ue,type:V!=null?typeof V:void 0})}bindTo(z){return z.createKey(this.key,this.f)}getValue(z){return z.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(z){return S.create(this.key,z)}notEqualsTo(z){return h.create(this.key,z)}}e.$5i=Pe,e.$6i=(0,L.$Nh)("contextKeyService");function ge(_,z){return _<z?-1:_>z?1:0}function me(_,z,V,ue){return _<V?-1:_>V?1:z<ue?-1:z>ue?1:0}function ce(_,z){if(_.type===0||z.type===1)return!0;if(_.type===9)return z.type===9?se(_.expr,z.expr):!1;if(z.type===9){for(const V of z.expr)if(ce(_,V))return!0;return!1}if(_.type===6){if(z.type===6)return se(z.expr,_.expr);for(const V of _.expr)if(ce(V,z))return!0;return!1}return _.equals(z)}e.$7i=ce;function se(_,z){let V=0,ue=0;for(;V<_.length&&ue<z.length;){const ye=_[V].cmp(z[ue]);if(ye<0)return!1;ye===0&&V++,ue++}return V===_.length}function $e(_){return _.type===9?_.expr:[_]}}),define(Re[171],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=void 0,e.$Uh=(0,y.$Nh)("environmentService"),e.$Vh=(0,y.$Oh)(e.$Uh)}),define(Re[92],Me([1,0,140,4]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$7n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=void 0,e.$Tn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Un=new RegExp(e.$Tn),e.$Vn="__web_extension",e.$Wn="skipWalkthrough",e.$Xn="extensionsSync",e.$Yn="dependecyOrPackExtensionInstall";function C(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Zn=C;function L(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$1n=L;function A(a,b){switch(a){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$2n=A;function l(a,b){return b==="web"&&!a.includes("web")}e.$3n=l;function k(a,b,E){return l(b,E)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===E?!0:f(E).includes(a)}e.$4n=k;function f(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$5n=f;function R(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$6n=R;var D;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var c;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var p;(function(a){a.Install="install",a.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var $;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$7n=(0,M.$Nh)("extensionGalleryService");var m;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var t;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(b,E){super(b),this.code=E,this.name=E}}e.$8n=i,e.$9n=(0,M.$Nh)("extensionManagementService"),e.$0n="extensionsIdentifiers/disabled",e.$$n="extensionsIdentifiers/enabled",e.$_n=(0,M.$Nh)("IGlobalExtensionEnablementService"),e.$ao=(0,M.$Nh)("IExtensionTipsService"),e.$bo=(0,y.localize)(0,null),e.$co={value:e.$bo,original:"Extensions"},e.$do={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Re[38],Me([1,0,49,19,15,16,2,142,4,22,13,40]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileKind=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileOperationResult=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileChangeType=e.$ok=e.FileOperation=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.FileSystemProviderErrorCode=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.FileSystemProviderCapabilities=e.$$j=e.FilePermission=e.FileType=e.$0j=e.$9j=void 0,e.$9j=(0,k.$Nh)("fileService");function c(ce){return ce.create===!0}e.$0j=c;var p;(function(ce){ce[ce.Unknown=0]="Unknown",ce[ce.File=1]="File",ce[ce.Directory=2]="Directory",ce[ce.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var $;(function(ce){ce[ce.Readonly=1]="Readonly",ce[ce.Locked=2]="Locked"})($||(e.FilePermission=$={}));function m(ce){const se=ce;return!!se&&typeof se.onDidChange=="function"}e.$$j=m;var t;(function(ce){ce[ce.None=0]="None",ce[ce.FileReadWrite=2]="FileReadWrite",ce[ce.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ce[ce.FileReadStream=16]="FileReadStream",ce[ce.FileFolderCopy=8]="FileFolderCopy",ce[ce.PathCaseSensitive=1024]="PathCaseSensitive",ce[ce.Readonly=2048]="Readonly",ce[ce.Trash=4096]="Trash",ce[ce.FileWriteUnlock=8192]="FileWriteUnlock",ce[ce.FileAtomicRead=16384]="FileAtomicRead",ce[ce.FileAtomicWrite=32768]="FileAtomicWrite",ce[ce.FileAtomicDelete=65536]="FileAtomicDelete",ce[ce.FileClone=131072]="FileClone"})(t||(e.FileSystemProviderCapabilities=t={}));function i(ce){return!!(ce.capabilities&2)}e.$_j=i;function a(ce){return!!(ce.capabilities&8)}e.$ak=a;function b(ce){return!!(ce.capabilities&131072)}e.$bk=b;function E(ce){return!!(ce.capabilities&4)}e.$ck=E;function v(ce){return!!(ce.capabilities&16)}e.$dk=v;function r(ce){return i(ce)?!!(ce.capabilities&16384):!1}e.$ek=r;function s(ce){return i(ce)?!!(ce.capabilities&32768):!1}e.$fk=s;function n(ce){return!!(ce.capabilities&65536)}e.$gk=n;function o(ce){return!!(ce.capabilities&2048)}e.$hk=o;var w;(function(ce){ce.FileExists="EntryExists",ce.FileNotFound="EntryNotFound",ce.FileNotADirectory="EntryNotADirectory",ce.FileIsADirectory="EntryIsADirectory",ce.FileExceedsStorageQuota="EntryExceedsStorageQuota",ce.FileTooLarge="EntryTooLarge",ce.FileWriteLocked="EntryWriteLocked",ce.NoPermissions="NoPermissions",ce.Unavailable="Unavailable",ce.Unknown="Unknown"})(w||(e.FileSystemProviderErrorCode=w={}));class d extends Error{static create(se,$e){const _=new d(se.toString(),$e);return u(_,$e),_}constructor(se,$e){super(se),this.code=$e}}e.$ik=d;function I(ce,se){return d.create(ce,se)}e.$jk=I;function S(ce){return ce||I((0,l.localize)(0,null),w.Unknown)}e.$kk=S;function u(ce,se){return ce.name=se?`${se} (FileSystemError)`:"FileSystemError",ce}e.$lk=u;function g(ce){if(!ce)return w.Unknown;if(ce instanceof d)return ce.code;const se=/^(.+) \(FileSystemError\)$/.exec(ce.name);if(!se)return w.Unknown;switch(se[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.$mk=g;function h(ce){if(ce instanceof O)return ce.fileOperationResult;switch(g(ce)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 9;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileTooLarge:return 7;default:return 10}}e.$nk=h;var P;(function(ce){ce[ce.CREATE=0]="CREATE",ce[ce.DELETE=1]="DELETE",ce[ce.MOVE=2]="MOVE",ce[ce.COPY=3]="COPY",ce[ce.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class W{constructor(se,$e,_){this.resource=se,this.operation=$e,this.target=_}isOperation(se){return this.operation===se}}e.$ok=W;var K;(function(ce){ce[ce.UPDATED=0]="UPDATED",ce[ce.ADDED=1]="ADDED",ce[ce.DELETED=2]="DELETED"})(K||(e.FileChangeType=K={}));class j{static{this.a=null}constructor(se,$e){this.c=$e,this.b=void 0,this.d=new D.$U(()=>{const _=y.$Th.forUris(()=>this.c);return _.fill(this.rawAdded.map(z=>[z,!0])),_}),this.f=new D.$U(()=>{const _=y.$Th.forUris(()=>this.c);return _.fill(this.rawUpdated.map(z=>[z,!0])),_}),this.g=new D.$U(()=>{const _=y.$Th.forUris(()=>this.c);return _.fill(this.rawDeleted.map(z=>[z,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of se){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==j.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(se,...$e){return this.h(se,{includeChildren:!1},...$e)}affects(se,...$e){return this.h(se,{includeChildren:!0},...$e)}h(se,$e,..._){if(!se)return!1;const z=_.length>0;return!!((!z||_.includes(1))&&(this.d.value.get(se)||$e.includeChildren&&this.d.value.findSuperstr(se))||(!z||_.includes(0))&&(this.f.value.get(se)||$e.includeChildren&&this.f.value.findSuperstr(se))||(!z||_.includes(2))&&(this.g.value.findSubstr(se)||$e.includeChildren&&this.g.value.findSuperstr(se)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(se){return this.b===se}hasCorrelation(){return typeof this.b=="number"}}e.$pk=j;function B(ce,se,$e){return!ce||!se||ce===se||se.length>ce.length?!1:(se.charAt(se.length-1)!==M.sep&&(se+=M.sep),$e?(0,C.$2e)(ce,se):ce.indexOf(se)===0)}e.$qk=B;class O extends Error{constructor(se,$e,_){super(se),this.fileOperationResult=$e,this.options=_}}e.$rk=O;class N extends O{constructor(se,$e,_,z){super(se,$e,z),this.fileOperationResult=$e,this.size=_}}e.$sk=N;class te extends O{constructor(se,$e,_){super(se,2,_),this.stat=$e}}e.$tk=te;var Y;(function(ce){ce[ce.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ce[ce.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ce[ce.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ce[ce.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ce[ce.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ce[ce.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ce[ce.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ce[ce.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ce[ce.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ce[ce.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ce[ce.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$uk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$vk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$wk="files.associations",e.$xk="files.exclude",e.$yk="files.readonlyInclude",e.$zk="files.readonlyExclude",e.$Ak="files.readonlyFromPermissions";var Ee;(function(ce){ce[ce.FILE=0]="FILE",ce[ce.FOLDER=1]="FOLDER",ce[ce.ROOT_FOLDER=2]="ROOT_FOLDER"})(Ee||(e.FileKind=Ee={})),e.$Bk="";function Se(ce){if(!(typeof ce.size!="number"||typeof ce.mtime!="number"))return ce.mtime.toString(29)+ce.size.toString(31)}e.$Ck=Se;async function Pe(ce,se){if(!se.hasProvider(A.URI.from({scheme:ce.scheme})))return new Promise($e=>{const _=se.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===ce.scheme&&z.added&&(_.dispose(),$e())})})}e.$Dk=Pe;class ge{static{this.KB=1024}static{this.MB=ge.KB*ge.KB}static{this.GB=ge.MB*ge.KB}static{this.TB=ge.GB*ge.KB}static formatSize(se){return(0,L.$Bf)(se)||(se=0),se<ge.KB?(0,l.localize)(1,null,se.toFixed(0)):se<ge.MB?(0,l.localize)(2,null,(se/ge.KB).toFixed(2)):se<ge.GB?(0,l.localize)(3,null,(se/ge.MB).toFixed(2)):se<ge.TB?(0,l.localize)(4,null,(se/ge.GB).toFixed(2)):(0,l.localize)(5,null,(se/ge.TB).toFixed(2))}}e.$Ek=ge;function me(ce){const se=typeof ce=="string"||ce?.scheme===R.Schemas.vscodeRemote;return typeof ce!="string"&&ce?.scheme===R.Schemas.file?1024*ge.MB:se?10*ge.MB:f.$p?50*ge.MB:1024*ge.MB}e.$Fk=me}),define(Re[70],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lh=void 0;class y{constructor(...C){this.a=new Map;for(const[L,A]of C)this.set(L,A)}set(C,L){const A=this.a.get(C);return this.a.set(C,L),A}has(C){return this.a.has(C)}get(C){return this.a.get(C)}}e.$Lh=y}),define(Re[172],Me([1,0,12,9,6,68,170,4,70,173]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=void 0;const R=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new k.$Lh,i=!1,a,b=R){this.f=t,this.g=i,this.h=a,this.i=b,this.o=new Set,this.f.set(l.$Mh,this),this._globalGraph=b?a?._globalGraph??new A.$_p(E=>E):void 0}createChild(t){return new c(t,this.g,this,this.i)}invokeFunction(t,...i){const a=$.traceInvocation(this.i,t);let b=!1;try{return t({get:v=>{if(b)throw(0,M.$7)("service accessor is only valid during the invocation of its target method");const r=this.m(v,a);if(!r)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...i)}finally{b=!0,a.stop()}}createInstance(t,...i){let a,b;return t instanceof L.$Kh?(a=$.traceCreation(this.i,t.ctor),b=this.j(t.ctor,t.staticArguments.concat(i),a)):(a=$.traceCreation(this.i,t),b=this.j(t,i,a)),a.stop(),b}j(t,i=[],a){const b=l._util.getServiceDependencies(t).sort((r,s)=>r.index-s.index),E=[];for(const r of b){const s=this.m(r.id,a);s||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),E.push(s)}const v=b.length>0?b[0].index:i.length;if(i.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${i.length} static arguments`);const r=v-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,v)}return Reflect.construct(t,i.concat(E))}k(t,i){if(this.f.get(t)instanceof L.$Kh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const a=this.l(t);return a instanceof L.$Kh?this.q(t,a,i.branch(t,!0)):(i.branch(t,!1),a)}q(t,i,a){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,a)}finally{this.o.delete(t)}}r(t,i,a){const b=new A.$_p(r=>r.id.toString());let E=0;const v=[{id:t,desc:i,_trace:a}];for(;v.length;){const r=v.pop();if(b.lookupOrInsertNode(r),E++>1e3)throw new D(b);for(const s of l._util.getServiceDependencies(r.desc.ctor)){const n=this.l(s.id);if(n||this.u(`[createInstance] ${t} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(s.id)),n instanceof L.$Kh){const o={id:s.id,desc:n,_trace:r._trace.branch(s.id,!0)};b.insertEdge(r,o),v.push(o)}}}for(;;){const r=b.roots();if(r.length===0){if(!b.isEmpty())throw new D(b);break}for(const{data:s}of r){if(this.l(s.id)instanceof L.$Kh){const o=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,o)}b.removeNode(s)}}return this.l(t)}s(t,i,a=[],b,E){if(this.f.get(t)instanceof L.$Kh)return this.t(t,i,a,b,E);if(this.h)return this.h.s(t,i,a,b,E);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,a=[],b,E){if(b){const v=new c(void 0,this.g,this,this.i);v.c=String(t);const r=new Map,s=new y.$0g(()=>{const n=v.j(i,a,E);for(const[o,w]of r){const d=n[o];if(typeof d=="function")for(const I of w)d.apply(n,I)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let I=r.get(o);return I||(I=new f.$1c,r.set(o,I)),(u,g,h)=>{const P=I.push([u,g,h]);return(0,C.$Pc)(P)}}if(o in n)return n[o];const w=s.value;let d=w[o];return typeof d!="function"||(d=d.bind(w),n[o]=d),d},set(n,o,w){return s.value[o]=w,!0},getPrototypeOf(n){return i.prototype}})}else return this.j(i,a,E)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$aq=c;var p;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(p||(p={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new $(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(t,i){return t?new $(1,i.name):$.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const a=new $(3,t.toString());return this.h.push([t,i,a]),a}stop(){const t=Date.now()-this.g;$.f+=t;let i=!1;function a(E,v){const r=[],s=new Array(E+1).join("	");for(const[n,o,w]of v.h)if(o&&w){i=!0,r.push(`${s}CREATES -> ${n}`);const d=a(E+1,w);d&&r.push(d)}else r.push(`${s}uses -> ${n}`);return r.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(t>2||i)&&$.all.add(b.join(`
`))}}e.$bq=$}),define(Re[14],Me([1,0,42,5,93,6,28,22,23,16,2,32,4]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.log=e.$$i=e.LogLevel=e.$0i=e.$9i=e.$8i=void 0,e.$8i=(0,c.$Nh)("logService"),e.$9i=(0,c.$Nh)("loggerService");function p(){return new Date().toISOString()}function $(u){return(0,f.$Bf)(u)}e.$0i=$;var m;(function(u){u[u.Off=0]="Off",u[u.Trace=1]="Trace",u[u.Debug=2]="Debug",u[u.Info=3]="Info",u[u.Warning=4]="Warning",u[u.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$$i=m.Info;function t(u,g,h){switch(g){case m.Trace:u.trace(h);break;case m.Debug:u.debug(h);break;case m.Info:u.info(h);break;case m.Warning:u.warn(h);break;case m.Error:u.error(h);break;case m.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=t;function i(u,g=!1){let h="";for(let P=0;P<u.length;P++){let W=u[P];if(W instanceof Error&&(W=(0,y.$yi)(W,g)),typeof W=="object")try{W=JSON.stringify(W)}catch{}h+=(P>0?" ":"")+W}return h}class a extends L.$Rc{constructor(){super(...arguments),this.b=e.$$i,this.c=this.B(new M.$Md),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==m.Off&&this.b<=g}}e.$aj=a;class b extends a{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...h){this.f(m.Trace)&&this.g(m.Trace,i([g,...h],!0))}debug(g,...h){this.f(m.Debug)&&this.g(m.Debug,i([g,...h]))}info(g,...h){this.f(m.Info)&&this.g(m.Info,i([g,...h]))}warn(g,...h){this.f(m.Warning)&&this.g(m.Warning,i([g,...h]))}error(g,...h){if(this.f(m.Error))if(g instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=g.stack,this.g(m.Error,i(P))}else this.g(m.Error,i([g,...h]))}flush(){}}e.$bj=b;class E extends a{constructor(g=e.$$i){super(),this.setLevel(g),this.g=!l.$j}trace(g,...h){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,g,...h):console.log(`[main ${p()}]`,g,...h))}debug(g,...h){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,g,...h):console.log(`[main ${p()}]`,g,...h))}info(g,...h){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,g,...h):console.log(`[main ${p()}]`,g,...h))}warn(g,...h){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,g,...h):console.warn(`[main ${p()}]`,g,...h))}error(g,...h){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,g,...h):console.error(`[main ${p()}]`,g,...h))}dispose(){}flush(){}}e.$cj=E;class v extends a{constructor(g=e.$$i,h=!0){super(),this.g=h,this.setLevel(g)}trace(g,...h){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...h):console.log(g,...h))}debug(g,...h){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...h):console.log(g,...h))}info(g,...h){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...h):console.log(g,...h))}warn(g,...h){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...h):console.log(g,...h))}error(g,...h){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...h):console.error(g,...h))}dispose(){}flush(){}}e.$dj=v;class r extends a{constructor(g,h=e.$$i){super(),this.g=g,this.setLevel(h)}trace(g,...h){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(g),...h])}debug(g,...h){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(g),...h])}info(g,...h){this.f(m.Info)&&this.g.log(m.Info,[this.h(g),...h])}warn(g,...h){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(g),...h])}error(g,...h){this.f(m.Error)&&this.g.log(m.Error,[this.h(g),...h])}h(g){return typeof g=="string"?g:(0,y.$yi)(g,this.f(m.Trace))}dispose(){}flush(){}}e.$ej=r;class s extends a{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const h of this.g)h.setLevel(g);super.setLevel(g)}trace(g,...h){for(const P of this.g)P.trace(g,...h)}debug(g,...h){for(const P of this.g)P.debug(g,...h)}info(g,...h){for(const P of this.g)P.info(g,...h)}warn(g,...h){for(const P of this.g)P.warn(g,...h)}error(g,...h){for(const P of this.g)P.error(g,...h)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose()}}e.$fj=s;class n extends L.$Rc{constructor(g,h,P){if(super(),this.h=g,this.j=h,this.b=new A.$zc,this.c=this.B(new M.$Md),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Md),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Md),this.onDidChangeVisibility=this.g.event,P)for(const W of P)this.b.set(W.resource,{logger:void 0,info:W})}m(g){return(0,f.$xf)(g)?[...this.b.values()].find(h=>h.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,h){const P=this.n(g),W=(0,f.$xf)(g)?g:h?.id??(0,C.$Bi)(P.toString()).toString(16);let K=this.b.get(P)?.logger;const j=h?.logLevel==="always"?m.Trace:h?.logLevel;K||(K=this.s(P,j??this.getLogLevel(P)??this.h,{...h,id:W}));const B={logger:K,info:{resource:P,id:W,logLevel:j,name:h?.name,hidden:h?.hidden,extensionId:h?.extensionId,when:h?.when}};return this.registerLogger(B.info),this.b.set(P,B),K}n(g){return(0,f.$xf)(g)?(0,k.$ug)(this.j,`${g}.log`):g}setLogLevel(g,h){if(R.URI.isUri(g)){const P=g,W=h,K=this.b.get(P);K&&W!==K.info.logLevel&&(K.info.logLevel=W===this.h?void 0:W,K.logger?.setLevel(W),this.b.set(K.info.resource,K),this.f.fire([P,W]))}else{this.h=g;for(const[P,W]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,h){const P=this.m(g);P&&h!==!P.info.hidden&&(P.info.hidden=!h,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,h]))}getLogLevel(g){let h;return g&&(h=this.b.get(g)?.info.logLevel),h??this.h}registerLogger(g){const h=this.b.get(g.resource);h?h.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const h=this.b.get(g);h&&(h.logger&&h.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[h.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$gj=n;class o{constructor(){this.onDidChangeLogLevel=new M.$Md().event}setLevel(g){}getLevel(){return m.Info}trace(g,...h){}debug(g,...h){}info(g,...h){}warn(g,...h){}error(g,...h){}critical(g,...h){}dispose(){}flush(){}}e.$hj=o;class w extends o{}e.$ij=w;function d(u){if(u.verbose)return m.Trace;if(typeof u.logLevel=="string"){const g=S(u.logLevel.toLowerCase());if(g!==void 0)return g}return e.$$i}e.$jj=d;function I(u){switch(u){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$kj=I;function S(u){switch(u){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$lj=S,e.$mj=new D.$5i("logLevel",I(m.Info))}),define(Re[174],Me([1,0,6,14]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=void 0;class C extends y.$Rc{constructor(A,l=[]){super(),this.a=new M.$fj([A,...l]),this.B(A.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...l){this.a.trace(A,...l)}debug(A,...l){this.a.debug(A,...l)}info(A,...l){this.a.info(A,...l)}warn(A,...l){this.a.warn(A,...l)}error(A,...l){this.a.error(A,...l)}flush(){this.a.flush()}}e.$yN=C}),define(Re[94],Me([1,0,29,143,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(k){function f($,m){return m-$}k.compare=f;const R=Object.create(null);R[k.Error]=(0,M.localize)(0,null),R[k.Warning]=(0,M.localize)(1,null),R[k.Info]=(0,M.localize)(2,null);function D($){return R[$]||""}k.toString=D;function c($){switch($){case y.default.Error:return k.Error;case y.default.Warning:return k.Warning;case y.default.Info:return k.Info;case y.default.Ignore:return k.Hint}}k.fromSeverity=c;function p($){switch($){case k.Error:return y.default.Error;case k.Warning:return y.default.Warning;case k.Info:return y.default.Info;case k.Hint:return y.default.Ignore}}k.toSeverity=p}(A||(e.MarkerSeverity=A={}));var l;(function(k){const f="";function R(c){return D(c,!0)}k.makeKey=R;function D(c,p){const $=[f];return c.source?$.push(c.source.replace("\xA6","\\\xA6")):$.push(f),c.code?typeof c.code=="string"?$.push(c.code.replace("\xA6","\\\xA6")):$.push(c.code.value.replace("\xA6","\\\xA6")):$.push(f),c.severity!==void 0&&c.severity!==null?$.push(A.toString(c.severity)):$.push(f),c.message&&p?$.push(c.message.replace("\xA6","\\\xA6")):$.push(f),c.startLineNumber!==void 0&&c.startLineNumber!==null?$.push(c.startLineNumber.toString()):$.push(f),c.startColumn!==void 0&&c.startColumn!==null?$.push(c.startColumn.toString()):$.push(f),c.endLineNumber!==void 0&&c.endLineNumber!==null?$.push(c.endLineNumber.toString()):$.push(f),c.endColumn!==void 0&&c.endColumn!==null?$.push(c.endColumn.toString()):$.push(f),$.push(f),$.join("\xA6")}k.makeKeyOptionalMessage=D})(l||(e.IMarkerData=l={})),e.$8s=(0,C.$Nh)("markerService")}),define(Re[175],Me([1,0,5,29,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Vu=e.Severity=void 0,e.Severity=M.default,e.$Vu=(0,C.$Nh)("notificationService");var L;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var l;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(l||(e.NotificationsFilter=l={}));class k{constructor(){this.progress=new f,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$Wu=k;class f{infinite(){}done(){}total(D){}worked(D){}}e.$Xu=f}),define(Re[95],Me([1,0,15,2,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aU=e.$_T=e.$$T=e.$0T=e.$9T=void 0,e.$9T=(0,C.$Nh)("openerService");function L(f,R){return M.URI.isUri(f)?(0,y.$1e)(f.scheme,R):(0,y.$2e)(f,R+":")}e.$0T=L;function A(f,...R){return R.some(D=>L(f,D))}e.$$T=A;function l(f,R){return f.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$_T=l;function k(f){let R;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return D&&(R={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},f=f.with({fragment:""})),{selection:R,uri:f}}e.$aU=k}),define(Re[176],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=void 0,e.$nj=(0,y.$Nh)("productService"),e.$oj="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function(we,e,y,M){var C=arguments.length,L=C<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,y):M,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(we,e,y,M);else for(var l=we.length-1;l>=0;l--)(A=we[l])&&(L=(C<3?A(L):C>3?A(e,y,L):A(e,y))||L);return C>3&&L&&Object.defineProperty(e,y,L),L},We=this&&this.__param||function(we,e){return function(y,M){e(y,M,we)}};define(Re[71],Me([1,0,12,21,6,4]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.ProgressLocation=e.$Yu=void 0,e.$Yu=(0,L.$Nh)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Zu=Object.freeze({total(){},worked(){},done(){}});class l{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(D,c){this.e=D,this.report=c?.async?this.g.bind(this):this.f.bind(this)}f(D){this.a=D,this.e(this.a)}g(D){this.b?this.b.push(D):this.b=[D],this.h()}async h(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const D=this.b.shift();this.a=D,await this.e(this.a)}}finally{this.c=!1;const D=this.d;this.d=void 0,D?.()}}drain(){return this.c?new Promise(D=>{const c=this.d;this.d=()=>{c?.(),D()}}):Promise.resolve()}}e.$1u=l;let k=class extends C.$Rc{constructor(D,c){super(),this.a=new y.$bh,c.withProgress(D,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,C.$Pc)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$2u=k,e.$2u=k=qe([We(1,e.$Yu)],k);class f extends C.$Rc{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new C.$Qc)}start(D){this.stop();const c=++this.a,p=new M.$Wd;return this.f=setTimeout(()=>{c===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,C.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,C.$Pc)(()=>p.cancel())),this.b.add((0,C.$Pc)(()=>this.c?this.c.done():void 0)),{id:c,token:p.token,stop:()=>this.h(c),isCurrent:()=>this.a===c}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$3u=f,e.$4u=(0,L.$Nh)("editorProgressService")}),define(Re[30],Me([1,0,51,16]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0;class C{constructor(){this.a=new Map}add(A,l){y.ok(M.$xf(A)),y.ok(M.$zf(l)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,l)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$cn=new C}),define(Re[72],Me([1,0,5,30]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=void 0,e.$dn={JSONContribution:"base.contributions.json"};function C(l){return l.length>0&&l.charAt(l.length-1)==="#"?l.substring(0,l.length-1):l}class L{constructor(){this.b=new y.$Md,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,f){this.a[C(k)]=f,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;M.$cn.add(e.$dn.JSONContribution,A)}),define(Re[96],Me([1,0,18,5,16,137,44,72,30]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.ConfigurationScope=e.$hn=e.EditPresentationTypes=void 0;var f;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$hn={Configuration:"base.contributions.configuration"};var R;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$in={properties:{},patternProperties:{}},e.$jn={properties:{},patternProperties:{}},e.$kn={properties:{},patternProperties:{}},e.$ln={properties:{},patternProperties:{}},e.$mn={properties:{},patternProperties:{}},e.$nn={properties:{},patternProperties:{}},e.$on="vscode://schemas/settings/resourceLanguage",e.$pn="vscode://schemas/settings/configurationDefaults";const D=k.$cn.as(l.$dn.JSONContribution);class c{constructor(){this.h=new Set,this.i=new M.$Md,this.onDidSchemaChange=this.i.event,this.j=new M.$Md,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$on,this.g),this.v()}registerConfiguration(r,s=!0){this.registerConfigurations([r],s)}registerConfigurations(r,s=!0){const n=new Set;this.n(r,s,n),D.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(r){const s=new Set;this.o(r,s),D.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:r,remove:s}){const n=new Set;this.o(s,n),this.n(r,!1,n),D.registerSchema(e.$on,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(r){const s=new Set;this.k(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(r,s){const n=[];for(const{overrides:o,source:w}of r)for(const d in o)if(s.add(d),e.$rn.test(d)){const I=this.a.get(d),S=I?.valuesSources??new Map;if(w)for(const P of Object.keys(o[d]))S.set(P,w);const u={...I?.value||{},...o[d]};this.a.set(d,{source:w,value:u,valuesSources:S});const g=(0,A.$ri)(d),h={type:"object",default:u,description:L.localize(1,null,g),$ref:e.$on,defaultDefaultValue:u,source:C.$xf(w)?void 0:w,defaultValueSource:w};n.push(...m(d)),this.d[d]=h,this.b.properties[d]=h}else{this.a.set(d,{value:o[d],source:w});const I=this.d[d];I&&(this.w(d,I),this.r(d,I))}this.m(n)}deregisterDefaultConfigurations(r){const s=new Set;this.l(r,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(r,s){for(const{overrides:n,source:o}of r)for(const w in n){const d=this.a.get(w),I=C.$xf(o)?o:o?.id,S=C.$xf(d?.source)?d?.source:d?.source?.id;if(I===S)if(s.add(w),this.a.delete(w),e.$rn.test(w))delete this.d[w],delete this.b.properties[w];else{const u=this.d[w];u&&(this.w(w,u),this.r(w,u))}}this.u()}deltaConfiguration(r){let s=!1;const n=new Set;r.removedDefaults&&(this.l(r.removedDefaults,n),s=!0),r.addedDefaults&&(this.k(r.addedDefaults,n),s=!0),r.removedConfigurations&&this.o(r.removedConfigurations,n),r.addedConfigurations&&this.n(r.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const s of r)this.h.add(s);this.u()}n(r,s,n){r.forEach(o=>{this.p(o,s,o.extensionInfo,o.restrictedProperties,void 0,n),this.c.push(o),this.q(o)})}o(r,s){const n=o=>{if(o.properties)for(const w in o.properties){s.add(w);const d=this.d[w];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[w],this.s(w,o.properties[w])}o.allOf?.forEach(w=>n(w))};for(const o of r){n(o);const w=this.c.indexOf(o);w!==-1&&this.c.splice(w,1)}}p(r,s=!0,n,o,w=3,d){w=C.$Gf(r.scope)?w:r.scope;const I=r.properties;if(I)for(const u in I){const g=I[u];if(s&&b(u,g)){delete I[u];continue}if(g.source=n,g.defaultDefaultValue=I[u].default,this.w(u,g),e.$rn.test(u)?g.scope=void 0:(g.scope=C.$Gf(g.scope)?w:g.scope,g.restricted=C.$Gf(g.restricted)?!!o?.includes(u):g.restricted),I[u].hasOwnProperty("included")&&!I[u].included){this.f[u]=I[u],delete I[u];continue}else this.d[u]=I[u],I[u].policy?.name&&this.e.set(I[u].policy.name,u);!I[u].deprecationMessage&&I[u].markdownDeprecationMessage&&(I[u].deprecationMessage=I[u].markdownDeprecationMessage),d.add(u)}const S=r.allOf;if(S)for(const u of S)this.p(u,s,n,o,w,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const s=n=>{const o=n.properties;if(o)for(const d in o)this.r(d,o[d]);n.allOf?.forEach(s)};s(r)}r(r,s){switch(e.$in.properties[r]=s,s.scope){case 1:e.$jn.properties[r]=s;break;case 2:e.$kn.properties[r]=s;break;case 6:e.$ln.properties[r]=s;break;case 3:e.$mn.properties[r]=s;break;case 4:e.$nn.properties[r]=s;break;case 5:e.$nn.properties[r]=s,this.g.properties[r]=s;break}}s(r,s){switch(delete e.$in.properties[r],s.scope){case 1:delete e.$jn.properties[r];break;case 2:delete e.$kn.properties[r];break;case 6:delete e.$ln.properties[r];break;case 3:delete e.$mn.properties[r];break;case 4:case 5:delete e.$nn.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const s=`[${r}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$on};this.w(s,n),e.$in.properties[s]=n,e.$jn.properties[s]=n,e.$kn.properties[s]=n,e.$ln.properties[s]=n,e.$mn.properties[s]=n,e.$nn.properties[s]=n}}v(){const r={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$on};e.$in.patternProperties[e.$qn]=r,e.$jn.patternProperties[e.$qn]=r,e.$kn.patternProperties[e.$qn]=r,e.$ln.patternProperties[e.$qn]=r,e.$mn.patternProperties[e.$qn]=r,e.$nn.patternProperties[e.$qn]=r,this.i.fire()}w(r,s){const n=this.a.get(r);let o=n?.value,w=n?.source;C.$Ef(o)&&(o=s.defaultDefaultValue,w=void 0),C.$Ef(o)&&(o=i(s.type)),s.default=o,s.defaultValueSource=w}}const p="\\[([^\\]]+)\\]",$=new RegExp(p,"g");e.$qn=`^(${p})+$`,e.$rn=new RegExp(e.$qn);function m(v){const r=[];if(e.$rn.test(v)){let s=$.exec(v);for(;s?.length;){const n=s[1].trim();n&&r.push(n),s=$.exec(v)}}return(0,y.$Lb)(r)}e.$sn=m;function t(v){return v.reduce((r,s)=>`${r}[${s}]`,"")}e.$tn=t;function i(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$un=i;const a=new c;k.$cn.add(e.$hn.Configuration,a);function b(v,r){return v.trim()?e.$rn.test(v)?L.localize(7,null,v):a.getConfigurationProperties()[v]!==void 0?L.localize(8,null,v):r.policy?.name&&a.getPolicyConfigurations().get(r.policy?.name)!==void 0?L.localize(9,null,v,r.policy?.name,a.getPolicyConfigurations().get(r.policy?.name)):null:L.localize(6,null)}e.$vn=b;function E(){const v=[],r=a.getConfigurationProperties();for(const s of Object.keys(r))v.push([s,r[s].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$wn=E}),define(Re[177],Me([1,0,18,5,115,6,28,24,16,2,44,96,30]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=void 0;function p(s){return Object.isFrozen(s)?s:l.$4m(s)}class ${constructor(n={},o=[],w=[],d){this.b=n,this.c=o,this.d=w,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(o=>{if(o instanceof $)return o;const w=new m("");return w.parseRaw(o),w.configurationModel});this.f=n.reduce((o,w)=>w===o?w:o.merge(w),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,R.$pi)(this.contents,n):this.contents}inspect(n,o){const w=this.rawConfiguration.getValue(n),d=o?this.rawConfiguration.getOverrideValue(n,o):void 0,I=o?this.rawConfiguration.override(o).getValue(n):w;return{value:w,override:d,merged:I}}getOverrideValue(n,o){const w=this.i(o);return w?n?(0,R.$pi)(w,n):w:void 0}getKeysForOverrideIdentifier(n){const o=[];for(const w of this.overrides)w.identifiers.includes(n)&&o.push(...w.keys);return y.$Lb(o)}getAllOverrideIdentifiers(){const n=[];for(const o of this.overrides)n.push(...o.identifiers);return y.$Lb(n)}override(n){let o=this.a.get(n);return o||(o=this.g(n),this.a.set(n,o)),o}merge(...n){const o=l.$3m(this.contents),w=l.$3m(this.overrides),d=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const S of n)if(I.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(o,S.contents);for(const u of S.overrides){const[g]=w.filter(h=>y.$tb(h.identifiers,u.identifiers));g?(this.h(g.contents,u.contents),g.keys.push(...u.keys),g.keys=y.$Lb(g.keys)):w.push(l.$3m(u))}for(const u of S.keys)d.indexOf(u)===-1&&d.push(u)}return new $(o,d,w,I.every(S=>S instanceof $)?void 0:I)}g(n){const o=this.i(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const w={};for(const d of y.$Lb([...Object.keys(this.contents),...Object.keys(o)])){let I=this.contents[d];const S=o[d];S&&(typeof I=="object"&&typeof S=="object"?(I=l.$3m(I),this.h(I,S)):I=S),w[d]=I}return new $(w,this.keys,this.overrides)}h(n,o){for(const w of Object.keys(o)){if(w in n&&k.$zf(n[w])&&k.$zf(o[w])){this.h(n[w],o[w]);continue}n[w]=l.$3m(o[w])}}i(n){let o=null,w=null;const d=I=>{I&&(w?this.h(w,I):w=l.$3m(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===n?o=I.contents:I.identifiers.includes(n)&&d(I.contents);return d(o),w}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,o){this.j(n,o,!0)}setValue(n,o){this.j(n,o,!1)}removeValue(n){const o=this.keys.indexOf(n);o!==-1&&(this.keys.splice(o,1),(0,R.$oi)(this.contents,n),D.$rn.test(n)&&this.overrides.splice(this.overrides.findIndex(w=>y.$tb(w.identifiers,(0,D.$sn)(n))),1))}j(n,o,w){(0,R.$ni)(this.contents,n,o,d=>console.error(d)),w=w||this.keys.indexOf(n)===-1,w&&this.keys.push(n),D.$rn.test(n)&&this.overrides.push({identifiers:(0,D.$sn)(n),keys:Object.keys(this.contents[n]),contents:(0,R.$mi)(this.contents[n],d=>console.error(d))})}}e.$xn=$;class m{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,o){if(!k.$Gf(n)){const w=this.g(n);this.parseRaw(w,o)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,o){this.a=n;const{contents:w,keys:d,overrides:I,restricted:S,hasExcludedProperties:u}=this.h(n,o);this.b=new $(w,d,I,u?[n]:void 0),this.c=S||[]}g(n){let o={},w=null,d=[];const I=[],S=[];function u(h){Array.isArray(d)?d.push(h):w!==null&&(d[w]=h)}const g={onObjectBegin:()=>{const h={};u(h),I.push(d),d=h,w=null},onObjectProperty:h=>{w=h},onObjectEnd:()=>{d=I.pop()},onArrayBegin:()=>{const h=[];u(h),I.push(d),d=h,w=null},onArrayEnd:()=>{d=I.pop()},onLiteralValue:u,onError:(h,P,W)=>{S.push({error:h,offset:P,length:W})}};if(n)try{C.$Zm(n,g),o=d[0]||{}}catch(h){console.error(`Error while parsing settings file ${this.f}: ${h}`),this.d=[h]}return o}h(n,o){const w=c.$cn.as(D.$hn.Configuration).getConfigurationProperties(),d=this.i(n,w,!0,o);n=d.raw;const I=(0,R.$mi)(n,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),S=Object.keys(n),u=this.j(n,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:I,keys:S,overrides:u,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(n,o,w,d){let I=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:I};const S={},u=[];for(const g in n)if(D.$rn.test(g)&&w){const h=this.i(n[g],o,!1,d);S[g]=h.raw,I=I||h.hasExcludedProperties,u.push(...h.restricted)}else{const h=o[g],P=h?typeof h.scope<"u"?h.scope:3:void 0;h?.restricted&&u.push(g),!d.exclude?.includes(g)&&(d.include?.includes(g)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&h?.restricted))?S[g]=n[g]:I=!0}return{raw:S,restricted:u,hasExcludedProperties:I}}j(n,o){const w=[];for(const d of Object.keys(n))if(D.$rn.test(d)){const I={};for(const S in n[d])I[S]=n[d][S];w.push({identifiers:(0,D.$sn)(d),keys:Object.keys(I),contents:(0,R.$mi)(I,o)})}return w}}e.$yn=m;class t extends L.$Rc{constructor(n,o,w,d){super(),this.c=n,this.f=o,this.g=d,this.b=this.B(new M.$Md),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(w.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,I=>I.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,I=>(I.isOperation(0)||I.isOperation(3)||I.isOperation(1)||I.isOperation(4))&&w.isEqual(I.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zn=t;class i{constructor(n,o,w,d,I,S,u,g,h,P,W,K,j){this.a=n,this.b=o,this.c=w,this.overrideIdentifiers=d,this.d=I,this.f=S,this.g=u,this.h=g,this.i=h,this.j=P,this.k=W,this.l=K,this.m=j}get value(){return p(this.c)}n(n,o,w){const d=n.inspect(o,w);return{get value(){return p(d.value)},get override(){return p(d.override)},get merged(){return p(d.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(n,o,w,d,I=new $,S=new $,u=new A.$zc,g=new $,h=new A.$zc){this.c=n,this.d=o,this.f=w,this.g=d,this.h=I,this.i=S,this.j=u,this.l=g,this.m=h,this.a=null,this.b=new A.$zc,this.n=null}getValue(n,o,w){return this.q(n,o,w).getValue(n)}updateValue(n,o,w={}){let d;w.resource?(d=this.m.get(w.resource),d||(d=new $,this.m.set(w.resource,d))):d=this.l,o===void 0?d.removeValue(n):d.setValue(n,o),w.resource||(this.a=null)}inspect(n,o,w){const d=this.q(n,o,w),I=this.u(o.resource,w),S=o.resource?this.m.get(o.resource)||this.l:this.l,u=new Set;for(const g of d.overrides)for(const h of g.identifiers)d.getOverrideValue(n,h)!==void 0&&u.add(h);return new i(n,o,d.getValue(n),u.size?[...u]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,w?this.i:void 0,I||void 0,S)}keys(n){const o=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,o){this.j.set(n,o),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const w=[];if(!o){const{added:d,updated:I,removed:S}=v(this.c,n);o=[...d,...I,...S]}for(const d of o)for(const I of(0,D.$sn)(d)){const S=this.c.getKeysForOverrideIdentifier(I),u=n.getKeysForOverrideIdentifier(I),g=[...u.filter(h=>S.indexOf(h)===-1),...S.filter(h=>u.indexOf(h)===-1),...S.filter(h=>!l.$7m(this.c.override(I).getValue(h),n.override(I).getValue(h)))];w.push([I,g])}return this.updateDefaultConfiguration(n),{keys:o,overrides:w}}compareAndUpdatePolicyConfiguration(n){const{added:o,updated:w,removed:d}=v(this.d,n),I=[...o,...w,...d];return I.length&&this.updatePolicyConfiguration(n),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:o,updated:w,removed:d,overrides:I}=v(this.applicationConfiguration,n),S=[...o,...w,...d];return S.length&&this.updateApplicationConfiguration(n),{keys:S,overrides:I}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:w,removed:d,overrides:I}=v(this.localUserConfiguration,n),S=[...o,...w,...d];return S.length&&this.updateLocalUserConfiguration(n),{keys:S,overrides:I}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:w,removed:d,overrides:I}=v(this.remoteUserConfiguration,n),S=[...o,...w,...d];return S.length&&this.updateRemoteUserConfiguration(n),{keys:S,overrides:I}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:w,removed:d,overrides:I}=v(this.workspaceConfiguration,n),S=[...o,...w,...d];return S.length&&this.updateWorkspaceConfiguration(n),{keys:S,overrides:I}}compareAndUpdateFolderConfiguration(n,o){const w=this.p.get(n),{added:d,updated:I,removed:S,overrides:u}=v(w,o),g=[...d,...I,...S];return(g.length||!w)&&this.updateFolderConfiguration(n,o),{keys:g,overrides:u}}compareAndDeleteFolderConfiguration(n){const o=this.p.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:w,updated:d,removed:I,overrides:S}=v(o,void 0);return{keys:[...w,...d,...I],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,o,w){let d=this.r(o,w);return o.overrideIdentifier&&(d=d.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(d=d.merge(this.d)),d}r({resource:n},o){let w=this.s();if(o&&n){const d=o.getFolder(n);d&&(w=this.t(d.uri)||w);const I=this.m.get(n);I&&(w=w.merge(I))}return w}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let o=this.b.get(n);if(!o){const w=this.s(),d=this.j.get(n);d?(o=w.merge(d),this.b.set(n,o)):o=w}return o}u(n,o){if(o&&n){const w=o.getFolder(n);if(w)return this.j.get(w.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,o)=>{const{contents:w,overrides:d,keys:I}=this.j.get(o);return n.push([o,{contents:w,overrides:d,keys:I}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(o=>n.add(o)),this.userConfiguration.keys.forEach(o=>n.add(o)),this.i.keys.forEach(o=>n.add(o)),this.j.forEach(o=>o.keys.forEach(w=>n.add(w))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>n.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(w=>n.add(w))),[...n.values()]}w(n){const o=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.i.getKeysForOverrideIdentifier(n).forEach(w=>o.add(w)),this.j.forEach(w=>w.getKeysForOverrideIdentifier(n).forEach(d=>o.add(d))),[...o.values()]}static parse(n){const o=this.x(n.defaults),w=this.x(n.policy),d=this.x(n.application),I=this.x(n.user),S=this.x(n.workspace),u=n.folders.reduce((g,h)=>(g.set(f.URI.revive(h[0]),this.x(h[1])),g),new A.$zc);return new a(o,w,d,I,new $,S,u,new $,new A.$zc)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$An=a;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const n=new Set,o=new Map;for(const d of s)d.keys.forEach(I=>n.add(I)),d.overrides.forEach(([I,S])=>{const u=(0,A.$wc)(o,I,new Set);S.forEach(g=>u.add(g))});const w=[];return o.forEach((d,I)=>w.push([I,[...d.values()]])),{keys:[...n.values()],overrides:w}}e.$Bn=b;class E{constructor(n,o,w,d){this.change=n,this.f=o,this.g=w,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const I of n.keys)this.affectedKeys.add(I);for(const[,I]of n.overrides)for(const S of I)this.affectedKeys.add(S);this.d=this.a;for(const I of this.affectedKeys)this.d+=I+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(n,o){const w=this.a+n,d=this.d.indexOf(w);if(d<0)return!1;const I=d+w.length;if(I>=this.d.length)return!1;const S=this.d.charCodeAt(I);if(S!==this.b&&S!==this.c)return!1;if(o){const u=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.f?.workspace):void 0,g=this.g.getValue(n,o,this.h);return!l.$7m(u,g)}return!0}}e.$Cn=E;function v(s,n){const{added:o,removed:w,updated:d}=r(n?.rawConfiguration,s?.rawConfiguration),I=[],S=s?.getAllOverrideIdentifiers()||[],u=n?.getAllOverrideIdentifiers()||[];if(n){const g=u.filter(h=>!S.includes(h));for(const h of g)I.push([h,n.getKeysForOverrideIdentifier(h)])}if(s){const g=S.filter(h=>!u.includes(h));for(const h of g)I.push([h,s.getKeysForOverrideIdentifier(h)])}if(n&&s){for(const g of S)if(u.includes(g)){const h=r({contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)},{contents:n.getOverrideValue(void 0,g)||{},keys:n.getKeysForOverrideIdentifier(g)});I.push([g,[...h.added,...h.removed,...h.updated]])}}return{added:o,removed:w,updated:d,overrides:I}}function r(s,n){const o=s?n?s.keys.filter(I=>n.keys.indexOf(I)===-1):[...s.keys]:[],w=n?s?n.keys.filter(I=>s.keys.indexOf(I)===-1):[...n.keys]:[],d=[];if(s&&n){for(const I of n.keys)if(s.keys.indexOf(I)!==-1){const S=(0,R.$pi)(n.contents,I),u=(0,R.$pi)(s.contents,I);l.$7m(S,u)||d.push(I)}}return{added:o,removed:w,updated:d}}}),define(Re[97],Me([1,0,9,4]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.RemoteAuthorityResolverErrorCode=e.$Pk=e.$Ok=e.RemoteConnectionType=e.$Nk=void 0,e.$Nk=(0,M.$Nh)("remoteAuthorityResolverService");var C;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(C||(e.RemoteConnectionType=C={}));class L{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$Ok=L;class A{constructor(D,c){this.host=D,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Pk=A;var l;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class k extends y.$ab{static isNotAvailable(D){return D instanceof k&&D._code===l.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof k&&D._code===l.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof k&&D._code===l.NoResolverFound}static isInvalidAuthority(D){return D instanceof k&&D._code===l.InvalidAuthority}static isHandled(D){return D instanceof k&&D.isHandled}constructor(D,c=l.Unknown,p){super(D),this._message=D,this._code=c,this._detail=p,this.isHandled=c===l.NotAvailable&&p===!0,Object.setPrototypeOf(this,k.prototype)}}e.$Qk=k;function f(R){const D=R.indexOf("+");return D===-1?R:R.substring(0,D)}e.$Rk=f}),define(Re[52],Me([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=void 0;function M(f){return f.scheme===y.Schemas.vscodeRemote?f.authority:void 0}e.$Sk=M;function C(f){if(!f)return;const R=f.indexOf("+");return R<0?f:f.substr(0,R)}e.$Tk=C;function L(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Uk=L;function A(f){const{host:R,port:D}=k(f);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:D}}e.$Vk=A;function l(f,R){let{host:D,port:c}=k(f);return typeof c>"u"&&(c=R),{host:D,port:c}}e.$Wk=l;function k(f){const R=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const D=f.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const c=f.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:f,port:void 0}}}),define(Re[20],Me([1,0,15,4,52]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.TargetPlatform=e.ExtensionType=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0,e.$Wl="extensions.user.cache",e.$Xl="extensions.builtin.cache",e.$Yl="undefined_publisher",e.$Zl=["ui","workspace","web"];function L(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$1l=L,e.$2l=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A||(e.ExtensionType=A={}));var l;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(l||(e.TargetPlatform=l={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const a=typeof t=="string"?t:t.value,b=typeof i=="string"?i:i.value;return y.$1e(a,b)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$3l=k;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(k.toKey(t))}delete(t){return this.c.delete(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}}e.$4l=f;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(k.toKey(t))}get(t){return this.c.get(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}set(t,i){this.c.set(k.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$5l=R;function D(m){return c(m)}e.$6l=D;function c(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$7l=c;function p(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$8l=p;function $(m,t){if(t){const i=`onResolveRemoteAuthority:${(0,C.$Tk)(t)}`;return!!m.activationEvents?.includes(i)}return!1}e.$9l=$,e.$0l=(0,M.$Nh)("IBuiltinExtensionsScannerService")}),define(Re[98],Me([1,0,9,20]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RE=e.$QE=void 0;class C{constructor(){this.a=new Map,this.b=new WeakMap}register(A,l){this.a.set(A,l)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const l=Object.create(null);for(const k of A){const f=this.readActivationEvents(k);f.length>0&&(l[M.$3l.toKey(k.identifier)]=f)}return l}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const l=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return l;for(const k in A.contributes){const f=this.a.get(k);if(!f)continue;const R=A.contributes[k],D=Array.isArray(R)?R:[R];try{f(D,l)}catch(c){(0,y.$Z)(c)}}return l}}e.$QE=C,e.$RE=new C}),define(Re[178],Me([1,0,22,73,36]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=void 0;function L(k){if(y.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function A(k,f,R,D,c,p,$,m){const t=Object.create(null);t["common.machineId"]=p,t.sessionID=(0,C.$dg)()+Date.now(),t.commitHash=D,t.version=c,t["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,y.$i)(y.$u),t["common.nodePlatform"]=M.$cc,t["common.nodeArch"]=R,t["common.product"]=m||"desktop",$&&(t["common.msftInternal"]=$);let i=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),y.$m&&(t["common.snap"]="true");const b=L(f);return b&&(t["common.platformDetail"]=b),t}e.$eo=A;function l(k){const f=M.env.USERDNSDOMAIN;if(!f)return!1;const R=f.toLowerCase();return k.some(D=>R===D)}e.$fo=l}),define(Re[179],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0,e.$al=(0,y.$Nh)("telemetryService"),e.$bl=(0,y.$Nh)("customEndpointTelemetryService"),e.$cl="telemetry.currentSessionDate",e.$dl="telemetry.firstSessionDate",e.$el="telemetry.lastSessionDate",e.$fl="telemetry.machineId",e.$gl="telemetry",e.$hl="telemetry.telemetryLevel",e.$il="telemetry.enableCrashReporter",e.$jl="telemetry.enableTelemetry";var M;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var C;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(C||(e.TelemetryConfiguration=C={}))}),define(Re[53],Me([1,0,24,16,5,44,52,178,179]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;class f{constructor(w){this.value=w,this.isTrustedTelemetryValue=!0}}e.$go=f;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ho=R,e.$io=new R;class D{async publicLog(w,d,I){}async publicLogError(w,d,I){}}e.$jo=D,e.$ko="telemetry",e.$lo="extensionTelemetryLog",e.$mo={log:()=>null,flush:()=>Promise.resolve(null)};function c(o,w){return C.Event.debounce(w.onDidChangeConfiguration,(I,S)=>{const u=I?new Set([...I.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:u}},1e3,!0)(I=>{I.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,L.$ki)(I.source),configurationKeys:Array.from(I.affectedKeys)})})}e.$no=c;function p(o,w){return!w.isBuilt&&!w.disableTelemetry?!0:!(w.disableTelemetry||!o.enableTelemetry)}e.$oo=p;function $(o,w){return w.extensionTestsLocationURI?!0:!(w.isBuilt||w.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.$po=$;function m(o){const w=o.getValue(k.$hl),d=o.getValue(k.$il);if(o.getValue(k.$jl)===!1||d===!1)return 0;switch(w??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$qo=m;function t(o){const w={},d={},I={};b(o,I);for(let S in I){S=S.length>150?S.substr(S.length-149):S;const u=I[S];typeof u=="number"?d[S]=u:typeof u=="boolean"?d[S]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${u.length}`),w[S]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(w[S]=u)}return{properties:w,measurements:d}}e.$ro=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(o){if(!o)return"none";const w=(0,A.$Tk)(o);return i.has(w)?w:"other"}e.$so=a;function b(o,w,d=0,I){if(o)for(const S of Object.getOwnPropertyNames(o)){const u=o[S],g=I?I+S:S;Array.isArray(u)?w[g]=(0,y.$8m)(u):u instanceof Date?w[g]=u.toISOString():(0,M.$zf)(u)?d<2?b(u,w,d+1,g+"."):w[g]=(0,y.$8m)(u):w[g]=u}}function E(o,w){const d=o.msftInternalDomains||[],I=w.getValue("telemetry.internalTesting");return(0,l.$fo)(d)||I}e.$to=E;function v(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.$uo=v;function r(o,w){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let d=o;const I=[];for(const h of w)for(;;){const P=h.exec(o);if(!P)break;I.push([P.index,h.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(d="";;){const h=u.exec(o);if(!h)break;const P=I.some(([W,K])=>h.index<K&&W<u.lastIndex);!S.test(h[0])&&!P&&(d+=o.substring(g,h.index)+"<REDACTED: user-file-path>",g=u.lastIndex)}return g<o.length&&(d+=o.substr(g)),d}function s(o){if(!o)return o;const w=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of w)if(d.regex.test(o))return`<REDACTED: ${d.label}>`;return o}function n(o,w){return(0,y.$5m)(o,d=>{if(d instanceof f||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let I=d.replaceAll("%20"," ");I=r(I,w);for(const S of w)I=I.replace(S,"");return I=s(I),I}})}e.$vo=n}),define(Re[180],Me([1,0,15,92,20,22,2,9,73,53]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0;function R(n,o){return n.uuid&&o.uuid?n.uuid===o.uuid:n.id===o.id?!0:(0,y.$Ve)(n.id,o.id)===0}e.$wo=R;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(o){const w=o.manifest?o.manifest.version:o.version,d=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new c(o.identifier,w,d)}static parse(o){const w=D.exec(o);return w&&w[1]&&w[2]?new c({id:w[1]},w[2],w[4]||void 0):null}constructor(o,w,d="undefined"){this.version=w,this.targetPlatform=d,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof c?R(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.$xo=c;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const o=p.exec(n);return o&&o[1]?[t(o[1]),o[2]]:[t(n),void 0]}e.$yo=$;function m(n,o){return`${n}.${o}`}e.$zo=m;function t(n){return n.toLowerCase()}e.$Ao=t;function i(n,o){return t(m(n??C.$Yl,o))}e.$Bo=i;function a(n,o){const w=[],d=I=>{for(const S of w)if(S.some(u=>R(o(u),o(I))))return S;return null};for(const I of n){const S=d(I);S?S.push(I):w.push([I])}return w}e.$Co=a;function b(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$Do=b;function E(n){return{id:new f.$go(n.identifier.id),name:new f.$go(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Eo=E,e.$Fo=new C.$3l("pprice.better-merge");function v(n,o){const w=[],d=o.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const I=d.shift();if(I&&w.every(S=>!R(S.identifier,{id:I}))){const S=n.filter(u=>R(u.identifier,{id:I}));S.length===1&&(w.push(S[0]),d.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return w}e.$Go=v;async function r(n,o){if(!L.$l)return!1;let w;try{w=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{w=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(I){o.debug("Error while getting the os-release file.",(0,l.$9)(I))}}return!!w&&(w.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(n,o){const w=await r(n,o),d=(0,M.$2n)(w?"alpine":L.$u,k.$dc);return o.debug("ComputeTargetPlatform:",d),d}e.$Ho=s}),define(Re[181],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=e.$kr=e.$jr=e.$ir=e.$hr=void 0;function y(k){return[...k.entries()]}e.$hr=y;function M(k){return k?[...k.entries()]:[]}e.$ir=M;function C(k){return new Map(k)}e.$jr=C;function L(k){return new Map(k??[])}e.$kr=L;function A(k){return Array.from(k.entries()).map(f=>[f[0],y(f[1].map),M(f[1].descriptionMap)])}e.$lr=A;function l(k){return new Map(k.map(f=>[f[0],{map:C(f[1]),descriptionMap:L(f[2])}]))}e.$mr=l}),define(Re[182],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkb=void 0;class y{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,L,A=5){const l=L(k=>{const f=typeof k=="string"?k:k.data;let R=this.a.get(C);if(R){R.data.push(f);return}const D=setTimeout(()=>this.flushBuffer(C),A);R={data:[f],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(C),l.dispose()}},this.a.set(C,R)});return l}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const L=this.a.get(C);L&&(this.a.delete(C),this.b(C,L.data.join("")))}}e.$Lkb=y}),define(Re[183],Me([1,0,12,89,41,5,16,2,144,72,30]),function(we,e,y,M,C,L,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8v=e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.IconFontDefinition=e.IconContribution=e.$Zv=void 0,e.$Zv={IconContribution:"base.contributions.icons"};var D;(function(E){function v(r,s){let n=r.defaults;for(;C.ThemeIcon.isThemeIcon(n);){const o=$.getIcon(n.id);if(!o)return;n=o.defaults}return n}E.getDefinition=v})(D||(e.IconContribution=D={}));var c;(function(E){function v(s){return{weight:s.weight,style:s.style,src:s.src.map(n=>({format:n.format,location:n.location.toString()}))}}E.toJSONObject=v;function r(s){const n=o=>(0,A.$xf)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,A.$xf)(o.format)&&(0,A.$xf)(o.location)))return{weight:n(s.weight),style:n(s.style),src:s.src.map(o=>({format:o.format,location:l.URI.parse(o.location)}))}}E.fromJSONObject=r})(c||(e.IconFontDefinition=c={}));class p{constructor(){this.a=new L.$Md,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${C.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,r,s,n){const o=this.b[v];if(o){if(s&&!o.description){o.description=s,this.d.properties[v].markdownDescription=`${s} $(${v})`;const I=this.e.enum.indexOf(v);I!==-1&&(this.e.enumDescriptions[I]=s),this.a.fire()}return o}const w={id:v,description:s,defaults:r,deprecationMessage:n};this.b[v]=w;const d={$ref:"#/definitions/icons"};return n&&(d.deprecationMessage=n),s&&(d.markdownDescription=`${s}: $(${v})`),this.d.properties[v]=d,this.e.enum.push(v),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const r=this.e.enum.indexOf(v);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,r){const s=this.f[v];return s||(this.f[v]=r,this.a.fire(),r)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(o,w)=>o.id.localeCompare(w.id),r=o=>{for(;C.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(o=>this.b[o]);for(const o of n.filter(w=>!!w.description).sort(v))s.push(`|<i class="${r(o)}"></i>|${o.id}|${C.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of n.filter(w=>!C.ThemeIcon.isThemeIcon(w.defaults)).sort(v))s.push(`|<i class="${r(o)}"></i>|${o.id}|`);return s.join(`
`)}}const $=new p;R.$cn.add(e.$Zv.IconContribution,$);function m(E,v,r,s){return $.registerIcon(E,v,r,s)}e.$1v=m;function t(){return $}e.$2v=t;function i(){const E=(0,M.$Qj)();for(const v in E){const r="\\"+E[v].toString(16);$.registerIcon(v,{fontCharacter:r})}}i(),e.$3v="vscode://schemas/icons";const a=R.$cn.as(f.$dn.JSONContribution);a.registerSchema(e.$3v,$.getIconSchema());const b=new y.$5g(()=>a.notifySchemaChanged(e.$3v),200);$.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.$4v=m("widget-close",M.$Sj.close,(0,k.localize)(2,null)),e.$5v=m("goto-previous-location",M.$Sj.arrowUp,(0,k.localize)(3,null)),e.$6v=m("goto-next-location",M.$Sj.arrowDown,(0,k.localize)(4,null)),e.$7v=C.ThemeIcon.modify(M.$Sj.sync,"spin"),e.$8v=C.ThemeIcon.modify(M.$Sj.loading,"spin")}),define(Re[184],Me([1,0,5,44,4,14]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cv=e.$bv=e.$av=e.$_u=e.$$u=e.$0u=e.$9u=e.$8u=e.ProvidedOnAutoForward=e.$7u=e.TunnelPrivacyId=e.TunnelProtocol=e.$6u=e.$5u=void 0,e.$5u=(0,C.$Nh)("tunnelService"),e.$6u=(0,C.$Nh)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var l;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(l||(e.TunnelPrivacyId=l={}));function k(t){return!!t.forwardPort}e.$7u=k;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$8u=R,e.$9u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$9u.indexOf(t)>=0}e.$0u=D,e.$$u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(t){return e.$$u.indexOf(t)>=0}e.$_u=c;function p(t,i,a,b){if(a===1)return!1;if(a===2&&c(i)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(E?.length===4&&parseInt(E[1])>=18)return!1}return t<1024}e.$av=p;class ${constructor(i,a,b){this.remoteAddress=i,this.localAddress=a,this.b=b,this.a=new y.$Md,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$bv=$;let m=class{constructor(i,a){this.j=i,this.k=a,this.a=new y.$Md,this.onTunnelOpened=this.a.event,this.b=new y.$Md,this.onTunnelClosed=this.b.event,this.c=new y.$Md,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],a=Array.from(this.e.values());for(const b of a){const E=Array.from(b.values());for(const v of E){const r=await v.value;r&&typeof r!="string"&&i.push(r)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:a}of i.values())await a.then(b=>typeof b!="string"?b?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,a,b,E,v){this.p(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:b,privacy:E,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(c(i)||D(i))&&(i=e.$9u[0]);const b=this.r(i,a);if(b)return++b.refcount,b.value}openTunnel(i,a,b,E,v,r=!1,s,n){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${b} on local port ${v}.`);const o=this.f??i;if(!o)return;if(a||(a="localhost"),E||(E=this.l),this.f&&this.i.has(b)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const w=this.s(o,a,b,E,v,r,s,n);return w?w.then(d=>{if(d){if(typeof d=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(a,b),d}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(a,b);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const I=this.n(d);return(d.tunnelRemoteHost!==a||d.tunnelRemotePort!==b)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&d.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(I),I}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),w)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.e.get(i.tunnelRemoteHost);if(a){const b=a.get(i.tunnelRemotePort);b&&(b.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,b))}}}}async o(i,a,b){if(b.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const E=b.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(a),E}}async closeTunnel(i,a){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const b=this.e.get(i);if(b&&b.has(a)){const E=b.get(a);E.refcount=0,await this.o(i,a,E)}}p(i,a,b){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(a,{refcount:1,value:b})}async q(i,a){const b=this.e.get(i);if(b){const E=b.get(a),v=E?await E.value:void 0;(!v||typeof v=="string")&&b.delete(a),b.size===0&&this.e.delete(i)}}r(i,a){const b=[i];D(i)?(b.push(...e.$9u),b.push(...e.$$u)):c(i)&&b.push(...e.$$u);const E=b.map(v=>this.e.get(v));for(const v of E){const r=v?.get(a);if(r)return r}}canTunnel(i){return!!R(i)}t(i,a,b,E,v,r,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${b} on local port ${E}.`);const n=b;this.i.add(n);const o=E===void 0?b:E,w={elevationRequired:v?this.isPortPrivileged(o):!1},d={remoteAddress:{host:a,port:b},localAddressPort:E,privacy:r,public:r?r!==l.Private:void 0,protocol:s},I=i.forwardPort(d,w);return I?(this.p(a,b,I),I.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(n)})):this.i.delete(n),I}};e.$cv=m,e.$cv=m=qe([We(0,L.$8i),We(1,M.$hi)],m)}),define(Re[185],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$dv=void 0,e.$dv=(0,y.$Nh)("editSessionIdentityService");var M;(function(C){C[C.Complete=100]="Complete",C[C.Partial=50]="Partial",C[C.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Re[186],Me([1,0,13]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=void 0;function M(k){return k.scheme!==y.Schemas.file&&k.scheme!==y.Schemas.vscodeRemote}e.$JJ=M;function C(k){if(k.folders.length)return k.folders.every(f=>M(f.uri))?k.folders[0].uri:void 0;if(k.configuration&&M(k.configuration))return k.configuration}e.$KJ=C;function L(k){return C(k)?.scheme}e.$LJ=L;function A(k){return C(k)?.authority}e.$MJ=A;function l(k){return C(k)!==void 0}e.$NJ=l}),define(Re[54],Me([1,0,145,19,49,23,2,4,13]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.WorkbenchState=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=void 0,e.$Wh=(0,l.$Nh)("contextService");function f(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.uri)}e.$Xh=f;function R(o){return typeof o?.id=="string"&&!f(o)&&!c(o)}e.$Yh=R,e.$Zh={id:"ext-dev"},e.$1h={id:"empty-window"};function D(o,w){if(typeof o=="string"||typeof o>"u")return typeof o=="string"?{id:(0,M.$mc)(o)}:w?e.$Zh:e.$1h;const d=o;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$2h=D;function c(o){const w=o;return typeof w?.id=="string"&&A.URI.isUri(w.configPath)}e.$3h=c;function p(o){const w=o;if(w?.uri)return{id:w.id,uri:A.URI.revive(w.uri)};const d=o;if(d?.configPath)return{id:d.id,configPath:A.URI.revive(d.configPath)};if(o?.id)return{id:o.id}}e.$4h=p;var $;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function m(o){const w=o;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.$5h=m;function t(o){const w=o;return!!(w&&typeof w=="object"&&A.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.$6h=t;class i{constructor(w,d,I,S,u){this.h=w,this.j=I,this.k=S,this.l=u,this.c=C.$Th.forUris(this.l,()=>!0),this.folders=d}update(w){this.h=w.id,this.k=w.configuration,this.j=w.transient,this.l=w.l,this.folders=w.folders}get folders(){return this.g}set folders(w){this.g=w,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(w){this.k=w}getFolder(w){return w&&this.c.findSubstr(w)||null}n(){this.c=C.$Th.forUris(this.l,()=>!0);for(const w of this.folders)this.c.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$7h=i;class a{constructor(w,d){this.raw=d,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,L.$ug)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$8h=a;function b(o){return new a({uri:o,index:0,name:(0,L.$qg)(o)},{uri:o.toString()})}e.$9h=b,e.$0h="code-workspace",e.$$h=`.${e.$0h}`,e.$_h=[{name:(0,y.localize)(0,null),extensions:[e.$0h]}],e.$ai="workspace.json";function E(o,w){return L.$lg.isEqualOrParent(o,w.untitledWorkspacesHome)}e.$bi=E;function v(o){let w;return A.URI.isUri(o)?w=o:w=o.configuration,w?.scheme===k.Schemas.tmp}e.$ci=v,e.$di="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(o){return o.id===e.$di}e.$ei=r;function s(o,w){return!E(o,w)&&!v(o)}e.$fi=s;function n(o){return(typeof o=="string"?(0,M.$nc)(o):(0,L.$sg)(o))===e.$$h}e.$gi=n}),define(Re[74],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=void 0;class y{static{this.a=!1}constructor(C){this.d=C,this.b=new Map,this.c=1}add(C){const L=this.c++;return this.b.set(L,C),this.e(),L}get(C,L){return this.b.has(C)?this.b.get(C)[L]:void 0}delete(C){this.b.delete(C),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Jbc=y}),define(Re[39],Me([1,0,13,23,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mbc=e.$Lbc=void 0;class L{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new M.$jg(l=>{const k=this.b.get(l.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(l,k){k===null?this.b.delete(l.scheme):this.b.set(l.scheme,k)}isFreeScheme(l){return!this.b.has(l)&&!this.a.has(l)}getCapabilities(l){return this.b.get(l)}}e.$Lbc=L,e.$Mbc=(0,C.$Nh)("IExtHostFileSystemInfo")}),define(Re[27],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rM=void 0,e.$rM=(0,y.$Nh)("IExtHostInitDataService")}),define(Re[187],Me([1,0,150,14,174,27]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;let A=class extends C.$yN{constructor(k,f,R){const D=R.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",c=R.remote.isRemote?(0,y.localize)(0,null):k?(0,y.localize)(1,null):(0,y.localize)(2,null);super(f.createLogger(D,{name:c}))}};e.$Sdc=A,e.$Sdc=A=qe([We(1,M.$9i),We(2,L.$rM)],A)}),define(Re[188],Me([1,0,12]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=e.$ccc=void 0;class M{constructor(A,l,k){this.h=new Map,this.a=A,this.b=l,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new y.$5g(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of f.values())R.complete()}catch(R){for(const D of f.values())D.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,l){let k=this.f[A];return typeof k>"u"&&(k=l),k}update(A,l){this.f[A]=l;const k=this.h.get(A);if(k!==void 0)return k.p;const f=new y.$bh;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$ccc=M;class C extends M{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,l){super(A.identifier.value,!0,l),this.j=A}}e.$dcc=C}),define(Re[189],Me([1,0,5,2]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bdc=void 0;class C{constructor(A){this.c=A,this.a=new y.$Md,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$Md,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,l,k,f){const D=this.c.getNotebookDocument(M.URI.revive(A)).acceptModelChanged(l.value,k,f);this.b.fire(D)}$acceptDirtyStateChanged(A,l){this.c.getNotebookDocument(M.URI.revive(A)).acceptDirty(l)}$acceptModelSaved(A){const l=this.c.getNotebookDocument(M.URI.revive(A));this.a.fire(l.apiNotebook)}}e.$Bdc=C}),define(Re[17],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cM=e.$bM=void 0,e.$bM=(0,y.$Nh)("IExtHostRpcService");class M{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$cM=M}),define(Re[190],Me([1,0,20,5]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class C{#e;constructor(A,l){this.b=new M.$Md,this.onDidChange=this.b.event,this.a=y.$3l.toKey(A.identifier),this.#e=l,this.#e.onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(A){return this.#e.get(this.a,A)}store(A,l){return this.#e.store(this.a,A,l)}delete(A){return this.#e.delete(this.a,A)}}e.$occ=C}),define(Re[55],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=e.$Wbc=void 0,e.$Wbc=(0,y.$Nh)("IURITransformerService");class M{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Xbc=M}),define(Re[191],Me([1,0,26]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tcb=e.$scb=void 0;class M{constructor(){this.buffers=[]}add(k){let f=this.buffers.indexOf(k);return f<0&&(f=this.buffers.length,this.buffers.push(k)),f}}function C(l,k){if(k.serializeBuffersForPostMessage){const f=new M,D=JSON.stringify(l,(p,$)=>{if($ instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add($)};if(ArrayBuffer.isView($)){const m=L($);if(m)return{$$vscode_array_buffer_reference$$:!0,index:f.add($.buffer),view:{type:m,byteLength:$.byteLength,byteOffset:$.byteOffset}}}return $}),c=f.buffers.map(p=>{const $=new Uint8Array(p);return y.$ae.wrap($)});return{message:D,buffers:c}}else return{message:JSON.stringify(l),buffers:[]}}e.$scb=C;function L(l){switch(l.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(l,k){const f=k.map(c=>{const p=new ArrayBuffer(c.byteLength);return new Uint8Array(p).set(c.buffer),p}),R=k.length?(c,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const $=p,{index:m}=$,t=f[m];if($.view)switch($.view.type){case 1:return new Int8Array(t,$.view.byteOffset,$.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,$.view.byteOffset,$.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,$.view.byteOffset,$.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,$.view.byteOffset,$.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,$.view.byteOffset,$.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,$.view.byteOffset,$.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,$.view.byteOffset,$.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,$.view.byteOffset,$.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,$.view.byteOffset,$.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,$.view.byteOffset,$.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,$.view.byteOffset,$.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return p}:void 0;return{message:JSON.parse(l,R),arrayBuffers:f}}e.$tcb=A}),define(Re[99],Me([1,0,159,16,2,6,4,30,38,13,42,127,29]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bE=e.$aE=e.$_D=e.EditorsOrder=e.$$D=e.CloseDirection=e.$0D=e.$9D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$8D=e.$7D=e.$6D=e.$5D=e.$4D=e.$3D=e.$2D=e.$1D=e.EditorInputCapabilities=e.$ZD=e.SaveReason=e.Verbosity=e.$YD=e.$XD=e.$WD=e.$VD=e.$UD=e.$TD=e.$SD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$RD=e.$QD=e.$PD=e.$OD=e.$ND=void 0,e.$ND={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$OD={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$PD="workbench.editor.sidebysideEditor",e.$QD="workbench.editors.textDiffEditor",e.$RD="workbench.editors.binaryResourceDiffEditor";var p;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var $;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})($||(e.EditorPaneSelectionCompareResult=$={}));function m(se){const $e=se;return!!$e&&typeof $e.getSelection=="function"&&!!$e.onDidChangeSelection}e.$SD=m;function t(se,$e,_){for(const z of _.visibleEditorPanes)if(z.group.id===$e&&se.matches(z.input))return z.getViewState()}e.$TD=t;function i(se){if(d(se))return!1;const $e=se;return C.URI.isUri($e?.resource)}e.$UD=i;function a(se){if(d(se))return!1;const $e=se;return $e?.original!==void 0&&$e.modified!==void 0}e.$VD=a;function b(se){if(d(se)||a(se))return!1;const $e=se;return $e?.primary!==void 0&&$e.secondary!==void 0}e.$WD=b;function E(se){if(d(se))return!1;const $e=se;return $e?$e.resource===void 0||$e.resource.scheme===f.Schemas.untitled||$e.forceUntitled===!0:!1}e.$XD=E;function v(se){if(d(se))return!1;const $e=se;return C.URI.isUri($e?.base?.resource)&&C.URI.isUri($e?.input1?.resource)&&C.URI.isUri($e?.input2?.resource)&&C.URI.isUri($e?.result?.resource)}e.$YD=v;var r;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class n{constructor(){this.a=new Map}registerSource($e,_){let z=this.a.get($e);return z||(z={source:$e,label:_},this.a.set($e,z)),z.source}getSourceLabel($e){return this.a.get($e)?.label??$e}}e.$ZD=new n;var o;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad"})(o||(e.EditorInputCapabilities=o={}));class w extends L.$Rc{}e.$1D=w;function d(se){return se instanceof w}e.$2D=d;function I(se){const $e=se;return C.URI.isUri($e?.preferredResource)}function S(se){const $e=se;return d($e?.primary)&&d($e?.secondary)}e.$3D=S;function u(se){const $e=se;return d($e?.modified)&&d($e?.original)}e.$4D=u;function g(se,$e,_,z,V){return ce(z,[(0,D.$xi)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const ue={..._,limits:{size:Number.MAX_VALUE}};se.openEditor($e,ue)}}),(0,D.$xi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>V.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.$5D=g;function h(se){return d(se?.editor)}e.$6D=h;function P(se){const $e=se;return h(se)&&$e?.group!==void 0}e.$7D=P;function W(se){const $e=se;return typeof $e?.groupId=="number"&&d($e.editor)}e.$8D=W;var K;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(K||(e.EditorCloseContext=K={}));var j;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LOCKED=2]="GROUP_LOCKED",se[se.EDITOR_OPEN=3]="EDITOR_OPEN",se[se.EDITOR_CLOSE=4]="EDITOR_CLOSE",se[se.EDITOR_MOVE=5]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=7]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=9]="EDITOR_PIN",se[se.EDITOR_STICKY=10]="EDITOR_STICKY",se[se.EDITOR_DIRTY=11]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(j||(e.GroupModelChangeKind=j={}));var B;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(B||(e.SideBySideEditor=B={}));class O{getOriginalUri($e,_){if(!$e)return;if(v($e))return e.$0D.getOriginalUri($e.result,_);if(_?.supportSideBySide){const{primary:V,secondary:ue}=this.a($e);if(V&&ue){if(_?.supportSideBySide===B.BOTH)return{primary:this.getOriginalUri(V,{filterByScheme:_.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===B.ANY)return this.getOriginalUri(V,{filterByScheme:_.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:_.filterByScheme});$e=_.supportSideBySide===B.PRIMARY?V:ue}}if(a($e)||b($e)||v($e))return;const z=I($e)?$e.preferredResource:$e.resource;return!z||!_||!_.filterByScheme?z:this.b(z,_.filterByScheme)}a($e){return S($e)||b($e)?{primary:$e.primary,secondary:$e.secondary}:u($e)||a($e)?{primary:$e.modified,secondary:$e.original}:{primary:void 0,secondary:void 0}}getCanonicalUri($e,_){if(!$e)return;if(v($e))return e.$0D.getCanonicalUri($e.result,_);if(_?.supportSideBySide){const{primary:V,secondary:ue}=this.a($e);if(V&&ue){if(_?.supportSideBySide===B.BOTH)return{primary:this.getCanonicalUri(V,{filterByScheme:_.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme})};if(_?.supportSideBySide===B.ANY)return this.getCanonicalUri(V,{filterByScheme:_.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:_.filterByScheme});$e=_.supportSideBySide===B.PRIMARY?V:ue}}if(a($e)||b($e)||v($e))return;const z=$e.resource;return!z||!_||!_.filterByScheme?z:this.b(z,_.filterByScheme)}b($e,_){if(Array.isArray(_)){if(_.some(z=>$e.scheme===z))return $e}else if(_===$e.scheme)return $e}}var N;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(N||(e.EditorCloseMethod=N={}));function te(se,$e,_,z){if(!se.isSticky($e))return!1;switch(z.preventPinnedEditorClose){case"keyboardAndMouse":return _===N.MOUSE||_===N.KEYBOARD;case"mouse":return _===N.MOUSE;case"keyboard":return _===N.KEYBOARD}return!1}e.$9D=te,e.$0D=new O;var Y;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(Y||(e.CloseDirection=Y={}));class Ee{constructor(){this.c=new Map,this.d=new Map}start($e){const _=this.a=$e.get(A.$Mh);for(const[z,V]of this.c)this.e(z,V,_);this.c.clear()}e($e,_,z){const V=z.createInstance(_);this.d.set($e,V)}registerFileEditorFactory($e){if(this.b)throw new Error("Can only register one file editor factory.");this.b=$e}getFileEditorFactory(){return(0,M.$If)(this.b)}registerEditorSerializer($e,_){if(this.c.has($e)||this.d.has($e))throw new Error(`A editor serializer with type ID '${$e}' was already registered.`);return this.a?this.e($e,_,this.a):this.c.set($e,_),(0,L.$Pc)(()=>{this.c.delete($e),this.d.delete($e)})}getEditorSerializer($e){return this.d.get(typeof $e=="string"?$e:$e.typeId)}}l.$cn.add(e.$ND.EditorFactory,new Ee);async function Se(se,$e,_){return!se||!se.length?[]:await Promise.all(se.map(async z=>{const V=C.URI.revive(z.fileUri);if(!V){_.info("Cannot resolve the path because it is not valid.",z);return}if(!await $e.canHandleResource(V)){_.info("Cannot resolve the path because it cannot be handled",z);return}let ye=z.exists,be=z.type;if(typeof ye!="boolean"||typeof be!="number")try{be=(await $e.stat(V)).isDirectory?k.FileType.Directory:k.FileType.Unknown,ye=!0}catch(De){_.error(De),ye=!1}if(!ye&&z.openOnlyIfExists){_.info("Cannot resolve the path because it does not exist",z);return}if(be===k.FileType.Directory){_.info("Cannot resolve the path because it is a directory",z);return}const pe={...z.options,pinned:!0};return ye?{resource:V,options:pe}:{resource:V,options:pe,forceUntitled:!0}}))}e.$$D=Se;var Pe;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(Pe||(e.EditorsOrder=Pe={}));function ge(se){const $e=se;if(!$e)return!1;const _=$e;if(_.modified)return ge(_.modified);const z=$e;return!!(z.contributionsState&&z.viewState&&Array.isArray(z.cursorState))}e.$_D=ge;function me(se){return(0,R.$zi)(se)}e.$aE=me;function ce(se,$e,_){const z=(0,R.$Ai)(se,$e);return z.forceMessage=_?.forceMessage,z.forceSeverity=_?.forceSeverity,z.allowDialog=_?.allowDialog,z}e.$bE=ce}),define(Re[192],Me([1,0,5,160,4,6,28,30,18,24,89,183]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mE=e.$lE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$kE=e.$jE=e.ViewContentGroups=e.$iE=e.$hE=e.ViewContainerLocation=e.Extensions=e.$gE=e.$fE=e.$eE=void 0,e.$eE="views",e.$fE=(0,M.localize)(0,null),e.$gE=(0,D.$1v)("default-view-icon",R.$Sj.window,(0,M.localize)(1,null));var c;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(c||(e.Extensions=c={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$hE=[0,1,2];function $(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$iE=$;class m extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Md),this.onDidRegister=this.c.event,this.f=this.B(new y.$Md),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$Qb)([...this.g.values()])}registerViewContainer(n,o,w){const d=this.get(n.id);if(d)return d;const I=n;return I.openCommandActionDescriptor=w?.doNotRegisterOpenCommand?void 0:I.openCommandActionDescriptor??{id:I.id},(0,A.$wc)(this.g,o,[]).push(I),w?.isDefault&&this.h.push(I),this.c.fire({viewContainer:I,viewContainerLocation:o}),I}deregisterViewContainer(n){for(const o of this.g.keys()){const w=this.g.get(o),d=w?.indexOf(n);if(d!==-1){w?.splice(d,1),w.length===0&&this.g.delete(o),this.f.fire({viewContainer:n,viewContainerLocation:o});return}}}get(n){return this.all.filter(o=>o.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(w=>w?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(o=>this.getViewContainerLocation(o)===n)}}l.$cn.add(c.ViewContainersRegistry,new m);var t;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(t||(e.ViewContentGroups=t={}));function i(s,n){const o=s.group??t.More,w=n.group??t.More;return o!==w?o.localeCompare(w):(s.order??5)-(n.order??5)}class a extends L.$Rc{constructor(){super(...arguments),this.c=this.B(new y.$Md),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$Md),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$Md),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$Md),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(n,o){this.registerViews2([{views:n,viewContainer:o}])}registerViews2(n){n.forEach(({views:o,viewContainer:w})=>this.r(o,w)),this.c.fire(n)}deregisterViews(n,o){const w=this.s(n,o);w.length&&this.f.fire({views:w,viewContainer:o})}moveViews(n,o){for(const w of this.m.keys())if(w!==o){const d=this.s(n,w);d.length&&(this.r(d,o),this.g.fire({views:d,from:w,to:o}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const o of this.j){const w=(this.m.get(o)||[]).filter(d=>d.id===n)[0];if(w)return w}return null}getViewContainer(n){for(const o of this.j)if((this.m.get(o)||[]).filter(d=>d.id===n)[0])return o;return null}registerViewWelcomeContent(n,o){return this.n.add(n,o),this.h.fire(n),(0,L.$Pc)(()=>{this.n.delete(n,o),this.h.fire(n)})}registerViewWelcomeContent2(n,o){const w=new Map;for(const[d,I]of o)this.n.add(n,I),w.set(d,(0,L.$Pc)(()=>{this.n.delete(n,I),this.h.fire(n)}));return this.h.fire(n),w}getViewWelcomeContent(n){const o=[];return this.n.forEach(n,w=>o.push(w)),o.sort(i)}r(n,o){let w=this.m.get(o);w||(w=[],this.m.set(o,w),this.j.push(o));for(const d of n){if(this.getView(d.id)!==null)throw new Error((0,M.localize)(2,null,d.id));w.push(d)}}s(n,o){const w=this.m.get(o);if(!w)return[];const d=[],I=[];for(const S of w)n.includes(S)?d.push(S):I.push(S);return d.length&&(I.length?this.m.set(o,I):(this.m.delete(o),this.j.splice(this.j.indexOf(o),1))),d}}l.$cn.add(c.ViewsRegistry,new a),e.$jE=(0,C.$Nh)("viewsService"),e.$kE=(0,C.$Nh)("viewDescriptorService");var b;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(b||(e.ViewVisibilityState=b={}));var E;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(E||(e.TreeItemCollapsibleState=E={}));class v{constructor(n,o){this.c=!1,this.d=!1,(0,f.$6m)(this,n),this.d=!!o,this.resolve=async w=>{if(o&&!this.c){const d=await o(w);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}w.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$lE=v;class r extends Error{constructor(n){super((0,M.localize)(3,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$mE=r}),define(Re[193],Me([1,0,5,12,161]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new y.$Md,this.n=new y.$Md,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(l){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=l}onEvent(l){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=l}onRequest(l){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=l}sendResponse(l){l.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${l.command}`)):this.s("response",l)}sendRequest(l,k,f,R){const D={command:l};if(k&&Object.keys(k).length>0&&(D.arguments=k),this.s("request",D),typeof R=="number"){const c=setTimeout(()=>{clearTimeout(c);const p=this.f.get(D.seq);if(p){this.f.delete(D.seq);const $={type:"response",seq:0,request_seq:D.seq,success:!1,command:l,message:(0,C.localize)(0,null,R,l)};p($)}},R)}return f&&this.f.set(D.seq,f),D.seq}acceptMessage(l){this.j?this.j(l):(this.k.push(l),this.k.length===1&&this.q())}o(l,k){return l.type!=="event"||k.type!=="event"}async q(){let l;for(;this.k.length;){if((!l||this.o(this.k[0],l))&&await(0,M.$Tg)(0),l=this.k.shift(),!l)return;switch(l.type){case"event":this.i?.(l);break;case"request":this.g?.(l);break;case"response":{const k=l,f=this.f.get(k.request_seq);f&&(this.f.delete(k.request_seq),f(k));break}}}}s(l,k){k.type=l,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const l=new Map;this.f.forEach((k,f)=>l.set(f,k)),await(0,M.$Tg)(500),l.forEach((k,f)=>{k({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Ycb=L}),define(Re[194],Me([1,0,162,32,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$3G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$2G=e.MemoryRangeType=e.$1G=e.State=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=void 0,e.$YF="workbench.view.debug",e.$ZF="workbench.debug.variablesView",e.$1F="workbench.debug.watchExpressionsView",e.$2F="workbench.debug.callStackView",e.$3F="workbench.debug.loadedScriptsView",e.$4F="workbench.debug.breakPointsView",e.$5F="workbench.debug.disassemblyView",e.$6F="workbench.panel.repl",e.$7F="workbench.panel.repl.view",e.$8F=new M.$5i("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$9F=new M.$5i("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$0F=new M.$5i("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$$F="debugUx",e.$_F=new M.$5i(e.$$F,"default",{type:"string",description:y.localize(3,null)}),e.$aG=new M.$5i("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$bG=new M.$5i("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$cG=new M.$5i("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$dG=new M.$5i("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$eG=new M.$5i("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$fG=new M.$5i("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$gG=new M.$5i("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$hG=new M.$5i("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$iG=new M.$5i("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$jG=new M.$5i("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$kG=new M.$5i("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$lG=new M.$5i("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$mG=new M.$5i("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$nG=new M.$5i("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$oG=new M.$5i("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$pG=new M.$5i("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$qG=new M.$5i("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$rG=new M.$5i("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$sG=new M.$5i("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$tG=new M.$5i("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$uG=new M.$5i("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$vG=new M.$5i("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$wG=new M.$5i("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$xG=new M.$5i("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$yG=new M.$5i("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$zG=new M.$5i("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$AG=new M.$5i("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$BG=new M.$5i("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$CG=new M.$5i("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$DG=new M.$5i("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$EG=new M.$5i("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$FG=new M.$5i("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$GG=new M.$5i("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$HG=new M.$5i("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$IG=new M.$5i("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$JG=new M.$5i("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$KG=new M.$5i("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$LG=new M.$5i("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$MG=new M.$5i("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$NG=new M.$5i("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$OG=new M.$5i("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$PG=new M.$5i("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$QG=new M.$5i("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$RG=new M.$5i("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$SG=new M.$5i("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$TG=new M.$5i("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$UG=new M.$5i("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const L=c=>y.localize(51,null,c);e.$VG=L,e.$WG="editor.contrib.debug",e.$XG="editor.contrib.breakpoint",e.$YG="debug",e.$ZG={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(A||(e.State=A={}));function l(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$1G=l;var k;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$2G="vscode-debug-memory";var f;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var R;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$3G=(0,C.$Nh)("debugService");var D;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Re[195],Me([1,0,15,2,19,24,13,45,21,18]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=void 0;const R=/{([^}]+)}/g;function D(S,u,g){return S.replace(R,function(h,P){return u&&P.length>0&&P[0]!=="_"?h:g&&g.hasOwnProperty(P)?g[P]:h})}e.$nF=D;function c(S){const u={};for(const g of Object.keys(S))g.startsWith("!")||(u[g]=S[g]);return u}e.$oF=c;function p(S){return S.configuration.request==="attach"&&!$(S)&&(!S.parentSession||p(S.parentSession))}e.$pF=p;function $(S){let u=S.configuration.type;if(u)return u==="vslsShare"&&(u=S.configuration.adapterProxy.configuration.type),(0,y.$1e)(u,"extensionhost")||(0,y.$1e)(u,"pwa-extensionhost")?S:S.parentSession?$(S.parentSession):void 0}e.$qF=$;function m(S){return S.type&&(S.label||S.program||S.runtime)}e.$rF=m;function t(S,u,g){let h,P=0;const W=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let K=null;for(;K=W.exec(S);){const j=K.index+1,B=j+K[0].length;if(j<=u&&B>=g){h=K[0],P=j;break}}if(h){const j=/\w+/g;let B=null;for(;(B=j.exec(h))&&!(B.index+1+P+B[0].length>=g););B&&(h=h.substring(0,j.lastIndex))}return h?{start:P,end:P+h.length-1}:{start:0,end:0}}e.$sF=t;async function i(S,u,g,h){if(S.evaluatableExpressionProvider.has(u)){const P=S.evaluatableExpressionProvider.ordered(u),W=(0,f.$Gb)(await Promise.all(P.map(async K=>{try{return await K.provideEvaluatableExpression(u,g,h??k.CancellationToken.None)}catch{return}})));if(W.length>0){let K=W[0].expression;const j=W[0].range;return K||(K=u.getLineContent(g.lineNumber).substring(j.startColumn-1,j.endColumn-1)),{range:j,matchingExpression:K}}}else{const P=u.getLineContent(g.lineNumber),{start:W,end:K}=t(P,g.column,g.column),j=P.substring(W-1,K);return{matchingExpression:j,range:new l.$ps(g.lineNumber,W,g.lineNumber,W+j.length)}}return null}e.$tF=i;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(S){return!!(S&&S.match(a))}e.$uF=b;function E(S){if(typeof S.path=="string"&&!(typeof S.sourceReference=="number"&&S.sourceReference>0)){if(b(S.path))return M.URI.parse(S.path);if((0,C.$hc)(S.path))return M.URI.file(S.path)}return S.path}function v(S){if(typeof S.path=="object"){const u=M.URI.revive(S.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return S.path}function r(S,u){const g=u?E:v,h=(0,L.$3m)(S);return n(h,(P,W)=>{P&&W&&(W.path=g(W))}),h}e.$vF=r;function s(S,u){const g=u?E:v,h=(0,L.$3m)(S);return n(h,(P,W)=>{!P&&W&&(W.path=g(W))}),h}e.$wF=s;function n(S,u){switch(S.type){case"event":{const g=S;switch(g.event){case"output":u(!1,g.body.source);break;case"loadedSource":u(!1,g.body.source);break;case"breakpoint":u(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=S;switch(g.command){case"setBreakpoints":u(!0,g.arguments.source);break;case"breakpointLocations":u(!0,g.arguments.source);break;case"source":u(!0,g.arguments.source);break;case"gotoTargets":u(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(h=>u(!1,h));break;default:break}break}case"response":{const g=S;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(h=>u(!1,h.source));break;case"loadedSources":g.body.sources.forEach(h=>u(!1,h));break;case"scopes":g.body.scopes.forEach(h=>u(!1,h.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(h=>u(!1,h.source));break;case"setBreakpoints":g.body.breakpoints.forEach(h=>u(!1,h.source));break;case"disassemble":g.body?.instructions.forEach(P=>u(!1,P.location));break;default:break}break}}}function o(S){return S.filter(u=>!u.presentation?.hidden).sort((u,g)=>u.presentation?g.presentation?u.presentation.group?g.presentation.group?u.presentation.group!==g.presentation.group?u.presentation.group.localeCompare(g.presentation.group):w(u.presentation.order,g.presentation.order):-1:g.presentation.group?1:w(u.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$xF=o;function w(S,u){return typeof S!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:S-u}async function d(S,u){const g=S.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(g!=="none"&&(await u.saveAll(),g==="allEditorsInActiveGroup")){const h=u.activeEditorPane;h&&h.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:h.input,groupId:h.group.id})}await S.reloadConfiguration()}e.$yF=d;const I=(S,u)=>!S||!u?S===u:S.name===u.name&&S.path===u.path&&S.sourceReference===u.sourceReference;e.$zF=I}),define(Re[75],Me([1,0,26,37,65,66,13,19,22,32]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oI=e.$nI=e.$mI=e.$lI=e.CellStatusbarAlignment=e.$kI=e.$jI=e.$iI=e.NotebookEditorPriority=e.$hI=e.$gI=e.$fI=e.$eI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$dI=e.$cI=e.$bI=e.$aI=e.CellKind=e.$_H=e.$$H=e.$0H=void 0,e.$0H="workbench.editor.notebook",e.$$H="workbench.editor.notebookTextDiffEditor",e.$_H="workbench.editor.interactive";var R;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(R||(e.CellKind=R={})),e.$aI=["application/json","application/javascript","text/html","image/svg+xml",L.$Mr.latex,L.$Mr.markdown,"image/png","image/jpeg",L.$Mr.text],e.$bI=[L.$Mr.latex,L.$Mr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$Mr.text],e.$cI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$dI="_notAvailable";var D;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var c;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var p;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var $;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})($||(e.NotebookRendererMatch=$={}));var m;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var a;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var b;(function(N){N.scheme=A.Schemas.vscodeNotebookCell;const te=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${te.join("")}]+`),Ee=7;function Se($e,_){const z=_.toString(Ee),ue=`${z.length<te.length?te[z.length-1]:"z"}${z}s${(0,y.$ue)(y.$ae.fromString($e.scheme),!0,!0)}`;return $e.with({scheme:N.scheme,fragment:ue})}N.generate=Se;function Pe($e){if($e.scheme!==N.scheme)return;const _=$e.fragment.indexOf("s");if(_<0)return;const z=parseInt($e.fragment.substring(0,_).replace(Y,""),Ee),V=(0,y.$te)($e.fragment.substring(_+1)).toString();if(!isNaN(z))return{handle:z,notebook:$e.with({scheme:V,fragment:null})}}N.parse=Pe;function ge($e,_){return $e.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${_??""},${$e.scheme!==A.Schemas.file?$e.scheme:""}`})}N.generateCellOutputUri=ge;function me($e){if($e.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const _=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec($e.fragment);if(!_)return;const z=_[1]&&_[1]!==""?_[1]:void 0,V=_[2];return{outputId:z,notebook:$e.with({scheme:V||A.Schemas.file,fragment:null})}}N.parseCellOutputUri=me;function ce($e,_,z){return N.generate($e,_).with({scheme:z})}N.generateCellPropertyUri=ce;function se($e,_){if($e.scheme===_)return N.parse($e.with({scheme:N.scheme}))}N.parseCellPropertyUri=se})(b||(e.CellUri=b={}));const E=N=>k.$j?N.replace(/\//g,"\\"):N;class v{constructor(te=[],Y=e.$aI){this.e=Y,this.d=[...new Set(te)].map(Ee=>({pattern:Ee,matches:M.$uj(E(Ee))}))}sort(te){const Y=new Map(C.Iterable.map(te,Se=>[Se,E(Se)]));let Ee=[];for(const{matches:Se}of this.d)for(const[Pe,ge]of Y)if(Se(ge)){Ee.push(Pe),Y.delete(Pe);break}return Y.size&&(Ee=Ee.concat([...Y.keys()].sort((Se,Pe)=>this.e.indexOf(Se)-this.e.indexOf(Pe)))),Ee}prioritize(te,Y){const Ee=this.f(te);if(Ee===-1){this.d.unshift({pattern:te,matches:M.$uj(E(te))});return}const Se=new Set(Y.map(ge=>this.f(ge,Ee)));Se.delete(-1);const Pe=Array.from(Se).sort();this.d.splice(Ee+1,0,...Pe.map(ge=>this.d[ge]));for(let ge=Pe.length-1;ge>=0;ge--)this.d.splice(Pe[ge],1)}toArray(){return this.d.map(te=>te.pattern)}f(te,Y=this.d.length){const Ee=E(te);for(let Se=0;Se<Y;Se++)if(this.d[Se].matches(Ee))return Se;return-1}}e.$eI=v;function r(N,te,Y,Ee=(Se,Pe)=>Se===Pe){const Se=[];function Pe(ce,se,$e){if(se===0&&$e.length===0)return;const _=Se[Se.length-1];_&&_.start+_.deleteCount===ce?(_.deleteCount+=se,_.toInsert.push(...$e)):Se.push({start:ce,deleteCount:se,toInsert:$e})}let ge=0,me=0;for(;;){if(ge===N.length){Pe(ge,0,te.slice(me));break}if(me===te.length){Pe(ge,N.length-ge,[]);break}const ce=N[ge],se=te[me];if(Ee(ce,se)){ge+=1,me+=1;continue}Y(se)?(Pe(ge,1,[]),ge+=1):(Pe(ge,0,[se]),me+=1)}return Se}e.$fI=r,e.$gI=new f.$5i("notebookEditorCursorAtBoundary","none"),e.$hI=new f.$5i("notebookEditorCursorAtLineBoundary","none");var s;(function(N){N.default="default",N.option="option"})(s||(e.NotebookEditorPriority=s={}));function n(N){const te=N;return!!((typeof te.include=="string"||M.$vj(te.include))&&(typeof te.exclude=="string"||M.$vj(te.exclude)))}e.$iI=n;function o(N,te,Y){if(Array.isArray(N.viewType)&&N.viewType.indexOf(te)>=0||N.viewType===te)return!0;if(N.filenamePattern){const Ee=n(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,Se=n(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(M.$tj(Ee,(0,l.$mc)(Y.fsPath).toLowerCase()))return!(Se&&M.$tj(Se,(0,l.$mc)(Y.fsPath).toLowerCase()))}return!1}e.$jI=o,e.$kI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var w;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(w||(e.CellStatusbarAlignment=w={}));class d{static{this.d="notebook/"}static create(te){return`${d.d}${te}`}static parse(te){if(te.startsWith(d.d))return te.substring(d.d.length)}}e.$lI=d;function I(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$mI=I;const S=new TextDecoder;function u(N){const te=[];let Y=!1;for(const ge of N)(te.length===0||Y)&&(te.push(ge),Y=!0);let Ee=P(te);const Se=y.$ae.concat(te.map(ge=>y.$ae.wrap(ge))),Pe=O(Se);return Ee=Ee||Pe.byteLength!==Se.byteLength,{data:Pe,didCompression:Ee}}e.$nI=u,e.$oI=`${String.fromCharCode(27)}[A`;const g=e.$oI.split("").map(N=>N.charCodeAt(0)),h=10;function P(N){let te=!1;return N.forEach((Y,Ee)=>{if(Ee===0||Y.length<e.$oI.length)return;const Se=N[Ee-1],Pe=Y.subarray(0,e.$oI.length);if(Pe[0]===g[0]&&Pe[1]===g[1]&&Pe[2]===g[2]){const ge=Se.lastIndexOf(h);if(ge===-1)return;te=!0,N[Ee-1]=Se.subarray(0,ge),N[Ee]=Y.subarray(e.$oI.length)}}),te}function W(N){let te=N;do N=te,te=N.replace(/[^\n]\x08/gm,"");while(te.length<N.length);return N}function K(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const te=N.match(/^(.*)\r+/m)[1];let Y=N.match(/\r+(.*)$/m)[1];Y=Y+te.slice(Y.length,te.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return N}const j="\b".charCodeAt(0),B="\r".charCodeAt(0);function O(N){return!N.buffer.includes(j)&&!N.buffer.includes(B)?N:y.$ae.fromString(K(W(S.decode(N.buffer))))}}),define(Re[7],Me([1,0,18,9,50,28,66,15,16,2,36,20,38,97,75]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$){"use strict";var m,t,i,a,b,E,v,r,s,n,o,w,d,I,S,u,g,h;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$3L=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$2L=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.TestRunProfileKind=e.TestResultState=e.$JL=e.$IL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$HL=e.$GL=e.$FL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$EL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.ColorThemeKind=e.$yL=e.$xL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$wL=e.DebugConsoleMode=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$qL=e.$pL=e.FileChangeType=e.$oL=e.$nL=e.$mL=e.$lL=e.InlineCompletionTriggerKind=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.ConfigurationTarget=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$1K=e.ViewBadge=e.ProgressLocation=e.$ZK=e.$YK=e.TaskScope=e.ShellQuoting=e.$XK=e.$WK=e.$VK=e.TaskPanelKind=e.TaskRevealKind=e.$UK=e.TerminalLocation=e.$TK=e.$SK=e.$RK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$QK=e.$PK=e.$OK=e.$NK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$MK=e.StatusBarAlignment=e.ViewColumn=e.$LK=e.$KK=e.$JK=e.$IK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$HK=e.$GK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.LanguageStatusSeverity=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.CodeActionTriggerKind=e.$uK=e.$tK=e.SymbolTag=e.SymbolKind=e.$sK=e.DocumentHighlightKind=e.$rK=e.$qK=e.$pK=e.$oK=e.DiagnosticSeverity=e.DiagnosticTag=e.$nK=e.$mK=e.FileEditType=e.$lK=e.$kK=e.$jK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(U){return Object.assign(U,{apply:function(...ie){if(ie.length===0)return Reflect.construct(U,[]);{const ke=ie.length===1?[]:ie[1];return Reflect.construct(U,ke,ie[0].constructor)}},call:function(...ie){if(ie.length===0)return Reflect.construct(U,[]);{const[ke,...He]=ie;return Reflect.construct(U,He,ke.constructor)}}})}var W;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var K;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(K||(e.TerminalQuickFixType=K={}));let j=m=class{static from(...T){let ie=T;return new m(function(){if(ie){for(const ke of ie)ke&&typeof ke.dispose=="function"&&ke.dispose();ie=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$cK=j,e.$cK=j=m=qe([P],j);let B=t=class{static Min(...T){if(T.length===0)throw new TypeError;let ie=T[0];for(let ke=1;ke<T.length;ke++){const He=T[ke];He.isBefore(ie)&&(ie=He)}return ie}static Max(...T){if(T.length===0)throw new TypeError;let ie=T[0];for(let ke=1;ke<T.length;ke++){const He=T[ke];He.isAfter(ie)&&(ie=He)}return ie}static isPosition(T){if(!T)return!1;if(T instanceof t)return!0;const{line:ie,character:ke}=T;return typeof ie=="number"&&typeof ke=="number"}static of(T){if(T instanceof t)return T;if(this.isPosition(T))return new t(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,ie){if(T<0)throw(0,M.$6)("line must be non-negative");if(ie<0)throw(0,M.$6)("character must be non-negative");this.c=T,this.e=ie}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,ie=0){if(T===null||ie===null)throw(0,M.$6)();let ke;return typeof T>"u"?ke=0:typeof T=="number"?ke=T:(ke=typeof T.lineDelta=="number"?T.lineDelta:0,ie=typeof T.characterDelta=="number"?T.characterDelta:0),ke===0&&ie===0?this:new t(this.line+ke,this.character+ie)}with(T,ie=this.character){if(T===null||ie===null)throw(0,M.$6)();let ke;return typeof T>"u"?ke=this.line:typeof T=="number"?ke=T:(ke=typeof T.line=="number"?T.line:this.line,ie=typeof T.character=="number"?T.character:this.character),ke===this.line&&ie===this.character?this:new t(ke,ie)}toJSON(){return{line:this.line,character:this.character}}};e.$dK=B,e.$dK=B=t=qe([P],B);let O=i=class{static isRange(T){return T instanceof i?!0:T?B.isPosition(T.start)&&B.isPosition(T.end):!1}static of(T){if(T instanceof i)return T;if(this.isRange(T))return new i(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,ie,ke,He){let Ye,ot;if(typeof T=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof He=="number"?(Ye=new B(T,ie),ot=new B(ke,He)):B.isPosition(T)&&B.isPosition(ie)&&(Ye=B.of(T),ot=B.of(ie)),!Ye||!ot)throw new Error("Invalid arguments");Ye.isBefore(ot)?(this.c=Ye,this.e=ot):(this.c=ot,this.e=Ye)}contains(T){return i.isRange(T)?this.contains(T.start)&&this.contains(T.end):B.isPosition(T)?!(B.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const ie=B.Max(T.start,this.c),ke=B.Min(T.end,this.e);if(!ie.isAfter(ke))return new i(ie,ke)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const ie=B.Min(T.start,this.c),ke=B.Max(T.end,this.end);return new i(ie,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,ie=this.end){if(T===null||ie===null)throw(0,M.$6)();let ke;return T?B.isPosition(T)?ke=T:(ke=T.start||this.start,ie=T.end||this.end):ke=this.start,ke.isEqual(this.c)&&ie.isEqual(this.end)?this:new i(ke,ie)}toJSON(){return[this.start,this.end]}};e.$eK=O,e.$eK=O=i=qe([P],O);let N=a=class extends O{static isSelection(T){return T instanceof a?!0:T?O.isRange(T)&&B.isPosition(T.anchor)&&B.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,ie,ke,He){let Ye,ot;if(typeof T=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof He=="number"?(Ye=new B(T,ie),ot=new B(ke,He)):B.isPosition(T)&&B.isPosition(ie)&&(Ye=B.of(T),ot=B.of(ie)),!Ye||!ot)throw new Error("Invalid arguments");super(Ye,ot),this.f=Ye,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$fK=N,e.$fK=N=a=qe([P],N);const te=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,M.$6)("connectionToken")};class Y{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ie,ke){if(typeof T!="string"||T.length===0)throw(0,M.$6)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,M.$6)("port");typeof ke<"u"&&te(ke),this.host=T,this.port=Math.round(ie),this.connectionToken=ke}}e.$gK=Y;class Ee{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,ie){this.makeConnection=T,this.connectionToken=ie,typeof ie<"u"&&te(ie)}}e.$hK=Ee;class Se extends Error{static NotAvailable(T,ie){return new Se(T,p.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(T){return new Se(T,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,ie=p.RemoteAuthorityResolverErrorCode.Unknown,ke){super(T),this._message=T,this._code=ie,this._detail=ke,Object.setPrototypeOf(this,Se.prototype)}}e.$iK=Se;var Pe;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(Pe||(e.EndOfLine=Pe={}));var ge;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(ge||(e.EnvironmentVariableMutatorType=ge={}));let me=b=class{static isTextEdit(T){return T instanceof b?!0:T?O.isRange(T)&&typeof T.newText=="string":!1}static replace(T,ie){return new b(T,ie)}static insert(T,ie){return b.replace(new O(T,T),ie)}static delete(T){return b.replace(T,"")}static setEndOfLine(T){const ie=new b(new O(new B(0,0),new B(0,0)),"");return ie.newEol=T,ie}get range(){return this.c}set range(T){if(T&&!O.isRange(T))throw(0,M.$6)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,M.$6)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,M.$6)("newEol");this.f=T}constructor(T,ie){this.c=T,this.e=ie}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$jK=me,e.$jK=me=b=qe([P],me);let ce=E=class{static isNotebookCellEdit(T){return T instanceof E?!0:T?xt.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,ie){return new E(T,ie)}static insertCells(T,ie){return new E(new xt(T,T),ie)}static deleteCells(T){return new E(T,[])}static updateCellMetadata(T,ie){const ke=new E(new xt(T,T),[]);return ke.newCellMetadata=ie,ke}static updateNotebookMetadata(T){const ie=new E(new xt(0,0),[]);return ie.newNotebookMetadata=T,ie}constructor(T,ie){this.range=T,this.newCells=ie}};e.$kK=ce,e.$kK=ce=E=qe([P],ce);class se{static isSnippetTextEdit(T){return T instanceof se?!0:T?O.isRange(T.range)&&z.isSnippetString(T.snippet):!1}static replace(T,ie){return new se(T,ie)}static insert(T,ie){return se.replace(new O(T,T),ie)}constructor(T,ie){this.range=T,this.snippet=ie}}e.$lK=se;var $e;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let _=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,ie,ke,He){this.c.push({_type:1,from:T,to:ie,options:ke,metadata:He})}createFile(T,ie,ke){this.c.push({_type:1,from:void 0,to:T,options:ie,metadata:ke})}deleteFile(T,ie,ke){this.c.push({_type:1,from:T,to:void 0,options:ie,metadata:ke})}e(T,ie,ke){this.c.push({_type:3,metadata:ke,uri:T,edit:{editType:5,metadata:ie},notebookMetadata:ie})}f(T,ie,ke,He){const Ye=ie.start,ot=ie.end;(Ye!==ot||ke.length>0)&&this.c.push({_type:5,uri:T,index:Ye,count:ot-Ye,cells:ke,metadata:He})}g(T,ie,ke,He){this.c.push({_type:3,metadata:He,uri:T,edit:{editType:3,index:ie,metadata:ke}})}replace(T,ie,ke,He){this.c.push({_type:2,uri:T,edit:new me(ie,ke),metadata:He})}insert(T,ie,ke,He){this.replace(T,new O(ie,ie),ke,He)}delete(T,ie,ke){this.replace(T,ie,"",ke)}has(T){return this.c.some(ie=>ie._type===2&&ie.uri.toString()===T.toString())}set(T,ie){if(ie)for(const ke of ie){if(!ke)continue;let He,Ye;Array.isArray(ke)?(He=ke[0],Ye=ke[1]):He=ke,ce.isNotebookCellEdit(He)?He.newCellMetadata?this.g(T,He.range.start,He.newCellMetadata,Ye):He.newNotebookMetadata?this.e(T,He.newNotebookMetadata,Ye):this.f(T,He.range,He.newCells,Ye):se.isSnippetTextEdit(He)?this.c.push({_type:6,uri:T,range:He.range,edit:He.snippet,metadata:Ye}):this.c.push({_type:2,uri:T,edit:He,metadata:Ye})}else{for(let ke=0;ke<this.c.length;ke++){const He=this.c[ke];switch(He._type){case 2:case 6:case 3:case 5:He.uri.toString()===T.toString()&&(this.c[ke]=void 0);break}}(0,y.$Hb)(this.c)}}get(T){const ie=[];for(const ke of this.c)ke._type===2&&ke.uri.toString()===T.toString()&&ie.push(ke.edit);return ie}entries(){const T=new L.$zc;for(const ie of this.c)if(ie._type===2){let ke=T.get(ie.uri);ke||(ke=[ie.uri,[]],T.set(ie.uri,ke)),ke[1].push(ie.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$mK=_,e.$mK=_=qe([P],_);let z=v=class{static isSnippetString(T){return T instanceof v?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=v.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,ie=this.e++){if(typeof T=="function"){const ke=new v;ke.e=this.e,T(ke),this.e=ke.e,T=ke.value}else T=v.c(T);return this.value+="${",this.value+=ie,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,ie=this.e++){const ke=T.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(T,ie){if(typeof ie=="function"){const ke=new v;ke.e=this.e,ie(ke),this.e=ke.e,ie=ke.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};e.$nK=z,e.$nK=z=v=qe([P],z);var V;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ue;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(ue||(e.DiagnosticSeverity=ue={}));let ye=r=class{static isLocation(T){return T instanceof r?!0:T?O.isRange(T.range)&&f.URI.isUri(T.uri):!1}constructor(T,ie){if(this.uri=T,ie)if(O.isRange(ie))this.range=O.of(ie);else if(B.isPosition(ie))this.range=new O(ie,ie);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$oK=ye,e.$oK=ye=r=qe([P],ye);let be=class{static is(T){return T?typeof T.message=="string"&&T.location&&O.isRange(T.location.range)&&f.URI.isUri(T.location.uri):!1}constructor(T,ie){this.location=T,this.message=ie}static isEqual(T,ie){return T===ie?!0:!T||!ie?!1:T.message===ie.message&&T.location.range.isEqual(ie.location.range)&&T.location.uri.toString()===ie.location.uri.toString()}};e.$pK=be,e.$pK=be=qe([P],be);let pe=class{constructor(T,ie,ke=ue.Error){if(!O.isRange(T))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=T,this.message=ie,this.severity=ke}toJSON(){return{severity:ue[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,ie){return T===ie?!0:!T||!ie?!1:T.message===ie.message&&T.severity===ie.severity&&T.code===ie.code&&T.severity===ie.severity&&T.source===ie.source&&T.range.isEqual(ie.range)&&(0,y.$tb)(T.tags,ie.tags)&&(0,y.$tb)(T.relatedInformation,ie.relatedInformation,be.isEqual)}};e.$qK=pe,e.$qK=pe=qe([P],pe);let De=class{constructor(T,ie){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=ie}};e.$rK=De,e.$rK=De=qe([P],De);var ne;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(ne||(e.DocumentHighlightKind=ne={}));let le=class{constructor(T,ie=ne.Text){this.range=T,this.kind=ie}toJSON(){return{range:this.range,kind:ne[this.kind]}}};e.$sK=le,e.$sK=le=qe([P],le);var re;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(re||(e.SymbolKind=re={}));var oe;(function(U){U[U.Deprecated=1]="Deprecated"})(oe||(e.SymbolTag=oe={}));let de=s=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,ie,ke,He,Ye){this.name=T,this.kind=ie,this.containerName=Ye,typeof ke=="string"&&(this.containerName=ke),He instanceof ye?this.location=He:ke instanceof O&&(this.location=new ye(He,ke)),s.validate(this)}toJSON(){return{name:this.name,kind:re[this.kind],location:this.location,containerName:this.containerName}}};e.$tK=de,e.$tK=de=s=qe([P],de);let Ie=n=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(n.validate)}constructor(T,ie,ke,He,Ye){this.name=T,this.detail=ie,this.kind=ke,this.range=He,this.selectionRange=Ye,this.children=[],n.validate(this)}};e.$uK=Ie,e.$uK=Ie=n=qe([P],Ie);var F;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(F||(e.CodeActionTriggerKind=F={}));let q=class{constructor(T,ie){this.title=T,this.kind=ie}};e.$vK=q,e.$vK=q=qe([P],q);let J=class{static{o=this}static{this.c="."}constructor(T){this.value=T}append(T){return new o(this.value?this.value+o.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+o.c)}};e.$wK=J,e.$wK=J=o=qe([P],J),J.Empty=new J(""),J.QuickFix=J.Empty.append("quickfix"),J.Refactor=J.Empty.append("refactor"),J.RefactorExtract=J.Refactor.append("extract"),J.RefactorInline=J.Refactor.append("inline"),J.RefactorMove=J.Refactor.append("move"),J.RefactorRewrite=J.Refactor.append("rewrite"),J.Source=J.Empty.append("source"),J.SourceOrganizeImports=J.Source.append("organizeImports"),J.SourceFixAll=J.Source.append("fixAll"),J.Notebook=J.Empty.append("notebook");let Q=class{constructor(T,ie){if(this.range=T,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$xK=Q,e.$xK=Q=qe([P],Q);class H{constructor(T,ie,ke,He,Ye,ot){this.kind=T,this.name=ie,this.detail=ke,this.uri=He,this.range=Ye,this.selectionRange=ot}}e.$yK=H;class x{constructor(T,ie){this.fromRanges=ie,this.from=T}}e.$zK=x;class ae{constructor(T,ie){this.fromRanges=ie,this.to=T}}e.$AK=ae;var Le;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Le||(e.LanguageStatusSeverity=Le={}));let je=class{constructor(T,ie){this.range=T,this.command=ie}get isResolved(){return!!this.command}};e.$BK=je,e.$BK=je=qe([P],je);let Qe=w=class{#e;static isMarkdownString(T){return T instanceof w?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,ie=!1){this.#e=new C.$1j(T,{supportThemeIcons:ie})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,ie){return this.#e.appendCodeblock(ie??"",T),this}};e.$CK=Qe,e.$CK=Qe=w=qe([P],Qe);let Ge=class{constructor(T,ie){this.label=T,this.documentation=ie}};e.$DK=Ge,e.$DK=Ge=qe([P],Ge);let xe=class{constructor(T,ie){this.label=T,this.documentation=ie,this.parameters=[]}};e.$EK=xe,e.$EK=xe=qe([P],xe);let Xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$FK=Xe,e.$FK=Xe=qe([P],Xe);var _e;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(_e||(e.SignatureHelpTriggerKind=_e={}));var it;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let tt=class{constructor(T){this.value=T}};e.$GK=tt,e.$GK=tt=qe([P],tt);let ze=class{constructor(T,ie,ke){this.position=T,this.label=ie,this.kind=ke}};e.$HK=ze,e.$HK=ze=qe([P],ze);var st;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(st||(e.CompletionTriggerKind=st={}));var X;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})(X||(e.CompletionItemKind=X={}));var Z;(function(U){U[U.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let ve=class{constructor(T,ie){this.label=T,this.kind=ie}toJSON(){return{label:this.label,kind:this.kind&&X[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$IK=ve,e.$IK=ve=qe([P],ve);let Ue=class{constructor(T=[],ie=!1){this.items=T,this.isIncomplete=ie}};e.$JK=Ue,e.$JK=Ue=qe([P],Ue);let Oe=class{constructor(T,ie,ke){this.insertText=T,this.range=ie,this.command=ke}};e.$KK=Oe,e.$KK=Oe=qe([P],Oe);let Ze=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$LK=Ze,e.$LK=Ze=qe([P],Ze);var rt;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var mt;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(mt||(e.StatusBarAlignment=mt={}));function wt(U,T){return`${D.$3l.toKey(U)}.${T}`}e.$MK=wt;var Ct;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative"})(Ct||(e.TextEditorLineNumbersStyle=Ct={}));var Yt;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var qt;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(qt||(e.TextEditorRevealType=qt={}));var bt;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(bt||(e.TextEditorSelectionChangeKind=bt={}));var Ut;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(Ut||(e.TextDocumentChangeReason=Ut={}));var Lt;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(Lt||(e.DecorationRangeBehavior=Lt={})),function(U){function T(ie){switch(ie){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=T}(bt||(e.TextEditorSelectionChangeKind=bt={}));var Bt;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(U){function T(ie){switch(ie){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=T}(Bt||(e.SyntaxTokenType=Bt={}));let Pt=class{constructor(T,ie){if(ie&&!f.URI.isUri(ie))throw(0,M.$6)("target");if(!O.isRange(T)||T.isEmpty)throw(0,M.$6)("range");this.range=T,this.target=ie}};e.$NK=Pt,e.$NK=Pt=qe([P],Pt);let At=class{constructor(T,ie,ke,He){this.red=T,this.green=ie,this.blue=ke,this.alpha=He}};e.$OK=At,e.$OK=At=qe([P],At);let Nt=class{constructor(T,ie){if(ie&&!(ie instanceof At))throw(0,M.$6)("color");if(!O.isRange(T)||T.isEmpty)throw(0,M.$6)("range");this.range=T,this.color=ie}};e.$PK=Nt,e.$PK=Nt=qe([P],Nt);let Wt=class{constructor(T){if(!T||typeof T!="string")throw(0,M.$6)("label");this.label=T}};e.$QK=Wt,e.$QK=Wt=qe([P],Wt);var Ht;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Kt;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var at;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class ut{constructor(T,ie,ke){if(this.startIndex=T,this.length=ie,this.tooltip=ke,typeof T!="number"||T<0)throw(0,M.$6)("startIndex");if(typeof ie!="number"||ie<1)throw(0,M.$6)("length");if(ke!==void 0&&typeof ke!="string")throw(0,M.$6)("tooltip")}}e.$RK=ut;class Jt{constructor(T){this.uri=T}}e.$SK=Jt;class It{constructor(T){this.terminalCommand=T}}e.$TK=It;var Et;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class dt{constructor(T){if(this.options=T,typeof T!="object")throw(0,M.$6)("options")}}e.$UK=dt;var kt;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(kt||(e.TaskRevealKind=kt={}));var Tt;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(Tt||(e.TaskPanelKind=Tt={}));let yt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(T){switch(T){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(T,ie){if(this.label=ie,typeof T!="string"||typeof ie!="string")throw(0,M.$6)("name");this.c=T}get id(){return this.c}};e.$VK=yt,e.$VK=yt=d=qe([P],yt);function Ke(U){let T="";for(let ie=0;ie<U.length;ie++)T+=U[ie].replace(/,/g,",,")+",";return T}let Ot=class{constructor(T,ie,ke){if(typeof T!="string")throw(0,M.$6)("process");this.e=[],this.c=T,ie!==void 0&&(Array.isArray(ie)?(this.e=ie,this.f=ke):this.f=ie)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,M.$6)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const ie of this.e)T.push(ie);return Ke(T)}};e.$WK=Ot,e.$WK=Ot=qe([P],Ot);let zt=class{constructor(T,ie,ke){if(this.f=[],Array.isArray(ie)){if(!T)throw(0,M.$6)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$6)("command");this.e=T,this.f=ie,this.g=ke}else{if(typeof T!="string")throw(0,M.$6)("commandLine");this.c=T,this.g=ie}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,M.$6)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,M.$6)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ie of this.f)T.push(typeof ie=="string"?ie:ie.value);return Ke(T)}};e.$XK=zt,e.$XK=zt=qe([P],zt);var Ce;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(Ce||(e.ShellQuoting=Ce={}));var Ae;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Ae||(e.TaskScope=Ae={}));class fe{constructor(T){this.c=T}computeId(){return"customExecution"+(0,R.$dg)()}set callback(T){this.c=T}get callback(){return this.c}}e.$YK=fe;let G=class{static{I=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,ie,ke,He,Ye,ot){this.j=!1,this.k=this.definition=T;let lt;typeof ie=="string"?(this.m=this.name=ie,this.t=this.source=ke,this.execution=He,lt=Ye,this.j=!0):ie===Ae.Global||ie===Ae.Workspace?(this.target=ie,this.m=this.name=ke,this.t=this.source=He,this.execution=Ye,lt=ot):(this.target=ie,this.m=this.name=ke,this.t=this.source=He,this.execution=Ye,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof Ot?this.k={type:I.e,id:this.n.computeId()}:this.n instanceof zt?this.k={type:I.f,id:this.n.computeId()}:this.n instanceof fe?this.k={type:I.c,id:this.n.computeId()}:this.k={type:I.g,id:(0,R.$dg)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,M.$6)("Kind can't be undefined or null");this.z(),this.k=T}get scope(){return this.l}set target(T){this.z(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,M.$6)("name");this.z(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.z(),this.n=T;const ie=this.k.type;(I.g===ie||I.e===ie||I.f===ie||I.c===ie)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.z(),this.o=T,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.z(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,M.$6)("source must be a string of length > 0");this.z(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.z(),this.u=T}get detail(){return this.y}set detail(T){T===null&&(T=void 0),this.y=T}get presentationOptions(){return this.w}set presentationOptions(T){T==null&&(T=Object.create(null)),this.z(),this.w=T}get runOptions(){return this.x}set runOptions(T){T==null&&(T=Object.create(null)),this.z(),this.x=T}};e.$ZK=G,e.$ZK=G=I=qe([P],G);var Fe;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Fe||(e.ProgressLocation=Fe={}));var Be;(function(U){function T(ie){const ke=ie;return(0,k.$Bf)(ke.value)?ke.tooltip&&!(0,k.$xf)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}U.isViewBadge=T})(Be||(e.ViewBadge=Be={}));let Je=S=class{static isTreeItem(T,ie){const ke=T;if(ke.checkboxState!==void 0){const He=(0,k.$Bf)(ke.checkboxState)?ke.checkboxState:(0,k.$zf)(ke.checkboxState)&&(0,k.$Bf)(ke.checkboxState.state)?ke.checkboxState.state:void 0,Ye=!(0,k.$Bf)(ke.checkboxState)&&(0,k.$zf)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(He===void 0||He!==et.Checked&&He!==et.Unchecked||Ye!==void 0&&!(0,k.$xf)(Ye))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(T instanceof S)return!0;if(ke.label!==void 0&&!(0,k.$xf)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,k.$xf)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,k.$xf)(ke.iconPath)&&!f.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,k.$xf)(ke.iconPath.id))){const He=ke.iconPath;if(!He||!(0,k.$xf)(He.light)&&!f.URI.isUri(He.light)&&!(0,k.$xf)(He.dark)&&!f.URI.isUri(He.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,k.$xf)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!f.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,k.$xf)(ke.tooltip)&&!(ke.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<Ve.None&&ke.collapsibleState>Ve.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,k.$xf)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(T,ie=Ve.None){this.collapsibleState=ie,f.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$1K=Je,e.$1K=Je=S=qe([P],Je);var Ve;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(Ve||(e.TreeItemCollapsibleState=Ve={}));var et;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let gt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$2K=gt,e.$2K=gt=qe([P],gt);class ft extends gt{}e.$3K=ft;class pt extends ft{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$4K=pt;class ht{constructor(T,ie,ke,He){this.name=T,this.uri=ie,this._itemId=ke,this.c=He}data(){return this.c()}}e.$5K=ht;let Rt=class{#e=new Map;constructor(T){for(const[ie,ke]of T??[]){const He=this.#e.get(this.#t(ie));He?He.push(ke):this.#e.set(this.#t(ie),[ke])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,ie){this.#e.set(this.#t(T),[ie])}forEach(T,ie){for(const[ke,He]of this.#e)for(const Ye of He)T.call(ie,Ye,ke,this)}*[Symbol.iterator](){for(const[T,ie]of this.#e)for(const ke of ie)yield[T,ke]}#t(T){return T.toLowerCase()}};e.$6K=Rt,e.$6K=Rt=qe([P],Rt);let Gt=class{constructor(T){this.insertText=T}};e.$7K=Gt,e.$7K=Gt=qe([P],Gt);let Ei=class{constructor(T,ie){this.label=ie,this.insertText=T}};e.$8K=Ei,e.$8K=Ei=qe([P],Ei);let Vt=class{constructor(T,ie){this.id=T,this.color=ie}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$9K=Vt,e.$9K=Vt=qe([P],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let mi=class{constructor(T){this.id=T}};e.$0K=mi,e.$0K=mi=qe([P],mi);var St;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(St||(e.ConfigurationTarget=St={}));let Di=class{get base(){return this.c}set base(T){this.c=T,this.e=f.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,ie){if(typeof T!="string"&&(!T||!f.URI.isUri(T)&&!f.URI.isUri(T.uri)))throw(0,M.$6)("base");if(typeof ie!="string")throw(0,M.$6)("pattern");typeof T=="string"?this.baseUri=f.URI.file(T):f.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=ie}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$$K=Di,e.$$K=Di=qe([P],Di);const Ki=new WeakMap;function Dt(U,T){Ki.set(U,T)}e.$_K=Dt;let ii=class{constructor(T,ie,ke,He){this.enabled=typeof T=="boolean"?T:!0,typeof ie=="string"&&(this.condition=ie),typeof ke=="string"&&(this.hitCondition=ke),typeof He=="string"&&(this.logMessage=He)}get id(){return this.c||(this.c=Ki.get(this)??(0,R.$dg)()),this.c}};e.$aL=ii,e.$aL=ii=qe([P],ii);let $i=class extends ii{constructor(T,ie,ke,He,Ye){if(super(ie,ke,He,Ye),T===null)throw(0,M.$6)("location");this.location=T}};e.$bL=$i,e.$bL=$i=qe([P],$i);let oi=class extends ii{constructor(T,ie,ke,He,Ye){super(ie,ke,He,Ye),this.functionName=T}};e.$cL=oi,e.$cL=oi=qe([P],oi);let ki=class extends ii{constructor(T,ie,ke,He,Ye,ot,lt){if(super(He,Ye,ot,lt),!ie)throw(0,M.$6)("dataId");this.label=T,this.dataId=ie,this.canPersist=ke}};e.$dL=ki,e.$dL=ki=qe([P],ki);let Si=class{constructor(T,ie,ke){this.command=T,this.args=ie||[],this.options=ke}};e.$eL=Si,e.$eL=Si=qe([P],Si);let Mt=class{constructor(T,ie){this.port=T,this.host=ie}};e.$fL=Mt,e.$fL=Mt=qe([P],Mt);let pi=class{constructor(T){this.path=T}};e.$gL=pi,e.$gL=pi=qe([P],pi);let Ii=class{constructor(T){this.implementation=T}};e.$hL=Ii,e.$hL=Ii=qe([P],Ii);let ai=class{constructor(T,ie,ke){this.session=T,this.threadId=ie,this.frameId=ke}};e.$iL=ai,e.$iL=ai=qe([P],ai);let ci=class{constructor(T,ie){this.session=T,this.threadId=ie}};e.$jL=ci,e.$jL=ci=qe([P],ci);let ct=class{constructor(T,ie){this.range=T,this.expression=ie}};e.$kL=ct,e.$kL=ct=qe([P],ct);var Vi;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let Xt=class{constructor(T,ie){this.range=T,this.text=ie}};e.$lL=Xt,e.$lL=Xt=qe([P],Xt);let ni=class{constructor(T,ie,ke=!0){this.range=T,this.variableName=ie,this.caseSensitiveLookup=ke}};e.$mL=ni,e.$mL=ni=qe([P],ni);let vi=class{constructor(T,ie){this.range=T,this.expression=ie}};e.$nL=vi,e.$nL=vi=qe([P],vi);let Ci=class{constructor(T,ie){this.frameId=T,this.stoppedLocation=ie}};e.$oL=Ci,e.$oL=Ci=qe([P],Ci);var qi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(qi||(e.FileChangeType=qi={}));let Pi=u=class extends Error{static FileExists(T){return new u(T,c.FileSystemProviderErrorCode.FileExists,u.FileExists)}static FileNotFound(T){return new u(T,c.FileSystemProviderErrorCode.FileNotFound,u.FileNotFound)}static FileNotADirectory(T){return new u(T,c.FileSystemProviderErrorCode.FileNotADirectory,u.FileNotADirectory)}static FileIsADirectory(T){return new u(T,c.FileSystemProviderErrorCode.FileIsADirectory,u.FileIsADirectory)}static NoPermissions(T){return new u(T,c.FileSystemProviderErrorCode.NoPermissions,u.NoPermissions)}static Unavailable(T){return new u(T,c.FileSystemProviderErrorCode.Unavailable,u.Unavailable)}constructor(T,ie=c.FileSystemProviderErrorCode.Unknown,ke){super(f.URI.isUri(T)?T.toString(!0):T),this.code=ke?.name??"Unknown",(0,c.$lk)(this,ie),Object.setPrototypeOf(this,u.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$pL=Pi,e.$pL=Pi=u=qe([P],Pi);let bi=class{constructor(T,ie,ke){this.start=T,this.end=ie,this.kind=ke}};e.$qL=bi,e.$qL=bi=qe([P],bi);var Hi;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ui;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(ui||(e.CommentMode=ui={}));var Gi;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var wi;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(T,ie=[]){this.tokenTypes=T,this.tokenModifiers=ie}}e.$rL=Ri;function cn(U){return typeof U>"u"||(0,k.$yf)(U)}class Mi{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let ie=0,ke=T.tokenTypes.length;ie<ke;ie++)this.j.set(T.tokenTypes[ie],ie);for(let ie=0,ke=T.tokenModifiers.length;ie<ke;ie++)this.k.set(T.tokenModifiers[ie],ie)}}push(T,ie,ke,He,Ye){if(typeof T=="number"&&typeof ie=="number"&&typeof ke=="number"&&typeof He=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(T,ie,ke,He,Ye);if(O.isRange(T)&&typeof ie=="string"&&cn(ke))return this.m(T,ie,ke);throw(0,M.$6)()}m(T,ie,ke){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ie))throw new Error("`tokenType` is not in the provided legend");const He=T.start.line,Ye=T.start.character,ot=T.end.character-T.start.character,lt=this.j.get(ie);let jt=0;if(ke)for(const Zt of ke){if(!this.k.has(Zt))throw new Error("`tokenModifier` is not in the provided legend");const ei=this.k.get(Zt);jt|=1<<ei>>>0}this.n(He,Ye,ot,lt,jt)}n(T,ie,ke,He,Ye){if(this.f&&(T<this.c||T===this.c&&ie<this.e)){this.f=!1;const jt=this.g.length/5|0;let Zt=0,ei=0;for(let ti=0;ti<jt;ti++){let si=this.g[5*ti],Bi=this.g[5*ti+1];si===0?(si=Zt,Bi+=ei):si+=Zt,this.g[5*ti]=si,this.g[5*ti+1]=Bi,Zt=si,ei=Bi}}let ot=T,lt=ie;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=ke,this.g[this.h++]=He,this.g[this.h++]=Ye,this.c=T,this.e=ie}static o(T){const ie=[],ke=T.length/5|0;for(let lt=0;lt<ke;lt++)ie[lt]=lt;ie.sort((lt,jt)=>{const Zt=T[5*lt],ei=T[5*jt];if(Zt===ei){const ti=T[5*lt+1],si=T[5*jt+1];return ti-si}return Zt-ei});const He=new Uint32Array(T.length);let Ye=0,ot=0;for(let lt=0;lt<ke;lt++){const jt=5*ie[lt],Zt=T[jt+0],ei=T[jt+1],ti=T[jt+2],si=T[jt+3],Bi=T[jt+4],wn=Zt-Ye,Mn=wn===0?ei-ot:ei,Wi=5*lt;He[Wi+0]=wn,He[Wi+1]=Mn,He[Wi+2]=ti,He[Wi+3]=si,He[Wi+4]=Bi,Ye=Zt,ot=ei}return He}build(T){return this.f?new ri(new Uint32Array(this.g),T):new ri(Mi.o(this.g),T)}}e.$sL=Mi;class ri{constructor(T,ie){this.resultId=ie,this.data=T}}e.$tL=ri;class un{constructor(T,ie,ke){this.start=T,this.deleteCount=ie,this.data=ke}}e.$uL=un;class ln{constructor(T,ie){this.resultId=ie,this.edits=T}}e.$vL=ln;var Ji;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new Vt("arrow-left")}}constructor(){}};e.$wL=fi,e.$wL=fi=qe([P],fi);var Qi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Yi{static validate(T){if(typeof T.badge=="string"){let ie=(0,l.$$e)(T.badge,0);if(ie<T.badge.length&&(ie+=(0,l.$$e)(T.badge,ie)),T.badge.length>ie)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Vt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,ie,ke){this.badge=T,this.tooltip=ie,this.color=ke}}e.$xL=Yi;let Fi=class{constructor(T){this.kind=T}};e.$yL=Fi,e.$yL=Fi=qe([P],Fi);var Xi;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class xt{static isNotebookRange(T){return T instanceof xt?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,ie){if(T<0)throw(0,M.$6)("start must be positive");if(ie<0)throw(0,M.$6)("end must be positive");T<=ie?(this.c=T,this.e=ie):(this.c=ie,this.e=T)}with(T){let ie=this.c,ke=this.e;return T.start!==void 0&&(ie=T.start),T.end!==void 0&&(ke=T.end),ie===this.c&&ke===this.e?this:new xt(ie,ke)}}e.$zL=xt;class yi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(ie=>yi.isNotebookCellData(ie))}static isNotebookCellData(T){return!0}constructor(T,ie,ke,He,Ye,ot,lt){this.kind=T,this.value=ie,this.languageId=ke,this.mime=He,this.outputs=Ye??[],this.metadata=ot,this.executionSummary=lt,yi.validate(this)}}e.$AL=yi;class hn{constructor(T){this.cells=T}}e.$BL=hn;class Qt{static isNotebookCellOutputItem(T){return T instanceof Qt?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const ie={name:T.name,message:T.message,stack:T.stack};return Qt.json(ie,"application/vnd.code.notebook.error")}static stdout(T){return Qt.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return Qt.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,ie="application/octet-stream"){return new Qt(T,ie)}static#e=new TextEncoder;static text(T,ie=A.$Mr.text){const ke=Qt.#e.encode(String(T));return new Qt(ke,ie)}static json(T,ie="text/x-json"){const ke=JSON.stringify(T,void 0,"	");return Qt.text(ke,ie)}constructor(T,ie){this.data=T,this.mime=ie;const ke=(0,A.$Qr)(ie,!0);if(!ke)throw new Error(`INVALID mime type: ${ie}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$CL=Qt;class li{static isNotebookCellOutput(T){return T instanceof li?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,ie=!1){const ke=new Set,He=new Set;for(let Ye=0;Ye<T.length;Ye++){const ot=T[Ye],lt=(0,A.$Qr)(ot.mime);if(!ke.has(lt)||(0,$.$mI)(lt)){ke.add(lt);continue}He.add(Ye),ie&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return He.size===0?T:T.filter((Ye,ot)=>!He.has(ot))}constructor(T,ie,ke){this.items=li.ensureUniqueMimeTypes(T,!0),typeof ie=="string"?(this.id=ie,this.metadata=ke):(this.id=(0,R.$dg)(),this.metadata=ie??ke)}}e.$DL=li;var Ti;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Ne;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(Ne||(e.NotebookCellExecutionState=Ne={}));var _t;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Li;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(Li||(e.NotebookEditorRevealType=Li={}));class $t{constructor(T,ie){this.text=T,this.alignment=ie}}e.$EL=$t;var xi;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(xi||(e.NotebookControllerAffinity=xi={}));var _i;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class en{constructor(T,ie=[]){this.uri=T,this.provides=(0,y.$2b)(ie)}}e.$FL=en;class dn{constructor(T){this.label=T}}e.$GL=dn;let hi=class{constructor(T,ie){this.label=T,this.timestamp=ie}};e.$HL=hi,e.$HL=hi=qe([P],hi);var tn;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(T,ie){this.ranges=T,this.wordPattern=ie}}e.$IL=sn;class fn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$JL=fn;var on;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(T=void 0,ie=void 0,ke=void 0,He=!1){this.include=T,this.exclude=ie,this.profile=ke,this.continuous=He}};e.$KL=Ni,e.$KL=Ni=qe([P],Ni);let Oi=g=class{static diff(T,ie,ke){const He=new g(T);return He.expectedOutput=ie,He.actualOutput=ke,He}constructor(T){this.message=T}};e.$LL=Oi,e.$LL=Oi=g=qe([P],Oi);let zi=class{constructor(T){this.id=T}};e.$ML=zi,e.$ML=zi=qe([P],zi);let di=class{constructor(T,ie){this.covered=T,this.total=ie}};e.$NL=di,e.$NL=di=qe([P],di);let ji=h=class{static fromDetails(T,ie){const ke=new di(0,0),He=new di(0,0),Ye=new di(0,0);for(const lt of ie)if("branches"in lt){ke.total+=1,ke.covered+=lt.executionCount>0?1:0;for(const jt of lt.branches)He.total+=1,He.covered+=jt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=lt.executionCount>0?1:0;const ot=new h(T,ke,He.total>0?He:void 0,Ye.total>0?Ye:void 0);return ot.detailedCoverage=ie,ot}constructor(T,ie,ke,He){this.uri=T,this.statementCoverage=ie,this.branchCoverage=ke,this.functionCoverage=He}};e.$OL=ji,e.$OL=ji=h=qe([P],ji);let Ui=class{constructor(T,ie,ke=[]){this.executionCount=T,this.location=ie,this.branches=ke}};e.$PL=Ui,e.$PL=Ui=qe([P],Ui);let ee=class{constructor(T,ie){this.executionCount=T,this.location=ie}};e.$QL=ee,e.$QL=ee=qe([P],ee);let he=class{constructor(T,ie){this.executionCount=T,this.location=ie}};e.$RL=he,e.$RL=he=qe([P],he);var Te;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(Te||(e.ExternalUriOpenerPriority=Te={}));var nt;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(nt||(e.WorkspaceTrustState=nt={}));var vt;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(vt||(e.PortAutoForwardAction=vt={}));class Ft{constructor(T,ie,ke,He,Ye,ot){this.kind=T,this.name=ie,this.detail=ke,this.uri=He,this.range=Ye,this.selectionRange=ot}}e.$SL=Ft;class yn{constructor(T){this.uri=T}}e.$TL=yn;class En{constructor(T,ie){this.original=T,this.modified=ie}}e.$UL=En;class Dn{constructor(T,ie,ke,He){this.base=T,this.input1=ie,this.input2=ke,this.result=He}}e.$VL=Dn;class kn{constructor(T,ie){this.uri=T,this.viewType=ie}}e.$WL=kn;class Sn{constructor(T){this.viewType=T}}e.$XL=Sn;class In{constructor(T,ie){this.uri=T,this.notebookType=ie}}e.$YL=In;class Cn{constructor(T,ie,ke){this.original=T,this.modified=ie,this.notebookType=ke}}e.$ZL=Cn;class Pn{constructor(){}}e.$1L=Pn;class An{constructor(T,ie){this.uri=T,this.inputBoxUri=ie}}e.$2L=An;var gn;(function(U){U[U.Up=1]="Up",U[U.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var vn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Rn{constructor(T,ie){this.role=T,this.content=ie}}e.$3L=Rn;var bn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(bn||(e.RelatedInformationType=bn={}))}),define(Re[100],Me([1,0,51,13,15,277,136,7,18]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fM=e.$eM=e.$dM=void 0;const f=new Map;function R($,m){m?f.set($,m):f.delete($)}e.$dM=R;function D($){return f.get($)}class c extends L.$Ru{constructor(m,t,i,a,b,E,v,r){super(t,i,a,b),this.c=m,this.m=E,this.q=v,this.notebook=r,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(m){return(0,k.$tb)(this.f,m)}get document(){if(!this.a){const m=this;this.a={get uri(){return m.d},get fileName(){return m.d.fsPath},get isUntitled(){return m.d.scheme===M.Schemas.untitled},get languageId(){return m.m},get version(){return m.h},get isClosed(){return m.b},get isDirty(){return m.q},save(){return m.r()},getText(t){return t?m.s(t):m.getText()},get eol(){return m.g===`
`?l.EndOfLine.LF:l.EndOfLine.CRLF},get lineCount(){return m.f.length},lineAt(t){return m.t(t)},offsetAt(t){return m.u(t)},positionAt(t){return m.v(t)},validateRange(t){return m.w(t)},validatePosition(t){return m.x(t)},getWordRangeAtPosition(t,i){return m.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(m){(0,y.ok)(!this.b),this.m=m}_acceptIsDirty(m){(0,y.ok)(!this.b),this.q=m}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(m){const t=this.w(m);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,a=t.start.line,b=t.end.line,E=[];E.push(this.f[a].substring(t.start.character));for(let v=a+1;v<b;v++)E.push(this.f[v]);return E.push(this.f[b].substring(0,t.end.character)),E.join(i)}t(m){let t;if(m instanceof l.$dK?t=m.line:typeof m=="number"&&(t=m),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new p(t,this.f[t],t===this.f.length-1)}u(m){return m=this.x(m),this.l(),this.j.getPrefixSum(m.line-1)+m.character}v(m){m=Math.floor(m),m=Math.max(0,m),this.l();const t=this.j.getIndexOf(m),i=this.f[t.index].length;return new l.$dK(t.index,Math.min(t.remainder,i))}w(m){if(!(m instanceof l.$eK))throw new Error("Invalid argument");const t=this.x(m.start),i=this.x(m.end);return t===m.start&&i===m.end?m:new l.$eK(t.line,t.character,i.line,i.character)}x(m){if(!(m instanceof l.$dK))throw new Error("Invalid argument");if(this.f.length===0)return m.with(0,0);let{line:t,character:i}=m,a=!1;if(t<0)t=0,i=0,a=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,a=!0;else{const b=this.f[t].length;i<0?(i=0,a=!0):i>b&&(i=b,a=!0)}return a?new l.$dK(t,i):m}y(m,t){const i=this.x(m);if(!t)t=D(this.m);else if((0,C.$Ne)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const a=(0,A.$5r)(i.character+1,(0,A.$3r)(t),this.f[i.line],0);if(a)return new l.$eK(i.line,a.startColumn-1,i.line,a.endColumn-1)}}e.$eM=c;class p{constructor(m,t,i){this.a=m,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new l.$eK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new l.$eK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$fM=p}),define(Re[196],Me([1,0,7,17,5]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=void 0;let L=class{constructor(l){this.a=new y.$yL(y.ColorThemeKind.Dark),this.b=new C.$Md}get activeColorTheme(){return this.a}$onColorThemeChange(l){let k;switch(l){case"light":k=y.ColorThemeKind.Light;break;case"hcDark":k=y.ColorThemeKind.HighContrast;break;case"hcLight":k=y.ColorThemeKind.HighContrastLight;break;default:k=y.ColorThemeKind.Dark}this.a=new y.$yL(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$kdc=L,e.$kdc=L=qe([We(0,M.$bM)],L)}),define(Re[197],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qI=e.CellExecutionUpdateType=void 0;var M;(function(C){C[C.Output=1]="Output",C[C.OutputItems=2]="OutputItems",C[C.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$qI=(0,y.$Nh)("INotebookExecutionService")}),define(Re[46],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(L){L.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var M;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class C{static fromExtHostTestItem(A,l,k=A.parent){if(A._isRoot)return new C([l]);const f=[A.id];for(let R=k;R&&R.id!==l;R=R.parent)f.push(R.id);return f.push(l),new C(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const l=A.indexOf("\0");return l===-1?A:A.slice(0,l)}static fromString(A){return new C(A.split("\0"))}static join(A,l){return new C([...A.path,l])}static joinToString(A,l){return A.toString()+"\0"+l}static parentId(A){const l=A.lastIndexOf("\0");return l===-1?void 0:A.slice(0,l)}static localId(A){const l=A.lastIndexOf("\0");return l===-1?A:A.slice(l+1)}static isChild(A,l){return l.startsWith(A)&&l[A.length]==="\0"}static compare(A,l){return A===l?0:C.isChild(A,l)?2:C.isChild(l,A)?3:1}constructor(A,l=A.length){if(this.path=A,this.d=l,A.length===0||l<1)throw new Error("cannot create test with empty path")}get rootId(){return new C(this.path,1)}get parentId(){return this.d>1?new C(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new C(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new C(this.path,A)}compare(A){if(typeof A=="string")return C.compare(this.toString(),A);for(let l=0;l<A.d&&l<this.d;l++)if(A.path[l]!==this.path[l])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$6I=C}),define(Re[56],Me([1,0,2,45,46]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$_I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$$I=e.$0I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$9I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$8I=e.$7I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(S){S[S.Unset=0]="Unset",S[S.Queued=1]="Queued",S[S.Running=2]="Running",S[S.Passed=3]="Passed",S[S.Failed=4]="Failed",S[S.Skipped=5]="Skipped",S[S.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(S){S[S.Run=1]="Run",S[S.Debug=2]="Debug",S[S.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var l;(function(S){S[S.Run=2]="Run",S[S.Debug=4]="Debug",S[S.Coverage=8]="Coverage",S[S.HasNonDefaultProfile=16]="HasNonDefaultProfile",S[S.HasConfigurable=32]="HasConfigurable",S[S.SupportsContinuousRun=64]="SupportsContinuousRun"})(l||(e.TestRunProfileBitset=l={})),e.$7I=[2,4,8,16,32,64];const k=S=>"runId"in S;e.$8I=k;var f;(function(S){S.serialize=u=>({range:u.range.toJSON(),uri:u.uri.toJSON()}),S.deserialize=u=>({range:M.$ps.lift(u.range),uri:y.URI.revive(u.uri)})})(f||(e.IRichLocation=f={}));var R;(function(S){S[S.Error=0]="Error",S[S.Output=1]="Output"})(R||(e.TestMessageType=R={}));var D;(function(S){S.serialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&f.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:0,expected:u.expected,actual:u.actual,contextValue:u.contextValue,location:u.location&&f.deserialize(u.location)})})(D||(e.ITestErrorMessage=D={}));const c=(S,u)=>`${u?"s":"e"}${S}`;e.$9I=c;var p;(function(S){S.serialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&f.serialize(u.location)}),S.deserialize=u=>({message:u.message,type:1,offset:u.offset,length:u.length,location:u.location&&f.deserialize(u.location)})})(p||(e.ITestOutputMessage=p={}));var $;(function(S){S.serialize=u=>u.type===0?D.serialize(u):p.serialize(u),S.deserialize=u=>u.type===0?D.deserialize(u):p.deserialize(u)})($||(e.ITestMessage=$={}));var m;(function(S){S.serializeWithoutMessages=u=>({state:u.state,duration:u.duration,messages:[]}),S.serialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.serialize)}),S.deserialize=u=>({state:u.state,duration:u.duration,messages:u.messages.map($.deserialize)})})(m||(e.ITestTaskState=m={}));const t="\0",i=(S,u)=>S+t+u;e.$0I=i;const a=S=>{const u=S.indexOf(t);return{ctrlId:S.slice(0,u),tagId:S.slice(u+1)}};e.$$I=a;var b;(function(S){S.serialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?.toJSON(),range:u.range?.toJSON()||null,description:u.description,error:u.error,sortText:u.sortText}),S.deserialize=u=>({extId:u.extId,label:u.label,tags:u.tags,busy:u.busy,children:void 0,uri:u.uri?y.URI.revive(u.uri):void 0,range:u.range?M.$ps.lift(u.range):null,description:u.description,error:u.error,sortText:u.sortText})})(b||(e.ITestItem=b={}));var E;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(E||(e.TestItemExpandState=E={}));var v;(function(S){S.serialize=u=>({expand:u.expand,item:b.serialize(u.item)}),S.deserialize=u=>({controllerId:C.$6I.root(u.item.extId),expand:u.expand,item:b.deserialize(u.item)})})(v||(e.InternalTestItem=v={}));var r;(function(S){S.serialize=u=>{let g;return u.item&&(g={},u.item.label!==void 0&&(g.label=u.item.label),u.item.tags!==void 0&&(g.tags=u.item.tags),u.item.busy!==void 0&&(g.busy=u.item.busy),u.item.uri!==void 0&&(g.uri=u.item.uri?.toJSON()),u.item.range!==void 0&&(g.range=u.item.range?.toJSON()),u.item.description!==void 0&&(g.description=u.item.description),u.item.error!==void 0&&(g.error=u.item.error),u.item.sortText!==void 0&&(g.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:g}},S.deserialize=u=>{let g;return u.item&&(g={},u.item.label!==void 0&&(g.label=u.item.label),u.item.tags!==void 0&&(g.tags=u.item.tags),u.item.busy!==void 0&&(g.busy=u.item.busy),u.item.range!==void 0&&(g.range=u.item.range?M.$ps.lift(u.item.range):null),u.item.description!==void 0&&(g.description=u.item.description),u.item.error!==void 0&&(g.error=u.item.error),u.item.sortText!==void 0&&(g.sortText=u.item.sortText)),{extId:u.extId,expand:u.expand,item:g}}})(r||(e.ITestItemUpdate=r={}));const s=(S,u)=>{u.expand!==void 0&&(S.expand=u.expand),u.item!==void 0&&(S.item=S.item?Object.assign(S.item,u.item):u.item)};e.$_I=s;var n;(function(S){S.serializeWithoutMessages=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.serializeWithoutMessages)}),S.serialize=u=>({...v.serialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.serialize)}),S.deserialize=u=>({...v.deserialize(u),ownComputedState:u.ownComputedState,computedState:u.computedState,tasks:u.tasks.map(m.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var o;(function(S){S[S.Function=0]="Function",S[S.Statement=1]="Statement"})(o||(e.DetailType=o={}));var w;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.DocumentSynced=2]="DocumentSynced",S[S.Remove=3]="Remove",S[S.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",S[S.Retire=5]="Retire",S[S.AddTag=6]="AddTag",S[S.RemoveTag=7]="RemoveTag"})(w||(e.TestDiffOpType=w={}));var d;(function(S){S.deserialize=u=>u.op===0?{op:u.op,item:v.deserialize(u.item)}:u.op===1?{op:u.op,item:r.deserialize(u.item)}:u.op===2?{op:u.op,uri:y.URI.revive(u.uri),docv:u.docv}:u,S.serialize=u=>u.op===0?{op:u.op,item:v.serialize(u.item)}:u.op===1?{op:u.op,item:r.serialize(u.item)}:u})(d||(e.TestsDiffOp=d={}));class I{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(u){const g=this.p();for(const h of u)switch(h.op){case 0:this.k(v.deserialize(h.item),g);break;case 1:this.l(r.deserialize(h.item),g);break;case 3:this.m(h.itemId,g);break;case 5:this.o(h.itemId);break;case 4:this.updatePendingRoots(h.amount);break;case 6:this.d.set(h.tag.id,h.tag);break;case 7:this.d.delete(h.id);break}g.complete?.()}k(u,g){const h=C.$6I.parentId(u.item.extId)?.toString();let P;if(!h)P=this.q(u),this.g.add(P),this.f.set(u.item.extId,P);else if(this.f.has(h)){const W=this.f.get(h);W.children.add(u.item.extId),P=this.q(u,W),this.f.set(u.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(u)}`);return}return g.add?.(P),u.expand===2&&this.h++,P}l(u,g){const h=this.f.get(u.extId);if(h)return u.expand!==void 0&&(h.expand===2&&this.h--,u.expand===2&&this.h++),(0,e.$_I)(h,u),g.update?.(h),h}m(u,g){const h=this.f.get(u);if(!h)return;const P=C.$6I.parentId(h.item.extId)?.toString();P?this.f.get(P).children.delete(h.item.extId):this.g.delete(h);const W=[[u]];for(;W.length;)for(const K of W.pop()){const j=this.f.get(K);j&&(W.push(j.children),this.f.delete(K),g.remove?.(j,j!==h),j.expand===2&&this.h--)}}o(u){}updatePendingRoots(u){this.j+=u}p(){return{}}}e.$aJ=I}),define(Re[76],Me([1,0,12,5,6,51,56,46]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.TestItemEventOp=void 0;var k;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const f=(a,b)=>a===b,D=Object.entries({range:(a,b)=>a===b?!0:!a||!b?!1:a.equalsRange(b),busy:f,label:f,description:f,error:f,sortText:f,tags:(a,b)=>!(a.length!==b.length||a.some(E=>!b.includes(E)))}),c=(a,b)=>{let E;for(const[v,r]of D)r(a[v],b[v])||(E?E[v]=b[v]:E={[v]:b[v]});return E};class p extends C.$Rc{get root(){return this.s.root}constructor(b){super(),this.s=b,this.f=this.B(new y.$5g(()=>this.flushDiff(),200)),this.g=this.B(new M.$Md),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(b){this.h=b;for(const E of this.tree.values())this.I(E)}get resolveHandler(){return this.h}collectDiff(){const b=this.m;return this.m=[],b}pushDiff(b){switch(b.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===b.uri){E.docv=b.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===b.item.extId){(0,A.$_I)(E.item,b.item);return}if(E.op===0&&E.item.item.extId===b.item.extId){(0,A.$_I)(E.item,b.item);return}}break}}this.m.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,E){const v=this.tree.get(b);if(v){if((v.expandLevels===void 0||E>v.expandLevels)&&(v.expandLevels=E),v.expand===1){const r=this.L(v);return r.isOpen()?this.J(v,E-1):r.wait().then(()=>this.J(v,E-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.J(v,E-1)):this.J(v,E-1)}}dispose(){for(const b of this.tree.values())this.s.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(b,E){switch(E.op){case 3:this.N(l.$6I.joinToString(b.fullId,E.id));break;case 0:this.y(E.item,b);break;case 5:for(const v of E.ops)this.u(b,v);break;case 1:this.z(E.new,E.old,b.fullId.toString());break;case 2:this.I(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:E.update}});break;case 6:this.w(b.actual.uri);break;default:(0,L.$3c)(E)}}w(b){b&&this.pushDiff({op:2,uri:b,docv:this.s.getDocumentVersion(b)})}y(b,E){const v=l.$6I.fromExtHostTestItem(b,this.root.id,E?.actual),r=this.s.getApiFor(b);r.parent&&r.parent!==E?.actual&&this.s.getChildren(r.parent).delete(b.id);let s=this.tree.get(v.toString());if(!s){s={fullId:v,actual:b,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},b.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(b,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(b)}}),this.H(b,s,E);return}if(s.actual===b){this.G(b,s,E);return}if(s.actual.uri?.toString()!==b.uri?.toString())return this.N(v.toString()),this.y(b,E);const n=this.s.getChildren(s.actual),o=s.actual,w=c(this.s.toITestItem(o),this.s.toITestItem(b));this.s.getApiFor(o).listener=void 0,s.actual=b,s.expand=0,w&&(w.hasOwnProperty("tags")&&(this.z(b.tags,o.tags,v.toString()),delete w.tags),this.u(s,{op:4,update:w})),this.H(b,s,E);for(const[d,I]of n)this.s.getChildren(b).get(I.id)||this.N(l.$6I.joinToString(v,I.id));this.w(s.actual.uri)}z(b,E,v){const r=new Set(E.map(s=>s.id));for(const s of b)r.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:v,item:{tags:b.map(s=>(0,A.$0I)(this.s.controllerId,s.id))}}}),r.forEach(this.D,this)}C(b){const E=this.j.get(b.id);E?E.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$0I)(this.s.controllerId,b.id)}}))}D(b){const E=this.j.get(b);E&&!--E.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,A.$0I)(this.s.controllerId,b)}))}F(b,E){this.s.getApiFor(b).parent=E&&E.actual!==this.root?E.actual:void 0}G(b,E,v){this.F(b,v);const r=this.s.getApiFor(b);r.parent=v?.actual,r.listener=s=>this.u(E,s),this.I(E)}H(b,E,v){this.G(b,E,v);for(const[r,s]of this.s.getChildren(b))this.y(s,E)}I(b){let E;this.h?b.resolveBarrier?E=b.resolveBarrier.isOpen()?3:2:E=b.actual.canResolveChildren?1:0:E=0,E!==b.expand&&(b.expand=E,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:E}}),E===1&&b.expandLevels!==void 0&&this.L(b))}J(b,E){if(E<0)return;const v=[];for(const[r,s]of this.s.getChildren(b.actual)){const n=this.expand(l.$6I.joinToString(b.fullId,s.id),E);(0,y.$Fg)(n)&&v.push(n)}if(v.length)return Promise.all(v).then(()=>{})}L(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const s=new y.$Rg;return s.open(),s}b.expand=2,this.M(b);const E=b.resolveBarrier=new y.$Rg,v=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let r;try{r=this.h(b.actual===this.root?void 0:b.actual)}catch(s){v(s)}return(0,y.$Fg)(r)?r.catch(v).then(()=>{E.open(),this.I(b)}):(E.open(),this.I(b)),b.resolveBarrier}M(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}N(b){const E=this.tree.get(b);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const v=[E];for(;v.length;){const r=v.pop();if(r){this.s.getApiFor(r.actual).listener=void 0;for(const s of r.actual.tags)this.D(s.id);this.tree.delete(r.fullId.toString());for(const[s,n]of this.s.getChildren(r.actual))v.push(this.tree.get(l.$6I.joinToString(r.fullId,n.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.$4L=p;class $ extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.$5L=$;class m extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$6L=m;class t extends Error{constructor(b,E,v){super(`TestItem with ID "${b}" is from controller "${E}" and cannot be added as a child of an item from controller "${v}".`)}}e.$7L=t;const i=(a,b,E)=>{let v=new Map;return{get size(){return v.size},forEach(r,s){for(const n of v.values())r.call(s,n,this)},[Symbol.iterator](){return v.entries()},replace(r){const s=new Map,n=new Set(v.keys()),o={op:5,ops:[]};for(const w of r){if(!(w instanceof E))throw new m(w.id);const d=b(w).controllerId;if(d!==a.controllerId)throw new t(w.id,d,a.controllerId);if(s.has(w.id))throw new $(w.id);s.set(w.id,w),n.delete(w.id),o.ops.push({op:0,item:w})}for(const w of n.keys())o.ops.push({op:3,id:w});a.listener?.(o),v=s},add(r){if(!(r instanceof E))throw new m(r.id);v.set(r.id,r),a.listener?.({op:0,item:r})},delete(r){v.delete(r)&&a.listener?.({op:3,id:r})},get(r){return v.get(r)},toJSON(){return Array.from(v.values())}}};e.$8L=i}),define(Re[101],Me([1,0,76]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=void 0;const M=new WeakMap,C=(A,l)=>{const k={controllerId:l};return M.set(A,k),k};e.$9L=C;const L=A=>{const l=M.get(A);if(!l)throw new y.$6L(A?.id||"<unknown>");return l};e.$0L=L}),define(Re[77],Me([1,0,13,2]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ob=e.$1ob=e.$Zob=e.$Yob=e.$Xob=void 0,e.$Xob="vscode-cdn.net",e.$Yob=`vscode-resource.${e.$Xob}`,e.$Zob=`'self' https://*.${e.$Xob}`;function C(l,k){return l.scheme===y.Schemas.http||l.scheme===y.Schemas.https?l:(k&&k.authority&&k.isRemote&&l.scheme===y.Schemas.file&&(l=M.URI.from({scheme:y.Schemas.vscodeRemote,authority:k.authority,path:l.path})),M.URI.from({scheme:y.Schemas.https,authority:`${l.scheme}+${L(l.authority)}.${e.$Yob}`,path:l.path,fragment:l.fragment,query:l.query}))}e.$1ob=C;function L(l){return l.replace(/./g,k=>{const f=k.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?k:"-"+f.toString(16).padStart(4,"0")})}function A(l){return l.replace(/-([0-9a-f]{4})/g,(k,f)=>String.fromCharCode(parseInt(f,16)))}e.$2ob=A}),define(Re[198],Me([1,0,5,6,77]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;class L{constructor(l,k,f){this.d=l,this.e=k,this.f=f,this.a=0,this.b=new M.$Qc,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const R=k.getVisibleTextEditors();for(const D of this.c.values())R.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(l=>l.inset.dispose()),this.b.dispose()}createWebviewEditorInset(l,k,f,R,D){let c;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===l){c=b;break}if(!c)throw new Error("not a visible editor");const p=this,$=this.a++,m=new y.$Md,t=new y.$Md,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,C.$1ob)(b,p.f)}get cspSource(){return C.$Zob}set options(b){this.b=b,p.d.$setOptions($,b)}get options(){return this.b}set html(b){this.a=b,p.d.$setHtml($,b)}get html(){return this.a}get onDidReceiveMessage(){return m.event}postMessage(b){return p.d.$postMessage($,b)}},a=new class{constructor(){this.editor=l,this.line=k,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){p.c.has($)&&(p.c.delete($),p.d.$disposeEditorInset($),t.fire(),t.dispose(),m.dispose())}};return this.d.$createEditorInset($,c.id,c.value.document.uri,k+1,f,R||{},D.identifier,D.extensionLocation),this.c.set($,{editor:l,inset:a,onDidReceiveMessage:m}),a}$onDidDispose(l){const k=this.c.get(l);k&&k.inset.dispose()}$onDidReceiveMessage(l,k){this.c.get(l)?.onDidReceiveMessage.fire(k)}}e.$Ucc=L}),define(Re[199],Me([1,0,4]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1M=e.VariableKind=e.$ZM=void 0,e.$ZM=(0,y.$Nh)("configurationResolverService");var M;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(M||(e.VariableKind=M={}));class C extends Error{constructor(A,l){super(l),this.variable=A}}e.$1M=C}),define(Re[200],Me([1,0,19,73,16,24,22,90,165,199,15]),function(we,e,y,M,C,L,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,$,m,t){this.h=new Map,this.a=p,this.b=$,this.g=m,t&&(this.c=t.then(i=>this.i(i)))}i(p){if(A.$j){const $=Object.create(null);return Object.keys(p).forEach(m=>{$[m.toLowerCase()]=p[m]}),$}return p}resolveWithEnvironment(p,$,m){return this.l({env:this.i(p),userHome:void 0},$?$.uri:void 0,m)}async resolveAsync(p,$){const m={env:await this.c,userHome:await this.g};return this.l(m,p?p.uri:void 0,$)}async j(p,$,m,t){const i=L.$3m($);A.$j&&i.windows?Object.keys(i.windows).forEach(b=>i[b]=i.windows[b]):A.$k&&i.osx?Object.keys(i.osx).forEach(b=>i[b]=i.osx[b]):A.$l&&i.linux&&Object.keys(i.linux).forEach(b=>i[b]=i.linux[b]),delete i.windows,delete i.osx,delete i.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,p?p.uri:void 0,i,m,t)}async resolveAnyAsync(p,$,m){return this.j(p,$,m)}async resolveAnyMap(p,$,m){const t=new Map;return{newConfig:await this.j(p,$,m,t),resolvedVariables:t}}resolveWithInteractionReplace(p,$,m,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,$,m,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,$){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,$)}async l(p,$,m,t,i){if(C.$xf(m))return this.m(p,$,m,t,i);if(Array.isArray(m))return Promise.all(m.map(a=>this.l(p,$,a,t,i)));if(C.$zf(m)){const a=Object.create(null),b=await Promise.all(Object.keys(m).map(async E=>[await this.m(p,$,E,t,i),await this.l(p,$,m[E],t,i)]));for(const[E,v]of b)a[E]=v;return a}return m}m(p,$,m,t,i){return(0,R.$Se)(m,D.VARIABLE_REGEXP,async(a,b)=>{if(b.includes(D.VARIABLE_LHS))return a;let E=await this.o(p,a,b,$,t);return i?.set(b,E),E!==a&&C.$xf(E)&&E.match(D.VARIABLE_REGEXP)&&(E=await this.m(p,$,E,t,i)),E})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,$,m,t,i){let a;const b=m.split(":");b.length>1&&(m=b[0],a=b[1]);const E=s=>{const n=this.a.getFilePath();if(n)return(0,l.$nv)(n);throw new f.$1M(s,(0,k.localize)(0,null,$))},v=s=>{const n=E(s);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,l.$nv)(o)}throw new f.$1M(s,(0,k.localize)(1,null,$,y.$mc(n)))},r=s=>{if(a){const n=this.a.getFolderUri(a);if(n)return n;throw new f.$1M(s,(0,k.localize)(2,null,$,a))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$1M(s,(0,k.localize)(3,null,$)):new f.$1M(s,(0,k.localize)(4,null,$))};switch(m){case"env":if(a){if(p.env){const s=p.env[A.$j?a.toLowerCase():a];if(C.$xf(s))return s}return""}throw new f.$1M(f.VariableKind.Env,(0,k.localize)(5,null,$));case"config":if(a){const s=this.a.getConfigurationValue(t,a);if(C.$Gf(s))throw new f.$1M(f.VariableKind.Config,(0,k.localize)(6,null,$,a));if(C.$zf(s))throw new f.$1M(f.VariableKind.Config,(0,k.localize)(7,null,$,a));return s}throw new f.$1M(f.VariableKind.Config,(0,k.localize)(8,null,$));case"command":return this.p(f.VariableKind.Command,$,a,i,"command");case"input":return this.p(f.VariableKind.Input,$,a,i,"input");case"extensionInstallFolder":if(a){const s=await this.a.getExtension(a);if(!s)throw new f.$1M(f.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,$,a));return this.n(s.extensionLocation)}throw new f.$1M(f.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,$));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,l.$nv)(this.n(r(f.VariableKind.WorkspaceFolder)));case"cwd":return t||a?(0,l.$nv)(this.n(r(f.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,l.$nv)(y.$mc(this.n(r(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new f.$1M(f.VariableKind.UserHome,(0,k.localize)(11,null,$))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new f.$1M(f.VariableKind.LineNumber,(0,k.localize)(12,null,$))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new f.$1M(f.VariableKind.SelectedText,(0,k.localize)(13,null,$))}case"file":return E(f.VariableKind.File);case"fileWorkspaceFolder":return v(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||a?y.$kc(this.n(r(f.VariableKind.RelativeFile)),E(f.VariableKind.RelativeFile)):E(f.VariableKind.RelativeFile);case"relativeFileDirname":{const s=y.$lc(E(f.VariableKind.RelativeFileDirname));if(t||a){const n=y.$kc(this.n(r(f.VariableKind.RelativeFileDirname)),s);return n.length===0?".":n}return s}case"fileDirname":return y.$lc(E(f.VariableKind.FileDirname));case"fileExtname":return y.$nc(E(f.VariableKind.FileExtname));case"fileBasename":return y.$mc(E(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=y.$mc(E(f.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-y.$nc(s).length)}case"fileDirnameBasename":return y.$mc(y.$lc(E(f.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||$}case"execInstallFolder":{const s=this.a.getAppRoot();return s||$}case"pathSeparator":return y.sep;default:try{const s=a?`${m}:${a}`:m;return this.p(f.VariableKind.Unknown,$,s,i,void 0)}catch{return $}}}}p(p,$,m,t,i){if(m&&t){const a=i===void 0?t[m]:t[i+":"+m];if(typeof a=="string")return a;throw new f.$1M(p,(0,k.localize)(14,null,$))}return $}}e.$cN=D}),define(Re[102],Me([1,0,4,99]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.OpenEditorContext=e.GroupsOrder=e.$aC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$_B=void 0,e.$_B=(0,y.$Nh)("editorGroupsService");var C;(function($){$[$.UP=0]="UP",$[$.DOWN=1]="DOWN",$[$.LEFT=2]="LEFT",$[$.RIGHT=3]="RIGHT"})(C||(e.GroupDirection=C={}));var L;(function($){$[$.HORIZONTAL=0]="HORIZONTAL",$[$.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function($){$[$.FIRST=0]="FIRST",$[$.LAST=1]="LAST",$[$.NEXT=2]="NEXT",$[$.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var l;(function($){$[$.MAXIMIZE=0]="MAXIMIZE",$[$.EVEN=1]="EVEN",$[$.TOGGLE=2]="TOGGLE"})(l||(e.GroupsArrangement=l={}));var k;(function($){$[$.COPY_EDITORS=0]="COPY_EDITORS",$[$.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function f($){const m=$;return(0,M.$2D)(m?.editor)&&(0,M.$2D)(m?.replacement)}e.$aC=f;var R;(function($){$[$.CREATION_TIME=0]="CREATION_TIME",$[$.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",$[$.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var D;(function($){$[$.NEW_EDITOR=1]="NEW_EDITOR",$[$.MOVE_EDITOR=2]="MOVE_EDITOR",$[$.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function c($){const m=$;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.$bC=c;function p($){return $.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$cC=p}),define(Re[201],Me([1,0,4,102]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=e.$fC=e.$eC=e.$dC=void 0,e.$dC=(0,y.$Nh)("editorService"),e.$eC=-1,e.$fC=-2;function C(L){const A=L;return typeof L=="number"||(0,M.$bC)(A)}e.$gC=C}),define(Re[8],Me([1,0,18,26,122,202,50,28,116,67,66,24,16,2,45,78,94,101,99,75,46,56,201,7]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$aM=e.$_L=e.MarkdownString=e.$$L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Ce){function Ae(G){const{selectionStartLineNumber:Fe,selectionStartColumn:Be,positionLineNumber:Je,positionColumn:Ve}=G,et=new s.$dK(Fe-1,Be-1),gt=new s.$dK(Je-1,Ve-1);return new s.$fK(et,gt)}Ce.to=Ae;function fe(G){const{anchor:Fe,active:Be}=G;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ce.from=fe})(n||(e.Selection=n={}));var o;(function(Ce){function Ae(G){if(!G)return;const{start:Fe,end:Be}=G;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ce.from=Ae;function fe(G){if(!G)return;const{startLineNumber:Fe,startColumn:Be,endLineNumber:Je,endColumn:Ve}=G;return new s.$eK(Fe-1,Be-1,Je-1,Ve-1)}Ce.to=fe})(o||(e.Range=o={}));var w;(function(Ce){function Ae(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ce.to=Ae})(w||(e.TokenType=w={}));var d;(function(Ce){function Ae(G){return new s.$dK(G.lineNumber-1,G.column-1)}Ce.to=Ae;function fe(G){return{lineNumber:G.line+1,column:G.character+1}}Ce.from=fe})(d||(e.Position=d={}));var I;(function(Ce){function Ae(Fe,Be,Je){return(0,y.$Gb)((0,y.$2b)(Fe).map(Ve=>fe(Ve,Be,Je)))}Ce.from=Ae;function fe(Fe,Be,Je){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Je?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:G(Fe.scheme,Be),pattern:st.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Je?.isBuiltin}}function G(Fe,Be){return Be&&typeof Fe=="string"?Be.transformOutgoingScheme(Fe):Fe}})(I||(e.DocumentSelector=I={}));var S;(function(Ce){function Ae(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ce.from=Ae;function fe(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ce.to=fe})(S||(e.DiagnosticTag=S={}));var u;(function(Ce){function Ae(G){let Fe;return G.code&&((0,c.$xf)(G.code)||(0,c.$Bf)(G.code)?Fe=String(G.code):Fe={value:String(G.code.value),target:G.code.target}),{...o.from(G.range),message:G.message,source:G.source,code:Fe,severity:h.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(g.from),tags:Array.isArray(G.tags)?(0,y.$Gb)(G.tags.map(S.from)):void 0}}Ce.from=Ae;function fe(G){const Fe=new s.$qK(o.to(G),G.message,h.to(G.severity));return Fe.source=G.source,Fe.code=(0,c.$xf)(G.code)?G.code:G.code?.value,Fe.relatedInformation=G.relatedInformation&&G.relatedInformation.map(g.to),Fe.tags=G.tags&&(0,y.$Gb)(G.tags.map(S.to)),Fe}Ce.to=fe})(u||(e.Diagnostic=u={}));var g;(function(Ce){function Ae(G){return{...o.from(G.location.range),message:G.message,resource:G.location.uri}}Ce.from=Ae;function fe(G){return new s.$pK(new s.$oK(G.resource,o.to(G)),G.message)}Ce.to=fe})(g||(e.DiagnosticRelatedInformation=g={}));var h;(function(Ce){function Ae(G){switch(G){case s.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ce.from=Ae;function fe(G){switch(G){case t.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ce.to=fe})(h||(e.DiagnosticSeverity=h={}));var P;(function(Ce){function Ae(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?r.$fC:r.$eC}Ce.from=Ae;function fe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ce.to=fe})(P||(e.ViewColumn=P={}));function W(Ce){return typeof Ce.range<"u"}function K(Ce){return Ce.length===0?!0:!!W(Ce[0])}e.$$L=K;var j;(function(Ce){function Ae(Ve){return Ve.map(Ce.from)}Ce.fromMany=Ae;function fe(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let et;if(fe(Ve)){const{language:ht,value:Rt}=Ve;et={value:"```"+ht+`
`+Rt+"\n```\n"}}else s.$CK.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const gt=Object.create(null);et.uris=gt;const ft=ht=>{try{let Rt=p.URI.parse(ht,!0);Rt=Rt.with({query:Fe(Rt.query,gt)}),gt[ht]=Rt}catch{}return""},pt=new k.marked.Renderer;return pt.link=ft,pt.image=ht=>typeof ht=="string"?ft(A.$8j(ht).href):"",(0,k.marked)(et.value,{renderer:pt}),et}Ce.from=G;function Fe(Ve,et){if(!Ve)return Ve;let gt;try{gt=(0,f.$jh)(Ve)}catch{}if(!gt)return Ve;let ft=!1;return gt=(0,D.$5m)(gt,pt=>{if(p.URI.isUri(pt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ht]=pt,ft=!0,ht}else return}),ft?JSON.stringify(gt):Ve}function Be(Ve){const et=new s.$CK(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,et}Ce.to=Be;function Je(Ve){if(Ve)return typeof Ve=="string"?Ve:Ce.from(Ve)}Ce.fromStrict=Je})(j||(e.MarkdownString=j={}));function B(Ce){return K(Ce)?Ce.map(Ae=>({range:o.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?j.fromMany(Ae.hoverMessage):Ae.hoverMessage?j.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):Ce.map(Ae=>({range:o.from(Ae)}))}e.$_L=B;function O(Ce){return typeof Ce>"u"?Ce:typeof Ce=="string"?p.URI.file(Ce):Ce}e.$aM=O;var N;(function(Ce){function Ae(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?O(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}Ce.from=Ae})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var te;(function(Ce){function Ae(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?O(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?N.from(fe.before):void 0,after:fe.after?N.from(fe.after):void 0}}Ce.from=Ae})(te||(e.ThemableDecorationRenderOptions=te={}));var Y;(function(Ce){function Ae(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ce.from=Ae})(Y||(e.DecorationRangeBehavior=Y={}));var Ee;(function(Ce){function Ae(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?Y.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?te.from(fe.light):void 0,dark:fe.dark?te.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?O(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?N.from(fe.before):void 0,after:fe.after?N.from(fe.after):void 0}}Ce.from=Ae})(Ee||(e.DecorationRenderOptions=Ee={}));var Se;(function(Ce){function Ae(G){return{text:G.newText,eol:G.newEol&&Xe.from(G.newEol),range:o.from(G.range)}}Ce.from=Ae;function fe(G){const Fe=new s.$jK(o.to(G.range),G.text);return Fe.newEol=typeof G.eol>"u"?void 0:Xe.to(G.eol),Fe}Ce.to=fe})(Se||(e.TextEdit=Se={}));var Pe;(function(Ce){function Ae(G,Fe){const Be={edits:[]};if(G instanceof s.$mK){const Je=new l.$Ac;for(const Ve of G._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Je.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let et;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?et={type:"base64",value:(0,M.$ue)(M.$ae.wrap(Ve.options.contents))}:et={type:"dataTransferItem",id:Ve.options.contents._itemId}),Be.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:et},metadata:Ve.metadata})}else Ve._type===2?Be.edits.push({resource:Ve.uri,textEdit:Se.from(Ve.edit),versionId:Je.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?Be.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Je.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Be.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Be.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(mt.from)}})}return Be}Ce.from=Ae;function fe(G){const Fe=new s.$mK,Be=new l.$zc;for(const Je of G.edits)if(Je.textEdit){const Ve=Je,et=p.URI.revive(Ve.resource),gt=o.to(Ve.textEdit.range),ft=Ve.textEdit.text,pt=Ve.textEdit.insertAsSnippet;let ht;pt?ht=s.$lK.replace(gt,new s.$nK(ft)):ht=s.$jK.replace(gt,ft);const Rt=Be.get(et);Rt?Rt.push(ht):Be.set(et,[ht])}else Fe.renameFile(p.URI.revive(Je.oldResource),p.URI.revive(Je.newResource),Je.options);for(const[Je,Ve]of Be)Fe.set(Je,Ve);return Fe}Ce.to=fe})(Pe||(e.WorkspaceEdit=Pe={}));var ge;(function(Ce){const Ae=Object.create(null);Ae[s.SymbolKind.File]=0,Ae[s.SymbolKind.Module]=1,Ae[s.SymbolKind.Namespace]=2,Ae[s.SymbolKind.Package]=3,Ae[s.SymbolKind.Class]=4,Ae[s.SymbolKind.Method]=5,Ae[s.SymbolKind.Property]=6,Ae[s.SymbolKind.Field]=7,Ae[s.SymbolKind.Constructor]=8,Ae[s.SymbolKind.Enum]=9,Ae[s.SymbolKind.Interface]=10,Ae[s.SymbolKind.Function]=11,Ae[s.SymbolKind.Variable]=12,Ae[s.SymbolKind.Constant]=13,Ae[s.SymbolKind.String]=14,Ae[s.SymbolKind.Number]=15,Ae[s.SymbolKind.Boolean]=16,Ae[s.SymbolKind.Array]=17,Ae[s.SymbolKind.Object]=18,Ae[s.SymbolKind.Key]=19,Ae[s.SymbolKind.Null]=20,Ae[s.SymbolKind.EnumMember]=21,Ae[s.SymbolKind.Struct]=22,Ae[s.SymbolKind.Event]=23,Ae[s.SymbolKind.Operator]=24,Ae[s.SymbolKind.TypeParameter]=25;function fe(Fe){return typeof Ae[Fe]=="number"?Ae[Fe]:6}Ce.from=fe;function G(Fe){for(const Be in Ae)if(Ae[Be]===Fe)return Number(Be);return s.SymbolKind.Property}Ce.to=G})(ge||(e.SymbolKind=ge={}));var me;(function(Ce){function Ae(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Ce.from=Ae;function fe(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Ce.to=fe})(me||(e.SymbolTag=me={}));var ce;(function(Ce){function Ae(G){return{name:G.name,kind:ge.from(G.kind),tags:G.tags&&G.tags.map(me.from),containerName:G.containerName,location:V.from(G.location)}}Ce.from=Ae;function fe(G){const Fe=new s.$tK(G.name,ge.to(G.kind),G.containerName,V.to(G.location));return Fe.tags=G.tags&&G.tags.map(me.to),Fe}Ce.to=fe})(ce||(e.WorkspaceSymbol=ce={}));var se;(function(Ce){function Ae(G){const Fe={name:G.name||"!!MISSING: name!!",detail:G.detail,range:o.from(G.range),selectionRange:o.from(G.selectionRange),kind:ge.from(G.kind),tags:G.tags?.map(me.from)??[]};return G.children&&(Fe.children=G.children.map(Ae)),Fe}Ce.from=Ae;function fe(G){const Fe=new s.$uK(G.name,G.detail,ge.to(G.kind),o.to(G.range),o.to(G.selectionRange));return(0,y.$Kb)(G.tags)&&(Fe.tags=G.tags.map(me.to)),G.children&&(Fe.children=G.children.map(fe)),Fe}Ce.to=fe})(se||(e.DocumentSymbol=se={}));var $e;(function(Ce){function Ae(G){const Fe=new s.$yK(ge.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Fe._sessionId=G._sessionId,Fe._itemId=G._itemId,Fe}Ce.to=Ae;function fe(G,Fe,Be){if(Fe=Fe??G._sessionId,Be=Be??G._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,name:G.name,detail:G.detail,kind:ge.from(G.kind),uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(me.from)}}Ce.from=fe})($e||(e.CallHierarchyItem=$e={}));var _;(function(Ce){function Ae(fe){return new s.$zK($e.to(fe.from),fe.fromRanges.map(G=>o.to(G)))}Ce.to=Ae})(_||(e.CallHierarchyIncomingCall=_={}));var z;(function(Ce){function Ae(fe){return new s.$AK($e.to(fe.to),fe.fromRanges.map(G=>o.to(G)))}Ce.to=Ae})(z||(e.CallHierarchyOutgoingCall=z={}));var V;(function(Ce){function Ae(G){return{range:G.range&&o.from(G.range),uri:G.uri}}Ce.from=Ae;function fe(G){return new s.$oK(p.URI.revive(G.uri),o.to(G.range))}Ce.to=fe})(V||(e.location=V={}));var ue;(function(Ce){function Ae(G){const Fe=G,Be=G;return{originSelectionRange:Fe.originSelectionRange?o.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Be.uri,range:o.from(Fe.targetRange?Fe.targetRange:Be.range),targetSelectionRange:Fe.targetSelectionRange?o.from(Fe.targetSelectionRange):void 0}}Ce.from=Ae;function fe(G){return{targetUri:p.URI.revive(G.uri),targetRange:o.to(G.range),targetSelectionRange:G.targetSelectionRange?o.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?o.to(G.originSelectionRange):void 0}}Ce.to=fe})(ue||(e.DefinitionLink=ue={}));var ye;(function(Ce){function Ae(G){return{range:o.from(G.range),contents:j.fromMany(G.contents)}}Ce.from=Ae;function fe(G){return new s.$rK(G.contents.map(j.to),o.to(G.range))}Ce.to=fe})(ye||(e.Hover=ye={}));var be;(function(Ce){function Ae(G){return{range:o.from(G.range),expression:G.expression}}Ce.from=Ae;function fe(G){return new s.$kL(o.to(G.range),G.expression)}Ce.to=fe})(be||(e.EvaluatableExpression=be={}));var pe;(function(Ce){function Ae(G){if(G instanceof s.$lL)return{type:"text",range:o.from(G.range),text:G.text};if(G instanceof s.$mL)return{type:"variable",range:o.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$nL)return{type:"expression",range:o.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ce.from=Ae;function fe(G){switch(G.type){case"text":return{range:o.to(G.range),text:G.text};case"variable":return{range:o.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:o.to(G.range),expression:G.expression}}}Ce.to=fe})(pe||(e.InlineValue=pe={}));var De;(function(Ce){function Ae(G){return{frameId:G.frameId,stoppedLocation:o.from(G.stoppedLocation)}}Ce.from=Ae;function fe(G){return new s.$oL(G.frameId,o.to(G.stoppedLocation))}Ce.to=fe})(De||(e.InlineValueContext=De={}));var ne;(function(Ce){function Ae(G){return{range:o.from(G.range),kind:G.kind}}Ce.from=Ae;function fe(G){return new s.$sK(o.to(G.range),G.kind)}Ce.to=fe})(ne||(e.DocumentHighlight=ne={}));var le;(function(Ce){function Ae(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ce.to=Ae})(le||(e.CompletionTriggerKind=le={}));var re;(function(Ce){function Ae(fe){return{triggerKind:le.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}Ce.to=Ae})(re||(e.CompletionContext=re={}));var oe;(function(Ce){function Ae(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Ce.from=Ae;function fe(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Ce.to=fe})(oe||(e.CompletionItemTag=oe={}));var de;(function(Ce){const Ae=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(Be){return Ae.get(Be)??9}Ce.from=fe;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(Be){return G.get(Be)??s.CompletionItemKind.Property}Ce.to=Fe})(de||(e.CompletionItemKind=de={}));var Ie;(function(Ce){function Ae(fe,G){const Fe=new s.$IK(fe.label);return Fe.insertText=fe.insertText,Fe.kind=de.to(fe.kind),Fe.tags=fe.tags?.map(oe.to),Fe.detail=fe.detail,Fe.documentation=A.$3j(fe.documentation)?j.to(fe.documentation):fe.documentation,Fe.sortText=fe.sortText,Fe.filterText=fe.filterText,Fe.preselect=fe.preselect,Fe.commitCharacters=fe.commitCharacters,$.$ps.isIRange(fe.range)?Fe.range=o.to(fe.range):typeof fe.range=="object"&&(Fe.range={inserting:o.to(fe.range.insert),replacing:o.to(fe.range.replace)}),Fe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Fe.insertText=new s.$nK(fe.insertText):(Fe.insertText=fe.insertText,Fe.textEdit=Fe.range instanceof s.$eK?new s.$jK(Fe.range,Fe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Fe.additionalTextEdits=fe.additionalTextEdits.map(Be=>Se.to(Be))),Fe.command=G&&fe.command?G.fromInternal(fe.command):void 0,Fe}Ce.to=Ae})(Ie||(e.CompletionItem=Ie={}));var F;(function(Ce){function Ae(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:j.fromStrict(G.documentation)}}Ce.from=Ae;function fe(G){return{label:G.label,documentation:A.$3j(G.documentation)?j.to(G.documentation):G.documentation}}Ce.to=fe})(F||(e.ParameterInformation=F={}));var q;(function(Ce){function Ae(G){return{label:G.label,documentation:j.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(F.from):[],activeParameter:G.activeParameter}}Ce.from=Ae;function fe(G){return{label:G.label,documentation:A.$3j(G.documentation)?j.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(F.to):[],activeParameter:G.activeParameter}}Ce.to=fe})(q||(e.SignatureInformation=q={}));var J;(function(Ce){function Ae(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.from):[]}}Ce.from=Ae;function fe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(q.to):[]}}Ce.to=fe})(J||(e.SignatureHelp=J={}));var Q;(function(Ce){function Ae(fe,G){const Fe=new s.$HK(d.to(G.position),typeof G.label=="string"?G.label:G.label.map(H.to.bind(void 0,fe)),G.kind&&x.to(G.kind));return Fe.textEdits=G.textEdits&&G.textEdits.map(Se.to),Fe.tooltip=A.$3j(G.tooltip)?j.to(G.tooltip):G.tooltip,Fe.paddingLeft=G.paddingLeft,Fe.paddingRight=G.paddingRight,Fe}Ce.to=Ae})(Q||(e.InlayHint=Q={}));var H;(function(Ce){function Ae(fe,G){const Fe=new s.$GK(G.label);return Fe.tooltip=A.$3j(G.tooltip)?j.to(G.tooltip):G.tooltip,m.Command.is(G.command)&&(Fe.command=fe.fromInternal(G.command)),G.location&&(Fe.location=V.to(G.location)),Fe}Ce.to=Ae})(H||(e.InlayHintLabelPart=H={}));var x;(function(Ce){function Ae(G){return G}Ce.from=Ae;function fe(G){return G}Ce.to=fe})(x||(e.InlayHintKind=x={}));var ae;(function(Ce){function Ae(G){return{range:o.from(G.range),url:G.target,tooltip:G.tooltip}}Ce.from=Ae;function fe(G){let Fe;if(G.url)try{Fe=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new s.$NK(o.to(G.range),Fe)}Ce.to=fe})(ae||(e.DocumentLink=ae={}));var Le;(function(Ce){function Ae(G){const Fe=new s.$QK(G.label);return G.textEdit&&(Fe.textEdit=Se.to(G.textEdit)),G.additionalTextEdits&&(Fe.additionalTextEdits=G.additionalTextEdits.map(Be=>Se.to(Be))),Fe}Ce.to=Ae;function fe(G){return{label:G.label,textEdit:G.textEdit?Se.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Fe=>Se.from(Fe)):void 0}}Ce.from=fe})(Le||(e.ColorPresentation=Le={}));var je;(function(Ce){function Ae(G){return new s.$OK(G[0],G[1],G[2],G[3])}Ce.to=Ae;function fe(G){return[G.red,G.green,G.blue,G.alpha]}Ce.from=fe})(je||(e.Color=je={}));var Qe;(function(Ce){function Ae(G){return{range:o.from(G.range)}}Ce.from=Ae;function fe(G){return new s.$xK(o.to(G.range))}Ce.to=fe})(Qe||(e.SelectionRange=Qe={}));var Ge;(function(Ce){function Ae(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ce.to=Ae})(Ge||(e.TextDocumentSaveReason=Ge={}));var xe;(function(Ce){function Ae(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ce.from=Ae;function fe(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ce.to=fe})(xe||(e.TextEditorLineNumbersStyle=xe={}));var Xe;(function(Ce){function Ae(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Ce.from=Ae;function fe(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Ce.to=fe})(Xe||(e.EndOfLine=Xe={}));var _e;(function(Ce){function Ae(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ce.from=Ae})(_e||(e.ProgressLocation=_e={}));var it;(function(Ce){function Ae(G){const Fe={start:G.start+1,end:G.end+1};return G.kind&&(Fe.kind=tt.from(G.kind)),Fe}Ce.from=Ae;function fe(G){const Fe={start:G.start-1,end:G.end-1};return G.kind&&(Fe.kind=tt.to(G.kind)),Fe}Ce.to=fe})(it||(e.FoldingRange=it={}));var tt;(function(Ce){function Ae(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return m.$et.Comment;case s.FoldingRangeKind.Imports:return m.$et.Imports;case s.FoldingRangeKind.Region:return m.$et.Region}}Ce.from=Ae;function fe(G){if(G)switch(G.value){case m.$et.Comment.value:return s.FoldingRangeKind.Comment;case m.$et.Imports.value:return s.FoldingRangeKind.Imports;case m.$et.Region.value:return s.FoldingRangeKind.Region}}Ce.to=fe})(tt||(e.FoldingRangeKind=tt={}));var ze;(function(Ce){function Ae(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?o.from(fe.selection):void 0,override:typeof fe.override=="boolean"?a.$OD.id:void 0}}Ce.from=Ae})(ze||(e.TextEditorOpenOptions=ze={}));var st;(function(Ce){function Ae(Be){return Be instanceof s.$$K?Be.toJSON():typeof Be=="string"?Be:fe(Be)||G(Be)?new s.$$K(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ce.from=Ae;function fe(Be){const Je=Be;return Je?p.URI.isUri(Je.baseUri)&&typeof Je.pattern=="string":!1}function G(Be){const Je=Be;return Je?typeof Je.base=="string"&&typeof Je.pattern=="string":!1}function Fe(Be){return typeof Be=="string"?Be:new s.$$K(p.URI.revive(Be.baseUri),Be.pattern)}Ce.to=Fe})(st||(e.GlobPattern=st={}));var X;(function(Ce){function Ae(fe){if(fe){if(Array.isArray(fe))return fe.map(Ae);if(typeof fe=="string")return fe;{const G=fe;return{language:G.language,scheme:G.scheme,pattern:st.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ce.from=Ae})(X||(e.LanguageSelector=X={}));var Z;(function(Ce){function Ae(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&p.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Je=>Je instanceof s.$eK)))}Ce.is=Ae;function fe(G){return{documents:G.documents.map(Fe=>Fe.map(Be=>({uri:p.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Je=>o.from(Je))})))}}Ce.from=fe})(Z||(e.MappedEditsContext=Z={}));var ve;(function(Ce){function Ae(G){return{start:G.start,end:G.end}}Ce.from=Ae;function fe(G){return new s.$zL(G.start,G.end)}Ce.to=fe})(ve||(e.NotebookRange=ve={}));var Ue;(function(Ce){function Ae(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ce.to=Ae;function fe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ce.from=fe})(Ue||(e.NotebookCellExecutionSummary=Ue={}));var Oe;(function(Ce){function Ae(fe){if(fe===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===b.NotebookCellExecutionState.Pending)return;if(fe===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}Ce.to=Ae})(Oe||(e.NotebookCellExecutionState=Oe={}));var Ze;(function(Ce){function Ae(G){switch(G){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}Ce.from=Ae;function fe(G){switch(G){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}Ce.to=fe})(Ze||(e.NotebookCellKind=Ze={}));var rt;(function(Ce){function Ae(G){const Fe={metadata:G.metadata??Object.create(null),cells:[]};for(const Be of G.cells)s.$AL.validate(Be),Fe.cells.push(mt.from(Be));return Fe}Ce.from=Ae;function fe(G){const Fe=new s.$BL(G.cells.map(mt.to));return(0,c.$Kf)(G.metadata)||(Fe.metadata=G.metadata),Fe}Ce.to=fe})(rt||(e.NotebookData=rt={}));var mt;(function(Ce){function Ae(G){return{cellKind:Ze.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ue.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Ct.from):[]}}Ce.from=Ae;function fe(G){return new s.$AL(Ze.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Ct.to):void 0,G.metadata,G.internalMetadata?Ue.to(G.internalMetadata):void 0)}Ce.to=fe})(mt||(e.NotebookCellData=mt={}));var wt;(function(Ce){function Ae(G){return{mime:G.mime,valueBytes:M.$ae.wrap(G.data)}}Ce.from=Ae;function fe(G){return new s.$CL(G.valueBytes.buffer,G.mime)}Ce.to=fe})(wt||(e.NotebookCellOutputItem=wt={}));var Ct;(function(Ce){function Ae(G){return{outputId:G.id,items:G.items.map(wt.from),metadata:G.metadata}}Ce.from=Ae;function fe(G){const Fe=G.items.map(wt.to);return new s.$DL(Fe,G.outputId,G.metadata)}Ce.to=fe})(Ct||(e.NotebookCellOutput=Ct={}));var Yt;(function(Ce){function Ae(Fe){return G(Fe)?{include:st.from(Fe.include)??void 0,exclude:st.from(Fe.exclude)??void 0}:st.from(Fe)??void 0}Ce.from=Ae;function fe(Fe){return G(Fe)?{include:st.to(Fe.include),exclude:st.to(Fe.exclude)}:st.to(Fe)}Ce.to=fe;function G(Fe){const Be=Fe;return Be?!(0,c.$Gf)(Be.include)&&!(0,c.$Gf)(Be.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var qt;(function(Ce){function Ae(fe,G,Fe){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Be,Fe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}Ce.from=Ae})(qt||(e.NotebookStatusBarItem=qt={}));var bt;(function(Ce){function Ae(fe,G,Fe){const Be=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:G.toInternal(Be,Fe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}Ce.from=Ae})(bt||(e.NotebookKernelSourceAction=bt={}));var Ut;(function(Ce){function Ae(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}Ce.from=Ae})(Ut||(e.NotebookDocumentContentOptions=Ut={}));var Lt;(function(Ce){function Ae(G){return{uri:G.uri,provides:G.provides}}Ce.from=Ae;function fe(G){return new s.$FL(p.URI.revive(G.uri),G.provides)}Ce.to=fe})(Lt||(e.NotebookRendererScript=Lt={}));var Bt;(function(Ce){function Ae(G){return{message:j.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:o.from(G.location.range),uri:G.location.uri}}}Ce.from=Ae;function fe(G){const Fe=new s.$LL(typeof G.message=="string"?G.message:j.to(G.message));return Fe.actualOutput=G.actual,Fe.expectedOutput=G.expected,Fe.contextValue=G.contextValue,Fe.location=G.location?V.to(G.location):void 0,Fe}Ce.to=fe})(Bt||(e.TestMessage=Bt={}));var Pt;(function(Ce){Ce.namespace=v.$0I,Ce.denamespace=v.$$I})(Pt||(e.TestTag=Pt={}));var At;(function(Ce){function Ae(G){const Fe=(0,i.$0L)(G).controllerId;return{extId:E.$6I.fromExtHostTestItem(G,Fe).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Be=>Pt.namespace(Fe,Be.id)),range:$.$ps.lift(o.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&j.fromStrict(G.error)||null}}Ce.from=Ae;function fe(G){return{parent:void 0,error:void 0,id:E.$6I.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Fe=>{const{tagId:Be}=Pt.denamespace(Fe);return new s.$ML(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ce.toPlain=fe})(At||(e.TestItem=At={})),function(Ce){function Ae(G){return{id:G.id}}Ce.from=Ae;function fe(G){return new s.$ML(G.id)}Ce.to=fe}(Pt||(e.TestTag=Pt={}));var Nt;(function(Ce){const Ae=(G,Fe)=>{const Be=[];for(const[Ve,et]of Fe)E.$6I.compare(et.item.extId,Ve)===2&&(Fe.delete(Ve),Be.push(et));const Je={...At.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(Bt.to)})),children:Be.map(Ve=>Ae(Ve,Fe))};for(const Ve of Je.children)Ve.parent=Je;return Je};function fe(G){const Fe=[],Be=new Map;for(const Je of G.items){Be.set(Je.item.extId,Je);const Ve=E.$6I.root(Je.item.extId);G.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Je.item.extId))&&Fe.push(Je)}return{completedAt:G.completedAt,results:Fe.map(Je=>Ae(Je,Be))}}Ce.to=fe})(Nt||(e.TestResults=Nt={}));var Wt;(function(Ce){function Ae(Be){return{covered:Be.covered,total:Be.covered}}function fe(Be){return"line"in Be?d.from(Be):o.from(Be)}function G(Be){return"branches"in Be?{count:Be.executionCount,location:fe(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Je=>({count:Je.executionCount,location:Je.location&&fe(Je.location)})):void 0}:{type:0,count:Be.executionCount,location:fe(Be.location)}}Ce.fromDetailed=G;function Fe(Be){return{uri:Be.uri,statement:Ae(Be.statementCoverage),branch:Be.branchCoverage&&Ae(Be.branchCoverage),function:Be.functionCoverage&&Ae(Be.functionCoverage),details:Be.detailedCoverage?.map(G)}}Ce.fromFile=Fe})(Wt||(e.TestCoverage=Wt={}));var Ht;(function(Ce){function Ae(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ce.to=Ae})(Ht||(e.CodeActionTriggerKind=Ht={}));var Kt;(function(Ce){function Ae(G){const Fe=new s.$SL(ge.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),o.to(G.range),o.to(G.selectionRange));return Fe._sessionId=G._sessionId,Fe._itemId=G._itemId,Fe}Ce.to=Ae;function fe(G,Fe,Be){if(Fe=Fe??G._sessionId,Be=Be??G._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,kind:ge.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:o.from(G.range),selectionRange:o.from(G.selectionRange),tags:G.tags?.map(me.from)}}Ce.from=fe})(Kt||(e.TypeHierarchyItem=Kt={}));var at;(function(Ce){function Ae(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}Ce.from=Ae})(at||(e.ViewBadge=at={}));var ut;(function(Ce){function Ae(Be,Je,Ve){const et=Je.fileData;return et?new s.$4K(new s.$5K(et.name,p.URI.revive(et.uri),et.id,(0,L.$cb)(()=>Ve(et.id)))):Be===R.$Mr.uriList&&Je.uriListData?new s.$3K(Fe(Je.uriListData)):new s.$3K(Je.asString)}Ce.to=Ae;async function fe(Be,Je){const Ve=await Je.asString();if(Be===R.$Mr.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const et=Je.asFile();return{asString:Ve,fileData:et?{name:et.name,uri:et.uri,id:et._itemId??et.id}:void 0}}Ce.from=fe;function G(Be){return C.$Ys.split(Be).map(Je=>{if(Je.startsWith("#"))return Je;try{return p.URI.parse(Je)}catch{}return Je})}function Fe(Be){return C.$Ys.create(Be.map(Je=>typeof Je=="string"?Je:p.URI.revive(Je)))}})(ut||(e.DataTransferItem=ut={}));var Jt;(function(Ce){function Ae(G,Fe){const Be=G.items.map(([Je,Ve])=>[Je,ut.to(Je,Ve,Fe)]);return new s.$6K(Be)}Ce.toDataTransfer=Ae;async function fe(G){const Fe={items:[]},Be=[];for(const[Je,Ve]of G)Be.push((async()=>{Fe.items.push([Je,await ut.from(Je,Ve)])})());return await Promise.all(Be),Fe}Ce.from=fe})(Jt||(e.DataTransfer=Jt={}));var It;(function(Ce){function Ae(G){return{message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ce.to=Ae;function fe(G){return{kind:"reply",message:G.message,metadata:G.metadata,title:G.title,tooltip:G.tooltip}}Ce.from=fe})(It||(e.ChatReplyFollowup=It={}));var Et;(function(Ce){function Ae(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:It.from(fe)}Ce.from=Ae})(Et||(e.ChatFollowup=Et={}));var dt;(function(Ce){function Ae(G){const Fe=new s.$3L(kt.to(G.role),G.content);return Fe.name=G.name,Fe}Ce.to=Ae;function fe(G){return{role:kt.from(G.role),content:G.content,name:G.name}}Ce.from=fe})(dt||(e.ChatMessage=dt={}));var kt;(function(Ce){function Ae(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ce.to=Ae;function fe(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ce.from=fe})(kt||(e.ChatMessageRole=kt={}));var Tt;(function(Ce){function Ae(G){return{level:yt.to(G.level),value:G.value,description:G.description}}Ce.to=Ae;function fe(G){return{level:yt.from(G.level),value:G.value,description:G.description}}Ce.from=fe})(Tt||(e.ChatVariable=Tt={}));var yt;(function(Ce){function Ae(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ce.to=Ae;function fe(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ce.from=fe})(yt||(e.ChatVariableLevel=yt={}));var Ke;(function(Ce){function Ae(fe){switch(fe){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}Ce.to=Ae})(Ke||(e.InteractiveEditorResponseFeedbackKind=Ke={}));var Ot;(function(Ce){function Ae(fe){return"placeholder"in fe&&"resolvedContent"in fe?{placeholder:fe.placeholder}:"responseId"in fe?{requestId:fe.responseId}:"content"in fe?{content:typeof fe.content=="string"?fe.content:j.from(fe.content)}:"documents"in fe?{documents:fe.documents.map(G=>({uri:G.uri,version:G.version,ranges:G.ranges.map(Fe=>o.from(Fe))}))}:"reference"in fe?{reference:"uri"in fe.reference?{uri:fe.reference.uri,range:o.from(fe.reference.range)}:fe.reference}:fe}Ce.from=Ae})(Ot||(e.ChatResponseProgress=Ot={}));var zt;(function(Ce){function Ae(fe,G,Fe){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand}:"uri"in fe?{uri:fe.uri}:G.toInternal(fe,Fe)}Ce.from=Ae})(zt||(e.TerminalQuickFix=zt={}))}),define(Re[203],Me([1,0,2,9,7,8,173]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6bc=void 0;class l{constructor(f,R,D,c={timeout:1500,errors:3}){this.c=f,this.d=R,this.f=D,this.g=c,this.a=new A.$1c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(R,D,c)=>{const $={dispose:this.a.push([R,D,f])};return Array.isArray(c)&&c.push($),$}}async $participateInSave(f,R){const D=y.URI.revive(f);let c=!1;const p=setTimeout(()=>c=!0,this.g.timeout),$=[];try{for(const m of[...this.a]){if(c)break;const t=this.d.getDocument(D),i=await this.h(m,{document:t,reason:L.TextDocumentSaveReason.to(R)});$.push(i)}}finally{clearTimeout(p)}return $}h([f,R,D],c){const p=this.b.get(f);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(D,f,R,c).then(()=>!0,$=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error($),!($ instanceof Error)||$.message!=="concurrent_edits"){const m=this.b.get(f);this.b.set(f,m?m+1:1),typeof m=="number"&&m>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,R,D,c){const p=[],$=Date.now(),{document:m,reason:t}=c,{version:i}=m,a=Object.freeze({document:m,reason:t,waitUntil(b){if(Object.isFrozen(p))throw(0,M.$7)("waitUntil can not be called async");p.push(Promise.resolve(b))}});try{R.apply(D,[a])}catch(b){return Promise.reject(b)}return Object.freeze(p),new Promise((b,E)=>{const v=setTimeout(()=>E(new Error("timeout")),this.g.timeout);return Promise.all(p).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-$}ms`),clearTimeout(v),b(r)}).catch(r=>{clearTimeout(v),E(r)})}).then(b=>{const E={edits:[]};for(const v of b)if(Array.isArray(v)&&v.every(r=>r instanceof C.$jK))for(const{newText:r,newEol:s,range:n}of v)E.edits.push({resource:m.uri,versionId:void 0,textEdit:{range:n&&L.Range.from(n),text:r,eol:s&&L.EndOfLine.from(s)}});if(E.edits.length!==0)return i===m.version?this.f.$tryApplyWorkspaceEdit(E):Promise.reject(new Error("concurrent_edits"))})}}e.$6bc=l}),define(Re[204],Me([1,0,13,2,8,7,75]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=e.$gdc=void 0;class l{constructor(D,c,p,$){this.start=D,this.deletedCount=c,this.deletedItems=p,this.items=$}asApiEvent(){return{range:new L.$zL(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(D,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,c,p){this.notebook=D,this.h=c,this.j=p,this.handle=p.handle,this.uri=M.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(C.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(C.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:C.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return D.g},set mime($){D.g=$},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(p)}return this.f}setOutputs(D){this.a=D.map(C.NotebookCellOutput.to)}setOutputItems(D,c,p){const $=p.map(C.NotebookCellOutputItem.to),m=this.a.find(t=>t.id===D);if(m&&(c||(m.items.length=0),m.items.push(...$),m.items.length>1&&m.items.every(t=>A.$mI(t.mime)))){const t=new Map,i=[];m.items.forEach(a=>{let b;t.has(a.mime)?b=t.get(a.mime):(b=[],t.set(a.mime,b),i.push(a.mime)),b.push(a.data)}),m.items.length=0,i.forEach(a=>{const b=A.$nI(t.get(a));m.items.push({mime:a,data:b.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(C.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$gdc=k;class f{static{this.a=0}constructor(D,c,p,$,m){this.k=D,this.l=c,this.m=p,this.uri=$,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=m.viewType,this.f=Object.freeze(m.metadata??Object.create(null)),this.r([[0,0,m.cells]],!0,void 0),this.g=m.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,c={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===y.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(p){return p=D.n(p),D.b[p].apiCell},getCells(p){return(p?D.p(p):D.b).map(m=>m.apiCell)},save(){return D.q()}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,c,p){this.g=D.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:p});const $={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},m=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,$.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,$.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),m.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),m.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),m.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?m.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),m.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),m.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<m.length;i++){const a=m[i],b=t.get(a.cell);if(b===void 0){const E=$.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});t.set(a.cell,E-1)}else $.cellChanges[b]={...$.cellChanges[b],...a}}return Object.freeze($),Object.freeze($.cellChanges),Object.freeze($.contentChanges),$}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let c=D.start|0,p=D.end|0;return c<0&&(c=0),p>this.b.length&&(p=this.b.length),D.with({start:c,end:p})}p(D){D=this.o(D);const c=[];for(let p=D.start;p<D.end;p++)c.push(this.b[p]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,c,p){if(this.j)return;const $=[],m=[],t=[];if(D.reverse().forEach(i=>{const b=i[2].map(r=>{const s=new k(this,this.l,r);return c||m.push(k.asModelAddData(this.apiNotebook,r)),s}),E=new l(i[0],i[1],[],b),v=this.b.splice(i[0],i[1],...b);for(const r of v)t.push(r.uri),E.deletedItems.push(r.apiCell);$.push(E)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:m,removedDocuments:t}),p)for(const i of $)p.push(i.asApiEvent())}s(D,c,p,$){const m=this.b.splice(D,c);this.b.splice(p,0,...m);const t=[new l(D,c,m.map(i=>i.apiCell),[]),new l(p,0,[],m)];for(const i of t)$.push(i.asApiEvent())}t(D,c){this.b[D].setOutputs(c)}u(D,c,p,$){this.b[D].setOutputItems(c,p,$)}v(D,c){const p=this.b[D];p.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(p.uri,c)}w(D,c){const p=this.b[D];p.apiCell.mime=c}x(D,c){this.b[D].setMetadata(c)}y(D,c){this.b[D].setInternalMetadata(c)}getCellFromApiCell(D){return this.b.find(c=>c.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(c=>c.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$hdc=f}),define(Re[205],Me([1,0,5,2,8,7]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hdc=void 0;class A{constructor(k,f,R,D={timeout:1500,errors:3}){this.b=k,this.c=f,this.d=R,this.f=D,this.a=new y.$Od}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(f,R,D)=>{const c=function($){f.call(R,$)};return c.extension=k,this.a.event(c,void 0,D)}}async $participateInSave(k,f,R){const D=M.URI.revive(k),c=this.c.getNotebookDocument(D);if(!c)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:c.apiNotebook,reason:C.TextDocumentSaveReason.to(f)},R,async(m,t)=>{const i=Date.now(),a=await await Promise.resolve(m);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&a&&(a instanceof L.$mK?p.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(p.length===0)return!0;const $={edits:[]};for(const m of p){const{edits:t}=C.WorkspaceEdit.from(m);$.edits=$.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit($)}}e.$Hdc=A}),define(Re[103],Me([1,0,9,8,7]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(l,k,f,R,D,c){this.id=l,this.f=k,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=R,this.c=c}get apiEditor(){if(!this.e){const l=this;this.e={get notebook(){return l.notebookData.apiNotebook},get selection(){return l.a[0]},set selection(k){this.selections=[k]},get selections(){return l.a},set selections(k){if(!Array.isArray(k)||!k.every(C.$zL.isNotebookRange))throw(0,y.$6)("selections");l.a=k,l.g(k)},get visibleRanges(){return l.b},revealRange(k,f){l.f.$tryRevealRange(l.id,M.NotebookRange.from(k),f??C.NotebookEditorRevealType.Default)},get viewColumn(){return l.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(l){this.d=l}_acceptVisibleRanges(l){this.b=l}_acceptSelections(l){this.a=l}g(l){this.f.$trySetSelections(this.id,l.map(M.NotebookRange.from))}_acceptViewColumn(l){this.c=l}}e.$idc=L}),define(Re[206],Me([1,0,9,5,14,8]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Adc=void 0;let A=class{constructor(k,f){this.c=k,this.d=f,this.a=new M.$Md({onListenerError:y.$1}),this.b=new M.$Md({onListenerError:y.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,f);const R=this.d.getEditorById(k);f.visibleRanges&&R._acceptVisibleRanges(f.visibleRanges.ranges.map(L.NotebookRange.to)),f.selections&&R._acceptSelections(f.selections.selections.map(L.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const f in k)this.d.getEditorById(f)._acceptViewColumn(L.ViewColumn.to(k[f]))}};e.$Adc=A,e.$Adc=A=qe([We(0,C.$8i)],A)}),define(Re[207],Me([1,0,8,71,152,21,64,9]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ecc=void 0;class k{constructor(c){this.b=0,this.c=new Map,this.a=c}async withProgress(c,p,$){const m=this.b++,{title:t,location:i,cancellable:a}=p,b={label:(0,C.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this.a.$startProgress(m,{location:y.ProgressLocation.from(i),title:t,source:b,cancellable:a},c.isUnderDevelopment?void 0:c.identifier.value).catch(l.$1),this.d(m,$,!!a)}d(c,p,$){let m;$&&(m=new L.$Wd,this.c.set(c,m));const t=a=>{this.a.$progressEnd(a),this.c.delete(a),m?.dispose()};let i;try{i=p(new R(this.a,c),$&&m?m.token:L.CancellationToken.None)}catch(a){throw t(c),a}return i.then(a=>t(c),a=>t(c)),i}$acceptProgressCanceled(c){const p=this.c.get(c);p&&(p.cancel(),this.c.delete(c))}}e.$Ecc=k;function f(D,c){return D.message=c.message,typeof c.increment=="number"&&(typeof D.increment=="number"?D.increment+=c.increment:D.increment=c.increment),D}class R extends M.$1u{constructor(c,p){super($=>this.throttledReport($)),this.i=c,this.j=p}throttledReport(c){this.i.$progressReport(this.j,c)}}qe([(0,A.$hh)(100,(D,c)=>f(D,c),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Re[104],Me([1,0,45,101,46,76,56,8,2]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=e.$nM=void 0;const f=(b,E,v,r)=>{let s=E;return{enumerable:!0,configurable:!1,get(){return s},set(n){if(!v(s,n)){const o=s;s=n,b.listener?.(r(n,o))}}}},R=(b,E)=>b===E,D={range:(b,E)=>b===E?!0:!b||!E?!1:b.isEqual(E),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(b,E)=>!(b.length!==E.length||b.some(v=>!E.find(r=>v.id===r.id)))},c=b=>E=>({op:4,update:b(E)}),p=(b,E)=>({range:(()=>{let v;const r=c(s=>({range:y.$ps.lift(l.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return v},set(s){b.listener?.({op:6}),D.range(v,s)||(v=s,b.listener?.(r(s)))}}})(),label:f(b,E,D.label,c(v=>({label:v}))),description:f(b,void 0,D.description,c(v=>({description:v}))),sortText:f(b,void 0,D.sortText,c(v=>({sortText:v}))),canResolveChildren:f(b,!1,D.canResolveChildren,v=>({op:2,state:v})),busy:f(b,!1,D.busy,c(v=>({busy:v}))),error:f(b,void 0,D.error,c(v=>({error:l.MarkdownString.fromStrict(v)||null}))),tags:f(b,[],D.tags,(v,r)=>({op:1,new:v.map(l.TestTag.from),old:r.map(l.TestTag.from)}))}),$=b=>{const E=C.$6I.fromString(b.extId),v=new t(E.controllerId,E.localId,b.label,k.URI.revive(b.uri)||void 0);return v.range=l.Range.to(b.range||void 0),v.description=b.description||void 0,v.sortText=b.sortText||void 0,v.tags=b.tags.map(r=>l.TestTag.to({id:(0,A.$$I)(r).tagId})),v},m=b=>{let E;for(const v of b.tests){const r=$(v.item);(0,M.$0L)(r).parent=E,E=r}return E};e.$nM=m;class t{constructor(E,v,r,s){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const n=(0,M.$9L)(this,E);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,L.$8L)(n,M.$0L,t),enumerable:!0,writable:!1},...p(n,r)})}}e.$oM=t;class i extends t{constructor(E,v){super(E,E,v,void 0),this._isRoot=!0}}e.$pM=i;class a extends L.$4L{constructor(E,v,r){super({controllerId:E,getDocumentVersion:s=>s&&r.getDocument(s)?.version,getApiFor:M.$0L,getChildren:s=>s.children,root:new i(E,v),toITestItem:l.TestItem.from})}}e.$qM=a}),define(Re[105],Me([1,0,51,9,88,8,7]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kM=e.$jM=e.$iM=void 0;class l{static{this.c=new C.$gM("TextEditorDecorationType")}constructor(c,p,$){const m=l.c.nextId();c.$registerTextEditorDecorationType(p.identifier,m,L.DecorationRenderOptions.from($)),this.value=Object.freeze({key:m,dispose(){c.$removeTextEditorDecorationType(m)}})}}e.$iM=l;class k{constructor(c,p){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,p){this.k();let $=null;if(c instanceof A.$dK)$=new A.$eK(c,c);else if(c instanceof A.$eK)$=c;else throw new Error("Unrecognized location");this.l($,p,!1)}insert(c,p){this.k(),this.l(new A.$eK(c,c),p,!0)}delete(c){this.k();let p=null;if(c instanceof A.$eK)p=c;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(c,p,$){const m=this.c.validateRange(c);this.g.push({range:m,text:p,forceMoveMarkers:$})}setEndOfLine(c){if(this.k(),c!==A.EndOfLine.LF&&c!==A.EndOfLine.CRLF)throw(0,M.$6)("endOfLine");this.h=c}}class f{constructor(c,p,$,m){this.c=c,this.d=p,this._accept($),this.e=m;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.insertSpaces,this.j=c.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(c.lineNumbers)}l(c){if(c==="auto")return"auto";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}m(c){const p=this.l(c);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const p=Math.floor(c);return p>0?p:null}if(typeof c=="string"){const p=parseInt(c,10);return isNaN(p)?null:p>0?p:null}return null}o(c){const p=this.n(c);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(c){return c==="auto"?"auto":c==="false"?!1:!!c}q(c){const p=this.p(c);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(c){this.j!==c&&(this.j=c,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}t(c){this.k!==c&&(this.k=c,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(c)})))}assign(c){const p={};let $=!1;if(typeof c.tabSize<"u"){const m=this.l(c.tabSize);m==="auto"?($=!0,p.tabSize=m):typeof m=="number"&&this.f!==m&&(this.f=m,$=!0,p.tabSize=m)}if(typeof c.indentSize<"u"){const m=this.n(c.indentSize);m==="tabSize"?($=!0,p.indentSize=m):typeof m=="number"&&this.g!==m&&(this.g=m,$=!0,p.indentSize=m)}if(typeof c.insertSpaces<"u"){const m=this.p(c.insertSpaces);m==="auto"?($=!0,p.insertSpaces=m):this.h!==m&&(this.h=m,$=!0,p.insertSpaces=m)}typeof c.cursorStyle<"u"&&this.j!==c.cursorStyle&&(this.j=c.cursorStyle,$=!0,p.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.k!==c.lineNumbers&&(this.k=c.lineNumbers,$=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(c.lineNumbers)),$&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(c,p){p.catch($=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn($)})}}e.$jM=f;class R{constructor(c,p,$,m,t,i,a,b){this.id=c,this.j=p,this.k=$,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,$),this.e=a,this.f=b;const E=this;this.value=Object.freeze({get document(){return m.value},set document(v){throw new M.$8("document")},get selection(){return E.c&&E.c[0]},set selection(v){if(!(v instanceof A.$fK))throw(0,M.$6)("selection");E.c=[v],E.l()},get selections(){return E.c},set selections(v){if(!Array.isArray(v)||v.some(r=>!(r instanceof A.$fK)))throw(0,M.$6)("selections");E.c=v,E.l()},get visibleRanges(){return E.e},set visibleRanges(v){throw new M.$8("visibleRanges")},get options(){return E.d.value},set options(v){E.g||E.d.assign(v)},get viewColumn(){return E.f},set viewColumn(v){throw new M.$8("viewColumn")},edit(v,r={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new k(m.value,r);return v(s),E.m(s)},insertSnippet(v,r,s={undoStopBefore:!0,undoStopAfter:!0}){if(E.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=E.c.map(o=>L.Range.from(o));else if(r instanceof A.$dK){const{lineNumber:o,column:w}=L.Position.from(r);n=[{startLineNumber:o,startColumn:w,endLineNumber:o,endColumn:w}]}else if(r instanceof A.$eK)n=[L.Range.from(r)];else{n=[];for(const o of r)if(o instanceof A.$eK)n.push(L.Range.from(o));else{const{lineNumber:w,column:d}=L.Position.from(o);n.push({startLineNumber:w,startColumn:d,endLineNumber:w,endColumn:d})}}return p.$tryInsertSnippet(c,m.value.version,v.value,n,s)},setDecorations(v,r){const s=r.length===0;s&&!E.h.has(v.key)||(s?E.h.delete(v.key):E.h.add(v.key),E.n(()=>{if(L.$$L(r))return p.$trySetDecorations(c,v.key,L.$_L(r));{const n=new Array(4*r.length);for(let o=0,w=r.length;o<w;o++){const d=r[o];n[4*o]=d.start.line+1,n[4*o+1]=d.start.character+1,n[4*o+2]=d.end.line+1,n[4*o+3]=d.end.character+1}return p.$trySetDecorationsFast(c,v.key,n)}}))},revealRange(v,r){E.n(()=>p.$tryRevealRange(c,L.Range.from(v),r||A.TextEditorRevealType.Default))},show(v){p.$tryShowEditor(c,L.ViewColumn.from(v))},hide(){p.$tryHideEditor(c)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,y.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,y.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,y.ok)(!this.g),this.f=c}_acceptSelections(c){(0,y.ok)(!this.g),this.c=c}async l(){const c=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const p=c.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const $=p.edits.map(t=>t.range);$.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=$.length-1;t<i;t++){const a=$[t].end;if($[t+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const m=p.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,m,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$kM=R}),define(Re[208],Me([1,0,4,171]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xJ=void 0,e.$xJ=(0,y.$Oh)(M.$Uh)}),define(Re[106],Me([1,0,20,5,19,6]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d4b=e.$c4b=e.$b4b=e.$a4b=e.$_3b=e.$$3b=void 0;class A{constructor(i,a){this.versionId=i,this.removedDueToLooping=a}}e.$$3b=A;class l{static isHostExtension(i,a,b){if(a.getExtensionDescription(i))return!1;const E=b.getExtensionDescription(i);return E?!!((E.main||E.browser)&&E.api==="none"):!1}constructor(i,a){this.j=i,this.c=new M.$Md,this.onDidChange=this.c.event,this.d=0,this.e=a,this.k()}k(){this.e.sort($),this.f=new y.$5l,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const a=this.j.readActivationEvents(i);if(Array.isArray(a))for(let b of a)b==="onUri"&&(b=`onUri:${y.$3l.toKey(i.identifier)}`),this.h.has(b)||this.h.set(b,[]),this.h.get(b).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,a){this.e=m(this.e,a),this.e=this.e.concat(i);const b=l.l(this.e);return this.e=m(this.e,b.map(E=>E.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,b)}static l(i){const a=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,n){this.addNode(s),this.addNode(n),this.c.has(s)?this.c.get(s).push(n):this.c.set(s,[n])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,n){const o=a.getArcs(s);for(let w=0;w<o.length;w++)if(!n.has(o[w]))return!1;return!0}getNodes(){return this.e}},b=new y.$5l;for(const s of i)if(b.set(s.identifier,s),s.extensionDependencies)for(const n of s.extensionDependencies)a.addArc(y.$3l.toKey(s.identifier),y.$3l.toKey(n));const E=new Set;a.getNodes().filter(s=>a.getArcs(s).length===0).forEach(s=>E.add(s));const v=a.getNodes().filter(s=>!E.has(s));let r;do{r=!1;for(let s=0;s<v.length;s++){const n=v[s];a.hasOnlyGoodArcs(n,E)&&(v.splice(s,1),s--,E.add(n),r=!0)}}while(r);return v.map(s=>b.get(s))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const a=this.h.get(i);return a?a.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new k(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const a=this.f.get(i);return a||void 0}getExtensionDescriptionByUUID(i){for(const a of this.g)if(a.uuid===i)return a}getExtensionDescriptionByIdOrUUID(i,a){return this.getExtensionDescription(i)??(a?this.getExtensionDescriptionByUUID(a):void 0)}}e.$_3b=l;class k{constructor(i,a){this.versionId=i,this.extensions=a}}e.$a4b=k,e.$b4b={readActivationEvents:t=>t.activationEvents};class f{constructor(i){this.d=new c,this.c=new l(i,[])}async acquireLock(i){const a=await this.d.acquire(i);return new R(this,a)}deltaExtensions(i,a,b){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(a,b)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,a){return this.c.getExtensionDescriptionByIdOrUUID(i,a)}}e.$c4b=f;class R extends L.$Rc{constructor(i,a){super(),this.f=i,this.c=!1,this.B(a)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$d4b=R;class D{constructor(i){this.name=i,this.promise=new Promise((a,b)=>{this.c=a})}resolve(i){this.c(i)}}class c{constructor(){this.c=[],this.d=!1}async acquire(i){const a=new D(i);return this.c.push(a),this.e(),a.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let a=!0;const b=setTimeout(()=>{a&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),E=()=>{a&&(clearTimeout(b),a=!1,this.d=!1,this.e())};i.resolve((0,L.$Pc)(E))}}var p;(function(t){t[t.Builtin=0]="Builtin",t[t.User=1]="User",t[t.Dev=2]="Dev"})(p||(p={}));function $(t,i){const a=t.isBuiltin?0:t.isUnderDevelopment?2:1,b=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(a!==b)return a-b;const E=C.$fc.basename(t.extensionLocation.path),v=C.$fc.basename(i.extensionLocation.path);return E<v?-1:E>v?1:0}function m(t,i){const a=new y.$4l(i);return t.filter(b=>!a.has(b.identifier))}}),define(Re[79],Me([1,0,26]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$_l=e.$$l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(M||(e.UIKind=M={}));var C;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(C||(e.ExtensionHostExitCode=C={}));var L;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(f){const R=y.$ae.alloc(1);switch(f){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$$l=A;function l(f,R){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$_l=l;var k;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Re[57],Me([1,0,4,5,14,27,79,52,53,24,2,6,154]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=e.$uM=e.$tM=e.$sM=void 0;let p=class extends D.$Rc{constructor(i,a){super(),this.s=i,this.t=a,this.a=this.B(new M.$Md),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Md),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=a.createLogger(this.m,{id:k.$lo,name:(0,c.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel(b=>{(0,C.$0i)(b)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===C.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,a,b){const E=this.getTelemetryDetails(),v=new $(a,b,i,this.n,this.j,this.getBuiltInCommonProperties(i),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),r=this.r.get(i.identifier.value)??[];return this.r.set(i.identifier.value,[...r,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(i,a,b){this.f=i,this.g=a,this.c=b??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(i){const a=Object.create(null);switch(a["common.extname"]=`${i.publisher}.${i.name}`,a["common.extversion"]=i.version,a["common.vscodemachineid"]=this.s.telemetryInfo.machineId,a["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,a["common.vscodeversion"]=this.s.version,a["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),a["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:a["common.uikind"]="web";break;case A.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,l.$Tk)((0,k.$so)(this.s.remote.authority)),a}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const a=this.getTelemetryDetails();this.r.forEach((b,E)=>{const v=b.filter(r=>!r.isDisposed);v.length===0?this.r.delete(E):this.r.set(E,v)}),this.r.forEach(b=>{for(const E of b)E.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(i,a){const E=this.r.get(i.value)?.filter(r=>!r.isDisposed);if(!E)return this.r.delete(i.value),!1;let v=!1;for(const r of E)r.ignoreUnhandledExtHostErrors||(r.logError(a),v=!0);return v}};e.$sM=p,e.$sM=p=qe([We(0,L.$rM),We(1,C.$9i)],p);class ${static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,a,b,E,v,r,s){this.g=b,this.h=E,this.i=v,this.j=r,this.a=new M.$Md,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(i,a){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let a="properties"in i?i.properties??{}:i;return a=(0,k.$vo)(a,[]),this.c&&(a=(0,f.$6m)(a,this.c)),this.b||(a=(0,f.$6m)(a,this.j)),"properties"in i?i.properties=a:i=a,i}k(i,a){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(i,a),this.h.trace(i,a))}logUsage(i,a){this.d.isUsageEnabled&&this.k(i,a)}logError(i,a){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,a);else{const b={name:i.name,message:i.message,stack:i.stack,cause:i.cause},E=(0,k.$vo)(b,[]),v=new Error(E.message,{cause:E.cause});v.stack=E.stack,v.name=E.name,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f.sendErrorData(v,a),this.h.trace("exception",a)}}get apiTelemetryLogger(){if(!this.e){const i=this,a={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$tM=$;function m(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$uM=m,e.$vM=(0,y.$Nh)("IExtHostTelemetry")}),define(Re[25],Me([1,0,5,2,180,98,20,4]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.$eF=e.$dF=e.ActivationKind=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.ExtensionHostStartup=e.$0E=e.$9E=e.$8E=e.$7E=void 0,e.$7E=Object.freeze({identifier:new A.$3l("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$8E="extensions.webWorker",e.$9E=(0,l.$Nh)("extensionService");class k{constructor(v){this.dependency=v}}e.$0E=k;var f;(function(E){E[E.EagerAutoStart=1]="EagerAutoStart",E[E.EagerManualStart=2]="EagerManualStart",E[E.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(v,r,s){this.c=v,this.d=r.slice(0),this.e=s.slice(0)}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$RE.createActivationEventsMap(this.d)}}set(v,r,s){if(this.c>v)throw new Error(`ExtensionHostExtensions: invalid versionId ${v} (current: ${this.c})`);const n=[],o=[],w=[],d=[],I=D(this.d),S=D(r),u=(K,j)=>K.extensionLocation.toString()===j.extensionLocation.toString()||K.isBuiltin===j.isBuiltin||K.isUserBuiltin===j.isUserBuiltin||K.isUnderDevelopment===j.isUnderDevelopment;for(const K of this.d){const j=S.get(K.identifier);if(!j){n.push(K.identifier),I.delete(K.identifier);continue}if(!u(K,j)){n.push(K.identifier),I.delete(K.identifier);continue}}for(const K of r){const j=I.get(K.identifier);if(!j){o.push(K);continue}if(!u(j,K)){n.push(j.identifier),I.delete(j.identifier);continue}}const g=new A.$4l(this.e),h=new A.$4l(s);for(const K of this.e)h.has(K)||w.push(K);for(const K of s)g.has(K)||d.push(K);const P=L.$RE.createActivationEventsMap(o),W={versionId:v,toRemove:n,toAdd:o,addActivationEvents:P,myToRemove:w,myToAdd:d};return this.delta(W),W}delta(v){if(this.c>=v.versionId)return null;const{toRemove:r,toAdd:s,myToRemove:n,myToAdd:o}=v,w=new A.$4l(r),d=new A.$4l(n);for(let I=0;I<this.d.length;I++)w.has(this.d[I].identifier)&&(this.d.splice(I,1),I--);for(let I=0;I<this.e.length;I++)d.has(this.e[I])&&(this.e.splice(I,1),I--);for(const I of s)this.d.push(I);for(const I of o)this.e.push(I);return v}containsExtension(v){for(const r of this.e)if(A.$3l.equals(r,v))return!0;return!1}}e.$$E=R;function D(E){const v=new A.$5l;for(const r of E)v.set(r.identifier,r);return v}function c(E,v){return E.enabledApiProposals?E.enabledApiProposals.includes(v):!1}e.$_E=c;function p(E,v){if(!c(E,v))throw new Error(`Extension '${E.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${E.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${E.identifier.value}`)}e.$aF=p;class ${constructor(v,r,s,n){this.codeLoadingTime=v,this.activateCallTime=r,this.activateResolvedTime=s,this.activationReason=n}}e.$bF=$;class m{constructor(v,r){this.description=v,this.value=r}}e.$cF=m;var t;(function(E){E[E.Normal=0]="Normal",E[E.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(E){return{type:E.isBuiltin?0:1,isBuiltin:E.isBuiltin||E.isUserBuiltin,identifier:{id:(0,C.$Bo)(E.publisher,E.name),uuid:E.uuid},manifest:E,location:E.extensionLocation,targetPlatform:E.targetPlatform,validations:[],isValid:!0}}e.$dF=i;function a(E,v){return{identifier:new A.$3l((0,C.$zo)(E.manifest.publisher,E.manifest.name)),isBuiltin:E.type===0,isUserBuiltin:E.type===1&&E.isBuiltin,isUnderDevelopment:!!v,extensionLocation:E.location,...E.manifest,uuid:E.identifier.uuid,targetPlatform:E.targetPlatform}}e.$eF=a;class b{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$fF=b}),define(Re[209],Me([1,0,9,106,20,25,14,12]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=e.$$bc=e.$0bc=e.$9bc=e.$8bc=e.$7bc=void 0;class k{static{this.NONE=new k(!1,-1,-1,-1)}constructor(i,a,b,E){this.startup=i,this.codeLoadingTime=a,this.activateCallTime=b,this.activateResolvedTime=E}}e.$7bc=k;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,a){return i===-1||a===-1?-1:a-i}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$8bc=f;class R{constructor(i,a,b,E,v,r){this.activationFailed=i,this.activationFailedError=a,this.activationTimes=b,this.module=E,this.exports=v,this.subscriptions=r}}e.$9bc=R;class D extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$0bc=D;class c extends R{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$$bc=c;class p extends R{constructor(i){super(!0,i,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let $=class{constructor(i,a,b,E){this.g=E,this.a=i,this.b=a,this.c=b,this.d=new C.$5l,this.f=Object.create(null)}dispose(){for(const[i,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const i=[];for(const[a,b]of this.d)i.push(b.wait());await Promise.all(i)}isActivated(i){const a=this.d.get(i);return!!(a&&a.value)}getActivatedExtension(i){const a=this.d.get(i);if(!a||!a.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return a.value}async activateByEvent(i,a){if(this.f[i])return;const b=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(b.map(E=>({id:E.identifier,reason:{startup:a,extensionId:E.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,a){const b=this.a.getExtensionDescription(i);if(!b)throw new Error(`Extension '${i}' is not known`);return this.h([{id:b.identifier,reason:a}])}async h(i){const a=i.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(a.map(b=>b.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const a=this.a.getExtensionDescription(i.id);if(!a){const v=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new p(v));return this.c.onExtensionActivationError(i.id,v,new L.$0E(i.id.value)),r}const b=[],E=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const v of E){if(this.m(v))continue;const r=this.d.get(v);if(r){b.push(r);continue}if(this.l(v)){b.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:i.reason}));continue}const s=this.a.getExtensionDescription(v);if(s){if(!s.main&&!s.browser)continue;b.push(this.j({id:s.identifier,reason:i.reason}));continue}const n=a.displayName||a.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${v}'`),w=this.k(i,a.displayName,[],new p(o));return this.c.onExtensionActivationError(a.identifier,o,new L.$0E(v)),w}return this.k(i,a.displayName,b,null)}k(i,a,b,E){const v=new m(i.id,a,i.reason,b,E,this.c,this.g);return this.d.set(i.id,v),v}l(i){return M.$_3b.isHostExtension(i,this.a,this.b)}m(i){const a=this.b.getExtensionDescription(i);return a?!a.main&&!a.browser:!1}};e.$_bc=$,e.$_bc=$=qe([We(3,A.$8i)],$);let m=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,a,b,E,v,r,s){this.c=i,this.d=a,this.f=b,this.g=E,this.h=v,this.j=r,this.k=s,this.a=new l.$Rg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const a=this.g[i];if(a.value&&!a.value.activationFailed){this.g.splice(i,1),i--;continue}if(a.value&&a.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);b.detail=a.value.activationFailedError,this.h=new p(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const a=new Error;if(i&&i.name&&(a.name=i.name),i&&i.message?a.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(a.stack=i.stack),this.h=new p(a),this.b&&y.$3(i))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};m=qe([We(6,A.$8i)],m)}),define(Re[210],Me([1,0,156,23,2,5,6,192,12,7,16,18,8,50,21,125,25]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;function i(E,v){if((0,R.$xf)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let r;return Array.isArray(E.highlights)&&(r=E.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),r=r.length?r:void 0),{label:E.label,highlights:r}}}class a extends A.$Rc{constructor(v,r,s){super(),this.f=v,this.g=r,this.h=s,this.a=new Map,this.b=new m.$G7;function n(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}r.registerArgumentProcessor({processArgument:o=>n(o)?this.r(o):Array.isArray(o)&&o.length>0?o.map(w=>n(w)?this.r(w):w):o})}registerTreeDataProvider(v,r,s){const n=this.createTreeView(v,{treeDataProvider:r},s);return{dispose:()=>n.dispose()}}createTreeView(v,r,s){if(!r||!r.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=r.dragAndDropController?.dropMimeTypes??[],o=r.dragAndDropController?.dragMimeTypes??[],w=!!r.dragAndDropController?.handleDrag,d=!!r.dragAndDropController?.handleDrop,I=this.m(v,r,s),S={showCollapseAll:!!r.showCollapseAll,canSelectMany:!!r.canSelectMany,dropMimeTypes:n,dragMimeTypes:o,hasHandleDrag:w,hasHandleDrop:d,manuallyManageCheckboxes:!!r.manageCheckboxStateManually},u=this.f.$registerTreeViewDataProvider(v,S),g={get onDidCollapseElement(){return I.onDidCollapseElement},get onDidExpandElement(){return I.onDidExpandElement},get selection(){return I.selectedElements},get onDidChangeSelection(){return I.onDidChangeSelection},get activeItem(){return(0,t.$aF)(s,"treeViewActiveItem"),I.focusedElement},get onDidChangeActiveItem(){return(0,t.$aF)(s,"treeViewActiveItem"),I.onDidChangeActiveItem},get visible(){return I.visible},get onDidChangeVisibility(){return I.onDidChangeVisibility},get onDidChangeCheckboxState(){return I.onDidChangeCheckboxState},get message(){return I.message},set message(h){(0,p.$3j)(h)&&(0,t.$aF)(s,"treeViewMarkdownMessage"),I.message=h},get title(){return I.title},set title(h){I.title=h},get description(){return I.description},set description(h){I.description=h},get badge(){return I.badge},set badge(h){h!==void 0&&f.ViewBadge.isViewBadge(h)?I.badge={value:Math.floor(Math.abs(h.value)),tooltip:h.tooltip}:h===void 0&&(I.badge=void 0)},reveal:(h,P)=>I.reveal(h,P),dispose:async()=>{await u,this.a.delete(v),I.dispose()}};return this.B(g),g}$getChildren(v,r){const s=this.a.get(v);return s?s.getChildren(r):Promise.reject(new l.$mE(v))}async $handleDrop(v,r,s,n,o,w,d,I){const S=this.a.get(v);if(!S)return Promise.reject(new l.$mE(v));const u=c.DataTransfer.toDataTransfer(s,async g=>(await this.f.$resolveDropFileData(v,r,g)).buffer);return d===v&&I&&await this.j(u,S,I,o,w),S.onDrop(u,n,o)}async j(v,r,s,n,o){const w=this.b.removeDragOperationTransfer(o);if(w)(await w)?.forEach((d,I)=>{d&&v.set(I,d)});else if(o&&r.handleDrag){const d=r.handleDrag(s,v,n);this.b.addDragOperationTransfer(o,d),await d}return v}async $handleDrag(v,r,s,n){const o=this.a.get(v);if(!o)return Promise.reject(new l.$mE(v));const w=await this.j(new f.$6K,o,r,n,s);if(!(!w||n.isCancellationRequested))return c.DataTransfer.from(w)}async $hasResolve(v){const r=this.a.get(v);if(!r)throw new l.$mE(v);return r.hasResolve}$resolve(v,r,s){const n=this.a.get(v);if(!n)throw new l.$mE(v);return n.resolveTreeItem(r,s)}$setExpanded(v,r,s){const n=this.a.get(v);if(!n)throw new l.$mE(v);n.setExpanded(r,s)}$setSelectionAndFocus(v,r,s){const n=this.a.get(v);if(!n)throw new l.$mE(v);n.setSelectionAndFocus(r,s)}$setVisible(v,r){const s=this.a.get(v);if(!s){if(!r)return;throw new l.$mE(v)}s.setVisible(r)}$changeCheckboxState(v,r){const s=this.a.get(v);if(!s)throw new l.$mE(v);s.setCheckboxState(r)}m(v,r,s){const n=this.B(new b(v,r,this.f,this.g.converter,this.h,s));return this.a.set(v,n),n}r(v){const r=this.a.get(v.$treeViewId);return r&&"$treeItemHandle"in v?r.getExtensionElement(v.$treeItemHandle):r&&"$focusedTreeItem"in v&&v.$focusedTreeItem?r.focusedElement:null}}e.$Lcc=a;class b extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(v=>this.getExtensionElement(v)).filter(v=>!(0,R.$Gf)(v))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(v,r,s,n,o,w){if(super(),this.I=v,this.J=s,this.L=n,this.M=o,this.N=w,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Md),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Md),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Md),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Md),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Md),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Md),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Md),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new $.$Wd,w.contributes&&w.contributes.views)for(const u in w.contributes.views)for(const g of w.contributes.views[u])g.id===v&&(this.P=g.name);this.f=r.treeDataProvider,this.g=r.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.F.fire({message:!1,element:u})));let d,I;const S=L.Event.debounce(this.F.event,(u,g)=>(u||(u={message:!1,elements:[]}),g.element!==!1&&(d||(d=new Promise(h=>I=h),this.G=this.G.then(()=>d)),Array.isArray(g.element)?u.elements.push(...g.element):u.elements.push(g.element)),g.message&&(u.message=!0),u),200,!0);this.B(S(({message:u,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const h=I;return d=null,this.$(g).then(()=>h())})),u&&this.J.$setMessage(this.I,c.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(v){const r=v?this.getExtensionElement(v):void 0;if(v&&!r)return this.M.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let s=this.X(v);return s||(s=await this.Y(r)),s?s.map(n=>n.item):void 0}getExtensionElement(v){return this.j.get(v)}reveal(v,r){r=r||{select:!0,focus:!1};const s=(0,R.$Gf)(r.select)?!0:r.select,n=(0,R.$Gf)(r.focus)?!1:r.focus,o=(0,R.$Gf)(r.expand)?!1:r.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.G.then(()=>this.S(v)).then(w=>this.W(v,w[w.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:w.map(I=>I.item)},{select:s,focus:n,expand:o})),w=>this.M.error(w)):this.J.$reveal(this.I,void 0,{select:s,focus:n,expand:o})}get message(){return this.O}set message(v){this.O=v,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(v){this.P=v,this.J.$setTitle(this.I,v,this.Q)}get description(){return this.Q}set description(v){this.Q=v,this.J.$setTitle(this.I,this.P,v)}get badge(){return this.R}set badge(v){this.R?.value===v?.value&&this.R?.tooltip===v?.tooltip||(this.R=c.ViewBadge.from(v),this.J.$setBadge(this.I,v))}setExpanded(v,r){const s=this.getExtensionElement(v);s&&(r?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(v,r){const s=!(0,D.$tb)(this.s,v);this.s=v;const n=this.t!==r;this.t=r,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(v){v!==this.r&&(this.r=v,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(v){const r=(await Promise.all(v.map(async s=>{const n=this.getExtensionElement(s.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);r.forEach(s=>{s.treeItem.checkboxState=s.newState?f.TreeItemCheckboxState.Checked:f.TreeItemCheckboxState.Unchecked}),this.D.fire({items:r.map(s=>[s.extensionItem,s.newState])})}async handleDrag(v,r,s){const n=[];for(const o of v){const w=this.getExtensionElement(o);w&&n.push(w)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,r,s),r}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,r,s){const n=r?this.getExtensionElement(r):void 0;if(!(!n&&r||!this.g?.handleDrop))return(0,k.$Lg)(()=>this.g?.handleDrop?this.g.handleDrop(n,v,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,r){if(!this.f.resolveTreeItem)return;const s=this.j.get(v);if(s){const n=this.m.get(s);if(n){const o=await this.f.resolveTreeItem(n.extensionItem,s,r)??n.extensionItem;return this.hb(o),n.item.tooltip=this.eb(o.tooltip),n.item.command=this.fb(n.disposableStore,o.command),n.item}}}S(v){return this.U(v).then(r=>r?this.S(r).then(s=>this.W(r,s[s.length-1]).then(n=>(s.push(n),s))):Promise.resolve([]))}U(v){const r=this.m.get(v);return r?Promise.resolve(r.parent?this.j.get(r.parent.item.handle):void 0):(0,k.$Lg)(()=>this.f.getParent(v))}W(v,r){const s=this.m.get(v);return s?Promise.resolve(s):(0,k.$Lg)(()=>this.f.getTreeItem(v)).then(n=>this.kb(v,n,r,!0)).then(n=>this.getChildren(r?r.item.handle:void 0).then(()=>{const o=this.getExtensionElement(n);if(o){const w=this.m.get(o);if(w)return Promise.resolve(w)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X(v){if(v){let r;if(typeof v=="string"){const s=this.getExtensionElement(v);r=s?this.m.get(s):void 0}else r=v;return r&&r.children||void 0}return this.h}async Y(v){this.rb(v);const r=new $.$Wd(this.Z.token);try{const s=v?this.m.get(v):void 0,n=await this.f.getChildren(v);if(r.token.isCancellationRequested)return;const o=await Promise.all((0,D.$Gb)(n||[]).map(async w=>{const d=await this.f.getTreeItem(w);return d&&!r.token.isCancellationRequested?this.db(w,d,s):null}));return r.token.isCancellationRequested?void 0:(0,D.$Gb)(o)}finally{r.dispose()}}$(v){if(v.some(s=>!s))return this.Z.dispose(!0),this.Z=new $.$Wd,this.tb(),this.J.$refresh(this.I);{const s=this.ab(v);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(v){const r=new Set,s=v.map(o=>this.m.get(o));for(const o of s)if(o&&!r.has(o.item.handle)){let w=o;for(;w&&w.parent&&s.findIndex(d=>w&&w.parent&&d&&d.item.handle===w.parent.item.handle)===-1;){const d=this.j.get(w.parent.item.handle);w=d?this.m.get(d):void 0}w&&!w.parent&&r.add(o.item.handle)}const n=[];return r.forEach(o=>{const w=this.j.get(o);if(w){const d=this.m.get(w);d&&(!d.parent||!r.has(d.parent.item.handle))&&n.push(o)}}),n}bb(v){const r={};return Promise.all(v.map(s=>this.cb(s).then(n=>{n&&(r[s]=n.item)}))).then(()=>Object.keys(r).length?this.J.$refresh(this.I,r):void 0)}cb(v){const r=this.getExtensionElement(v);if(r){const s=this.m.get(r);if(s)return this.rb(r),(0,k.$Lg)(()=>this.f.getTreeItem(r)).then(n=>{if(n){const o=this.ib(r,n,s.parent);return this.pb(r,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}db(v,r,s){const n=this.ib(v,r,s);if(r.id&&this.j.has(n.item.handle))throw new Error((0,y.localize)(0,null,r.id));return this.ob(v,n),this.qb(n,s),n}eb(v){return f.$CK.isMarkdownString(v)?c.MarkdownString.from(v):v}fb(v,r){return r?{...this.L.toInternal(r,v),originalId:r.command}:void 0}gb(v){if(v.checkboxState===void 0)return;let r,s,n;return typeof v.checkboxState=="number"?r=v.checkboxState:(r=v.checkboxState.state,s=v.checkboxState.tooltip,n=v.checkboxState.accessibilityInformation),{isChecked:r===f.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:n}}hb(v){if(!f.$1K.isTreeItem(v,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(v,r,s){this.hb(r);const n=this.B(new A.$Qc),o=this.kb(v,r,s),w=this.lb(r);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:i(r.label,this.N),description:r.description,resourceUri:r.resourceUri,tooltip:this.eb(r.tooltip),command:this.fb(n,r.command),contextValue:r.contextValue,icon:w,iconDark:this.mb(r)||w,themeIcon:this.jb(r),collapsibleState:(0,R.$Gf)(r.collapsibleState)?f.TreeItemCollapsibleState.None:r.collapsibleState,accessibilityInformation:r.accessibilityInformation,checkbox:this.gb(r)},extensionItem:r,parent:s,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb(v){return v.iconPath instanceof f.$9K?v.iconPath:void 0}kb(v,{id:r,label:s,resourceUri:n},o,w){if(r)return`${b.b}/${r}`;const d=i(s,this.N),I=o?o.item.handle:b.a;let S=d?d.label:n?(0,M.$rg)(n):"";S=S.indexOf("/")!==-1?S.replace("/","//"):S;const u=this.m.has(v)?this.m.get(v).item.handle:void 0,g=this.X(o)||[];let h,P=0;do{if(h=`${I}/${P}:${S}`,w||!this.j.has(h)||u===h)break;P++}while(P<=g.length);return h}lb(v){if(v.iconPath&&!(v.iconPath instanceof f.$9K))return typeof v.iconPath=="string"||C.URI.isUri(v.iconPath)?this.nb(v.iconPath):this.nb(v.iconPath.light)}mb(v){if(v.iconPath&&!(v.iconPath instanceof f.$9K)&&v.iconPath.dark)return this.nb(v.iconPath.dark)}nb(v){return C.URI.isUri(v)?v:C.URI.file(v)}ob(v,r){this.j.set(r.item.handle,v),this.m.set(v,r)}pb(v,r,s,n){this.j.delete(r.item.handle),this.m.delete(v),r.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(v,r);const o=this.X(n)||[],w=o.filter(d=>d.item.handle===s.item.handle)[0];w&&o.splice(o.indexOf(w),1,r)}qb(v,r){r?(r.children||(r.children=[]),r.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}rb(v){if(v){const r=this.m.get(v);if(r){if(r.children)for(const s of r.children){const n=this.j.get(s.item.handle);n&&this.sb(n)}r.children=void 0}}else this.tb()}sb(v){const r=this.m.get(v);if(r){if(r.children)for(const s of r.children){const n=this.j.get(s.item.handle);n&&this.sb(n)}this.m.delete(v),this.j.delete(r.item.handle),r.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(v=>v.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[211],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[212],Me([1,0,166,9,29,92,72,30,20,211,176,98]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=void 0;const c=l.$cn.as(A.$dn.JSONContribution);class p{constructor(v,r,s){this.a=v,this.b=r,this.c=s}d(v,r){this.a({type:v,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(C.default.Error,v)}warn(v){this.d(C.default.Warning,v)}info(v){this.d(C.default.Info,v)}}e.$1E=p;class ${static a(v){const r=new k.$4l;for(let s=0,n=v.length;s<n;s++)r.add(v[s].description.identifier);return r}static compute(v,r){if(!v||!v.length)return new $(r,[]);if(!r||!r.length)return new $([],v);const s=this.a(v),n=this.a(r),o=r.filter(d=>!s.has(d.description.identifier)),w=v.filter(d=>!n.has(d.description.identifier));return new $(o,w)}constructor(v,r){this.added=v,this.removed=r}}e.$2E=$;class m{constructor(v,r){this.name=v,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=$.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,M.$Z)(v)}}}e.$3E=m;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$4E={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$2l},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Tn}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Tn}},extensionKind:{description:y.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class a{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const r=new m(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,r),v.activationEventsGenerator&&D.$RE.register(v.extensionPoint,v.activationEventsGenerator),e.$4E.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,c.registerSchema(i,e.$4E),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$5E=a;const b={ExtensionsRegistry:"ExtensionsRegistry"};l.$cn.add(b.ExtensionsRegistry,new a),e.$6E=l.$cn.as(b.ExtensionsRegistry),c.registerSchema(i,e.$4E),c.registerSchema(R.$oj,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Re[213],Me([1,0,163,16,24,212,32,5]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var f;(function(c){function p($,m,t){if(!$)return;const i=M.$xf($.type)?$.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const a=[];if(Array.isArray($.required))for(const b of $.required)M.$xf(b)&&a.push(b);return{extensionId:m.value,taskType:i,required:a,properties:$.properties?C.$3m($.properties):{},when:$.when?A.$Li.deserialize($.when):void 0}}c.from=p})(f||(f={}));const R=L.$6E.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,p)=>{for(const $ of c)$.type&&p.push(`onTaskType:${$.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:k}});class D{constructor(){this.d=new l.$Md,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,$)=>{R.setHandler((m,t)=>{this.c=void 0;try{for(const i of t.removed){const a=i.value;for(const b of a)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const i of t.added){const a=i.value;for(const b of a){const E=f.from(b,i.description.identifier,i.collector);E&&(this.a[E.taskType]=E)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const $ of this.all()){const m={type:"object",additionalProperties:!1};$.required.length>0&&(m.required=$.required.slice(0)),$.properties!==void 0?m.properties=C.$3m($.properties):m.properties=Object.create(null),m.properties.type={type:"string",enum:[$.taskType]},p.push(m)}this.c={oneOf:p}}return this.c}}e.$NF=new D}),define(Re[214],Me([1,0,164,16,23,24,32,213]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$XF=e.JsonSchemaVersion=e.ExecutionEngine=e.$WF=e.$VF=e.$UF=e.$TF=e.$SF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$RF=e.ShellQuoting=e.$QF=e.$PF=e.$OF=void 0,e.$OF="settings",e.$PF=new A.$5i("taskRunning",!1,y.localize(0,null)),e.$QF={value:y.localize(1,null),original:"Tasks"};var k;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$RF="$customized",function(O){function N(te){if(!te)return O.Strong;switch(te.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(k||(e.ShellQuoting=k={}));var f;(function(O){O.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R||(e.RevealKind=R={})),function(O){function N(te){switch(te.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(R||(e.RevealKind=R={}));var D;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(O){function N(te){switch(te.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(D||(e.RevealProblemKind=D={}));var c;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(c||(e.PanelKind=c={})),function(O){function N(te){switch(te.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(c||(e.PanelKind=c={}));var p;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:D.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var $;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})($||(e.RuntimeType=$={})),function(O){function N(Y){switch(Y.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function te(Y){switch(Y){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=te}($||(e.RuntimeType=$={}));var m;(function(O){function N(te){return M.$xf(te)?te:te.value}O.value=N})(m||(e.CommandString=m={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Y){return Y===O.Clean._id||Y===O.Build._id||Y===O.Rebuild._id||Y===O.Test._id}O.is=N;function te(Y){if(Y!==void 0)return M.$xf(Y)?N(Y)?{_id:Y,isDefault:!1}:void 0:Y}O.from=te})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var a;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(te){switch(te){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(a||(e.TaskSourceKind=a={}));var b;(function(O){O.parallel="parallel",O.sequence="sequence"})(b||(e.DependsOrder=b={}));var E;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(E||(e.RunOnOptions=E={}));var v;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:E.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class r{constructor(N,te,Y,Ee,Se,Pe){this._label="",this._id=N,te&&(this._label=te),Y&&(this.type=Y),this.runOptions=Ee,this.configurationProperties=Se,this._source=Pe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,te=!1){if(N===void 0)return!1;if(M.$xf(N))return N===this._label||N===this.configurationProperties.identifier||te&&N===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$SF=r;class s extends r{constructor(N,te,Y,Ee,Se,Pe,ge,me){super(N,Y,void 0,ge,me,te),this.command={},this._source=te,this.hasDefinedMatchers=Pe,Se&&(this.command=Se)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let te;switch(this.command?this.command.runtime:void 0){case $.Shell:te="shell";break;case $.Process:te="process";break;case $.CustomExecution:te="customExecution";break;case void 0:te="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:te,_key:this._id,id:this._id}}}static is(N){return N instanceof s}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$OF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let te=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(te+=this._source.kind);const Y={type:e.$RF,folder:N,id:te};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$rg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new s(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$TF=s;class n extends r{constructor(N,te,Y,Ee,Se,Pe,ge){super(N,Y,Ee,Pe,ge,te),this._source=te,this.configures=Se}static is(N){return N instanceof n}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?C.$rg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$OF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let te=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(te+=this._source.kind);const Y={type:e.$RF,folder:N,id:te};return JSON.stringify(Y)}}e.$UF=n;class o extends r{constructor(N,te,Y,Ee,Se,Pe,ge,me,ce){super(N,Y,Ee,me,ce,te),this.defines=Se,this.hasDefinedMatchers=ge,this.command=Pe,this.icon=ce.icon,this.hide=ce.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof o}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new o(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$VF=o;class w extends r{constructor(N,te,Y,Ee,Se,Pe){super(N,Y,Ee,Se,Pe,te),this._source=te}clone(){return new w(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof w}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new w(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$WF=w;var d;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(O){O._default=O.Terminal}(d||(e.ExecutionEngine=d={}));var I;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(I||(e.JsonSchemaVersion=I={}));class S{constructor(N){this.c=new Map;for(let te=0;te<N.length;te++)this.c.set(N[te].uri.toString(),te)}compare(N,te){const Y=N.getWorkspaceFolder(),Ee=te.getWorkspaceFolder();if(Y&&Ee){let Se=this.c.get(Y.uri.toString());Se=Se===void 0?0:Se+1;let Pe=this.c.get(Ee.uri.toString());return Pe=Pe===void 0?0:Pe+1,Se===Pe?N._label.localeCompare(te._label):Se-Pe}else return!Y&&Ee?-1:Y&&!Ee?1:0}}e.$XF=S;var u;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(u||(e.TaskEventKind=u={}));var g;(function(O){O.SingleRun="singleRun",O.Background="background"})(g||(e.TaskRunType=g={}));var h;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(h||(e.TaskRunSource=h={}));var P;(function(O){function N(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?"background":"singleRun",group:me.configurationProperties.group,__task:me}}function te(me,ce,se){return{...N(me),kind:"start",terminalId:ce,resolvedVariables:se}}O.start=te;function Y(me,ce,se){return{...N(me),kind:"processStarted",terminalId:ce,processId:se}}O.processStarted=Y;function Ee(me,ce,se){return{...N(me),kind:"processEnded",terminalId:ce,exitCode:se}}O.processEnded=Ee;function Se(me,ce,se){return{...N(me),kind:"terminated",exitReason:se,terminalId:ce}}O.terminated=Se;function Pe(me,ce,se){return{...N(ce),kind:me,terminalId:se}}O.general=Pe;function ge(){return{kind:"changed"}}O.changed=ge})(P||(e.TaskEvent=P={}));var W;(function(O){function N(Y){const Ee=Object.keys(Y).sort();let Se="";for(const Pe of Ee){let ge=Y[Pe];ge instanceof Object?ge=N(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),Se+=Pe+","+ge+","}return Se}function te(Y){const Se={_key:N(Y),type:Y.taskType};return Object.assign(Se,Y),Se}O.create=te})(W||(e.KeyedTaskIdentifier=W={}));var K;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(K||(e.TaskSettingId=K={}));var j;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var B;(function(O){function N(te,Y){const Ee=l.$NF.get(te.type);if(Ee===void 0){const me=L.$3m(te);return delete me._key,W.create(me)}const Se=Object.create(null);Se.type=Ee.taskType;const Pe=new Set;Ee.required.forEach(me=>Pe.add(me));const ge=Ee.properties;for(const me of Object.keys(ge)){const ce=te[me];if(ce!=null)Se[me]=ce;else if(Pe.has(me)){const se=ge[me];if(se.default!==void 0)Se[me]=L.$3m(se.default);else switch(se.type){case"boolean":Se[me]=!1;break;case"number":case"integer":Se[me]=0;break;case"string":Se[me]="";break;default:Y.error(y.localize(2,null,JSON.stringify(te,void 0,0),me));return}}}return W.create(Se)}O.createTaskIdentifier=N})(B||(e.TaskDefinition=B={}))}),define(Re[215],Me([1,0,9]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.$e4b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,l)=>{this.b=A,this.d=l,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$Z)(A))}then(A,l){return this.j().then(A,l)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$e4b=M;class C extends M{constructor(){super(),this.h=!0,this.i=new y.$4}}e.$f4b=C}),define(Re[47],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=void 0;class y{static{this.count=0}constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++y.count}}e.$iv=y;const M=[];function C(l){const k=new y(l);return M[k.nid]=k,k}e.$jv=C;function L(l){return M[l].sid}e.$kv=L;class A{constructor(k){this.value=k}}e.$lv=A}),define(Re[3],Me([1,0,47]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bK=e.$aK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$_J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var C;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(C||(e.TabInputKind=C={}));var L;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var l;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(l||(e.WebviewMessageArrayBufferViewType=l={}));var k;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var f;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var R;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$_J=D;var c;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var p;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var $;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})($||(e.ExtHostTestingResource=$={})),e.$aK={MainThreadAuthentication:(0,y.$jv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$jv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$jv)("MainThreadChatProvider"),MainThreadChatAgents:(0,y.$jv)("MainThreadChatAgents"),MainThreadChatVariables:(0,y.$jv)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$jv)("MainThreadClipboard"),MainThreadCommands:(0,y.$jv)("MainThreadCommands"),MainThreadComments:(0,y.$jv)("MainThreadComments"),MainThreadConfiguration:(0,y.$jv)("MainThreadConfiguration"),MainThreadConsole:(0,y.$jv)("MainThreadConsole"),MainThreadDebugService:(0,y.$jv)("MainThreadDebugService"),MainThreadDecorations:(0,y.$jv)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$jv)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$jv)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$jv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$jv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$jv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$jv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$jv)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$jv)("MainThreadErrors"),MainThreadTreeViews:(0,y.$jv)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$jv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,y.$jv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$jv)("MainThreadLanguages"),MainThreadLogger:(0,y.$jv)("MainThreadLogger"),MainThreadMessageService:(0,y.$jv)("MainThreadMessageService"),MainThreadOutputService:(0,y.$jv)("MainThreadOutputService"),MainThreadProgress:(0,y.$jv)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$jv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$jv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$jv)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$jv)("MainThreadSecretState"),MainThreadStorage:(0,y.$jv)("MainThreadStorage"),MainThreadTelemetry:(0,y.$jv)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$jv)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$jv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$jv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$jv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$jv)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$jv)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$jv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$jv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$jv)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$jv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,y.$jv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,y.$jv)("MainThreadExtensionService"),MainThreadSCM:(0,y.$jv)("MainThreadSCM"),MainThreadSearch:(0,y.$jv)("MainThreadSearch"),MainThreadShare:(0,y.$jv)("MainThreadShare"),MainThreadTask:(0,y.$jv)("MainThreadTask"),MainThreadWindow:(0,y.$jv)("MainThreadWindow"),MainThreadLabelService:(0,y.$jv)("MainThreadLabelService"),MainThreadNotebook:(0,y.$jv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$jv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$jv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$jv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$jv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$jv)("MainThreadInteractive"),MainThreadChat:(0,y.$jv)("MainThreadChat"),MainThreadInlineChat:(0,y.$jv)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$jv)("MainThreadTheming"),MainThreadTunnelService:(0,y.$jv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$jv)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$jv)("MainThreadTimeline"),MainThreadTesting:(0,y.$jv)("MainThreadTesting"),MainThreadLocalization:(0,y.$jv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$jv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$jv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$jv)("MainThreadIssueReporter")},e.$bK={ExtHostCommands:(0,y.$jv)("ExtHostCommands"),ExtHostConfiguration:(0,y.$jv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$jv)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$jv)("ExtHostDebugService"),ExtHostDecorations:(0,y.$jv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$jv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$jv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$jv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$jv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$jv)("ExtHostEditors"),ExtHostTreeViews:(0,y.$jv)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$jv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$jv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$jv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$jv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$jv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$jv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$jv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$jv)("ExtHostStatusBar"),ExtHostShare:(0,y.$jv)("ExtHostShare"),ExtHostExtensionService:(0,y.$jv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$jv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$jv)("ExtHostTerminalService"),ExtHostSCM:(0,y.$jv)("ExtHostSCM"),ExtHostSearch:(0,y.$jv)("ExtHostSearch"),ExtHostTask:(0,y.$jv)("ExtHostTask"),ExtHostWorkspace:(0,y.$jv)("ExtHostWorkspace"),ExtHostWindow:(0,y.$jv)("ExtHostWindow"),ExtHostWebviews:(0,y.$jv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$jv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$jv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$jv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$jv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$jv)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$jv)("ExtHostProgress"),ExtHostComments:(0,y.$jv)("ExtHostComments"),ExtHostSecretState:(0,y.$jv)("ExtHostSecretState"),ExtHostStorage:(0,y.$jv)("ExtHostStorage"),ExtHostUrls:(0,y.$jv)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$jv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$jv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$jv)("ExtHostOutputService"),ExtHosLabelService:(0,y.$jv)("ExtHostLabelService"),ExtHostNotebook:(0,y.$jv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$jv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$jv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$jv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$jv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$jv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$jv)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$jv)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$jv)("ExtHostChat"),ExtHostChatAgents:(0,y.$jv)("ExtHostChatAgents"),ExtHostChatVariables:(0,y.$jv)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$jv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,y.$jv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$jv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$jv)("ExtHostTheming"),ExtHostTunnelService:(0,y.$jv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$jv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$jv)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$jv)("ExtHostTimeline"),ExtHostTesting:(0,y.$jv)("ExtHostTesting"),ExtHostTelemetry:(0,y.$jv)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$jv)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$jv)("ExtHostIssueReporter")}}),define(Re[216],Me([1,0,3,7]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$aK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,l,k){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(l,k)??[]}getRelatedInformation(A,l,k){return this.c.$getAiRelatedInformation(l,k)}registerRelatedInformationProvider(A,l,k){const f=this.b;return this.b++,this.a.set(f,k),this.c.$registerAiRelatedInformationProvider(f,l),new M.$cK(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$Mdc=C}),define(Re[80],Me([1,0,4,14,3,17]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,y.$Nh)("IExtHostApiDeprecationService");let A=class{constructor(k,f){this.c=f,this.a=new Set,this.b=k.getProxy(C.$aK.MainThreadTelemetry)}report(k,f,R){const D=this.d(k,f);this.a.has(D)||(this.a.add(D),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:k}))}d(k,f){return`${k}-${f.identifier.value}`}};e.$Qbc=A,e.$Qbc=A=qe([We(0,L.$bM),We(1,M.$8i)],A),e.$Rbc=Object.freeze(new class{report(l,k,f){}})}),define(Re[217],Me([1,0,5,3,7,20]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new y.$Md,this.onDidChangeSessions=this.d.event,this.f=new l,this.g=new l,this.a=f.getProxy(M.$aK.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,R,D,c={}){const p=L.$3l.toKey(f.identifier),$=[...D].sort().join(" ");return await this.f.getOrCreate(`${p} ${R} ${$}`,async()=>{await this.a.$ensureProvider(R);const m=f.displayName||f.name;return this.a.$getSession(R,D,p,m,c)})}async getSessions(f,R,D){const c=L.$3l.toKey(f.identifier),p=[...D].sort().join(" ");return await this.g.getOrCreate(`${c} ${p}`,async()=>{await this.a.$ensureProvider(R);const $=f.displayName||f.name;return this.a.$getSessions(R,D,c,$)})}async removeSession(f,R){const D=this.b.get(f);return D?D.provider.removeSession(R):this.a.$removeSession(f,R)}registerAuthenticationProvider(f,R,D,c){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:R,provider:D,options:c??{supportsMultipleAccounts:!1}}),this.c.find($=>$.id===f)||this.c.push({id:f,label:R});const p=D.onDidChangeSessions($=>{this.a.$sendDidChangeSessions(f,{added:$.added??[],changed:$.changed??[],removed:$.removed??[]})});return this.a.$registerAuthenticationProvider(f,R,c?.supportsMultipleAccounts??!1),new C.$cK(()=>{p.dispose(),this.b.delete(f);const $=this.c.findIndex(m=>m.id===f);$>-1&&this.c.splice($),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,R,D){const c=this.b.get(f);if(c)return Promise.resolve(c.provider.createSession(R,D));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,R){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,R){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,R){return this.d.fire({provider:{id:f,label:R}}),Promise.resolve()}}e.$ldc=A;class l{constructor(){this.a=new Map}getOrCreate(f,R){const D=this.a.get(f);if(D)return D;const c=R().finally(()=>this.a.delete(f));return this.a.set(f,c),c}}}),define(Re[218],Me([1,0,3,17,8]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;let L=class{constructor(l,k){this.a=l.getProxy(y.$aK.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>k.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(l,k,f){const R=C.WorkspaceEdit.from(l,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,f?.isRefactoring??!1)}};e.$rdc=L,e.$rdc=L=qe([We(0,M.$bM)],L)}),define(Re[219],Me([1,0,12,5,65,6,58,146,3,8]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fdc=void 0;class R{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=R.a++}}class D{static{this.a=0}constructor(p,$){this.h=$,this.b=new Map,this.d=new Map,this.e=new M.$Md,this.onDidPerformUserAction=this.e.event,this.g=p.getProxy(k.$aK.MainThreadChat)}registerChatProvider(p,$,m){const t=new R(p,m);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,$),(0,L.$Pc)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(p,$){const m=C.Iterable.find(this.d.keys(),t=>this.d.get(t)===p)??0;typeof m=="number"&&this.g.$transferChatSession(m,$)}sendInteractiveRequestToProvider(p,$){this.g.$sendRequestToProvider(p,$)}async $prepareChat(p,$,m){const t=this.b.get(p);if(!t)return;const i=await t.provider.prepareSession($,m);if(!i)return;const a=D.a++;return this.d.set(a,i),{id:a,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $provideWelcomeMessage(p,$){const m=this.b.get(p);if(!m||!m.provider.provideWelcomeMessage)return;const t=await m.provider.provideWelcomeMessage($);if(t)return t.map(i=>typeof i=="string"?i:i.map(a=>f.ChatReplyFollowup.from(a)))}async $provideFollowups(p,$,m){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,m))?.map(b=>f.ChatFollowup.from(b))}$removeRequest(p,$,m){const t=this.b.get(p);if(!t)return;const i=this.d.get($);i&&t.provider.removeRequest&&t.provider.removeRequest(i,m)}async $provideReply(p,$,m,t){const i=this.b.get(p);if(!i)return;const a=this.d.get($);if(!a)return;const b={session:a,message:typeof m.message=="string"?m.message:f.ChatReplyFollowup.to(m.message),variables:{}};if(m.variables)for(const o of Object.keys(m.variables))b.variables[o]=m.variables[o].map(f.ChatVariable.to);const E=A.$Id.create(!1);let v;const r={report:o=>{if(t.isCancellationRequested)return;typeof v>"u"&&(v=E.elapsed());const w=f.ChatResponseProgress.from(o);if("placeholder"in o&&"resolvedContent"in o){const d=Promise.all([this.g.$acceptResponseProgress(p,$,w),o.resolvedContent]);(0,y.$Hg)(d,t).then(I=>{if(!I)return;const[S,u]=I;this.g.$acceptResponseProgress(p,$,u,S??void 0)})}else this.g.$acceptResponseProgress(p,$,w)}};let s;try{s=await i.provider.provideResponseWithProgress(b,r,t),s||(s={errorDetails:{message:(0,l.localize)(0,null)}})}catch(o){s={errorDetails:{message:(0,l.localize)(1,null,o.message),responseIsIncomplete:!0}},this.h.error(o)}try{if(a.saveState&&this.d.has($)){const o=a.saveState();this.g.$acceptChatState($,o)}}catch(o){this.h.warn(o)}const n={firstProgress:v??0,totalElapsed:E.elapsed()};return{errorDetails:s.errorDetails,timings:n}}async $provideSlashCommands(p,$,m){const t=this.b.get(p);if(!t)return;const i=this.d.get($);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,m))?.map(b=>({...b,kind:f.CompletionItemKind.from(b.kind)}))}$releaseSession(p){this.d.delete(p)}async $onDidPerformUserAction(p){this.e.fire(p)}}e.$Fdc=D}),define(Re[220],Me([1,0,12,6,71,3,8,7]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Odc=void 0;class k{static{this.a=0}constructor(D,c,p){this.d=c,this.e=p,this.b=new Map,this.c=D.getProxy(L.$aK.MainThreadChatAgents)}registerAgent(D,c,p,$){const m=k.a++;return this.b.set(m,{extension:D,agent:p}),this.c.$registerAgent(m,c,$),(0,M.$Pc)(()=>{this.c.$unregisterAgent(m),this.b.delete(m)})}async $invokeAgent(D,c,p,$,m){const t=this.b.get(D);if(!t){this.e.warn(`[CHAT](${D}) CANNOT invoke agent because the agent is not registered`);return}let i=!1;function a(){if(i)throw new Error("Only valid while executing the command")}const b=new y.$bh;m.onCancellationRequested(()=>b.complete()),setTimeout(()=>b.complete(),10*1e3),this.d.allowListExtensionWhile(t.extension,b.p);const E=t.agent({role:l.ChatMessageRole.User,content:p},{history:$.history.map(A.ChatMessage.to)},new C.$1u(v=>{a(),this.c.$handleProgressChunk(c,{content:f(v.message)?v.message:v.message.value})}),m);try{return await(0,y.$Hg)(Promise.resolve(E).then(v=>{if(v&&"followUp"in v)return{followUp:v?.followUp?.map(s=>A.ChatFollowup.from(s))}}),m)}finally{i=!0,b.complete()}}}e.$Odc=k;function f(R){return!!R&&typeof R=="object"&&"treeData"in R}}),define(Re[221],Me([1,0,6,3,8,71,20]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;class l{static{this.a=1}constructor(f,R){this.d=R,this.c=new Map,this.e=new Map,this.f=new A.$5l,this.b=f.getProxy(M.$aK.MainThreadChatProvider)}registerProvider(f,R,D,c){const p=l.a++;return this.c.set(p,{extension:f,provider:D}),this.b.$registerProvider(p,R,{extension:f,displayName:c.name??f.value}),(0,y.$Pc)(()=>{this.b.$unregisterProvider(p),this.c.delete(p)})}async $provideChatResponse(f,R,D,c,p){const $=this.c.get(f);if(!$)return;const m=new L.$1u(async t=>{if(p.isCancellationRequested){this.d.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(R,{index:t.index,part:t.part})},{async:!0});return $.provider.provideChatResponse(D.map(C.ChatMessage.to),c,m,p)}allowListExtensionWhile(f,R){this.f.set(f,R),R.finally(()=>this.f.delete(f))}async requestChatResponseProvider(f,R){if(!this.f.has(f))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D.f.has(f)},async makeRequest(c,p,$,m){if(!D.f.has(f))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D.e.set(t,$);try{await D.b.$fetchResponse(f,R,t,c.map(C.ChatMessage.from),p,m)}finally{D.e.delete(t)}}}}async $handleResponseFragment(f,R){this.e.get(f)?.report(R)}}e.$Kdc=l}),define(Re[222],Me([1,0,6,3,9,8]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class A{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(M.$aK.MainThreadChatVariables)}async $resolveVariable(k,f,R){const D=this.b.get(k);if(D)try{const c=await D.resolver.resolve(D.data.name,{message:f},R);if(c)return c.map(L.ChatVariable.from)}catch(c){(0,C.$1)(c)}}registerVariableResolver(k,f,R,D){const c=A.a++;return this.b.set(c,{extension:k.identifier,data:{name:f,description:R},resolver:D}),this.c.$registerVariable(c,{name:f,description:R}),(0,y.$Pc)(()=>{this.b.delete(c),this.c.$unregisterVariable(c)})}}e.$Ldc=A}),define(Re[223],Me([1,0,3]),function(we,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class M{constructor(L){const A=L.getProxy(y.$aK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(l){return A.$writeText(l)}})}}e.$Ubc=M}),define(Re[31],Me([1,0,16,7,8,24,3,18,14,67,45,278,2,6,4,17,104,26,47,42,58,53,57]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=void 0;let s=class{#e;#t;#i;constructor(S,u,g){this.b=new Map,this.c=new Map,this.#e=S.getProxy(A.$aK.MainThreadCommands),this.d=u,this.#i=g,this.#t=S.getProxy(A.$aK.MainThreadTelemetry),this.converter=new n(this,h=>{const P=this.c.get(h);return P?.result===w.Void?P:void 0},u),this.f=[{processArgument(h){return(0,f.$kh)(h)}},{processArgument(h){return(0,L.$5m)(h,function(P){if(R.$ps.isIRange(P))return C.Range.to(P);if(D.$os.isIPosition(P))return C.Position.to(P);if(R.$ps.isIRange(P.range)&&c.URI.isUri(P.uri))return C.location.to(P);if(P instanceof i.$ae)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(S){this.f.push(S)}registerApiCommand(S){const u=this.registerCommand(!1,S.id,async(...g)=>{const h=S.args.map((W,K)=>{if(!W.validate(g[K]))throw new Error(`Invalid argument '${W.name}' when running '${S.id}', received: ${typeof g[K]=="object"?JSON.stringify(g[K],null,"	"):g[K]} `);return W.convert(g[K])}),P=await this.executeCommand(S.internalId,...h);return S.result.convert(P,g,this.converter)},void 0,{description:S.description,args:S.args,returns:S.result.description});return this.c.set(S.id,S),new M.$cK(()=>{u.dispose(),this.c.delete(S.id)})}registerCommand(S,u,g,h,P,W){if(this.d.trace("ExtHostCommands#registerCommand",u),!u.trim().length)throw new Error("invalid id");if(this.b.has(u))throw new Error(`command '${u}' already exists`);return this.b.set(u,{callback:g,thisArg:h,metadata:P,extension:W}),S&&this.#e.$registerCommand(u),new M.$cK(()=>{this.b.delete(u)&&S&&this.#e.$unregisterCommand(u)})}executeCommand(S,...u){return this.d.trace("ExtHostCommands#executeCommand",S),this.g(S,u,!0)}async g(S,u,g){if(this.b.has(S))return this.#e.$fireCommandActivationEvent(S),this.h(S,u,!1);{let h=!1;const P=(0,L.$5m)(u,function(W){if(W instanceof M.$dK)return C.Position.from(W);if(W instanceof M.$eK)return C.Range.from(W);if(W instanceof M.$oK)return C.location.from(W);if(M.$zL.isNotebookRange(W))return C.NotebookRange.from(W);if(W instanceof ArrayBuffer)return h=!0,i.$ae.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return h=!0,i.$ae.wrap(W);if(W instanceof i.$ae)return h=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(S,h?new a.$lv(P):P,g);return(0,f.$kh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(S,u,!1);throw W}}}async h(S,u,g){const h=this.b.get(S);if(!h)throw new Error("Unknown command");const{callback:P,thisArg:W,metadata:K}=h;if(K?.args)for(let B=0;B<K.args.length;B++)try{(0,y.$Of)(u[B],K.args[B].constraint)}catch{throw new Error(`Running the contributed command: '${S}' failed. Illegal argument '${K.args[B].name}' - ${K.args[B].description}`)}const j=E.$Id.create();try{return await P.apply(W,u)}catch(B){if(S===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...u);O&&(S=O.command)}if(this.d.error(B,S,h.extension?.identifier),!g)throw B;if(h.extension?.identifier){const O=this.#i.onExtensionError(h.extension.identifier,B);this.d.trace("forwarded error to extension?",O,h.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.$yi)(B)),this.id=S,this.source=h.extension?.displayName??h.extension?.name}}}finally{this.j(h,S,j.elapsed())}}j(S,u,g){S.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:S.extension.identifier.value,id:new v.$go(u),duration:g})}$executeContributedCommand(S,...u){this.d.trace("ExtHostCommands#$executeContributedCommand",S);const g=this.b.get(S);return g?(u=u.map(h=>this.f.reduce((P,W)=>W.processArgument(P,g.extension?.identifier),h)),this.h(S,u,!0)):Promise.reject(new Error(`Contributed command '${S}' does not exist.`))}getCommands(S=!1){return this.d.trace("ExtHostCommands#getCommands",S),this.#e.$getCommands().then(u=>(S&&(u=u.filter(g=>g[0]!=="_")),u))}$getContributedCommandMetadata(){const S=Object.create(null);for(const[u,g]of this.b){const{metadata:h}=g;h&&(S[u]=h)}return Promise.resolve(S)}};e.$wM=s,e.$wM=s=qe([We(0,m.$bM),We(1,k.$8i),We(2,r.$vM)],s),e.$xM=(0,$.$Nh)("IExtHostCommands");class n{constructor(S,u,g){this.d=S,this.f=u,this.g=g,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(S,u){if(!S)return;const g={$ident:void 0,id:S.command,title:S.title,tooltip:S.tooltip};if(!S.command)return g;const h=this.f(S.command);if(h)g.id=h.internalId,g.arguments=h.args.map((P,W)=>P.convert(S.arguments&&S.arguments[W]));else if((0,l.$Kb)(S.arguments)){const P=`${S.command} /${++this.c}`;this.b.set(P,S),u.add((0,p.$Pc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),g.$ident=P,g.id=this.delegatingCommandId,g.arguments=[P],this.g.trace("CommandsConverter#CREATE",S.command,P)}return g}fromInternal(S){return typeof S.$ident=="string"?this.b.get(S.$ident):{command:S.id,title:S.title,arguments:S.arguments}}getActualCommand(...S){return this.b.get(S[0])}h(...S){const u=this.getActualCommand(...S);return this.g.trace("CommandsConverter#EXECUTE",S[0],u?u.command:"MISSING"),u?this.d.executeCommand(u.command,...u.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${S[0]}`)}}e.$yM=n;class o{static{this.Uri=new o("uri","Uri of a text document",S=>c.URI.isUri(S),S=>S)}static{this.Position=new o("position","A position in a text document",S=>M.$dK.isPosition(S),C.Position.from)}static{this.Range=new o("range","A range in a text document",S=>M.$eK.isRange(S),C.Range.from)}static{this.Selection=new o("selection","A selection in a text document",S=>M.$fK.isSelection(S),C.Selection.from)}static{this.Number=new o("number","",S=>typeof S=="number",S=>S)}static{this.String=new o("string","",S=>typeof S=="string",S=>S)}static{this.StringArray=o.Arr(o.String)}static Arr(S){return new o(`${S.name}_array`,`Array of ${S.name}, ${S.description}`,u=>Array.isArray(u)&&u.every(g=>S.validate(g)),u=>u.map(g=>S.convert(g)))}static{this.CallHierarchyItem=new o("item","A call hierarchy item",S=>S instanceof M.$yK,C.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new o("item","A type hierarchy item",S=>S instanceof M.$SL,C.TypeHierarchyItem.from)}static{this.TestItem=new o("testItem","A VS Code TestItem",S=>S instanceof t.$oM,C.TestItem.from)}constructor(S,u,g,h){this.name=S,this.description=u,this.validate=g,this.convert=h}optional(){return new o(this.name,`(optional) ${this.description}`,S=>S==null||this.validate(S),S=>S===void 0?void 0:S===null?null:this.convert(S))}with(S,u){return new o(S??this.name,u??this.description,this.validate,this.convert)}}e.$zM=o;class w{static{this.Void=new w("no result",S=>S)}constructor(S,u){this.description=S,this.convert=u}}e.$AM=w;class d{constructor(S,u,g,h,P){this.id=S,this.internalId=u,this.description=g,this.args=h,this.result=P}}e.$BM=d}),define(Re[224],Me([1,0,18,13,2,78,91,32,95,31,8,7]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;const c=[new f.$BM("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of DocumentHighlight-instances.",$(R.DocumentHighlight.to))),new f.$BM("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$zM.Uri],new f.$AM("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$Jb)(t))return;class a extends D.$tK{static to(E){const v=new a(E.name,R.SymbolKind.to(E.kind),E.containerName||"",new D.$oK(i[0],R.Range.to(E.range)));return v.detail=E.detail,v.range=v.location.range,v.selectionRange=R.Range.to(E.selectionRange),v.children=E.children?E.children.map(a.to):[],v}}return t.map(a.to)})),new f.$BM("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$zM.Uri,new f.$zM("options","Formatting options",t=>!0,t=>t)],new f.$AM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$BM("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$zM.Uri,f.$zM.Range,new f.$zM("options","Formatting options",t=>!0,t=>t)],new f.$AM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$BM("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$zM.Uri,f.$zM.Position,new f.$zM("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$zM("options","Formatting options",t=>!0,t=>t)],new f.$AM("A promise that resolves to an array of TextEdits.",$(R.TextEdit.to))),new f.$BM("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$BM("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$BM("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$BM("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of Location or LocationLink instances.",m)),new f.$BM("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of Location-instances.",$(R.location.to))),new f.$BM("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of Hover-instances.",$(R.Hover.to))),new f.$BM("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$zM.Uri,new f.$zM("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$dK.isPosition(i)),t=>t.map(R.Position.from))],new f.$AM("A promise that resolves to an array of ranges.",t=>t.map(i=>{let a;for(const b of i.reverse())a=new D.$xK(R.Range.to(b),a);return a}))),new f.$BM("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$zM.String.with("query","Search string")],new f.$AM("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new f.$BM("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new f.$BM("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$zM.CallHierarchyItem],new f.$AM("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new f.$BM("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$zM.CallHierarchyItem],new f.$AM("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new f.$BM("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new f.$BM("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$zM.Uri,f.$zM.Position,f.$zM.String.with("newName","The new symbol name")],new f.$AM("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new f.$BM("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$zM.Uri,f.$zM.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$AM("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new f.$BM("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$zM.Uri],new f.$AM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$rL(t.tokenTypes,t.tokenModifiers)})),new f.$BM("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$zM.Uri],new f.$AM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$R0)(t);if(i.type==="full")return new D.$tL(i.data,void 0)})),new f.$BM("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$zM.Uri,f.$zM.Range.optional()],new f.$AM("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$rL(t.tokenTypes,t.tokenModifiers)})),new f.$BM("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$zM.Uri,f.$zM.Range],new f.$AM("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$R0)(t);if(i.type==="full")return new D.$tL(i.data,void 0)})),new f.$BM("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$zM.Uri,f.$zM.Position,f.$zM.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$zM.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$AM("A promise that resolves to a CompletionList-instance.",(t,i,a)=>{if(!t)return new D.$JK([]);const b=t.suggestions.map(E=>R.CompletionItem.to(E,a));return new D.$JK(b,t.incomplete)})),new f.$BM("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$zM.Uri,f.$zM.Position,f.$zM.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$AM("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new f.$BM("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$zM.Uri,f.$zM.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$AM("A promise that resolves to an array of CodeLens-instances.",(t,i,a)=>$(b=>new D.$BK(R.Range.to(b.range),b.command&&a.fromInternal(b.command)))(t))),new f.$BM("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$zM.Uri,new f.$zM("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$eK.isRange(t),t=>D.$fK.isSelection(t)?R.Selection.from(t):R.Range.from(t)),f.$zM.String.with("kind","Code action kind to return code actions for").optional(),f.$zM.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$AM("A promise that resolves to an array of Command-instances.",(t,i,a)=>$(b=>{if(b._isSynthetic){if(!b.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(b.command)}else{const E=new D.$vK(b.title,b.kind?new D.$wK(b.kind):void 0);return b.edit&&(E.edit=R.WorkspaceEdit.to(b.edit)),b.command&&(E.command=a.fromInternal(b.command)),E.isPreferred=b.isPreferred,E}})(t))),new f.$BM("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$zM.Uri],new f.$AM("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$PK(R.Range.to(i.range),R.Color.to(i.color))):[])),new f.$BM("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$zM("color","The color to show and insert",t=>t instanceof D.$OK,R.Color.from),new f.$zM("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new f.$AM("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new f.$BM("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$zM.Uri,f.$zM.Range],new f.$AM("A promise that resolves to an array of Inlay objects",(t,i,a)=>t.map(R.InlayHint.to.bind(void 0,a)))),new f.$BM("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$zM.Uri],new f.$AM("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(R.FoldingRange.to)})),new f.$BM("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$AM("A promise that resolves to an array of NotebookContentProvider static info objects.",$(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>R.NotebookExclusiveDocumentPattern.to(i))})))),new f.$BM("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$zM.Uri,f.$zM.Range,new f.$zM("context","An InlineValueContext",t=>t&&typeof t.frameId=="number"&&t.stoppedLocation instanceof D.$eK,t=>R.InlineValueContext.from(t))],new f.$AM("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new f.$BM("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$zM("uriOrString","Uri-instance or string (only http/https)",t=>C.URI.isUri(t)||typeof t=="string"&&(0,k.$$T)(t,M.Schemas.http,M.Schemas.https),t=>t),new f.$zM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),f.$zM.String.with("label","").optional()],f.$AM.Void),new f.$BM("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$zM.Uri.with("resource","Resource to open"),f.$zM.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new f.$zM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],f.$AM.Void),new f.$BM("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$zM.Uri.with("left","Left-hand side resource of the diff editor"),f.$zM.Uri.with("right","Right-hand side resource of the diff editor"),f.$zM.String.with("title","Human readable title for the diff editor").optional(),new f.$zM("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],f.$AM.Void),new f.$BM("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$zM.Uri,f.$zM.Position],new f.$AM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$BM("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$zM.TypeHierarchyItem],new f.$AM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$BM("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$zM.TypeHierarchyItem],new f.$AM("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new f.$BM("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$zM.TestItem],f.$AM.Void),new f.$BM("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$zM.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$AM.Void),new f.$BM("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$zM.String.with("name","The context key name"),new f.$zM("value","The context key value",()=>!0,t=>t)],f.$AM.Void),new f.$BM("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$zM.Uri,f.$zM.StringArray,new f.$zM("MappedEditsContext","Mapped Edits Context",t=>R.MappedEditsContext.is(t),t=>R.MappedEditsContext.from(t))],new f.$AM("A promise that resolves to a workspace edit or null",t=>t?R.WorkspaceEdit.to(t):null))];class p{static register(i){c.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",l.$Mi)}}e.$Tbc=p;function $(t){return i=>{if(Array.isArray(i))return i.map(t)}}function m(t){if(!Array.isArray(t))return;const i=[];for(const a of t)L.$at(a)?i.push(R.DefinitionLink.to(a)):i.push(R.location.to(a));return i}}),define(Re[225],Me([1,0,12,64,5,6,2,78,20,8,7,3,25]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;function p($,m,t){const i=$.getProxy(D.$aK.MainThreadComments);class a{static{this.a=0}constructor(){this.b=new Map,this.c=new k.$5l,m.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const I=this.b.get(d.handle);return I?I.value:d}else if(d&&d.$mid===7){const I=this.b.get(d.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.commentThreadHandle);return S?S.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);return S?d.$mid===8?S.value:{thread:S.value,text:d.text}:d}else if(d&&d.$mid===10){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.commentUniqueId,g=S.getCommentByUniqueId(u);return g||d}else if(d&&d.$mid===11){const I=this.b.get(d.thread.commentControlHandle);if(!I)return d;const S=I.getCommentThread(d.thread.commentThreadHandle);if(!S)return d;const u=d.text,g=d.commentUniqueId,h=S.getCommentByUniqueId(g);return h?(typeof h.body=="string"?h.body=u:h.body=new R.$CK(u),h):d}return d}})}createCommentController(d,I,S){const u=a.a++,g=new E(d,u,I,S);this.b.set(g.handle,g);const h=this.c.get(d.identifier)||[];return h.push(g),this.c.set(d.identifier,h),g.value}async $createCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$createCommentThreadTemplate(I,S)}async $updateCommentThreadTemplate(d,I,S){const u=this.b.get(d);u&&u.$updateCommentThreadTemplate(I,S)}$deleteCommentThread(d,I){this.b.get(d)?.$deleteCommentThread(I)}$provideCommentingRanges(d,I,S){const u=this.b.get(d);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const g=t.getDocument(A.URI.revive(I));return(0,y.$Lg)(async()=>{const h=await u.commentingRangeProvider.provideCommentingRanges(g,S);let P;return Array.isArray(h)?P={ranges:h,fileComments:!1}:h?P={ranges:h.ranges||[],fileComments:h.fileComments||!1}:P=h??void 0,P}).then(h=>{let P;return h&&(P={ranges:h.ranges.map(W=>f.Range.from(W)),fileComments:h.fileComments}),P})}$toggleReaction(d,I,S,u,g){const h=this.b.get(d);return!h||!h.reactionHandler?Promise.resolve(void 0):(0,y.$Lg)(()=>{const P=h.getCommentThread(I);if(P){const W=P.getCommentByUniqueId(u.uniqueIdInThread);if(h!==void 0&&W&&h.reactionHandler)return h.reactionHandler(W,s(g))}return Promise.resolve(void 0)})}}class b{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,I,S,u,g,h,P,W){this.m=I,this.n=S,this.o=u,this.p=g,this.q=h,this.extensionDescription=P,this.r=W,this.handle=b.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new C.$Md,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Sc,this.l.value=new L.$Qc,this.n===void 0&&(this.n=`${d}.${this.handle}`),i.$createCommentThread(I,this.handle,this.n,this.o,f.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=h,this.i.push({dispose:()=>{i.$deleteCommentThread(I,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(j){K.range=j},get comments(){return K.comments},set comments(j){K.comments=j},get collapsibleState(){return K.collapsibleState},set collapsibleState(j){K.collapsibleState=j},get canReply(){return K.canReply},set canReply(j){K.canReply=j},get contextValue(){return K.contextValue},set contextValue(j){K.contextValue=j},get label(){return K.label},set label(j){K.label=j},get state(){return K.state},set state(j){K.state=j},dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Qc);const d=S=>Object.prototype.hasOwnProperty.call(this.b,S),I={};d("range")&&(I.range=f.Range.from(this.p)),d("label")&&(I.label=this.label),d("contextValue")&&(I.contextValue=this.contextValue??null),d("comments")&&(I.comments=this.q.map(S=>v(this,S,this.k,this.extensionDescription))),d("collapsibleState")&&(I.collapseState=n(this.g)),d("canReply")&&(I.canReply=this.canReply),d("state")&&(I.state=o(this.h)),d("isTemplate")&&(I.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,I)}getCommentByUniqueId(d){for(const I of this.k){const S=I[0],u=I[1];if(d===u)return S}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}qe([(0,M.$gh)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class E{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(d,I,S,u){this.f=d,this.g=I,this.h=S,this.i=u,this.a=new Map,i.$registerCommentController(this.handle,S,u,this.f.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(h){g.options=h},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(h){g.commentingRangeProvider=h},get reactionHandler(){return g.reactionHandler},set reactionHandler(h){g.reactionHandler=h},createCommentThread(h,P,W){return g.createCommentThread(h,P,W).value},dispose:()=>{g.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread(d,I,S){I===void 0&&(0,c.$aF)(this.f,"fileComments");const u=new b(this.id,this.handle,void 0,d,I,S,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(d,I){const S=new b(this.id,this.handle,void 0,A.URI.revive(d),f.Range.to(I),[],this.f,!0);return S.collapsibleState=l.CommentThreadCollapsibleState.Expanded,this.a.set(S.handle,S),S}$updateCommentThreadTemplate(d,I){const S=this.a.get(d);S&&(S.range=f.Range.to(I))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.e.forEach(d=>d.dispose())}}function v(w,d,I,S){let u=I.get(d);return u||(u=++w.commentHandle,I.set(d,u)),d.state!==void 0&&(0,c.$aF)(S,"commentsDraftState"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:u,body:typeof d.body=="string"?d.body:f.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(g=>r(g)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function r(w){return{label:w.label,iconPath:w.iconPath?f.$aM(w.iconPath):void 0,count:w.count,hasReacted:w.authorHasReacted}}function s(w){return{label:w.label||"",count:w.count||0,iconPath:w.iconPath?A.URI.revive(w.iconPath):"",authorHasReacted:w.hasReacted||!1}}function n(w){if(w!==void 0)switch(w){case R.CommentThreadCollapsibleState.Expanded:return l.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return l.CommentThreadCollapsibleState.Collapsed}return l.CommentThreadCollapsibleState.Collapsed}function o(w){if(w!==void 0)switch(w){case R.CommentThreadState.Unresolved:return l.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return l.CommentThreadState.Resolved}return l.CommentThreadState.Unresolved}return new a}e.$Vbc=p}),define(Re[226],Me([1,0,24,3,27,17]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0;let A=class{constructor(R,D){this.a=R.getProxy(M.$aK.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,D){const c=this,p=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){c.e(R,D,p,arguments)}})}e(R,D,c,p){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:k(p,this.b)}),this.c&&this.f(R,c,p)}};e.$Rdc=A,e.$Rdc=A=qe([We(0,L.$bM),We(1,C.$rM)],A);const l=1e5;function k(f,R){const D=[];if(f.length)for(let c=0;c<f.length;c++){let p=f[c];if(typeof p>"u")p="undefined";else if(p instanceof Error){const $=p;$.stack?p=$.stack:p=$.toString()}D.push(p)}if(R){const c=new Error().stack;c&&D.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,y.$8m)(D);return c.length>l?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Re[107],Me([1,0,2,3,7,4,17,14,18,15,19,25]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xcc=e.$Wcc=void 0;let p=class{static{c=this}static{this.c=0}static{this.d=250}constructor(m,t){this.h=t,this.f=new Map,this.g=m.getProxy(M.$aK.MainThreadDecorations)}registerFileDecorationProvider(m,t){const i=c.c++;this.f.set(i,{provider:m,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const a=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(b=>{if(!b){this.g.$onDidChange(i,null);return}const E=(0,k.$2b)(b);if(E.length<=c.d){this.g.$onDidChange(i,E);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,E.length);const v=E.map(n=>({uri:n,rank:(0,f.$Fe)(n.path,"/")})),r=(0,k.$yb)(v,(n,o)=>n.rank-o.rank||(0,f.$Te)(n.uri.path,o.uri.path)),s=[];e:for(const n of r){let o;for(const w of n){const d=(0,R.$lc)(w.uri.path);if(o!==d&&(o=d,s.push(w.uri)>=c.d))break e}}this.g.$onDidChange(i,s)});return new C.$cK(()=>{a?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(m,t,i){if(!this.f.has(m))return Object.create(null);const a=Object.create(null),{provider:b,extensionDescription:E}=this.f.get(m);return await Promise.all(t.map(async v=>{try{const{uri:r,id:s}=v,n=await Promise.resolve(b.provideFileDecoration(y.URI.revive(r),i));if(!n)return;try{C.$xL.validate(n),n.badge&&typeof n.badge!="string"&&(0,D.$aF)(E,"codiconDecoration"),a[s]=[n.propagate,n.tooltip,n.badge,n.color]}catch(o){this.h.warn(`INVALID decoration from extension '${E.identifier.value}': ${o}`)}}catch(r){this.h.error(r)}})),a}};e.$Wcc=p,e.$Wcc=p=c=qe([We(0,A.$bM),We(1,l.$8i)],p),e.$Xcc=(0,L.$Nh)("IExtHostDecorations")}),define(Re[227],Me([1,0,147,94,2,3,7,8,5,14,28,39]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=void 0;class p{#e;#t;#i;constructor(t,i,a,b,E,v,r,s){this.d=t,this.e=i,this.f=a,this.g=b,this.h=E,this.c=!1,this.f=Math.max(b,a),this.#i=new R.$zc(n=>v.getComparisonKey(n)),this.#e=r,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let a=[];if(C.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),a=[t]}else if(Array.isArray(t)){a=[];let v;t=[...t].sort(p.k);for(const r of t){const[s,n]=r;if((!v||s.toString()!==v.toString())&&(v&&this.#i.get(v).length===0&&this.#i.delete(v),v=s,a.push(s),this.#i.set(s,[])),n)this.#i.get(s)?.push(...n);else{const o=this.#i.get(s);o&&(o.length=0)}}}if(this.#t.fire(a),!this.#e)return;const b=[];let E=0;for(const v of a){let r=[];const s=this.#i.get(v);if(s)if(s.length>this.g){r=[];const n=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let o=0;o<4;o++)for(const w of s)if(w.severity===n[o]&&r.push({...l.Diagnostic.from(w),modelVersionId:this.h(v)})===this.g)break e;r.push({severity:M.MarkerSeverity.Info,message:(0,y.localize)(0,null,s.length-this.g),startLineNumber:r[r.length-1].startLineNumber,startColumn:r[r.length-1].startColumn,endLineNumber:r[r.length-1].endLineNumber,endColumn:r[r.length-1].endColumn})}else r=s.map(n=>({...l.Diagnostic.from(n),modelVersionId:this.h(v)}));if(b.push([v,r]),E+=r.length,E>this.f)break}this.#e.$changeMany(this.e,b)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[a,b]of this)t.call(i,a,b,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$Nbc=p;let $=class{static{c=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*c.d}static _mapper(t){const i=new R.$zc;for(const a of t)i.set(a,a);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,a,b){this.j=i,this.k=a,this.l=b,this.g=new Map,this.h=new k.$Qd({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,c._mapper),this.f=t.getProxy(L.$aK.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:a,f:b,h:E,j:v,k:r,l:s}=this,n=new class{$changeMany(d,I){b.$changeMany(d,I),v.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,d,I.length===0?"CLEARING":I)}$clear(d){b.$clear(d),v.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,d)}dispose(){b.dispose()}};let o;if(!i)i="_generated_diagnostic_collection_name_#"+c.c++,o=i;else if(!a.has(i))o=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do o=i+c.c++;while(a.has(o))}return new class extends p{constructor(){super(i,o,c.e,c.d,d=>s.getDocument(d)?.version,r.extUri,n,E),a.set(o,this)}dispose(){super.dispose(),a.delete(o)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,a=[];for(const b of this.g.values())b.forEach((E,v)=>{let r=i.get(E.toString());typeof r>"u"&&(r=a.length,i.set(E.toString(),r),a.push([E,[]])),a[r][1]=a[r][1].concat(...v)});return a}}m(t){let i=[];for(const a of this.g.values())a.has(t)&&(i=i.concat(a.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",a=new p(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,b=>{},this.k.extUri,void 0,this.h);this.g.set(i,a),this.n=a}for(const[i,a]of t)this.n.set(C.URI.revive(i),a.map(l.Diagnostic.to))}};e.$Obc=$,e.$Obc=$=c=qe([We(1,f.$8i),We(2,D.$Mbc)],$)}),define(Re[228],Me([1,0,2,3,25]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;class L{constructor(l){this.a=l.getProxy(M.$aK.MainThreadDialogs)}showOpenDialog(l,k){return k?.allowUIResources&&(0,C.$aF)(l,"showLocal"),this.a.$showOpenDialog(k).then(f=>f?f.map(R=>y.URI.revive(R)):void 0)}showSaveDialog(l){return this.a.$showSaveDialog(l).then(k=>k?y.URI.revive(k):void 0)}}e.$4bc=L}),define(Re[229],Me([1,0,9,2,7,3,13,21,15]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5bc=void 0;class f{static{this.a=0}constructor(D,c,p){this.d=c,this.e=p,this.b=new Map,this.c=D.getProxy(L.$aK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,c){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const p=f.a++;this.b.set(p,c),this.c.$registerTextContentProvider(p,D);let $;return typeof c.onDidChange=="function"&&($=c.onDidChange(m=>{if(m.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}this.d.getDocument(m)&&this.$provideTextDocumentContent(p,m).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(m);if(!i)return;const a=(0,k.$Oe)(t);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(m,t)},y.$Z)})),new C.$cK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),$&&($.dispose(),$=void 0)})}$provideTextDocumentContent(D,c){const p=this.b.get(D);return p?Promise.resolve(p.provideTextDocumentContent(M.URI.revive(c),l.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.$5bc=f}),define(Re[230],Me([1,0,5,6,2,3,100,8,16,24,7,9]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class c{constructor($,m){this.a=new y.$Md({onListenerError:D.$1}),this.b=new y.$Md({onListenerError:D.$1}),this.c=new y.$Md({onListenerError:D.$1}),this.d=new y.$Md({onListenerError:D.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Qc,this.h=new Map,this.f=$.getProxy(L.$aK.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const m=this.g.getDocument($);if(m)return m}getDocument($){const m=this.getDocumentData($);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return m.document}ensureDocumentData($){const m=this.g.getDocument($);if(m)return Promise.resolve(m);let t=this.h.get($.toString());return t||(t=this.f.$tryOpenDocument($).then(i=>{this.h.delete($.toString());const a=C.URI.revive(i);return(0,k.$If)(this.g.getDocument(a))},i=>(this.h.delete($.toString()),Promise.reject(i))),this.h.set($.toString(),t)),t}createDocumentData($){return this.f.$tryCreateDocument($).then(m=>C.URI.revive(m))}$acceptModelLanguageChanged($,m){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(m),this.a.fire(i.document)}$acceptModelSaved($){const m=C.URI.revive($),t=this.g.getDocument(m);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(t.document)}$acceptDirtyStateChanged($,m){const t=C.URI.revive($),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(m),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,m,t){const i=C.URI.revive($),a=this.g.getDocument(i);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(m);let b;m.isUndoing?b=R.TextDocumentChangeReason.Undo:m.isRedoing&&(b=R.TextDocumentChangeReason.Redo),this.c.fire((0,f.$4m)({document:a.document,contentChanges:m.changes.map(E=>({range:l.Range.to(E.range),rangeOffset:E.rangeOffset,rangeLength:E.rangeLength,text:E.text})),reason:b}))}setWordDefinitionFor($,m){(0,A.$dM)($,m)}}e.$Kbc=c}),define(Re[59],Me([1,0,51,5,6,2,4,3,100,17,105,8,14,28,13,65,40]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=void 0;class i{constructor(E){this.value=E,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(E,v){this.h=E,this.i=v,this.a=null,this.b=new Map,this.c=new p.$zc,this.d=new M.$Md,this.e=new M.$Md,this.f=new M.$Md,this.g=new M.$Md,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(E){this.acceptDocumentsAndEditorsDelta(E)}acceptDocumentsAndEditorsDelta(E){const v=[],r=[],s=[];if(E.removedDocuments)for(const n of E.removedDocuments){const o=L.URI.revive(n),w=this.c.get(o);w?.unref()&&(this.c.delete(o),v.push(w.value))}if(E.addedDocuments)for(const n of E.addedDocuments){const o=L.URI.revive(n.uri);let w=this.c.get(o);if(w&&o.scheme!==$.Schemas.vscodeNotebookCell&&o.scheme!==$.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);w||(w=new i(new k.$eM(this.h.getProxy(l.$aK.MainThreadDocuments),o,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(o,w),r.push(w.value)),w.ref()}if(E.removedEditors)for(const n of E.removedEditors){const o=this.b.get(n);this.b.delete(n),o&&s.push(o)}if(E.addedEditors)for(const n of E.addedEditors){const o=L.URI.revive(n.documentUri);y.ok(this.c.has(o),`document '${o}' does not exist`),y.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const w=this.c.get(o).value,d=new R.$kM(n.id,this.h.getProxy(l.$aK.MainThreadTextEditors),this.i,new t.$U(()=>w.document),n.selections.map(D.Selection.to),n.options,n.visibleRanges.map(I=>D.Range.to(I)),typeof n.editorPosition=="number"?D.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,d)}E.newActiveEditor!==void 0&&(y.ok(E.newActiveEditor===null||this.b.has(E.newActiveEditor),`active editor '${E.newActiveEditor}' does not exist`),this.a=E.newActiveEditor),(0,C.$Mc)(v),(0,C.$Mc)(s),E.removedDocuments&&this.e.fire(v),E.addedDocuments&&this.d.fire(r),(E.removedEditors||E.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),E.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(E){return this.c.get(E)?.value}allDocuments(){return m.Iterable.map(this.c.values(),E=>E.value)}getEditor(E){return this.b.get(E)}activeEditor(E){if(!this.a)return;const v=this.b.get(this.a);return E?v:v?.value}allEditors(){return[...this.b.values()]}};e.$lM=a,e.$lM=a=qe([We(0,f.$bM),We(1,c.$8i)],a),e.$mM=(0,A.$Nh)("IExtHostDocumentsAndEditors")}),define(Re[60],Me([1,0,8,3,2,5,4,7,17,16,231]),function(we,e,y,M,C,L,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0,e.$2cc=(0,A.$Nh)("IExtHostEditorTabs");class D{constructor(t,i,a){this.e=a,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new l.$TL(C.URI.revive(this.b.input.uri));case 2:return new l.$UL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified));case 3:return new l.$VL(C.URI.revive(this.b.input.base),C.URI.revive(this.b.input.input1),C.URI.revive(this.b.input.input2),C.URI.revive(this.b.input.result));case 6:return new l.$WL(C.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new l.$XL(this.b.input.viewType);case 4:return new l.$YL(C.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new l.$ZL(C.URI.revive(this.b.input.original),C.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new l.$1L;case 9:return new l.$2L(C.URI.revive(this.b.input.uri),C.URI.revive(this.b.input.inputBoxUri));default:return}}}class c{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const a of t.tabs)a.isActive&&(this.d=a.id),this.c.push(new D(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return y.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(a=>a.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(a=>a.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const a=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,a),t.tabDto.isActive&&(this.d=a.tabId),a}else if(t.kind===1){const a=this.c.splice(t.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(t.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,a),a}const i=this.c.find(a=>a.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let p=class{constructor(t){this.b=new L.$Md,this.c=new L.$Md,this.e=[],this.a=t.getProxy(M.$aK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(a=>a.apiObject))},get activeTabGroup(){const a=t.d;return(0,f.$If)(t.e.find(E=>E.groupId===a)?.apiObject)},close:async(a,b)=>{const E=Array.isArray(a)?a:[a];return E.length?$(E[0])?this.j(E,b):this.i(E,b):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(n=>n.groupId)),a=new Set(t.map(n=>n.groupId)),b=(0,R.$K)(i,a),E=this.e.filter(n=>b.removed.includes(n.groupId)).map(n=>n.apiObject),v=[],r=[];this.e=t.map(n=>{const o=new c(n,()=>this.d);return b.added.includes(o.groupId)?v.push(o.apiObject):r.push(o.apiObject),o});const s=(0,f.$If)(t.find(n=>n.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:v,closed:E,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(a=>a.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(b=>b.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const a=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(t){for(const i of this.e)for(const a of i.tabs)if(a.apiObject===t)return a}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const a=[];for(const b of t){const E=this.g(b);if(!E)throw new Error("Tab close: Invalid tab not found!");a.push(E.tabId)}return this.a.$closeTab(a,i)}async j(t,i){const a=[];for(const b of t){const E=this.h(b);if(!E)throw new Error("Group close: Invalid group not found!");a.push(E.groupId)}return this.a.$closeGroup(a,i)}};e.$3cc=p,e.$3cc=p=qe([We(0,k.$bM)],p);function $(m){return m.tabs!==void 0}}),define(Re[232],Me([1,0,3,7]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=void 0;class C{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$aK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,l,k){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const R=await f.provideEmbeddingVector(l,k);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,l,k){const f=this.b;return this.b++,this.a.set(f,k),this.c.$registerAiEmbeddingVectorProvider(l,f),new M.$cK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$Ndc=C}),define(Re[233],Me([1,0,2,3,6,7,8,279,15,26,25,50]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0;class c{constructor(){this.a=[]}add(m){this.b=void 0,this.a.push(m)}delete(m){const t=this.a.indexOf(m);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const m=this.a.sort(),t=[];let i,a,b=14,E=14;for(const v of m){let r=i?(0,k.$3e)(i,v):0;for(r===0?a=1:a=E;r<v.length;r++)r+1===v.length?(b=E,E=9):E+=1,t.push([a,v.toUpperCase().charCodeAt(r),E]),t.push([a,v.toLowerCase().charCodeAt(r),E]),a=E;i=v,E=b}t.push([9,58,10]),t.push([10,47,12]),this.b=new l.$TY(t)}}provideDocumentLinks(m){this.c();const t=[],i=l.$UY.computeLinks({getLineContent(a){return m.lineAt(a-1).text},getLineCount(){return m.lineCount}},this.b);for(const a of i){const b=A.DocumentLink.to(a);b.target&&t.push(b)}return t}}class p{constructor(m,t){this.i=t,this.b=new c,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=m.getProxy(M.$aK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(m,t,i,a={}){if(p.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(m,"*",this.b));const b=this.h++;this.b.add(t),this.d.add(t),this.c.set(b,i);let E=2;a.isCaseSensitive&&(E+=1024),a.isReadonly&&(E+=2048),typeof i.copy=="function"&&(E+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,R.$aF)(m,"fsChunks"),E+=4);let v;a.isReadonly&&(0,D.$3j)(a.isReadonly)&&((0,R.$aF)(m,"readonlyMessage"),v={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(b,t,E,v).catch(s=>{console.error(`FAILED to register filesystem provider of ${m.identifier.value}-extension for the scheme ${t}`),console.error(s)});const r=i.onDidChangeFile(s=>{const n=[];for(const o of s){const{uri:w,type:d}=o;if(w.scheme!==t)continue;let I;switch(d){case L.FileChangeType.Changed:I=0;break;case L.FileChangeType.Created:I=1;break;case L.FileChangeType.Deleted:I=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:w,type:I})}this.a.$onFileSystemChange(b,n)});return(0,C.$Pc)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(b),this.a.$unregisterProvider(b)})}static j(m){if(!m)throw new Error("MISSING provider");if(typeof m.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof m.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof m.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof m.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof m.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof m.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof m.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof m.rename!="function")throw new Error("Provider does NOT implement rename")}static k(m){const{type:t,ctime:i,mtime:a,size:b,permissions:E}=m;return{type:t,ctime:i,mtime:a,size:b,permissions:E}}$stat(m,t){return Promise.resolve(this.l(m).stat(y.URI.revive(t))).then(i=>p.k(i))}$readdir(m,t){return Promise.resolve(this.l(m).readDirectory(y.URI.revive(t)))}$readFile(m,t){return Promise.resolve(this.l(m).readFile(y.URI.revive(t))).then(i=>f.$ae.wrap(i))}$writeFile(m,t,i,a){return Promise.resolve(this.l(m).writeFile(y.URI.revive(t),i.buffer,a))}$delete(m,t,i){return Promise.resolve(this.l(m).delete(y.URI.revive(t),i))}$rename(m,t,i,a){return Promise.resolve(this.l(m).rename(y.URI.revive(t),y.URI.revive(i),a))}$copy(m,t,i,a){const b=this.l(m);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(y.URI.revive(t),y.URI.revive(i),a))}$mkdir(m,t){return Promise.resolve(this.l(m).createDirectory(y.URI.revive(t)))}$watch(m,t,i,a){const b=this.l(m).watch(y.URI.revive(i),a);this.f.set(t,b)}$unwatch(m,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(m,t,i){const a=this.l(m);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(y.URI.revive(t),i))}$close(m,t){const i=this.l(m);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(m,t,i,a){const b=this.l(m);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const E=f.$ae.alloc(a);return Promise.resolve(b.read(t,i,E.buffer,0,a)).then(v=>E.slice(0,v))}$write(m,t,i,a){const b=this.l(m);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(t,i,a.buffer,0,a.byteLength))}l(m){const t=this.c.get(m);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$ycc=p}),define(Re[61],Me([1,0,3,38,7,26,4,17,39,6,12,23,13]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=e.$ecc=void 0;let $=p=class{constructor(t,i){this.b=new Map,this.c=new R.$2g,this.a=t.getProxy(y.$aK.MainThreadFileSystem);const a=this;this.value=Object.freeze({async stat(b){try{let E;const v=a.b.get(b.scheme);return v?(await a.a.$ensureActivation(b.scheme),E=await v.impl.stat(b)):E=await a.a.$stat(b),{type:E.type,ctime:E.ctime,mtime:E.mtime,size:E.size,permissions:E.permissions===M.FilePermission.Readonly?1:void 0}}catch(E){p.e(E)}},async readDirectory(b){try{const E=a.b.get(b.scheme);return E?(await a.a.$ensureActivation(b.scheme),(await E.impl.readDirectory(b)).slice()):await a.a.$readdir(b)}catch(E){return p.e(E)}},async createDirectory(b){try{const E=a.b.get(b.scheme);return E&&!E.isReadonly?(await a.a.$ensureActivation(b.scheme),await a.d(E.impl,E.extUri,b)):await a.a.$mkdir(b)}catch(E){return p.e(E)}},async readFile(b){try{const E=a.b.get(b.scheme);return E?(await a.a.$ensureActivation(b.scheme),(await E.impl.readFile(b)).slice()):(await a.a.$readFile(b)).buffer}catch(E){return p.e(E)}},async writeFile(b,E){try{const v=a.b.get(b.scheme);return v&&!v.isReadonly?(await a.a.$ensureActivation(b.scheme),await a.d(v.impl,v.extUri,v.extUri.dirname(b)),await a.c.queueFor(b).queue(()=>Promise.resolve(v.impl.writeFile(b,E,{create:!0,overwrite:!0})))):await a.a.$writeFile(b,L.$ae.wrap(E))}catch(v){return p.e(v)}},async delete(b,E){try{const v=a.b.get(b.scheme);return v&&!v.isReadonly?(await a.a.$ensureActivation(b.scheme),await v.impl.delete(b,{recursive:!1,...E})):await a.a.$delete(b,{recursive:!1,useTrash:!1,atomic:!1,...E})}catch(v){return p.e(v)}},async rename(b,E,v){try{return await a.a.$rename(b,E,{overwrite:!1,...v})}catch(r){return p.e(r)}},async copy(b,E,v){try{return await a.a.$copy(b,E,{overwrite:!1,...v})}catch(r){return p.e(r)}},isWritableFileSystem(b){const E=i.getCapabilities(b);if(typeof E=="number")return!(E&2048)}})}async d(t,i,a){const b=[];for(;!i.isEqual(a,i.dirname(a));)try{if(!((await t.stat(a)).type&M.FileType.Directory))throw C.$pL.FileExists(`Unable to create folder '${a.scheme===c.Schemas.file?a.fsPath:a.toString(!0)}' that already exists but is not a directory`);break}catch(E){if(M.$mk(E)!==M.FileSystemProviderErrorCode.FileNotFound)throw E;b.push(i.basename(a)),a=i.dirname(a)}for(let E=b.length-1;E>=0;E--){a=i.joinPath(a,b[E]);try{await t.createDirectory(a)}catch(v){if(M.$mk(v)!==M.FileSystemProviderErrorCode.FileExists)throw v}}}static e(t){if(t instanceof C.$pL)throw t;if(t instanceof M.$ik)switch(t.code){case M.FileSystemProviderErrorCode.FileExists:throw C.$pL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$pL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$pL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$pL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$pL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$pL.Unavailable(t.message);default:throw new C.$pL(t.message,t.name)}if(!(t instanceof Error))throw new C.$pL(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw C.$pL.Unavailable(t.message);switch(t.name){case M.FileSystemProviderErrorCode.FileExists:throw C.$pL.FileExists(t.message);case M.FileSystemProviderErrorCode.FileNotFound:throw C.$pL.FileNotFound(t.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw C.$pL.FileNotADirectory(t.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw C.$pL.FileIsADirectory(t.message);case M.FileSystemProviderErrorCode.NoPermissions:throw C.$pL.NoPermissions(t.message);case M.FileSystemProviderErrorCode.Unavailable:throw C.$pL.Unavailable(t.message);default:throw new C.$pL(t.message,t.name)}}addFileSystemProvider(t,i,a){return this.b.set(t,{impl:i,extUri:a?.isCaseSensitive?D.$kg:D.$mg,isReadonly:!!a?.isReadonly}),(0,f.$Pc)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$kg}};e.$ecc=$,e.$ecc=$=p=qe([We(0,l.$bM),We(1,k.$Mbc)],$),e.$fcc=(0,A.$Nh)("IExtHostConsumerFileSystem")}),define(Re[234],Me([1,0,5,37,2,3,8,7,40]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zcc=void 0;class f{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,$,m,t,i,a){this.a=Math.random(),this.b=new y.$Md,this.c=new y.$Md,this.d=new y.$Md,this.h=0,a?.ignoreCreateEvents&&(this.h+=1),a?.ignoreChangeEvents&&(this.h+=2),a?.ignoreDeleteEvents&&(this.h+=4);const b=(0,M.$uj)(i),E=typeof i=="string",v=t(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)){if(!a?.ignoreCreateEvents)for(const s of r.created){const n=C.URI.revive(s);b(n.fsPath)&&(!E||$.getWorkspaceFolder(n))&&this.b.fire(n)}if(!a?.ignoreChangeEvents)for(const s of r.changed){const n=C.URI.revive(s);b(n.fsPath)&&(!E||$.getWorkspaceFolder(n))&&this.c.fire(n)}if(!a?.ignoreDeleteEvents)for(const s of r.deleted){const n=C.URI.revive(s);b(n.fsPath)&&(!E||$.getWorkspaceFolder(n))&&this.d.fire(n)}}});this.g=l.$cK.from(this.i(p,m,i,a),this.b,this.c,this.d,v)}i(p,$,m,t){const i=l.$cK.from();if(typeof m=="string")return i;const a=p.getProxy(L.$aK.MainThreadFileSystemEventService);let b=!1;return(m.pattern.includes(M.$qj)||m.pattern.includes(M.$rj))&&(b=!0),a.$watch($.identifier.value,this.a,m.baseUri,{recursive:b,excludes:t?.excludes??[]}),l.$cK.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor(p){this.a=p,this.session=this.a.session,this.b=new k.$U(()=>this.a.created.map(C.URI.revive)),this.c=new k.$U(()=>this.a.changed.map(C.URI.revive)),this.d=new k.$U(()=>this.a.deleted.map(C.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(p,$,m){this.j=p,this.k=$,this.l=m,this.a=new y.$Md,this.b=new y.$Md,this.c=new y.$Md,this.d=new y.$Md,this.g=new y.$Od,this.h=new y.$Od,this.i=new y.$Od,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,$,m,t){return new f(this.j,p,$,this.a.event,A.GlobPattern.from(m),t)}$onFileEvent(p){this.a.fire(new R(p))}$onDidRunFileOperation(p,$){switch(p){case 2:this.b.fire(Object.freeze({files:$.map(m=>({oldUri:C.URI.revive(m.source),newUri:C.URI.revive(m.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(m=>C.URI.revive(m.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(m=>C.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,$){return(m,t,i)=>{const a=function(E){m.call(t,E)};return a.extension=p,$.event(a,void 0,i)}}async $onWillRunFileOperation(p,$,m,t){switch(p){case 2:return await this.n(this.g,{files:$.map(i=>({oldUri:C.URI.revive(i.source),newUri:C.URI.revive(i.target)}))},m,t);case 1:return await this.n(this.i,{files:$.map(i=>C.URI.revive(i.target))},m,t);case 0:case 3:return await this.n(this.h,{files:$.map(i=>C.URI.revive(i.target))},m,t)}}async n(p,$,m,t){const i=new Set,a=[];if(await p.fireAsync($,t,async(E,v)=>{const r=Date.now(),s=await Promise.resolve(E);s instanceof l.$mK&&(a.push([v.extension,s]),i.add(v.extension.displayName??v.extension.identifier.value)),Date.now()-r>m&&this.k.warn("SLOW file-participant",v.extension.identifier)}),t.isCancellationRequested||a.length===0)return;const b={edits:[]};for(const[,E]of a){const{edits:v}=A.WorkspaceEdit.from(E,{getTextDocumentVersion:r=>this.l.getDocument(r)?.version,getNotebookDocumentVersion:()=>{}});b.edits=b.edits.concat(v)}return{edit:b,extensionNames:Array.from(i)}}}e.$zcc=D}),define(Re[235],Me([1,0,6,2,3,8,7,31,12]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=void 0;class f{static{this.a=0}constructor(p,$){this.extension=p,this.provider=$,this.handle=f.a++}}class R{constructor(p){this.session=p,this.responses=[]}}class D{static{this.a=0}constructor(p,$,m,t){this.f=m,this.g=t,this.b=new Map,this.d=new Map,this.e=p.getProxy(C.$aK.MainThreadInlineChat),$.registerApiCommand(new l.$BM("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new l.$zM("Run arguments","",i=>!0,i=>{if(i)return{initialRange:i.initialRange?L.Range.from(i.initialRange):void 0,initialSelection:i.initialSelection?L.Selection.from(i.initialSelection):void 0,message:i.message,autoSend:i.autoSend,position:i.position?L.Position.from(i.position):void 0}})],l.$AM.Void))}registerProvider(p,$,m){const t=new f(p,$);return this.b.set(t.handle,t),this.e.$registerInteractiveEditorProvider(t.handle,m.label,p.identifier.value,typeof $.handleInteractiveEditorResponseFeedback=="function"),(0,y.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(t.handle),this.b.delete(t.handle)})}async $prepareSession(p,$,m,t){const i=this.b.get(p);if(!i){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const a=this.f.getDocument(M.URI.revive($)),b=L.Selection.to(m),E=await i.provider.prepareInteractiveEditorSession({document:a,selection:b},t);if(!E)return;if(E.wholeRange&&!E.wholeRange.contains(b))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const v=D.a++;return this.d.set(v,new R(E)),{id:v,placeholder:E.placeholder,slashCommands:E.slashCommands?.map(r=>({command:r.command,detail:r.detail,refer:r.refer,executeImmediately:r.executeImmediately})),wholeRange:L.Range.from(E.wholeRange),message:E.message}}async $provideResponse(p,$,m,t){const i=this.b.get(p);if(!i)return;const a=this.d.get($.id);if(!a)return;const b={prompt:m.prompt,selection:L.Selection.to(m.selection),wholeRange:L.Range.to(m.wholeRange),attempt:m.attempt,live:m.live};let E=!1;const v={report:async d=>{if(!m.live)throw new Error("Progress reporting is only supported for live sessions");E||t.isCancellationRequested||await this.e.$handleProgressChunk(m.requestId,{message:d.message,edits:d.edits?.map(L.TextEdit.from),slashCommand:d.slashCommand?.command})}},r=Promise.resolve(i.provider.provideInteractiveEditorResponse(a.session,b,v,t));let s;try{s=await(0,k.$Hg)(r,t)}finally{E=!0}if(!s)return;const n=a.responses.push(s)-1,o={wholeRange:L.Range.from(s.wholeRange),placeholder:s.placeholder};if(D.h(s))return{...o,id:n,type:"message",message:L.MarkdownString.from(s.contents)};const{edits:w}=s;return w instanceof A.$mK?{...o,id:n,type:"bulkEdit",edits:L.WorkspaceEdit.from(w)}:{...o,id:n,type:"editorEdit",edits:w.map(L.TextEdit.from)}}$handleFeedback(p,$,m,t){const i=this.b.get(p),a=this.d.get($),b=a?.responses[m];if(i&&b){const E=L.InteractiveEditorResponseFeedbackKind.to(t);i.provider.handleInteractiveEditorResponseFeedback?.(a.session,b,E)}}$releaseSession(p,$){}static h(p){return typeof p=="object"&&typeof p.contents=="object"}}e.$Gdc=D}),define(Re[236],Me([1,0,2,31]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cdc=void 0;class C{constructor(A,l,k,f,R){this.a=l,this.b=k,this.c=f;const D=new M.$BM("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$zM("showOptions","Show Options",c=>!0,c=>c),new M.$zM("resource","Interactive resource Uri",c=>!0,c=>c),new M.$zM("controllerId","Notebook controller Id",c=>!0,c=>c),new M.$zM("title","Interactive editor title",c=>!0,c=>c)],new M.$AM("Notebook and input URI",c=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const p=this.a.getEditorById(c.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:y.URI.revive(c.notebookUri),inputUri:y.URI.revive(c.inputUri),notebookEditor:p.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:y.URI.revive(c.notebookUri),inputUri:y.URI.revive(c.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,l,k,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:l,lines:[""],languageId:k,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,l){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Cdc=C}),define(Re[237],Me([1,0,3,7]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Idc=void 0;class C{constructor(A){this.a=new Map,this.b=A.getProxy(y.$aK.MainThreadIssueReporter)}async $getIssueReporterUri(A,l){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(A);if(!k)throw new Error("Issue request handler not found");const f=await k.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}registerIssueUriRequestHandler(A,l){const k=A.identifier.value;return this.a.set(k,l),this.b.$registerIssueUriRequestHandler(k),new M.$cK(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$Idc=C}),define(Re[238],Me([1,0,6,3]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0;class C{constructor(A){this.b=0,this.a=A.getProxy(M.$aK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const l=this.b++;return this.a.$registerResourceLabelFormatter(l,A),(0,y.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(l)})}}e.$Vcc=C}),define(Re[239],Me([1,0,2,24,8,7,78,3,15,45,18,16,280,21,20,6,91,88,74,58,9,12,25,149]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;class n{constructor(F,q){this.d=F,this.e=q}async provideDocumentSymbols(F,q){const J=this.d.getDocument(F),Q=await this.e.provideDocumentSymbols(J,q);if(!(0,R.$Jb)(Q))return Q[0]instanceof L.$uK?Q.map(C.DocumentSymbol.from):n.f(Q)}static f(F){F=F.slice(0).sort((Q,H)=>{let x=Q.location.range.start.compareTo(H.location.range.start);return x===0&&(x=H.location.range.end.compareTo(Q.location.range.end)),x});const q=[],J=[];for(const Q of F){const H={name:Q.name||"!!MISSING: name!!",kind:C.SymbolKind.from(Q.kind),tags:Q.tags?.map(C.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:C.Range.from(Q.location.range),selectionRange:C.Range.from(Q.location.range),children:[]};for(;;){if(J.length===0){J.push(H),q.push(H);break}const x=J[J.length-1];if(f.$ps.containsRange(x.range,H.range)&&!f.$ps.equalsRange(x.range,H.range)){x.children?.push(H),J.push(H);break}J.pop()}}return q}}class o{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,q,J){this.g=F,this.h=q,this.j=J,this.e=new a.$Jbc("CodeLens"),this.f=new Map}async provideCodeLenses(F,q){const J=this.g.getDocument(F),Q=await this.j.provideCodeLenses(J,q);if(!Q||q.isCancellationRequested)return;const H=this.e.add(Q),x=new m.$Qc;this.f.set(H,x);const ae={cacheId:H,lenses:[]};for(let Le=0;Le<Q.length;Le++)ae.lenses.push({cacheId:[H,Le],range:C.Range.from(Q[Le].range),command:this.h.toInternal(Q[Le].command,x)});return ae}async resolveCodeLens(F,q){const J=F.cacheId&&this.e.get(...F.cacheId);if(!J)return;let Q;if(typeof this.j.resolveCodeLens!="function"||J.isResolved?Q=J:Q=await this.j.resolveCodeLens(J,q),Q||(Q=J),q.isCancellationRequested)return;const H=F.cacheId&&this.f.get(F.cacheId[0]);if(H)return F.command=this.h.toInternal(Q.command??o.d,H),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function w(Ie){return Array.isArray(Ie)?Ie.map(C.DefinitionLink.from):Ie?[C.DefinitionLink.from(Ie)]:[]}class d{constructor(F,q){this.d=F,this.e=q}async provideDefinition(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),x=await this.e.provideDefinition(Q,H,J);return w(x)}}class I{constructor(F,q){this.d=F,this.e=q}async provideDeclaration(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),x=await this.e.provideDeclaration(Q,H,J);return w(x)}}class S{constructor(F,q){this.d=F,this.e=q}async provideImplementation(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),x=await this.e.provideImplementation(Q,H,J);return w(x)}}class u{constructor(F,q){this.d=F,this.e=q}async provideTypeDefinition(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),x=await this.e.provideTypeDefinition(Q,H,J);return w(x)}}class g{constructor(F,q){this.d=F,this.e=q}async provideHover(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),x=await this.e.provideHover(Q,H,J);if(!(!x||(0,R.$Jb)(x.contents)))return x.range||(x.range=Q.getWordRangeAtPosition(H)),x.range||(x.range=new L.$eK(H,H)),C.Hover.from(x)}}class h{constructor(F,q){this.d=F,this.e=q}async provideEvaluatableExpression(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),x=await this.e.provideEvaluatableExpression(Q,H,J);if(x)return C.EvaluatableExpression.from(x)}}class P{constructor(F,q){this.d=F,this.e=q}async provideInlineValues(F,q,J,Q){const H=this.d.getDocument(F),x=await this.e.provideInlineValues(H,C.Range.to(q),C.InlineValueContext.to(J),Q);if(Array.isArray(x))return x.map(ae=>C.InlineValue.from(ae))}}class W{constructor(F,q){this.d=F,this.e=q}async provideDocumentHighlights(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),x=await this.e.provideDocumentHighlights(Q,H,J);if(Array.isArray(x))return x.map(C.DocumentHighlight.from)}}class K{constructor(F,q){this.d=F,this.e=q}async provideLinkedEditingRanges(F,q,J){const Q=this.d.getDocument(F),H=C.Position.to(q),x=await this.e.provideLinkedEditingRanges(Q,H,J);if(x&&Array.isArray(x.ranges))return{ranges:(0,R.$Gb)(x.ranges.map(C.Range.from)),wordPattern:x.wordPattern}}}class j{constructor(F,q){this.d=F,this.e=q}async provideReferences(F,q,J,Q){const H=this.d.getDocument(F),x=C.Position.to(q),ae=await this.e.provideReferences(H,x,J,Q);if(Array.isArray(ae))return ae.map(C.location.from)}}class B{static{this.d=1e3}constructor(F,q,J,Q,H,x,ae){this.g=F,this.h=q,this.j=J,this.k=Q,this.l=H,this.m=x,this.n=ae,this.e=new a.$Jbc("CodeAction"),this.f=new Map}async provideCodeActions(F,q,J,Q){const H=this.g.getDocument(F),x=c.$rs.isISelection(q)?C.Selection.to(q):C.Range.to(q),ae=[];for(const Xe of this.j.getDiagnostics(F))if(x.intersection(Xe.range)&&ae.push(Xe)>B.d)break;const Le={diagnostics:ae,only:J.only?new L.$wK(J.only):void 0,triggerKind:C.CodeActionTriggerKind.to(J.trigger)},je=await this.k.provideCodeActions(H,x,Le,Q);if(!(0,R.$Kb)(je)||Q.isCancellationRequested)return;const Qe=this.e.add(je),Ge=new m.$Qc;this.f.set(Qe,Ge);const xe=[];for(let Xe=0;Xe<je.length;Xe++){const _e=je[Xe];_e&&(B.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),xe.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,Ge)})):(Le.only&&(_e.kind?Le.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Le.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),xe.push({cacheId:[Qe,Xe],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,Ge),diagnostics:_e.diagnostics&&_e.diagnostics.map(C.Diagnostic.from),edit:_e.edit&&C.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,isAI:(0,r.$_E)(this.m,"codeActionAI")?_e.isAI:!1,disabled:_e.disabled?.reason})))}return{cacheId:Qe,actions:xe}}async resolveCodeAction(F,q){const[J,Q]=F,H=this.e.get(J,Q);if(!H||B.o(H))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(H,q)??H;let ae;x.edit&&(ae=C.WorkspaceEdit.from(x.edit,void 0));let Le;if(x.command){const je=this.f.get(J);je&&(Le=this.h.toInternal(x.command,je))}return{edit:ae,command:Le}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static o(F){return typeof F.command=="string"&&typeof F.title=="string"}}class O{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,J,Q,H){this.d=F,this.e=q,this.f=J,this.g=Q,this.h=H}async prepareDocumentPaste(F,q,J,Q){if(!this.f.prepareDocumentPaste)return;const H=this.e.getDocument(F),x=q.map(je=>C.Range.to(je)),ae=C.DataTransfer.toDataTransfer(J,()=>{throw new E.$0});if(await this.f.prepareDocumentPaste(H,x,ae,Q),Q.isCancellationRequested)return;const Le=Array.from(ae).filter(([,je])=>!(je instanceof L.$3K));return C.DataTransfer.from(Le)}async providePasteEdits(F,q,J,Q,H){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(q),ae=J.map(Qe=>C.Range.to(Qe)),Le=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,F,Qe)).buffer),je=await this.f.provideDocumentPasteEdits(x,ae,Le,H);if(je)return{label:je.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:O.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class N{constructor(F,q){this.d=F,this.e=q}async provideDocumentFormattingEdits(F,q,J){const Q=this.d.getDocument(F),H=await this.e.provideDocumentFormattingEdits(Q,q,J);if(Array.isArray(H))return H.map(C.TextEdit.from)}}class te{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeFormattingEdits(F,q,J,Q){const H=this.d.getDocument(F),x=C.Range.to(q),ae=await this.e.provideDocumentRangeFormattingEdits(H,x,J,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,q,J,Q){(0,D.$Hf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const H=this.d.getDocument(F),x=q.map(C.Range.to),ae=await this.e.provideDocumentRangesFormattingEdits(H,x,J,Q);if(Array.isArray(ae))return ae.map(C.TextEdit.from)}}class Y{constructor(F,q){this.d=F,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,q,J,Q,H){const x=this.d.getDocument(F),ae=C.Position.to(q),Le=await this.e.provideOnTypeFormattingEdits(x,ae,J,Q,H);if(Array.isArray(Le))return Le.map(C.TextEdit.from)}}class Ee{constructor(F,q){this.e=F,this.f=q,this.d=new a.$Jbc("WorkspaceSymbols")}async provideWorkspaceSymbols(F,q){const J=await this.e.provideWorkspaceSymbols(F,q);if(!(0,R.$Kb)(J))return{symbols:[]};const Q=this.d.add(J),H={cacheId:Q,symbols:[]};for(let x=0;x<J.length;x++){const ae=J[x];if(!ae||!ae.name){this.f.warn("INVALID SymbolInformation",ae);continue}H.symbols.push({...C.WorkspaceSymbol.from(ae),cacheId:[Q,x]})}return H}async resolveWorkspaceSymbol(F,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const J=this.d.get(...F.cacheId);if(J){const Q=await this.e.resolveWorkspaceSymbol(J,q);return Q&&(0,M.$6m)(F,C.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class Se{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,q,J){this.d=F,this.e=q,this.f=J}async provideRenameEdits(F,q,J,Q){const H=this.d.getDocument(F),x=C.Position.to(q);try{const ae=await this.e.provideRenameEdits(H,x,J,Q);return ae?C.WorkspaceEdit.from(ae):void 0}catch(ae){const Le=Se.g(ae);return Le?{rejectReason:Le,edits:void 0}:Promise.reject(ae)}}async resolveRenameLocation(F,q,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(F),H=C.Position.to(q);try{const x=await this.e.prepareRename(Q,H,J);let ae,Le;if(L.$eK.isRange(x)?(ae=x,Le=Q.getText(x)):(0,D.$zf)(x)&&(ae=x.range,Le=x.placeholder),!ae||!Le)return;if(ae.start.line>H.line||ae.end.line<H.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ae),text:Le}}catch(x){const ae=Se.g(x);return ae?{rejectReason:ae,range:void 0,text:void 0}:Promise.reject(x)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Pe{constructor(F,q){this.resultId=F,this.tokens=q}}class ge{constructor(F,q){this.f=F,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,q,J){const Q=this.f.getDocument(F),H=q!==0?this.d.get(q):null;let x=typeof H?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,H.resultId,J):await this.g.provideDocumentSemanticTokens(Q,J);return H&&this.d.delete(q),x?(x=ge.h(x),this.o(ge.n(H,x),x)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return ge.j(F)?ge.k(F)?F:new L.$tL(new Uint32Array(F.data),F.resultId):ge.l(F)?ge.m(F)?F:new L.$vL(F.edits.map(q=>new L.$uL(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const q of F.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(F,q){if(!ge.j(q)||!F||!F.tokens)return q;const J=F.tokens,Q=J.length,H=q.data,x=H.length;let ae=0;const Le=Math.min(Q,x);for(;ae<Le&&J[ae]===H[ae];)ae++;if(ae===Q&&ae===x)return new L.$vL([],q.resultId);let je=0;const Qe=Le-ae;for(;je<Qe&&J[Q-je-1]===H[x-je-1];)je++;return new L.$vL([{start:ae,deleteCount:Q-ae-je,data:H.subarray(ae,x-je)}],q.resultId)}o(F,q){if(ge.j(F)){const J=this.e++;return this.d.set(J,new Pe(F.resultId,F.data)),(0,t.$Q0)({id:J,type:"full",data:F.data})}if(ge.l(F)){const J=this.e++;return ge.j(q)?this.d.set(J,new Pe(q.resultId,q.data)):this.d.set(J,new Pe(F.resultId)),(0,t.$Q0)({id:J,type:"delta",deltas:(F.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class me{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeSemanticTokens(F,q,J){const Q=this.d.getDocument(F),H=await this.e.provideDocumentRangeSemanticTokens(Q,C.Range.to(q),J);return H?this.f(H):null}f(F){return(0,t.$Q0)({id:0,type:"full",data:F.data})}}class ce{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,q,J,Q,H){this.f=F,this.g=q,this.h=J,this.j=Q,this.k=H,this.d=new a.$Jbc("CompletionItem"),this.e=new Map}async provideCompletionItems(F,q,J,Q){const H=this.f.getDocument(F),x=C.Position.to(q),ae=H.getWordRangeAtPosition(x)||new L.$eK(x,x),Le=ae.with({end:x}),je=new b.$Id,Qe=await this.h.provideCompletionItems(H,x,Q,C.CompletionContext.to(J));if(!Qe||Q.isCancellationRequested)return;const Ge=Array.isArray(Qe)?new L.$JK(Qe):Qe,xe=ce.supportsResolving(this.h)?this.d.add(Ge.items):this.d.add([]),Xe=new m.$Qc;this.e.set(xe,Xe);const _e=[],it={x:xe,b:_e,a:{replace:C.Range.from(ae),insert:C.Range.from(Le)},c:Ge.isIncomplete||void 0,d:je.elapsed()};for(let tt=0;tt<Ge.items.length;tt++){const ze=Ge.items[tt],st=this.l(ze,[xe,tt],Le,ae);_e.push(st)}return it}async resolveCompletionItem(F,q){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...F);if(!J)return;const Q=this.l(J,F),H=await this.h.resolveCompletionItem(J,q);if(!H)return;const x=this.l(H,F);return(Q.h!==x.h||Q.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==x.n||Q.o!==x.o||!(0,M.$7m)(Q.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q,J,Q){const H=this.e.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const x=this.g.toInternal(F.command,H),ae={x:q,a:F.label,b:F.kind!==void 0?C.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(C.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:C.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(C.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ae.h=F.textEdit.newText):typeof F.insertText=="string"?ae.h=F.insertText:F.insertText instanceof L.$nK&&(ae.h=F.insertText.value,ae.i|=4);let Le;return F.textEdit?Le=F.textEdit.range:F.range&&(Le=F.range),L.$eK.isRange(Le)?ae.j=C.Range.from(Le):Le&&(!J?.isEqual(Le.inserting)||!Q?.isEqual(Le.replacing))&&(ae.j={insert:C.Range.from(Le.inserting),replace:C.Range.from(Le.replacing)}),ae}}class se{async provideInlineCompletions(F,q,J,Q){}disposeCompletions(F){}handleDidShowCompletionItem(F,q,J){}handlePartialAccept(F,q,J){}}class $e extends se{constructor(F,q,J,Q){super(),this.f=F,this.g=q,this.h=J,this.j=Q,this.d=new _,this.e=(0,r.$_E)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$_E)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,q,J,Q){const H=this.g.getDocument(F),x=C.Position.to(q),ae=await this.h.provideInlineCompletionItems(H,x,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:C.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},Q);if(!ae||Q.isCancellationRequested)return;const Le=Array.isArray(ae)?ae:ae.items,je=this.e?Array.isArray(ae)?[]:ae.commands||[]:[],Qe=this.e&&!Array.isArray(ae)?ae.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Le}),items:Le.map((Xe,_e)=>{let it;Xe.command&&(Ge||(Ge=new m.$Qc),it=this.j.toInternal(Xe.command,Ge));const tt=Xe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Xe.filterText,range:Xe.range?C.Range.from(Xe.range):void 0,command:it,idx:_e,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:je.map(Xe=>(Ge||(Ge=new m.$Qc),this.j.toInternal(Xe,Ge))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,q,J){const Q=this.d.get(F)?.items[q];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,J)}handlePartialAccept(F,q,J){const Q=this.d.get(F)?.items[q];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,J)}}class _{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const q=this.e++;return this.d.set(q,F),q}disposeReferenceId(F){const q=this.d.get(F);return this.d.delete(F),q}get(F){return this.d.get(F)}}class z{constructor(F,q){this.e=F,this.f=q,this.d=new a.$Jbc("SignatureHelp")}async provideSignatureHelp(F,q,J,Q){const H=this.e.getDocument(F),x=C.Position.to(q),ae=this.g(J),Le=await this.f.provideSignatureHelp(H,x,Q,ae);if(Le){const je=this.d.add([Le]);return{...C.SignatureHelp.from(Le),id:je}}}g(F){let q;if(F.activeSignatureHelp){const J=C.SignatureHelp.to(F.activeSignatureHelp),Q=this.d.get(F.activeSignatureHelp.id,0);Q?(q=Q,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return{...F,activeSignatureHelp:q}}releaseSignatureHelp(F){this.d.delete(F)}}class V{constructor(F,q,J,Q,H){this.f=F,this.g=q,this.h=J,this.j=Q,this.k=H,this.d=new a.$Jbc("InlayHints"),this.e=new Map}async provideInlayHints(F,q,J){const Q=this.f.getDocument(F),H=C.Range.to(q),x=await this.h.provideInlayHints(Q,H,J);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(J.isCancellationRequested)return;const ae=this.d.add(x);this.e.set(ae,new m.$Qc);const Le={hints:[],cacheId:ae};for(let je=0;je<x.length;je++)this.l(x[je],H)&&Le.hints.push(this.m(x[je],[ae,je]));return this.j.trace(`[InlayHints] ${Le.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),Le}async resolveInlayHint(F,q){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...F);if(!J)return;const Q=await this.h.resolveInlayHint(J,q);if(Q&&this.l(Q))return this.m(Q,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q){return F.label.length===0||Array.isArray(F.label)&&F.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(q&&!q.contains(F.position))}m(F,q){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:q,tooltip:C.MarkdownString.fromStrict(F.tooltip),position:C.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(C.TextEdit.from),kind:F.kind&&C.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?Q.label=F.label:Q.label=F.label.map(H=>{const x={label:H.value};return x.tooltip=C.MarkdownString.fromStrict(H.tooltip),L.$oK.isLocation(H.location)&&(x.location=C.location.from(H.location)),H.command&&(x.command=this.g.toInternal(H.command,J)),x}),Q}}class ue{constructor(F,q){this.e=F,this.f=q,this.d=new a.$Jbc("DocumentLink")}async provideLinks(F,q){const J=this.e.getDocument(F),Q=await this.f.provideDocumentLinks(J,q);if(!(!Array.isArray(Q)||Q.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(ue.g).map(C.DocumentLink.from)};{const H=this.d.add(Q),x={links:[],cacheId:H};for(let ae=0;ae<Q.length;ae++){if(!ue.g(Q[ae]))continue;const Le=C.DocumentLink.from(Q[ae]);Le.cacheId=[H,ae],x.links.push(Le)}return x}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,q){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...F);if(!J)return;const Q=await this.f.resolveDocumentLink(J,q);if(!(!Q||!ue.g(Q)))return C.DocumentLink.from(Q)}releaseLinks(F){this.d.delete(F)}}class ye{constructor(F,q){this.d=F,this.e=q}async provideColors(F,q){const J=this.d.getDocument(F),Q=await this.e.provideDocumentColors(J,q);return Array.isArray(Q)?Q.map(x=>({color:C.Color.from(x.color),range:C.Range.from(x.range)})):[]}async provideColorPresentations(F,q,J){const Q=this.d.getDocument(F),H=C.Range.to(q.range),x=C.Color.to(q.color),ae=await this.e.provideColorPresentations(x,{document:Q,range:H},J);if(Array.isArray(ae))return ae.map(C.ColorPresentation.from)}}class be{constructor(F,q){this.d=F,this.e=q}async provideFoldingRanges(F,q,J){const Q=this.d.getDocument(F),H=await this.e.provideFoldingRanges(Q,q,J);if(Array.isArray(H))return H.map(C.FoldingRange.from)}}class pe{constructor(F,q,J){this.d=F,this.e=q,this.f=J}async provideSelectionRanges(F,q,J){const Q=this.d.getDocument(F),H=q.map(C.Position.to),x=await this.e.provideSelectionRanges(Q,H,J);if(!(0,R.$Kb)(x))return[];if(x.length!==H.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ae=[];for(let Le=0;Le<H.length;Le++){const je=[];ae.push(je);let Qe=H[Le],Ge=x[Le];for(;;){if(!Ge.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(je.push(C.SelectionRange.from(Ge)),!Ge.parent)break;Qe=Ge.range,Ge=Ge.parent}}return ae}}class De{constructor(F,q){this.f=F,this.g=q,this.d=new i.$gM(""),this.e=new Map}async prepareSession(F,q,J){const Q=this.f.getDocument(F),H=C.Position.to(q),x=await this.g.prepareCallHierarchy(Q,H,J);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Le=>this.h(ae,Le)):[this.h(ae,x)]}async provideCallsTo(F,q,J){const Q=this.j(F,q);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyIncomingCalls(Q,J);if(H)return H.map(x=>({from:this.h(F,x.from),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}async provideCallsFrom(F,q,J){const Q=this.j(F,q);if(!Q)throw new Error("missing call hierarchy item");const H=await this.g.provideCallHierarchyOutgoingCalls(Q,J);if(H)return H.map(x=>({to:this.h(F,x.to),fromRanges:x.fromRanges.map(ae=>C.Range.from(ae))}))}releaseSession(F){this.e.delete(F)}h(F,q){const J=this.e.get(F),Q=C.CallHierarchyItem.from(q,F,J.size.toString(36));return J.set(Q._itemId,q),Q}j(F,q){return this.e.get(F)?.get(q)}}class ne{constructor(F,q){this.f=F,this.g=q,this.d=new i.$gM(""),this.e=new Map}async prepareSession(F,q,J){const Q=this.f.getDocument(F),H=C.Position.to(q),x=await this.g.prepareTypeHierarchy(Q,H,J);if(!x)return;const ae=this.d.nextId();return this.e.set(ae,new Map),Array.isArray(x)?x.map(Le=>this.h(ae,Le)):[this.h(ae,x)]}async provideSupertypes(F,q,J){const Q=this.j(F,q);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySupertypes(Q,J);if(H)return H.map(x=>this.h(F,x))}async provideSubtypes(F,q,J){const Q=this.j(F,q);if(!Q)throw new Error("missing type hierarchy item");const H=await this.g.provideTypeHierarchySubtypes(Q,J);if(H)return H.map(x=>this.h(F,x))}releaseSession(F){this.e.delete(F)}h(F,q){const J=this.e.get(F),Q=C.TypeHierarchyItem.from(q,F,J.size.toString(36));return J.set(Q._itemId,q),Q}j(F,q){return this.e.get(F)?.get(q)}}class le{static toInternalProviderId(F,q){return F+"."+q}constructor(F,q,J,Q,H){this.d=F,this.e=q,this.f=J,this.g=Q,this.h=H}async provideDocumentOnDropEdits(F,q,J,Q,H){const x=this.e.getDocument(q),ae=C.Position.to(J),Le=C.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Qe)).buffer),je=await this.f.provideDocumentDropEdits(x,ae,Le,H);if(je)return{label:je.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:je.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:le.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof je.insertText=="string"?je.insertText:{snippet:je.insertText.value},additionalEdit:je.additionalEdit?C.WorkspaceEdit.from(je.additionalEdit,void 0):void 0}}}class re{constructor(F,q){this.d=F,this.e=q}async provideMappedEdits(F,q,J,Q){const H=y.URI.revive(F),x=this.d.getDocument(H),ae=J.documents.map(Qe=>Qe.map(Ge=>({uri:y.URI.revive(Ge.uri),version:Ge.version,ranges:Ge.ranges.map(xe=>C.Range.to(xe))}))),Le={documents:ae,selections:ae[0]?.[0]?.ranges??[]},je=await this.e.provideMappedEdits(x,q,Le,Q);return je?C.WorkspaceEdit.from(je):null}}class oe{constructor(F,q){this.adapter=F,this.extension=q}}class de{static{this.d=0}constructor(F,q,J,Q,H,x,ae,Le){this.g=q,this.h=J,this.j=Q,this.k=H,this.l=x,this.m=ae,this.n=Le,this.f=new Map,this.e=F.getProxy(l.$aK.MainThreadLanguageFeatures)}o(F,q){return C.DocumentSelector.from(F,this.g,q)}p(F){return new L.$cK(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return de.d++}async s(F,q,J,Q,H,x=!1){const ae=this.f.get(F);if(!ae||!(ae.adapter instanceof q))return Q;const Le=Date.now();x||this.l.trace(`[${ae.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const je=J(ae.adapter,ae.extension);return Promise.resolve(je).catch(Qe=>{(0,E.$3)(Qe)||(this.l.error(`[${ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ae.extension.identifier,Qe))}).finally(()=>{x||this.l.trace(`[${ae.extension.identifier.value}] provider DONE after ${Date.now()-Le}ms`)}),p.CancellationToken.isCancellationToken(H)?(0,v.$Ig)(je,H):je}t(F,q){const J=this.q();return this.f.set(J,new oe(F,q)),J}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,q,J,Q){const H=this.t(new n(this.h,J),F),x=Q&&Q.label||de.u(F);return this.e.$registerDocumentSymbolProvider(H,this.o(q,F),x),this.p(H)}$provideDocumentSymbols(F,q,J){return this.s(F,n,Q=>Q.provideDocumentSymbols(y.URI.revive(q),J),void 0,J)}registerCodeLensProvider(F,q,J){const Q=this.q(),H=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new oe(new o(this.h,this.j.converter,J),F)),this.e.$registerCodeLensSupport(Q,this.o(q,F),H);let x=this.p(Q);if(H!==void 0){const ae=J.onDidChangeCodeLenses(Le=>this.e.$emitCodeLensEvent(H));x=L.$cK.from(x,ae)}return x}$provideCodeLenses(F,q,J){return this.s(F,o,Q=>Q.provideCodeLenses(y.URI.revive(q),J),void 0,J)}$resolveCodeLens(F,q,J){return this.s(F,o,Q=>Q.resolveCodeLens(q,J),void 0,void 0)}$releaseCodeLenses(F,q){this.s(F,o,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(F,q,J){const Q=this.t(new d(this.h,J),F);return this.e.$registerDefinitionSupport(Q,this.o(q,F)),this.p(Q)}$provideDefinition(F,q,J,Q){return this.s(F,d,H=>H.provideDefinition(y.URI.revive(q),J,Q),[],Q)}registerDeclarationProvider(F,q,J){const Q=this.t(new I(this.h,J),F);return this.e.$registerDeclarationSupport(Q,this.o(q,F)),this.p(Q)}$provideDeclaration(F,q,J,Q){return this.s(F,I,H=>H.provideDeclaration(y.URI.revive(q),J,Q),[],Q)}registerImplementationProvider(F,q,J){const Q=this.t(new S(this.h,J),F);return this.e.$registerImplementationSupport(Q,this.o(q,F)),this.p(Q)}$provideImplementation(F,q,J,Q){return this.s(F,S,H=>H.provideImplementation(y.URI.revive(q),J,Q),[],Q)}registerTypeDefinitionProvider(F,q,J){const Q=this.t(new u(this.h,J),F);return this.e.$registerTypeDefinitionSupport(Q,this.o(q,F)),this.p(Q)}$provideTypeDefinition(F,q,J,Q){return this.s(F,u,H=>H.provideTypeDefinition(y.URI.revive(q),J,Q),[],Q)}registerHoverProvider(F,q,J,Q){const H=this.t(new g(this.h,J),F);return this.e.$registerHoverProvider(H,this.o(q,F)),this.p(H)}$provideHover(F,q,J,Q){return this.s(F,g,H=>H.provideHover(y.URI.revive(q),J,Q),void 0,Q)}registerEvaluatableExpressionProvider(F,q,J,Q){const H=this.t(new h(this.h,J),F);return this.e.$registerEvaluatableExpressionProvider(H,this.o(q,F)),this.p(H)}$provideEvaluatableExpression(F,q,J,Q){return this.s(F,h,H=>H.provideEvaluatableExpression(y.URI.revive(q),J,Q),void 0,Q)}registerInlineValuesProvider(F,q,J,Q){const H=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new P(this.h,J),F);this.e.$registerInlineValuesProvider(x,this.o(q,F),H);let ae=this.p(x);if(H!==void 0){const Le=J.onDidChangeInlineValues(je=>this.e.$emitInlineValuesEvent(H));ae=L.$cK.from(ae,Le)}return ae}$provideInlineValues(F,q,J,Q,H){return this.s(F,P,x=>x.provideInlineValues(y.URI.revive(q),J,Q,H),void 0,H)}registerDocumentHighlightProvider(F,q,J){const Q=this.t(new W(this.h,J),F);return this.e.$registerDocumentHighlightProvider(Q,this.o(q,F)),this.p(Q)}$provideDocumentHighlights(F,q,J,Q){return this.s(F,W,H=>H.provideDocumentHighlights(y.URI.revive(q),J,Q),void 0,Q)}registerLinkedEditingRangeProvider(F,q,J){const Q=this.t(new K(this.h,J),F);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(q,F)),this.p(Q)}$provideLinkedEditingRanges(F,q,J,Q){return this.s(F,K,async H=>{const x=await H.provideLinkedEditingRanges(y.URI.revive(q),J,Q);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?de.w(x.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(F,q,J){const Q=this.t(new j(this.h,J),F);return this.e.$registerReferenceSupport(Q,this.o(q,F)),this.p(Q)}$provideReferences(F,q,J,Q,H){return this.s(F,j,x=>x.provideReferences(y.URI.revive(q),J,Q,H),void 0,H)}registerCodeActionProvider(F,q,J,Q){const H=new m.$Qc,x=this.t(new B(this.h,this.j.converter,this.k,J,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(x,this.o(q,F),{providedKinds:Q?.providedCodeActionKinds?.map(ae=>ae.value),documentation:Q?.documentation?.map(ae=>({kind:ae.kind.value,command:this.j.converter.toInternal(ae.command,H)}))},de.u(F),!!J.resolveCodeAction),H.add(this.p(x)),H}$provideCodeActions(F,q,J,Q,H){return this.s(F,B,x=>x.provideCodeActions(y.URI.revive(q),J,Q,H),void 0,H)}$resolveCodeAction(F,q,J){return this.s(F,B,Q=>Q.resolveCodeAction(q,J),{},void 0)}$releaseCodeActions(F,q){this.s(F,B,J=>Promise.resolve(J.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(F,q,J){const Q=this.t(new N(this.h,J),F);return this.e.$registerDocumentFormattingSupport(Q,this.o(q,F),F.identifier,F.displayName||F.name),this.p(Q)}$provideDocumentFormattingEdits(F,q,J,Q){return this.s(F,N,H=>H.provideDocumentFormattingEdits(y.URI.revive(q),J,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(F,q,J){const Q=typeof J.provideDocumentRangesFormattingEdits=="function",H=this.t(new te(this.h,J),F);return this.e.$registerRangeFormattingSupport(H,this.o(q,F),F.identifier,F.displayName||F.name,Q),this.p(H)}$provideDocumentRangeFormattingEdits(F,q,J,Q,H){return this.s(F,te,x=>x.provideDocumentRangeFormattingEdits(y.URI.revive(q),J,Q,H),void 0,H)}$provideDocumentRangesFormattingEdits(F,q,J,Q,H){return this.s(F,te,x=>x.provideDocumentRangesFormattingEdits(y.URI.revive(q),J,Q,H),void 0,H)}registerOnTypeFormattingEditProvider(F,q,J,Q){const H=this.t(new Y(this.h,J),F);return this.e.$registerOnTypeFormattingSupport(H,this.o(q,F),Q,F.identifier),this.p(H)}$provideOnTypeFormattingEdits(F,q,J,Q,H,x){return this.s(F,Y,ae=>ae.provideOnTypeFormattingEdits(y.URI.revive(q),J,Q,H,x),void 0,x)}registerWorkspaceSymbolProvider(F,q){const J=this.t(new Ee(q,this.l),F);return this.e.$registerNavigateTypeSupport(J,typeof q.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(F,q,J){return this.s(F,Ee,Q=>Q.provideWorkspaceSymbols(q,J),{symbols:[]},J)}$resolveWorkspaceSymbol(F,q,J){return this.s(F,Ee,Q=>Q.resolveWorkspaceSymbol(q,J),void 0,void 0)}$releaseWorkspaceSymbols(F,q){this.s(F,Ee,J=>J.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(F,q,J){const Q=this.t(new Se(this.h,J,this.l),F);return this.e.$registerRenameSupport(Q,this.o(q,F),Se.supportsResolving(J)),this.p(Q)}$provideRenameEdits(F,q,J,Q,H){return this.s(F,Se,x=>x.provideRenameEdits(y.URI.revive(q),J,Q,H),void 0,H)}$resolveRenameLocation(F,q,J,Q){return this.s(F,Se,H=>H.resolveRenameLocation(y.URI.revive(q),J,Q),void 0,Q)}registerDocumentSemanticTokensProvider(F,q,J,Q){const H=this.t(new ge(this.h,J),F),x=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(H,this.o(q,F),Q,x);let ae=this.p(H);if(x){const Le=J.onDidChangeSemanticTokens(je=>this.e.$emitDocumentSemanticTokensEvent(x));ae=L.$cK.from(ae,Le)}return ae}$provideDocumentSemanticTokens(F,q,J,Q){return this.s(F,ge,H=>H.provideDocumentSemanticTokens(y.URI.revive(q),J,Q),null,Q)}$releaseDocumentSemanticTokens(F,q){this.s(F,ge,J=>J.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,q,J,Q){const H=this.t(new me(this.h,J),F);return this.e.$registerDocumentRangeSemanticTokensProvider(H,this.o(q,F),Q),this.p(H)}$provideDocumentRangeSemanticTokens(F,q,J,Q){return this.s(F,me,H=>H.provideDocumentRangeSemanticTokens(y.URI.revive(q),J,Q),null,Q)}registerCompletionItemProvider(F,q,J,Q){const H=this.t(new ce(this.h,this.j.converter,J,this.m,F),F);return this.e.$registerCompletionsProvider(H,this.o(q,F),Q,ce.supportsResolving(J),F.identifier),this.p(H)}$provideCompletionItems(F,q,J,Q,H){return this.s(F,ce,x=>x.provideCompletionItems(y.URI.revive(q),J,Q,H),void 0,H)}$resolveCompletionItem(F,q,J){return this.s(F,ce,Q=>Q.resolveCompletionItem(q,J),void 0,J)}$releaseCompletionItems(F,q){this.s(F,ce,J=>J.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(F,q,J,Q){const H=new $e(F,this.h,J,this.j.converter),x=this.t(H,F);return this.e.$registerInlineCompletionsSupport(x,this.o(q,F),H.supportsHandleEvents,$.$3l.toKey(F.identifier.value),Q?.yieldTo?.map(ae=>$.$3l.toKey(ae))||[]),this.p(x)}$provideInlineCompletions(F,q,J,Q,H){return this.s(F,se,x=>x.provideInlineCompletions(y.URI.revive(q),J,Q,H),void 0,H)}$handleInlineCompletionDidShow(F,q,J,Q){this.s(F,se,async H=>{H.handleDidShowCompletionItem(q,J,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,q,J,Q){this.s(F,se,async H=>{H.handlePartialAccept(q,J,Q)},void 0,void 0)}$freeInlineCompletionsList(F,q){this.s(F,se,async J=>{J.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(F,q,J,Q){const H=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,x=this.t(new z(this.h,J),F);return this.e.$registerSignatureHelpProvider(x,this.o(q,F),H),this.p(x)}$provideSignatureHelp(F,q,J,Q,H){return this.s(F,z,x=>x.provideSignatureHelp(y.URI.revive(q),J,Q,H),void 0,H)}$releaseSignatureHelp(F,q){this.s(F,z,J=>J.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(F,q,J){const Q=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,H=this.t(new V(this.h,this.j.converter,J,this.l,F),F);this.e.$registerInlayHintsProvider(H,this.o(q,F),typeof J.resolveInlayHint=="function",Q,de.u(F));let x=this.p(H);if(Q!==void 0){const ae=J.onDidChangeInlayHints(Le=>this.e.$emitInlayHintsEvent(Q));x=L.$cK.from(x,ae)}return x}$provideInlayHints(F,q,J,Q){return this.s(F,V,H=>H.provideInlayHints(y.URI.revive(q),J,Q),void 0,Q)}$resolveInlayHint(F,q,J){return this.s(F,V,Q=>Q.resolveInlayHint(q,J),void 0,J)}$releaseInlayHints(F,q){this.s(F,V,J=>J.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(F,q,J){const Q=this.t(new ue(this.h,J),F);return this.e.$registerDocumentLinkProvider(Q,this.o(q,F),typeof J.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(F,q,J){return this.s(F,ue,Q=>Q.provideLinks(y.URI.revive(q),J),void 0,J,q.scheme==="output")}$resolveDocumentLink(F,q,J){return this.s(F,ue,Q=>Q.resolveLink(q,J),void 0,void 0,!0)}$releaseDocumentLinks(F,q){this.s(F,ue,J=>J.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(F,q,J){const Q=this.t(new ye(this.h,J),F);return this.e.$registerDocumentColorProvider(Q,this.o(q,F)),this.p(Q)}$provideDocumentColors(F,q,J){return this.s(F,ye,Q=>Q.provideColors(y.URI.revive(q),J),[],J)}$provideColorPresentations(F,q,J,Q){return this.s(F,ye,H=>H.provideColorPresentations(y.URI.revive(q),J,Q),void 0,Q)}registerFoldingRangeProvider(F,q,J){const Q=this.q(),H=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new oe(new be(this.h,J),F)),this.e.$registerFoldingRangeProvider(Q,this.o(q,F),F.identifier,H);let x=this.p(Q);if(H!==void 0){const ae=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(H));x=L.$cK.from(x,ae)}return x}$provideFoldingRanges(F,q,J,Q){return this.s(F,be,H=>H.provideFoldingRanges(y.URI.revive(q),J,Q),void 0,Q)}registerSelectionRangeProvider(F,q,J){const Q=this.t(new pe(this.h,J,this.l),F);return this.e.$registerSelectionRangeProvider(Q,this.o(q,F)),this.p(Q)}$provideSelectionRanges(F,q,J,Q){return this.s(F,pe,H=>H.provideSelectionRanges(y.URI.revive(q),J,Q),[],Q)}registerCallHierarchyProvider(F,q,J){const Q=this.t(new De(this.h,J),F);return this.e.$registerCallHierarchyProvider(Q,this.o(q,F)),this.p(Q)}$prepareCallHierarchy(F,q,J,Q){return this.s(F,De,H=>Promise.resolve(H.prepareSession(y.URI.revive(q),J,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(F,q,J,Q){return this.s(F,De,H=>H.provideCallsTo(q,J,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(F,q,J,Q){return this.s(F,De,H=>H.provideCallsFrom(q,J,Q),void 0,Q)}$releaseCallHierarchy(F,q){this.s(F,De,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(F,q,J){const Q=this.t(new ne(this.h,J),F);return this.e.$registerTypeHierarchyProvider(Q,this.o(q,F)),this.p(Q)}$prepareTypeHierarchy(F,q,J,Q){return this.s(F,ne,H=>Promise.resolve(H.prepareSession(y.URI.revive(q),J,Q)),void 0,Q)}$provideTypeHierarchySupertypes(F,q,J,Q){return this.s(F,ne,H=>H.provideSupertypes(q,J,Q),void 0,Q)}$provideTypeHierarchySubtypes(F,q,J,Q){return this.s(F,ne,H=>H.provideSubtypes(q,J,Q),void 0,Q)}$releaseTypeHierarchy(F,q){this.s(F,ne,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(F,q,J,Q){const H=this.q();this.f.set(H,new oe(new le(this.e,this.h,J,H,F),F));const x=(0,r.$_E)(F,"dropMetadata")&&Q?le.toInternalProviderId(F.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(H,this.o(q,F),x,(0,r.$_E)(F,"dropMetadata")?Q:void 0),this.p(H)}$provideDocumentOnDropEdits(F,q,J,Q,H,x){return this.s(F,le,ae=>Promise.resolve(ae.provideDocumentOnDropEdits(q,y.URI.revive(J),Q,H,x)),void 0,void 0)}registerMappedEditsProvider(F,q,J){const Q=this.t(new re(this.h,J),F);return this.e.$registerMappedEditsProvider(Q,this.o(q,F)),this.p(Q)}$provideMappedEdits(F,q,J,Q,H){return this.s(F,re,x=>Promise.resolve(x.provideMappedEdits(q,J,Q,H)),null,H)}registerDocumentPasteEditProvider(F,q,J,Q){const H=this.q();this.f.set(H,new oe(new O(this.e,this.h,J,H,F),F));const x=O.toInternalProviderId(F.identifier.value,Q.id);return this.e.$registerPasteEditProvider(H,this.o(q,F),x,{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(H)}$prepareDocumentPaste(F,q,J,Q,H){return this.s(F,O,x=>x.prepareDocumentPaste(y.URI.revive(q),J,Q,H),void 0,H)}$providePasteEdits(F,q,J,Q,H,x){return this.s(F,O,ae=>ae.providePasteEdits(q,y.URI.revive(J),Q,H,x),void 0,x)}static w(F){return{pattern:F.source,flags:F.flags}}static y(F){return{decreaseIndentPattern:de.w(F.decreaseIndentPattern),increaseIndentPattern:de.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?de.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?de.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:de.w(F.beforeText),afterText:F.afterText?de.w(F.afterText):void 0,previousLineText:F.previousLineText?de.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(de.z)}static C(F){return{open:F.open,close:F.close,notIn:F.notIn?F.notIn.map(q=>L.SyntaxTokenType.toString(q)):void 0}}static D(F){return F.map(de.C)}setLanguageConfiguration(F,q,J){const{wordPattern:Q}=J;if(Q&&(0,k.$Ne)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(q,Q):this.h.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use.");const H=this.q(),x={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?de.w(J.wordPattern):void 0,indentationRules:J.indentationRules?de.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?de.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?de.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(H,q,x),this.p(H)}$setWordDefinitions(F){for(const q of F)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Sbc=de}),define(Re[240],Me([1,0,3,8,7,29,12,6,25]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=void 0;class f{constructor(D,c,p,$){this.c=c,this.d=p,this.e=$,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(y.$aK.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,c){await this.a.$changeLanguage(D,c);const p=this.c.getDocumentData(D);if(!p)throw new Error(`document '${D.toString()}' NOT found`);return p.document}async tokenAtPosition(D,c){const p=D.version,$=M.Position.from(c),m=await this.a.$tokensAtPosition(D.uri,$),t={type:C.StandardTokenType.Other,range:D.getWordRangeAtPosition(c)??new C.$eK(c.line,c.character,c.line,c.character)};if(!m)return t;const i={range:M.Range.to(m.range),type:M.TokenType.to(m.type)};return!i.range.contains(c)||p!==D.version?t:i}createLanguageStatusItem(D,c,p){const $=this.f++,m=this.a,t=this.g,i=`${D.identifier.value}/${c}`;if(t.has(i))throw new Error(`LanguageStatusItem with id '${c}' ALREADY exists`);t.add(i);const a={selector:p,id:c,name:D.displayName??D.name,severity:C.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let b;const E=new l.$Qc,v=()=>{if(b?.dispose(),!t.has(i)){console.warn(`LanguageStatusItem (${c}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}b=(0,A.$Ug)(()=>{E.clear(),this.a.$setLanguageStatus($,{id:i,name:a.name??D.displayName??D.name,source:D.displayName??D.name,selector:M.DocumentSelector.from(a.selector,this.e),label:a.text,detail:a.detail??"",severity:a.severity===C.LanguageStatusSeverity.Error?L.default.Error:a.severity===C.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:a.command&&this.d.toInternal(a.command,E),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},r={dispose(){E.dispose(),b?.dispose(),m.$removeLanguageStatus($),t.delete(i)},get id(){return a.id},get name(){return a.name},set name(s){a.name=s,v()},get selector(){return a.selector},set selector(s){a.selector=s,v()},get text(){return a.text},set text(s){a.text=s,v()},set text2(s){(0,k.$aF)(D,"languageStatusText"),a.text=s,v()},get text2(){return(0,k.$aF)(D,"languageStatusText"),a.text},get detail(){return a.detail},set detail(s){a.detail=s,v()},get severity(){return a.severity},set severity(s){a.severity=s,v()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(s){a.accessibilityInformation=s,v()},get command(){return a.command},set command(s){a.command=s,v()},get busy(){return a.busy},set busy(s){a.busy=s,v()}};return v(),r}}e.$Acc=f}),define(Re[81],Me([1,0,22,15,2,4,14,3,27,17]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=e.$pcc=void 0;let R=class{constructor(c,p,$){this.f=$,this.d=new Map,this.a=p.getProxy(l.$aK.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===y.$g}getMessage(c,p){const{message:$,args:m,comment:t}=p;if(this.c)return(0,M.$Ce)($,m??{});let i=$;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const a=this.d.get(c)?.contents[i];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,M.$Ce)(a??$,m??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let p;const $=await this.g(c);if(!$){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const m=await this.a.$fetchBundleContents($),t=JSON.parse(m);p=c.isBuiltin?t.contents?.bundle:t}catch(m){this.f.error(`Failed to load translations for ${c.identifier.value} from ${$}: ${m.message}`);return}p&&this.d.set(c.identifier.value,{contents:p,uri:$})}async g(c){if(c.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return C.URI.revive(p)}return c.l10n?C.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$pcc=R,e.$pcc=R=qe([We(0,k.$rM),We(1,f.$bM),We(2,A.$8i)],R),e.$qcc=(0,L.$Nh)("IExtHostLocalizationService")}),define(Re[241],Me([1,0,14,3,27,17,2,67]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qdc=void 0;let k=class extends y.$gj{constructor(D,c){super(c.logLevel,c.logsLocation,c.loggers.map(p=>(0,l.$kh)(p))),this.r=D.getProxy(M.$aK.MainThreadLogger)}$setLogLevel(D,c){c?this.setLogLevel(A.URI.revive(c),D):this.setLogLevel(D)}setVisibility(D,c){super.setVisibility(D,c),this.r.$setVisibility(D,c)}s(D,c,p){return new f(this.r,D,c,p)}};e.$Qdc=k,e.$Qdc=k=qe([We(0,L.$bM),We(1,C.$rM)],k);class f extends y.$bj{constructor(D,c,p,$){super($?.logLevel==="always"),this.r=D,this.s=c,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(c,$).then(()=>{this.u(this.n),this.m=!0})}g(D,c){const p=[[D,c]];this.m?this.u(p):this.n.push(...p)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Re[82],Me([1,0,3,4,6,17,26]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=e.$rcc=void 0,e.$rcc=(0,M.$Nh)("IExtHostManagedSockets");let l=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(y.$aK.MainThreadManagedSockets)}setFactory(D,c){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(D,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const c=++this.b,p=await this.c.makeConnection(),$=new C.$Qc;return this.d.set(c,new f(c,p,$)),$.add((0,C.$Pc)(()=>this.d.delete(c))),$.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),$.dispose()})),$.add(p.onDidClose(m=>{this.a.$onDidManagedSocketClose(c,m?.stack??m?.message),$.dispose()})),$.add(p.onDidReceiveMessage(m=>this.a.$onDidManagedSocketHaveData(c,A.$ae.wrap(m)))),c}$remoteSocketWrite(D,c){this.d.get(D)?.actual.send(c.buffer)}$remoteSocketEnd(D){const c=this.d.get(D);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$scc=l,e.$scc=l=qe([We(0,L.$bM)],l);class k{constructor(D,c){this.socketFactoryId=D,this.makeConnection=c}}class f extends C.$Rc{constructor(D,c,p){super(),this.socketId=D,this.actual=c,this.B(p)}}}),define(Re[242],Me([1,0,3,14,25]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0;function L(l){return l&&l.title}let A=class{constructor(k,f){this.b=f,this.a=k.getProxy(y.$aK.MainThreadMessageService)}showMessage(k,f,R,D,c){const p={source:{identifier:k.identifier,label:k.displayName||k.name}};let $;typeof D=="string"||L(D)?$=[D,...c]:(p.modal=D?.modal,p.useCustom=D?.useCustom,p.detail=D?.detail,$=c),p.useCustom&&(0,C.$aF)(k,"resolvers");const m=[];for(let t=0;t<$.length;t++){const i=$[t];if(typeof i=="string")m.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:a,isCloseAffordance:b}=i;m.push({title:a,isCloseAffordance:!!b,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,R,p,m).then(t=>{if(typeof t=="number")return $[t]})}};e.$Bcc=A,e.$Bcc=A=qe([We(1,M.$8i)],A)}),define(Re[243],Me([1,0,151,26,5,6,28,15,16,2,38,74,3,31,8,7,47,204,103,9,24,13]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,o,w,d,I){this.q=w,this.r=d,this.s=I,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new C.$Md({onListenerError:b.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new C.$Md({onListenerError:b.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new C.$Md({onListenerError:b.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new C.$Md({onListenerError:b.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Jbc("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(c.$aK.MainThreadNotebook),this.c=n.getProxy(c.$aK.MainThreadNotebookDocuments),this.d=n.getProxy(c.$aK.MainThreadNotebookEditors),this.i=o.converter,o.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===13){const u=S.notebookEditor?.notebookUri,g=S.cell.handle,P=this.g.get(u)?.getCell(g);if(P)return P.apiCell}if(S&&S.$mid===14){const u=S.uri,g=this.g.get(u);if(g)return g.apiNotebook}return S}}),r.A(o)}getEditorById(n){const o=this.h.get(n);if(!o)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return o}getIdByEditor(n){for(const[o,w]of this.h)if(w.apiEditor===n)return o}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,o){const w=this.g.get(n);if(!w&&!o)throw new Error(`NO notebook document for '${n}'`);return w}static t(n,o){if(!o)return;const w=o.filenamePattern.map(d=>$.NotebookExclusiveDocumentPattern.from(d)).filter(d=>d!==void 0);if(o.filenamePattern&&!w){console.warn(`Notebook content provider view options file name pattern is invalid ${o.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:o.displayName,filenamePattern:w,exclusive:o.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,o,w){const d=r.a++,I=typeof w.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(d,w),this.b.$registerNotebookCellStatusBarItemProvider(d,I,o);let S;return I!==void 0&&(S=w.onDidChangeCellStatusBarItems(u=>this.b.$emitCellStatusBarEvent(I))),new m.$cK(()=>{this.f.delete(d),this.b.$unregisterNotebookCellStatusBarItemProvider(d,I),S?.dispose()})}async createNotebookDocument(n){const o=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&$.NotebookData.from(n.content)});return f.URI.revive(o)}async openNotebookDocument(n){const o=this.g.get(n);if(o)return o.apiNotebook;const w=await this.c.$tryOpenNotebook(n),d=this.g.get(f.URI.revive(w));return(0,k.$If)(d?.apiNotebook)}async showNotebookDocument(n,o){f.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let w;typeof o=="object"?w={position:$.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus,selections:o.selections&&o.selections.map($.NotebookRange.from),pinned:typeof o.preview=="boolean"?!o.preview:void 0}:w={preserveFocus:!1};const d=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,w),I=d&&this.h.get(d)?.apiEditor;if(I)return I;throw d?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,o,w,d){const I=this.f.get(n),S=f.URI.revive(o),u=this.g.get(S);if(!u||!I)return;const g=u.getCellFromIndex(w);if(!g)return;const h=await I.provideCellStatusBarItems(g.apiCell,d);if(!h)return;const P=new L.$Qc,W=this.p.add([P]),j=(Array.isArray(h)?h:[h]).map(B=>$.NotebookStatusBarItem.from(B,this.i,P));return{cacheId:W,items:j}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,o,w,d,I){if((0,l.$Ae)(o))throw new Error("viewType cannot be empty or just whitespace");const S=this.u++;return this.w.set(S,{viewType:o,serializer:w,options:d}),this.b.$registerNotebookSerializer(S,{id:n.identifier,location:n.extensionLocation},o,$.NotebookDocumentContentOptions.from(d),r.t(n,I)),(0,L.$Pc)(()=>{this.b.$unregisterNotebookSerializer(S)})}async $dataToNotebook(n,o,w){const d=this.w.get(n);if(!d)throw new Error("NO serializer found");const I=await d.serializer.deserializeNotebook(o.buffer,w);return new t.$lv($.NotebookData.from(I))}async $notebookToData(n,o,w){const d=this.w.get(n);if(!d)throw new Error("NO serializer found");const I=await d.serializer.serializeNotebook($.NotebookData.to(o.value),w);return M.$ae.wrap(I)}async $saveNotebook(n,o,w,d,I){const S=f.URI.revive(o),u=this.w.get(n);if(!u)throw new Error("NO serializer found");const g=this.g.get(S);if(!g)throw new Error("Document NOT found");if(g.versionId!==w)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(S.scheme))throw new R.$rk((0,y.localize)(0,null,this.y(S)),6);await this.x(S,d);const h={metadata:(0,E.$$m)(g.apiNotebook.metadata,B=>!(u.options?.transientDocumentMetadata??{})[B]),cells:[]};for(const B of g.apiNotebook.getCells()){const O=new m.$AL(B.kind,B.document.getText(),B.document.languageId,B.mime,u.options?.transientOutputs?[]:[...B.outputs],B.metadata,B.executionSummary);O.metadata=(0,E.$$m)(B.metadata,N=>!(u.options?.transientCellMetadata??{})[N]),h.cells.push(O)}const P=await u.serializer.serializeNotebook(h,I);await this.s.value.writeFile(S,P);const W=this.s.getFileSystemProviderExtUri(S.scheme),K=await this.s.value.stat(S);return{name:W.basename(S),isFile:(K.type&R.FileType.File)!==0,isDirectory:(K.type&R.FileType.Directory)!==0,isSymbolicLink:(K.type&R.FileType.SymbolicLink)!==0,mtime:K.mtime,ctime:K.ctime,size:K.size,readonly:!!((K.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(S.scheme),locked:!!((K.permissions??0)&R.FilePermission.Locked),etag:R.$Ck({mtime:K.mtime,size:K.size}),children:void 0}}async x(n,o){const w=await this.s.value.stat(n);if(typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==R.$Bk&&typeof w.mtime=="number"&&typeof w.size=="number"&&o.mtime<w.mtime&&o.etag!==R.$Ck({mtime:o.mtime,size:w.size}))throw new R.$rk((0,y.localize)(1,null),3,o)}y(n){return n.scheme===v.Schemas.file?n.fsPath:n.toString()}z(n,o,w){if(this.h.has(o))throw new Error(`editor with id ALREADY EXSIST: ${o}`);const d=new a.$idc(o,this.d,n,w.visibleRanges.map($.NotebookRange.to),w.selections.map($.NotebookRange.to),typeof w.viewColumn=="number"?$.ViewColumn.to(w.viewColumn):void 0);this.h.set(o,d)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const w of n.value.removedDocuments){const d=f.URI.revive(w),I=this.g.get(d);I&&(I.dispose(),this.g.delete(d),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:I.apiNotebook.getCells().map(S=>S.document.uri)}),this.n.fire(I.apiNotebook));for(const S of this.h.values())S.notebookData.uri.toString()===d.toString()&&this.h.delete(S.id)}if(n.value.addedDocuments){const w=[];for(const d of n.value.addedDocuments){const I=f.URI.revive(d.uri);if(this.g.has(I))throw new Error(`adding EXISTING notebook ${I} `);const S=new i.$hdc(this.c,this.q,this.r,I,d);w.push(...d.cells.map(u=>i.$gdc.asModelAddData(S.apiNotebook,u))),this.g.get(I)?.dispose(),this.g.set(I,S),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:w}),this.m.fire(S.apiNotebook)}}if(n.value.addedEditors)for(const w of n.value.addedEditors){if(this.h.has(w.id))return;const d=f.URI.revive(w.documentUri),I=this.g.get(d);I&&this.z(I,w.id,w)}const o=[];if(n.value.removedEditors)for(const w of n.value.removedEditors){const d=this.h.get(w);d&&(this.h.delete(w),this.k?.id===d.id&&(this.k=void 0),o.push(d))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(d=>this.h.get(d)).filter(d=>!!d);const w=new Set;this.l.forEach(d=>w.add(d.id));for(const d of this.h.values()){const I=w.has(d.id);d._acceptVisibility(I)}this.l=[...this.h.values()].map(d=>d).filter(d=>d.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const o=p.$zM.String.with("notebookType","A notebook type"),w=new p.$BM("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[o,new p.$zM("data","Bytes to convert to data",I=>I instanceof Uint8Array,I=>M.$ae.wrap(I))],new p.$AM("Notebook Data",I=>$.NotebookData.to(I.value))),d=new p.$BM("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[o,new p.$zM("NotebookData","Notebook data to convert to bytes",I=>!0,I=>new t.$lv($.NotebookData.from(I)))],new p.$AM("Bytes",I=>I.buffer));n.registerApiCommand(w),n.registerApiCommand(d)}}e.$jdc=r}),define(Re[244],Me([1,0,18,12,21,5,6,28,2,20,14,3,31,8,7,77,197,25,47]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=e.$xdc=void 0;let b=class{constructor(d,I,S,u,g){this.l=I,this.m=S,this.n=u,this.o=g,this.b=new l.$zc,this.c=new l.$zc,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new Map,this.j=0,this.k=new L.$Md,this.onDidChangeNotebookCellExecutionState=this.k.event,this.a=d.getProxy(D.$aK.MainThreadNotebookKernels);const h=new c.$BM("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.$zM("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const W=this.m.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:W}}else if(P&&"notebookEditor"in P){const W=this.m.getIdByEditor(P.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return P})],c.$AM.Void);this.n.registerApiCommand(h)}createNotebookController(d,I,S,u,g,h){for(const me of this.i.values())if(me.controller.id===I&&f.$3l.equals(d.identifier,me.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const P=this.j++,W=this;this.o.trace(`NotebookController[${P}], CREATED by ${d.identifier.value}, ${I}`);const K=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${d.identifier}'`);let j=!1;const B=new L.$Md,O=new L.$Md,N={id:o(d.identifier,I),notebookType:S,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:u||d.identifier.value,preloads:h?h.map(p.NotebookRendererScript.from):[]};let te=g??K,Y;this.a.$addKernel(P,N).catch(me=>{console.log(me),j=!0});let Ee=0;const Se=()=>{if(j)return;const me=++Ee;Promise.resolve().then(()=>{me===Ee&&this.a.$updateKernel(P,N)})},Pe=new l.$zc,ge={get id(){return I},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:B.event,get label(){return N.label},set label(me){N.label=me??d.displayName??d.name,Se()},get detail(){return N.detail??""},set detail(me){N.detail=me,Se()},get description(){return N.description??""},set description(me){N.description=me,Se()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(me){N.supportedLanguages=me,Se()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(me){N.supportsExecutionOrder=me,Se()},get rendererScripts(){return N.preloads?N.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return te},set executeHandler(me){te=me??K},get interruptHandler(){return Y},set interruptHandler(me){Y=me,N.supportsInterrupt=!!me,Se()},createNotebookCellExecution(me){if(j)throw new Error("notebook controller is DISPOSED");if(!Pe.has(me.notebook.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.notebook.uri.toString()}`);return W._createNotebookCellExecution(me,o(d.identifier,this.id))},createNotebookExecution(me){if((0,i.$aF)(d,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!Pe.has(me.uri))throw W.o.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Pe.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${me.uri.toString()}`);return W._createNotebookExecution(me,o(d.identifier,this.id))},dispose:()=>{j||(this.o.trace(`NotebookController[${P}], DISPOSED`),j=!0,this.i.delete(P),B.dispose(),O.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(me,ce){ce===$.NotebookControllerAffinity2.Hidden&&(0,i.$aF)(d,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(P,me.uri,ce)},onDidReceiveMessage:O.event,postMessage(me,ce){return(0,i.$aF)(d,"notebookMessaging"),W.a.$postMessage(P,ce&&W.m.getIdByEditor(ce),me)},asWebviewUri(me){return(0,i.$aF)(d,"notebookMessaging"),(0,m.$1ob)(me,W.l.remote)}};return this.i.set(P,{extensionId:d.identifier,controller:ge,onDidReceiveMessage:O,onDidChangeSelection:B,associatedNotebooks:Pe}),ge}getIdByController(d){for(const[I,S]of this.i)if(S.controller===d)return o(S.extensionId,d.id);return null}createNotebookControllerDetectionTask(d,I){const S=this.f++,u=this;this.o.trace(`NotebookControllerDetectionTask[${S}], CREATED by ${d.identifier.value}`),this.a.$addKernelDetectionTask(S,I);const g={dispose:()=>{this.e.delete(S),u.a.$removeKernelDetectionTask(S)}};return this.e.set(S,g),g}registerKernelSourceActionProvider(d,I,S){const u=this.h++,g=typeof S.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,h=this;this.g.set(u,S),this.o.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${d.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,I);let P;return g!==void 0&&(P=S.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(g))),{dispose:()=>{this.g.delete(u),h.a.$removeKernelSourceActionProvider(u,u),P?.dispose()}}}async $provideKernelSourceActions(d,I){const S=this.g.get(d);if(S){const u=new A.$Qc;return(await S.provideNotebookKernelSourceActions(I)??[]).map(h=>p.NotebookKernelSourceAction.from(h,this.n.converter,u))}return[]}$acceptNotebookAssociation(d,I,S){const u=this.i.get(d);if(u){const g=this.m.getNotebookDocument(k.URI.revive(I));S?u.associatedNotebooks.set(g.uri,!0):u.associatedNotebooks.delete(g.uri),this.o.trace(`NotebookController[${d}] ASSOCIATE notebook`,g.uri.toString(),S),u.onDidChangeSelection.fire({selected:S,notebook:g.apiNotebook})}}async $executeCells(d,I,S){const u=this.i.get(d);if(!u)return;const g=this.m.getNotebookDocument(k.URI.revive(I)),h=[];for(const P of S){const W=g.getCell(P);W&&h.push(W.apiCell)}try{this.o.trace(`NotebookController[${d}] EXECUTE cells`,g.uri.toString(),h.length),await u.controller.executeHandler.call(u.controller,h,g.apiNotebook,u.controller)}catch(P){this.o.error(`NotebookController[${d}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(d,I,S){const u=this.i.get(d);if(!u)return;const g=this.m.getNotebookDocument(k.URI.revive(I));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,g.apiNotebook);else for(const h of S){const P=g.getCell(h);P&&this.b.get(P.uri)?.cancel()}if(u.controller.interruptHandler){const h=this.c.get(g.uri);S.length&&Array.isArray(h)&&h.length&&h.forEach(P=>P.dispose())}}$acceptKernelMessageFromRenderer(d,I,S){const u=this.i.get(d);if(!u)return;const g=this.m.getEditorById(I);u.onDidReceiveMessage.fire(Object.freeze({editor:g.apiEditor,message:S}))}$cellExecutionChanged(d,I,S){const g=this.m.getNotebookDocument(k.URI.revive(d)).getCell(I);if(g){const h=S?p.NotebookCellExecutionState.to(S):$.NotebookCellExecutionState.Idle;h!==void 0&&this.k.fire({cell:g.apiCell,state:h})}}_createNotebookCellExecution(d,I){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.m.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const g=new v(I,u,this.a);this.b.set(u.uri,g);const h=g.onDidChangeState(()=>{g.state===E.Resolved&&(g.dispose(),h.dispose(),this.b.delete(u.uri))});return g.asApiObject()}_createNotebookExecution(d,I){const S=this.m.getNotebookDocument(d.uri),u=d.getCells().find(P=>{const W=S.getCellFromApiCell(P);return W&&this.b.has(W.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(S.uri))throw new Error(`duplicate notebook execution for ${S.uri}`);const g=new s(I,S,this.a),h=g.onDidChangeState(()=>{g.state===r.Resolved&&(g.dispose(),h.dispose(),this.c.delete(S.uri))});return this.c.set(S.uri,[g,h]),g.asApiObject()}};e.$xdc=b,e.$xdc=b=qe([We(4,R.$8i)],b);var E;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(E||(E={}));class v extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.m=I,this.n=S,this.b=v.a++,this.c=new L.$Md,this.onDidChangeState=this.c.event,this.f=E.Init,this.g=this.B(new C.$Wd),this.h=new n(10,u=>this.s(u)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,d,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(d){await this.h.addItem(d)}async s(d){const I=Array.isArray(d)?d:[d];return this.n.$updateExecution(this.b,new a.$lv(I))}t(){if(this.f===E.Init)throw new Error("Must call start before modifying cell output");if(this.f===E.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(d){let I=this.m;if(d&&(I=this.m.notebook.getCellFromApiCell(d)),!I)throw new Error("INVALID cell");return I.handle}y(d){return d.map(I=>{const S=$.$DL.ensureUniqueMimeTypes(I.items,!0);return S===I.items?p.NotebookCellOutput.from(I):p.NotebookCellOutput.from({items:S,id:I.id,metadata:I.metadata})})}async z(d,I,S){const u=this.w(I),g=this.y((0,y.$2b)(d));return this.r({editType:t.CellExecutionUpdateType.Output,cellHandle:u,append:S,outputs:g})}async C(d,I,S){return d=$.$DL.ensureUniqueMimeTypes((0,y.$2b)(d),!0),this.r({editType:t.CellExecutionUpdateType.OutputItems,items:d.map(p.NotebookCellOutputItem.from),outputId:I.id,append:S})}asApiObject(){const d=this;return Object.freeze({get token(){return d.g.token},get cell(){return d.m.apiCell},get executionOrder(){return d.j},set executionOrder(S){d.j=S,d.s([{editType:t.CellExecutionUpdateType.ExecutionState,executionOrder:d.j}])},start(S){if(d.f===E.Resolved||d.f===E.Started)throw new Error("Cannot call start again");d.f=E.Started,d.c.fire(),d.s({editType:t.CellExecutionUpdateType.ExecutionState,runStartTime:S})},end(S,u){if(d.f===E.Resolved)throw new Error("Cannot call resolve twice");d.f=E.Resolved,d.c.fire(),d.h.flush(),d.n.$completeExecution(d.b,new a.$lv({runEndTime:u,lastRunSuccess:S}))},clearOutput(S){return d.t(),d.z([],S,!1)},appendOutput(S,u){return d.t(),d.z(S,u,!0)},replaceOutput(S,u){return d.t(),d.z(S,u,!1)},appendOutputItems(S,u){return d.t(),d.C(S,u,!0)},replaceOutputItems(S,u){return d.t(),d.C(S,u,!1)}})}}var r;(function(w){w[w.Init=0]="Init",w[w.Started=1]="Started",w[w.Resolved=2]="Resolved"})(r||(r={}));class s extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(d,I,S){super(),this.h=I,this.j=S,this.b=s.a++,this.c=new L.$Md,this.onDidChangeState=this.c.event,this.f=r.Init,this.g=this.B(new C.$Wd),this.j.$createNotebookExecution(this.b,d,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===r.Resolved||this.f===r.Started)throw new Error("Cannot call start again");this.f=r.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===r.Resolved)throw new Error("Cannot call resolve twice");this.f=r.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class n{constructor(d,I){this.e=d,this.f=I,this.a=[],this.b=Date.now()}addItem(d){return this.a.push(d),this.c||(this.c=new M.$bh,this.b=Date.now(),(0,M.$Tg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const d=this.c;this.c=void 0;const I=this.a;return this.a=[],this.f(I).finally(()=>d.complete())}}function o(w,d){return`${w.value}/${d}`}e.$ydc=o}),define(Re[245],Me([1,0,5,3,103]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zdc=void 0;class L{constructor(l,k){this.c=k,this.a=new Map,this.b=l.getProxy(M.$aK.MainThreadNotebookRenderers)}$postRendererMessage(l,k,f){const R=this.c.getEditorById(l);this.a.get(k)?.fire({editor:R.apiEditor,message:f})}createRendererMessaging(l,k){if(!l.contributes?.notebookRenderer?.some(R=>R.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(R,D,c)=>this.d(k).event(R,D,c),postMessage:(R,D)=>{C.$idc.apiEditorsToExtHost.has(R)&&([R,D]=[D,R]);const c=D&&C.$idc.apiEditorsToExtHost.get(D);return this.b.$postMessage(c?.id,k,R)}}}d(l){let k=this.a.get(l);return k||(k=new y.$Md({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(l)}}),this.a.set(l,k),k)}}e.$zdc=L}),define(Re[246],Me([1,0,6,16,2,25,3]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=void 0;class l{constructor(f){this.b=new Map,this.a=f.getProxy(A.$aK.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,R,D){if((0,L.$aF)(f,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,D),this.a.$registerProfileContentHandler(R,D.name,D.description,f.identifier.value),(0,y.$Pc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(f,R,D,c){const p=this.b.get(f);if(!p)throw new Error(`Unknown handler with id: ${f}`);return p.saveProfile(R,D,c)}async $readProfile(f,R,D){const c=this.b.get(f);if(!c)throw new Error(`Unknown handler with id: ${f}`);return c.readProfile((0,M.$xf)(R)?R:C.URI.revive(R),D)}}e.$Ddc=l}),define(Re[247],Me([1,0,2,3,12,8]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;class A{static{this.a=0}constructor(k,f){this.d=f,this.c=new Map,this.b=k.getProxy(M.$aK.MainThreadQuickDiff)}$provideOriginalResource(k,f,R){const D=y.URI.revive(f),c=this.c.get(k);return c?(0,C.$Lg)(()=>c.provideOriginalResource(D,R)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(k,f,R,D){const c=A.a++;return this.c.set(c,f),this.b.$registerQuickDiffProvider(c,L.DocumentSelector.from(k,this.d),R,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.$Edc=A}),define(Re[248],Me([1,0,21,5,6,3,2,7,9,18,29,41,25,8]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=void 0;function $(m,t,i){const a=m.getProxy(L.$aK.MainThreadQuickOpen);class b{constructor(I,S){this.e=new Map,this.f=0,this.a=I,this.b=S}showQuickPick(I,S,u,g=y.CancellationToken.None){this.c=void 0;const h=Promise.resolve(S),P=++this.f,W=a.$show(P,{title:u?.title,placeHolder:u?.placeHolder,matchOnDescription:u?.matchOnDescription,matchOnDetail:u?.matchOnDetail,ignoreFocusLost:u?.ignoreFocusOut,canPickMany:u?.canPickMany},g),K={},j=W.then(()=>K);return Promise.race([j,h]).then(B=>{if(B===K)return;const O=(0,c.$_E)(I,"quickPickItemTooltip");return h.then(N=>{const te=[];for(let Y=0;Y<N.length;Y++){const Ee=N[Y];if(typeof Ee=="string")te.push({label:Ee,handle:Y});else if(Ee.kind===l.QuickPickItemKind.Separator)te.push({type:"separator",label:Ee.label});else{Ee.tooltip&&!O&&console.warn(`Extension '${I.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${I.identifier.value}`);const Se=Ee.iconPath?n(Ee.iconPath):void 0;te.push({label:Ee.label,iconPath:Se?.iconPath,iconClass:Se?.iconClass,description:Ee.description,detail:Ee.detail,picked:Ee.picked,alwaysShow:Ee.alwaysShow,tooltip:O?p.MarkdownString.fromStrict(Ee.tooltip):void 0,handle:Y})}}return u&&typeof u.onDidSelectItem=="function"&&(this.c=Y=>{u.onDidSelectItem(N[Y])}),a.$setItems(P,te),W.then(Y=>{if(typeof Y=="number")return N[Y];if(Array.isArray(Y))return Y.map(Ee=>N[Ee])})})}).then(void 0,B=>{if(!(0,k.$3)(B))return a.$setError(P,B),Promise.reject(B)})}$onItemSelected(I){this.c?.(I)}showInput(I,S=y.CancellationToken.None){return this.d=I?.validateInput,a.$input(I,typeof this.d=="function",S).then(void 0,u=>{if(!(0,k.$3)(u))return Promise.reject(u)})}async $validateInput(I){if(!this.d)return;const S=await this.d(I);if(!S||typeof S=="string")return S;let u;switch(S.severity){case l.InputBoxValidationSeverity.Info:u=R.default.Info;break;case l.InputBoxValidationSeverity.Warning:u=R.default.Warning;break;case l.InputBoxValidationSeverity.Error:u=R.default.Error;break;default:u=S.message?R.default.Error:R.default.Ignore;break}return{content:S.message,severity:u}}async showWorkspaceFolderPick(I,S=y.CancellationToken.None){const u=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[I]);if(!u)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(h=>h.uri.toString()===u.uri.toString())}createQuickPick(I){const S=new o(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}createInputBox(I){const S=new w(I,()=>this.e.delete(S._id));return this.e.set(S._id,S),S}$onDidChangeValue(I,S){this.e.get(I)?._fireDidChangeValue(S)}$onDidAccept(I){this.e.get(I)?._fireDidAccept()}$onDidChangeActive(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeActive(S)}$onDidChangeSelection(I,S){const u=this.e.get(I);u instanceof o&&u._fireDidChangeSelection(S)}$onDidTriggerButton(I,S){this.e.get(I)?._fireDidTriggerButton(S)}$onDidTriggerItemButton(I,S,u){const g=this.e.get(I);g instanceof o&&g._fireDidTriggerItemButton(S,u)}$onDidHide(I){this.e.get(I)?._fireDidHide()}}class E{static{this.a=1}constructor(I,S){this.x=I,this.y=S,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Md,this.q=new M.$Md,this.r=new M.$Md,this.s=new M.$Md,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(I){this.b=I,this.z({title:I})}get step(){return this.c}set step(I){this.c=I,this.z({step:I})}get totalSteps(){return this.d}set totalSteps(I){this.d=I,this.z({totalSteps:I})}get enabled(){return this.g}set enabled(I){this.g=I,this.z({enabled:I})}get busy(){return this.j}set busy(I){this.j=I,this.z({busy:I})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(I){this.k=I,this.z({ignoreFocusOut:I})}get value(){return this.l}set value(I){this.l=I,this.z({value:I})}get placeholder(){return this.m}set placeholder(I){this.m=I,this.z({placeholder:I})}get buttons(){return this.n}set buttons(I){this.n=I.slice(),this.o.clear(),I.forEach((S,u)=>{const g=S===l.$wL.Back?-1:u;this.o.set(g,S)}),this.z({buttons:I.map((S,u)=>({...n(S.iconPath),tooltip:S.tooltip,handle:S===l.$wL.Back?-1:u}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(I){this.l=I,this.q.fire(I)}_fireDidTriggerButton(I){const S=this.o.get(I);S&&this.r.fire(S)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,C.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(I){if(!this.v){for(const S of Object.keys(I)){const u=I[S];this.u[S]=u===void 0?null:u}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function v(d){if(d instanceof l.$9K)return{id:d.id};const I=s(d),S=r(d);return{dark:typeof I=="string"?A.URI.file(I):I,light:typeof S=="string"?A.URI.file(S):S}}function r(d){return typeof d=="object"&&"light"in d?d.light:d}function s(d){return typeof d=="object"&&"dark"in d?d.dark:d}function n(d){const I=v(d);let S,u;return"id"in I?u=D.ThemeIcon.asClassName(I):S=I,{iconPath:S,iconClass:u}}class o extends E{constructor(I,S){super(I.identifier,S),this.O=I,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Md,this.L=[],this.M=new M.$Md,this.N=new M.$Md,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(I){this.B=I.slice(),this.C.clear(),this.D.clear(),I.forEach((g,h)=>{this.C.set(h,g),this.D.set(g,h)});const S=(0,c.$_E)(this.O,"quickPickItemTooltip"),u=[];for(let g=0;g<I.length;g++){const h=I[g];if(h.kind===l.QuickPickItemKind.Separator)u.push({type:"separator",label:h.label});else{h.tooltip&&!S&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=h.iconPath?n(h.iconPath):void 0;u.push({handle:g,label:h.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:h.description,detail:h.detail,picked:h.picked,alwaysShow:h.alwaysShow,tooltip:S?p.MarkdownString.fromStrict(h.tooltip):void 0,buttons:h.buttons?.map((W,K)=>({...n(W.iconPath),tooltip:W.tooltip,handle:K}))})}}this.z({items:u})}get canSelectMany(){return this.E}set canSelectMany(I){this.E=I,this.z({canSelectMany:I})}get matchOnDescription(){return this.F}set matchOnDescription(I){this.F=I,this.z({matchOnDescription:I})}get matchOnDetail(){return this.G}set matchOnDetail(I){this.G=I,this.z({matchOnDetail:I})}get sortByLabel(){return this.H}set sortByLabel(I){this.H=I,this.z({sortByLabel:I})}get keepScrollPosition(){return this.I}set keepScrollPosition(I){this.I=I,this.z({keepScrollPosition:I})}get activeItems(){return this.J}set activeItems(I){this.J=I.filter(S=>this.D.has(S)),this.z({activeItems:this.J.map(S=>this.D.get(S))})}get selectedItems(){return this.L}set selectedItems(I){this.L=I.filter(S=>this.D.has(S)),this.z({selectedItems:this.L.map(S=>this.D.get(S))})}_fireDidChangeActive(I){const S=(0,f.$Gb)(I.map(u=>this.C.get(u)));this.J=S,this.K.fire(S)}_fireDidChangeSelection(I){const S=(0,f.$Gb)(I.map(u=>this.C.get(u)));this.L=S,this.M.fire(S)}_fireDidTriggerItemButton(I,S){const u=this.C.get(I);if(!u||!u.buttons||!u.buttons.length)return;const g=u.buttons[S];g&&this.N.fire({button:g,item:u})}}class w extends E{constructor(I,S){super(I.identifier,S),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(I){this.B=I,this.z({password:I})}get prompt(){return this.C}set prompt(I){this.C=I,this.z({prompt:I})}get valueSelection(){return this.D}set valueSelection(I){this.D=I,this.z({valueSelection:I})}get validationMessage(){return this.E}set validationMessage(I){this.E=I,I?typeof I=="string"?this.z({validationMessage:I,severity:R.default.Error}):this.z({validationMessage:I.message,severity:I.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new b(t,i)}e.$Fcc=$}),define(Re[249],Me([1,0,2,5,64,6,12,3,18,131,14,20,41,8,25,13]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;function i(g){if(g)return typeof g.iconPath=="string"?y.URI.file(g.iconPath):y.URI.isUri(g.iconPath)||c.ThemeIcon.isThemeIcon(g.iconPath)?g.iconPath:void 0}function a(g){if(g.icon){if(y.URI.isUri(g.icon))return g.icon;if(c.ThemeIcon.isThemeIcon(g.icon))return g.icon;{const h=g.icon;return{light:h.light,dark:h.dark}}}else return}function b(g,h){if(!g.iconPath&&!h.iconPath)return 0;if(g.iconPath){if(!h.iconPath)return 1}else return-1;const P=typeof g.iconPath=="string"?g.iconPath:y.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id,W=typeof h.iconPath=="string"?h.iconPath:y.URI.isUri(h.iconPath)?h.iconPath.fsPath:h.iconPath.id;return(0,f.$oq)(P,W)}function E(g,h){let P=0;if(g.strikeThrough!==h.strikeThrough)return g.strikeThrough?1:-1;if(g.faded!==h.faded)return g.faded?1:-1;if(g.tooltip!==h.tooltip)return(g.tooltip||"").localeCompare(h.tooltip||"");if(P=b(g,h),P!==0)return P;if(g.light&&h.light)P=b(g.light,h.light);else{if(g.light)return 1;if(h.light)return-1}if(P!==0)return P;if(g.dark&&h.dark)P=b(g.dark,h.dark);else{if(g.dark)return 1;if(h.dark)return-1}return P}function v(g,h){if(g.command!==h.command)return g.command<h.command?-1:1;if(g.title!==h.title)return g.title<h.title?-1:1;if(g.tooltip!==h.tooltip){if(g.tooltip!==void 0&&h.tooltip!==void 0)return g.tooltip<h.tooltip?-1:1;if(g.tooltip!==void 0)return 1;if(h.tooltip!==void 0)return-1}if(g.arguments===h.arguments)return 0;if(g.arguments)if(h.arguments){if(g.arguments.length!==h.arguments.length)return g.arguments.length-h.arguments.length}else return 1;else return-1;for(let P=0;P<g.arguments.length;P++){const W=g.arguments[P],K=h.arguments[P];if(W!==K)return W<K?-1:1}return 0}function r(g,h){let P=(0,f.$oq)(g.resourceUri.fsPath,h.resourceUri.fsPath,!0);if(P!==0)return P;if(g.command&&h.command)P=v(g.command,h.command);else{if(g.command)return 1;if(h.command)return-1}if(P!==0)return P;if(g.decorations&&h.decorations)P=E(g.decorations,h.decorations);else{if(g.decorations)return 1;if(h.decorations)return-1}return P}function s(g,h){for(let P=0;P<g.length;P++)if(g[P]!==h[P])return!1;return!0}function n(g,h){return g.command===h.command&&g.title===h.title&&g.tooltip===h.tooltip&&(g.arguments&&h.arguments?s(g.arguments,h.arguments):g.arguments===h.arguments)}function o(g,h){return(0,k.$tb)(g,h,n)}function w(g,h){return g===h?!0:!g||!h?!1:g.id===h.id&&g.label===h.label&&g.upstream?.id===h.upstream?.id&&g.upstream?.label===h.upstream?.label}class d{#e;#t;get value(){return this.d}set value(h){h=h??"",this.#e.$setInputBoxValue(this.l,h),this.n(h)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(h){this.#e.$setInputBoxPlaceholder(this.l,h),this.f=h}get validateInput(){return(0,$.$aF)(this.k,"scmValidation"),this.g}set validateInput(h){if((0,$.$aF)(this.k,"scmValidation"),h&&typeof h!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=h,this.#e.$setValidationProviderIsEnabled(this.l,!!h)}get enabled(){return this.h}set enabled(h){h=!!h,this.h!==h&&(this.h=h,this.#e.$setInputBoxEnablement(this.l,h))}get visible(){return this.j}set visible(h){h=!!h,this.j!==h&&(this.j=h,this.#e.$setInputBoxVisibility(this.l,h))}get document(){return(0,$.$aF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(h,P,W,K,j){this.k=h,this.l=K,this.m=j,this.d="",this.e=new M.$Md,this.f="",this.h=!0,this.j=!0,this.#t=P,this.#e=W}showValidationMessage(h,P){(0,$.$aF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,h,P)}$onInputBoxValueChange(h){this.n(h)}n(h){this.d=h,this.e.fire(h)}}e.$Gcc=d;class I{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(h){this.v=h,this.q.$updateGroupLabel(this.t,this.handle,h)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(h){this.p=h,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(h){this.f=[...h],this.k.fire()}constructor(h,P,W,K,j){this.q=h,this.s=P,this.t=W,this.u=K,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Md,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Md,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=I.d++}getResourceState(h){return this.g.get(h)}$executeResourceCommand(h,P){const W=this.h.get(h);return W?(0,A.$Lg)(()=>this.s.executeCommand(W.command,...W.arguments||[],P)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const h=[...this.f].sort(r),W=(0,k.$Cb)(this.o,h,r).map(B=>{const O=B.toInsert.map(N=>{const te=this.e++;this.g.set(te,N);const Y=N.resourceUri;let Ee;if(N.command)if(N.command.command==="vscode.open"||N.command.command==="vscode.diff"){const V=new L.$Qc;Ee=this.s.converter.toInternal(N.command,V),this.j.set(te,V)}else this.h.set(te,N.command);const Se=i(N.decorations),Pe=N.decorations&&i(N.decorations.light)||Se,ge=N.decorations&&i(N.decorations.dark)||Se,me=[Pe,ge],ce=N.decorations&&N.decorations.tooltip||"",se=N.decorations&&!!N.decorations.strikeThrough,$e=N.decorations&&!!N.decorations.faded,_=N.contextValue||"";return{rawResource:[te,Y,me,ce,se,$e,_,Ee],handle:te}});return{start:B.start,deleteCount:B.deleteCount,toInsert:O}}),K=W.map(({start:B,deleteCount:O,toInsert:N})=>[B,O,N.map(te=>te.rawResource)]),j=W.reverse();for(const{start:B,deleteCount:O,toInsert:N}of j){const te=N.map(Ee=>Ee.handle),Y=this.n.splice(B,O,...te);for(const Ee of Y)this.g.delete(Ee),this.h.delete(Ee),this.j.get(Ee)?.dispose(),this.j.delete(Ee)}return this.o=h,K}dispose(){this.l=!0,this.m.fire()}}class S{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(h){this.g!==h&&(this.g=h,this.#e.$updateSourceControl(this.x,{count:h}))}get quickDiffProvider(){return this.h}set quickDiffProvider(h){this.h=h;let P;(0,$.$_E)(this.y,"quickDiffProvider")&&(P=h?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!h,quickDiffLabel:P})}get historyProvider(){return(0,$.$aF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(h){(0,$.$aF)(this.y,"scmHistoryProvider"),this.j=h,this.k.value=new L.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!h}),h&&(this.k.value.add(h.onDidChangeCurrentHistoryItemGroup(()=>{w(this.l,h?.currentHistoryItemGroup)||(this.l=h?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l))})),this.k.value.add(h.onDidChangeActionButton(()=>{(0,$.$aF)(this.y,"scmActionButton"),this.m.value=new L.$Qc;const P=h.actionButton!==void 0?{command:this.z.converter.toInternal(h.actionButton.command,this.m.value),description:h.actionButton.description,enabled:h.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,P??null)})))}get commitTemplate(){return this.n}set commitTemplate(h){h!==this.n&&(this.n=h,this.#e.$updateSourceControl(this.x,{commitTemplate:h}))}get acceptInputCommand(){return this.p}set acceptInputCommand(h){this.o.value=new L.$Qc,this.p=h;const P=this.z.converter.toInternal(h,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:P})}get actionButton(){return(0,$.$aF)(this.y,"scmActionButton"),this.s}set actionButton(h){(0,$.$aF)(this.y,"scmActionButton"),this.q.value=new L.$Qc,this.s=h;const P=h!==void 0?{command:this.z.converter.toInternal(h.command,this.q.value),secondaryCommands:h.secondaryCommands?.map(W=>W.map(K=>this.z.converter.toInternal(K,this.q.value))),description:h.description,enabled:h.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:P??null})}get statusBarCommands(){return this.u}set statusBarCommands(h){if(this.u&&h&&o(this.u,h))return;this.t.value=new L.$Qc,this.u=h;const P=(h||[]).map(W=>this.z.converter.toInternal(W,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:P})}get selected(){return this.v}constructor(h,P,W,K,j,B,O){this.y=h,this.z=K,this.A=j,this.B=B,this.C=O,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Sc,this.m=new L.$Sc,this.n=void 0,this.o=new L.$Sc,this.p=void 0,this.q=new L.$Sc,this.t=new L.$Sc,this.u=void 0,this.v=!1,this.w=new M.$Md,this.onDidChangeSelection=this.w.event,this.x=S.d++,this.D=new Map,this.E=new Set,this.#e=W;const N=y.URI.from({scheme:m.Schemas.vscodeSourceControl,path:`${j}/scm${this.x}/input`,query:O?`rootUri=${encodeURIComponent(O.toString())}`:void 0});this.f=new d(h,P,this.#e,this.x,N),this.#e.$registerSourceControl(this.x,j,B,O,N)}createResourceGroup(h,P){const W=new I(this.#e,this.z,this.x,h,P),K=M.Event.once(W.onDidDispose)(()=>this.D.delete(W));return this.D.set(W,K),this.eventuallyAddResourceGroups(),W}eventuallyAddResourceGroups(){const h=[],P=[];for(const[W,K]of this.D){K.dispose();const j=W.onDidUpdateResourceStates(()=>{this.E.add(W),this.eventuallyUpdateResourceStates()});M.Event.once(W.onDidDispose)(()=>{this.E.delete(W),j.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.x,W.handle)}),h.push([W.handle,W.id,W.label,W.features]);const B=W._takeResourceStateSnapshot();B.length>0&&P.push([W.handle,B]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.x,h,P),this.D.clear()}eventuallyUpdateResourceStates(){const h=[];this.E.forEach(P=>{const W=P._takeResourceStateSnapshot();W.length!==0&&h.push([P.handle,W])}),h.length>0&&this.#e.$spliceResourceStates(this.x,h),this.E.clear()}getResourceGroup(h){return this.e.get(h)}setSelectionState(h){this.v=h,this.w.fire(h)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(h=>h.dispose()),this.#e.$unregisterSourceControl(this.x)}}qe([(0,C.$gh)(100)],S.prototype,"eventuallyAddResourceGroups",null),qe([(0,C.$gh)(100)],S.prototype,"eventuallyUpdateResourceStates",null);let u=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(h,P,W,K){this.l=P,this.m=W,this.n=K,this.g=new Map,this.h=new D.$5l,this.j=new M.$Md,this.e=h.getProxy(l.$aK.MainThreadSCM),this.f=h.getProxy(l.$aK.MainThreadTelemetry),P.registerArgumentProcessor({processArgument:j=>{if(j&&j.$mid===3){const B=this.g.get(j.sourceControlHandle);if(!B)return j;const O=B.getResourceGroup(j.groupHandle);return O?O.getResourceState(j.handle):j}else if(j&&j.$mid===4){const B=this.g.get(j.sourceControlHandle);return B?B.getResourceGroup(j.groupHandle):j}else if(j&&j.$mid===5){const B=this.g.get(j.handle);return B||j}return j}})}createSourceControl(h,P,W,K){this.n.trace("ExtHostSCM#createSourceControl",h.identifier.value,P,W,K),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:h.identifier.value});const j=t.d++,B=new S(h,this.m,this.e,this.l,P,W,K);this.g.set(j,B);const O=this.h.get(h.identifier)||[];return O.push(B),this.h.set(h.identifier,O),B}getLastInputBox(h){this.n.trace("ExtHostSCM#getLastInputBox",h.identifier.value);const P=this.h.get(h.identifier),W=P&&P[P.length-1];return W&&W.inputBox}$provideOriginalResource(h,P,W){const K=y.URI.revive(P);this.n.trace("ExtHostSCM#$provideOriginalResource",h,K.toString());const j=this.g.get(h);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Lg)(()=>j.quickDiffProvider.provideOriginalResource(K,W)).then(B=>B||null)}$onInputBoxValueChange(h,P){this.n.trace("ExtHostSCM#$onInputBoxValueChange",h);const W=this.g.get(h);return W&&W.inputBox.$onInputBoxValueChange(P),Promise.resolve(void 0)}$executeResourceCommand(h,P,W,K){this.n.trace("ExtHostSCM#$executeResourceCommand",h,P,W);const j=this.g.get(h);if(!j)return Promise.resolve(void 0);const B=j.getResourceGroup(P);return B?B.$executeResourceCommand(W,K):Promise.resolve(void 0)}$validateInput(h,P,W){this.n.trace("ExtHostSCM#$validateInput",h);const K=this.g.get(h);return!K||!K.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Lg)(()=>K.inputBox.validateInput(P,W)).then(j=>{if(!j)return Promise.resolve(void 0);const B=p.MarkdownString.fromStrict(j.message);return B?Promise.resolve([B,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(h){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",h),h!==void 0&&this.g.get(h)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=h,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(h,P,W){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupBase(P,W)??void 0}async $resolveHistoryItemGroupCommonAncestor(h,P,W,K){return await this.g.get(h)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(P,W,K)??void 0}async $provideHistoryItems(h,P,W,K){return(await this.g.get(h)?.historyProvider?.provideHistoryItems(P,W,K))?.map(O=>({id:O.id,parentIds:O.parentIds,label:O.label,description:O.description,icon:a(O),timestamp:O.timestamp}))??void 0}async $provideHistoryItemChanges(h,P,W){return await this.g.get(h)?.historyProvider?.provideHistoryItemChanges(P,W)??void 0}};e.$Hcc=u,e.$Hcc=u=t=qe([We(3,R.$8i)],u)}),define(Re[83],Me([1,0,3,5,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=e.$mcc=void 0;class L{constructor(l){this.b=new M.$Md,this.onDidChangePassword=this.b.event,this.a=l.getProxy(y.$aK.MainThreadSecretState)}async $onDidChangePassword(l){this.b.fire(l)}get(l,k){return this.a.$getPassword(l,k)}store(l,k,f){return this.a.$setPassword(l,k,f)}delete(l,k){return this.a.$deletePassword(l,k)}}e.$mcc=L,e.$ncc=(0,C.$Nh)("IExtHostSecretState")}),define(Re[250],Me([1,0,3,8,2]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=void 0;class L{static{this.a=0}constructor(l,k){this.d=k,this.c=new Map,this.b=l.getProxy(y.$aK.MainThreadShare)}async $provideShare(l,k,f){return await this.c.get(l)?.provideShare({selection:M.Range.to(k.selection),resourceUri:C.URI.revive(k.resourceUri)},f)??void 0}registerShareProvider(l,k){const f=L.a++;return this.c.set(f,k),this.b.$registerShareProvider(f,M.DocumentSelector.from(l,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$Jdc=L}),define(Re[251],Me([1,0,7,3,153,6,8,16]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=e.$Icc=void 0;class k{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$0K("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$0K("statusBarItem.warningForeground")]])}#e;#t;constructor(c,p,$,m,t,i=y.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new L.$Qc,this.#e=c,this.#t=p,t&&m){this.c=(0,y.$MK)(m.identifier,t);const b=$.get(this.c);b&&(i=b.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,a=b.priority,this.j=!0,this.name=b.name,this.text=b.text,this.tooltip=b.tooltip,this.command=b.command,this.accessibilityInformation=b.accessibilityInformation)}else this.c=String(k.a++);this.e=m,this.f=t,this.g=i,this.h=this.u(a)}u(c){if((0,l.$Bf)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(c){this.k=c,this.v()}set name(c){this.m=c,this.v()}set tooltip(c){this.l=c,this.v()}set color(c){this.n=c,this.v()}set backgroundColor(c){c&&!k.b.has(c.id)&&(c=void 0),this.o=c,this.v()}set command(c){this.r?.fromApi!==c&&(this.p&&this.q.add(this.p),this.p=new L.$Qc,typeof c=="string"?this.r={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this.p)}:c?this.r={fromApi:c,internal:this.#t.toInternal(c,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(c){this.t=c,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let c;this.e?this.f?c=`${this.e.identifier.value}.${this.f}`:c=this.e.identifier.value:c=this.f;let p;this.m?p=this.m:p=(0,C.localize)(0,null,this.e.displayName||this.e.name);let $=this.n;this.o&&($=k.b.get(this.o.id));const m=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,c,this.e?.identifier.value,p,this.k,m,this.r?.internal,$,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Icc=k;class f{constructor(c){this.b=[],this.a=c.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,C.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(c){const p={message:c};return this.b.unshift(p),this.c(),new y.$cK(()=>{const $=this.b.indexOf(p);$>=0&&(this.b.splice($,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(c,p){this.e=new Map,this.a=c.getProxy(M.$aK.MainThreadStatusBar),this.b=p,this.c=new f(this)}$acceptStaticEntries(c){for(const p of c)this.e.set(p.entryId,p)}createStatusBarEntry(c,p,$,m){return new k(this.a,this.b,this.e,c,p,$,m)}setStatusBarMessage(c,p){const $=this.c.setMessage(c);let m;return typeof p=="number"?m=setTimeout(()=>$.dispose(),p):typeof p<"u"&&p.then(()=>$.dispose(),()=>$.dispose()),new y.$cK(()=>{$.dispose(),clearTimeout(m)})}}e.$Jcc=R}),define(Re[84],Me([1,0,3,5,4]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=e.$acc=void 0;class L{constructor(l,k){this.c=k,this.b=new M.$Md,this.onDidChangeStorage=this.b.event,this.a=l.getProxy(y.$aK.MainThreadStorage)}registerExtensionStorageKeysToSync(l,k){this.a.$registerExtensionStorageKeysToSync(l,k)}async initializeExtensionStorage(l,k,f){const R=await this.a.$initializeExtensionStorage(l,k);let D;return R&&(D=this.d(l,k,R)),D||f}setValue(l,k,f){return this.a.$setValue(l,k,f)}$acceptValue(l,k,f){const R=this.d(l,k,f);R&&this.b.fire({shared:l,key:k,value:R})}d(l,k,f){try{return JSON.parse(f)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${l}): ${R}`)}}}e.$acc=L,e.$bcc=(0,C.$Nh)("IExtHostStorage")}),define(Re[85],Me([1,0,4,27,14,61,2]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=e.$gcc=void 0,e.$gcc=(0,y.$Nh)("IExtensionStoragePaths");let l=class{constructor(f,R,D){this.d=R,this.f=D,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(c=>this.c=c)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,R=await this.g(f);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$hcc=l,e.$hcc=l=qe([We(0,M.$rM),We(1,C.$8i),We(2,L.$fcc)],l)}),define(Re[62],Me([1,0,5,3,4,2,17,6,7,155,9,181,21,36,182,41,12,8,31]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=e.$kcc=e.$jcc=e.$icc=void 0,e.$icc=(0,C.$Nh)("IExtHostTerminalService");class b{constructor(u,g,h,P){this.l=u,this._id=g,this.m=h,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(K=>this.f=K);const W=this;this.value={get name(){return W.n||""},get processId(){return W.b},get creationOptions(){return W.m},get exitStatus(){return W.h},get state(){return W.j},get selection(){return W.k},sendText(K,j=!0){W.q(),W.l.$sendText(W._id,K,j)},show(K){W.q(),W.l.$show(W._id,K)},hide(){W.q(),W.l.$hide(W._id)},dispose(){W.a||(W.a=!0,W.l.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(u,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:u.name,shellPath:u.shellPath??void 0,shellArgs:u.shellArgs??void 0,cwd:u.cwd??void 0,env:u.env??void 0,icon:w(u.iconPath)??void 0,color:m.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:u.message??void 0,strictEnv:u.strictEnv??void 0,hideFromUser:u.hideFromUser??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o(u.location,g?.resolvedExtHostIdentifier),isTransient:u.isTransient??void 0})}async createExtensionTerminal(u,g,h,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:h,color:m.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(u,g),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(u,g){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in u?{viewColumn:i.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.n=u}setExitStatus(u,g){this.h=Object.freeze({code:u,reason:g})}setDimensions(u,g){return u===this.d&&g===this.g||u===0||g===0?!1:(this.d=u,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(u){this.k=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(g=>{g!==u&&(this.b=Promise.resolve(u))})}}e.$jcc=b;class E{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new y.$Md,this.onProcessData=this.a.event,this.b=new y.$Md,this.d=new y.$Md,this.onDidChangeProperty=this.d.event,this.f=new y.$Md,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,g){this.g.setDimensions?.({columns:u,rows:g})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let v=1,r=class extends l.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}constructor(u,g,h){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new l.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new y.$Md,this.onDidCloseTerminal=this.H.event,this.I=new y.$Md,this.onDidOpenTerminal=this.I.event,this.J=new y.$Md,this.onDidChangeActiveTerminal=this.J.event,this.L=new y.$Md,this.onDidChangeTerminalDimensions=this.L.event,this.M=new y.$Md,this.onDidChangeTerminalState=this.M.event,this.N=new y.$Md,this.onDidChangeShell=this.N.event,this.O=new y.$Md({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new y.$Md({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=h.getProxy(M.$aK.MainThreadTerminalService),this.y=new $.$Lkb(this.a.$sendProcessData),this.a.$registerProcessSupport(u),this.Q.registerArgumentProcessor({processArgument:P=>{const W=K=>{const j=K;return this.W(j.instanceId)?.value};switch(P?.$mid){case 15:return W(P);default:{if(Array.isArray(P))for(let K=0;K<P.length&&P[K].$mid===15;K++)P[K]=W(P[K]);return P}}}}),this.B({dispose:()=>{for(const[P,W]of this.g)W.shutdown(!0)}})}getDefaultShell(u){return(u?this.u:this.s)?.path||""}getDefaultShellArgs(u){return(u?this.u:this.s)?.args||[]}createExtensionTerminal(u,g){const h=new b(this.a,(0,p.$dg)(),u,u.name),P=new E(u.pty);return h.createExtensionTerminal(u.location,this.R(u,g).resolvedExtHostIdentifier,w(u.iconPath),d(u.color)).then(W=>{const K=this.S(W,P);this.h[W]=K}),this.f.push(h),h.value}R(u,g){if(g=g||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const h=u.location.parentTerminal;if(h){const P=this.f.find(W=>W.value===h);P&&(g.resolvedExtHostIdentifier=P._id)}}else u.location&&typeof u.location!="object"?g.location=u.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(u,g){if(!this.W(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const P=new E(g),W=this.S(u,P);this.h[u]=W}async $acceptActiveTerminalChanged(u){const g=this.b;if(u===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const h=this.W(u);h&&(this.b=h,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(u,g){const h=this.W(u);h&&this.O.fire({terminal:h.value,data:g})}async $acceptTerminalDimensions(u,g,h){const P=this.W(u);P&&P.setDimensions(g,h)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(u,g){const h=this.W(u);h&&this.P.fire({terminal:h.value,...g})}async $acceptTerminalMaximumDimensions(u,g,h){this.g.get(u)?.resize(g,h)}async $acceptTerminalTitleChange(u,g){const h=this.W(u);h&&(h.name=g)}async $acceptTerminalClosed(u,g,h){const P=this.Y(this.f,u);if(P!==null){const W=this.f.splice(P,1)[0];W.setExitStatus(g,h),this.H.fire(W.value)}}$acceptTerminalOpened(u,g,h,P){if(g){const j=this.Y(this.f,g);if(j!==null){this.f[j]._id=u,this.I.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const W={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:L.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},K=new b(this.a,u,W,h);this.f.push(K),this.I.fire(K.value),K.isOpen=!0}async $acceptTerminalProcessId(u,g){this.W(u)?._setProcessId(g)}async $startExtensionTerminal(u,g){const h=this.W(u);if(!h)return{message:(0,f.localize)(0,null,u)};h.isOpen||await new Promise(W=>{const K=this.onDidOpenTerminal(async j=>{j===h.value&&(K.dispose(),W())})});const P=this.g.get(u);P?P.startSendingEvents(g):this.j[u]={initialDimensions:g}}S(u,g){const h=new l.$Qc;h.add(g.onProcessReady(W=>this.a.$sendProcessReady(u,W.pid,W.cwd,W.windowsPty))),h.add(g.onDidChangeProperty(W=>this.a.$sendProcessProperty(u,W))),this.y.startBuffering(u,g.onProcessData),h.add(g.onProcessExit(W=>this.U(u,W))),this.g.set(u,g);const P=this.j[u];return P&&g instanceof E&&(g.startSendingEvents(P.initialDimensions),delete this.j[u]),h}$acceptProcessAckDataEvent(u,g){this.g.get(u)?.acknowledgeDataEvent(g)}$acceptProcessInput(u,g){this.g.get(u)?.input(g)}$acceptTerminalInteraction(u){const g=this.W(u);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection(u,g){this.W(u)?.setSelection(g)}$acceptProcessResize(u,g,h){try{this.g.get(u)?.resize(g,h)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(u,g){this.g.get(u)?.shutdown(g)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(g=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(g=>this.a.$sendProcessProperty(u,{type:"cwd",value:g}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.z.add(u),this.z.size===1&&this.a.$startLinkProvider(),new k.$cK(()=>{this.z.delete(u),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,g,h){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,h),this.a.$registerProfileProvider(g,u.identifier.value),new k.$cK(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider(u,g,h){if(this.D.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.D.set(u,h),this.a.$registerQuickFixProvider(u,g),new k.$cK(()=>{this.D.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,g){const h=new c.$Wd().token;if(h.isCancellationRequested)return;const P=this.D.get(u);if(!P)return;const W=await P.provideTerminalQuickFixes(g,h);if(W===null||Array.isArray(W)&&W.length===0)return;const K=new l.$Qc;if(this.w.value=K,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.Q.converter,K):void 0;const j=[];for(const B of W){const O=i.TerminalQuickFix.from(B,this.Q.converter,K);O&&j.push(O)}return j}async $createContributedProfileTerminal(u,g){const h=new c.$Wd().token;let P=await this.C.get(u)?.provideTerminalProfile(h);if(!h.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,g);return}this.createTerminalFromOptions(P.options,g)}}async $provideLinks(u,g){const h=this.W(u);if(!h)return[];this.F.delete(u),this.G.get(u)?.dispose(!0);const W=new c.$Wd;this.G.set(u,W);const K=[],j={terminal:h.value,line:g},B=[];for(const te of this.z)B.push(t.Promises.withAsyncBody(async Y=>{W.token.onCancellationRequested(()=>Y({provider:te,links:[]}));const Ee=await te.provideTerminalLinks(j,W.token)||[];W.token.isCancellationRequested||Y({provider:te,links:Ee})}));const O=await Promise.all(B);if(W.token.isCancellationRequested)return[];const N=new Map;for(const te of O)te&&te.links.length>0&&K.push(...te.links.map(Y=>{const Ee={id:v++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return N.set(Ee.id,{provider:te.provider,link:Y}),Ee}));return this.F.set(u,N),K}$activateLink(u,g){const h=this.F.get(u)?.get(g);h&&h.provider.handleTerminalLink(h.link)}U(u,g){this.y.stopBuffering(u),this.g.delete(u),delete this.j[u];const h=this.h[u];h&&(h.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,g)}W(u){return this.X(this.f,u)}X(u,g){const h=this.Y(u,g);return h!==null?u[h]:null}Y(u,g){const h=u.findIndex(P=>P._id===g);return h===-1?null:h}getEnvironmentVariableCollection(u){let g=this.n.get(u.identifier.value);return g||(g=new s,this.$(u.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z(u,g){const h=(0,D.$hr)(g.map),P=(0,D.$ir)(g.descriptionMap);this.a.$setEnvironmentVariableCollection(u,g.persistent,h.length===0?void 0:h,P)}$initEnvironmentVariableCollections(u){u.forEach(g=>{const h=g[0],P=new s(g[1]);this.$(h,P)})}$acceptDefaultProfile(u,g){const h=this.s;this.s=u,this.u=g,h?.path!==u.path&&this.N.fire(u.path)}$(u,g){this.n.set(u,g),g.onDidChangeCollection(()=>{this.Z(u,g)})}};e.$kcc=r,e.$kcc=r=qe([We(1,a.$xM),We(2,A.$bM)],r);class s{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$Md,this.map=new Map(u)}getScopedEnvironmentVariableCollection(u){const g=this.h(u);let h=this.a.get(g);return h||(h=new n(this,u),this.a.set(g,h),h.onDidChangeCollection(()=>this.d.fire())),h}replace(u,g,h,P){this.f(u,{value:g,type:k.EnvironmentVariableMutatorType.Replace,options:h??{applyAtProcessCreation:!0},scope:P})}append(u,g,h,P){this.f(u,{value:g,type:k.EnvironmentVariableMutatorType.Append,options:h??{applyAtProcessCreation:!0},scope:P})}prepend(u,g,h,P){this.f(u,{value:g,type:k.EnvironmentVariableMutatorType.Prepend,options:h??{applyAtProcessCreation:!0},scope:P})}f(u,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const h=this.g(u,g.scope),P=this.map.get(h),W=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==g.value||P.type!==g.type||P.options?.applyAtProcessCreation!==W.applyAtProcessCreation||P.options?.applyAtShellIntegration!==W.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const K=this.g(u,g.scope),j={variable:u,...g,options:W};this.map.set(K,j),this.d.fire()}}get(u,g){const h=this.g(u,g),P=this.map.get(h);return P?I(P):void 0}g(u,g){const h=this.h(g);return h.length?`${u}:::${h}`:u}h(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const g=new Map;for(const[h,P]of this.map)this.h(P.scope)===this.h(u)&&g.set(P.variable,I(P));return g}delete(u,g){const h=this.g(u,g);this.map.delete(h),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[g,h]of this.map)h.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(g);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,g){const h=this.h(g),P=this.descriptionMap.get(h);if(!P||P.description!==u){let W;typeof u=="string"?W=u:W=u?.value.split(`

`)[0];const K={description:W,scope:g};this.descriptionMap.set(h,K),this.d.fire()}}getDescription(u){const g=this.h(u);return this.descriptionMap.get(g)?.description}k(u){const g=this.h(u);this.descriptionMap.delete(g)}}class n{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,g){this.b=u,this.d=g,this.a=new y.$Md}getScoped(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,g,h){this.b.replace(u,g,h,this.d)}append(u,g,h){this.b.append(u,g,h,this.d)}prepend(u,g,h){this.b.prepend(u,g,h,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,g){this.b.getVariableMap(this.d).forEach((h,P)=>u.call(g,P,h,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends r{constructor(u,g){super(!1,u,g)}createTerminal(u,g,h){throw new R.$$}createTerminalFromOptions(u,g){throw new R.$$}};e.$lcc=o,e.$lcc=o=qe([We(0,a.$xM),We(1,A.$bM)],o);function w(S){if(!(!S||typeof S=="string"))return"id"in S?{id:S.id,color:S.color}:S}function d(S){return m.ThemeColor.isThemeColor(S)?S:void 0}function I(S){const u={...S};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Re[252],Me([1,0,281,12,26,21,5,202,93,6,24,16,36,3,17,104,8,7,46,76,56,25]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vdc=e.$udc=e.$tdc=e.$sdc=void 0;let r=class{constructor(j,B,O){this.k=O,this.d=new A.$Md,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=j.getProxy(p.$aK.MainThreadTesting),this.j=new h(this.g),this.h=new w(this.g),B.registerArgumentProcessor({processArgument:N=>{switch(N?.$mid){case 16:{const te=N,Y=te.tests[te.tests.length-1].item.extId;return this.f.get(a.$6I.root(Y))?.collection.tree.get(Y)?.actual??(0,m.$nM)(N)}case 18:{const{extId:te,message:Y}=N;return{test:this.f.get(a.$6I.root(te))?.collection.tree.get(te)?.actual,message:t.TestMessage.to(Y)}}default:return N}}}),B.registerCommand(!1,"testing.getExplorerSelection",async()=>{const N=await B.executeCommand("_testing.getExplorerSelection"),te=Y=>{const Ee=this.f.get(a.$6I.root(Y));if(Ee)return a.$6I.isRoot(Y)?Ee.controller:Ee.collection.tree.get(Y)?.actual};return{include:N?.include.map(te).filter(D.$Ff)||[],exclude:N?.exclude.map(te).filter(D.$Ff)||[]}})}createTestController(j,B,O,N){if(this.f.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const te=new f.$Qc,Y=te.add(new m.$qM(B,O,this.k));Y.root.label=O;const Ee=new Map,Se=this.g,Pe={items:Y.root.children,get label(){return O},set label(me){O=me,Y.root.label=me,Se.$updateController(B,{label:O})},get refreshHandler(){return N},set refreshHandler(me){N=me,Se.$updateController(B,{canRefresh:!!me})},get id(){return B},createRunProfile:(me,ce,se,$e,_,z)=>{let V=(0,k.$Bi)(me);for(;Ee.has(V);)V++;return new P(this.g,Ee,B,V,me,ce,se,$e,_,z)},createTestItem(me,ce,se){return new m.$oM(B,me,ce,se)},createTestRun:(me,ce,se=!0)=>this.h.createTestRun(j,B,Y,me,ce,se),invalidateTestResults:me=>{if(me===void 0)this.g.$markTestRetired(void 0);else{const ce=me instanceof Array?me:[me];this.g.$markTestRetired(ce.map(se=>a.$6I.fromExtHostTestItem(se,B).toString()))}},set resolveHandler(me){Y.resolveHandler=me},get resolveHandler(){return Y.resolveHandler},dispose:()=>{te.dispose()}};Se.$registerTestController(B,O,!!N),te.add((0,f.$Pc)(()=>Se.$unregisterTestController(B)));const ge={controller:Pe,collection:Y,profiles:Ee,extension:j};return this.f.set(B,ge),te.add((0,f.$Pc)(()=>this.f.delete(B))),te.add(Y.onDidGenerateDiff(me=>Se.$publishDiff(B,me.map(E.TestsDiffOp.serialize)))),Pe}createTestObserver(){return this.j.checkout()}async runTests(j,B=L.CancellationToken.None){const O=d(j);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const N=this.f.get(O.controllerId);if(!N)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(te=>a.$6I.fromExtHostTestItem(te,N.collection.root.id).toString())??[N.collection.root.id],profileGroup:W[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:j.exclude?.map(te=>te.id)},B)}$syncTests(){for(const{collection:j}of this.f.values())j.flushDiff();return Promise.resolve()}$provideFileCoverage(j,B,O){return(0,y.$qb)(this.h.trackers,te=>te.id===j?te.getCoverage(B):void 0)?.provideFileCoverage(O)??Promise.resolve([])}$resolveFileCoverage(j,B,O,N){return(0,y.$qb)(this.h.trackers,Y=>Y.id===j?Y.getCoverage(B):void 0)?.resolveFileCoverage(O,N)??Promise.resolve([])}$configureRunProfile(j,B){this.f.get(j)?.profiles.get(B)?.configureHandler?.()}async $refreshTests(j,B){await this.f.get(j)?.controller.refreshHandler?.(B)}$publishTestResults(j){this.results=Object.freeze(j.map(B=>(0,R.$4m)(t.TestResults.to(B))).concat(this.results).sort((B,O)=>O.completedAt-B.completedAt).slice(0,32)),this.d.fire()}async $expandTest(j,B){const O=this.f.get(a.$6I.fromString(j).controllerId)?.collection;O&&(await O.expand(j,B<0?1/0:B),O.flushDiff())}$acceptDiff(j){this.j.applyDiff(j.map(E.TestsDiffOp.deserialize))}async $runControllerTests(j,B){return Promise.all(j.map(O=>this.l(O,!1,B)))}async $startContinuousRun(j,B){const O=new L.$Wd(B),N=await Promise.all(j.map(te=>this.l(te,!0,O.token)));return!B.isCancellationRequested&&!N.some(te=>te.error)&&await new Promise(te=>B.onCancellationRequested(te)),O.dispose(!0),N}async l(j,B,O){const N=this.f.get(j.controllerId);if(!N)return{};const{collection:te,profiles:Y,extension:Ee}=N,Se=Y.get(j.profileId);if(!Se)return{};const Pe=j.testIds.map(se=>te.tree.get(se)).filter(D.$Ff),ge=j.excludeExtIds.map(se=>N.collection.tree.get(se)).filter(D.$Ff).filter(se=>Pe.some($e=>$e.fullId.compare(se.fullId)===2));if(!Pe.length)return{};const me=new i.$KL(Pe.some(se=>se.actual instanceof m.$pM)?void 0:Pe.map(se=>se.actual),ge.map(se=>se.actual),Se,B),ce=(0,E.$8I)(j)&&this.h.prepareForMainThreadTestRun(me,I.fromInternal(j,N.collection),Ee,O);try{return await Se.runHandler(me,O),{}}catch(se){return{error:String(se)}}finally{ce&&(ce.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ce.onEnd),ce.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.h.cancelAllRuns():this.h.cancelRunById(j)}};e.$sdc=r,e.$sdc=r=qe([We(0,$.$bM)],r);const s=1e4;var n;(function(K){K[K.Running=0]="Running",K[K.Cancelling=1]="Cancelling",K[K.Ended=2]="Ended"})(n||(n={}));class o extends f.$Rc{get hasRunningTasks(){return this.g.size>0}get id(){return this.s.id}constructor(j,B,O,N){super(),this.s=j,this.u=B,this.w=O,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new A.$Md),this.onEnd=this.m.event,this.j=this.B(new L.$Wd(N));const te=this.B(new M.$5g(()=>this.y(),s));this.B(this.j.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.y()}getCoverage(j){return this.g.get(j)?.coverage}createRun(j){const B=this.s.id,O=this.s.controllerId,N=(0,c.$dg)(),te=new S(this.u,B,N),Y=ge=>(me,...ce)=>{if(Se){console.warn(`Setting the state of test "${me.id}" is a no-op after the run ends.`);return}this.s.isIncluded(me)&&(this.C(me),ge(me,...ce))},Ee=(ge,me)=>{const ce=me instanceof Array?me.map(t.TestMessage.from):[t.TestMessage.from(me)];if(ce.some(se=>se.contextValue!==void 0)&&(0,v.$aF)(this.w,"testMessageContextValue"),ge.uri&&ge.range){const se={range:t.Range.from(ge.range),uri:ge.uri};for(const $e of ce)$e.location=$e.location||se}this.u.$appendTestMessagesInRun(B,N,a.$6I.fromExtHostTestItem(ge,O).toString(),ce)};let Se=!1;const Pe={isPersisted:this.s.isPersisted,token:this.j.token,name:j,get coverageProvider(){return te.coverageProvider},set coverageProvider(ge){te.coverageProvider=ge},enqueued:Y(ge=>{this.u.$updateTestStateInRun(B,N,a.$6I.fromExtHostTestItem(ge,O).toString(),1)}),skipped:Y(ge=>{this.u.$updateTestStateInRun(B,N,a.$6I.fromExtHostTestItem(ge,O).toString(),5)}),started:Y(ge=>{this.u.$updateTestStateInRun(B,N,a.$6I.fromExtHostTestItem(ge,O).toString(),2)}),errored:Y((ge,me,ce)=>{Ee(ge,me),this.u.$updateTestStateInRun(B,N,a.$6I.fromExtHostTestItem(ge,O).toString(),6,ce)}),failed:Y((ge,me,ce)=>{Ee(ge,me),this.u.$updateTestStateInRun(B,N,a.$6I.fromExtHostTestItem(ge,O).toString(),4,ce)}),passed:Y((ge,me)=>{this.u.$updateTestStateInRun(B,N,a.$6I.fromExtHostTestItem(ge,this.s.controllerId).toString(),3,me)}),appendOutput:(ge,me,ce)=>{Se||(ce&&(this.s.isIncluded(ce)?this.C(ce):ce=void 0),this.u.$appendOutputToRun(B,N,C.$ae.fromString(ge),me&&t.location.from(me),ce&&a.$6I.fromExtHostTestItem(ce,O).toString()))},end:()=>{Se||(Se=!0,this.u.$finishedTestRunTask(B,N),this.g.delete(N),this.g.size||this.z())}};return this.g.set(N,{run:Pe,coverage:te}),this.u.$startedTestRunTask(B,{id:N,name:j,running:!0}),Pe}y(){for(const{run:j}of this.g.values())j.end()}z(){this.f!==2&&(this.f=2,this.m.fire())}C(j){if(!(j instanceof m.$oM))throw new b.$6L(j.id);if(this.h.has(a.$6I.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const B=[],O=this.s.colllection.root;for(;;){const N=t.TestItem.from(j);if(B.unshift(N),this.h.has(N.extId)||(this.h.add(N.extId),j===O))break;j=j.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,B)}dispose(){this.z(),super.dispose()}}class w{get trackers(){return this.d.values()}constructor(j){this.f=j,this.d=new Map}prepareForMainThreadTestRun(j,B,O,N){return this.g(j,B,O,N)}cancelRunById(j){for(const B of this.d.values())if(B.id===j){B.cancel();return}}cancelAllRuns(){for(const j of this.d.values())j.cancel()}createTestRun(j,B,O,N,te,Y){const Ee=this.d.get(N);if(Ee)return Ee.createRun(te);const Se=I.fromPublic(B,O,N,Y),Pe=d(N);this.f.$startedExtensionTestRun({controllerId:B,continuous:!!N.continuous,profile:Pe&&{group:W[Pe.kind],id:Pe.profileId},exclude:N.exclude?.map(me=>a.$6I.fromExtHostTestItem(me,O.root.id).toString())??[],id:Se.id,include:N.include?.map(me=>a.$6I.fromExtHostTestItem(me,O.root.id).toString())??[O.root.id],persist:Y});const ge=this.g(N,Se,j);return A.Event.once(ge.onEnd)(()=>{this.f.$finishedExtensionTestRun(Se.id),ge.dispose()}),ge.createRun(te)}g(j,B,O,N){const te=new o(B,this.f,O,N);return this.d.set(j,te),A.Event.once(te.onEnd)(()=>this.d.delete(j)),te}}e.$tdc=w;const d=K=>{if(K.profile){if(!(K.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return K.profile}};class I{static fromPublic(j,B,O,N){return new I(j,(0,c.$dg)(),O.include?.map(te=>a.$6I.fromExtHostTestItem(te,j).toString())??[j],O.exclude?.map(te=>a.$6I.fromExtHostTestItem(te,j).toString())??[],N,B)}static fromInternal(j,B){return new I(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,B)}constructor(j,B,O,N,te,Y){this.controllerId=j,this.id=B,this.isPersisted=te,this.colllection=Y,this.d=O.map(Ee=>Ee+"\0"),this.f=N.map(Ee=>Ee+"\0")}isIncluded(j){const B=a.$6I.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const O of this.f)if(B===O||B.startsWith(O))return!1;for(const O of this.d)if(B===O||B.startsWith(O))return!0;return!1}}e.$udc=I;class S{set coverageProvider(j){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");j&&(this.d=j,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(j,B,O){this.g=j,this.h=B,this.j=O}async provideFileCoverage(j){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(j))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.f=void 0,B}}async resolveFileCoverage(j,B){const O=await this.f;let N=O?.[j];return!this.d||!O||!N?[]:(N.detailedCoverage||(N=O[j]=await this.d.resolveFileCoverage?.(N,B)??N),N.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class u{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(j){this.j=j,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(j){this.d.add(j)}update(j){Object.assign(j.revived,t.TestItem.toPlain(j.item)),this.d.has(j)||this.f.add(j)}remove(j){if(this.d.has(j)){this.d.delete(j);return}this.f.delete(j);const B=a.$6I.parentId(j.item.extId);if(B&&this.h.has(B.toString())){this.h.add(j.item.extId);return}this.g.add(j)}getChangeEvent(){const{d:j,f:B,g:O}=this;return{get added(){return[...j].map(N=>N.revived)},get updated(){return[...B].map(N=>N.revived)},get removed(){return[...O].map(N=>N.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends E.$aJ{constructor(){super(...arguments),this.s=new A.$Md,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(j){return this.f.get(j)}getMirroredTestDataByReference(j){return this.f.get(j.id)}q(j,B){return{...j,revived:t.TestItem.toPlain(j.item),depth:B?B.depth+1:0,children:new Set}}p(){return new u(this.s)}}class h{constructor(j){this.f=j}checkout(){this.d||(this.d=this.g());const j=this.d;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(B=>B.revived)},dispose:(0,l.$cb)(()=>{--j.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(j){return this.d?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.d?.tests.apply(j)}g(){const j=new g;return this.f.$subscribeToDiffs(),{observers:0,tests:j}}}class P{#e;#t;get label(){return this.f}set label(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(j){j!==this.h&&(this.h=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.g}set isDefault(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?t.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.d}set configureHandler(j){j!==this.d&&(this.d=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}constructor(j,B,O,N,te,Y,Ee,Se=!1,Pe=void 0,ge=!1){this.controllerId=O,this.profileId=N,this.f=te,this.kind=Y,this.runHandler=Ee,this.g=Se,this._tag=Pe,this.h=ge,this.#e=j,this.#t=B,B.set(N,this);const me=W[Y];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:N,controllerId:O,tag:Pe?t.TestTag.namespace(this.controllerId,Pe.id):null,label:te,group:me,isDefault:Se,hasConfigurationHandler:!1,supportsContinuousRun:ge})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$vdc=P;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Re[253],Me([1,0,18,9,5,3,105,8,7]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;class f{constructor(D,c){this.i=c,this.a=new C.$Md({onListenerError:M.$1}),this.b=new C.$Md({onListenerError:M.$1}),this.c=new C.$Md({onListenerError:M.$1}),this.d=new C.$Md({onListenerError:M.$1}),this.f=new C.$Md({onListenerError:M.$1}),this.g=new C.$Md({onListenerError:M.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(L.$aK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const c=this.i.allEditors();return D?c:c.map(p=>p.value)}async showTextDocument(D,c,p){let $;typeof c=="number"?$={position:l.ViewColumn.from(c),preserveFocus:p}:typeof c=="object"?$={position:l.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?l.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:$={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(D.uri,$),t=m&&this.i.getEditor(m);if(t)return t.value;throw m?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,c){return new A.$iM(this.h,D,c).value}$acceptEditorPropertiesChanged(D,c){const p=this.i.getEditor(D);if(!p)throw new Error("unknown text editor");if(c.options&&p._acceptOptions(c.options),c.selections){const $=c.selections.selections.map(l.Selection.to);p._acceptSelections($)}if(c.visibleRanges){const $=y.$Gb(c.visibleRanges.map(l.Range.to));p._acceptVisibleRanges($)}if(c.options&&this.b.fire({textEditor:p.value,options:{...c.options,lineNumbers:l.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const $=k.TextEditorSelectionChangeKind.fromValue(c.selections.source),m=c.selections.selections.map(l.Selection.to);this.a.fire({textEditor:p.value,selections:m,kind:$})}if(c.visibleRanges){const $=y.$Gb(c.visibleRanges.map(l.Range.to));this.c.fire({textEditor:p.value,visibleRanges:$})}}$acceptEditorPositionData(D){for(const c in D){const p=this.i.getEditor(c);if(!p)throw new Error("Unknown text editor");const $=l.ViewColumn.to(D[c]);p.value.viewColumn!==$&&(p._acceptViewColumn($),this.d.fire({textEditor:p.value,viewColumn:$}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$Kcc=f}),define(Re[254],Me([1,0,2,4,3,6,7,8,20,16]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=void 0,e.$mdc=(0,M.$Nh)("IExtHostTimeline");class R{constructor(p,$){this.b=new Map,this.c=new Map,this.a=p.getProxy(C.$aK.MainThreadTimeline),$.registerArgumentProcessor({processArgument:(m,t)=>{if(m&&m.$mid===12)if(this.b.get(m.source)&&k.$3l.equals(t,this.b.get(m.source)?.extension)){const i=m.uri===void 0?void 0:y.URI.revive(m.uri);return this.c.get(m.source)?.get(D(i))?.get(m.handle)}else return;return m}})}async $getTimeline(p,$,m,t){return this.b.get(p)?.provider.provideTimeline(y.URI.revive($),m,t)}registerTimelineProvider(p,$,m,t){const i=new L.$Qc,a=this.d($.id,t,i).bind(this);let b;$.onDidChange&&(b=$.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:$.id}),this));const E=this.c;return this.f({...$,scheme:p,onDidChange:void 0,async provideTimeline(v,r,s){r?.resetCache&&(i.clear(),E.get($.id)?.clear());const n=await $.provideTimeline(v,r,s);if(n==null)return;const o=a(v,r);return{...n,source:$.id,items:n.items.map(o)}},dispose(){for(const v of E.values())v.get($.id)?.clear();b?.dispose(),i.dispose()}},m)}d(p,$,m){return(t,i)=>{let a;if(i?.cacheResults){let b=this.c.get(p);b===void 0&&(b=new Map,this.c.set(p,b));const E=D(t);a=b.get(E),a===void 0&&(a=new Map,b.set(E,a))}return b=>{const{iconPath:E,...v}=b,r=`${p}|${b.id??b.timestamp}`;a?.set(r,b);let s,n,o;b.iconPath&&(E instanceof A.$9K?o={id:E.id,color:E.color}:y.URI.isUri(E)?(s=E,n=E):{light:s,dark:n}=E);let w;return A.$CK.isMarkdownString(v.tooltip)?w=l.MarkdownString.from(v.tooltip):(0,f.$xf)(v.tooltip)?w=v.tooltip:A.$CK.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=l.MarkdownString.from(v.detail)):(0,f.$xf)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),w=v.detail),{...v,id:v.id??void 0,handle:r,source:p,command:b.command?$.toInternal(b.command,m):void 0,icon:s,iconDark:n,themeIcon:o,tooltip:w,accessibilityInformation:b.accessibilityInformation}}}}f(p,$){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:$}),(0,L.$Pc)(()=>{for(const t of this.c.values())t.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$ndc=R;function D(c){return c?.toString()}}),define(Re[86],Me([1,0,21,5,6,157,4,14,184,3,27,17,7]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xvb=e.$Wvb=e.TunnelDtoConverter=void 0;class p extends k.$bv{}var $;(function(t){function i(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:b.protocol}}t.fromApiTunnel=i;function a(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==k.TunnelPrivacyId.ConstantPrivate&&b.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}t.fromServiceTunnel=a})($||(e.TunnelDtoConverter=$={})),e.$Wvb=(0,A.$Nh)("IExtHostTunnelService");let m=class extends C.$Rc{constructor(i,a,b){super(),this.s=b,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Md,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=i.getProxy(f.$aK.MainThreadTunnelService)}async openTunnel(i,a){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const b=await this.a.$openTunnel(a,i.displayName);if(b){const E=new p(b.remoteAddress,b.localAddress,()=>this.a.$closeTunnel(b.remoteAddress));return this.B(E),E}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(i,a){const b=this.u();return this.r.set(b,{selector:i,provider:a}),this.a.$registerPortsAttributesProvider(i,b),new c.$cK(()=>{this.r.delete(b),this.a.$unregisterPortsAttributesProvider(b)})}async $providePortAttributes(i,a,b,E,v){const r=[];for(const n of i){const o=this.r.get(n);if(!o)return[];r.push(...await Promise.all(a.map(async w=>{let d;try{d=await o.provider.providePortAttributes({port:w,pid:b,commandLine:E},v)}catch{d=await o.provider.providePortAttributes(w,b,E,v)}return{providedAttributes:d,port:w}})))}const s=r.filter(n=>!!n.providedAttributes);return s.length>0?s.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(E,v)=>await i.provideTunnel(E,v,new y.$Wd().token)??void 0;const b=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(b),Promise.resolve((0,C.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,a){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const b=i.tunnelFactory??(a?this.w(a):void 0);if(b){this.b=b;let E=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&E.length===0&&(E=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const v=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:E}:void 0;this.a.$setTunnelProvider(v)}}else this.b=void 0;return(0,C.$Pc)(()=>{this.b=void 0})}w(i){}async $closeTunnel(i,a){if(this.g.has(i.host)){const b=this.g.get(i.host);b.has(i.port)&&(a&&b.get(i.port).disposeListener.dispose(),await b.get(i.port).tunnel.dispose(),b.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,a){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const b=this.b(i,a);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),b!==void 0){const E=await b;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),E===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const v=this.B(E.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(E.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:E,disposeListener:v}),$.fromApiTunnel(E)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(b){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),b instanceof Error)return b.message}}async $applyCandidateFilter(i){const a=await Promise.all(i.map(E=>this.f(E.host,E.port,E.detail??""))),b=i.filter((E,v)=>a[v]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(E=>E.port).join(", ")} to ${b.map(E=>E.port).join(", ")}`),b}};e.$Xvb=m,e.$Xvb=m=qe([We(0,D.$bM),We(1,R.$rM),We(2,l.$8i)],m)}),define(Re[255],Me([1,0,6,13,2,3]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wdc=void 0;class A{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(k){this.c=new Map,this.b=k.getProxy(L.$aK.MainThreadUriOpeners)}registerExternalUriOpener(k,f,R,D){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const c=D.schemes.find(p=>!A.a.has(p));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set(f,R),this.b.$registerUriOpener(f,D.schemes,k,D.label),(0,y.$Pc)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(k,f,R){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener with id: ${k}`);const c=C.URI.revive(f);return D.canOpenExternalUri(c,R)}async $openUri(k,f,R){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener id: '${k}'`);return D.openExternalUri(C.URI.revive(f.resolvedUri),{sourceUri:C.URI.revive(f.sourceUri)},R)}}e.$wdc=A}),define(Re[256],Me([1,0,3,2,6,9,20]),function(we,e,y,M,C,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;class l{static{this.a=0}constructor(f){this.c=new A.$4l,this.d=new Map,this.b=f.getProxy(y.$aK.MainThreadUrls)}registerUriHandler(f,R){const D=f.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const c=l.a++;return this.c.add(D),this.d.set(c,R),this.b.$registerUriHandler(c,D,f.displayName||f.name),(0,C.$Pc)(()=>{this.c.delete(D),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri(f,R){const D=this.d.get(f);if(!D)return Promise.resolve(void 0);try{D.handleUri(M.URI.revive(R))}catch(c){(0,L.$Z)(c)}return Promise.resolve(void 0)}async createAppUri(f){return M.URI.revive(await this.b.$createAppUri(f))}}e.$Mcc=l}),define(Re[63],Me([1,0,5,6,13,24,2,169,191,77,3]),function(we,e,y,M,C,L,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=e.$Pcc=e.$Occ=e.$Ncc=void 0;class D{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(E,v,r,s,n,o,w){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new y.$Md,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$Md,this._onDidDispose=this.#h.event,this.#e=E,this.#t=v,this.#r=r,this.#l=s,this.#u=n,this.#n=o,this.#c=c(o),this.#d=p(o),this.#i=w}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(E){return this.#a=!0,(0,f.$1ob)(E,this.#l)}get cspSource(){const E=this.#n.extensionLocation;if(E.scheme===C.Schemas.https||E.scheme===C.Schemas.http){let v=E.toString();return v.endsWith("/")||(v+="/"),v+" "+f.$Zob}return f.$Zob}get html(){return this.a(),this.#s}set html(E){this.a(),this.#s!==E&&(this.#s=E,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(E)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(E)))}get options(){return this.a(),this.#r}set options(E){this.a(),L.$7m(this.#r,E)||this.#t.$setOptions(this.#e,t(this.#n,this.#u,E)),this.#r=E}async postMessage(E){if(this.#o)return!1;const v=(0,k.$scb)(E,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,v.message,...v.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(E){if(!this.#d)return E;const v=this.#n.extensionLocation?.scheme===C.Schemas.vscodeRemote,r=this.#n.extensionLocation.scheme===C.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return E.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,n,o,w,d,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(d)}),u=(0,f.$1ob)(S,{isRemote:v,authority:r}).toString();return`${n}${u}${I}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,n,o,w,d,I)=>{const S=A.URI.from({scheme:w||"file",path:decodeURIComponent(d)}),u=(0,f.$1ob)(S,{isRemote:v,authority:r}).toString();return`${n}${u}${I}`})}}e.$Ncc=D;function c(b){try{const E=(0,l.$Ko)((0,l.$Jo)(b.engines.vscode));return!!E&&E.majorBase>=1&&E.minorBase>=57}catch{return!1}}e.$Occ=c;function p(b){try{const E=(0,l.$Ko)((0,l.$Jo)(b.engines.vscode));return E?E.majorBase<1||E.majorBase===1&&E.minorBase<60:!1}catch{return!1}}class $ extends M.$Rc{constructor(E,v,r,s,n){super(),this.c=v,this.f=r,this.g=s,this.h=n,this.b=new Map,this.a=E.getProxy(R.$aK.MainThreadWebviews)}dispose(){super.dispose();for(const E of this.b.values())E.dispose();this.b.clear()}$onMessage(E,v,r){const s=this.j(E);if(s){const{message:n}=(0,k.$tcb)(v,r.value);s._onMessageEmitter.fire(n)}}$onMissingCsp(E,v){this.g.warn(`${v} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(E,v,r){const s=new D(E,this.a,i(v),this.c,this.f,r,this.h);this.b.set(E,s);const n=s._onDidDispose(()=>{n.dispose(),this.deleteWebview(E)});return s}deleteWebview(E){this.b.delete(E)}j(E){return this.b.get(E)}}e.$Pcc=$;function m(b){return{id:b.identifier,location:b.extensionLocation}}e.$Qcc=m;function t(b,E,v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots||a(b,E)}}e.$Rcc=t;function i(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(E=>A.URI.from(E))}}function a(b,E){return[...(E?.getWorkspaceFolders()||[]).map(v=>v.uri),b.extensionLocation]}}),define(Re[257],Me([1,0,21,93,6,13,23,2,8,63,74,3,7]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;class p{constructor(s,n){this.document=s,this.b=n,this.a=1,this.c=new R.$Jbc("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,n){await this.f(s).undo(),n||this.disposeBackup()}async redo(s,n){await this.f(s).redo(),n||this.disposeBackup()}disposeEdits(s){for(const n of s)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=v(this.document.uri)+this.a++;return(0,A.$ug)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const n=this.c.get(s,0);if(!n)throw new Error("No edit found");return n}}class ${constructor(){this.a=new Map}get(s,n){return this.a.get(this.b(s,n))}add(s,n,o){const w=this.b(s,n.uri);if(this.a.has(w))throw new Error(`Document already exists for viewType:${s} resource:${n.uri}`);const d=new p(n,o);return this.a.set(w,d),d}delete(s,n){const o=this.b(s,n.uri);this.a.delete(o)}b(s,n){return`${s}@@@${n}`}}var m;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(m||(m={}));class t{constructor(){this.a=new Map}addTextProvider(s,n,o){return this.b(0,s,n,o)}addCustomProvider(s,n,o){return this.b(1,s,n,o)}get(s){return this.a.get(s)}b(s,n,o,w){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:s,extension:o,provider:w}),new c.$cK(()=>this.a.delete(n))}}class i{constructor(s,n,o,w,d){this.d=n,this.f=o,this.g=w,this.h=d,this.b=new t,this.c=new $,this.a=s.getProxy(D.$aK.MainThreadCustomEditors)}registerCustomEditorProvider(s,n,o,w){const d=new C.$Qc;return b(o)?(d.add(this.b.addTextProvider(n,s,o)),this.a.$registerTextEditorProvider((0,f.$Qcc)(s),n,w.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,f.$Occ)(s))):(d.add(this.b.addCustomProvider(n,s,o)),a(o)&&d.add(o.onDidChangeCustomDocument(I=>{const S=this.i(n,I.document.uri);if(E(I)){const u=S.addEdit(I);this.a.$onDidEdit(I.document.uri,n,u,I.label)}else this.a.$onContentChange(I.document.uri,n)})),this.a.$registerCustomEditorProvider((0,f.$Qcc)(s),n,w.webviewOptions||{},!!w.supportsMultipleEditorsPerDocument,(0,f.$Occ)(s))),c.$cK.from(d,new c.$cK(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(s,n,o,w,d){const I=this.b.get(n);if(!I)throw new Error(`No provider found for '${n}'`);if(I.type!==1)throw new Error(`Invalid provide type for '${n}'`);const S=l.URI.revive(s),u=await I.provider.openCustomDocument(S,{backupId:o,untitledDocumentData:w?.buffer},d);let g;return a(I.provider)&&this.f&&(g=this.f.workspaceValue(I.extension)??this.f.globalValue(I.extension)),this.c.add(n,u,g),{editable:a(I.provider)}}async $disposeCustomDocument(s,n){const o=this.b.get(n);if(!o)throw new Error(`No provider found for '${n}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${n}'`);const w=l.URI.revive(s),{document:d}=this.i(n,w);this.c.delete(n,d),d.dispose()}async $resolveCustomEditor(s,n,o,w,d,I){const S=this.b.get(o);if(!S)throw new Error(`No provider found for '${o}'`);const u=k.ViewColumn.to(d),g=this.g.createNewWebview(n,w.contentOptions,S.extension),h=this.h.createNewWebviewPanel(n,o,w.title,u,w.options,g,w.active),P=l.URI.revive(s);switch(S.type){case 1:{const{document:W}=this.i(o,P);return S.provider.resolveCustomEditor(W,h,I)}case 0:{const W=this.d.getDocument(P);return S.provider.resolveCustomTextEditor(W,h,I)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,n,o){this.i(n,s).disposeEdits(o)}async $onMoveCustomEditor(s,n,o){const w=this.b.get(o);if(!w)throw new Error(`No provider found for '${o}'`);if(!w.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const d=this.h.getWebviewPanel(s);if(!d)throw new Error("No webview found");const I=l.URI.revive(n),S=this.d.getDocument(I);await w.provider.moveCustomTextEditor(S,d,y.CancellationToken.None)}async $undo(s,n,o,w){return this.i(n,s).undo(o,w)}async $redo(s,n,o,w){return this.i(n,s).redo(o,w)}async $revert(s,n,o){const w=this.i(n,s);await this.j(n).revertCustomDocument(w.document,o),w.disposeBackup()}async $onSave(s,n,o){const w=this.i(n,s);await this.j(n).saveCustomDocument(w.document,o),w.disposeBackup()}async $onSaveAs(s,n,o,w){const d=this.i(n,s);return this.j(n).saveCustomDocumentAs(d.document,l.URI.revive(o),w)}async $backup(s,n,o){const w=this.i(n,s),I=await this.j(n).backupCustomDocument(w.document,{destination:w.getNewBackupUri()},o);return w.updateBackup(I),I.id}i(s,n){const o=this.c.get(s,l.URI.revive(n));if(!o)throw new Error("No custom document found");return o}j(s){const o=this.b.get(s)?.provider;if(!o||!a(o))throw new Error("Custom document is not editable");return o}}e.$qdc=i;function a(r){return!!r.onDidChangeCustomDocument}function b(r){return typeof r.resolveCustomTextEditor=="function"}function E(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function v(r){const s=r.scheme===L.Schemas.file||r.scheme===L.Schemas.untitled?r.fsPath:r.toString();return(0,M.$Bi)(s)+""}}),define(Re[258],Me([1,0,5,6,2,36,8,63,3,7]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class R extends M.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor($,m,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new y.$Md),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$Md),this.onDidChangeViewState=this.#h.event,this.#e=$,this.#t=m,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title($){this.c(),this.#n!==$&&(this.#n=$,this.#t.$setTitle(this.#e,$))}get iconPath(){return this.c(),this.#s}set iconPath($){this.c(),this.#s!==$&&(this.#s=$,this.#t.$setIconPath(this.#e,C.URI.isUri($)?{light:$,dark:$}:$))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState($){this.#c||(this.active!==$.active||this.visible!==$.visible||this.viewColumn!==$.viewColumn)&&(this.#a=$.active,this.#o=$.visible,this.#r=$.viewColumn,this.#h.fire({webviewPanel:this}))}reveal($,m){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof $>"u"?void 0:A.ViewColumn.from($),preserveFocus:!!m})}c(){if(this.#c)throw new Error("Webview is disposed")}}class D extends M.$Rc{static c(){return(0,L.$dg)()}constructor($,m,t){super(),this.j=m,this.m=t,this.g=new Map,this.h=new Map,this.f=$.getProxy(k.$aK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach($=>$.dispose()),this.g.clear()}createWebviewPanel($,m,t,i,a={}){const b=typeof i=="object"?i.viewColumn:i,E={viewColumn:A.ViewColumn.from(b),preserveFocus:typeof i=="object"&&!!i.preserveFocus},v=(0,l.$Occ)($),r=D.c();this.f.$createWebviewPanel((0,l.$Qcc)($),r,m,{title:t,panelOptions:c(a),webviewOptions:(0,l.$Rcc)($,this.m,a),serializeBuffersForPostMessage:v},E);const s=this.j.createNewWebview(r,a,$);return this.createNewWebviewPanel(r,m,t,b,a,s,!0)}$onDidChangeWebviewPanelViewStates($){const m=Object.keys($);m.sort((t,i)=>{const a=$[t],b=$[i];return a.active?1:b.active?-1:+a.visible-+b.visible});for(const t of m){const i=this.getWebviewPanel(t);if(!i)continue;const a=$[t];i._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel($){this.getWebviewPanel($)?.dispose(),this.g.delete($),this.j.deleteWebview($)}registerWebviewPanelSerializer($,m,t){if(this.h.has(m))throw new Error(`Serializer for '${m}' already registered`);return this.h.set(m,{serializer:t,extension:$}),this.f.$registerSerializer(m,{serializeBuffersForPostMessage:(0,l.$Occ)($)}),new f.$cK(()=>{this.h.delete(m),this.f.$unregisterSerializer(m)})}async $deserializeWebviewPanel($,m,t,i){const a=this.h.get(m);if(!a)throw new Error(`No serializer found for '${m}'`);const{serializer:b,extension:E}=a,v=this.j.createNewWebview($,t.webviewOptions,E),r=this.createNewWebviewPanel($,m,t.title,i,t.panelOptions,v,t.active);await b.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel($,m,t,i,a,b,E){const v=new R($,this.f,b,{viewType:m,title:t,viewColumn:i,panelOptions:a,active:E});return this.g.set($,v),v}getWebviewPanel($){return this.g.get($)}}e.$pdc=D;function c(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Re[259],Me([1,0,5,6,63,8,3,7]),function(we,e,y,M,C,L,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;class k extends M.$Rc{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(D,c,p,$,m,t){super(),this.#u=!1,this.#a=this.B(new y.$Md),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new y.$Md),this.onDidDispose=this.#c.event,this.#i=p,this.#s=$,this.#e=D,this.#t=c,this.#l=m,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#r}set description(D){this.a(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#u||(this.#n=D,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(D){this.a(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#u)throw new Error("Webview is disposed")}}class f{constructor(D,c){this.d=c,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$aK.MainThreadWebviewViews)}registerWebviewViewProvider(D,c,p,$){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:p,extension:D}),this.a.$registerWebviewViewProvider((0,C.$Qcc)(D),c,{retainContextWhenHidden:$?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,C.$Occ)(D)}),new l.$cK(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(D,c,p,$,m){const t=this.b.get(c);if(!t)throw new Error(`No view provider found for '${c}'`);const{provider:i,extension:a}=t,b=this.d.createNewWebview(D,{},a),E=new k(D,this.a,c,p,b,!0);this.c.set(D,E),await i.resolveWebviewView(E,{state:$},m)}async $onDidChangeWebviewViewVisibility(D,c){this.e(D)._setVisible(c)}async $disposeWebviewView(D){const c=this.e(D);this.c.delete(D),c.dispose(),this.d.deleteWebview(D)}e(D){const c=this.c.get(D);if(!c)throw new Error("No webview found");return c}}e.$odc=f}),define(Re[108],Me([1,0,5,3,2,13,15,4,17,25]),function(we,e,y,M,C,L,A,l,k,f){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0;let D=class{static{R=this}static{this.a={focused:!0,active:!0}}getState(p){const $=this.d;return{get focused(){return $.focused},get active(){return(0,f.$aF)(p,"windowActivity"),$.active}}}constructor(p){this.c=new y.$Md,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=p.getProxy(M.$aK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:$,isActive:m})=>{this.onDidChangeWindowProperty("focused",$),this.onDidChangeWindowProperty("active",m)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,$){$!==this.d[p]&&(this.d={...this.d,[p]:$},this.c.fire(this.d))}openUri(p,$){let m;if(typeof p=="string"){m=p;try{p=C.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,A.$Ae)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,m,$)}async asExternalUri(p,$){if((0,A.$Ae)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this.b.$asExternalUri(p,$);return C.URI.from(m)}};e.$Scc=D,e.$Scc=D=R=qe([We(0,k.$bM)],D),e.$Tcc=(0,l.$Nh)("IExtHostWindow")}),define(Re[260],Me([1,0,226,27,17]),function(we,e,y,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=void 0;let L=class extends y.$Rdc{constructor(l,k){super(l,k)}f(l,k,f){k.apply(console,f)}};e.$Yfc=L,e.$Yfc=L=qe([We(0,C.$bM),We(1,M.$rM)],L)}),define(Re[261],Me([1,0,12,26,21,9,5,6,132,215,47]),function(we,e,y,M,C,L,A,l,k,f,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$i4b=e.ResponsiveState=e.RequestInitiator=e.$h4b=e.$g4b=void 0;function c(h,P){try{return JSON.stringify(h,P)}catch{return"null"}}const p="$$ref$$",$={[p]:-1};class m{constructor(P,W){this.jsonString=P,this.referencedBuffers=W}}function t(h,P=null,W=!1){const K=[];return{jsonString:(W?c:JSON.stringify)(h,(B,O)=>{if(typeof O>"u")return $;if(typeof O=="object"){if(O instanceof M.$ae){const N=K.push(O)-1;return{[p]:N}}if(P)return P(B,O)}return O}),referencedBuffers:K}}e.$g4b=t;function i(h,P,W){return JSON.parse(h,(K,j)=>{if(j){const B=j[p];if(typeof B=="number")return P[B];if(W&&j.$mid===1)return W.transformIncoming(j)}return j})}e.$h4b=i;function a(h,P){return JSON.stringify(h,P)}function b(h){return h?(P,W)=>W&&W.$mid===1?h.transformOutgoing(W):W:null}var E;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));var v;(function(h){h[h.Responsive=0]="Responsive",h[h.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const r=()=>{},s=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class o extends l.$Rc{static{D=s}static{this.a=3*1e3}constructor(P,W=null,K=null){super(),this[D]=!0,this.b=this.B(new A.$Md),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=W,this.g=K,this.h=b(this.g),this.j=!1,this.m=[],this.s=[];for(let j=0,B=R.$iv.count;j<B;j++)this.m[j]=null,this.s[j]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new y.$5g(()=>this.H(),1e3)),this.c.onMessage(j=>this.L(j))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const W=this.w[P];delete this.w[P],W.resolveErr(L.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+o.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+o.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,k.$Lm)(P,this.g):P}getProxy(P){const{nid:W,sid:K}=P;return this.s[W]||(this.s[W]=this.J(W,K)),this.s[W]}J(P,W){const K={get:(j,B)=>(typeof B=="string"&&!j[B]&&B.charCodeAt(0)===36&&(j[B]=(...O)=>this.U(P,B,O)),B===n?W:j[B])};return new Proxy(Object.create(null),K)}set(P,W){return this.m[P.nid]=W,W}assertRegistered(P){for(let W=0,K=P.length;W<K;W++){const j=P[W];if(!this.m[j.nid])throw new Error(`Missing proxy instance ${j.sid}`)}}L(P){if(this.j)return;const W=P.byteLength,K=d.read(P,0),j=K.readUInt8(),B=K.readUInt32();switch(j){case 1:case 2:{let{rpcId:O,method:N,args:te}=S.deserializeRequestJSONArgs(K);this.g&&(te=(0,k.$Lm)(te,this.g)),this.M(W,B,O,N,te,j===2);break}case 3:case 4:{let{rpcId:O,method:N,args:te}=S.deserializeRequestMixedArgs(K);this.g&&(te=(0,k.$Lm)(te,this.g)),this.M(W,B,O,N,te,j===4);break}case 5:{this.f?.logIncoming(W,B,0,"ack"),this.G(B);break}case 6:{this.N(W,B);break}case 7:{this.O(W,B,void 0);break}case 9:{let O=S.deserializeReplyOKJSON(K);this.g&&(O=(0,k.$Lm)(O,this.g)),this.O(W,B,O);break}case 10:{const O=S.deserializeReplyOKJSONWithBuffers(K,this.g);this.O(W,B,O);break}case 8:{const O=S.deserializeReplyOKVSBuffer(K);this.O(W,B,O);break}case 11:{let O=S.deserializeReplyErrError(K);this.g&&(O=(0,k.$Lm)(O,this.g)),this.P(W,B,O);break}case 12:{this.P(W,B,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,W,K,j,B,O){this.f?.logIncoming(P,W,1,`receiveRequest ${(0,R.$kv)(K)}.${j}(`,B);const N=String(W);let te,Y;if(O){const Se=new C.$Wd;B.push(Se.token),te=this.Q(K,j,B),Y=()=>Se.cancel()}else te=this.Q(K,j,B),Y=r;this.u[N]=Y;const Ee=S.serializeAcknowledged(W);this.f?.logOutgoing(Ee.byteLength,W,1,"ack"),this.c.send(Ee),te.then(Se=>{delete this.u[N];const Pe=S.serializeReplyOK(W,Se,this.h);this.f?.logOutgoing(Pe.byteLength,W,1,"reply:",Se),this.c.send(Pe)},Se=>{delete this.u[N];const Pe=S.serializeReplyErr(W,Se);this.f?.logOutgoing(Pe.byteLength,W,1,"replyErr:",Se),this.c.send(Pe)})}N(P,W){this.f?.logIncoming(P,W,1,"receiveCancel");const K=String(W);this.u[K]?.()}O(P,W,K){this.f?.logIncoming(P,W,0,"receiveReply:",K);const j=String(W);if(!this.w.hasOwnProperty(j))return;const B=this.w[j];delete this.w[j],B.resolveOk(K)}P(P,W,K){this.f?.logIncoming(P,W,0,"receiveReplyErr:",K);const j=String(W);if(!this.w.hasOwnProperty(j))return;const B=this.w[j];delete this.w[j];let O;K&&(K.$isError?(O=new Error,O.name=K.name,O.message=K.message,O.stack=K.stack):O=K),B.resolveErr(O)}Q(P,W,K){try{return Promise.resolve(this.S(P,W,K))}catch(j){return Promise.reject(j)}}S(P,W,K){const j=this.m[P];if(!j)throw new Error("Unknown actor "+(0,R.$kv)(P));const B=j[W];if(typeof B!="function")throw new Error("Unknown method "+W+" on actor "+(0,R.$kv)(P));return B.apply(j,K)}U(P,W,K){if(this.j)return new f.$f4b;let j=null;if(K.length>0&&C.CancellationToken.isCancellationToken(K[K.length-1])&&(j=K.pop()),j&&j.isCancellationRequested)return Promise.reject(L.$5());const B=S.serializeRequestArguments(K,this.h),O=++this.t,N=String(O),te=new f.$e4b,Y=new l.$Qc;j&&Y.add(j.onCancellationRequested(()=>{const Se=S.serializeCancel(O);this.f?.logOutgoing(Se.byteLength,O,0,"cancel"),this.c.send(S.serializeCancel(O))})),this.w[N]=new w(te,Y),this.F(O);const Ee=S.serializeRequest(O,P,W,B,!!j);return this.f?.logOutgoing(Ee.byteLength,O,0,`request: ${(0,R.$kv)(P)}.${W}(`,K),this.c.send(Ee),te}}e.$i4b=o;class w{constructor(P,W){this.a=P,this.b=W}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,W,K){const j=new d(M.$ae.alloc(K+1+4),0);return j.writeUInt8(P),j.writeUInt32(W),j}static read(P,W){return new d(P,W)}get buffer(){return this.a}constructor(P,W){this.a=P,this.b=W}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const K=this.a.slice(this.b,this.b+P).toString();return this.b+=P,K}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P);return this.b+=P,W}static sizeMixedArray(P){let W=0;W+=1;for(let K=0,j=P.length;K<j;K++){const B=P[K];switch(W+=1,B.type){case 1:W+=this.sizeLongString(B.value);break;case 2:W+=this.sizeVSBuffer(B.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(B.value);for(let O=0;O<B.buffers.length;++O)W+=this.sizeVSBuffer(B.buffers[O]);break;case 4:break}}return W}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let W=0,K=P.length;W<K;W++){const j=P[W];switch(j.type){case 1:this.writeUInt8(1),this.writeLongString(j.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(j.value);break;case 3:this.writeUInt8(3),this.writeUInt32(j.buffers.length),this.writeLongString(j.value);for(let B=0;B<j.buffers.length;++B)this.writeBuffer(j.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const W=new Array(P);for(let K=0;K<P;K++)switch(this.readUInt8()){case 1:W[K]=this.readLongString();break;case 2:W[K]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),O=this.readLongString(),N=[];for(let te=0;te<B;++te)N.push(this.readVSBuffer());W[K]=new R.$lv(i(O,N,null));break}case 4:W[K]=void 0;break}return W}}var I;(function(h){h[h.Simple=0]="Simple",h[h.Mixed=1]="Mixed"})(I||(I={}));class S{static a(P){for(let W=0,K=P.length;W<K;W++)if(P[W]instanceof M.$ae||P[W]instanceof R.$lv||typeof P[W]>"u")return!0;return!1}static serializeRequestArguments(P,W){if(this.a(P)){const K=[];for(let j=0,B=P.length;j<B;j++){const O=P[j];if(O instanceof M.$ae)K[j]={type:2,value:O};else if(typeof O>"u")K[j]={type:4};else if(O instanceof R.$lv){const{jsonString:N,referencedBuffers:te}=t(O.value,W);K[j]={type:3,value:M.$ae.fromString(N),buffers:te}}else K[j]={type:1,value:M.$ae.fromString(a(O,W))}}return{type:1,args:K}}return{type:0,args:a(P,W)}}static serializeRequest(P,W,K,j,B){switch(j.type){case 0:return this.b(P,W,K,j.args,B);case 1:return this.c(P,W,K,j.args,B)}}static b(P,W,K,j,B){const O=M.$ae.fromString(K),N=M.$ae.fromString(j);let te=0;te+=d.sizeUInt8(),te+=d.sizeShortString(O),te+=d.sizeLongString(N);const Y=d.alloc(B?2:1,P,te);return Y.writeUInt8(W),Y.writeShortString(O),Y.writeLongString(N),Y.buffer}static deserializeRequestJSONArgs(P){const W=P.readUInt8(),K=P.readShortString(),j=P.readLongString();return{rpcId:W,method:K,args:JSON.parse(j)}}static c(P,W,K,j,B){const O=M.$ae.fromString(K);let N=0;N+=d.sizeUInt8(),N+=d.sizeShortString(O),N+=d.sizeMixedArray(j);const te=d.alloc(B?4:3,P,N);return te.writeUInt8(W),te.writeShortString(O),te.writeMixedArray(j),te.buffer}static deserializeRequestMixedArgs(P){const W=P.readUInt8(),K=P.readShortString(),j=P.readMixedArray(),B=new Array(j.length);for(let O=0,N=j.length;O<N;O++){const te=j[O];typeof te=="string"?B[O]=JSON.parse(te):B[O]=te}return{rpcId:W,method:K,args:B}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,W,K){if(typeof W>"u")return this.d(P);if(W instanceof M.$ae)return this.e(P,W);if(W instanceof R.$lv){const{jsonString:j,referencedBuffers:B}=t(W.value,K,!0);return this.g(P,j,B)}else return this.f(P,c(W,K))}static d(P){return d.alloc(7,P,0).buffer}static e(P,W){let K=0;K+=d.sizeVSBuffer(W);const j=d.alloc(8,P,K);return j.writeVSBuffer(W),j.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,W){const K=M.$ae.fromString(W);let j=0;j+=d.sizeLongString(K);const B=d.alloc(9,P,j);return B.writeLongString(K),B.buffer}static g(P,W,K){const j=M.$ae.fromString(W);let B=0;B+=d.sizeUInt32,B+=d.sizeLongString(j);for(const N of K)B+=d.sizeVSBuffer(N);const O=d.alloc(10,P,B);O.writeUInt32(K.length),O.writeLongString(j);for(const N of K)O.writeBuffer(N);return O.buffer}static deserializeReplyOKJSON(P){const W=P.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(P,W){const K=P.readUInt32(),j=P.readLongString(),B=[];for(let O=0;O<K;++O)B.push(P.readVSBuffer());return new R.$lv(i(j,B,W))}static serializeReplyErr(P,W){const K=W?c(L.$2(W),null):void 0;if(typeof K!="string")return this.h(P);const j=M.$ae.fromString(K);let B=0;B+=d.sizeLongString(j);const O=d.alloc(11,P,B);return O.writeLongString(j),O.buffer}static deserializeReplyErrError(P){const W=P.readLongString();return JSON.parse(W)}static h(P){return d.alloc(12,P,0).buffer}}var u;(function(h){h[h.RequestJSONArgs=1]="RequestJSONArgs",h[h.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",h[h.RequestMixedArgs=3]="RequestMixedArgs",h[h.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",h[h.Acknowledged=5]="Acknowledged",h[h.Cancel=6]="Cancel",h[h.ReplyOKEmpty=7]="ReplyOKEmpty",h[h.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",h[h.ReplyOKJSON=9]="ReplyOKJSON",h[h.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",h[h.ReplyErrError=11]="ReplyErrError",h[h.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var g;(function(h){h[h.String=1]="String",h[h.VSBuffer=2]="VSBuffer",h[h.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",h[h.Undefined=4]="Undefined"})(g||(g={}))}),define(Re[262],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;const y=function(L){const A=l=>{globalThis.removeEventListener("message",A);const k=l.data;Object.defineProperties(globalThis,{postMessage:{value(f,R){k.postMessage(f,R)}},onmessage:{get(){return k.onmessage},set(f){k.onmessage=f}}}),k.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),k.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",A)}.toString();class M extends EventTarget{constructor(L,A,l){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const k=`((${y})('${A}'))`,f=new Blob([k],{type:"application/javascript"}),R=URL.createObjectURL(f),D=new MessageChannel,c=R,p={type:"_newWorker",id:c,port:D.port2,url:R,options:l};L(p,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{L({type:"_terminateWorker",id:c}),URL.revokeObjectURL(R),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set($){D.port1.onmessage=$}},onmessageerror:{get(){return D.port1.onmessageerror},set($){D.port1.onmessageerror=$}}}),D.port1.addEventListener("messageerror",$=>{const m=new MessageEvent("messageerror",{data:$.data});this.dispatchEvent(m)}),D.port1.addEventListener("message",$=>{const m=new MessageEvent("message",{data:$.data});this.dispatchEvent(m)}),D.port1.start()}}e.$1fc=M}),define(Re[263],Me([1,0,5,30,32,4]),function(we,e,y,M,C,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.$vJ=e.OutputChannelUpdateMode=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=void 0,e.$lJ="text/x-code-output",e.$mJ="output",e.$nJ="Log",e.$oJ="text/x-code-log-output",e.$pJ="log",e.$qJ="workbench.panel.output",e.$rJ=new C.$5i("inOutput",!1),e.$sJ=new C.$5i("activeLogOutput",!1),e.$tJ=new C.$5i("outputView.scrollLock",!1),e.$uJ=(0,L.$Nh)("outputService");var A;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$vJ={OutputChannels:"workbench.contributions.outputChannels"};class l{constructor(){this.a=new Map,this.b=new y.$Md,this.onDidRegisterChannel=this.b.event,this.c=new y.$Md,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(R=>f.push(R)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}M.$cn.add(e.$vJ.OutputChannels,new l),e.$wJ=new C.$5i("activeOutputChannel","")}),define(Re[109],Me([1,0,3,4,17,20,14,263,61,27,39,129,26,16,38,5,6]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0;class i extends A.$bj{get disposed(){return this.n}constructor(v,r,s,n,o){super(),this.id=v,this.name=r,this.r=s,this.s=n,this.extension=o,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(w=>this.setLevel(w)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.m;this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Clear,v)}replace(v){const r=this.m;this.info(v),this.s.$update(this.id,l.OutputChannelUpdateMode.Replace,r),this.visible&&this.r.flush()}show(v,r){this.r.flush(),this.s.$reveal(this.id,!!(typeof v=="boolean"?v:r))}hide(){this.s.$close(this.id)}g(v,r){this.m+=c.$ae.fromString(r).byteLength,(0,A.log)(this.r,v,r),this.visible&&(this.r.flush(),this.s.$update(this.id,l.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class a extends i{appendLine(v){this.append(v)}}let b=class{constructor(v,r,s,n,o,w){this.i=r,this.j=s,this.k=n,this.l=o,this.m=w,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(y.$aK.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,D.$bm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[r,s]of this.g)s.visible=r===this.h}createOutputChannel(v,r,s){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const n=typeof r=="object"&&r.log,o=(0,p.$xf)(r)?r:void 0;if((0,p.$xf)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let w;const d=this.i.environment.extensionLogLevel?.find(([S])=>L.$3l.equals(s.identifier,S))?.[1];d&&(w=(0,A.$lj)(d));const I=n?this.o(v,w,s):this.n(v,o,s);return I.then(S=>{this.g.set(S.id,S),S.visible=S.id===this.h}),n?this.r(v,w??this.m.getLevel(),I):this.q(v,I)}async n(v,r,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,o=this.k.extUri.joinPath(n,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),w=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(v,o,r,s.identifier.value);return new i(d,v,w,this.a,s)}async o(v,r,s){const n=await this.p(s),o=v.replace(/[\\/:\*\?"<>\|]/g,""),w=this.k.extUri.joinPath(n,`${o}.log`),d=`${s.identifier.value}.${o}`,I=this.l.createLogger(w,{id:d,name:v,logLevel:r,extensionId:s.identifier.value});return new a(d,v,I,this.a,s)}p(v){let r=this.d.get(v.identifier.value);if(!r){const s=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(s)}catch(n){if((0,$.$mk)(n)!==$.FileSystemProviderErrorCode.FileExists)throw n}return s})())}return r}q(v,r){let s=!1;const n=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return v},append(o){n(),r.then(w=>w.append(o))},appendLine(o){n(),r.then(w=>w.appendLine(o))},clear(){n(),r.then(o=>o.clear())},replace(o){n(),r.then(w=>w.replace(o))},show(o,w){n(),r.then(d=>d.show(o,w))},hide(){n(),r.then(o=>o.hide())},dispose(){s=!0,r.then(o=>o.dispose())}}}r(v,r,s){const n=new t.$Qc,o=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},w=n.add(new m.$Md);function d(I){r=I,w.fire(I)}return s.then(I=>{n.add(I),I.logLevel!==r&&d(I.logLevel),n.add(I.onDidChangeLogLevel(S=>d(S)))}),{...this.q(v,s),get logLevel(){return r},onDidChangeLogLevel:w.event,trace(I,...S){o(),s.then(u=>u.trace(I,...S))},debug(I,...S){o(),s.then(u=>u.debug(I,...S))},info(I,...S){o(),s.then(u=>u.info(I,...S))},warn(I,...S){o(),s.then(u=>u.warn(I,...S))},error(I,...S){o(),s.then(u=>u.error(I,...S))},dispose(){n.dispose()}}}};e.$Ccc=b,e.$Ccc=b=qe([We(0,C.$bM),We(1,f.$rM),We(2,k.$fcc),We(3,R.$Mbc),We(4,A.$9i),We(5,A.$8i)],b),e.$Dcc=(0,M.$Nh)("IExtHostOutputService")}),define(Re[264],Me([1,0,4,12]),function(we,e,y,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0,e.$qm=(0,y.$Nh)("remoteAgentService"),e.$rm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(C){let L=1/0;for(let l=0;l<this.maxSampleCount;l++){const k=await C.getRoundTripTime();if(k===void 0)return;L=Math.min(L,k/2),await(0,M.$Tg)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((l,k)=>l+k,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((l,k)=>l+k,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Re[265],Me([1,0,43,13,19,22,23,2,4,186,54,208,264]),function(we,e,y,M,C,L,A,l,k,f,R,D,c){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$PJ=e.$OJ=void 0,e.$OJ=(0,k.$Nh)("pathService");let $=p=class{constructor(t,i,a,b){this.d=t,this.e=i,this.f=a,this.g=b,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const E=await this.e.getEnvironment();return this.c=E?.userHome??t})()}hasValidBasename(t,i,a){return typeof i=="string"||typeof i>"u"?this.a.then(b=>this.h(t,b,i)):this.h(t,i,a)}h(t,i,a){return t.scheme===M.Schemas.file||t.scheme===M.Schemas.vscodeRemote?(0,y.$Uf)(a??(0,A.$rg)(t),i===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return M.Schemas.vscodeRemote;const a=(0,f.$LJ)(i.getWorkspace());if(a)return a;const b=i.getWorkspace().folders[0];if(b)return b.uri.scheme;const E=i.getWorkspace().configuration;return E?E.scheme:M.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?C.$ec:C.$fc)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const b=t.indexOf("/",2);b===-1?(i=t.substring(2),t="/"):(i=t.substring(2,b),t=t.substring(b)||"/")}return l.URI.from({scheme:M.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$PJ=$,e.$PJ=$=p=qe([We(1,c.$qm),We(2,D.$xJ),We(3,R.$Wh)],$)}),define(Re[110],Me([1,0]),function(we,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$yI=e.$xI=void 0;class y{constructor(A,l){this.line=A,this.character=l}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,l){return new y(0,0)}with(A){return new y(0,0)}}e.$xI=y;class M{constructor(A,l,k,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,l),this.end=new y(k,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new M(0,0,0,0)}with(A){return new M(0,0,0,0)}}e.$yI=M;var C;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(C||(e.TextSearchCompleteMessageType=C={}))}),define(Re[48],Me([1,0,18,37,24,43,15,4,19,9,110,12]),function(we,e,y,M,C,L,A,l,k,f,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.SearchErrorCode=e.$NI=e.$MI=e.SearchSortOrder=e.ViewMode=e.$LI=e.$KI=e.$JI=e.$II=e.SearchCompletionExitCode=e.$HI=e.$GI=e.$FI=e.QueryType=e.SearchProviderType=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$zI="workbench.view.search",e.$AI="workbench.panel.search",e.$BI="workbench.view.search",e.$CI="search-result",e.$DI="search.exclude";const c="\u27EA ",p=" characters skipped \u27EB",$=(c.length+p.length+5)*2;e.$EI=(0,l.$Nh)("searchService");var m;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text"})(m||(e.SearchProviderType=m={}));var t;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text"})(t||(e.QueryType=t={}));function i(ge){return!!ge.preview}e.$FI=i;function a(ge){return!!ge.resource}e.$GI=a;function b(ge){return!!ge.message}e.$HI=b;var E;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(E||(e.SearchCompletionExitCode=E={}));class v{constructor(me){this.resource=me,this.results=[]}}e.$II=v;class r{constructor(me,ce,se,$e){this.ranges=ce,this.webviewIndex=$e;const _=Array.isArray(ce)?ce:[ce];if(se&&se.matchLines===1&&s(_)){me=(0,A.$qf)(me,se.matchLines);let z="",V=0,ue=0;const ye=Math.floor(se.charsPerLine/5),be=[];for(const pe of _){const De=Math.max(pe.startColumn-ye,0),ne=pe.startColumn+se.charsPerLine;if(De>ue+ye+$){const le=c+(De-ue)+p;z+=le+me.slice(De,ne),V+=De-(ue+le.length)}else z+=me.slice(ue,ne);be.push(new o(0,pe.startColumn-V,pe.endColumn-V)),ue=ne}this.preview={text:z,matches:Array.isArray(this.ranges)?be:be[0]}}else{const z=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:me,matches:(0,y.$1b)(ce,V=>new n(V.startLineNumber-z,V.startColumn,V.endLineNumber-z,V.endColumn))}}}}e.$JI=r;function s(ge){const me=ge[0].startLineNumber;for(const ce of ge)if(ce.startLineNumber!==me||ce.endLineNumber!==me)return!1;return!0}class n{constructor(me,ce,se,$e){this.startLineNumber=me,this.startColumn=ce,this.endLineNumber=se,this.endColumn=$e}}e.$KI=n;class o extends n{constructor(me,ce,se){super(me,ce,me,se)}}e.$LI=o;var w;(function(ge){ge.List="list",ge.Tree="tree"})(w||(e.ViewMode=w={}));var d;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function I(ge,me=!0){const ce=ge&&ge.files&&ge.files.exclude,se=me&&ge&&ge.search&&ge.search.exclude;if(!ce&&!se)return;if(!ce||!se)return ce||se;let $e=Object.create(null);return $e=C.$6m($e,C.$3m(ce)),$e=C.$6m($e,C.$3m(se),!0),$e}e.$MI=I;function S(ge,me){return ge.excludePattern&&M.$tj(ge.excludePattern,me)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&M.$tj(ge.includePattern,me)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(ce=>{const se=ce.folder.fsPath;if(L.$Wf(me,se)){const $e=k.$kc(se,me);return!ce.includePattern||!!M.$tj(ce.includePattern,$e)}else return!1}):!1:!0}e.$NI=S;var u;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(u||(e.SearchErrorCode=u={}));class g extends Error{constructor(me,ce){super(me),this.code=ce}}e.$OI=g;function h(ge){const me=ge.message;if((0,f.$3)(ge))return new g(me,u.canceled);try{const ce=JSON.parse(me);return new g(ce.message,ce.code)}catch{return new g(me,u.other)}}e.$PI=h;function P(ge){const me={message:ge.message,code:ge.code};return new Error(JSON.stringify(me))}e.$QI=P;function W(ge){return ge.type==="error"?!0:ge.type==="success"}e.$RI=W;function K(ge){return ge.type==="success"}e.$SI=K;function j(ge){return!!ge.path}e.$TI=j;function B(ge,me){const ce=ge.searchPath?ge.searchPath:ge.relativePath;return(0,A.$nf)(ce,me)}e.$UI=B;class O{constructor(me){this.path=me,this.results=[]}addMatch(me){this.results.push(me)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$VI=O;function N(ge,me){const ce={...ge||{},...me||{}};return Object.keys(ce).filter(se=>{const $e=ce[se];return typeof $e=="boolean"&&$e})}e.$WI=N;class te{constructor(me,ce){this.c=null,this.a={...me.excludePattern||{},...ce.excludePattern||{}},this.b=M.$uj(this.a);let se=me.includePattern;ce.includePattern&&(se?se={...se,...ce.includePattern}:se=ce.includePattern),se&&(this.c=M.$uj(se))}matchesExcludesSync(me,ce,se){return!!(this.b&&this.b(me,ce,se))}includedInQuerySync(me,ce,se){return!(this.b&&this.b(me,ce,se)||this.c&&!this.c(me,ce,se))}includedInQuery(me,ce,se){const $e=this.b(me,ce,se),_=()=>this.c?!!this.c(me,ce,se):!0;return(0,D.$Fg)($e)?$e.then(z=>z?!1:_()):_()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$XI=te;function Y(ge){for(const me in ge)if(typeof ge[me]!="boolean")return!0;return!1}function Ee(ge){if(!ge)return;let me;return ce=>(me||(me=(ge()||Promise.resolve([])).then(se=>se?Pe(se):{})),me.then(se=>!!se[ce]))}e.$YI=Ee;function Se(ge){if(!ge)return;let me;return ce=>{if(!me){const se=ge();me=se?Pe(se):{}}return!!me[ce]}}e.$ZI=Se;function Pe(ge){const me={};for(const ce of ge)me[ce]=!0;return me}}),define(Re[33],Me([1,0,18,12,21,5,6,49,13,117,23,15,2,158,4,14,175,54,39,27,17,8,7,55,48,3]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v,r,s,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0;function w(W,K,j){return new R.$jg(B=>u(B,j)).isEqual(W,K)}function d(W,K,j){return w(W.uri,K.uri,j)?0:(0,D.$Te)(W.uri.toString(),K.uri.toString())}function I(W,K,j){return W.index!==K.index?W.index<K.index?-1:1:w(W.uri,K.uri,j)?(0,D.$Te)(W.name,K.name):(0,D.$Te)(W.uri.toString(),K.uri.toString())}function S(W,K,j,B){const O=W.slice(0).sort((te,Y)=>j(te,Y,B)),N=K.slice(0).sort((te,Y)=>j(te,Y,B));return(0,y.$Db)(O,N,(te,Y)=>j(te,Y,B))}function u(W,K){const j=K.getCapabilities(W.scheme);return!(j&&j&1024)}class g extends i.$7h{static toExtHostWorkspace(K,j,B,O){if(!K)return{workspace:null,added:[],removed:[]};const{id:N,name:te,folders:Y,configuration:Ee,transient:Se,isUntitled:Pe}=K,ge=[],me=j;j?Y.forEach((_,z)=>{const V=c.URI.revive(_.uri),ue=g.o(B||j,V,O);ue?(ue.name=_.name,ue.index=_.index,ge.push(ue)):ge.push({uri:V,name:_.name,index:z})}):ge.push(...Y.map(({uri:_,name:z,index:V})=>({uri:c.URI.revive(_),name:z,index:V}))),ge.sort((_,z)=>_.index<z.index?-1:1);const ce=new g(N,te,ge,!!Se,Ee?c.URI.revive(Ee):null,!!Pe,_=>u(_,O)),{added:se,removed:$e}=S(me?me.workspaceFolders:[],ce.workspaceFolders,d,O);return{workspace:ce,added:se,removed:$e}}static o(K,j,B){for(let O=0;O<K.folders.length;O++){const N=K.workspaceFolders[O];if(w(N.uri,j,B))return N}}constructor(K,j,B,O,N,te,Y){super(K,B.map(Ee=>new i.$8h(Ee)),O,N,Y),this.t=j,this.u=te,this.q=[],this.s=l.$Th.forUris(Y),B.forEach(Ee=>{this.q.push(Ee),this.s.set(Ee.uri,Ee)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(K,j){return j&&this.s.get(K)&&(K=(0,R.$tg)(K)),this.s.findSubstr(K)}resolveWorkspaceFolder(K){return this.s.get(K)}}let h=class{constructor(K,j,B,O,N){this.c=new L.$Md,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Md,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Od,this.B=new Map,this.h=O,this.s=B,this.t=N,this.j=new f.$Nl,this.k=new M.$Rg,this.o=K.getProxy(o.$aK.MainThreadWorkspace),this.q=K.getProxy(o.$aK.MainThreadMessageService);const te=j.workspace;this.l=te?new g(te.id,te.name,[],!!te.transient,te.configuration?c.URI.revive(te.configuration):null,!!te.isUntitled,Y=>u(Y,B)):void 0}$initializeWorkspace(K,j){this.v=j,this.$acceptWorkspaceData(K),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?c.URI.from({scheme:k.Schemas.untitled,path:(0,R.$rg)((0,R.$tg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(K,j,B,...O){const N=[];if(Array.isArray(O)&&O.forEach(Pe=>{c.URI.isUri(Pe.uri)&&!N.some(ge=>w(ge.uri,Pe.uri,this.s))&&N.push({uri:Pe.uri,name:Pe.name||(0,R.$qg)(Pe.uri)})}),this.n||[j,B].some(Pe=>typeof Pe!="number"||Pe<0)||B===0&&N.length===0)return!1;const te=this.x?this.x.workspaceFolders:[];if(j+B>te.length)return!1;const Y=te.slice(0);Y.splice(j,B,...N.map(Pe=>({uri:Pe.uri,name:Pe.name||(0,R.$qg)(Pe.uri),index:void 0})));for(let Pe=0;Pe<Y.length;Pe++){const ge=Y[Pe];if(Y.some((me,ce)=>ce!==Pe&&w(ge.uri,me.uri,this.s)))return!1}Y.forEach((Pe,ge)=>Pe.index=ge);const{added:Ee,removed:Se}=S(te,Y,I,this.s);if(Ee.length===0&&Se.length===0)return!1;if(this.o){const Pe=K.displayName||K.name;this.o.$updateWorkspaceFolders(Pe,j,B,N).then(void 0,ge=>{this.n=void 0;const me={source:{identifier:K.identifier,label:K.displayName||K.name}};this.q.$showMessage(t.Severity.Error,(0,p.localize)(0,null,Pe,ge.toString()),me,[])})}return this.y(Y),!0}getWorkspaceFolder(K,j){if(this.x)return this.x.getWorkspaceFolder(K,j)}async getWorkspaceFolder2(K,j){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(K,j)}async resolveWorkspaceFolder(K){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(K)}getPath(){if(!this.x)return;const{folders:K}=this.x;if(K.length!==0)return K[0].uri.fsPath}getRelativePath(K,j){let B,O="";if(typeof K=="string"?(B=c.URI.file(K),O=K):typeof K<"u"&&(B=K,O=K.fsPath),!B)return O;const N=this.getWorkspaceFolder(B,!0);if(!N)return O;typeof j>"u"&&this.x&&(j=this.x.folders.length>1);let te=(0,R.$wg)(N.uri,B);return j&&N.name&&(te=`${N.name}/${te}`),te}y(K){this.x&&(this.n=g.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:K,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(K){const{workspace:j,added:B,removed:O}=g.toExtHostWorkspace(K,this.l,this.n,this.s);this.l=j||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:O}))}findFiles(K,j,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let te;if(j===null?te=!1:j&&(typeof j=="string"?te=j:te=j.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:Ee}=P(v.GlobPattern.from(K));return this.o.$startFileSearch(Y??null,Ee??null,te??null,B??null,N).then(Se=>Array.isArray(Se)?Se.map(Pe=>c.URI.revive(Pe)):[])}async findTextInFiles(K,j,B,O,N=C.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const te=this.j.getNext(),Y=typeof j.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:Ee,folder:Se}=P(v.GlobPattern.from(j.include)),Pe=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,ge={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof j.useParentIgnoreFiles=="boolean"?!j.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:Y,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:Ee,excludePattern:Pe},me=!1;if(this.u[te]=ce=>{if(me)return;const se=c.URI.revive(ce.resource);ce.results.forEach($e=>{(0,n.$FI)($e)?B({uri:se,preview:{text:$e.preview.text,matches:(0,y.$1b)($e.preview.matches,_=>new r.$eK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))},ranges:(0,y.$1b)($e.ranges,_=>new r.$eK(_.startLineNumber,_.startColumn,_.endLineNumber,_.endColumn))}):B({uri:se,text:$e.text,lineNumber:$e.lineNumber})})},N.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(K,Se??null,ge,te,N);return delete this.u[te],ce||{}}catch(ce){throw delete this.u[te],ce}}$handleTextSearchResult(K,j){this.u[j]?.(K)}async save(K){const j=await this.o.$save(K,{saveAs:!1});return c.URI.revive(j)}async saveAs(K){const j=await this.o.$save(K,{saveAs:!0});return c.URI.revive(j)}saveAll(K){return this.o.$saveAll(K)}resolveProxy(K){return this.o.$resolveProxy(K)}get trusted(){return this.v}requestWorkspaceTrust(K){return this.o.$requestWorkspaceTrust(K)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(K,j){if(this.w.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.w.set(K,j);const B=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerEditSessionIdentityProvider(O,B),(0,A.$Pc)(()=>{this.w.delete(K),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(K,j){this.h.info("Getting edit session identifier for workspaceFolder",K);const B=await this.resolveWorkspaceFolder(c.URI.revive(K));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const O=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!O),!O)return;const N=await O.provideEditSessionIdentity(B,j);if(this.h.info("Provider returned edit session identifier: ",N),!!N)return N}async $provideEditSessionIdentityMatch(K,j,B,O){this.h.info("Getting edit session identifier for workspaceFolder",K);const N=await this.resolveWorkspaceFolder(c.URI.revive(K));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const te=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!te),!te)return;const Y=await te.provideEditSessionIdentityMatch?.(j,B,O);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(K){return(j,B,O)=>{const N=function(Y){j.call(B,Y)};return N.extension=K,this.A.event(N,void 0,O)}}async $onWillCreateEditSessionIdentity(K,j,B){const O=await this.resolveWorkspaceFolder(c.URI.revive(K));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:O},j,async(N,te)=>{const Y=Date.now();await Promise.resolve(N),Date.now()-Y>B&&this.h.warn("SLOW edit session create-participant",te.extension.identifier)}),j.isCancellationRequested}registerCanonicalUriProvider(K,j){if(this.B.has(K))throw new Error(`A provider has already been registered for scheme ${K}`);this.B.set(K,j);const B=this.t.transformOutgoingScheme(K),O=this.z++;return this.o.$registerCanonicalUriProvider(O,B),(0,A.$Pc)(()=>{this.B.delete(K),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(K,j,B){const O=this.B.get(K.scheme);if(!O)return;const N=await O.provideCanonicalUri?.(c.URI.revive(K),j,B);if(N)return N}async $provideCanonicalUri(K,j,B){return this.provideCanonicalUri(c.URI.revive(K),{targetScheme:j},B)}};e.$Ybc=h,e.$Ybc=h=qe([We(0,E.$bM),We(1,b.$rM),We(2,a.$Mbc),We(3,m.$8i),We(4,s.$Wbc)],h),e.$Zbc=(0,$.$Nh)("IExtHostWorkspace");function P(W){let K,j;return W&&(typeof W=="string"?K=W:(K=W.pattern,j=c.URI.revive(W.baseUri))),{includePattern:K,folder:j}}}),define(Re[34],Me([1,0,24,5,33,3,7,177,96,16,12,4,17,14,2]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=e.$2bc=e.$1bc=void 0;function m(s,n){if(n){const o=n.split(".");let w=s;for(let d=0;w&&d<o.length;d++)w=w[o[d]];return w}}function t(s){return s instanceof $.URI}function i(s){return s&&s.uri instanceof $.URI&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof $.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function E(s){if(t(s))return{resource:s};if(i(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(a(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let v=class{constructor(n,o,w){this.a=n.getProxy(L.$aK.MainThreadConfiguration),this.c=o,this.b=w,this.d=new R.$Rg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new r(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,o){this.getConfigProvider().then(w=>w.$acceptConfigurationChanged(n,o))}};e.$1bc=v,e.$1bc=v=qe([We(0,c.$bM),We(1,C.$Zbc),We(2,p.$8i)],v);class r{constructor(n,o,w,d){this.a=new M.$Md,this.b=n,this.f=d,this.c=o,this.e=l.$An.parse(w),this.d=this.k(w.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,o){const w={data:this.e.toData(),workspace:this.c.workspace};this.e=l.$An.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(o,w))}getConfiguration(n,o,w){const d=E(o)||{},I=this.g(n?m(this.e.getValue(void 0,d,this.c.workspace),n):this.e.getValue(void 0,d,this.c.workspace));n&&this.h(n,d,w?.identifier);function S(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const u={has(g){return typeof m(I,g)<"u"},get:(g,h)=>{this.h(n?`${n}.${g}`:g,d,w?.identifier);let P=m(I,g);if(typeof P>"u")P=h;else{let W;const K=(j,B)=>{if((0,f.$zf)(j)){let O;const N=()=>{W=W||(0,y.$3m)(I),O=O||m(W,B)};return new Proxy(j,{get:(te,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||m(W,B),O[Y];const Ee=te[Y];return typeof Y=="string"?K(Ee,`${B}.${Y}`):Ee},set:(te,Y,Ee)=>(N(),O&&(O[Y]=Ee),!0),deleteProperty:(te,Y)=>(N(),O&&delete O[Y],!0),defineProperty:(te,Y,Ee)=>(N(),O&&Object.defineProperty(O,Y,Ee),!0)})}return Array.isArray(j)?(0,y.$3m)(j):j};P=K(P,g)}return P},update:(g,h,P,W)=>{g=n?`${n}.${g}`:g;const K=S(P);return h!==void 0?this.b.$updateConfigurationOption(K,g,h,d,W):this.b.$removeConfigurationOption(K,g,d,W)},inspect:g=>{g=n?`${n}.${g}`:g;const h=this.e.inspect(g,d,this.c.workspace);if(h)return{key:g,defaultValue:(0,y.$3m)(h.policy?.value??h.default?.value),globalValue:(0,y.$3m)(h.user?.value??h.application?.value),workspaceValue:(0,y.$3m)(h.workspace?.value),workspaceFolderValue:(0,y.$3m)(h.workspaceFolder?.value),defaultLanguageValue:(0,y.$3m)(h.default?.override),globalLanguageValue:(0,y.$3m)(h.user?.override??h.application?.override),workspaceLanguageValue:(0,y.$3m)(h.workspace?.override),workspaceFolderLanguageValue:(0,y.$3m)(h.workspaceFolder?.override),languageIds:(0,y.$3m)(h.overrideIdentifiers)}}};return typeof I=="object"&&(0,y.$6m)(u,I,!1),Object.freeze(u)}g(n){const o=w=>(0,f.$zf)(w)?new Proxy(w,{get:(d,I)=>o(d[I]),set:(d,I,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(I)}' of object`)},deleteProperty:(d,I)=>{throw new Error(`TypeError: Cannot delete read only property '${String(I)}' of object`)},defineProperty:(d,I)=>{throw new Error(`TypeError: Cannot define property '${String(I)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):w;return o(n)}h(n,o,w){const d=k.$rn.test(n)?4:this.d.get(n),I=w?`[${w.value}] `:"";if(d===4){typeof o?.resource>"u"&&this.f.warn(`${I}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){o?.resource&&this.f.warn(`${I}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,o){const w=new l.$Cn(n,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,I)=>w.affectsConfiguration(d,E(I))})}k(n){return n.reduce((o,w)=>(o.set(w[0],w[1]),o),new Map)}}e.$2bc=r,e.$3bc=(0,D.$Nh)("IExtHostConfiguration")}),define(Re[111],Me([1,0,2,12,5,3,7,33,59,34,21,62,17,27,4,13,22,14,80,214,9]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=e.$Zcc=e.$Ycc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var v;(function(K){function j(O){if(O!=null)return O}K.from=j;function B(O){if(O!=null)return O}K.to=B})(v||(v={}));var r;(function(K){function j(O){if(O!=null)return O}K.from=j;function B(O){if(O!=null)return O}K.to=B})(r||(r={}));var s;(function(K){function j(O){if(O!=null)return O}K.from=j;function B(O){if(O!=null)return O}K.to=B})(s||(s={}));var n;(function(K){function j(N){if(N){const te=N;return te&&!!te.process}else return!1}K.is=j;function B(N){if(N==null)return;const te={process:N.process,args:N.args};return N.options&&(te.options=s.from(N.options)),te}K.from=B;function O(N){if(N!=null)return new A.$WK(N.process,N.args,N.options)}K.to=O})(n||(n={}));var o;(function(K){function j(O){if(O!=null)return O}K.from=j;function B(O){if(O!=null)return O}K.to=B})(o||(o={}));var w;(function(K){function j(N){if(N){const te=N;return te&&(!!te.commandLine||!!te.command)}else return!1}K.is=j;function B(N){if(N==null)return;const te={};return N.commandLine!==void 0?te.commandLine=N.commandLine:(te.command=N.command,te.args=N.args),N.options&&(te.options=o.from(N.options)),te}K.from=B;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.$XK(N.commandLine,N.options):new A.$XK(N.command,N.args?N.args:[],N.options)}K.to=O})(w||(w={}));var d;(function(K){function j(N){if(N){const te=N;return te&&te.customExecution==="customExecution"}else return!1}K.is=j;function B(N){return{customExecution:"customExecution"}}K.from=B;function O(N,te){return te.get(N)}K.to=O})(d||(e.CustomExecutionDTO=d={}));var I;(function(K){function j(B,O){let N;return B.scope!==void 0&&typeof B.scope!="number"?N=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===A.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=b.$OF),{id:B._id,workspaceFolder:N}}K.from=j})(I||(e.TaskHandleDTO=I={}));var S;(function(K){function j(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}K.from=j})(S||(S={}));var u;(function(K){function j(N,te){if(N==null)return[];const Y=[];for(const Ee of N){const Se=B(Ee,te);Se&&Y.push(Se)}return Y}K.fromMany=j;function B(N,te){if(N==null)return;let Y;N.execution instanceof A.$WK?Y=n.from(N.execution):N.execution instanceof A.$XK?Y=w.from(N.execution):N.execution&&N.execution instanceof A.$YK&&(Y=d.from(N.execution));const Ee=v.from(N.definition);let Se;return N.scope?typeof N.scope=="number"?Se=N.scope:Se=N.scope.uri:Se=A.TaskScope.Workspace,!Ee||!Se?void 0:{_id:N._id,definition:Ee,name:N.name,source:{extensionId:te.identifier.value,label:N.source,scope:Se},execution:Y,isBackground:N.isBackground,group:S.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}K.from=B;async function O(N,te,Y){if(N==null)return;let Ee;n.is(N.execution)?Ee=n.to(N.execution):w.is(N.execution)?Ee=w.to(N.execution):d.is(N.execution)&&(Ee=d.to(N._id,Y));const Se=v.to(N.definition);let Pe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Pe=N.source.scope:Pe=await te.resolveWorkspaceFolder(y.URI.revive(N.source.scope)):Pe=A.TaskScope.Workspace),!Se||!Pe)return;const ge=new A.$ZK(Se,Pe,N.name,N.source.label,Ee,N.problemMatchers);return N.isBackground!==void 0&&(ge.isBackground=N.isBackground),N.group!==void 0&&(ge.group=A.$VK.from(N.group._id),ge.group&&N.group.isDefault&&(ge.group=new A.$VK(ge.group.id,ge.group.label),N.group.isDefault===!0&&(ge.group.isDefault=N.group.isDefault))),N.presentationOptions&&(ge.presentationOptions=r.to(N.presentationOptions)),N._id&&(ge._id=N._id),N.detail&&(ge.detail=N.detail),ge}K.to=O})(u||(e.TaskDTO=u={}));var g;(function(K){function j(O){return O}K.from=j;function B(O){if(O)return Object.assign(Object.create(null),O)}K.to=B})(g||(g={}));class h{#e;constructor(j,B,O){this._id=B,this.a=O,this.#e=j}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}let P=class{constructor(j,B,O,N,te,Y,Ee,Se){this.q=new C.$Md,this.r=new C.$Md,this.s=new C.$Md,this.t=new C.$Md,this.a=j.getProxy(L.$aK.MainThreadTask),this.b=O,this.c=N,this.d=te,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=Ee,this.g=Se,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,B,O){if(!O)return new A.$cK(()=>{});const N=this.w();return this.j.set(N,{type:B,provider:O,extension:j}),this.a.$registerTaskProvider(N,B),new A.$cK(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(j,B){this.a.$registerTaskSystem(j,B)}fetchTasks(j){return this.a.$fetchTasks(g.from(j)).then(async B=>{const O=[];for(const N of B){const te=await u.to(N,this.b,this.m);te&&O.push(te)}return O})}get taskExecutions(){const j=[];return this.k.forEach(B=>j.push(B)),j}terminateTask(j){if(!(j instanceof h))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,B,O){const N=this.m.get(j.id);N&&(this.o.set(j.id,N),this.e.attachPtyToTerminal(B,await N.callback(O))),this.p=j.id,this.q.fire({execution:await this.y(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){const B=await this.y(j);this.l.delete(j.id),this.k.delete(j.id),this.A(j),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const B=await this.y(j.id);this.s.fire({execution:B,processId:j.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(j){const B=await this.y(j.id);this.t.fire({execution:B,exitCode:j.exitCode})}$provideTasks(j,B){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));const N=[],te=(0,M.$Lg)(()=>O.provider.provideTasks(R.CancellationToken.None)).then(Y=>this.u(B,N,O,Y));return new Promise(Y=>{te.then(Ee=>{Promise.all(N).then(()=>{Y(Ee)})})})}async $resolveTask(j,B){const O=this.j.get(j);if(!O)return Promise.reject(new Error("no handler found"));if(B.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await u.to(B,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const te=await O.provider.resolveTask(N,R.CancellationToken.None);if(!te)return;this.z(te,O);const Y=u.from(te,O.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(te.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(Y.execution)&&await this.x(Y,te,!0),await this.v(Y)}w(){return this.h++}async x(j,B,O){const N=await this.a.$createTaskId(j);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,B.execution)),this.m.set(N,B.execution)}async y(j,B){if(typeof j=="string"){const te=this.l.get(j);if(!te)throw new E.$ab("Unexpected: The specified task is missing an execution");return te}const O=this.l.get(j.id);if(O)return O;const N=new Promise((te,Y)=>{function Ee(Se,Pe,ge){ge?te(new h(Se,Pe.id,ge)):Y("Unexpected: Task does not exist.")}B?Ee(this,j,B):u.to(j.task,this.b,this.m).then(Se=>Ee(this,j,Se))});return this.l.set(j.id,N),N.then(te=>(this.k.set(j.id,te),te),te=>Promise.reject(te))}z(j,B){j._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$Ycc=P,e.$Ycc=P=qe([We(0,c.$bM),We(1,p.$rM),We(2,l.$Zbc),We(3,k.$mM),We(4,f.$3bc),We(5,D.$icc),We(6,i.$8i),We(7,a.$Pbc)],P);let W=class extends P{constructor(j,B,O,N,te,Y,Ee,Se){super(j,B,O,N,te,Y,Ee,Se),this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:"",platform:t.$i(0)})}async executeTask(j,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const O=u.from(B,j);if(O===void 0)throw new Error("Task is not valid");if(d.is(O.execution))await this.x(O,B,!1);else throw new E.$$;const N=await this.y(await this.a.$getTaskExecution(O),B);return this.a.$executeTask(O).catch(te=>{throw new Error(te)}),N}u(j,B,O,N){const te=[];if(N)for(const Y of N){this.z(Y,O),(!Y.definition||!j[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const Ee=u.from(Y,O.extension);Ee&&d.is(Ee.execution)?(te.push(Ee),B.push(this.x(Ee,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:te,extension:O.extension}}async v(j){if(d.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,B,O){}};e.$Zcc=W,e.$Zcc=W=qe([We(0,c.$bM),We(1,p.$rM),We(2,l.$Zbc),We(3,k.$mM),We(4,f.$3bc),We(5,D.$icc),We(6,i.$8i),We(7,a.$Pbc)],W),e.$1cc=(0,$.$Nh)("IExtHostTask")}),define(Re[266],Me([1,0,19,21,42,37,23,58,48]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class f{constructor(c,p,$){this.k=c,this.l=p,this.o=$,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&L.$uj(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&L.$uj(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const p=this.k.folderQueries||[];return new Promise(($,m)=>{const t=i=>{this.f++,c(i)};if(this.g)return $({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const a=i.toString(),b=y.$mc(a);this.j&&this.j(a,b)||this.v(t,{base:i,basename:b})}),Promise.all(p.map(i=>this.p(i,t))).then(i=>{$({limitHit:this.e,stats:i[0]||void 0})},i=>{m(new Error((0,C.$yi)(i)))})})}async p(c,p){const $=new M.$Wd,m=this.q(c),t=this.r(),i=new k.$XI(this.k,c),a=!i.hasSiblingExcludeClauses();let b;try{this.h.add($),b=l.$Id.create();const E=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},m,$.token),v=b.elapsed(),r=l.$Id.create();return this.g&&!this.e||(E&&E.forEach(s=>{const n=y.$fc.relative(c.folder.path,s.path);if(a){const o=y.$mc(s.path);this.v(p,{base:c.folder,relativePath:n,basename:o});return}this.s(t,c.folder,n,p)}),this.g&&!this.e)?null:(this.u(t,i,p),{providerTime:v,postProcessTime:r.elapsed()})}finally{$.dispose(),this.h.delete($)}}q(c){const p=(0,k.$WI)(this.k.includePattern,c.includePattern),$=(0,k.$WI)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:$,includes:p,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},p,$,m){if($===this.a){const i=y.$mc(this.a);this.v(m,{base:p,relativePath:this.a,basename:i})}function t(i){const a=y.$mc(i),b=y.$lc(i);let E=c[b];E||(E=c[b]=[],t(b)),E.push({base:p,relativePath:i,basename:a})}t($)}u({rootEntries:c,pathToEntries:p},$,m){const t=this,i=this.a;function a(b){const E=(0,k.$ZI)(()=>b.map(v=>v.basename));for(let v=0,r=b.length;v<r;v++){const s=b[v],{relativePath:n,basename:o}=s;if($.matchesExcludesSync(n,o,i!==o?E:void 0))continue;const w=p[n];if(w)a(w);else{if(n===i)continue;t.v(m,s)}if(t.e)break}}a(c)}v(c,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(p))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(c,p,$,m){const t=this.c(c.cacheKey),i=new f(c,p,t&&t.token);let a=0;const b=E=>{a+=E.length,$(E.map(v=>this.d(v)))};return this.e(i,R.a,b,m).then(E=>({limitHit:E.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:E.stats}}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new M.$Wd),this.b.get(c)}d(c){return c.relativePath?{resource:A.$ug(c.base,c.relativePath)}:{resource:c.base}}e(c,p,$,m){const t=m.onCancellationRequested(()=>{c.cancel()}),i=b=>{b&&(a.push(b),p>0&&a.length>=p&&($(a),a=[]))};let a=[];return c.search(i).then(b=>(a.length&&$(a),t.dispose(),b),b=>(a.length&&$(a),t.dispose(),Promise.reject(b)))}}e.$$cc=R}),define(Re[267],Me([1,0,18,231,37,90,28,13,19,23,15,16,2,282,167,44,14,54,102,265,48]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RJ=e.$QJ=void 0;let v=class{constructor(g,h,P,W,K){this.a=g,this.b=h,this.c=P,this.d=W,this.e=K}text(g,h,P={}){g=this.f(g,P);const W=this.a.getValue(),K=h&&h.some(B=>!this.a.getValue({resource:B}).search.useRipgrep);return{...this.h(h?.map(i.$9h),P),type:2,contentPattern:g,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:W.search.usePCRE2||K||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(g,h){const P=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const W={...g,wordSeparators:P.editor.wordSeparators};return this.j(g,h)&&(W.isCaseSensitive=!0),this.k(g)&&(W.isMultiline=!0),h.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=h.notebookSearchConfig.includeMarkupInput),h.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=h.notebookSearchConfig.includeMarkupPreview),h.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=h.notebookSearchConfig.includeCodeInput),h.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=h.notebookSearchConfig.includeOutput),W}file(g,h={}){return{...this.h(g,h),type:1,filePattern:h.filePattern?h.filePattern.trim():h.filePattern,exists:h.exists,sortByScore:h.sortByScore,cacheKey:h.cacheKey}}g(g,h){return g?(g=Array.isArray(g)?g.map(w):w(g),h?this.parseSearchPaths(g):{pattern:s(...Array.isArray(g)?g:[g])}):{}}h(g=[],h={}){const P=this.g(h.includePattern,h.expandPatterns),W=this.g(h.excludePattern,h.expandPatterns),K=g.length>1,j=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(N=>this.q(N,h,W)):g.map(N=>this.r(N,h,W,K))).filter(N=>!!N),B={_reason:h._reason,folderQueries:j,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:h.extraFileResources,excludePattern:W.pattern,includePattern:P.pattern,onlyOpenEditors:h.onlyOpenEditors,maxResults:h.maxResults};if(h.onlyOpenEditors){const N=y.$Gb(y.$Qb(this.c.groups.map(Ee=>Ee.editors.map(Se=>Se.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const te=N.filter(Ee=>(0,E.$NI)(B,Ee.fsPath)),Y=this.i(te);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...B,...Y}}const O=h.extraFileResources&&h.extraFileResources.filter(N=>(0,E.$NI)(B,N.fsPath));return B.extraFileResources=O&&O.length?O:void 0,B}i(g){const h=[],P=new A.$zc,W={};let K=!1;return g.forEach(j=>{if(j.scheme===l.Schemas.walkThrough)return;if((0,f.$yg)(j)){const O=this.b.getWorkspaceFolder(j)?.uri??j.with({path:k.$lc(j.fsPath)});let N=P.get(O);N||(K=!0,N={folder:O,includePattern:{}},h.push(N),P.set(O,N));const te=k.$kc(O.fsPath,j.fsPath);(0,D.$If)(N.includePattern)[te.replace(/\\/g,"/")]=!0}else j.fsPath&&(K=!0,W[j.fsPath]=!0)}),{folderQueries:h,includePattern:W,usingSearchPaths:!0,excludePattern:K?void 0:{"**/*":!0}}}j(g,h){if(h.isSmartCase){if(g.isRegExp){if(R.$of(g.pattern,!0))return!0}else if(R.$of(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,p.$pB)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const h=Y=>k.$hc(Y)||/^\.\.?([\/\\]|$)/.test(Y),W=(Array.isArray(g)?g:n(g)).map(Y=>{const Ee=this.e.resolvedUserHome;return Ee?(0,L.$pv)(Y,Ee.scheme===l.Schemas.file?Ee.fsPath:Ee.path):Y}),K=M.$J(W,Y=>h(Y)?"searchPaths":"exprSegments"),j=(K.exprSegments||[]).map(Y=>R.$Je(Y,"/")).map(Y=>R.$Je(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),o(Y))),B={},O=this.m(K.searchPaths||[]);O&&O.length&&(B.searchPaths=O);const N=y.$Qb(j),te=s(...N);return te&&(B.pattern=te),B}l(g,h){return h.disregardExcludeSettings?void 0:(0,E.$MI)(g,!h.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const h=g.flatMap(W=>{let{pathPortion:K,globPortion:j}=r(W);return j&&(j=d(j)),this.n(K).flatMap(O=>this.o(O,j))}),P=new Map;return h.forEach(W=>{const K=W.searchPath.toString(),j=P.get(K);j?W.pattern&&(j.pattern=j.pattern||{},j.pattern[W.pattern]=!0):P.set(K,{searchPath:W.searchPath,pattern:W.pattern?s(W.pattern):void 0})}),Array.from(P.values())}n(g){if(k.$hc(g)){const h=this.b.getWorkspace().folders;return h[0]&&h[0].uri.scheme!==l.Schemas.file?[{searchPath:h[0].uri.with({path:g})}]:[{searchPath:c.URI.file(k.$gc(g))}]}if(this.b.getWorkbenchState()===2){const h=this.b.getWorkspace().folders[0].uri;if(g=w(g),g.startsWith("../")||g===".."){const W=k.$fc.resolve(h.path,g);return[{searchPath:h.with({path:W})}]}const P=d(g);return[{searchPath:h,pattern:P}]}else{if(g==="./"||g===".\\")return[];{const h=g.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(K=>{const j=h.match(new RegExp(`^${R.$Ee(K.name)}(?:/(.*)|$)`));return j?{match:j,folder:K}:null}).filter(D.$Ff);if(W.length)return W.map(K=>{const j=K.match[1];return{searchPath:K.folder.uri,pattern:j&&d(j)}});{const K=g.match(/\.[\/\\](.+)[\/\\]?/),j=K?K[1]:g,B=$.localize(0,null,j);throw new Error(B)}}}}o(g,h){const P=g.pattern&&h?`${g.pattern}/${h}`:g.pattern||h,W=[{searchPath:g.searchPath,pattern:P}];return P&&!P.endsWith("**")&&W.push({searchPath:g.searchPath,pattern:P+"/**"}),W}q(g,h,P){const W=this.r((0,i.$9h)(g.searchPath),h,P,!1);return W?{...W,includePattern:g.pattern}:null}r(g,h,P,W){let K;const j=c.URI.isUri(g)?g:g.uri;if(P.searchPaths){const Y=P.searchPaths.filter(Ee=>(0,f.$ng)(Ee.searchPath,j))[0];if(Y&&!Y.pattern)return null;Y&&(K=Y.pattern)}const B=this.a.getValue({resource:j}),N={...this.l(B,h)||{},...K||{}},te=c.URI.isUri(g)?(0,f.$rg)(g):g.name;return{folder:j,folderName:W?te:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:B.files&&B.files.encoding,disregardIgnoreFiles:typeof h.disregardIgnoreFiles=="boolean"?h.disregardIgnoreFiles:!B.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof h.disregardGlobalIgnoreFiles=="boolean"?h.disregardGlobalIgnoreFiles:!B.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof h.disregardParentIgnoreFiles=="boolean"?h.disregardParentIgnoreFiles:!B.search.useParentIgnoreFiles,ignoreSymlinks:typeof h.ignoreSymlinks=="boolean"?h.ignoreSymlinks:!B.search.followSymlinks}}};e.$QJ=v,e.$QJ=v=qe([We(0,m.$hi),We(1,i.$Wh),We(2,a.$_B),We(3,t.$8i),We(4,b.$OJ)],v);function r(u){const g=u.match(/[\*\{\}\(\)\[\]\?]/);if(g){const h=g.index,P=u.substr(0,h).match(/[/|\\][^/\\]*$/);if(P){let W=u.substr(0,P.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:u.substr((P.index||0)+1)}}}return{pathPortion:u}}function s(...u){return u.length?u.reduce((g,h)=>(g[h]=!0,g),Object.create(null)):void 0}function n(u){return C.$sj(u,",").map(g=>g.trim()).filter(g=>!!g.length)}function o(u){return[`**/${u}/**`,`**/${u}`].map(h=>h.replace(/\*\*\/\*\*/g,"**"))}function w(u){return u.replace(/\\/g,"/")}function d(u){return w(u).replace(/^\.\//,"").replace(/\/+$/g,"")}function I(u){return u.replace(/([?*[\]])/g,"[$1]")}function S(u,g){u=y.$Lb(u,W=>W.toString());const h=[],P=g.getWorkspace();return u&&u.forEach(W=>{let K;if(g.getWorkbenchState()===2)K=(0,f.$wg)(P.folders[0].uri,W),K&&K!=="."&&(K="./"+K);else{const j=g.getWorkspaceFolder(W);if(j){const B=j.name;if(P.folders.filter(N=>N.name===B).length===1){const N=(0,f.$wg)(j.uri,W);N===""?K=`./${j.name}`:K=`./${j.name}/${N}`}else K=W.fsPath}}K&&h.push(I(K))}),h}e.$RJ=S}),define(Re[268],Me([1,0,23,2,21,9,4,267,48,54]),function(we,e,y,M,C,L,A,l,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$slb=e.$rlb=void 0;const R=7e3;function D(m,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const a=[],b=[];for(const o of i)if(/^workspaceContains:/.test(o)){const w=o.substr(18);w.indexOf("*")>=0||w.indexOf("?")>=0||m.forceUsingSearch?b.push(w):a.push(w)}if(a.length===0&&b.length===0)return Promise.resolve(void 0);let E;const v=new Promise((o,w)=>{E=o}),r=o=>E({activationEvent:o}),s=Promise.all(a.map(o=>c(m,o,r))).then(()=>{}),n=p(m,t.identifier,b,r);return Promise.all([s,n]).then(()=>{E(void 0)}),v}e.$rlb=D;async function c(m,t,i){for(const a of m.folders)if(await m.exists(y.$ug(M.URI.revive(a),t))){i(`workspaceContains:${t}`);return}}async function p(m,t,i,a){if(i.length===0)return Promise.resolve(void 0);const b=new C.$Wd,E=m.checkExists(m.folders,i,b.token),v=setTimeout(async()=>{b.cancel(),m.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},R);let r=!1;try{r=await E}catch(s){L.$3(s)||L.$Z(s)}b.dispose(),clearTimeout(v),r&&a(`workspaceContains:${i.join(",")}`)}function $(m,t,i,a){const b=m.get(A.$Mh),E=m.get(k.$EI),r=b.createInstance(l.$QJ).file(t.map(s=>(0,f.$9h)(M.URI.revive(s))),{_reason:"checkExists",includePattern:i,exists:!0});return E.fileSearch(r,a).then(s=>!!s.limitHit,s=>L.$3(s)?!1:Promise.reject(s))}e.$slb=$}),define(Re[35],Me([1,0,148,19,87,23,12,6,49,2,14,3,34,209,84,33,25,106,9,20,26,188,7,97,4,27,85,17,70,86,62,5,268,83,190,13,81,58,22,82]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v,r,s,n,o,w,d,I,S,u,g,h,P,W,K,j,B,O,N){"use strict";var te;Object.defineProperty(e,"__esModule",{value:!0}),e.$xcc=e.$wcc=e.$vcc=e.$ucc=e.$tcc=void 0,e.$tcc=(0,n.$Nh)("IHostUtils");let Y=te=class extends l.$Rc{constructor(_,z,V,ue,ye,be,pe,De,ne,le,re,oe){super(),this.X=oe,this.a=this.B(new g.$Md),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=z,this.g=V,this.f=pe,this.j=ue,this.m=ye,this.s=be,this.t=ne,this.u=le,this.w=re,this.y=this.g.getProxy(D.$aK.MainThreadWorkspace),this.z=this.g.getProxy(D.$aK.MainThreadTelemetry),this.C=this.g.getProxy(D.$aK.MainThreadExtensionService),this.D=new A.$Rg,this.F=new A.$Rg,this.G=new A.$Rg,this.H=new A.$Rg,this.I=new se(this.f.extensions.activationEvents),this.L=new i.$_3b(this.I,this.f.extensions.allExtensions);const de=new b.$4l(this.f.extensions.myExtensions);this.J=new i.$_3b(this.I,me(this.L,de)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Pe(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Pe(this.J)}`)),this.M=new $.$acc(this.g,this.s),this.N=new P.$mcc(this.g),this.O=De,this.h=_.createChild(new I.$Lh([$.$bcc,this.M],[P.$ncc,this.N])),this.P=this.B(new p.$_bc(this.J,this.L,{onExtensionActivationError:(Ie,F,q)=>{this.C.$onExtensionActivationError(Ie,a.$2(F),q)},actualActivateExtension:async(Ie,F)=>{if(i.$_3b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,F),new p.$$bc;const q=this.J.getExtensionDescription(Ie);return this.db(q,F)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),C.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(_){a.$Z(_)}}async Y(){this.O.onWillDeactivateAll();let _=[];try{_=this.J.getAllExtensionDescriptions().map(ye=>ye.identifier).filter(ye=>this.isActivated(ye)).map(ye=>this.cb(ye))}catch{}await Promise.all(_)}terminate(_,z=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${_}`),this.s.flush(),this.u.dispose(),this.P.dispose(),a.setUnexpectedErrorHandler(ue=>{this.s.error(ue)}),this.g.dispose();const V=this.Y();Promise.race([(0,A.$Tg)(5e3),V]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${z}`):this.s.info(`Extension host exiting with code ${z}`),this.s.flush(),this.s.dispose(),this.c.exit(z)})}isActivated(_){return this.G.isOpen()?this.P.isActivated(_):!1}async getExtension(_){const z=await this.C.$getExtension(_);return z&&{...z,identifier:new b.$3l(z.identifier.value),extensionLocation:f.URI.revive(z.extensionLocation)}}Z(_,z){return this.P.activateByEvent(_,z)}$(_,z){return this.P.activateById(_,z)}activateByIdWithErrors(_,z){return this.$(_,z).then(()=>{const V=this.P.getActivatedExtension(_);if(V.activationFailed)return Promise.reject(V.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(_=>this.J)}getExtensionExports(_){if(this.G.isOpen())return this.P.getActivatedExtension(_).exports;try{return this.P.getActivatedExtension(_).exports}catch{return null}}async ab(_){if(_.scheme===K.Schemas.file&&this.c.fsRealpath){const z=await this.c.fsRealpath(_.fsPath);return f.URI.file(z)}return _}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(_=>new ce(_))),this.Q}async bb(_){const z=k.$Th.forUris(V=>L.$lg.ignorePathCasing(V));return await Promise.all(_.map(async V=>{if(this.ub(V)){const ue=await this.ab(V.extensionLocation);z.set(ue,V)}})),z}cb(_){let z=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(_))return z;const V=this.P.getActivatedExtension(_);if(!V)return z;try{typeof V.module.deactivate=="function"&&(z=Promise.resolve(V.module.deactivate()).then(void 0,ue=>(this.s.error(ue),Promise.resolve(void 0))))}catch(ue){this.s.error(`An error occurred when deactivating the extension '${_.value}':`),this.s.error(ue)}try{(0,l.$Mc)(V.subscriptions)}catch(ue){this.s.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.s.error(ue)}return z}async db(_,z){return this.f.remote.isRemote?this.C.$onWillActivateExtension(_.identifier):await this.C.$onWillActivateExtension(_.identifier),this.fb(_,z).then(V=>{const ue=V.activationTimes;return this.C.$onDidActivateExtension(_.identifier,ue.codeLoadingTime,ue.activateCallTime,ue.activateResolvedTime,z),this.eb(_,z,"success",ue),V},V=>{throw this.eb(_,z,"failure"),V})}eb(_,z,V,ue){const ye=Se(_,z);this.z.$publicLog2("extensionActivationTimes",{...ye,...ue||{},outcome:V})}fb(_,z){const V=Se(_,z);this.z.$publicLog2("activatePlugin",V);const ue=this.ub(_);if(!ue)return Promise.resolve(new p.$0bc(p.$7bc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${z.startup}, activationEvent: '${z.activationEvent}'${_.identifier.value!==z.extensionId.value?`, root cause: ${z.extensionId.value}`:""}`),this.s.flush();const ye=new p.$8bc(z.startup);return Promise.all([this.vb(_,(0,L.$ug)(_.extensionLocation,ue),ye),this.gb(_)]).then(be=>(C.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),te.hb(this.s,_.identifier,be[0],be[1],ye))).then(be=>(C.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),be))}gb(_){const z=new v.$dcc(_,this.M),V=new v.$ccc(_.identifier.value,!1,this.M),ue=new W.$occ(_,this.N),ye=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,be=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([z.whenReady,V.whenReady,this.O.whenReady]).then(()=>{const pe=this;let De,ne;const le=(0,t.$_E)(_,"ipc")?this.f.messagePorts?.get(b.$3l.toKey(_.identifier)):void 0;return Object.freeze({globalState:z,workspaceState:V,secrets:ue,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(re){return M.$ic(_.extensionLocation.fsPath,re)},get storagePath(){return pe.O.workspaceValue(_)?.fsPath},get globalStoragePath(){return pe.O.globalValue(_).fsPath},get logPath(){return M.$ic(pe.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return f.URI.joinPath(pe.f.logsLocation,_.identifier.value)},get storageUri(){return pe.O.workspaceValue(_)},get globalStorageUri(){return pe.O.globalValue(_)},get extensionMode(){return ye},get extension(){return De===void 0&&(De=new ge(pe,_.identifier,_,be,!1)),De},get extensionRuntime(){return(0,t.$aF)(_,"extensionRuntime"),pe.extensionRuntime},get environmentVariableCollection(){return pe.u.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!ne){if(!le)return;const re=g.Event.buffer(g.Event.fromDOMEventEmitter(le,"message",oe=>oe.data));le.start(),ne={onDidReceiveMessage:re,postMessage:le.postMessage.bind(le)}}return ne}})})}static hb(_,z,V,ue,ye){return V=V||{activate:void 0,deactivate:void 0},this.ib(_,z,V,ue,ye).then(be=>new p.$9bc(!1,null,ye.build(),V,be,ue.subscriptions))}static ib(_,z,V,ue,ye){if(typeof V.activate=="function")try{ye.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${z.value}`);const be=typeof global=="object"?global:self,pe=V.activate.apply(be,[ue]);return ye.activateCallStop(),ye.activateResolveStart(),Promise.resolve(pe).then(De=>(ye.activateResolveStop(),De))}catch(be){return Promise.reject(be)}else return Promise.resolve(V)}jb(_,z){this.$(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:z}).then(void 0,V=>{this.s.error(V)})}kb(_,z=0){const ue=Date.now();(0,O.$B)(()=>{for(let ye=z;ye<_.length;ye+=1){const be=_[ye];for(const pe of be.activationEvents??[])if(pe==="onStartupFinished")if(Date.now()-ue>50){this.kb(_,ye);break}else this.jb(be,pe)}})}lb(){this.C.$setPerformanceMarks(C.getMarks()),this.m.getConfigProvider().then(_=>{const z=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),V=this.J.getAllExtensionDescriptions();if(z)this.kb(V);else for(const ue of V)if(ue.activationEvents)for(const ye of ue.activationEvents)ye==="onStartupFinished"&&this.jb(ue,ye)})}mb(){const _=this.Z("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.nb(be.added)));const z=this.j.workspace?this.j.workspace.folders:[],V=this.nb(z),ue=this.pb(),ye=Promise.all([ue,_,V]).then(()=>{});return Promise.race([ye,(0,A.$Tg)(1e4)]).then(()=>{this.lb()}),ye}nb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(z=>this.ob(_,z))).then(()=>{})}async ob(_,z){if(this.isActivated(z.identifier))return;const V=!this.f.remote.isRemote&&!!this.f.remote.authority,ue={logService:this.s,folders:_.map(be=>be.uri),forceUsingSearch:V||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,pe,De)=>this.y.$checkExists(be,pe,De)},ye=await(0,h.$rlb)(ue,z);if(ye)return this.$(z.identifier,{startup:!0,extensionId:z.identifier,activationEvent:ye.activationEvent}).then(void 0,be=>this.s.error(be))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(_){throw console.error(_),_}}async qb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:z}=this.f.environment;if(!_||!z)throw new Error(y.localize(0,null));const V=await this.vb(null,z,new p.$8bc(!1));if(!V||typeof V.run!="function")throw new Error(y.localize(1,null,z.toString()));return new Promise((ue,ye)=>{const be=(ne,le)=>{ne?(O.$t&&this.s.error("Test runner called back with error",ne),ye(ne)):(O.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),ue(typeof le=="number"&&le>0?1:0))},pe=(0,L.$ig)(z),De=V.run(pe,be);De&&De.then&&De.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),ue(0)}).catch(ne=>{O.$t&&this.s.error("Test runner finished with error",ne),ye(ne instanceof Error&&ne.stack?ne.stack:String(ne))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Tg)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,z){return this.R[_]=z,(0,l.$Pc)(()=>{delete this.R[_]})}async getRemoteExecServer(_){const{resolver:z}=await this.sb(_);return z?.resolveExecServer?.(_,{resolveAttempt:0})}async sb(_){const z=_.indexOf("+");if(z===-1)throw new r.$iK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const V=_.substr(0,z);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${V}`,!1),{authorityPrefix:V,resolver:this.R[V]}}async $resolveAuthority(_,z){const V=B.$Id.create(!1),ue=()=>`[resolveAuthority(${(0,s.$Rk)(_)},${z})][${V.elapsed()}ms] `,ye=Q=>this.s.info(`${ue()}${Q}`),be=Q=>this.s.warn(`${ue()}${Q}`),pe=(Q,H=void 0)=>this.s.error(`${ue()}${Q}`,H),De=Q=>{if(Q instanceof r.$iK)return{type:"error",error:{code:Q._code,message:Q._message,detail:Q._detail}};throw Q},ne=async Q=>{ye(`activating resolver for ${Q}...`);const{resolver:H,authorityPrefix:x}=await this.sb(Q);if(!H)throw pe(`no resolver for ${x}`),new r.$iK(`No remote extension installed to resolve ${x}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:x,remoteAuthority:Q}},le=_.split(/@|%40/g).reverse();ye(`activating remote resolvers ${le.join(" -> ")}`);let re;try{re=await Promise.all(le.map(ne)).catch(async Q=>{if(!(Q instanceof r.$iK)||Q._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw Q;return be(`resolving nested authorities failed: ${Q.message}`),[await ne(_)]})}catch(Q){return De(Q)}const oe=new A.$4g;oe.cancelAndSet(()=>ye("waiting..."),1e3);let de,Ie;for(const[Q,{authorityPrefix:H,resolver:x,remoteAuthority:ae}]of re.entries())try{if(Q===re.length-1)ye("invoking final resolve()..."),C.mark(`code/extHost/willResolveAuthority/${H}`),de=await x.resolve(ae,{resolveAttempt:z,execServer:Ie}),C.mark(`code/extHost/didResolveAuthorityOK/${H}`),ye("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(x,r.$hK.isManagedResolvedAuthority(de)?de:void 0));else{if(ye(`invoking resolveExecServer() for ${ae}`),C.mark(`code/extHost/willResolveExecServer/${H}`),Ie=await x.resolveExecServer?.(ae,{resolveAttempt:z,execServer:Ie}),!Ie)throw new r.$iK(`Exec server was not available for ${ae}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);C.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(Le){return C.mark(`code/extHost/didResolveAuthorityError/${H}`),pe("returned an error",Le),oe.dispose(),De(Le)}oe.dispose();const F={environmentTunnels:de.environmentTunnels,features:de.tunnelFeatures},q={extensionHostEnv:de.extensionHostEnv,isTrusted:de.isTrusted,authenticationSession:de.authenticationSessionForInitializingExtensions?{id:de.authenticationSessionForInitializingExtensions.id,providerId:de.authenticationSessionForInitializingExtensions.providerId}:void 0};ye(`returned ${r.$hK.isManagedResolvedAuthority(de)?"managed authority":`${de.host}:${de.port}`}`);let J;if(r.$hK.isManagedResolvedAuthority(de)){const Q=z;this.X.setFactory(Q,de.makeConnection),J={authority:_,connectTo:new s.$Ok(Q),connectionToken:de.connectionToken}}else J={authority:_,connectTo:new s.$Pk(de.host,de.port),connectionToken:de.connectionToken};return{type:"ok",value:{authority:J,options:q,tunnelInformation:F}}}async $getCanonicalURI(_,z){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$Rk)(_)})`);const{resolver:V}=await this.sb(_);if(!V)return null;const ue=f.URI.revive(z);if(typeof V.getCanonicalURI>"u")return ue;const ye=await(0,A.$Lg)(()=>V.getCanonicalURI(ue));return ye||ue}$startExtensionHost(_){_.toAdd.forEach(ue=>ue.extensionLocation=f.URI.revive(ue.extensionLocation));const{globalRegistry:z,myExtensions:V}=Ee(this.I,this.L,this.J,_);return this.L.set(z.getAllExtensionDescriptions()),this.J.set(V),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Pe(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Pe(this.J)}`)),this.rb()}$activateByEvent(_,z){return z===1?this.D.wait().then(V=>this.Z(_,!1)):this.G.wait().then(V=>this.Z(_,!1))}async $activate(_,z){return await this.G.wait(),this.J.getExtensionDescription(_)?(await this.$(_,z),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(be=>be.extensionLocation=f.URI.revive(be.extensionLocation));const{globalRegistry:z,myExtensions:V}=Ee(this.I,this.L,this.J,_),ue=await this.bb(V);return(await this.getExtensionPathIndex()).setSearchTree(ue),this.L.set(z.getAllExtensionDescriptions()),this.J.set(V),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Pe(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Pe(this.J)}`)),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const z=E.$ae.alloc(_),V=Math.random()%256;for(let ue=0;ue<_;ue++)z.writeUInt8(V,ue);return z}async $updateRemoteConnectionData(_){this.W=_,this.a.fire()}};e.$ucc=Y,e.$ucc=Y=te=qe([We(0,n.$Mh),We(1,e.$tcc),We(2,d.$bM),We(3,m.$Zbc),We(4,c.$3bc),We(5,R.$8i),We(6,o.$rM),We(7,w.$gcc),We(8,S.$Wvb),We(9,u.$icc),We(10,j.$qcc),We(11,N.$rcc)],Y);function Ee($e,_,z,V){$e.addActivationEvents(V.addActivationEvents);const ue=new i.$_3b($e,_.getAllExtensionDescriptions());ue.deltaExtensions(V.toAdd,V.toRemove);const ye=new b.$4l(z.getAllExtensionDescriptions().map(pe=>pe.identifier));for(const pe of V.myToRemove)ye.delete(pe);for(const pe of V.myToAdd)ye.add(pe);const be=me(ue,ye);return{globalRegistry:ue,myExtensions:be}}function Se($e,_){return{id:$e.identifier.value,name:$e.name,extensionVersion:$e.version,publisherDisplayName:$e.publisher,activationEvents:$e.activationEvents?$e.activationEvents.join(","):null,isBuiltin:$e.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}function Pe($e){return $e.getAllExtensionDescriptions().map(_=>_.identifier.value).join(",")}e.$vcc=(0,n.$Nh)("IExtHostExtensionService");class ge{#e;#t;#i;constructor(_,z,V,ue,ye){this.#e=_,this.#t=z,this.#i=V.identifier,this.id=V.identifier.value,this.extensionUri=V.extensionLocation,this.extensionPath=M.$gc((0,L.$ig)(V.extensionLocation)),this.packageJSON=V,this.extensionKind=ue,this.isFromDifferentExtensionHost=ye}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$wcc=ge;function me($e,_){return $e.getAllExtensionDescriptions().filter(z=>_.has(z.identifier))}class ce{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$xcc=ce;class se{constructor(_){this.a=new b.$5l,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)}addActivationEvents(_){for(const z of Object.keys(_))this.a.set(z,_[z])}}}),define(Re[269],Me([1,0,87,2,3,34,25,20,17,27,4,35,14,15]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;let m=class{constructor(E,v,r,s,n,o,w){this.c=E,this.d=v,this.e=r,this.f=s,this.g=n,this.h=o,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const E=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const v=await this.g.getExtensionPathIndex();this.register(new i(this.c,v,this.d,E,this.i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(a,v,this.h.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(const v of E.nodeModuleName)this.a.set(v,E);else this.a.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this.b.push(v=>E.alternativeModuleName(v))}};e.$Tdc=m,e.$Tdc=m=qe([We(2,R.$Mh),We(3,L.$3bc),We(4,D.$vcc),We(5,f.$rM),We(6,c.$8i)],m);let t=class{static{$=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(E){if(E.environment.appRoot&&$.a.size){const v=(0,p.$Ee)(this.c(E.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${v}/${n}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(E){if(!this.b)return;const v=this.b.exec(this.c(E));if(!v)return;const[,r,s,n]=v,o=$.a.get(s);if(o!==void 0)return console.warn(`${s} as been renamed to ${o}, please update your imports`),r+o+n}c(E){return E.replace(/\\/g,"/")}};t=$=qe([We(0,f.$rM)],t);class i{constructor(E,v,r,s,n){this.c=E,this.d=v,this.e=r,this.f=s,this.g=n,this.nodeModuleName="vscode",this.a=new l.$5l}load(E,v){const r=this.d.findSubstr(v);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((n,o)=>s+=`	${o} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${v}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$7E,this.e,this.f)}return this.b}}let a=class{constructor(E,v,r){this.e=E,this.f=v,this.nodeModuleName=["open","opn"],this.d=r.getProxy(C.$aK.MainThreadTelemetry);const s=r.getProxy(C.$aK.MainThreadWindow);this.c=(n,o)=>{const w=M.URI.parse(n);return o?this.g(n,o):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,n,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,n,{}):this.g(n,o)}}load(E,v,r){const s=this.e.findSubstr(v);return s&&(this.a=s.identifier.value,this.h()),this.b=r(E),this.c}g(E,v){return this.i(),this.b(E,v)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};a=qe([We(2,k.$bM)],a)}),define(Re[112],Me([1,0,40,6,19,73,4,59,60,35,7,33,200,34]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=e.$4cc=void 0,e.$4cc=(0,A.$Nh)("IExtHostVariableResolverProvider");class $ extends c.$cN{constructor(i,a,b,E,v,r,s){function n(){if(b){const o=b.activeEditor();if(o)return o.document.uri;const w=E.tabGroups.all.find(d=>d.isActive)?.activeTab;if(w!==void 0){if(w.input instanceof R.$UL||w.input instanceof R.$ZL)return w.input.modified;if(w.input instanceof R.$TL||w.input instanceof R.$YL||w.input instanceof R.$WL)return w.input.uri}}}super({getFolderUri:o=>{const w=r.folders.filter(d=>d.name===o);if(w&&w.length>0)return w[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(o,w)=>v.getConfiguration(void 0,o).get(w),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=n();if(o)return C.$gc(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const o=n();if(o){const w=a.getWorkspaceFolder(o);if(w)return C.$gc(w.uri.fsPath)}}},getSelectedText:()=>{if(b){const o=b.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(b){const o=b.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>i.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let m=class extends M.$Rc{constructor(i,a,b,E,v){super(),this.b=i,this.c=a,this.g=b,this.h=E,this.j=v,this.a=new y.$U(async()=>{const r=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new $(this.b,this.c,this.g,this.j,r,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$5cc=m,e.$5cc=m=qe([We(0,f.$vcc),We(1,D.$Zbc),We(2,l.$mM),We(3,p.$3bc),We(4,k.$2cc)],m)}),define(Re[113],Me([1,0,12,5,2,4,3,60,35,17,7,33,193,195,34,112]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=e.$9cc=e.$8cc=e.$7cc=e.$6cc=void 0,e.$6cc=(0,L.$Nh)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,n,o,w,d,I){this.E=n,this.F=o,this.G=w,this.H=d,this.I=I,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new M.$Md,this.n=new M.$Md,this.o=new M.$Md,this.u=new M.$Md,this.k=s.getProxy(A.$aK.MainThreadDebugService),this.y=new M.$Md,this.A=new M.$Md,this.v=new a(this.k),this.w=new Map,this.F.getExtensionRegistry().then(S=>{S.onDidChange(u=>{this.J(S)}),this.J(S)})}asDebugSourceUri(s,n){const o=s;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let w=`debug:${encodeURIComponent(o.path||"")}`,d="?";return n&&(w+=`${d}session=${encodeURIComponent(n.id)}`,d="&"),w+=`${d}ref=${o.sourceReference}`,C.URI.parse(w)}else{if(o.path)return C.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const n=[];for(const o of s.getAllExtensionDescriptions())if(o.contributes){const w=o.contributes.debuggers;if(w&&w.length>0)for(const d of w)(0,p.$rF)(d)&&n.push(d.type)}this.k.$registerDebugTypes(n)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(n=>s.push(n)),s}addBreakpoints(s){const n=s.filter(d=>{const I=d.id;return this.w.has(I)?!1:(this.w.set(I,d),!0)});this.U(n,[],[]);const o=[],w=new Map;for(const d of n)if(d instanceof R.$bL){let I=w.get(d.location.uri.toString());I||(I={type:"sourceMulti",uri:d.location.uri,lines:[]},w.set(d.location.uri.toString(),I),o.push(I)),I.lines.push({id:d.id,enabled:d.enabled,condition:d.condition,hitCondition:d.hitCondition,logMessage:d.logMessage,line:d.location.range.start.line,character:d.location.range.start.character})}else d instanceof R.$cL&&o.push({type:"function",id:d.id,enabled:d.enabled,hitCondition:d.hitCondition,logMessage:d.logMessage,condition:d.condition,functionName:d.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(s){const n=s.filter(I=>this.w.delete(I.id));this.U([],n,[]);const o=n.filter(I=>I instanceof R.$bL).map(I=>I.id),w=n.filter(I=>I instanceof R.$cL).map(I=>I.id),d=n.filter(I=>I instanceof R.$dL).map(I=>I.id);return this.k.$unregisterBreakpoints(o,w,d)}startDebugging(s,n,o){return this.k.$startDebugging(s?s.uri:void 0,n,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,n,o){if(!n)return new R.$cK(()=>{});const w=this.d++;return this.f.push({type:s,handle:w,provider:n}),this.k.$registerDebugConfigurationProvider(s,o,!!n.provideDebugConfigurations,!!n.resolveDebugConfiguration,!!n.resolveDebugConfigurationWithSubstitutedVariables,w),new R.$cK(()=>{this.f=this.f.filter(d=>d.provider!==n),this.k.$unregisterDebugConfigurationProvider(w)})}registerDebugAdapterDescriptorFactory(s,n,o){if(!o)return new R.$cK(()=>{});if(!this.Q(s,n))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${n}' debugger.`);if(this.N(n))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const w=this.g++;return this.h.push({type:n,handle:w,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(n,w),new R.$cK(()=>{this.h=this.h.filter(d=>d.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(w)})}registerDebugAdapterTrackerFactory(s,n){if(!n)return new R.$cK(()=>{});const o=this.i++;return this.j.push({type:s,handle:o,factory:n}),new R.$cK(()=>{this.j=this.j.filter(w=>w.factory!==n)})}async $runInTerminal(s,n){return Promise.resolve(void 0)}async $substituteVariables(s,n){let o;const w=await this.W(s);return w&&(o={uri:w.uri,name:w.name,index:w.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,n)}K(s,n){if(s.type==="implementation")return new E(s.implementation)}L(){}async $startDASession(s,n){const o=this,w=await this.V(n);return this.S(this.N(w.type),w).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}' (extension might have failed to activate)`);const I=this.M(d),S=this.K(I,w);if(!S)throw new Error(`Couldn't create a debug adapter for type '${w.type}'.`);const u=S;return this.B.set(s,u),this.R(w).then(g=>(g&&this.C.set(s,g),u.onMessage(async h=>{if(h.type==="request"&&h.command==="handshake"){const P=h,W={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const K=await this.D.sign(P.arguments.value);W.body={signature:K},u.sendResponse(W)}else throw new Error("no signer")}catch(K){W.success=!1,W.message=K.message,u.sendResponse(W)}}else g&&g.onDidSendMessage&&g.onDidSendMessage(h),h=(0,p.$wF)(h,!0),o.k.$acceptDAMessage(s,h)}),u.onError(h=>{g&&g.onError&&g.onError(h),this.k.$acceptDAError(s,h.name,h.message,h.stack)}),u.onExit(h=>{g&&g.onExit&&g.onExit(h??void 0,void 0),this.k.$acceptDAExit(s,h??void 0,void 0)}),g&&g.onWillStartSession&&g.onWillStartSession(),u.startSession()))})}$sendDAMessage(s,n){n=(0,p.$vF)(n,!1);const o=this.C.get(s);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(n),this.B.get(s)?.sendMessage(n)}$stopDASession(s){const n=this.C.get(s);this.C.delete(s),n&&n.onWillStopSession&&n.onWillStopSession();const o=this.B.get(s);return this.B.delete(s),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const n=[],o=[],w=[];if(s.added)for(const d of s.added){const I=d.id;if(I&&!this.w.has(I)){let S;if(d.type==="function")S=new R.$cL(d.functionName,d.enabled,d.condition,d.hitCondition,d.logMessage);else if(d.type==="data")S=new R.$dL(d.label,d.dataId,d.canPersist,d.enabled,d.hitCondition,d.condition,d.logMessage);else{const u=C.URI.revive(d.uri);S=new R.$bL(new R.$oK(u,new R.$dK(d.line,d.character)),d.enabled,d.condition,d.hitCondition,d.logMessage)}(0,R.$_K)(S,I),this.w.set(I,S),n.push(S)}}if(s.removed)for(const d of s.removed){const I=this.w.get(d);I&&(this.w.delete(d),o.push(I))}if(s.changed){for(const d of s.changed)if(d.id){const I=this.w.get(d.id);if(I){if(I instanceof R.$cL&&d.type==="function"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.functionName=d.functionName}else if(I instanceof R.$bL&&d.type==="source"){const S=I;S.enabled=d.enabled,S.condition=d.condition,S.hitCondition=d.hitCondition,S.logMessage=d.logMessage,S.location=new R.$oK(C.URI.revive(d.uri),new R.$dK(d.line,d.character))}w.push(I)}}}this.U(n,o,w)}async $acceptStackFrameFocus(s){let n;const o=s.sessionId?await this.V(s.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?n=new R.$jL(o,s.threadId):n=new R.$iL(o,s.threadId,s.frameId),this.z=n,this.A.fire(this.z)}$provideDebugConfigurations(s,n,o){return(0,y.$Lg)(async()=>{const w=this.P(s);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const d=await this.W(n);return w.provideDebugConfigurations(d,o)}).then(w=>{if(!w)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return w})}$resolveDebugConfiguration(s,n,o,w){return(0,y.$Lg)(async()=>{const d=this.P(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const I=await this.W(n);return d.resolveDebugConfiguration(I,o,w)})}$resolveDebugConfigurationWithSubstitutedVariables(s,n,o,w){return(0,y.$Lg)(async()=>{const d=this.P(s);if(!d)throw new Error("no DebugConfigurationProvider found");if(!d.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const I=await this.W(n);return d.resolveDebugConfigurationWithSubstitutedVariables(I,o,w)})}async $provideDebugAdapter(s,n){const o=this.O(s);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const w=await this.V(n);return this.S(o,w).then(d=>{if(!d)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${w.type}'`);return this.M(d)})}async $acceptDebugSessionStarted(s){const n=await this.V(s);this.m.fire(n)}async $acceptDebugSessionTerminated(s){const n=await this.V(s);n&&(this.n.fire(n),this.l.delete(n.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,n){(await this.V(s))?._acceptNameChanged(n)}async $acceptDebugSessionCustomEvent(s,n){const w={session:await this.V(s),event:n.event,body:n.body};this.u.fire(w)}M(s){if(s instanceof R.$eL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof R.$fL)return{type:"server",port:s.port,host:s.host};if(s instanceof R.$gL)return{type:"pipeServer",path:s.path};if(s instanceof R.$hL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const n=this.h.filter(o=>o.type===s);if(n.length>0)return n[0].factory}O(s){const n=this.h.filter(o=>o.handle===s);if(n.length>0)return n[0].factory}P(s){const n=this.f.filter(o=>o.handle===s);if(n.length>0)return n[0].provider}Q(s,n){if(s.contributes){const o=s.contributes.debuggers;if(o&&o.length>0){for(const w of o)if(w.label&&w.type&&w.type===n)return!0}}return!1}R(s){const o=s.configuration.type,w=this.j.filter(d=>d.type===o||d.type==="*").map(d=>(0,y.$Lg)(()=>d.factory.createDebugAdapterTracker(s)).then(I=>I,I=>null));return Promise.race([Promise.all(w).then(d=>{const I=d.filter(S=>!!S);if(I.length>0)return new b(I)}),new Promise(d=>setTimeout(()=>d(void 0),1e3))]).catch(d=>{})}async S(s,n){const o=n.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new R.$fL(o));if(s){const d=await this.F.getExtensionRegistry();return(0,y.$Lg)(()=>s.createDebugAdapterDescriptor(n,this.T(n,d))).then(I=>{if(I)return I})}const w=await this.F.getExtensionRegistry();return Promise.resolve(this.T(n,w))}T(s,n){}U(s,n,o){(s.length>0||n.length>0||o.length>0)&&this.y.fire(Object.freeze({added:s,removed:n,changed:o}))}async V(s){if(s)if(typeof s=="string"){const n=this.l.get(s);if(n)return n}else{let n=this.l.get(s.id);if(!n){const o=await this.W(s.folderUri),w=s.parent?this.l.get(s.parent):void 0;n=new i(this.k,s.id,s.type,s.name,o,s.configuration,w),this.l.set(n.id,n),this.k.$sessionCached(n.id)}return n}throw new Error("cannot find session")}W(s){if(s){const n=C.URI.revive(s);return this.E.resolveWorkspaceFolder(n)}return Promise.resolve(void 0)}};e.$7cc=t,e.$7cc=t=qe([We(0,f.$bM),We(1,D.$Zbc),We(2,k.$vcc),We(3,$.$3bc),We(4,l.$2cc),We(5,m.$4cc)],t);class i{constructor(s,n,o,w,d,I,S){this.d=s,this.f=n,this.g=o,this.h=w,this.i=d,this.j=I,this.k=S}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,n){return this.d.$customDebugAdapterRequest(this.f,s,n)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$8cc=i;class a{constructor(s){this.value=Object.freeze({append(n){s.$appendDebugConsole(n)},appendLine(n){this.append(n+`
`)}})}}e.$9cc=a;class b{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(n=>n.onWillReceiveMessage?n.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(n=>n.onDidSendMessage?n.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(n=>n.onError?n.onError(s):void 0)}onExit(s,n){this.d.forEach(o=>o.onExit?o.onExit(s,n):void 0)}}class E extends c.$Ycb{constructor(s){super(),this.h=s,s.onDidSendMessage(n=>{this.acceptMessage(n)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let v=class extends t{constructor(s,n,o,w,d,I){super(s,n,o,w,d,I)}};e.$0cc=v,e.$0cc=v=qe([We(0,f.$bM),We(1,D.$Zbc),We(2,k.$vcc),We(3,$.$3bc),We(4,l.$2cc),We(5,m.$4cc)],v)}),define(Re[270],Me([1,0,9,87,2,3,261,14,69,70,27,172,17,55,35,57]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=e.$Udc=void 0;class t{static async installEarlyHandler(b){Error.stackTraceLimit=100;const E=b.get(l.$8i),r=b.get(c.$bM).getProxy(L.$aK.MainThreadErrors);y.setUnexpectedErrorHandler(s=>{E.error(s);const n=y.$2(s);r.$onUnexpectedError(n)})}static async installFullHandler(b){const E=b.get(l.$8i),v=b.get(c.$bM),r=b.get($.$vcc),s=b.get(m.$vM),n=v.getProxy(L.$aK.MainThreadExtensionService),o=v.getProxy(L.$aK.MainThreadErrors),w=await r.getExtensionPathIndex(),d=new WeakMap;function I(g,h){if(d.has(g))return d.get(g).stack;let P="",W,K;for(const B of h)P+=`
	at ${B.toString()}`,K=B.getFileName(),!W&&K&&(W=w.findSubstr(C.URI.file(K)));const j=`${g.name||"Error"}: ${g.message||""}${P}`;return d.set(g,{extensionIdentifier:W?.identifier,stack:j}),j}const S=Symbol("prepareStackTrace wrapped");let u=I;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(g){if(g===I||!g||g[S]){u=g||I;return}u=function(h,P){return I(h,P),g.call(Error,h,P)},Object.assign(u,{[S]:!0})}}),y.setUnexpectedErrorHandler(g=>{E.error(g);const h=y.$2(g),P=d.get(g);if(!P?.extensionIdentifier){o.$onUnexpectedError(h);return}n.$onExtensionRuntimeError(P.extensionIdentifier,h);const W=s.onExtensionError(P.extensionIdentifier,g);E.trace("forwarded error to extension?",W,P)})}}e.$Udc=t;class i{constructor(b,E,v,r,s){this.a=v,this.b=new A.$i4b(b,null,r),E=i.e(E,this.b);const n=new f.$Lh(...(0,k.$ur)());n.set(R.$rM,{_serviceBrand:void 0,...E,messagePorts:s}),n.set(c.$bM,new c.$cM(this.b)),n.set(p.$Wbc,new p.$Xbc(r)),n.set($.$tcc,v);const o=new D.$aq(n,!0);o.invokeFunction(t.installEarlyHandler),this.d=o.invokeFunction(w=>w.get(l.$8i)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",E),this.c=o.invokeFunction(w=>w.get($.$vcc)),this.c.initialize(),o.invokeFunction(t.installFullHandler)}async asBrowserUri(b){const E=this.b.getProxy(L.$aK.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,E){b.extensions.allExtensions.forEach(r=>{r.extensionLocation=C.URI.revive(E.transformIncomingURIs(r.extensionLocation))}),b.environment.appRoot=C.URI.revive(E.transformIncomingURIs(b.environment.appRoot));const v=b.environment.extensionDevelopmentLocationURI;return v&&(b.environment.extensionDevelopmentLocationURI=v.map(r=>C.URI.revive(E.transformIncomingURIs(r)))),b.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=C.URI.revive(E.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=C.URI.revive(E.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=C.URI.revive(E.transformIncomingURIs(b.logsLocation)),b.workspace=E.transformIncomingURIs(b.workspace),b}}e.$Vdc=i}),define(Re[271],Me([1,0,18,12,21,42,13,19,23,2,48]),function(we,e,y,M,C,L,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=e.$adc=e.$_cc=void 0;class D{constructor(a,b,E,v){this.d=a,this.e=b,this.f=E,this.g=v,this.a=null,this.b=!1,this.c=0}search(a,b){const E=this.d.folderQueries||[],v=new C.$Wd(b);return new Promise((r,s)=>{this.a=new p(a);let n=!1;const o=(w,d)=>{if(!n&&!this.b){const I=this.h(w);m(w)&&typeof this.d.maxResults=="number"&&this.c+I>this.d.maxResults&&(this.b=!0,n=!0,v.cancel(),w=this.j(w,this.d.maxResults-this.c));const S=this.h(w);this.c+=S,(S>0||!m(w))&&this.a.add(w,d)}};Promise.all(E.map((w,d)=>this.k(w,I=>o(I,d),v.token))).then(w=>{v.dispose(),this.a.flush();const d=w.some(I=>!!I&&!!I.limitHit);r({limitHit:this.b||d,messages:(0,y.$Qb)(w.map(I=>I?.message?Array.isArray(I.message)?I.message:[I.message]:[])),stats:{type:this.g}})},w=>{v.dispose();const d=(0,L.$yi)(w);s(new Error(d))})})}h(a){return m(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,b){const E=Array.isArray(a.ranges)?a.ranges:[a.ranges],v=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:E.slice(0,b),preview:{matches:v.slice(0,b),text:a.preview.text},uri:a.uri}}async k(a,b,E){const v=new R.$XI(this.d,a),r=[],s={report:w=>{if(!this.l(w))return;const d=a.folder.scheme===A.Schemas.file?(0,R.$YI)(()=>this.f.readdir(k.$tg(w.uri))):void 0,I=k.$wg(a.folder,w.uri);if(I){const S=v.includedInQuery(I,l.$mc(I),d);(0,M.$Fg)(S)?r.push(S.then(u=>{u&&b(w)})):S&&b(w)}}},n=this.n(a),o=await this.e.provideTextSearchResults(c(this.d.contentPattern),n,s,E);return r.length&&await Promise.all(r),o}l(a){if(m(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const b=(0,R.$WI)(this.d.includePattern,a.includePattern),E=(0,R.$WI)(this.d.excludePattern,a.excludePattern),v={folder:f.URI.from(a.folder),excludes:E,includes:b,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.$_cc=D;function c(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class p{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new t(512,b=>this.g(b))}add(a,b){this.d&&(this.b!==b||!k.$ng(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:a.uri,results:[]}),this.d.results.push($(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$adc=p;function $(i){return m(i)?{preview:{matches:(0,y.$1b)(i.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:i.preview.text},ranges:(0,y.$1b)(i.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function m(i){return!!i.preview}e.$bdc=m;class t{static{this.a=4e3}static{this.b=50}constructor(a,b){this.g=a,this.h=b,this.c=0,this.d=[],this.e=0}addItem(a,b){a&&this.j(a,b)}addItems(a,b){a&&this.k(a,b)}j(a,b){this.d.push(a),this.e+=b,this.l()}k(a,b){this.d=this.d.concat(a),this.e+=b,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$cdc=t}),define(Re[114],Me([1,0,6,3,4,266,17,55,14,2,271]),function(we,e,y,M,C,L,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=void 0,e.$ddc=(0,C.$Nh)("IExtHostSearch");let D=class{constructor(m,t,i){this.k=m,this.l=t,this.n=i,this.c=this.k.getProxy(M.$aK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$$cc}o(m){return this.l.transformOutgoingScheme(m)}registerTextSearchProvider(m,t){if(this.g.has(m))throw new Error(`a text search provider for the scheme '${m}' is already registered`);this.g.add(m);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(m)),(0,y.$Pc)(()=>{this.g.delete(m),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(m,t){if(this.i.has(m))throw new Error(`a file search provider for the scheme '${m}' is already registered`);this.i.add(m);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(m)),(0,y.$Pc)(()=>{this.i.delete(m),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(m,t,i,a){const b=c(i),E=this.h.get(m);if(E)return this.j.fileSearch(b,E,v=>{this.c.$handleFileMatch(m,t,v.map(r=>r.resource))},a);throw new Error("unknown provider: "+m)}$clearCache(m){return this.j.clearCache(m),Promise.resolve(void 0)}$provideTextSearchResults(m,t,i,a){const b=this.e.get(m);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${m}`);const E=c(i);return this.q(E,b).search(r=>this.c.$handleTextMatch(m,t,r),a)}$enableExtensionHostSearch(){}q(m,t){return new R.$_cc(m,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$edc=D,e.$edc=D=qe([We(0,A.$bM),We(1,l.$Wbc),We(2,k.$8i)],D);function c($){return{...$,folderQueries:$.folderQueries&&$.folderQueries.map(p),extraFileResources:$.extraFileResources&&$.extraFileResources.map(m=>f.URI.revive(m))}}e.$fdc=c;function p($){return{...$,folder:f.URI.revive($.folder)}}}),define(Re[272],Me([1,0,21,9,5,29,2,135,283,124,133,38,3,79,224,223,31,225,34,227,228,229,203,230,59,35,233,234,239,240,242,109,207,248,249,251,84,62,253,210,8,7,53,256,63,108,33,20,198,238,52,107,111,113,114,14,55,17,27,243,196,86,80,217,254,85,61,259,257,258,218,39,252,255,83,60,57,244,110,245,13,95,206,189,236,6,25,194,81,185,246,247,219,235,205,237,82,250,221,222,216,232,220]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v,r,s,n,o,w,d,I,S,u,g,h,P,W,K,j,B,O,N,te,Y,Ee,Se,Pe,ge,me,ce,se,$e,_,z,V,ue,ye,be,pe,De,ne,le,re,oe,de,Ie,F,q,J,Q,H,x,ae,Le,je,Qe,Ge,xe,Xe,_e,it,tt,ze,st,X,Z,ve,Ue,Oe,Ze,rt,mt,wt,Ct,Yt,qt,bt,Ut,Lt,Bt,Pt,At,Nt,Wt,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=void 0;function Kt(at){const ut=at.get(ne.$rM),Jt=at.get(Le.$Mbc),It=at.get(J.$fcc),Et=at.get(o.$vcc),dt=at.get(me.$Zbc),kt=at.get(Xe.$vM),Tt=at.get(a.$3bc),yt=at.get(pe.$Wbc),Ke=at.get(De.$bM),Ot=at.get(j.$bcc),zt=at.get(q.$gcc),Ce=at.get(be.$9i),Ae=at.get(be.$8i),fe=at.get(oe.$Wvb),G=at.get(de.$Pbc),Fe=at.get(ge.$Tcc),Be=at.get(Ge.$ncc),Je=at.get(xe.$2cc),Ve=at.get(Lt.$rcc);Ke.set(c.$bK.ExtHostFileSystemInfo,Jt),Ke.set(c.$bK.ExtHostLogLevelServiceShape,Ce),Ke.set(c.$bK.ExtHostWorkspace,dt),Ke.set(c.$bK.ExtHostConfiguration,Tt),Ke.set(c.$bK.ExtHostExtensionService,Et),Ke.set(c.$bK.ExtHostStorage,Ot),Ke.set(c.$bK.ExtHostTunnelService,fe),Ke.set(c.$bK.ExtHostWindow,Fe),Ke.set(c.$bK.ExtHostSecretState,Be),Ke.set(c.$bK.ExtHostTelemetry,kt),Ke.set(c.$bK.ExtHostEditorTabs,Je),Ke.set(c.$bK.ExtHostManagedSockets,Ve);const et=Ke.set(c.$bK.ExtHostDecorations,at.get(z.$Xcc)),gt=Ke.set(c.$bK.ExtHostDocumentsAndEditors,at.get(n.$mM)),ft=Ke.set(c.$bK.ExtHostCommands,at.get(t.$xM)),pt=Ke.set(c.$bK.ExtHostTerminalService,at.get(B.$icc)),ht=Ke.set(c.$bK.ExtHostDebugService,at.get(ue.$6cc)),Rt=Ke.set(c.$bK.ExtHostSearch,at.get(ye.$ddc)),Gt=Ke.set(c.$bK.ExtHostTask,at.get(V.$1cc)),Ei=Ke.set(c.$bK.ExtHostOutputService,at.get(g.$Dcc)),Vt=Ke.set(c.$bK.ExtHostLocalization,at.get(rt.$qcc)),mi=Ke.set(c.$bK.ExtHostUrls,new Se.$Mcc(Ke)),St=Ke.set(c.$bK.ExtHostDocuments,new s.$Kbc(Ke,gt)),Di=Ke.set(c.$bK.ExtHostDocumentContentProviders,new v.$5bc(Ke,gt,Ae)),Ki=Ke.set(c.$bK.ExtHostDocumentSaveParticipant,new r.$6bc(Ae,St,Ke.getProxy(c.$aK.MainThreadBulkEdits))),Dt=Ke.set(c.$bK.ExtHostNotebook,new le.$jdc(Ke,ft,gt,St,It)),ii=Ke.set(c.$bK.ExtHostNotebookDocuments,new Z.$Bdc(Dt)),$i=Ke.set(c.$bK.ExtHostNotebookEditors,new X.$Adc(Ae,Dt)),oi=Ke.set(c.$bK.ExtHostNotebookKernels,new _e.$xdc(Ke,ut,Dt,ft,Ae)),ki=Ke.set(c.$bK.ExtHostNotebookRenderers,new tt.$zdc(Ke,Dt)),Si=Ke.set(c.$bK.ExtHostNotebookDocumentSaveParticipant,new bt.$Hdc(Ae,Dt,Ke.getProxy(c.$aK.MainThreadBulkEdits))),Mt=Ke.set(c.$bK.ExtHostEditors,new O.$Kcc(Ke,gt)),pi=Ke.set(c.$bK.ExtHostTreeViews,new N.$Lcc(Ke.getProxy(c.$aK.MainThreadTreeViews),ft,Ae)),Ii=Ke.set(c.$bK.ExtHostEditorInsets,new se.$Ucc(Ke.getProxy(c.$aK.MainThreadEditorInsets),Mt,ut.remote)),ai=Ke.set(c.$bK.ExtHostDiagnostics,new b.$Obc(Ke,Ae,Jt,gt)),ci=Ke.set(c.$bK.ExtHostLanguages,new S.$Acc(Ke,St,ft.converter,yt)),ct=Ke.set(c.$bK.ExtHostLanguageFeatures,new I.$Sbc(Ke,yt,St,ft,ai,Ae,G,kt)),Vi=Ke.set(c.$bK.ExtHostFileSystem,new w.$ycc(Ke,ct)),Xt=Ke.set(c.$bK.ExtHostFileSystemEventService,new d.$zcc(Ke,Ae,gt)),ni=Ke.set(c.$bK.ExtHostQuickOpen,(0,P.$Fcc)(Ke,dt,ft)),vi=Ke.set(c.$bK.ExtHostSCM,new W.$Hcc(Ke,ft,St,Ae)),Ci=Ke.set(c.$bK.ExtHostQuickDiff,new Ct.$Edc(Ke,yt)),qi=Ke.set(c.$bK.ExtHostShare,new Bt.$Jdc(Ke,yt)),Pi=Ke.set(c.$bK.ExtHostComments,(0,i.$Vbc)(Ke,ft,St)),bi=Ke.set(c.$bK.ExtHostProgress,new h.$Ecc(Ke.getProxy(c.$aK.MainThreadProgress))),Hi=Ke.set(c.$bK.ExtHosLabelService,new $e.$Vcc(Ke)),Ai=Ke.set(c.$bK.ExtHostTheming,new re.$kdc(Ke)),ui=Ke.set(c.$bK.ExtHostAuthentication,new Ie.$ldc(Ke)),Gi=Ke.set(c.$bK.ExtHostTimeline,new F.$ndc(Ke,ft)),wi=Ke.set(c.$bK.ExtHostWebviews,new Pe.$Pcc(Ke,ut.remote,dt,Ae,G)),Ri=Ke.set(c.$bK.ExtHostWebviewPanels,new x.$pdc(Ke,wi,dt)),cn=Ke.set(c.$bK.ExtHostCustomEditors,new H.$qdc(Ke,St,zt,wi,Ri)),Mi=Ke.set(c.$bK.ExtHostWebviewViews,new Q.$odc(Ke,wi)),ri=Ke.set(c.$bK.ExtHostTesting,new je.$sdc(Ke,ft,gt)),un=Ke.set(c.$bK.ExtHostUriOpeners,new Qe.$wdc(Ke)),ln=Ke.set(c.$bK.ExtHostProfileContentHandlers,new wt.$Ddc(Ke));Ke.set(c.$bK.ExtHostInteractive,new ve.$Cdc(Ke,Dt,gt,ft,Ae));const Ji=Ke.set(c.$bK.ExtHostInlineChat,new qt.$Gdc(Ke,ft,St,Ae)),fi=Ke.set(c.$bK.ExtHostChatProvider,new Pt.$Kdc(Ke,Ae)),Qi=Ke.set(c.$bK.ExtHostChatAgents,new Ht.$Odc(Ke,fi,Ae)),Zi=Ke.set(c.$bK.ExtHostChatVariables,new At.$Ldc(Ke)),gi=Ke.set(c.$bK.ExtHostChat,new Yt.$Fdc(Ke,Ae)),Yi=Ke.set(c.$bK.ExtHostAiRelatedInformation,new Nt.$Mdc(Ke)),Fi=Ke.set(c.$bK.ExtHostAiEmbeddingVector,new Wt.$Ndc(Ke)),Xi=Ke.set(c.$bK.ExtHostIssueReporter,new Ut.$Idc(Ke)),xt=Ke.set(c.$bK.ExtHostStatusBar,new K.$Jcc(Ke,ft.converter)),yi=Object.values(c.$bK);Ke.assertRegistered(yi);const hn=new ae.$rdc(Ke,gt),Qt=new m.$Ubc(Ke),li=new u.$Bcc(Ke,Ae),Ti=new E.$4bc(Ke);return $.$Tbc.register(ft),function(Ne,_t,Li){const $t=function(){let ee=!Ne.isUnderDevelopment;function he(){ee||(Ae.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Te(nt){if(Array.isArray(nt))nt.forEach(Te);else if(typeof nt=="string")he();else{const vt=nt;typeof vt.scheme>"u"&&he(),typeof vt.exclusive=="boolean"&&(0,Oe.$aF)(Ne,"documentFiltersExclusive")}return nt}}(),xi={getSession(ee,he,Te){return ui.getSession(Ne,ee,he,Te)},getSessions(ee,he){return(0,Oe.$aF)(Ne,"authGetSessions"),ui.getSessions(Ne,ee,he)},async hasSession(ee,he){return(0,Oe.$aF)(Ne,"authSession"),!!await ui.getSession(Ne,ee,he,{silent:!0})},get onDidChangeSessions(){return ui.onDidChangeSessions},registerAuthenticationProvider(ee,he,Te,nt){return ui.registerAuthenticationProvider(ee,he,Te,nt)}},_i={registerCommand(ee,he,Te){return ft.registerCommand(!0,ee,he,Te,void 0,Ne)},registerTextEditorCommand(ee,he,Te){return ft.registerCommand(!0,ee,(...nt)=>{const vt=Mt.getActiveTextEditor();if(!vt){Ae.warn("Cannot execute "+ee+" because there is no active text editor.");return}return vt.edit(Ft=>{he.apply(Te,[vt,Ft,...nt])}).then(Ft=>{Ft||Ae.warn("Edits from command "+ee+" were not applied.")},Ft=>{Ae.warn("An error occurred while running command "+ee,Ft)})},void 0,void 0,Ne)},registerDiffInformationCommand:(ee,he,Te)=>((0,Oe.$aF)(Ne,"diffCommand"),ft.registerCommand(!0,ee,async(...nt)=>{const vt=gt.activeEditor(!0);if(!vt){Ae.warn("Cannot execute "+ee+" because there is no active text editor.");return}const Ft=await Mt.getDiffInformation(vt.id);he.apply(Te,[Ft,...nt])},void 0,void 0,Ne)),executeCommand(ee,...he){return ft.executeCommand(ee,...he)},getCommands(ee=!1){return ft.getCommands(ee)}},en={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Qt.value},get shell(){return pt.getDefaultShell(!1)},get onDidChangeShell(){return pt.onDidChangeShell},get isTelemetryEnabled(){return kt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return kt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$aF)(Ne,"telemetry"),kt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$aF)(Ne,"telemetry"),kt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$uM)(ut.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,he){return Xe.$tM.validateSender(ee),kt.instantiateLogger(Ne,ee,he)},openExternal(ee,he){return Fe.openUri(ee,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:he?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===ut.environment.appUriScheme)return mi.createAppUri(ee);try{return await Fe.asExternalUri(ee,{allowTunneling:!!ut.remote.authority})}catch(he){if((0,st.$0T)(ee,ze.Schemas.http)||(0,st.$0T)(ee,ze.Schemas.https))return ee;throw he}},get remoteName(){return(0,_.$Tk)(ut.remote.authority)},get remoteAuthority(){return(0,Oe.$aF)(Ne,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind},get logLevel(){return Ae.getLevel()},get onDidChangeLogLevel(){return Ae.onDidChangeLogLevel},registerIssueUriRequestHandler(ee){return(0,Oe.$aF)(Ne,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Ne,ee)},get appQuality(){return(0,Oe.$aF)(Ne,"resolvers"),ut.quality},get appCommit(){return(0,Oe.$aF)(Ne,"resolvers"),ut.commit}};ut.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(ee,he,Te){return ri.createTestController(Ne,ee,he,Te)},createTestObserver(){return(0,Oe.$aF)(Ne,"testObserver"),ri.createTestObserver()},runTests(ee){return(0,Oe.$aF)(Ne,"testObserver"),ri.runTests(ee)},get onDidChangeTestResults(){return(0,Oe.$aF)(Ne,"testObserver"),ri.onResultsChanged},get testResults(){return(0,Oe.$aF)(Ne,"testObserver"),ri.results}},hi=ut.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,tn={getExtension(ee,he){(0,Oe.$_E)(Ne,"extensionsAny")||(he=!1);const Te=_t.mine.getExtensionDescription(ee);if(Te)return new o.$wcc(Et,Ne.identifier,Te,hi,!1);if(he){const nt=_t.all.getExtensionDescription(ee);if(nt)return new o.$wcc(Et,Ne.identifier,nt,hi,!0)}},get all(){const ee=[];for(const he of _t.mine.getAllExtensionDescriptions())ee.push(new o.$wcc(Et,Ne.identifier,he,hi,!1));return ee},get allAcrossExtensionHosts(){(0,Oe.$aF)(Ne,"extensionsAny");const ee=new ce.$4l(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),he=[];for(const Te of _t.all.getAllExtensionDescriptions()){const nt=!ee.has(Te.identifier);he.push(new o.$wcc(Et,Ne.identifier,Te,hi,nt))}return he},get onDidChange(){return(0,Oe.$_E)(Ne,"extensionsAny")?C.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(ee){return ai.createDiagnosticCollection(Ne.identifier,ee)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:ee=>ai.getDiagnostics(ee),getLanguages(){return ci.getLanguages()},setTextDocumentLanguage(ee,he){return ci.changeLanguage(ee.uri,he)},match(ee,he){const Te=St.getDocumentData(he.uri)?.notebook;return(0,R.$nE)(te.LanguageSelector.from(ee),he.uri,he.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(ee,he,Te){return ct.registerCodeActionProvider(Ne,$t(ee),he,Te)},registerDocumentPasteEditProvider(ee,he,Te){return(0,Oe.$aF)(Ne,"documentPaste"),ct.registerDocumentPasteEditProvider(Ne,$t(ee),he,Te)},registerCodeLensProvider(ee,he){return ct.registerCodeLensProvider(Ne,$t(ee),he)},registerDefinitionProvider(ee,he){return ct.registerDefinitionProvider(Ne,$t(ee),he)},registerDeclarationProvider(ee,he){return ct.registerDeclarationProvider(Ne,$t(ee),he)},registerImplementationProvider(ee,he){return ct.registerImplementationProvider(Ne,$t(ee),he)},registerTypeDefinitionProvider(ee,he){return ct.registerTypeDefinitionProvider(Ne,$t(ee),he)},registerHoverProvider(ee,he){return ct.registerHoverProvider(Ne,$t(ee),he,Ne.identifier)},registerEvaluatableExpressionProvider(ee,he){return ct.registerEvaluatableExpressionProvider(Ne,$t(ee),he,Ne.identifier)},registerInlineValuesProvider(ee,he){return ct.registerInlineValuesProvider(Ne,$t(ee),he,Ne.identifier)},registerDocumentHighlightProvider(ee,he){return ct.registerDocumentHighlightProvider(Ne,$t(ee),he)},registerLinkedEditingRangeProvider(ee,he){return ct.registerLinkedEditingRangeProvider(Ne,$t(ee),he)},registerReferenceProvider(ee,he){return ct.registerReferenceProvider(Ne,$t(ee),he)},registerRenameProvider(ee,he){return ct.registerRenameProvider(Ne,$t(ee),he)},registerDocumentSymbolProvider(ee,he,Te){return ct.registerDocumentSymbolProvider(Ne,$t(ee),he,Te)},registerWorkspaceSymbolProvider(ee){return ct.registerWorkspaceSymbolProvider(Ne,ee)},registerDocumentFormattingEditProvider(ee,he){return ct.registerDocumentFormattingEditProvider(Ne,$t(ee),he)},registerDocumentRangeFormattingEditProvider(ee,he){return ct.registerDocumentRangeFormattingEditProvider(Ne,$t(ee),he)},registerOnTypeFormattingEditProvider(ee,he,Te,...nt){return ct.registerOnTypeFormattingEditProvider(Ne,$t(ee),he,[Te].concat(nt))},registerDocumentSemanticTokensProvider(ee,he,Te){return ct.registerDocumentSemanticTokensProvider(Ne,$t(ee),he,Te)},registerDocumentRangeSemanticTokensProvider(ee,he,Te){return ct.registerDocumentRangeSemanticTokensProvider(Ne,$t(ee),he,Te)},registerSignatureHelpProvider(ee,he,Te,...nt){return typeof Te=="object"?ct.registerSignatureHelpProvider(Ne,$t(ee),he,Te):ct.registerSignatureHelpProvider(Ne,$t(ee),he,typeof Te>"u"?[]:[Te,...nt])},registerCompletionItemProvider(ee,he,...Te){return ct.registerCompletionItemProvider(Ne,$t(ee),he,Te)},registerInlineCompletionItemProvider(ee,he,Te){return he.handleDidShowCompletionItem&&(0,Oe.$aF)(Ne,"inlineCompletionsAdditions"),he.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$aF)(Ne,"inlineCompletionsAdditions"),Te&&(0,Oe.$aF)(Ne,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ne,$t(ee),he,Te)},registerDocumentLinkProvider(ee,he){return ct.registerDocumentLinkProvider(Ne,$t(ee),he)},registerColorProvider(ee,he){return ct.registerColorProvider(Ne,$t(ee),he)},registerFoldingRangeProvider(ee,he){return ct.registerFoldingRangeProvider(Ne,$t(ee),he)},registerSelectionRangeProvider(ee,he){return ct.registerSelectionRangeProvider(Ne,ee,he)},registerCallHierarchyProvider(ee,he){return ct.registerCallHierarchyProvider(Ne,ee,he)},registerTypeHierarchyProvider(ee,he){return ct.registerTypeHierarchyProvider(Ne,ee,he)},setLanguageConfiguration:(ee,he)=>ct.setLanguageConfiguration(Ne,ee,he),getTokenInformationAtPosition(ee,he){return(0,Oe.$aF)(Ne,"tokenInformation"),ci.tokenAtPosition(ee,he)},registerInlayHintsProvider(ee,he){return ct.registerInlayHintsProvider(Ne,ee,he)},createLanguageStatusItem(ee,he){return ci.createLanguageStatusItem(Ne,ee,he)},registerDocumentDropEditProvider(ee,he,Te){return ct.registerDocumentOnDropEditProvider(Ne,ee,he,(0,Oe.$_E)(Ne,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return pt.activeTerminal},get terminals(){return pt.terminals},async showTextDocument(ee,he,Te){const nt=await(A.URI.isUri(ee)?Promise.resolve(sn.openTextDocument(ee)):Promise.resolve(ee));return Mt.showTextDocument(nt,he,Te)},createTextEditorDecorationType(ee){return Mt.createTextEditorDecorationType(Ne,ee)},onDidChangeActiveTextEditor(ee,he,Te){return Mt.onDidChangeActiveTextEditor(ee,he,Te)},onDidChangeVisibleTextEditors(ee,he,Te){return Mt.onDidChangeVisibleTextEditors(ee,he,Te)},onDidChangeTextEditorSelection(ee,he,Te){return Mt.onDidChangeTextEditorSelection(ee,he,Te)},onDidChangeTextEditorOptions(ee,he,Te){return Mt.onDidChangeTextEditorOptions(ee,he,Te)},onDidChangeTextEditorVisibleRanges(ee,he,Te){return Mt.onDidChangeTextEditorVisibleRanges(ee,he,Te)},onDidChangeTextEditorViewColumn(ee,he,Te){return Mt.onDidChangeTextEditorViewColumn(ee,he,Te)},onDidCloseTerminal(ee,he,Te){return pt.onDidCloseTerminal(ee,he,Te)},onDidOpenTerminal(ee,he,Te){return pt.onDidOpenTerminal(ee,he,Te)},onDidChangeActiveTerminal(ee,he,Te){return pt.onDidChangeActiveTerminal(ee,he,Te)},onDidChangeTerminalDimensions(ee,he,Te){return(0,Oe.$aF)(Ne,"terminalDimensions"),pt.onDidChangeTerminalDimensions(ee,he,Te)},onDidChangeTerminalState(ee,he,Te){return pt.onDidChangeTerminalState(ee,he,Te)},onDidWriteTerminalData(ee,he,Te){return(0,Oe.$aF)(Ne,"terminalDataWriteEvent"),pt.onDidWriteTerminalData(ee,he,Te)},onDidExecuteTerminalCommand(ee,he,Te){return(0,Oe.$aF)(Ne,"terminalExecuteCommandEvent"),pt.onDidExecuteTerminalCommand(ee,he,Te)},get state(){return Fe.getState(Ne)},onDidChangeWindowState(ee,he,Te){return Fe.onDidChangeWindowState(ee,he,Te)},showInformationMessage(ee,...he){return li.showMessage(Ne,L.default.Info,ee,he[0],he.slice(1))},showWarningMessage(ee,...he){return li.showMessage(Ne,L.default.Warning,ee,he[0],he.slice(1))},showErrorMessage(ee,...he){return li.showMessage(Ne,L.default.Error,ee,he[0],he.slice(1))},showQuickPick(ee,he,Te){return ni.showQuickPick(Ne,ee,he,Te)},showWorkspaceFolderPick(ee){return ni.showWorkspaceFolderPick(ee)},showInputBox(ee,he){return ni.showInput(ee,he)},showOpenDialog(ee){return Ti.showOpenDialog(Ne,ee)},showSaveDialog(ee){return Ti.showSaveDialog(ee)},createStatusBarItem(ee,he,Te){let nt,vt,Ft;return typeof ee=="string"?(nt=ee,vt=he,Ft=Te):(vt=ee,Ft=he),xt.createStatusBarEntry(Ne,nt,vt,Ft)},setStatusBarMessage(ee,he){return xt.setStatusBarMessage(ee,he)},withScmProgress(ee){return G.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),bi.withProgress(Ne,{location:Y.ProgressLocation.SourceControl},(he,Te)=>ee({report(nt){}}))},withProgress(ee,he){return bi.withProgress(Ne,ee,he)},createOutputChannel(ee,he){return Ei.createOutputChannel(ee,he,Ne)},createWebviewPanel(ee,he,Te,nt){return Ri.createWebviewPanel(Ne,ee,he,Te,nt)},createWebviewTextEditorInset(ee,he,Te,nt){return(0,Oe.$aF)(Ne,"editorInsets"),Ii.createWebviewEditorInset(ee,he,Te,nt,Ne)},createTerminal(ee,he,Te){return typeof ee=="object"?"pty"in ee?pt.createExtensionTerminal(ee):pt.createTerminalFromOptions(ee):pt.createTerminal(ee,he,Te)},registerTerminalLinkProvider(ee){return pt.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,he){return pt.registerProfileProvider(Ne,ee,he)},registerTerminalQuickFixProvider(ee,he){return(0,Oe.$aF)(Ne,"terminalQuickFixProvider"),pt.registerTerminalQuickFixProvider(ee,Ne.identifier.value,he)},registerTreeDataProvider(ee,he){return pi.registerTreeDataProvider(ee,he,Ne)},createTreeView(ee,he){return pi.createTreeView(ee,he,Ne)},registerWebviewPanelSerializer:(ee,he)=>Ri.registerWebviewPanelSerializer(Ne,ee,he),registerCustomEditorProvider:(ee,he,Te={})=>cn.registerCustomEditorProvider(Ne,ee,he,Te),registerFileDecorationProvider(ee){return et.registerFileDecorationProvider(ee,Ne)},registerUriHandler(ee){return mi.registerUriHandler(Ne,ee)},createQuickPick(){return ni.createQuickPick(Ne)},createInputBox(){return ni.createInputBox(Ne)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(ee,he,Te){return Ai.onDidChangeActiveColorTheme(ee,he,Te)},registerWebviewViewProvider(ee,he,Te){return Mi.registerWebviewViewProvider(Ne,ee,he,Te?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,he,Te){return Dt.onDidChangeActiveNotebookEditor(ee,he,Te)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,he,Te){return $i.onDidChangeNotebookEditorSelection(ee,he,Te)},onDidChangeNotebookEditorVisibleRanges(ee,he,Te){return $i.onDidChangeNotebookEditorVisibleRanges(ee,he,Te)},showNotebookDocument(ee,he){return Dt.showNotebookDocument(ee,he)},registerExternalUriOpener(ee,he,Te){return(0,Oe.$aF)(Ne,"externalUriOpener"),un.registerExternalUriOpener(Ne.identifier,ee,he,Te)},registerProfileContentHandler(ee,he){return(0,Oe.$aF)(Ne,"profileContentHandlers"),ln.registrProfileContentHandler(Ne,ee,he)},registerQuickDiffProvider(ee,he,Te,nt){return(0,Oe.$aF)(Ne,"quickDiffProvider"),Ci.registerQuickDiffProvider($t(ee),he,Te,nt)},get tabGroups(){return Je.tabGroups},registerShareProvider(ee,he){return(0,Oe.$aF)(Ne,"shareProvider"),qi.registerShareProvider($t(ee),he)}},sn={get rootPath(){return G.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw new M.$8("rootPath")},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw new M.$8("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw new M.$8("workspaceFile")},updateWorkspaceFolders:(ee,he,...Te)=>dt.updateWorkspaceFolders(Ne,ee,he||0,...Te),onDidChangeWorkspaceFolders:function(ee,he,Te){return dt.onDidChangeWorkspace(ee,he,Te)},asRelativePath:(ee,he)=>dt.getRelativePath(ee,he),findFiles:(ee,he,Te,nt)=>dt.findFiles(ee,he,Te,Ne.identifier,nt),findTextInFiles:(ee,he,Te,nt)=>{(0,Oe.$aF)(Ne,"findTextInFiles");let vt,Ft;return typeof he=="object"?(vt=he,Ft=Te):(vt={},Ft=he,nt=Te),dt.findTextInFiles(ee,vt||{},Ft,Ne.identifier,nt)},save:ee=>((0,Oe.$aF)(Ne,"saveEditor"),dt.save(ee)),saveAs:ee=>((0,Oe.$aF)(Ne,"saveEditor"),dt.saveAs(ee)),saveAll:ee=>dt.saveAll(ee),applyEdit(ee,he){return hn.applyWorkspaceEdit(ee,Ne,he)},createFileSystemWatcher:(ee,he,Te,nt)=>{let vt;return typeof he=="boolean"?vt={ignoreCreateEvents:!!he,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!nt}:he&&((0,Oe.$aF)(Ne,"createFileSystemWatcher"),vt=he),Xt.createFileSystemWatcher(dt,Ne,ee,vt)},get textDocuments(){return St.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new M.$8("textDocuments")},openTextDocument(ee){let he;const Te=ee;if(typeof ee=="string")he=Promise.resolve(A.URI.file(ee));else if(A.URI.isUri(ee))he=Promise.resolve(ee);else if(!Te||typeof Te=="object")he=St.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(nt=>St.ensureDocumentData(nt).then(vt=>vt.document))},onDidOpenTextDocument:(ee,he,Te)=>St.onDidAddDocument(ee,he,Te),onDidCloseTextDocument:(ee,he,Te)=>St.onDidRemoveDocument(ee,he,Te),onDidChangeTextDocument:(ee,he,Te)=>St.onDidChangeDocument(ee,he,Te),onDidSaveTextDocument:(ee,he,Te)=>St.onDidSaveDocument(ee,he,Te),onWillSaveTextDocument:(ee,he,Te)=>Ki.getOnWillSaveTextDocumentEvent(Ne)(ee,he,Te),get notebookDocuments(){return Dt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,he){let Te;if(A.URI.isUri(ee))Te=ee,await Dt.openNotebookDocument(ee);else if(typeof ee=="string")Te=A.URI.revive(await Dt.createNotebookDocument({viewType:ee,content:he}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(ee,he,Te){return ii.onDidSaveNotebookDocument(ee,he,Te)},onDidChangeNotebookDocument(ee,he,Te){return ii.onDidChangeNotebookDocument(ee,he,Te)},onWillSaveNotebookDocument(ee,he,Te){return Si.getOnWillSaveNotebookDocumentEvent(Ne)(ee,he,Te)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(ee,he,Te,nt){return Dt.registerNotebookSerializer(Ne,ee,he,Te,(0,Oe.$_E)(Ne,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:(ee,he,Te)=>Li.onDidChangeConfiguration(ee,he,Te),getConfiguration(ee,he){return he=arguments.length===1?void 0:he,Li.getConfiguration(ee,he,Ne)},registerTextDocumentContentProvider(ee,he){return Di.registerTextDocumentContentProvider(ee,he)},registerTaskProvider:(ee,he)=>(G.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),Gt.registerTaskProvider(Ne,ee,he)),registerFileSystemProvider(ee,he,Te){return(0,Ue.$Oc)(Vi.registerFileSystemProvider(Ne,ee,he,Te),It.addFileSystemProvider(ee,he,Te))},get fs(){return It.value},registerFileSearchProvider:(ee,he)=>((0,Oe.$aF)(Ne,"fileSearchProvider"),Rt.registerFileSearchProvider(ee,he)),registerTextSearchProvider:(ee,he)=>((0,Oe.$aF)(Ne,"textSearchProvider"),Rt.registerTextSearchProvider(ee,he)),registerRemoteAuthorityResolver:(ee,he)=>((0,Oe.$aF)(Ne,"resolvers"),Et.registerRemoteAuthorityResolver(ee,he)),registerResourceLabelFormatter:ee=>((0,Oe.$aF)(Ne,"resolvers"),Hi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Oe.$aF)(Ne,"resolvers"),Et.getRemoteExecServer(ee)),onDidCreateFiles:(ee,he,Te)=>Xt.onDidCreateFile(ee,he,Te),onDidDeleteFiles:(ee,he,Te)=>Xt.onDidDeleteFile(ee,he,Te),onDidRenameFiles:(ee,he,Te)=>Xt.onDidRenameFile(ee,he,Te),onWillCreateFiles:(ee,he,Te)=>Xt.getOnWillCreateFileEvent(Ne)(ee,he,Te),onWillDeleteFiles:(ee,he,Te)=>Xt.getOnWillDeleteFileEvent(Ne)(ee,he,Te),onWillRenameFiles:(ee,he,Te)=>Xt.getOnWillRenameFileEvent(Ne)(ee,he,Te),openTunnel:ee=>((0,Oe.$aF)(Ne,"tunnels"),fe.openTunnel(Ne,ee).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return(0,Oe.$aF)(Ne,"tunnels"),fe.getTunnels()},onDidChangeTunnels:(ee,he,Te)=>((0,Oe.$aF)(Ne,"tunnels"),fe.onDidChangeTunnels(ee,he,Te)),registerPortAttributesProvider:(ee,he)=>((0,Oe.$aF)(Ne,"portsAttributes"),fe.registerPortsAttributesProvider(ee,he)),registerTunnelProvider:(ee,he)=>((0,Oe.$aF)(Ne,"tunnelFactory"),fe.registerTunnelProvider(ee,he)),registerTimelineProvider:(ee,he)=>((0,Oe.$aF)(Ne,"timeline"),Gi.registerTimelineProvider(ee,he,Ne.identifier,ft.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,Oe.$aF)(Ne,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,he,Te)=>dt.onDidGrantWorkspaceTrust(ee,he,Te),registerEditSessionIdentityProvider:(ee,he)=>((0,Oe.$aF)(Ne,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(ee,he)),onWillCreateEditSessionIdentity:(ee,he,Te)=>((0,Oe.$aF)(Ne,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Ne)(ee,he,Te)),registerCanonicalUriProvider:(ee,he)=>((0,Oe.$aF)(Ne,"canonicalUriProvider"),dt.registerCanonicalUriProvider(ee,he)),getCanonicalUri:(ee,he,Te)=>((0,Oe.$aF)(Ne,"canonicalUriProvider"),dt.provideCanonicalUri(ee,he,Te))},fn={get inputBox(){return G.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(Ne)},createSourceControl(ee,he,Te){return vi.createSourceControl(Ne,ee,he,Te)}},on={createCommentController(ee,he){return Pi.createCommentController(Ne,ee,he)}},an={get activeDebugSession(){return ht.activeDebugSession},get activeDebugConsole(){return ht.activeDebugConsole},get breakpoints(){return ht.breakpoints},get stackFrameFocus(){return ht.stackFrameFocus},onDidStartDebugSession(ee,he,Te){return ht.onDidStartDebugSession(ee,he,Te)},onDidTerminateDebugSession(ee,he,Te){return ht.onDidTerminateDebugSession(ee,he,Te)},onDidChangeActiveDebugSession(ee,he,Te){return ht.onDidChangeActiveDebugSession(ee,he,Te)},onDidReceiveDebugSessionCustomEvent(ee,he,Te){return ht.onDidReceiveDebugSessionCustomEvent(ee,he,Te)},onDidChangeBreakpoints(ee,he,Te){return ht.onDidChangeBreakpoints(ee,he,Te)},onDidChangeStackFrameFocus(ee,he,Te){return(0,Oe.$aF)(Ne,"debugFocus"),ht.onDidChangeStackFrameFocus(ee,he,Te)},registerDebugConfigurationProvider(ee,he,Te){return ht.registerDebugConfigurationProvider(ee,he,Te||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,he){return ht.registerDebugAdapterDescriptorFactory(Ne,ee,he)},registerDebugAdapterTrackerFactory(ee,he){return ht.registerDebugAdapterTrackerFactory(ee,he)},startDebugging(ee,he,Te){return!Te||typeof Te=="object"&&"configuration"in Te?ht.startDebugging(ee,he,{parentSession:Te}):ht.startDebugging(ee,he,Te||{})},stopDebugging(ee){return ht.stopDebugging(ee)},addBreakpoints(ee){return ht.addBreakpoints(ee)},removeBreakpoints(ee){return ht.removeBreakpoints(ee)},asDebugSourceUri(ee,he){return ht.asDebugSourceUri(ee,he)}},Ni={registerTaskProvider:(ee,he)=>Gt.registerTaskProvider(Ne,ee,he),fetchTasks:ee=>Gt.fetchTasks(ee),executeTask:ee=>Gt.executeTask(Ne,ee),get taskExecutions(){return Gt.taskExecutions},onDidStartTask:(ee,he,Te)=>Gt.onDidStartTask(ee,he,Te),onDidEndTask:(ee,he,Te)=>Gt.onDidEndTask(ee,he,Te),onDidStartTaskProcess:(ee,he,Te)=>Gt.onDidStartTaskProcess(ee,he,Te),onDidEndTaskProcess:(ee,he,Te)=>Gt.onDidEndTaskProcess(ee,he,Te)},Oi={createNotebookController(ee,he,Te,nt,vt){return oi.createNotebookController(Ne,ee,he,Te,nt,(0,Oe.$_E)(Ne,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,he)=>Dt.registerNotebookCellStatusBarItemProvider(Ne,ee,he),createRendererMessaging(ee){return ki.createRendererMessaging(Ne,ee)},createNotebookControllerDetectionTask(ee){return(0,Oe.$aF)(Ne,"notebookKernelSource"),oi.createNotebookControllerDetectionTask(Ne,ee)},registerKernelSourceActionProvider(ee,he){return(0,Oe.$aF)(Ne,"notebookKernelSource"),oi.registerKernelSourceActionProvider(Ne,ee,he)},onDidChangeNotebookCellExecutionState(ee,he,Te){return(0,Oe.$aF)(Ne,"notebookCellExecutionState"),oi.onDidChangeNotebookCellExecutionState(ee,he,Te)}},zi={t(...ee){if(typeof ee[0]=="string"){const he=ee.shift(),Te=!ee||typeof ee[0]!="object"?ee:ee[0];return Vt.getMessage(Ne.identifier.value,{message:he,args:Te})}return Vt.getMessage(Ne.identifier.value,ee[0])},get bundle(){return Vt.getBundle(Ne.identifier.value)},get uri(){return Vt.getBundleUri(Ne.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(ee,he){return(0,Oe.$aF)(Ne,"interactive"),Ji.registerProvider(Ne,ee,he={label:he?.label??Ne.displayName??Ne.name})},registerInteractiveSessionProvider(ee,he){return(0,Oe.$aF)(Ne,"interactive"),gi.registerChatProvider(Ne,ee,he)},sendInteractiveRequestToProvider(ee,he){return(0,Oe.$aF)(Ne,"interactive"),gi.sendInteractiveRequestToProvider(ee,he)},get onDidPerformUserAction(){return(0,Oe.$aF)(Ne,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(ee,he){return(0,Oe.$aF)(Ne,"interactive"),gi.transferChatSession(ee,he)}},ji={getRelatedInformation(ee,he){return(0,Oe.$aF)(Ne,"aiRelatedInformation"),Yi.getRelatedInformation(Ne,ee,he)},registerRelatedInformationProvider(ee,he){return(0,Oe.$aF)(Ne,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ne,ee,he)},registerEmbeddingVectorProvider(ee,he){return(0,Oe.$aF)(Ne,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Ne,ee,he)}},Ui={registerChatResponseProvider(ee,he,Te){return(0,Oe.$aF)(Ne,"chatProvider"),fi.registerProvider(Ne.identifier,ee,he,Te)},requestChatAccess(ee){return(0,Oe.$aF)(Ne,"chatRequestAccess"),fi.requestChatResponseProvider(Ne.identifier,ee)},registerVariable(ee,he,Te){return(0,Oe.$aF)(Ne,"chatVariables"),Zi.registerVariableResolver(Ne,ee,he,Te)},registerMappedEditsProvider(ee,he){return(0,Oe.$aF)(Ne,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ne,ee,he)},registerAgent(ee,he,Te){return(0,Oe.$aF)(Ne,"chatAgents"),Qi.registerAgent(Ne.identifier,ee,he,Te)}};return{version:ut.version,ai:ji,authentication:xi,commands:_i,comments:on,chat:Ui,debug:an,env:en,extensions:tn,interactive:di,l10n:zi,languages:nn,notebooks:Oi,scm:fn,tasks:Ni,tests:dn,window:rn,workspace:sn,Breakpoint:Y.$aL,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatMessage:Y.$3L,ChatMessageRole:Y.ChatMessageRole,ChatVariableLevel:Y.ChatVariableLevel,CallHierarchyIncomingCall:Y.$zK,CallHierarchyItem:Y.$yK,CallHierarchyOutgoingCall:Y.$AK,CancellationError:M.$4,CancellationTokenSource:y.$Wd,CandidatePortSource:c.CandidatePortSource,CodeAction:Y.$vK,CodeActionKind:Y.$wK,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$BK,Color:Y.$OK,ColorInformation:Y.$PK,ColorPresentation:Y.$QK,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CompletionItem:Y.$IK,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$JK,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$YK,DebugAdapterExecutable:Y.$eL,DebugAdapterInlineImplementation:Y.$hL,DebugAdapterNamedPipeServer:Y.$gL,DebugAdapterServer:Y.$fL,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$qK,DiagnosticRelatedInformation:Y.$pK,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$cK,DocumentHighlight:Y.$sK,DocumentHighlightKind:Y.DocumentHighlightKind,DocumentLink:Y.$NK,DocumentSymbol:Y.$uK,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$kL,InlineValueText:Y.$lL,InlineValueVariableLookup:Y.$mL,InlineValueEvaluatableExpression:Y.$nL,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:C.$Md,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$xL,FileDecoration2:Y.$xL,FileSystemError:Y.$pL,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Y.$qL,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$cL,InlineCompletionItem:Y.$KK,InlineCompletionList:Y.$LK,Hover:Y.$rK,IndentAction:f.IndentAction,Location:Y.$oK,MarkdownString:Y.$CK,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:Y.$DK,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$dK,ProcessExecution:Y.$WK,ProgressLocation:Y.ProgressLocation,QuickInputButtons:Y.$wL,Range:Y.$eK,RelativePattern:Y.$$K,Selection:Y.$fK,SelectionRange:Y.$xK,SemanticTokens:Y.$tL,SemanticTokensBuilder:Y.$sL,SemanticTokensEdit:Y.$uL,SemanticTokensEdits:Y.$vL,SemanticTokensLegend:Y.$rL,ShellExecution:Y.$XK,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$FK,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$EK,SnippetString:Y.$nK,SourceBreakpoint:Y.$bL,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$tK,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$ZK,TaskGroup:Y.$VK,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$RK,TerminalQuickFixExecuteTerminalCommand:Y.$TK,TerminalQuickFixOpener:Y.$SK,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$UK,TerminalExitReason:Y.TerminalExitReason,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$jK,SnippetTextEdit:Y.$lK,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$0K,ThemeIcon:Y.$9K,TreeItem:Y.$1K,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$SL,UIKind:p.UIKind,Uri:A.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$mK,DocumentDropEdit:Y.$7K,DocumentPasteEdit:Y.$8K,InlayHint:Y.$HK,InlayHintLabelPart:Y.$GK,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$iK,ResolvedAuthority:Y.$gK,ManagedResolvedAuthority:Y.$hK,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$HL,NotebookRange:Y.$zL,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$AL,NotebookData:Y.$BL,NotebookRendererScript:Y.$FL,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$DL,NotebookCellOutputItem:Y.$CL,NotebookCellStatusBarItem:Y.$EL,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$kK,NotebookKernelSourceAction:Y.$GL,PortAttributes:Y.$JL,LinkedEditingRanges:Y.$IL,TestResultState:Y.TestResultState,TestRunRequest:Y.$KL,TestMessage:Y.$LL,TestMessage2:Y.$LL,TestTag:Y.$ML,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Y.$6K,DataTransferItem:Y.$2K,CoveredCount:Y.$NL,FileCoverage:Y.$OL,StatementCoverage:Y.$PL,BranchCoverage:Y.$QL,FunctionCoverage:Y.$RL,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$TL,TabInputTextDiff:Y.$UL,TabInputTextMerge:Y.$VL,TabInputCustom:Y.$WL,TabInputNotebook:Y.$YL,TabInputNotebookDiff:Y.$ZL,TabInputWebview:Y.$XL,TabInputTerminal:Y.$1L,TabInputInteractiveWindow:Y.$2L,TelemetryTrustedValue:Ee.$go,LogLevel:be.LogLevel,EditSessionIdentityMatch:mt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Y.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Y.$iL,ThreadFocus:Y.$jL,RelatedInformationType:Y.RelatedInformationType}}}e.$Pdc=Kt}),define(Re[273],Me([1,0,69,109,33,107,34,31,59,62,111,113,114,84,86,80,108,61,39,83,57,60,241,14,112,81,82]),function(we,e,y,M,C,L,A,l,k,f,R,D,c,p,$,m,t,i,a,b,E,v,r,s,n,o,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$tr)(o.$qcc,o.$pcc,1),(0,y.$tr)(s.$9i,r.$Qdc,1),(0,y.$tr)(m.$Pbc,m.$Qbc,1),(0,y.$tr)(l.$xM,l.$wM,0),(0,y.$tr)(A.$3bc,A.$1bc,0),(0,y.$tr)(i.$fcc,i.$ecc,0),(0,y.$tr)(D.$6cc,D.$0cc,0),(0,y.$tr)(L.$Xcc,L.$Wcc,0),(0,y.$tr)(k.$mM,k.$lM,0),(0,y.$tr)(w.$rcc,w.$scc,0),(0,y.$tr)(a.$Mbc,a.$Lbc,0),(0,y.$tr)(M.$Dcc,M.$Ccc,1),(0,y.$tr)(c.$ddc,c.$edc,0),(0,y.$tr)(p.$bcc,p.$acc,0),(0,y.$tr)(R.$1cc,R.$Zcc,0),(0,y.$tr)(f.$icc,f.$lcc,0),(0,y.$tr)($.$Wvb,$.$Xvb,0),(0,y.$tr)(t.$Tcc,t.$Scc,0),(0,y.$tr)(C.$Zbc,C.$Ybc,0),(0,y.$tr)(b.$ncc,b.$mcc,0),(0,y.$tr)(E.$vM,E.$sM,0),(0,y.$tr)(v.$2cc,v.$3cc,0),(0,y.$tr)(n.$4cc,n.$5cc,0)}),define(Re[274],Me([1,0,272,35,2,269,7,12,260]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=void 0;class f extends L.$Tdc{j(){}getModule(p,$){for(const m of this.b){const t=m(p);if(t){p=t;break}}if(this.a.has(p))return this.a.get(p).load(p,$,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends M.$ucc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(k.$Yfc);const p=this.h.invokeFunction(y.$Pdc);this.r=this.h.createInstance(f,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,$,m){$=$.with({path:D($.path,".js")});const t=p?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=C.URI.revive(await this.C.$asBrowserUri($)),a=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),a.status!==200)throw new Error(a.statusText);const b=await a.text(),E=`${$.toString(!0)}#vscode-extension`,v=`${b}
//# sourceURL=${E}`;let r;try{r=new Function("module","exports","require",v)}catch(w){throw console.error(t?`Loading code for extension ${t} failed: ${w.message}`:`Loading code failed: ${w.message}`),console.error(`${$.toString(!0)}${typeof w.line=="number"?` line ${w.line}`:""}${typeof w.column=="number"?` column ${w.column}`:""}`),console.error(w),w}p&&await this.w.initializeLocalizedMessages(p);const s={},n={exports:s},o=w=>{const d=this.r.getModule(w,$);if(d===void 0)throw new Error(`Cannot load module '${w}'`);return d};try{return m.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(n,s,o),n.exports!==s?n.exports:s}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),m.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const $=Date.now()+p;for(;Date.now()<$&&!("__jsDebugIsReady"in globalThis);)await(0,l.$Tg)(10)}}e.$Zfc=R;function D(c,p){return c.endsWith(p)?c:c+p}}),define(Re[275],Me([1,0,68,69,14,35,187,85,274]),function(we,e,y,M,C,L,A,l,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$tr)(C.$8i,new y.$Kh(A.$Sdc,[!0],!0)),(0,M.$tr)(L.$vcc,k.$Zfc,0),(0,M.$tr)(l.$gcc,l.$hcc,0)}),define(Re[284],Me([1,0,26,5,79,270,262,19,87,13,2,273,275]),function(we,e,y,M,C,L,A,l,k,f,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(r){return/^(file|vscode-remote):/i.test(r)}const $=fetch.bind(self);function m(r){self.fetch=async function(s,n){return s instanceof Request||p(String(s))&&(s=(await r(R.URI.parse(String(s)))).toString(!0)),$(s,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,n,o,w,d){(async()=>(p(n.toString())&&(n=(await r(R.URI.parse(n.toString()))).toString(!0)),super.open(s,n,o??!0,w,d)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(s,n){if(/^file:/i.test(s.toString()))s=f.$bg.uriToBrowserUri(R.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const w=`(${function(u){function g(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const h=fetch.bind(self);self.fetch=function(W,K){return W instanceof Request?h(W,K):h(g(W),K)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,K,j,B,O){return super.open(W,g(K),j??!0,B,O)}};const P=importScripts.bind(self);self.importScripts=(...W)=>{P(...W.map(g))},P(u)}.toString()}('${s}'))`;n=n||{},n.name=n.name||l.$mc(s.toString());const d=new Blob([w],{type:"application/javascript"}),I=URL.createObjectURL(d);return new r(I,n)}}else self.Worker=class extends A.$1fc{constructor(r,s){super(c,r,{name:l.$mc(r.toString()),...s})}};const t=new class{constructor(){this.pid=void 0}exit(r){D()}};class i{constructor(){const s=new MessageChannel,n=new M.$Md;let o=!1;c(s.port2,[s.port2]),s.port1.onmessage=w=>{const{data:d}=w;if(!(d instanceof ArrayBuffer)){console.warn("UNKNOWN data received",d);return}const I=y.$ae.wrap(new Uint8Array(d,0,d.byteLength));if((0,C.$_l)(I,2)){o=!0,b("received terminate message from renderer");return}n.fire(I)},this.protocol={onMessage:n.event,send:w=>{if(!o){const d=w.buffer.buffer.slice(w.buffer.byteOffset,w.buffer.byteOffset+w.buffer.byteLength);s.port1.postMessage(d,[d])}}}}}function a(r){return new Promise(s=>{const n=r.onMessage(o=>{n.dispose();const w=JSON.parse(o.toString());r.send((0,C.$$l)(0)),s({protocol:r,initData:w})});r.send((0,C.$$l)(1))})}let b=r=>D();function E(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function v(){k.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(s){E(s)&&a(r.protocol).then(n=>{k.mark("code/extHost/didWaitForInitData");const o=new L.$Vdc(n.protocol,n.initData,t,null,s.data);m(w=>o.asBrowserUri(w)),b=w=>o.terminate(w)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b63441dbc9f729977e8e97321f536a06521496f7/core/vs/workbench/api/worker/extensionHostWorker.js.map
